-- Melbis Shop 6 SQL Dump
-- https://melbis.com
--
-- Generation Time: Tue, 01 Apr 2025 12:09:50 +0000

--

-- --------------------------------------------------------

--
-- Table structure for table `ms_advert`
--

DROP TABLE IF EXISTS `ms_advert`;

CREATE TABLE `ms_advert` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `tindex` int unsigned NOT NULL DEFAULT '0',
  `tlevel` int unsigned NOT NULL DEFAULT '0',
  `absindex` int unsigned NOT NULL DEFAULT '0',
  `folder` tinyint unsigned NOT NULL DEFAULT '0',
  `kind_key` char(100) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_advert`
--

LOCK TABLES `ms_advert` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_advert_goods`
--

DROP TABLE IF EXISTS `ms_advert_goods`;

CREATE TABLE `ms_advert_goods` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `advert_id` int unsigned DEFAULT NULL,
  `kind_key` char(100) NOT NULL DEFAULT '',
  `elem_id` int unsigned DEFAULT NULL,
  `params` char(255) NOT NULL DEFAULT '',
  `comment` char(255) NOT NULL DEFAULT '',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `advert_id` (`advert_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_advert_goods`
--

LOCK TABLES `ms_advert_goods` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_advert_link`
--

DROP TABLE IF EXISTS `ms_advert_link`;

CREATE TABLE `ms_advert_link` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `advert_id` int unsigned DEFAULT NULL,
  `obj_key` char(100) NOT NULL DEFAULT '',
  `kind_key` char(100) NOT NULL DEFAULT '',
  `param_id` int unsigned DEFAULT NULL,
  `params` char(255) NOT NULL DEFAULT '',
  `comment` char(255) NOT NULL DEFAULT '',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `advert_id` (`advert_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_advert_link`
--

LOCK TABLES `ms_advert_link` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_advert_text`
--

DROP TABLE IF EXISTS `ms_advert_text`;

CREATE TABLE `ms_advert_text` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `advert_id` int unsigned DEFAULT NULL,
  `date_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `name` char(255) NOT NULL DEFAULT '',
  `descr` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `kind_key` char(100) NOT NULL DEFAULT '',
  `params` char(255) NOT NULL DEFAULT '',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_advert_text`
--

LOCK TABLES `ms_advert_text` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_brand`
--

DROP TABLE IF EXISTS `ms_brand`;

CREATE TABLE `ms_brand` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `descr` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `kind_key` char(100) NOT NULL DEFAULT '',
  `params` char(255) NOT NULL DEFAULT '',
  `seo_code` char(255) NOT NULL DEFAULT '',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_brand`
--

LOCK TABLES `ms_brand` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_brand_key`
--

DROP TABLE IF EXISTS `ms_brand_key`;

CREATE TABLE `ms_brand_key` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `tindex` int unsigned NOT NULL DEFAULT '0',
  `tlevel` int unsigned NOT NULL DEFAULT '0',
  `absindex` int unsigned NOT NULL DEFAULT '0',
  `folder` tinyint unsigned NOT NULL DEFAULT '0',
  `descr` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `mask_edit` char(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_brand_key`
--

LOCK TABLES `ms_brand_key` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_brand_key_set`
--

DROP TABLE IF EXISTS `ms_brand_key_set`;

CREATE TABLE `ms_brand_key_set` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `brand_id` int unsigned DEFAULT NULL,
  `key_id` int unsigned DEFAULT NULL,
  `value_id` int unsigned DEFAULT NULL,
  `value_txt` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  PRIMARY KEY (`id`),
  KEY `brand_id` (`brand_id`),
  KEY `key_id` (`key_id`),
  KEY `value_id` (`value_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_brand_key_set`
--

LOCK TABLES `ms_brand_key_set` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_brand_key_value`
--

DROP TABLE IF EXISTS `ms_brand_key_value`;

CREATE TABLE `ms_brand_key_value` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `key_id` int unsigned DEFAULT NULL,
  `name` char(255) NOT NULL DEFAULT '',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `key_id` (`key_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_brand_key_value`
--

LOCK TABLES `ms_brand_key_value` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_client`
--

DROP TABLE IF EXISTS `ms_client`;

CREATE TABLE `ms_client` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `group_id` int unsigned DEFAULT NULL,
  `login` char(100) NOT NULL DEFAULT '',
  `pass` char(100) NOT NULL DEFAULT '',
  `discount` decimal(10,4) NOT NULL DEFAULT '0.0000',
  `order_sum` decimal(10,2) NOT NULL DEFAULT '0.00',
  `reg_date` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `last_date` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  PRIMARY KEY (`id`),
  KEY `group_id` (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_client`
--

LOCK TABLES `ms_client` WRITE;
INSERT INTO `ms_client` VALUES ('1',NULL,'auto1529','965ab534','0.0000','0.00','2025-04-01 10:09:07','2025-04-01 10:09:07');
INSERT INTO `ms_client` VALUES ('2',NULL,'auto2601','23ec58f8','0.0000','0.00','2025-04-01 10:22:32','2025-04-01 10:22:32');
INSERT INTO `ms_client` VALUES ('3',NULL,'auto3430','b1d19d3c','0.0000','0.00','2025-04-01 10:23:00','2025-04-01 10:23:00');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_client_field`
--

DROP TABLE IF EXISTS `ms_client_field`;

CREATE TABLE `ms_client_field` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `client_id` int unsigned DEFAULT NULL,
  `field_id` int unsigned DEFAULT NULL,
  `value_id` int unsigned DEFAULT NULL,
  `value_txt` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  PRIMARY KEY (`id`),
  KEY `client_id` (`client_id`),
  KEY `field_id` (`field_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_client_field`
--

LOCK TABLES `ms_client_field` WRITE;
INSERT INTO `ms_client_field` VALUES ('1','1','4',NULL,'');
INSERT INTO `ms_client_field` VALUES ('2','1','1',NULL,'KasDim');
INSERT INTO `ms_client_field` VALUES ('3','1','2',NULL,'+38(050)111-22-33');
INSERT INTO `ms_client_field` VALUES ('4','1','5',NULL,'');
INSERT INTO `ms_client_field` VALUES ('5','1','3',NULL,'Kharkiv');
INSERT INTO `ms_client_field` VALUES ('6','1','6',NULL,'23');
INSERT INTO `ms_client_field` VALUES ('7','2','4',NULL,'');
INSERT INTO `ms_client_field` VALUES ('8','2','1',NULL,'');
INSERT INTO `ms_client_field` VALUES ('9','2','2',NULL,'');
INSERT INTO `ms_client_field` VALUES ('10','2','5',NULL,'');
INSERT INTO `ms_client_field` VALUES ('11','2','3','1','Киев');
INSERT INTO `ms_client_field` VALUES ('12','2','6',NULL,'');
INSERT INTO `ms_client_field` VALUES ('13','3','4',NULL,'');
INSERT INTO `ms_client_field` VALUES ('14','3','1',NULL,'');
INSERT INTO `ms_client_field` VALUES ('15','3','2',NULL,'');
INSERT INTO `ms_client_field` VALUES ('16','3','5',NULL,'');
INSERT INTO `ms_client_field` VALUES ('17','3','3','1','Киев');
INSERT INTO `ms_client_field` VALUES ('18','3','6',NULL,'');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_client_group`
--

DROP TABLE IF EXISTS `ms_client_group`;

CREATE TABLE `ms_client_group` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `price_num` tinyint unsigned NOT NULL DEFAULT '0',
  `discount` decimal(10,4) NOT NULL DEFAULT '0.0000',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_client_group`
--

LOCK TABLES `ms_client_group` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_client_rules`
--

DROP TABLE IF EXISTS `ms_client_rules`;

CREATE TABLE `ms_client_rules` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `order_sum` decimal(10,2) NOT NULL DEFAULT '0.00',
  `sum_curr_id` int unsigned DEFAULT NULL,
  `set_group_id` int unsigned DEFAULT NULL,
  `set_discount` decimal(10,4) NOT NULL DEFAULT '0.0000',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_client_rules`
--

LOCK TABLES `ms_client_rules` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_currency`
--

DROP TABLE IF EXISTS `ms_currency`;

CREATE TABLE `ms_currency` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `name` char(32) NOT NULL DEFAULT '',
  `multiplex` decimal(10,4) NOT NULL DEFAULT '0.0000',
  `division` tinyint unsigned NOT NULL DEFAULT '0',
  `provider_id` int unsigned DEFAULT NULL,
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_currency`
--

LOCK TABLES `ms_currency` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_disc_group`
--

DROP TABLE IF EXISTS `ms_disc_group`;

CREATE TABLE `ms_disc_group` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_disc_group`
--

LOCK TABLES `ms_disc_group` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_disc_rate`
--

DROP TABLE IF EXISTS `ms_disc_rate`;

CREATE TABLE `ms_disc_rate` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `group_id` int unsigned DEFAULT NULL,
  `kind_key` char(100) NOT NULL DEFAULT '',
  `from_sum` decimal(10,2) NOT NULL DEFAULT '0.00',
  `sum_curr_id` int unsigned DEFAULT NULL,
  `disc_proc` decimal(10,4) NOT NULL DEFAULT '0.0000',
  `begin_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `end_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  PRIMARY KEY (`id`),
  KEY `group_id` (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_disc_rate`
--

LOCK TABLES `ms_disc_rate` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_field`
--

DROP TABLE IF EXISTS `ms_field`;

CREATE TABLE `ms_field` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `descr` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `tindex` int unsigned NOT NULL DEFAULT '0',
  `tlevel` int unsigned NOT NULL DEFAULT '0',
  `absindex` int unsigned NOT NULL DEFAULT '0',
  `folder` tinyint unsigned NOT NULL DEFAULT '0',
  `kind_key` char(100) NOT NULL DEFAULT '',
  `spec_key` char(100) NOT NULL DEFAULT '',
  `parent_id` int unsigned DEFAULT NULL,
  `fixed_set` tinyint unsigned NOT NULL DEFAULT '0',
  `read_only` tinyint unsigned NOT NULL DEFAULT '0',
  `mask_edit` char(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_field`
--

LOCK TABLES `ms_field` WRITE;
INSERT INTO `ms_field` VALUES ('5','','Доставка','','0','0','3','1','kDefault','kDefault',NULL,'0','0','');
INSERT INTO `ms_field` VALUES ('4','','Покупатель','','0','0','0','1','kDefault','kDefault',NULL,'0','0','');
INSERT INTO `ms_field` VALUES ('3','','Город','','5','1','4','0','kDefault','kDefault',NULL,'1','0','');
INSERT INTO `ms_field` VALUES ('2','','Телефон','','4','1','2','0','kDefault','kDefault',NULL,'0','0','');
INSERT INTO `ms_field` VALUES ('1','','Имя','','4','1','1','0','kDefault','kDefault',NULL,'0','0','');
INSERT INTO `ms_field` VALUES ('6','','Адрес','','5','1','5','0','kDefault','kDefault',NULL,'0','0','');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_field_value`
--

DROP TABLE IF EXISTS `ms_field_value`;

CREATE TABLE `ms_field_value` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `field_id` int unsigned DEFAULT NULL,
  `code` char(255) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `kind_key` char(100) NOT NULL DEFAULT '',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `field_id` (`field_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_field_value`
--

LOCK TABLES `ms_field_value` WRITE;
INSERT INTO `ms_field_value` VALUES ('1','','3','','Киев','kDefault','1');
INSERT INTO `ms_field_value` VALUES ('2','','3','','Харьков','kDefault','2');
INSERT INTO `ms_field_value` VALUES ('3','','3','','Одесса','kDefault','3');
INSERT INTO `ms_field_value` VALUES ('4','','3','','Днепр','kDefault','4');
INSERT INTO `ms_field_value` VALUES ('5','','3','','Львов','kDefault','5');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_files_advert_text`
--

DROP TABLE IF EXISTS `ms_files_advert_text`;

CREATE TABLE `ms_files_advert_text` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `elem_id` int unsigned DEFAULT NULL,
  `kind_key` char(100) NOT NULL DEFAULT '',
  `file_name` char(100) NOT NULL DEFAULT '',
  `file_size` int unsigned NOT NULL DEFAULT '0',
  `upload_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `upload_ok` tinyint unsigned NOT NULL DEFAULT '0',
  `real_name` char(255) NOT NULL DEFAULT '',
  `parent_id` int unsigned DEFAULT NULL,
  `format_xml` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `elem_id` (`elem_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_files_advert_text`
--

LOCK TABLES `ms_files_advert_text` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_files_brand`
--

DROP TABLE IF EXISTS `ms_files_brand`;

CREATE TABLE `ms_files_brand` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `elem_id` int unsigned DEFAULT NULL,
  `kind_key` char(100) NOT NULL DEFAULT '',
  `file_name` char(100) NOT NULL DEFAULT '',
  `file_size` int unsigned NOT NULL DEFAULT '0',
  `upload_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `upload_ok` tinyint unsigned NOT NULL DEFAULT '0',
  `real_name` char(255) NOT NULL DEFAULT '',
  `parent_id` int unsigned DEFAULT NULL,
  `format_xml` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `elem_id` (`elem_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_files_brand`
--

LOCK TABLES `ms_files_brand` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_files_field`
--

DROP TABLE IF EXISTS `ms_files_field`;

CREATE TABLE `ms_files_field` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `elem_id` int unsigned DEFAULT NULL,
  `kind_key` char(100) NOT NULL DEFAULT '',
  `file_name` char(100) NOT NULL DEFAULT '',
  `file_size` int unsigned NOT NULL DEFAULT '0',
  `upload_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `upload_ok` tinyint unsigned NOT NULL DEFAULT '0',
  `real_name` char(255) NOT NULL DEFAULT '',
  `parent_id` int unsigned DEFAULT NULL,
  `format_xml` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `elem_id` (`elem_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_files_field`
--

LOCK TABLES `ms_files_field` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_files_info`
--

DROP TABLE IF EXISTS `ms_files_info`;

CREATE TABLE `ms_files_info` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `elem_id` int unsigned DEFAULT NULL,
  `kind_key` char(100) NOT NULL DEFAULT '',
  `file_name` char(100) NOT NULL DEFAULT '',
  `file_size` int unsigned NOT NULL DEFAULT '0',
  `upload_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `upload_ok` tinyint unsigned NOT NULL DEFAULT '0',
  `real_name` char(255) NOT NULL DEFAULT '',
  `parent_id` int unsigned DEFAULT NULL,
  `format_xml` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `elem_id` (`elem_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_files_info`
--

LOCK TABLES `ms_files_info` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_files_info_value`
--

DROP TABLE IF EXISTS `ms_files_info_value`;

CREATE TABLE `ms_files_info_value` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `elem_id` int unsigned DEFAULT NULL,
  `kind_key` char(100) NOT NULL DEFAULT '',
  `file_name` char(100) NOT NULL DEFAULT '',
  `file_size` int unsigned NOT NULL DEFAULT '0',
  `upload_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `upload_ok` tinyint unsigned NOT NULL DEFAULT '0',
  `real_name` char(255) NOT NULL DEFAULT '',
  `parent_id` int unsigned DEFAULT NULL,
  `format_xml` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `elem_id` (`elem_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_files_info_value`
--

LOCK TABLES `ms_files_info_value` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_files_key_value`
--

DROP TABLE IF EXISTS `ms_files_key_value`;

CREATE TABLE `ms_files_key_value` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `elem_id` int unsigned DEFAULT NULL,
  `kind_key` char(100) NOT NULL DEFAULT '',
  `file_name` char(100) NOT NULL DEFAULT '',
  `file_size` int unsigned NOT NULL DEFAULT '0',
  `upload_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `upload_ok` tinyint unsigned NOT NULL DEFAULT '0',
  `real_name` char(255) NOT NULL DEFAULT '',
  `parent_id` int unsigned DEFAULT NULL,
  `format_xml` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `elem_id` (`elem_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_files_key_value`
--

LOCK TABLES `ms_files_key_value` WRITE;
INSERT INTO `ms_files_key_value` VALUES ('2','110','kBase','files_key_value_1_2.css','200387','2025-03-29 14:17:55','1','bootstrap.css',NULL,'','1');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_files_lang`
--

DROP TABLE IF EXISTS `ms_files_lang`;

CREATE TABLE `ms_files_lang` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `elem_id` int unsigned DEFAULT NULL,
  `kind_key` char(100) NOT NULL DEFAULT '',
  `file_name` char(100) NOT NULL DEFAULT '',
  `file_size` int unsigned NOT NULL DEFAULT '0',
  `upload_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `upload_ok` tinyint unsigned NOT NULL DEFAULT '0',
  `real_name` char(255) NOT NULL DEFAULT '',
  `parent_id` int unsigned DEFAULT NULL,
  `format_xml` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `elem_id` (`elem_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_files_lang`
--

LOCK TABLES `ms_files_lang` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_files_order_option`
--

DROP TABLE IF EXISTS `ms_files_order_option`;

CREATE TABLE `ms_files_order_option` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `elem_id` int unsigned DEFAULT NULL,
  `kind_key` char(100) NOT NULL DEFAULT '',
  `file_name` char(100) NOT NULL DEFAULT '',
  `file_size` int unsigned NOT NULL DEFAULT '0',
  `upload_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `upload_ok` tinyint unsigned NOT NULL DEFAULT '0',
  `real_name` char(255) NOT NULL DEFAULT '',
  `parent_id` int unsigned DEFAULT NULL,
  `format_xml` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `elem_id` (`elem_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_files_order_option`
--

LOCK TABLES `ms_files_order_option` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_files_order_option_value`
--

DROP TABLE IF EXISTS `ms_files_order_option_value`;

CREATE TABLE `ms_files_order_option_value` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `elem_id` int unsigned DEFAULT NULL,
  `kind_key` char(100) NOT NULL DEFAULT '',
  `file_name` char(100) NOT NULL DEFAULT '',
  `file_size` int unsigned NOT NULL DEFAULT '0',
  `upload_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `upload_ok` tinyint unsigned NOT NULL DEFAULT '0',
  `real_name` char(255) NOT NULL DEFAULT '',
  `parent_id` int unsigned DEFAULT NULL,
  `format_xml` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `elem_id` (`elem_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_files_order_option_value`
--

LOCK TABLES `ms_files_order_option_value` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_files_store`
--

DROP TABLE IF EXISTS `ms_files_store`;

CREATE TABLE `ms_files_store` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `elem_id` int unsigned DEFAULT NULL,
  `kind_key` char(100) NOT NULL DEFAULT '',
  `file_name` char(100) NOT NULL DEFAULT '',
  `file_size` int unsigned NOT NULL DEFAULT '0',
  `upload_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `upload_ok` tinyint unsigned NOT NULL DEFAULT '0',
  `real_name` char(255) NOT NULL DEFAULT '',
  `parent_id` int unsigned DEFAULT NULL,
  `format_xml` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `elem_id` (`elem_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_files_store`
--

LOCK TABLES `ms_files_store` WRITE;
INSERT INTO `ms_files_store` VALUES ('84','1','kBase','u_files_store_1_1.png','21138','2025-03-29 14:38:59','1','Буфер обмена',NULL,'','1');
INSERT INTO `ms_files_store` VALUES ('68','2','kDefault','u_files_store_1_36.jpg','47167','2025-03-30 19:04:23','1','На основе: На основе: Буфер обмена',NULL,'<MELBISSHOP ShopVersion=\"Melbis Shop Commercial v6.4.0.386\">
  <FRAME Type=\"0\">
    <POINT X=\"0\" Y=\"0\"/>
    <POINT X=\"817\" Y=\"566\"/>
  </FRAME>
  <JPEG FileType=\"0\" Compress=\"80\" Width=\"815\" Hight=\"815\" Smart=\"False\"/>
  <MASK File=\"files/1899/12_30/00_00/\" Pos=\"0\" Alpha=\"0\"/>
  <CANVAS Range=\"255\" Color=\"16777215\" Border=\"0\"/>
  <ROTATE Rotate=\"0\" Mirror=\"False\"/>
  <EFFECTS Red=\"0\" Green=\"0\" Blue=\"0\" Intensive=\"0\" Contrast=\"0\" Sharpen=\"0\"/>
</MELBISSHOP>
','1');
INSERT INTO `ms_files_store` VALUES ('67','2','kDescrImg','u_files_store_1_9.jpg','33976','2025-03-30 13:09:54','1','На основе: Буфер обмена',NULL,'<MELBISSHOP ShopVersion=\"Melbis Shop Commercial v6.4.0.386\">
  <FRAME Type=\"0\">
    <POINT X=\"0\" Y=\"0\"/>
    <POINT X=\"588\" Y=\"570\"/>
  </FRAME>
  <JPEG FileType=\"0\" Compress=\"80\" Width=\"588\" Hight=\"570\" Smart=\"True\"/>
  <MASK File=\"files/1899/12_30/00_00/\" Pos=\"0\" Alpha=\"0\"/>
  <CANVAS Range=\"255\" Color=\"16777215\" Border=\"0\"/>
  <ROTATE Rotate=\"0\" Mirror=\"False\"/>
  <EFFECTS Red=\"0\" Green=\"0\" Blue=\"0\" Intensive=\"0\" Contrast=\"0\" Sharpen=\"0\"/>
</MELBISSHOP>
','4');
INSERT INTO `ms_files_store` VALUES ('66','2','kDescrImg','u_files_store_1_7.jpg','47995','2025-03-30 13:09:31','1','На основе: Буфер обмена',NULL,'<MELBISSHOP ShopVersion=\"Melbis Shop Commercial v6.4.0.386\">
  <FRAME Type=\"0\">
    <POINT X=\"0\" Y=\"0\"/>
    <POINT X=\"985\" Y=\"540\"/>
  </FRAME>
  <JPEG FileType=\"0\" Compress=\"80\" Width=\"985\" Hight=\"540\" Smart=\"True\"/>
  <MASK File=\"files/1899/12_30/00_00/\" Pos=\"0\" Alpha=\"0\"/>
  <CANVAS Range=\"255\" Color=\"16777215\" Border=\"0\"/>
  <ROTATE Rotate=\"0\" Mirror=\"False\"/>
  <EFFECTS Red=\"0\" Green=\"0\" Blue=\"0\" Intensive=\"0\" Contrast=\"0\" Sharpen=\"0\"/>
</MELBISSHOP>
','3');
INSERT INTO `ms_files_store` VALUES ('65','2','kDescrImg','u_files_store_1_5.jpg','46337','2025-03-30 13:09:00','1','На основе: Буфер обмена',NULL,'<MELBISSHOP ShopVersion=\"Melbis Shop Commercial v6.4.0.386\">
  <FRAME Type=\"0\">
    <POINT X=\"0\" Y=\"0\"/>
    <POINT X=\"985\" Y=\"550\"/>
  </FRAME>
  <JPEG FileType=\"0\" Compress=\"80\" Width=\"985\" Hight=\"550\" Smart=\"True\"/>
  <MASK File=\"files/1899/12_30/00_00/\" Pos=\"0\" Alpha=\"0\"/>
  <CANVAS Range=\"255\" Color=\"16777215\" Border=\"0\"/>
  <ROTATE Rotate=\"0\" Mirror=\"False\"/>
  <EFFECTS Red=\"0\" Green=\"0\" Blue=\"0\" Intensive=\"0\" Contrast=\"0\" Sharpen=\"0\"/>
</MELBISSHOP>
','2');
INSERT INTO `ms_files_store` VALUES ('72','3','kDefault','u_files_store_1_39.jpg','52450','2025-03-30 19:06:52','1','На основе: На основе: Буфер обмена',NULL,'<MELBISSHOP ShopVersion=\"Melbis Shop Commercial v6.4.0.386\">
  <FRAME Type=\"0\">
    <POINT X=\"0\" Y=\"0\"/>
    <POINT X=\"793\" Y=\"570\"/>
  </FRAME>
  <JPEG FileType=\"0\" Compress=\"80\" Width=\"792\" Hight=\"792\" Smart=\"False\"/>
  <MASK File=\"files/1899/12_30/00_00/\" Pos=\"0\" Alpha=\"0\"/>
  <CANVAS Range=\"255\" Color=\"16777215\" Border=\"0\"/>
  <ROTATE Rotate=\"0\" Mirror=\"False\"/>
  <EFFECTS Red=\"0\" Green=\"0\" Blue=\"0\" Intensive=\"0\" Contrast=\"0\" Sharpen=\"0\"/>
</MELBISSHOP>
','1');
INSERT INTO `ms_files_store` VALUES ('71','3','kDescrImg','u_files_store_1_17.jpg','34187','2025-03-30 17:35:15','1','На основе: Буфер обмена',NULL,'<MELBISSHOP ShopVersion=\"Melbis Shop Commercial v6.4.0.386\">
  <FRAME Type=\"0\">
    <POINT X=\"0\" Y=\"0\"/>
    <POINT X=\"724\" Y=\"570\"/>
  </FRAME>
  <JPEG FileType=\"0\" Compress=\"80\" Width=\"724\" Hight=\"570\" Smart=\"True\"/>
  <MASK File=\"files/1899/12_30/00_00/\" Pos=\"0\" Alpha=\"0\"/>
  <CANVAS Range=\"255\" Color=\"16777215\" Border=\"0\"/>
  <ROTATE Rotate=\"0\" Mirror=\"False\"/>
  <EFFECTS Red=\"0\" Green=\"0\" Blue=\"0\" Intensive=\"0\" Contrast=\"0\" Sharpen=\"0\"/>
</MELBISSHOP>
','4');
INSERT INTO `ms_files_store` VALUES ('70','3','kDescrImg','u_files_store_1_15.jpg','42710','2025-03-30 17:34:36','1','На основе: Буфер обмена',NULL,'<MELBISSHOP ShopVersion=\"Melbis Shop Commercial v6.4.0.386\">
  <FRAME Type=\"0\">
    <POINT X=\"0\" Y=\"0\"/>
    <POINT X=\"910\" Y=\"570\"/>
  </FRAME>
  <JPEG FileType=\"0\" Compress=\"80\" Width=\"909\" Hight=\"570\" Smart=\"True\"/>
  <MASK File=\"files/1899/12_30/00_00/\" Pos=\"0\" Alpha=\"0\"/>
  <CANVAS Range=\"255\" Color=\"16777215\" Border=\"0\"/>
  <ROTATE Rotate=\"0\" Mirror=\"False\"/>
  <EFFECTS Red=\"0\" Green=\"0\" Blue=\"0\" Intensive=\"0\" Contrast=\"0\" Sharpen=\"0\"/>
</MELBISSHOP>
','3');
INSERT INTO `ms_files_store` VALUES ('69','3','kDescrImg','u_files_store_1_13.jpg','43968','2025-03-30 17:34:21','1','На основе: Буфер обмена',NULL,'<MELBISSHOP ShopVersion=\"Melbis Shop Commercial v6.4.0.386\">
  <FRAME Type=\"0\">
    <POINT X=\"0\" Y=\"0\"/>
    <POINT X=\"857\" Y=\"570\"/>
  </FRAME>
  <JPEG FileType=\"0\" Compress=\"80\" Width=\"857\" Hight=\"570\" Smart=\"True\"/>
  <MASK File=\"files/1899/12_30/00_00/\" Pos=\"0\" Alpha=\"0\"/>
  <CANVAS Range=\"255\" Color=\"16777215\" Border=\"0\"/>
  <ROTATE Rotate=\"0\" Mirror=\"False\"/>
  <EFFECTS Red=\"0\" Green=\"0\" Blue=\"0\" Intensive=\"0\" Contrast=\"0\" Sharpen=\"0\"/>
</MELBISSHOP>
','2');
INSERT INTO `ms_files_store` VALUES ('77','4','kDefault','u_files_store_1_37.jpg','45005','2025-03-30 19:05:22','1','На основе: На основе: Буфер обмена',NULL,'<MELBISSHOP ShopVersion=\"Melbis Shop Commercial v6.4.0.386\">
  <FRAME Type=\"0\">
    <POINT X=\"0\" Y=\"0\"/>
    <POINT X=\"683\" Y=\"575\"/>
  </FRAME>
  <JPEG FileType=\"0\" Compress=\"80\" Width=\"683\" Hight=\"683\" Smart=\"False\"/>
  <MASK File=\"files/1899/12_30/00_00/\" Pos=\"0\" Alpha=\"0\"/>
  <CANVAS Range=\"255\" Color=\"16777215\" Border=\"0\"/>
  <ROTATE Rotate=\"0\" Mirror=\"False\"/>
  <EFFECTS Red=\"0\" Green=\"0\" Blue=\"0\" Intensive=\"0\" Contrast=\"0\" Sharpen=\"0\"/>
</MELBISSHOP>
','1');
INSERT INTO `ms_files_store` VALUES ('76','4','kDescrImg','u_files_store_1_27.jpg','81353','2025-03-30 17:46:07','1','На основе: Буфер обмена',NULL,'<MELBISSHOP ShopVersion=\"Melbis Shop Commercial v6.4.0.386\">
  <FRAME Type=\"0\">
    <POINT X=\"0\" Y=\"0\"/>
    <POINT X=\"731\" Y=\"576\"/>
  </FRAME>
  <JPEG FileType=\"0\" Compress=\"80\" Width=\"731\" Hight=\"576\" Smart=\"True\"/>
  <MASK File=\"files/1899/12_30/00_00/\" Pos=\"0\" Alpha=\"0\"/>
  <CANVAS Range=\"255\" Color=\"16777215\" Border=\"0\"/>
  <ROTATE Rotate=\"0\" Mirror=\"False\"/>
  <EFFECTS Red=\"0\" Green=\"0\" Blue=\"0\" Intensive=\"0\" Contrast=\"0\" Sharpen=\"0\"/>
</MELBISSHOP>
','5');
INSERT INTO `ms_files_store` VALUES ('75','4','kDescrImg','u_files_store_1_25.jpg','80441','2025-03-30 17:45:44','1','На основе: Буфер обмена',NULL,'<MELBISSHOP ShopVersion=\"Melbis Shop Commercial v6.4.0.386\">
  <FRAME Type=\"0\">
    <POINT X=\"0\" Y=\"0\"/>
    <POINT X=\"545\" Y=\"576\"/>
  </FRAME>
  <JPEG FileType=\"0\" Compress=\"80\" Width=\"545\" Hight=\"576\" Smart=\"True\"/>
  <MASK File=\"files/1899/12_30/00_00/\" Pos=\"0\" Alpha=\"0\"/>
  <CANVAS Range=\"255\" Color=\"16777215\" Border=\"0\"/>
  <ROTATE Rotate=\"0\" Mirror=\"False\"/>
  <EFFECTS Red=\"0\" Green=\"0\" Blue=\"0\" Intensive=\"0\" Contrast=\"0\" Sharpen=\"0\"/>
</MELBISSHOP>
','4');
INSERT INTO `ms_files_store` VALUES ('74','4','kDescrImg','u_files_store_1_23.jpg','60814','2025-03-30 17:45:31','1','На основе: Буфер обмена',NULL,'<MELBISSHOP ShopVersion=\"Melbis Shop Commercial v6.4.0.386\">
  <FRAME Type=\"0\">
    <POINT X=\"0\" Y=\"0\"/>
    <POINT X=\"772\" Y=\"576\"/>
  </FRAME>
  <JPEG FileType=\"0\" Compress=\"80\" Width=\"772\" Hight=\"576\" Smart=\"True\"/>
  <MASK File=\"files/1899/12_30/00_00/\" Pos=\"0\" Alpha=\"0\"/>
  <CANVAS Range=\"255\" Color=\"16777215\" Border=\"0\"/>
  <ROTATE Rotate=\"0\" Mirror=\"False\"/>
  <EFFECTS Red=\"0\" Green=\"0\" Blue=\"0\" Intensive=\"0\" Contrast=\"0\" Sharpen=\"0\"/>
</MELBISSHOP>
','3');
INSERT INTO `ms_files_store` VALUES ('73','4','kDescrImg','u_files_store_1_21.jpg','43501','2025-03-30 17:45:16','1','На основе: Буфер обмена',NULL,'<MELBISSHOP ShopVersion=\"Melbis Shop Commercial v6.4.0.386\">
  <FRAME Type=\"0\">
    <POINT X=\"0\" Y=\"0\"/>
    <POINT X=\"669\" Y=\"576\"/>
  </FRAME>
  <JPEG FileType=\"0\" Compress=\"80\" Width=\"668\" Hight=\"576\" Smart=\"True\"/>
  <MASK File=\"files/1899/12_30/00_00/\" Pos=\"0\" Alpha=\"0\"/>
  <CANVAS Range=\"255\" Color=\"16777215\" Border=\"0\"/>
  <ROTATE Rotate=\"0\" Mirror=\"False\"/>
  <EFFECTS Red=\"0\" Green=\"0\" Blue=\"0\" Intensive=\"0\" Contrast=\"0\" Sharpen=\"0\"/>
</MELBISSHOP>
','2');
INSERT INTO `ms_files_store` VALUES ('81','5','kDefault','u_files_store_1_38.jpg','47308','2025-03-30 19:05:56','1','На основе: На основе: Буфер обмена',NULL,'<MELBISSHOP ShopVersion=\"Melbis Shop Commercial v6.4.0.386\">
  <FRAME Type=\"0\">
    <POINT X=\"0\" Y=\"0\"/>
    <POINT X=\"676\" Y=\"576\"/>
  </FRAME>
  <JPEG FileType=\"0\" Compress=\"80\" Width=\"674\" Hight=\"674\" Smart=\"False\"/>
  <MASK File=\"files/1899/12_30/00_00/\" Pos=\"0\" Alpha=\"0\"/>
  <CANVAS Range=\"255\" Color=\"16777215\" Border=\"0\"/>
  <ROTATE Rotate=\"0\" Mirror=\"False\"/>
  <EFFECTS Red=\"0\" Green=\"0\" Blue=\"0\" Intensive=\"0\" Contrast=\"0\" Sharpen=\"0\"/>
</MELBISSHOP>
','1');
INSERT INTO `ms_files_store` VALUES ('80','5','kDescrImg','u_files_store_1_35.jpg','42722','2025-03-30 18:28:30','1','На основе: Буфер обмена',NULL,'<MELBISSHOP ShopVersion=\"Melbis Shop Commercial v6.4.0.386\">
  <FRAME Type=\"0\">
    <POINT X=\"0\" Y=\"0\"/>
    <POINT X=\"576\" Y=\"576\"/>
  </FRAME>
  <JPEG FileType=\"0\" Compress=\"80\" Width=\"576\" Hight=\"576\" Smart=\"True\"/>
  <MASK File=\"files/1899/12_30/00_00/\" Pos=\"0\" Alpha=\"0\"/>
  <CANVAS Range=\"255\" Color=\"16777215\" Border=\"0\"/>
  <ROTATE Rotate=\"0\" Mirror=\"False\"/>
  <EFFECTS Red=\"0\" Green=\"0\" Blue=\"0\" Intensive=\"0\" Contrast=\"0\" Sharpen=\"0\"/>
</MELBISSHOP>
','4');
INSERT INTO `ms_files_store` VALUES ('79','5','kDescrImg','u_files_store_1_33.jpg','53314','2025-03-30 18:28:17','1','На основе: Буфер обмена',NULL,'<MELBISSHOP ShopVersion=\"Melbis Shop Commercial v6.4.0.386\">
  <FRAME Type=\"0\">
    <POINT X=\"0\" Y=\"0\"/>
    <POINT X=\"739\" Y=\"576\"/>
  </FRAME>
  <JPEG FileType=\"0\" Compress=\"80\" Width=\"739\" Hight=\"576\" Smart=\"True\"/>
  <MASK File=\"files/1899/12_30/00_00/\" Pos=\"0\" Alpha=\"0\"/>
  <CANVAS Range=\"255\" Color=\"16777215\" Border=\"0\"/>
  <ROTATE Rotate=\"0\" Mirror=\"False\"/>
  <EFFECTS Red=\"0\" Green=\"0\" Blue=\"0\" Intensive=\"0\" Contrast=\"0\" Sharpen=\"0\"/>
</MELBISSHOP>
','3');
INSERT INTO `ms_files_store` VALUES ('78','5','kDescrImg','u_files_store_1_31.jpg','33109','2025-03-30 18:28:04','1','На основе: Буфер обмена',NULL,'<MELBISSHOP ShopVersion=\"Melbis Shop Commercial v6.4.0.386\">
  <FRAME Type=\"0\">
    <POINT X=\"0\" Y=\"0\"/>
    <POINT X=\"576\" Y=\"576\"/>
  </FRAME>
  <JPEG FileType=\"0\" Compress=\"80\" Width=\"576\" Hight=\"576\" Smart=\"True\"/>
  <MASK File=\"files/1899/12_30/00_00/\" Pos=\"0\" Alpha=\"0\"/>
  <CANVAS Range=\"255\" Color=\"16777215\" Border=\"0\"/>
  <ROTATE Rotate=\"0\" Mirror=\"False\"/>
  <EFFECTS Red=\"0\" Green=\"0\" Blue=\"0\" Intensive=\"0\" Contrast=\"0\" Sharpen=\"0\"/>
</MELBISSHOP>
','2');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_files_topic`
--

DROP TABLE IF EXISTS `ms_files_topic`;

CREATE TABLE `ms_files_topic` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `elem_id` int unsigned DEFAULT NULL,
  `kind_key` char(100) NOT NULL DEFAULT '',
  `file_name` char(100) NOT NULL DEFAULT '',
  `file_size` int unsigned NOT NULL DEFAULT '0',
  `upload_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `upload_ok` tinyint unsigned NOT NULL DEFAULT '0',
  `real_name` char(255) NOT NULL DEFAULT '',
  `parent_id` int unsigned DEFAULT NULL,
  `format_xml` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `elem_id` (`elem_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_files_topic`
--

LOCK TABLES `ms_files_topic` WRITE;
INSERT INTO `ms_files_topic` VALUES ('2','4','kDefault','files_topic_1_2.jpg','52808','2025-03-30 11:19:48','1','На основе: Буфер обмена',NULL,'<MELBISSHOP ShopVersion=\"Melbis Shop Commercial v6.4.0.386\">
  <FRAME Type=\"0\">
    <POINT X=\"0\" Y=\"0\"/>
    <POINT X=\"1000\" Y=\"1000\"/>
  </FRAME>
  <JPEG FileType=\"0\" Compress=\"80\" Width=\"1000\" Hight=\"1000\" Smart=\"True\"/>
  <MASK File=\"files/1899/12_30/00_00/\" Pos=\"0\" Alpha=\"0\"/>
  <CANVAS Range=\"255\" Color=\"16777215\" Border=\"0\"/>
  <ROTATE Rotate=\"0\" Mirror=\"False\"/>
  <EFFECTS Red=\"0\" Green=\"0\" Blue=\"0\" Intensive=\"0\" Contrast=\"0\" Sharpen=\"0\"/>
</MELBISSHOP>
','1');
INSERT INTO `ms_files_topic` VALUES ('14','10','kDefault','files_topic_1_14.jpg','54669','2025-03-30 12:14:16','1','На основе: Буфер обмена',NULL,'<MELBISSHOP ShopVersion=\"Melbis Shop Commercial v6.4.0.386\">
  <FRAME Type=\"0\">
    <POINT X=\"0\" Y=\"0\"/>
    <POINT X=\"1000\" Y=\"1000\"/>
  </FRAME>
  <JPEG FileType=\"0\" Compress=\"80\" Width=\"1000\" Hight=\"1000\" Smart=\"True\"/>
  <MASK File=\"files/1899/12_30/00_00/\" Pos=\"0\" Alpha=\"0\"/>
  <CANVAS Range=\"255\" Color=\"16777215\" Border=\"0\"/>
  <ROTATE Rotate=\"0\" Mirror=\"False\"/>
  <EFFECTS Red=\"0\" Green=\"0\" Blue=\"0\" Intensive=\"0\" Contrast=\"0\" Sharpen=\"0\"/>
</MELBISSHOP>
','1');
INSERT INTO `ms_files_topic` VALUES ('22','11','kDefault','files_topic_1_22.jpg','56439','2025-04-01 11:25:56','1','На основе: Буфер обмена',NULL,'<MELBISSHOP ShopVersion=\"Melbis Shop Commercial v6.4.0.386\">
  <FRAME Type=\"0\">
    <POINT X=\"0\" Y=\"0\"/>
    <POINT X=\"1000\" Y=\"1000\"/>
  </FRAME>
  <JPEG FileType=\"0\" Compress=\"80\" Width=\"1000\" Hight=\"1000\" Smart=\"False\"/>
  <MASK File=\"files/1899/12_30/00_00/\" Pos=\"0\" Alpha=\"0\"/>
  <CANVAS Range=\"255\" Color=\"16777215\" Border=\"0\"/>
  <ROTATE Rotate=\"0\" Mirror=\"False\"/>
  <EFFECTS Red=\"0\" Green=\"0\" Blue=\"0\" Intensive=\"0\" Contrast=\"0\" Sharpen=\"0\"/>
</MELBISSHOP>
','1');
INSERT INTO `ms_files_topic` VALUES ('24','9','kDefault','files_topic_1_24.jpg','84775','2025-04-01 11:27:01','2','На основе: Буфер обмена',NULL,'<MELBISSHOP ShopVersion=\"Melbis Shop Commercial v6.4.0.386\">
  <FRAME Type=\"0\">
    <POINT X=\"0\" Y=\"0\"/>
    <POINT X=\"1018\" Y=\"846\"/>
  </FRAME>
  <JPEG FileType=\"0\" Compress=\"80\" Width=\"1000\" Hight=\"1000\" Smart=\"False\"/>
  <MASK File=\"files/1899/12_30/00_00/\" Pos=\"0\" Alpha=\"0\"/>
  <CANVAS Range=\"255\" Color=\"16777215\" Border=\"0\"/>
  <ROTATE Rotate=\"0\" Mirror=\"False\"/>
  <EFFECTS Red=\"0\" Green=\"0\" Blue=\"0\" Intensive=\"0\" Contrast=\"0\" Sharpen=\"0\"/>
</MELBISSHOP>
','1');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_files_web_key`
--

DROP TABLE IF EXISTS `ms_files_web_key`;

CREATE TABLE `ms_files_web_key` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `elem_id` int unsigned DEFAULT NULL,
  `kind_key` char(100) NOT NULL DEFAULT '',
  `file_name` char(100) NOT NULL DEFAULT '',
  `file_size` int unsigned NOT NULL DEFAULT '0',
  `upload_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `upload_ok` tinyint unsigned NOT NULL DEFAULT '0',
  `real_name` char(255) NOT NULL DEFAULT '',
  `parent_id` int unsigned DEFAULT NULL,
  `format_xml` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `elem_id` (`elem_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_files_web_key`
--

LOCK TABLES `ms_files_web_key` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_files_web_key_value`
--

DROP TABLE IF EXISTS `ms_files_web_key_value`;

CREATE TABLE `ms_files_web_key_value` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `elem_id` int unsigned DEFAULT NULL,
  `kind_key` char(100) NOT NULL DEFAULT '',
  `file_name` char(100) NOT NULL DEFAULT '',
  `file_size` int unsigned NOT NULL DEFAULT '0',
  `upload_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `upload_ok` tinyint unsigned NOT NULL DEFAULT '0',
  `real_name` char(255) NOT NULL DEFAULT '',
  `parent_id` int unsigned DEFAULT NULL,
  `format_xml` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `elem_id` (`elem_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_files_web_key_value`
--

LOCK TABLES `ms_files_web_key_value` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_generator`
--

DROP TABLE IF EXISTS `ms_generator`;

CREATE TABLE `ms_generator` (
  `table_name` char(50) NOT NULL DEFAULT '',
  `gen_value` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`table_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_generator`
--

LOCK TABLES `ms_generator` WRITE;
INSERT INTO `ms_generator` VALUES ('advert','0');
INSERT INTO `ms_generator` VALUES ('advert_text','0');
INSERT INTO `ms_generator` VALUES ('advert_goods','0');
INSERT INTO `ms_generator` VALUES ('advert_link','0');
INSERT INTO `ms_generator` VALUES ('lang','3');
INSERT INTO `ms_generator` VALUES ('trans','30');
INSERT INTO `ms_generator` VALUES ('trans_origin','252');
INSERT INTO `ms_generator` VALUES ('trans_lang','470');
INSERT INTO `ms_generator` VALUES ('brand','0');
INSERT INTO `ms_generator` VALUES ('brand_key','0');
INSERT INTO `ms_generator` VALUES ('brand_key_value','0');
INSERT INTO `ms_generator` VALUES ('brand_key_set','0');
INSERT INTO `ms_generator` VALUES ('currency','0');
INSERT INTO `ms_generator` VALUES ('client','3');
INSERT INTO `ms_generator` VALUES ('client_field','18');
INSERT INTO `ms_generator` VALUES ('client_group','0');
INSERT INTO `ms_generator` VALUES ('client_rules','0');
INSERT INTO `ms_generator` VALUES ('disc_group','0');
INSERT INTO `ms_generator` VALUES ('disc_rate','0');
INSERT INTO `ms_generator` VALUES ('files_advert_text','0');
INSERT INTO `ms_generator` VALUES ('files_lang','0');
INSERT INTO `ms_generator` VALUES ('files_brand','0');
INSERT INTO `ms_generator` VALUES ('files_field','0');
INSERT INTO `ms_generator` VALUES ('files_info','0');
INSERT INTO `ms_generator` VALUES ('files_info_value','0');
INSERT INTO `ms_generator` VALUES ('files_key_value','2');
INSERT INTO `ms_generator` VALUES ('files_topic','24');
INSERT INTO `ms_generator` VALUES ('files_store','84');
INSERT INTO `ms_generator` VALUES ('files_order_option','0');
INSERT INTO `ms_generator` VALUES ('files_order_option_value','0');
INSERT INTO `ms_generator` VALUES ('field','6');
INSERT INTO `ms_generator` VALUES ('field_value','5');
INSERT INTO `ms_generator` VALUES ('key','151');
INSERT INTO `ms_generator` VALUES ('key_value','390');
INSERT INTO `ms_generator` VALUES ('oper','332');
INSERT INTO `ms_generator` VALUES ('oper_right','754');
INSERT INTO `ms_generator` VALUES ('oper_table','738');
INSERT INTO `ms_generator` VALUES ('orders','3');
INSERT INTO `ms_generator` VALUES ('orders_version','3');
INSERT INTO `ms_generator` VALUES ('order_right','0');
INSERT INTO `ms_generator` VALUES ('order_option','3');
INSERT INTO `ms_generator` VALUES ('order_option_value','9');
INSERT INTO `ms_generator` VALUES ('order_option_block','0');
INSERT INTO `ms_generator` VALUES ('order_option_limit','0');
INSERT INTO `ms_generator` VALUES ('order_option_limit_right','0');
INSERT INTO `ms_generator` VALUES ('order_option_right','0');
INSERT INTO `ms_generator` VALUES ('order_store_option','0');
INSERT INTO `ms_generator` VALUES ('order_store_option_value','0');
INSERT INTO `ms_generator` VALUES ('order_store_option_block','0');
INSERT INTO `ms_generator` VALUES ('order_store_option_right','0');
INSERT INTO `ms_generator` VALUES ('info','24');
INSERT INTO `ms_generator` VALUES ('info_value','25');
INSERT INTO `ms_generator` VALUES ('info_right','0');
INSERT INTO `ms_generator` VALUES ('info_key','0');
INSERT INTO `ms_generator` VALUES ('info_key_value','0');
INSERT INTO `ms_generator` VALUES ('info_key_set','0');
INSERT INTO `ms_generator` VALUES ('param','0');
INSERT INTO `ms_generator` VALUES ('param_value','0');
INSERT INTO `ms_generator` VALUES ('provider','0');
INSERT INTO `ms_generator` VALUES ('provider_group','0');
INSERT INTO `ms_generator` VALUES ('provider_key','0');
INSERT INTO `ms_generator` VALUES ('provider_key_value','0');
INSERT INTO `ms_generator` VALUES ('provider_key_set','0');
INSERT INTO `ms_generator` VALUES ('report','0');
INSERT INTO `ms_generator` VALUES ('report_right','0');
INSERT INTO `ms_generator` VALUES ('store','1251');
INSERT INTO `ms_generator` VALUES ('store_param','0');
INSERT INTO `ms_generator` VALUES ('store_set','0');
INSERT INTO `ms_generator` VALUES ('store_clann','0');
INSERT INTO `ms_generator` VALUES ('self_key','2');
INSERT INTO `ms_generator` VALUES ('self_key_right','0');
INSERT INTO `ms_generator` VALUES ('self_key_value','5');
INSERT INTO `ms_generator` VALUES ('topic','24');
INSERT INTO `ms_generator` VALUES ('topic_store','1251');
INSERT INTO `ms_generator` VALUES ('topic_right','0');
INSERT INTO `ms_generator` VALUES ('topic_alt','10');
INSERT INTO `ms_generator` VALUES ('topic_filter','0');
INSERT INTO `ms_generator` VALUES ('topic_key','0');
INSERT INTO `ms_generator` VALUES ('topic_key_value','0');
INSERT INTO `ms_generator` VALUES ('topic_key_set','0');
INSERT INTO `ms_generator` VALUES ('user','1');
INSERT INTO `ms_generator` VALUES ('user_group','11');
INSERT INTO `ms_generator` VALUES ('user_filter','0');
INSERT INTO `ms_generator` VALUES ('web_outside','5');
INSERT INTO `ms_generator` VALUES ('web_outside_right','0');
INSERT INTO `ms_generator` VALUES ('web_inside','5');
INSERT INTO `ms_generator` VALUES ('web_inside_right','0');
INSERT INTO `ms_generator` VALUES ('web_key','0');
INSERT INTO `ms_generator` VALUES ('web_key_right','0');
INSERT INTO `ms_generator` VALUES ('web_key_value','0');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_generator_u`
--

DROP TABLE IF EXISTS `ms_generator_u`;

CREATE TABLE `ms_generator_u` (
  `table_name` char(50) NOT NULL DEFAULT '',
  `user_id` int unsigned NOT NULL DEFAULT '0',
  `gen_value` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`table_name`,`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_generator_u`
--

LOCK TABLES `ms_generator_u` WRITE;
INSERT INTO `ms_generator_u` VALUES ('u_info_value','1','0');
INSERT INTO `ms_generator_u` VALUES ('u_files_info_value','1','0');
INSERT INTO `ms_generator_u` VALUES ('u_store','1','0');
INSERT INTO `ms_generator_u` VALUES ('u_files_store','1','0');
INSERT INTO `ms_generator_u` VALUES ('u_store_set','1','0');
INSERT INTO `ms_generator_u` VALUES ('u_topic_store','1','0');
INSERT INTO `ms_generator_u` VALUES ('u_store_info','1','0');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_info`
--

DROP TABLE IF EXISTS `ms_info`;

CREATE TABLE `ms_info` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `descr` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `tindex` int unsigned NOT NULL DEFAULT '0',
  `tlevel` int unsigned NOT NULL DEFAULT '0',
  `absindex` int unsigned NOT NULL DEFAULT '0',
  `folder` tinyint unsigned NOT NULL DEFAULT '0',
  `kind_key` char(100) NOT NULL DEFAULT '',
  `type_key` char(100) NOT NULL DEFAULT '',
  `in_topic` tinyint unsigned NOT NULL DEFAULT '0',
  `in_goods` tinyint unsigned NOT NULL DEFAULT '0',
  `seo_code` char(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_info`
--

LOCK TABLES `ms_info` WRITE;
INSERT INTO `ms_info` VALUES ('22','','Межзрачковое расстояние','','12','2','19','0','kDefault','kText','0','0','');
INSERT INTO `ms_info` VALUES ('21','','Вынос зрачка, мм','','2','2','9','0','kDefault','kDecimal','0','0','');
INSERT INTO `ms_info` VALUES ('20','','Предел фокусировки от, м','','2','2','8','0','kDefault','kDecimal','0','0','');
INSERT INTO `ms_info` VALUES ('19','','Комплектация','','1','1','23','0','kDefault','kText','0','0','');
INSERT INTO `ms_info` VALUES ('18','','Корпус','','12','2','22','0','kDefault','kSet','0','0','');
INSERT INTO `ms_info` VALUES ('17','','Фокусировка','','12','2','18','0','kDefault','kSet','0','0','');
INSERT INTO `ms_info` VALUES ('16','','Увеличение','','12','2','17','0','kDefault','kSet','0','0','');
INSERT INTO `ms_info` VALUES ('14','','Стекла','','12','2','15','0','kDefault','kSet','1','0','');
INSERT INTO `ms_info` VALUES ('15','','Защита','','12','2','16','0','kDefault','kSet','1','0','');
INSERT INTO `ms_info` VALUES ('13','','Тип','','12','2','14','0','kDefault','kSet','1','0','');
INSERT INTO `ms_info` VALUES ('11','','Светосила','','2','2','12','0','kDefault','kDecimal','0','0','');
INSERT INTO `ms_info` VALUES ('12','','Конструкция','','1','1','13','1','kDefault','kSet','0','0','');
INSERT INTO `ms_info` VALUES ('10','','Фактор сумерек','','2','2','11','0','kDefault','kDecimal','0','0','');
INSERT INTO `ms_info` VALUES ('9','','Выходной зрачек, мм','','2','2','10','0','kDefault','kDecimal','0','0','');
INSERT INTO `ms_info` VALUES ('8','','Угловое поле зрения, град','','2','2','7','0','kDefault','kDecimal','0','0','');
INSERT INTO `ms_info` VALUES ('7','','Серия','','1','1','2','0','kDefault','kSet','1','0','');
INSERT INTO `ms_info` VALUES ('6','','Вес, кг','','1','1','1','0','kDefault','kDecimal','0','0','');
INSERT INTO `ms_info` VALUES ('5','','Поле зрения на 1000м','','2','2','6','0','kDefault','kDecimal','1','0','');
INSERT INTO `ms_info` VALUES ('4','','Max увеличение','','2','2','5','0','kDefault','kDecimal','1','0','');
INSERT INTO `ms_info` VALUES ('3','','Диаметр, мм','','2','2','4','0','kDefault','kDecimal','1','0','');
INSERT INTO `ms_info` VALUES ('2','','Оптика','','1','1','3','1','kDefault','kSet','0','0','');
INSERT INTO `ms_info` VALUES ('1','','Бинокли','','0','0','0','1','kDefault','kSet','0','0','');
INSERT INTO `ms_info` VALUES ('23','','Наглазники','','12','2','21','0','kDefault','kSet','0','0','');
INSERT INTO `ms_info` VALUES ('24','','Коррекция диоптрия','','12','2','20','0','kDefault','kText','1','0','');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_info_key`
--

DROP TABLE IF EXISTS `ms_info_key`;

CREATE TABLE `ms_info_key` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `tindex` int unsigned NOT NULL DEFAULT '0',
  `tlevel` int unsigned NOT NULL DEFAULT '0',
  `absindex` int unsigned NOT NULL DEFAULT '0',
  `folder` tinyint unsigned NOT NULL DEFAULT '0',
  `descr` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `mask_edit` char(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_info_key`
--

LOCK TABLES `ms_info_key` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_info_key_set`
--

DROP TABLE IF EXISTS `ms_info_key_set`;

CREATE TABLE `ms_info_key_set` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `info_id` int unsigned DEFAULT NULL,
  `key_id` int unsigned DEFAULT NULL,
  `value_id` int unsigned DEFAULT NULL,
  `value_txt` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  PRIMARY KEY (`id`),
  KEY `info_id` (`info_id`),
  KEY `key_id` (`key_id`),
  KEY `value_id` (`value_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_info_key_set`
--

LOCK TABLES `ms_info_key_set` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_info_key_value`
--

DROP TABLE IF EXISTS `ms_info_key_value`;

CREATE TABLE `ms_info_key_value` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `key_id` int unsigned DEFAULT NULL,
  `name` char(255) NOT NULL DEFAULT '',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `key_id` (`key_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_info_key_value`
--

LOCK TABLES `ms_info_key_value` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_info_right`
--

DROP TABLE IF EXISTS `ms_info_right`;

CREATE TABLE `ms_info_right` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `info_id` int unsigned DEFAULT NULL,
  `user_id` int unsigned DEFAULT NULL,
  `group_id` int unsigned DEFAULT NULL,
  `for_info` tinyint unsigned NOT NULL DEFAULT '0',
  `for_value` tinyint unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `info_id` (`info_id`),
  KEY `user_id` (`user_id`),
  KEY `group_id` (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_info_right`
--

LOCK TABLES `ms_info_right` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_info_value`
--

DROP TABLE IF EXISTS `ms_info_value`;

CREATE TABLE `ms_info_value` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `info_id` int unsigned DEFAULT NULL,
  `name` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `descr` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `kind_key` char(100) NOT NULL DEFAULT '',
  `params` char(255) NOT NULL DEFAULT '',
  `seo_code` char(255) NOT NULL DEFAULT '',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `info_id` (`info_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_info_value`
--

LOCK TABLES `ms_info_value` WRITE;
INSERT INTO `ms_info_value` VALUES ('25','','18','армированный стекловолокном','','kDefault','','','25');
INSERT INTO `ms_info_value` VALUES ('24','','14',' металлическое напыление','','kDefault','','','24');
INSERT INTO `ms_info_value` VALUES ('23','','7','Bresser Pirsch','','kDefault','','','23');
INSERT INTO `ms_info_value` VALUES ('22','','7','Bresser Corvette','','kDefault','','','22');
INSERT INTO `ms_info_value` VALUES ('21','','23','поворотно-выдвижные','','kDefault','','','21');
INSERT INTO `ms_info_value` VALUES ('20','','18','металл','','kDefault','','','20');
INSERT INTO `ms_info_value` VALUES ('19','','18','с креплением под штатив','','kDefault','','','11');
INSERT INTO `ms_info_value` VALUES ('17','','18','поликарбонат','','kDefault','','','9');
INSERT INTO `ms_info_value` VALUES ('18','','18','обрезиненный','','kDefault','','','10');
INSERT INTO `ms_info_value` VALUES ('15','','16','постоянное','','kDefault','','','7');
INSERT INTO `ms_info_value` VALUES ('16','','17','центральная','','kDefault','','','8');
INSERT INTO `ms_info_value` VALUES ('14','','15','газонаполненный','','kDefault','','','19');
INSERT INTO `ms_info_value` VALUES ('13','','15','водонепроницаемый','','kDefault','','','18');
INSERT INTO `ms_info_value` VALUES ('11','','15','водозащищенный','','kDefault','','','5');
INSERT INTO `ms_info_value` VALUES ('12','','15','ударостойкий','','kDefault','','','6');
INSERT INTO `ms_info_value` VALUES ('10','','14','просветление полное многослойное','','kDefault','','','17');
INSERT INTO `ms_info_value` VALUES ('9','','14','фазовая корреция','','kDefault','','','16');
INSERT INTO `ms_info_value` VALUES ('7','','14','ED-стекло','','kDefault','','','14');
INSERT INTO `ms_info_value` VALUES ('8','','14','призмы BAK4','','kDefault','','','15');
INSERT INTO `ms_info_value` VALUES ('6','','14','просветление многослойное','','kDefault','','','4');
INSERT INTO `ms_info_value` VALUES ('5','','14','призмы BK7','','kDefault','','','3');
INSERT INTO `ms_info_value` VALUES ('4','','13','Roof','','kDefault','','','13');
INSERT INTO `ms_info_value` VALUES ('3','','13','Porro','','kDefault','','','2');
INSERT INTO `ms_info_value` VALUES ('2','','7','Arsenal BW','','kDefault','','','12');
INSERT INTO `ms_info_value` VALUES ('1','','7','Arsenal Porro NBN18','','kDefault','','','1');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_key`
--

DROP TABLE IF EXISTS `ms_key`;

CREATE TABLE `ms_key` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `code` char(100) NOT NULL DEFAULT '',
  `name` char(100) NOT NULL DEFAULT '',
  `tindex` int unsigned NOT NULL DEFAULT '0',
  `tlevel` int unsigned NOT NULL DEFAULT '0',
  `absindex` int unsigned NOT NULL DEFAULT '0',
  `folder` tinyint unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_key`
--

LOCK TABLES `ms_key` WRITE;
INSERT INTO `ms_key` VALUES ('151','MODULE_TRANSLATE_LINE','Переводчик','150','2','92','0');
INSERT INTO `ms_key` VALUES ('150','code 150','Мультиязычность','106','1','91','0');
INSERT INTO `ms_key` VALUES ('149','TRANS_TABLE_KEY','Данные','145','3','43','0');
INSERT INTO `ms_key` VALUES ('148','TRANS_ORIGIN_KIND_KEY','Тип','147','3','45','0');
INSERT INTO `ms_key` VALUES ('147','code 147','Оригинал','142','2','44','1');
INSERT INTO `ms_key` VALUES ('146','TRANS_KIND_KEY','Тип','145','3','42','0');
INSERT INTO `ms_key` VALUES ('145','code 145','Категория','142','2','41','1');
INSERT INTO `ms_key` VALUES ('144','LANG_KIND_KEY','Тип','143','3','40','0');
INSERT INTO `ms_key` VALUES ('143','code 143','Язык','142','2','39','1');
INSERT INTO `ms_key` VALUES ('142','code 142','Мультиязычность','94','1','38','1');
INSERT INTO `ms_key` VALUES ('140','STORE_SET_OBJ_KEY','Объект','62','3','14','0');
INSERT INTO `ms_key` VALUES ('139','PROVIDER_STATE_KEY','Состояние','137','2','19','0');
INSERT INTO `ms_key` VALUES ('138','PROVIDER_KIND_KEY','Тип','137','2','18','0');
INSERT INTO `ms_key` VALUES ('137','code 137','Поставщики','1','1','17','1');
INSERT INTO `ms_key` VALUES ('136','FILES_WEB_KEY_VALUE','Группы файлов','132','3','65','0');
INSERT INTO `ms_key` VALUES ('135','WEB_KEY_VALUE_KIND_KEY','Тип','132','3','64','0');
INSERT INTO `ms_key` VALUES ('134','FILES_WEB_KEY','Группы файлов','131','3','62','0');
INSERT INTO `ms_key` VALUES ('133','WEB_KEY_KIND_KEY','Тип','131','3','61','0');
INSERT INTO `ms_key` VALUES ('132','code 132','Значение','130','2','63','1');
INSERT INTO `ms_key` VALUES ('131','code 131','Наименование','130','2','60','1');
INSERT INTO `ms_key` VALUES ('130','code 130','Опции модулей','94','1','59','1');
INSERT INTO `ms_key` VALUES ('129','TASK_STATE_KEY','Статус','127','2','58','0');
INSERT INTO `ms_key` VALUES ('128','TASK_KIND_KEY','Тип','127','2','57','0');
INSERT INTO `ms_key` VALUES ('127','code 127','Планировщик','94','1','56','1');
INSERT INTO `ms_key` VALUES ('125','HTML_TEMPLATE','Шаблоны','67','2','101','0');
INSERT INTO `ms_key` VALUES ('124','HTML_CLASS','Классы','67','2','100','0');
INSERT INTO `ms_key` VALUES ('123','HTML_TAG','Теги','67','2','99','0');
INSERT INTO `ms_key` VALUES ('118','code 118','Диспетчер','106','1','88','1');
INSERT INTO `ms_key` VALUES ('117','EVENT_NOTIFICATION','Список событий','118','2','90','0');
INSERT INTO `ms_key` VALUES ('116','MODULE_NOTIFICATION','Обнаружение событий','118','2','89','0');
INSERT INTO `ms_key` VALUES ('113','ORDER_STORE_OPTION_KIND_KEY','Тип','112','4','77','0');
INSERT INTO `ms_key` VALUES ('112','code 112','Опция','111','3','76','1');
INSERT INTO `ms_key` VALUES ('111','code 111','Опции товаров','76','2','75','1');
INSERT INTO `ms_key` VALUES ('110','FILES_BRAND','Группы файлов','108','2','22','0');
INSERT INTO `ms_key` VALUES ('109','BRAND_KIND_KEY','Тип','108','2','21','0');
INSERT INTO `ms_key` VALUES ('108','code 108','Бренды','1','1','20','1');
INSERT INTO `ms_key` VALUES ('107','ORDER_TRANSPORT','Параметры передачи','80','2','87','0');
INSERT INTO `ms_key` VALUES ('106','code 106','------------- Вызываемые модули ---------------','0','0','83','1');
INSERT INTO `ms_key` VALUES ('103','ADVERT_LINK_OBJ_KEY','Объект','102','3','54','0');
INSERT INTO `ms_key` VALUES ('102','code 102','Привязка','54','2','53','1');
INSERT INTO `ms_key` VALUES ('101','code 101','Товары','54','2','51','1');
INSERT INTO `ms_key` VALUES ('98','STORE_STATE_KEY','Состояние','43','2','10','0');
INSERT INTO `ms_key` VALUES ('97','INFO_TYPE_KEY','Содержание','33','3','26','0');
INSERT INTO `ms_key` VALUES ('95','code 95','------------- Каталог и товары ----------------','0','0','0','1');
INSERT INTO `ms_key` VALUES ('94','code 94','------------------ Компоненты --------------------','0','0','35','1');
INSERT INTO `ms_key` VALUES ('93','PARAM_KIND_KEY','Тип','92','2','32','0');
INSERT INTO `ms_key` VALUES ('92','code 92','Параметры','1','1','31','1');
INSERT INTO `ms_key` VALUES ('91','code 91','Фильтры товаров','94','1','36','1');
INSERT INTO `ms_key` VALUES ('88','code 88','Опции заказов','76','2','78','1');
INSERT INTO `ms_key` VALUES ('87','code 87','Значение','72','3','72','1');
INSERT INTO `ms_key` VALUES ('86','code 86','Поле','72','3','69','1');
INSERT INTO `ms_key` VALUES ('84','code 84','Значение опции','88','3','81','1');
INSERT INTO `ms_key` VALUES ('83','MODULE_ORDER_VERSION_ADD','Редактирование','80','2','86','0');
INSERT INTO `ms_key` VALUES ('81','MODULE_ORDER_VERSION_CALC','Калькуляция','80','2','85','0');
INSERT INTO `ms_key` VALUES ('80','code 80','Заказы','106','1','84','1');
INSERT INTO `ms_key` VALUES ('79','ORDER_OPTION_VALUE_KIND_KEY','Тип','84','4','82','0');
INSERT INTO `ms_key` VALUES ('78','ORDER_OPTION_KIND_KEY','Тип','77','4','80','0');
INSERT INTO `ms_key` VALUES ('77','code 77','Опция','88','3','79','1');
INSERT INTO `ms_key` VALUES ('76','code 76','Заказы','70','1','74','1');
INSERT INTO `ms_key` VALUES ('75','FIELD_VALUE_KIND_KEY','Тип','87','4','73','0');
INSERT INTO `ms_key` VALUES ('74','FIELD_SPEC_KEY','Спец','86','4','71','0');
INSERT INTO `ms_key` VALUES ('73','FIELD_KIND_KEY','Тип','86','4','70','0');
INSERT INTO `ms_key` VALUES ('72','code 72','Регистрация','71','2','68','1');
INSERT INTO `ms_key` VALUES ('71','code 71','Покупатели','70','1','67','1');
INSERT INTO `ms_key` VALUES ('70','code 70','-------------- Покупатели и заказы --------------','0','0','66','1');
INSERT INTO `ms_key` VALUES ('69','TOPIC_FILTER_KIND_KEY','Тип','91','2','37','0');
INSERT INTO `ms_key` VALUES ('67','code 67','HTML-редактор','8','1','97','1');
INSERT INTO `ms_key` VALUES ('66','code 66','Редактор изображений','8','1','94','1');
INSERT INTO `ms_key` VALUES ('65','HTML_OPTION','Настройки','67','2','98','0');
INSERT INTO `ms_key` VALUES ('62','code 62','Привязка','43','2','13','1');
INSERT INTO `ms_key` VALUES ('61','ADVERT_LINK_KIND_KEY','Тип','102','3','55','0');
INSERT INTO `ms_key` VALUES ('60','ADVERT_GOODS_KIND_KEY','Тип','101','3','52','0');
INSERT INTO `ms_key` VALUES ('58','FILES_ADVERT_TEXT','Группы файлов','57','3','50','0');
INSERT INTO `ms_key` VALUES ('57','code 57','Текст','54','2','48','1');
INSERT INTO `ms_key` VALUES ('56','ADVERT_TEXT_KIND_KEY','Тип','57','3','49','0');
INSERT INTO `ms_key` VALUES ('55','ADVERT_KIND_KEY','Тип блока','54','2','47','0');
INSERT INTO `ms_key` VALUES ('54','code 54','Промо-блоки','94','1','46','1');
INSERT INTO `ms_key` VALUES ('52','INFO_VALUE_KIND_KEY','Тип','34','3','29','0');
INSERT INTO `ms_key` VALUES ('51','DISC_KIND_KEY','Тип','50','2','34','0');
INSERT INTO `ms_key` VALUES ('50','code 50','Скидки','1','1','33','1');
INSERT INTO `ms_key` VALUES ('49','STORE_SET_KIND_KEY','Тип','62','3','15','0');
INSERT INTO `ms_key` VALUES ('47','FILES_STORE','Группы файлов','43','2','12','0');
INSERT INTO `ms_key` VALUES ('46','STORE_TEMPL_KEY','Стиль','43','2','11','0');
INSERT INTO `ms_key` VALUES ('45','STORE_STATUS_KEY','Статус','43','2','9','0');
INSERT INTO `ms_key` VALUES ('44','STORE_KIND_KEY','Тип','43','2','8','0');
INSERT INTO `ms_key` VALUES ('43','code 43','Товары','95','1','7','1');
INSERT INTO `ms_key` VALUES ('34','code 34','Значение','32','2','28','1');
INSERT INTO `ms_key` VALUES ('33','code 33','Наименование','32','2','24','1');
INSERT INTO `ms_key` VALUES ('32','code 32','Характеристики','1','1','23','1');
INSERT INTO `ms_key` VALUES ('24','TOPIC_ALT_KIND_KEY','Альтернативные каталоги','95','1','1','0');
INSERT INTO `ms_key` VALUES ('22','code 22','Разделы','95','1','2','1');
INSERT INTO `ms_key` VALUES ('21','TOPIC_ORDER_KEY','Сортировка','22','2','5','0');
INSERT INTO `ms_key` VALUES ('19','TOPIC_KIND_KEY','Тип','22','2','3','0');
INSERT INTO `ms_key` VALUES ('12','FILES_TOPIC','Группы файлов','22','2','6','0');
INSERT INTO `ms_key` VALUES ('11','TOPIC_TEMPL_KEY','Стиль','22','2','4','0');
INSERT INTO `ms_key` VALUES ('9','FILES_PROFILE','Профайлы','66','2','95','0');
INSERT INTO `ms_key` VALUES ('8','FILES_KEY_VALUE','------------- Настройки редакторов -------------','0','0','93','1');
INSERT INTO `ms_key` VALUES ('7','FILES_MASK','Файлы-маски','66','2','96','0');
INSERT INTO `ms_key` VALUES ('5','FILES_INFO_VALUE','Группы файлов','34','3','30','0');
INSERT INTO `ms_key` VALUES ('4','FILES_INFO','Группы файлов','33','3','27','0');
INSERT INTO `ms_key` VALUES ('2','INFO_KIND_KEY','Тип','33','3','25','0');
INSERT INTO `ms_key` VALUES ('1','code 1','----------- Основные справочники -----------','0','0','16','1');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_key_value`
--

DROP TABLE IF EXISTS `ms_key_value`;

CREATE TABLE `ms_key_value` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `key_code` char(100) NOT NULL DEFAULT '',
  `key_name` char(100) NOT NULL DEFAULT '',
  `value_txt` text NOT NULL DEFAULT (_utf8mb3''),
  `sys_key` tinyint unsigned NOT NULL DEFAULT '0',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `key_code` (`key_code`(10))
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_key_value`
--

LOCK TABLES `ms_key_value` WRITE;
INSERT INTO `ms_key_value` VALUES ('390','TRANS_TABLE_KEY','kOption','Опции заказа','0','390');
INSERT INTO `ms_key_value` VALUES ('387','HTML_TEMPLATE','Код','<pre><code>Code</code></pre>','0','387');
INSERT INTO `ms_key_value` VALUES ('388','TRANS_TABLE_KEY','kInfo','Характеристики','0','5');
INSERT INTO `ms_key_value` VALUES ('389','TRANS_TABLE_KEY','kClient','Покупатель','0','389');
INSERT INTO `ms_key_value` VALUES ('386','HTML_TEMPLATE','YouTube','<div class=\"embed-responsive embed-responsive-16by9\">  <iframe class=\"embed-responsive-item\" src=\"https://www.youtube.com/embed/zpOULjyy-n8?rel=0\" allowfullscreen></iframe></div>','0','386');
INSERT INTO `ms_key_value` VALUES ('342','HTML_CLASS','[a][button].btn btn-light','Light','0','342');
INSERT INTO `ms_key_value` VALUES ('341','HTML_CLASS','[a][button].btn btn-warning','Warning','0','341');
INSERT INTO `ms_key_value` VALUES ('340','HTML_CLASS','[a][button].btn btn-danger','Danger','0','340');
INSERT INTO `ms_key_value` VALUES ('339','HTML_CLASS','[a][button].btn btn-success','Success','0','339');
INSERT INTO `ms_key_value` VALUES ('338','HTML_CLASS','[a][button].btn btn-primary','Primary','0','338');
INSERT INTO `ms_key_value` VALUES ('337','HTML_CLASS','[div].alert alert-warning','Warning','0','337');
INSERT INTO `ms_key_value` VALUES ('336','HTML_CLASS','[div].alert alert-danger','Danger','0','336');
INSERT INTO `ms_key_value` VALUES ('335','HTML_CLASS','[div].alert alert-success','Success','0','335');
INSERT INTO `ms_key_value` VALUES ('334','HTML_CLASS','[span].badge badge-warning','Warning','0','334');
INSERT INTO `ms_key_value` VALUES ('333','HTML_CLASS','[span].badge badge-danger','Danger','0','333');
INSERT INTO `ms_key_value` VALUES ('332','HTML_CLASS','[span].badge badge-success','Success','0','332');
INSERT INTO `ms_key_value` VALUES ('331','HTML_CLASS','[span].badge badge-dark','Dark','0','331');
INSERT INTO `ms_key_value` VALUES ('329','HTML_CLASS','[p].lead','Акцент','0','329');
INSERT INTO `ms_key_value` VALUES ('330','HTML_CLASS','[span].badge badge-light','Light','0','330');
INSERT INTO `ms_key_value` VALUES ('327','HTML_CLASS','[p][div][h1][h2][h3][h4][h5].text-center','По центру','0','327');
INSERT INTO `ms_key_value` VALUES ('323','HTML_CLASS','[img].img-fluid img-thumbnail','Растягиваемое с рамкой','0','323');
INSERT INTO `ms_key_value` VALUES ('324','HTML_CLASS','[img].img-fluid img-thumbnail mx-auto img_preview img_max d-block','Максимум','0','324');
INSERT INTO `ms_key_value` VALUES ('322','HTML_CLASS','[img].img-fluid','Растягиваемое','0','322');
INSERT INTO `ms_key_value` VALUES ('321','HTML_CLASS','[img].','Просто изображение','0','321');
INSERT INTO `ms_key_value` VALUES ('317','HTML_TAG','code','Код','0','317');
INSERT INTO `ms_key_value` VALUES ('316','HTML_TAG','pre','Форматировать','0','316');
INSERT INTO `ms_key_value` VALUES ('315','HTML_TAG','button','Кнопка','0','315');
INSERT INTO `ms_key_value` VALUES ('302','TRANS_TABLE_KEY','kTag','Теги','0','2');
INSERT INTO `ms_key_value` VALUES ('313','HTML_TAG','img','Изображение','0','313');
INSERT INTO `ms_key_value` VALUES ('314','HTML_TAG','small','Маленькое','0','314');
INSERT INTO `ms_key_value` VALUES ('301','TOPIC_KIND_KEY','kText','Текстовая страница','0','301');
INSERT INTO `ms_key_value` VALUES ('296','TRANS_TABLE_KEY','kTopic','Разделы','0','3');
INSERT INTO `ms_key_value` VALUES ('297','TRANS_TABLE_KEY','kStore','Товары','0','4');
INSERT INTO `ms_key_value` VALUES ('299','MODULE_TRANSLATE_LINE','melbis_inc_translate.php','MELBIS_INC_TRANSLATE_service','0','299');
INSERT INTO `ms_key_value` VALUES ('295','TRANS_TABLE_KEY','kDefault','По умолчанию','1','1');
INSERT INTO `ms_key_value` VALUES ('293','TRANS_KIND_KEY','kDefault','По умолчанию','1','293');
INSERT INTO `ms_key_value` VALUES ('294','TRANS_ORIGIN_KIND_KEY','kDefault','По умолчанию','1','294');
INSERT INTO `ms_key_value` VALUES ('292','LANG_KIND_KEY','kDefault','По умолчанию','1','292');
INSERT INTO `ms_key_value` VALUES ('291','HTML_OPTION','kPostProcess','','1','291');
INSERT INTO `ms_key_value` VALUES ('290','STORE_SET_OBJ_KEY','kTopic','К разделу','1','290');
INSERT INTO `ms_key_value` VALUES ('289','STORE_SET_OBJ_KEY','kGoods','К товару','1','289');
INSERT INTO `ms_key_value` VALUES ('284','FILES_WEB_KEY_VALUE','kDefault','Иконка по умолчанию','0','284');
INSERT INTO `ms_key_value` VALUES ('286','PROVIDER_KIND_KEY','kDefault','По умолчанию','1','286');
INSERT INTO `ms_key_value` VALUES ('287','PROVIDER_STATE_KEY','kDefault','По умолчанию','1','287');
INSERT INTO `ms_key_value` VALUES ('288','INFO_TYPE_KEY','kText','Текст','1','288');
INSERT INTO `ms_key_value` VALUES ('283','FILES_WEB_KEY_VALUE','kDescr','Файл из описания','1','283');
INSERT INTO `ms_key_value` VALUES ('282','FILES_WEB_KEY_VALUE','kBase','Исходный файл','1','282');
INSERT INTO `ms_key_value` VALUES ('281','FILES_WEB_KEY','kDefault','Иконка по умолчанию','0','281');
INSERT INTO `ms_key_value` VALUES ('280','FILES_WEB_KEY','kDescr','Файл из описания','1','280');
INSERT INTO `ms_key_value` VALUES ('279','FILES_WEB_KEY','kBase','Исходный файл','1','279');
INSERT INTO `ms_key_value` VALUES ('273','TASK_STATE_KEY','kExplain','Требует уточнения','1','273');
INSERT INTO `ms_key_value` VALUES ('274','TASK_STATE_KEY','kComment','Комментарий','1','274');
INSERT INTO `ms_key_value` VALUES ('275','TASK_STATE_KEY','kClose','Закрыто','1','275');
INSERT INTO `ms_key_value` VALUES ('277','WEB_KEY_KIND_KEY','kDefault','По умолчанию','1','277');
INSERT INTO `ms_key_value` VALUES ('278','WEB_KEY_VALUE_KIND_KEY','kDefault','По умолчанию','1','278');
INSERT INTO `ms_key_value` VALUES ('272','TASK_STATE_KEY','kTrans','Перепоручено','1','272');
INSERT INTO `ms_key_value` VALUES ('271','TASK_STATE_KEY','kStop','Остановлено','1','271');
INSERT INTO `ms_key_value` VALUES ('270','TASK_STATE_KEY','kDone','Выполнено','1','270');
INSERT INTO `ms_key_value` VALUES ('269','TASK_STATE_KEY','kHold','Отложено','1','269');
INSERT INTO `ms_key_value` VALUES ('268','TASK_STATE_KEY','kAccept','Принято','1','268');
INSERT INTO `ms_key_value` VALUES ('267','TASK_STATE_KEY','kNew','Новое','1','267');
INSERT INTO `ms_key_value` VALUES ('266','TASK_KIND_KEY','kPriority3','Приоритет №3','0','266');
INSERT INTO `ms_key_value` VALUES ('265','TASK_KIND_KEY','kPriority2','Приоритет №2','0','265');
INSERT INTO `ms_key_value` VALUES ('264','TASK_KIND_KEY','kPriority1','Приоритет №1','0','264');
INSERT INTO `ms_key_value` VALUES ('263','TASK_KIND_KEY','kWish','Желательно','1','263');
INSERT INTO `ms_key_value` VALUES ('194','HTML_TAG','h5','<H5> Заголовок 5','1','9');
INSERT INTO `ms_key_value` VALUES ('195','HTML_TAG','h6','<H6> Заголовок 6','1','10');
INSERT INTO `ms_key_value` VALUES ('196','HTML_TAG','a','<A> Ссылка, якорь','1','4');
INSERT INTO `ms_key_value` VALUES ('253','HTML_TEMPLATE','Таблица','<table  border=\"1\" width=\"100%\" cellpadding=\"2\" cellspacing=\"2\"><tr><td>1</td><td>2</td></tr><tr><td>3</td><td>4</td></tr></table>','0','253');
INSERT INTO `ms_key_value` VALUES ('257','HTML_OPTION','kContainer','','1','257');
INSERT INTO `ms_key_value` VALUES ('261','TASK_KIND_KEY','kDefault','По умолчанию','1','261');
INSERT INTO `ms_key_value` VALUES ('262','TASK_KIND_KEY','kUrgent','Срочно','1','262');
INSERT INTO `ms_key_value` VALUES ('193','HTML_TAG','h4','<H4> Заголовок 4','1','8');
INSERT INTO `ms_key_value` VALUES ('192','HTML_TAG','h3','<H3> Заголовок 3','1','7');
INSERT INTO `ms_key_value` VALUES ('191','HTML_TAG','h2','<H2> Заголовок 2','1','6');
INSERT INTO `ms_key_value` VALUES ('184','HTML_TAG','h1','<H1> Заголовок 1','1','5');
INSERT INTO `ms_key_value` VALUES ('181','HTML_TAG','p','<P> Параграф','1','1');
INSERT INTO `ms_key_value` VALUES ('182','HTML_TAG','div','<DIV> Раздел','1','3');
INSERT INTO `ms_key_value` VALUES ('183','HTML_TAG','span','<SPAN> Фрагмент','1','2');
INSERT INTO `ms_key_value` VALUES ('178','FILES_KEY_VALUE','kAttach','Дополнительный файл','1','178');
INSERT INTO `ms_key_value` VALUES ('164','EVENT_NOTIFICATION','kNewClient','Новый покупатель','0','164');
INSERT INTO `ms_key_value` VALUES ('163','EVENT_NOTIFICATION','kNewOrder','Новый заказ','0','163');
INSERT INTO `ms_key_value` VALUES ('161','MODULE_NOTIFICATION','melbis_inc_logic.php','MELBIS_INC_LOGIC_notify_events','0','161');
INSERT INTO `ms_key_value` VALUES ('159','ORDER_STORE_OPTION_KIND_KEY','kDefault','По умолчанию','1','159');
INSERT INTO `ms_key_value` VALUES ('154','BRAND_KIND_KEY','kDefault','По умолчанию','1','154');
INSERT INTO `ms_key_value` VALUES ('155','FILES_BRAND','kBase','Исходный файл','1','155');
INSERT INTO `ms_key_value` VALUES ('156','FILES_BRAND','kDescr','Файл из описания','1','156');
INSERT INTO `ms_key_value` VALUES ('157','FILES_BRAND','kDefault','Иконка по умолчанию','0','157');
INSERT INTO `ms_key_value` VALUES ('153','ORDER_TRANSPORT','kDefault','По умолчанию','1','153');
INSERT INTO `ms_key_value` VALUES ('150','ADVERT_LINK_OBJ_KEY','kGoods','К товару','1','150');
INSERT INTO `ms_key_value` VALUES ('149','ADVERT_LINK_OBJ_KEY','kTopic','К разделу','1','149');
INSERT INTO `ms_key_value` VALUES ('148','STORE_STATE_KEY','kOk','Готовый','0','148');
INSERT INTO `ms_key_value` VALUES ('147','STORE_STATE_KEY','kDescrUp','Обновить описание','0','147');
INSERT INTO `ms_key_value` VALUES ('146','STORE_STATE_KEY','kDescrNeed','Составить описание','0','146');
INSERT INTO `ms_key_value` VALUES ('145','STORE_STATE_KEY','kImport','Импортирован','0','145');
INSERT INTO `ms_key_value` VALUES ('125','MODULE_ORDER_VERSION_ADD','melbis_inc_logic.php','MELBIS_INC_LOGIC_order_edit','0','125');
INSERT INTO `ms_key_value` VALUES ('131','PARAM_KIND_KEY','kDefault','По умолчанию','1','131');
INSERT INTO `ms_key_value` VALUES ('135','INFO_TYPE_KEY','kSet','Набор значений','1','135');
INSERT INTO `ms_key_value` VALUES ('137','INFO_TYPE_KEY','kDecimal','Число','1','137');
INSERT INTO `ms_key_value` VALUES ('138','STORE_STATE_KEY','kDefault','По умолчанию','1','138');
INSERT INTO `ms_key_value` VALUES ('123','MODULE_ORDER_VERSION_CALC','melbis_inc_logic.php','MELBIS_INC_LOGIC_order_calc','0','123');
INSERT INTO `ms_key_value` VALUES ('121','ORDER_OPTION_VALUE_KIND_KEY','kDefault','По умолчанию','1','121');
INSERT INTO `ms_key_value` VALUES ('120','ORDER_OPTION_KIND_KEY','kDefault','По умолчанию','1','120');
INSERT INTO `ms_key_value` VALUES ('117','FIELD_VALUE_KIND_KEY','kDefault','По умолчанию','1','117');
INSERT INTO `ms_key_value` VALUES ('116','FIELD_SPEC_KEY','kDefault','По умолчанию','1','116');
INSERT INTO `ms_key_value` VALUES ('114','TOPIC_FILTER_KIND_KEY','kDefault','По умолчанию','1','114');
INSERT INTO `ms_key_value` VALUES ('115','FIELD_KIND_KEY','kDefault','По умолчанию','1','115');
INSERT INTO `ms_key_value` VALUES ('110','HTML_OPTION','kCSS','','1','110');
INSERT INTO `ms_key_value` VALUES ('107','ADVERT_LINK_KIND_KEY','kId','По ID','1','107');
INSERT INTO `ms_key_value` VALUES ('105','ADVERT_GOODS_KIND_KEY','kDefault','По умолчанию','1','105');
INSERT INTO `ms_key_value` VALUES ('104','FILES_ADVERT_TEXT','kDefault','Иконка по умолчанию','0','104');
INSERT INTO `ms_key_value` VALUES ('103','FILES_ADVERT_TEXT','kDescr','Файл из описания','1','103');
INSERT INTO `ms_key_value` VALUES ('101','FILES_ADVERT_TEXT','kBase','Исходный файл','1','101');
INSERT INTO `ms_key_value` VALUES ('100','ADVERT_TEXT_KIND_KEY','kDefault','По умолчанию','1','100');
INSERT INTO `ms_key_value` VALUES ('94','ADVERT_KIND_KEY','kDefault','По умолчанию','1','94');
INSERT INTO `ms_key_value` VALUES ('82','STORE_SET_KIND_KEY','kDefault','По умолчанию','1','82');
INSERT INTO `ms_key_value` VALUES ('83','DISC_KIND_KEY','kOrder','От суммы заказа','1','83');
INSERT INTO `ms_key_value` VALUES ('85','DISC_KIND_KEY','kBalanceSum','От суммы баланса покупателя','0','85');
INSERT INTO `ms_key_value` VALUES ('86','INFO_VALUE_KIND_KEY','kDefault','По умолчанию','1','86');
INSERT INTO `ms_key_value` VALUES ('80','FILES_STORE','kDescrImg','Большое изображение','0','80');
INSERT INTO `ms_key_value` VALUES ('78','FILES_STORE','kDescr','Файл из описания','1','78');
INSERT INTO `ms_key_value` VALUES ('79','FILES_STORE','kDefault','Иконка по умолчанию','0','79');
INSERT INTO `ms_key_value` VALUES ('75','STORE_STATUS_KEY','kAbsentOrder','Ожидается не скоро','0','75');
INSERT INTO `ms_key_value` VALUES ('76','FILES_STORE','kBase','Исходный файл','1','76');
INSERT INTO `ms_key_value` VALUES ('74','STORE_STATUS_KEY','kExistOrder','Ожидается','0','74');
INSERT INTO `ms_key_value` VALUES ('73','STORE_STATUS_KEY','kAbsent','Отсутствует','1','73');
INSERT INTO `ms_key_value` VALUES ('72','STORE_STATUS_KEY','kExist','Есть на складе','1','72');
INSERT INTO `ms_key_value` VALUES ('71','STORE_TEMPL_KEY','kDefault','По умолчанию','1','71');
INSERT INTO `ms_key_value` VALUES ('70','STORE_KIND_KEY','kDefault','По умолчанию','1','70');
INSERT INTO `ms_key_value` VALUES ('41','TOPIC_ALT_KIND_KEY','kCenter','Центральный','0','2');
INSERT INTO `ms_key_value` VALUES ('40','TOPIC_ALT_KIND_KEY','kTree','Древовидный','1','1');
INSERT INTO `ms_key_value` VALUES ('39','TOPIC_ORDER_KEY','kDefault','По умолчанию','1','1');
INSERT INTO `ms_key_value` VALUES ('37','TOPIC_KIND_KEY','kLink','Ссылка на URL','1','4');
INSERT INTO `ms_key_value` VALUES ('35','TOPIC_KIND_KEY','kGoods','Отдел с товарами','1','2');
INSERT INTO `ms_key_value` VALUES ('25','FILES_TOPIC','kDefault','Иконка по умолчанию','0','4');
INSERT INTO `ms_key_value` VALUES ('22','FILES_TOPIC','kBase','Исходный файл','1','1');
INSERT INTO `ms_key_value` VALUES ('24','FILES_TOPIC','kDescr','Файл из описания','1','3');
INSERT INTO `ms_key_value` VALUES ('11','FILES_INFO_VALUE','kDescr','Файл из описания','1','3');
INSERT INTO `ms_key_value` VALUES ('15','FILES_KEY_VALUE','kBase','Базовый файл','1','1');
INSERT INTO `ms_key_value` VALUES ('20','TOPIC_TEMPL_KEY','kDefault','По умолчанию','1','1');
INSERT INTO `ms_key_value` VALUES ('17','FILES_PROFILE','Пример','<MELBISSHOP ShopVersion=\"Melbis Shop Commercial v6.2.1.345\"><JPEG FileType=\"0\" Compress=\"90\" Width=\"200\" Hight=\"200\" Smart=\"True\"/><FILE KindKey=\"kDefault\"/><MASK File=\"files/1899/12_30/00_00/\" Pos=\"0\" Alpha=\"0\"/><CANVAS Range=\"255\" Border=\"5\" Color=\"16777215\"/><ROTATE Rotate=\"0\" Mirror=\"False\"/><EFFECTS Red=\"0\" Green=\"0\" Blue=\"0\" Intensive=\"0\" Contrast=\"0\" Sharpen=\"10\"/></MELBISSHOP>','0','1');
INSERT INTO `ms_key_value` VALUES ('16','FILES_MASK','Без маски','','1','1');
INSERT INTO `ms_key_value` VALUES ('10','FILES_INFO','kDescr','Файл из описания','1','3');
INSERT INTO `ms_key_value` VALUES ('7','FILES_INFO_VALUE','kDefault','Иконка по умолчанию','0','4');
INSERT INTO `ms_key_value` VALUES ('5','FILES_INFO','kDefault','Иконка по умолчанию','0','4');
INSERT INTO `ms_key_value` VALUES ('4','FILES_INFO_VALUE','kBase','Исходный файл','1','1');
INSERT INTO `ms_key_value` VALUES ('3','FILES_INFO','kBase','Исходный файл','1','1');
INSERT INTO `ms_key_value` VALUES ('1','INFO_KIND_KEY','kDefault','По умолчанию','1','1');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_lang`
--

DROP TABLE IF EXISTS `ms_lang`;

CREATE TABLE `ms_lang` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `descr` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `kind_key` char(100) NOT NULL DEFAULT '',
  `params` char(255) NOT NULL DEFAULT '',
  `is_origin` tinyint unsigned NOT NULL DEFAULT '0',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_lang`
--

LOCK TABLES `ms_lang` WRITE;
INSERT INTO `ms_lang` VALUES ('3','en','English','','kDefault','','0','2');
INSERT INTO `ms_lang` VALUES ('2','uk','Українська','','kDefault','','0','3');
INSERT INTO `ms_lang` VALUES ('1','ru','Русский','','kDefault','','1','1');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_oper`
--

DROP TABLE IF EXISTS `ms_oper`;

CREATE TABLE `ms_oper` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `name` char(100) NOT NULL DEFAULT '',
  `tindex` int unsigned NOT NULL DEFAULT '0',
  `tlevel` int unsigned NOT NULL DEFAULT '0',
  `absindex` int unsigned NOT NULL DEFAULT '0',
  `folder` tinyint unsigned NOT NULL DEFAULT '0',
  `command` char(100) NOT NULL DEFAULT '',
  `allow_from` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `allow_to` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  PRIMARY KEY (`id`),
  KEY `command` (`command`(10))
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_oper`
--

LOCK TABLES `ms_oper` WRITE;
INSERT INTO `ms_oper` VALUES ('264','Бизнес','0','0','0','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('82','Диспетчер','264','1','1','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('83','Получить общую информацию','82','2','2','0','GET_COMMON_DATA','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('84','Читать сообщения','82','2','3','0','GET_USER_CHAT','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('85','Отправить сообщение','82','2','4','0','POST_USER_CHAT','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('246','Проверить уведомления','82','2','5','0','GET_EVENT_NOTIFICATION','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('281','Планировщик','264','1','6','1','','2016-04-04 00:00:00','2016-04-04 23:59:59');
INSERT INTO `ms_oper` VALUES ('282','Обновить настройки','281','2','7','0','GET_SCHED_RELATIVE','2016-04-04 00:00:00','2016-04-04 23:59:59');
INSERT INTO `ms_oper` VALUES ('283','Задачи','281','2','8','1','','2016-04-04 00:00:00','2016-04-04 23:59:59');
INSERT INTO `ms_oper` VALUES ('284','Получить','283','3','9','0','GET_SCHED_TASK','2016-04-04 00:00:00','2016-04-04 23:59:59');
INSERT INTO `ms_oper` VALUES ('285','Добавить','283','3','10','0','ADD_SCHED_TASK','2016-04-04 00:00:00','2016-04-04 23:59:59');
INSERT INTO `ms_oper` VALUES ('286','Комментарии','281','2','11','1','','2016-04-04 00:00:00','2016-04-04 23:59:59');
INSERT INTO `ms_oper` VALUES ('287','Получить','286','3','12','0','GET_SCHED_NOTE','2016-04-04 00:00:00','2016-04-04 23:59:59');
INSERT INTO `ms_oper` VALUES ('288','Добавить','286','3','13','0','ADD_SCHED_NOTE','2016-04-04 00:00:00','2016-04-04 23:59:59');
INSERT INTO `ms_oper` VALUES ('29','Валюты','264','1','14','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('30','Получить','29','2','15','0','GET_CURRENCY','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('31','Сохранить','29','2','16','0','PUT_CURRENCY','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('98','Скидки','264','1','17','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('99','Получить','98','2','18','0','GET_DISCOUNT','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('100','Сохранить','98','2','19','0','PUT_DISCOUNT','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('26','Поставщики','264','1','20','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('27','Получить','26','2','21','0','GET_PROVIDER','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('28','Сохранить','26','2','22','0','PUT_PROVIDER','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('166','Заказы','264','1','23','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('167','Обновить настройки','166','2','24','0','GET_ORDER_RELATIVE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('176','Получить заказы','166','2','25','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('177','Запрос на поиск','176','3','26','0','GET_SEARCH_ORDERS','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('175','Расширенный запрос','176','3','27','0','GET_EXTEND_ORDERS','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('231','Получить версии заказа','176','3','28','0','GET_ORDER_VERSION','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('178','Редактирование','166','2','29','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('179','Поиск покупателя','178','3','30','0','ORDER_CLIENT_SEARCH','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('174','Обновить информацию о товаре','178','3','31','0','ORDER_STORE_REFRESH','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('173','Выполнить калькуляцию заказа','178','3','32','0','ORDER_VERSION_CALC','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('170','Показывать цену поставщика','178','3','33','0','ORDER_PPRICE_ALLOW','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('172','Сохранить версию заказа','178','3','34','0','ORDER_VERSION_ADD','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('192','Удалить заказ','166','2','35','0','ORDER_DELETE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('193','Покупатели','264','1','36','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('194','Обновить настройки','193','2','37','0','GET_CLIENT_RELATIVE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('197','Получить покупателей','193','2','38','0','GET_CLIENT','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('198','Сохранить','193','2','39','0','UPDATE_CLIENT','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('201','Добавить','193','2','40','0','CLIENT_CREATE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('200','Удалить','193','2','41','0','CLIENT_DELETE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('266','Товары','0','0','42','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('232','Бренды','266','1','43','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('233','Получить','232','2','44','0','GET_BRAND','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('234','Сохранить','232','2','45','0','PUT_BRAND','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('16','Описания','266','1','46','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('248','Персональный раздел','16','2','47','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('210','Обновить настройки','248','3','48','0','GET_USER_FRAME_RELATIVE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('17','Получить','248','3','49','0','GET_USER_FRAME','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('18','Сохранить','248','3','50','0','PUT_USER_FRAME','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('68','Обмен данными','248','3','51','0','COPY_USER_FRAME','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('245','Проверка изменений','248','3','52','0','TEST_UPDATE_GOODS','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('35','Получить товары','16','2','53','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('209','Расширенный запрос','35','3','54','0','GET_EXTEND_IMPORT_GOODS','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('60','Запрос товаров раздела','35','3','55','0','GET_IMPORT_GOODS','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('41','Передать в магазин','16','2','56','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('51','Слияние характеристик','41','3','57','0','MERGE_INFO_VALUE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('50','Слияние товаров','41','3','58','0','MERGE_STORE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('227','Добавить новый клан','16','2','59','0','NEW_CLANN','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('292','Добавить новый бренд','16','2','60','0','NEW_BRAND','2017-02-12 00:00:00','2017-02-12 23:59:59');
INSERT INTO `ms_oper` VALUES ('295','Получить значения характеристик','16','2','61','0','GET_IMPORT_INFO_VALUE','2017-02-12 00:00:00','2017-02-12 23:59:59');
INSERT INTO `ms_oper` VALUES ('297','Переместить значения характеристик','16','2','62','0','RELOCATE_INFO_VALUE','2018-10-31 00:00:00','2018-10-31 23:59:59');
INSERT INTO `ms_oper` VALUES ('296','Переместить товары','16','2','63','0','RELOCATE_GOODS','2018-10-31 00:00:00','2018-10-31 23:59:59');
INSERT INTO `ms_oper` VALUES ('73','Расположение','266','1','64','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('269','Обновить настройки','73','2','65','0','GET_CONTROL_STORE_RELATIVE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('117','Получить товары','73','2','66','0','GET_CONTROL_STORE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('75','Сохранить','73','2','67','0','UPDATE_CONTROL_STORE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('72','Цены','266','1','68','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('204','Обновить настройки','72','2','69','0','GET_PRICE_STORE_RELATIVE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('214','Добавить товар','72','2','70','0','ADD_PRICE_STORE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('87','Получить товары раздела','72','2','71','0','GET_PART_PRICE_STORE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('208','Расширенный запрос товаров','72','2','72','0','GET_EXTEND_PRICE_STORE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('76','Сохранить','72','2','73','0','UPDATE_PRICE_STORE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('154','Прайс-листы','266','1','74','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('216','Обновить настройки','154','2','75','0','GET_DATA_EXCHANGE_RELATIVE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('155','Импорт и обновление товаров','154','2','76','0','IMPORT_UPDATE_STORE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('112','Восстановление','266','1','77','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('113','Получить','112','2','78','0','GET_REMOVE_STORE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('114','Восстановить','112','2','79','0','RESTORE_REMOVE_STORE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('115','Удалить','112','2','80','0','DELETE_REMOVE_STORE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('235','Отзывы','266','1','81','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('238','Получить','235','2','82','0','GET_STORE_COMMENT','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('240','Добавить','235','2','83','0','STORE_COMMENT_CREATE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('239','Сохранить','235','2','84','0','UPDATE_STORE_COMMENT','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('241','Черный список','235','2','85','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('242','Получить','241','3','86','0','GET_STORE_COMMENT_BLOCK','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('243','Добавить','241','3','87','0','ADD_STORE_COMMENT_BLOCK','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('244','Удалить','241','3','88','0','DELETE_STORE_COMMENT_BLOCK','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('263','Обозреватель','266','1','89','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('274','Обновить настройки','263','2','90','0','GET_SELECT_STORE_RELATIVE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('106','Получить товары раздела','263','2','91','0','GET_PART_SELECT_STORE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('191','Найти и получить товары','263','2','92','0','GET_SEARCH_SELECT_STORE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('265','Структура','0','0','93','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('32','Каталог','265','1','94','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('219','Быстрый доступ','32','2','95','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('57','Обновить список','219','3','96','0','GET_SELECT_TOPIC','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('220','Добавить','219','3','97','0','ADD_FAST_TOPIC','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('221','Переименовать','219','3','98','0','RENAME_FAST_TOPIC','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('275','Переместить','219','3','99','0','MOVE_FAST_TOPIC','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('276','Переместить вверх','219','3','100','0','MOVE_UP_FAST_TOPIC','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('277','Переместить вниз','219','3','101','0','MOVE_DOWN_FAST_TOPIC','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('225','Удалить','219','3','102','0','DELETE_FAST_TOPIC','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('305','Управление и настройки','32','2','103','1','','2018-11-21 00:00:00','2018-11-21 23:59:59');
INSERT INTO `ms_oper` VALUES ('33','Получить','305','3','104','0','GET_TOPIC','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('34','Сохранить','305','3','105','0','PUT_TOPIC','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('315','Альтернативные каталоги','32','2','106','1','','2019-02-16 00:00:00','2019-02-16 23:59:59');
INSERT INTO `ms_oper` VALUES ('316','Получить','315','3','107','0','GET_TOPIC_ALT','2019-02-16 00:00:00','2019-02-16 23:59:59');
INSERT INTO `ms_oper` VALUES ('317','Сохранить','315','3','108','0','PUT_TOPIC_ALT','2019-02-16 00:00:00','2019-02-16 23:59:59');
INSERT INTO `ms_oper` VALUES ('306','Права доступа пользователей','32','2','109','1','','2018-11-21 00:00:00','2018-11-21 23:59:59');
INSERT INTO `ms_oper` VALUES ('308','Получить','306','3','110','0','GET_TOPIC_RIGHT','2018-11-21 00:00:00','2018-11-21 23:59:59');
INSERT INTO `ms_oper` VALUES ('309','Сохранить','306','3','111','0','PUT_TOPIC_RIGHT','2018-11-21 00:00:00','2018-11-21 23:59:59');
INSERT INTO `ms_oper` VALUES ('307','Дополнительные опции','32','2','112','1','','2018-11-21 00:00:00','2018-11-21 23:59:59');
INSERT INTO `ms_oper` VALUES ('310','Получить','307','3','113','0','GET_TOPIC_KEY_SET','2018-11-21 00:00:00','2018-11-21 23:59:59');
INSERT INTO `ms_oper` VALUES ('311','Сохранить','307','3','114','0','PUT_TOPIC_KEY_SET','2018-11-21 00:00:00','2018-11-21 23:59:59');
INSERT INTO `ms_oper` VALUES ('19','Характеристики','265','1','115','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('108','Быстрый доступ','19','2','116','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('228','Добавить','108','3','117','0','ADD_FAST_INFO','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('229','Переименовать','108','3','118','0','RENAME_FAST_INFO','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('278','Переместить','108','3','119','0','MOVE_FAST_INFO','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('279','Переместить вверх','108','3','120','0','MOVE_UP_FAST_INFO','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('280','Переместить вниз','108','3','121','0','MOVE_DOWN_FAST_INFO','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('230','Удалить','108','3','122','0','DELETE_FAST_INFO','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('298','Управление и настройки','19','2','123','1','','2018-11-18 00:00:00','2018-11-18 23:59:59');
INSERT INTO `ms_oper` VALUES ('20','Получить','298','3','124','0','GET_INFO_VALUE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('21','Сохранить','298','3','125','0','PUT_INFO_VALUE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('270','Поиск неиспользуемых','298','3','126','0','SEARCH_UNUSED_INFO_VALUE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('299','Права доступа пользователей','19','2','127','1','','2018-11-18 00:00:00','2018-11-18 23:59:59');
INSERT INTO `ms_oper` VALUES ('300','Получить','299','3','128','0','GET_INFO_RIGHT','2018-11-18 00:00:00','2018-11-18 23:59:59');
INSERT INTO `ms_oper` VALUES ('301','Сохранить','299','3','129','0','PUT_INFO_RIGHT','2018-11-18 00:00:00','2018-11-18 23:59:59');
INSERT INTO `ms_oper` VALUES ('302','Дополнительные опции','19','2','130','1','','2018-11-20 00:00:00','2018-11-20 23:59:59');
INSERT INTO `ms_oper` VALUES ('303','Получить','302','3','131','0','GET_INFO_KEY_SET','2018-11-20 00:00:00','2018-11-20 23:59:59');
INSERT INTO `ms_oper` VALUES ('304','Сохранить','302','3','132','0','PUT_INFO_KEY_SET','2018-11-20 00:00:00','2018-11-20 23:59:59');
INSERT INTO `ms_oper` VALUES ('188','Параметры','265','1','133','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('189','Получить','188','2','134','0','GET_PARAM','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('190','Сохранить','188','2','135','0','PUT_PARAM','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('321','Мультиязычность','265','1','136','1','','2025-03-09 00:00:00','2025-03-09 23:59:59');
INSERT INTO `ms_oper` VALUES ('324','Языки и категории','321','2','137','1','','2025-03-11 00:00:00','2025-03-11 23:59:59');
INSERT INTO `ms_oper` VALUES ('322','Получить','324','3','138','0','GET_LANG','2025-03-09 00:00:00','2025-03-09 23:59:59');
INSERT INTO `ms_oper` VALUES ('323','Сохранить','324','3','139','0','PUT_LANG','2025-03-09 00:00:00','2025-03-09 23:59:59');
INSERT INTO `ms_oper` VALUES ('325','Переводы','321','2','140','1','','2025-03-11 00:00:00','2025-03-11 23:59:59');
INSERT INTO `ms_oper` VALUES ('326','Обновить настройки','325','3','141','0','GET_TRANS_LANG_RELATIVE','2025-03-11 00:00:00','2025-03-11 23:59:59');
INSERT INTO `ms_oper` VALUES ('330','Добавить оригинал','325','3','142','0','ADD_TRANS_ORIGIN','2025-03-12 00:00:00','2025-03-12 23:59:59');
INSERT INTO `ms_oper` VALUES ('331','Добавить перевод','325','3','143','0','ADD_TRANS_LANG','2025-03-14 00:00:00','2025-03-14 23:59:59');
INSERT INTO `ms_oper` VALUES ('329','Получить переводы','325','3','144','0','GET_PART_TRANS_LANG','2025-03-12 00:00:00','2025-03-12 23:59:59');
INSERT INTO `ms_oper` VALUES ('327','Расширенный запрос','325','3','145','0','GET_EXTEND_TRANS_LANG','2025-03-11 00:00:00','2025-03-11 23:59:59');
INSERT INTO `ms_oper` VALUES ('332','Выполнить перевод','325','3','146','0','TRANS_LANG_SERVICE','2025-03-14 00:00:00','2025-03-14 23:59:59');
INSERT INTO `ms_oper` VALUES ('328','Сохранить','325','3','147','0','UPDATE_TRANS_LANG','2025-03-11 00:00:00','2025-03-11 23:59:59');
INSERT INTO `ms_oper` VALUES ('185','Фильтры','265','1','148','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('186','Получить','185','2','149','0','GET_FILTER_TOPIC','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('187','Сохранить','185','2','150','0','PUT_FILTER_TOPIC','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('95','Промо-блоки','265','1','151','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('96','Получить','95','2','152','0','GET_ADVERT','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('97','Сохранить','95','2','153','0','PUT_ADVERT','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('271','Настройки','265','1','154','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('272','Получить','271','2','155','0','GET_USER_KEY','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('273','Сохранить','271','2','156','0','UPDATE_USER_KEY','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('262','Веб-модули','265','1','157','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('261','Получить список','262','2','158','0','GET_OUTSIDE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('267','Проектирование','0','0','159','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('22','Реестр настроек','267','1','160','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('23','Получить','22','2','161','0','GET_KEY_VALUE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('24','Сохранить','22','2','162','0','PUT_KEY_VALUE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('161','Опции заказа','267','1','163','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('162','Получить','161','2','164','0','GET_ORDER_OPTION','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('163','Сохранить','161','2','165','0','PUT_ORDER_OPTION','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('158','Опции покупателей','267','1','166','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('159','Получить','158','2','167','0','GET_CLIENT_RULES','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('160','Сохранить','158','2','168','0','PUT_CLIENT_RULES','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('180','Редактор отчетов','267','1','169','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('181','Получить','180','2','170','0','GET_REPORT','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('182','Сохранить','180','2','171','0','PUT_REPORT','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('257','Модули и опции','267','1','172','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('258','Получить','257','2','173','0','GET_OUTSIDE_RIGHT','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('259','Сохранить','257','2','174','0','PUT_OUTSIDE_RIGHT','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('8','Инсталляция','267','1','175','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('9','Получить данные','8','2','176','0','LOAD_SERVER_PARAMS','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('10','Сохранить данные','8','2','177','0','SAVE_SERVER_PARAMS','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('11','Протестировать настройки подключения','8','2','178','0','TEST_SERVER_PARAMS','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('12','Инсталляция таблиц','8','2','179','0','SERVER_INSTALL','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('13','Ремонт таблиц','8','2','180','0','SERVER_REPAIR','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('14','Копировать магазин','8','2','181','0','SHOP_DOWNLOAD','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('15','Загрузить магазин','8','2','182','0','SHOP_UPLOAD','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('120','Среда разработки','267','1','183','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('121','Работа с файлами','120','2','184','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('122','Загрузить перечень','121','3','185','0','LOAD_SCRIPTS_TREE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('217','Выполнить очистку кэша','121','3','186','0','SCRIPTS_CAHCE_CLEAR','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('255','Поиск текста в файлах','121','3','187','0','SCRIPTS_SEARCH','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('123','Набор шаблонов','121','3','188','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('126','Добавить','123','4','189','0','SCRIPTS_TEMPLATE_ADD','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('127','Переименовать','123','4','190','0','SCRIPTS_TEMPLATE_RENAME','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('128','Удалить','123','4','191','0','SCRIPTS_TEMPLATE_REMOVE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('129','Спец-файлы','121','3','192','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('131','Добавить','129','4','193','0','SCRIPTS_FILE_ADD','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('132','Переименовать','129','4','194','0','SCRIPTS_FILE_RENAME','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('133','Удалить','129','4','195','0','SCRIPTS_FILE_REMOVE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('249','Загрузить','129','4','196','0','SCRIPTS_FILE_LOAD','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('250','Сохранить','129','4','197','0','SCRIPTS_FILE_SAVE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('130','PHP-скрипты','121','3','198','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('134','Добавить','130','4','199','0','SCRIPTS_PHP_ADD','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('135','Переименовать','130','4','200','0','SCRIPTS_PHP_RENAME','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('136','Удалить','130','4','201','0','SCRIPTS_PHP_REMOVE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('251','Загрузить','130','4','202','0','SCRIPTS_PHP_LOAD','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('252','Сохранить','130','4','203','0','SCRIPTS_PHP_SAVE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('137','HTML-шаблоны','121','3','204','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('138','Добавить','137','4','205','0','SCRIPTS_HTML_ADD','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('139','Переименовать','137','4','206','0','SCRIPTS_HTML_RENAME','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('140','Удалить','137','4','207','0','SCRIPTS_HTML_REMOVE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('253','Загрузить','137','4','208','0','SCRIPTS_HTML_LOAD','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('254','Сохранить','137','4','209','0','SCRIPTS_HTML_SAVE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('141','Изображения','121','3','210','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('142','Добавить','141','4','211','0','SCRIPTS_IMAGE_ADD','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('143','Переименовать','141','4','212','0','SCRIPTS_IMAGE_RENAME','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('144','Удалить','141','4','213','0','SCRIPTS_IMAGE_REMOVE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('145','Каталог для изображений','121','3','214','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('146','Добавить','145','4','215','0','SCRIPTS_IMAGE_DIR_ADD','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('147','Переименовать','145','4','216','0','SCRIPTS_IMAGE_DIR_RENAME','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('148','Удалить','145','4','217','0','SCRIPTS_IMAGE_DIR_REMOVE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('289','Версии файлов','121','3','218','1','','2016-04-04 00:00:00','2016-04-04 23:59:59');
INSERT INTO `ms_oper` VALUES ('290','Получить перечень','289','4','219','0','SCRIPTS_VERSION_LIST','2016-04-04 00:00:00','2016-04-04 23:59:59');
INSERT INTO `ms_oper` VALUES ('291','Получить содержимое','289','4','220','0','SCRIPTS_VERSION_CONTENT','2016-04-04 00:00:00','2016-04-04 23:59:59');
INSERT INTO `ms_oper` VALUES ('149','База данных','120','2','221','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('150','Загрузить','149','3','222','0','LOAD_TABLE_TREE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('151','SQL-запрос','149','3','223','0','TEST_QUERY_EXECUTE','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('86','Обновить статистику','149','3','224','0','LOAD_TABLE_STAT','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('268','Система','0','0','225','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('5','Блокировки','268','1','226','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('6','Получить список','5','2','227','0','LOAD_LOCK_TABLES_LIST','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('54','Снять свою блокировку','5','2','228','0','UNLOCK_MY_TABLES','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('7','Снять любую блокировку','5','2','229','0','UNLOCK_ANY_TABLES','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('64','Пользователи','268','1','230','1','','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('1','Получить','64','2','231','0','GET_USERS','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('2','Сохранить','64','2','232','0','PUT_USERS','2000-01-01 00:00:00','2000-01-01 23:59:59');
INSERT INTO `ms_oper` VALUES ('318','Профайлы','268','1','233','1','','2019-02-17 00:00:00','2019-02-17 23:59:59');
INSERT INTO `ms_oper` VALUES ('319','Получить','318','2','234','0','LOAD_PROFILE','2019-02-17 00:00:00','2019-02-17 23:59:59');
INSERT INTO `ms_oper` VALUES ('320','Сохранить','318','2','235','0','SAVE_PROFILE','2019-02-17 00:00:00','2019-02-17 23:59:59');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_oper_block`
--

DROP TABLE IF EXISTS `ms_oper_block`;

CREATE TABLE `ms_oper_block` (
  `table_name` char(100) NOT NULL DEFAULT '',
  `oper_id` int unsigned DEFAULT NULL,
  `user_id` int unsigned DEFAULT NULL,
  `from_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `successful` tinyint unsigned NOT NULL DEFAULT '0',
  UNIQUE KEY `user_id` (`user_id`,`table_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_oper_block`
--

LOCK TABLES `ms_oper_block` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_oper_right`
--

DROP TABLE IF EXISTS `ms_oper_right`;

CREATE TABLE `ms_oper_right` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `oper_id` int unsigned DEFAULT NULL,
  `user_id` int unsigned DEFAULT NULL,
  `group_id` int unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `oper_id` (`oper_id`),
  KEY `user_id` (`user_id`),
  KEY `group_id` (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_oper_right`
--

LOCK TABLES `ms_oper_right` WRITE;
INSERT INTO `ms_oper_right` VALUES ('1','6',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('2','6',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('3','6',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('4','6',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('5','6',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('6','7',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('7','7',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('8','9',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('9','9',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('10','10',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('11','11',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('14','13',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('16','14',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('18','15',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('20','1',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('21','1',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('22','2',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('23','17',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('24','18',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('25','20',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('26','21',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('27','23',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('28','24',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('29','28',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('30','27',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('31','31',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('32','30',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('33','34',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('34','33',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('42','17',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('43','17',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('44','18',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('45','18',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('60','50',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('61','50',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('63','54',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('64','54',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('65','54',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('66','54',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('67','54',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('70','51',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('71','51',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('85','57',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('86','57',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('89','57',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('90','57',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('91','57',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('95','60',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('96','60',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('97','60',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('114','68',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('115','68',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('123','75',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('124','75',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('125','76',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('126','76',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('127','76',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('144','83',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('145','83',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('146','83',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('147','83',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('148','83',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('149','85',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('150','85',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('151','85',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('152','85',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('153','85',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('154','84',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('155','84',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('156','84',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('157','84',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('158','84',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('161','86',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('162','86',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('163','87',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('164','87',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('165','87',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('175','99',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('176','100',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('181','27',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('182','30',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('183','99',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('184','100',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('185','96',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('186','97',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('189','97',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('190','96',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('198','106',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('199','106',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('200','106',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('201','106',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('202','106',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('222','113',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('223','113',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('224','114',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('225','114',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('226','115',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('227','115',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('228','113',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('230','117',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('231','117',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('251','122',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('252','126',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('254','127',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('256','128',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('258','131',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('259','132',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('260','133',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('261','136',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('262','135',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('263','134',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('264','138',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('265','139',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('266','140',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('267','142',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('268','143',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('269','144',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('270','146',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('271','147',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('272','148',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('273','150',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('274','151',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('276','122',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('277','155',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('278','155',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('279','155',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('280','159',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('281','159',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('284','160',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('285','160',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('286','162',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('287','162',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('288','163',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('289','163',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('301','167',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('302','167',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('308','167',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('309','170',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('310','170',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('311','173',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('312','173',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('313','172',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('314','172',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('318','172',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('319','173',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('320','174',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('321','174',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('322','174',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('323','175',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('324','175',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('325','175',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('326','177',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('327','177',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('328','177',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('329','179',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('330','179',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('331','179',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('332','181',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('333','181',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('334','182',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('335','182',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('336','187',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('337','187',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('338','186',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('339','186',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('340','12',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('365','23',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('369','33',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('370','34',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('373','21',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('374','31',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('375','28',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('382','189',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('383','189',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('384','190',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('385','190',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('386','191',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('387','191',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('388','191',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('389','191',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('390','191',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('393','192',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('394','194',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('395','194',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('396','194',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('400','197',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('401','197',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('402','197',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('403','198',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('404','198',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('405','200',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('406','201',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('407','201',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('412','204',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('413','204',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('414','204',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('418','208',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('419','208',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('420','208',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('421','209',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('422','209',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('423','209',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('424','210',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('425','210',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('426','210',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('434','214',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('435','214',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('436','214',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('439','216',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('440','216',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('441','216',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('442','217',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('444','220',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('445','220',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('446','220',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('447','221',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('448','221',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('449','221',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('457','225',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('458','225',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('461','227',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('462','227',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('464','228',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('465','228',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('466','228',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('467','229',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('468','229',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('469','230',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('470','230',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('471','231',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('472','231',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('473','231',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('474','233',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('475','233',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('476','234',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('477','234',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('478','233',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('479','233',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('482','238',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('483','238',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('484','240',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('485','240',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('486','242',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('487','242',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('488','243',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('489','243',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('490','244',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('491','244',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('492','245',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('493','245',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('494','245',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('495','246',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('496','246',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('497','246',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('498','246',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('499','246',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('509','249',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('510','249',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('511','250',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('512','250',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('513','251',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('514','251',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('515','252',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('516','252',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('517','253',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('518','253',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('519','254',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('520','254',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('521','255',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('522','255',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('525','259',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('526','259',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('527','258',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('528','258',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('529','261',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('530','261',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('531','269',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('532','269',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('534','270',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('535','270',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('536','20',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('537','272',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('538','272',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('539','272',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('540','272',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('541','272',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('544','273',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('545','273',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('546','273',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('547','273',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('548','273',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('551','274',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('552','274',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('553','274',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('554','274',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('555','274',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('558','275',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('559','275',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('560','276',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('561','276',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('562','277',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('563','277',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('564','278',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('565','278',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('566','279',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('567','279',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('568','280',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('569','280',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('570','282',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('571','282',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('572','282',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('573','282',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('574','282',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('577','284',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('578','284',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('579','284',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('580','284',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('581','284',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('584','285',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('585','285',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('586','285',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('587','285',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('588','285',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('591','287',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('592','287',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('593','287',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('594','287',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('595','287',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('598','288',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('599','288',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('600','288',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('601','288',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('602','288',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('605','290',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('606','290',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('608','291',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('609','291',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('611','292',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('612','292',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('613','292',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('614','227',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('622','295',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('623','295',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('624','295',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('625','296',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('626','296',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('627','297',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('628','297',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('629','300',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('630','300',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('631','301',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('632','301',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('635','303',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('636','303',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('637','304',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('638','304',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('639','308',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('640','308',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('641','309',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('642','309',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('643','310',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('644','310',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('645','311',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('646','311',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('651','317',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('652','317',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('653','316',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('654','316',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('655','319',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('656','319',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('657','319',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('658','319',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('659','319',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('662','320',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('663','320',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('664','320',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('665','320',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('666','320',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('669','31',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('670','30',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('671','27',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('672','28',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('673','99',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('674','100',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('675','167',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('676','177',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('677','175',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('678','231',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('679','179',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('680','174',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('681','173',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('682','170',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('683','172',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('684','192',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('685','194',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('686','197',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('687','198',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('688','201',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('689','201',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('690','200',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('698','198',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('699','233',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('700','234',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('701','51',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('702','50',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('703','227',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('704','297',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('705','296',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('706','269',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('707','117',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('708','75',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('709','117',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('710','269',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('711','75',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('712','113',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('713','114',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('714','114',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('715','239',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('716','239',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('717','220',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('718','221',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('719','275',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('720','275',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('721','276',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('722','276',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('723','277',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('724','277',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('725','225',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('726','225',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('728','229',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('729','278',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('730','279',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('731','280',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('732','230',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('733','261',NULL,'3');
INSERT INTO `ms_oper_right` VALUES ('734','261',NULL,'4');
INSERT INTO `ms_oper_right` VALUES ('735','261',NULL,'5');
INSERT INTO `ms_oper_right` VALUES ('736','2',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('737','322',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('738','322',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('739','323',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('740','323',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('741','326',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('742','326',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('743','327',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('744','327',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('745','328',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('746','328',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('747','329',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('748','329',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('749','330',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('750','330',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('751','331',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('752','331',NULL,'2');
INSERT INTO `ms_oper_right` VALUES ('753','332',NULL,'1');
INSERT INTO `ms_oper_right` VALUES ('754','332',NULL,'2');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_oper_table`
--

DROP TABLE IF EXISTS `ms_oper_table`;

CREATE TABLE `ms_oper_table` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `oper_id` int unsigned DEFAULT NULL,
  `server_table` char(100) NOT NULL DEFAULT '',
  `local_table` char(100) NOT NULL DEFAULT '',
  `fields_list` char(255) NOT NULL DEFAULT '',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `oper_id` (`oper_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_oper_table`
--

LOCK TABLES `ms_oper_table` WRITE;
INSERT INTO `ms_oper_table` VALUES ('1','1','user_group','user_group','*','1');
INSERT INTO `ms_oper_table` VALUES ('2','1','user','users','*','2');
INSERT INTO `ms_oper_table` VALUES ('3','1','oper','oper','*','3');
INSERT INTO `ms_oper_table` VALUES ('4','1','oper_right','oper_right','*','4');
INSERT INTO `ms_oper_table` VALUES ('5','1','oper_table','oper_table','*','5');
INSERT INTO `ms_oper_table` VALUES ('6','2','user_group','user_group','*','1');
INSERT INTO `ms_oper_table` VALUES ('7','2','user','users','*','2');
INSERT INTO `ms_oper_table` VALUES ('8','2','oper','oper','*','3');
INSERT INTO `ms_oper_table` VALUES ('9','2','oper_right','oper_right','*','4');
INSERT INTO `ms_oper_table` VALUES ('10','2','oper_table','oper_table','*','5');
INSERT INTO `ms_oper_table` VALUES ('12','17','u_store','u_store','*','7');
INSERT INTO `ms_oper_table` VALUES ('13','17','u_topic_store','u_topic_store','*','10');
INSERT INTO `ms_oper_table` VALUES ('17','21','info','info','*','1');
INSERT INTO `ms_oper_table` VALUES ('18','21','info_value','info_value','*','2');
INSERT INTO `ms_oper_table` VALUES ('19','21','files_info','files_info','*','5');
INSERT INTO `ms_oper_table` VALUES ('20','20','info','info','*','1');
INSERT INTO `ms_oper_table` VALUES ('21','20','info_value','info_value','*','2');
INSERT INTO `ms_oper_table` VALUES ('22','20','files_info','files_info','*','5');
INSERT INTO `ms_oper_table` VALUES ('23','20','files_info_value','files_info_value','*','6');
INSERT INTO `ms_oper_table` VALUES ('24','21','files_info_value','files_info_value','*','6');
INSERT INTO `ms_oper_table` VALUES ('25','23','key','keys','*','1');
INSERT INTO `ms_oper_table` VALUES ('26','23','key_value','key_value','*','2');
INSERT INTO `ms_oper_table` VALUES ('27','24','key','keys','*','1');
INSERT INTO `ms_oper_table` VALUES ('28','24','key_value','key_value','*','2');
INSERT INTO `ms_oper_table` VALUES ('29','23','files_key_value','files_key_value','*','3');
INSERT INTO `ms_oper_table` VALUES ('30','24','files_key_value','files_key_value','*','3');
INSERT INTO `ms_oper_table` VALUES ('31','20','key_value','cut_key_value','*','7');
INSERT INTO `ms_oper_table` VALUES ('32','20','files_key_value','cut_files_key_value','*','8');
INSERT INTO `ms_oper_table` VALUES ('33','27','provider','provider','*','2');
INSERT INTO `ms_oper_table` VALUES ('34','28','provider','provider','*','0');
INSERT INTO `ms_oper_table` VALUES ('35','30','currency','currency','*','0');
INSERT INTO `ms_oper_table` VALUES ('36','31','currency','currency','*','0');
INSERT INTO `ms_oper_table` VALUES ('37','33','topic','topic','*','1');
INSERT INTO `ms_oper_table` VALUES ('40','34','topic','topic','*','1');
INSERT INTO `ms_oper_table` VALUES ('42','33','topic_alt','topic_alt','*','4');
INSERT INTO `ms_oper_table` VALUES ('43','34','topic_alt','topic_alt','*','3');
INSERT INTO `ms_oper_table` VALUES ('44','33','key_value','cut_key_value','*','12');
INSERT INTO `ms_oper_table` VALUES ('45','33','files_topic','files_topic','*','2');
INSERT INTO `ms_oper_table` VALUES ('46','34','files_topic','files_topic','*','2');
INSERT INTO `ms_oper_table` VALUES ('48','33','files_key_value','cut_files_key_value','*','13');
INSERT INTO `ms_oper_table` VALUES ('52','17','u_info_value','u_info_value','*','3');
INSERT INTO `ms_oper_table` VALUES ('54','17','u_files_info_value','u_files_info_value','*','4');
INSERT INTO `ms_oper_table` VALUES ('57','17','u_store_info','u_store_info','*','11');
INSERT INTO `ms_oper_table` VALUES ('58','17','u_files_store','u_files_store','*','8');
INSERT INTO `ms_oper_table` VALUES ('70','18','u_files_info_value','u_files_info_value','*','2');
INSERT INTO `ms_oper_table` VALUES ('73','18','u_store','u_store','*','3');
INSERT INTO `ms_oper_table` VALUES ('74','18','u_files_store','u_files_store','*','4');
INSERT INTO `ms_oper_table` VALUES ('76','18','u_topic_store','u_topic_store','*','6');
INSERT INTO `ms_oper_table` VALUES ('77','18','u_store_info','u_store_info','*','7');
INSERT INTO `ms_oper_table` VALUES ('114','50','store_info','','','4');
INSERT INTO `ms_oper_table` VALUES ('115','50','topic_store','','','5');
INSERT INTO `ms_oper_table` VALUES ('116','50','store','','','1');
INSERT INTO `ms_oper_table` VALUES ('117','50','files_store','','','2');
INSERT INTO `ms_oper_table` VALUES ('119','57','topic','cut_topic','*','119');
INSERT INTO `ms_oper_table` VALUES ('125','60','FUNC:GetImportStore','imp_store','*','3');
INSERT INTO `ms_oper_table` VALUES ('126','60','FUNC:GetImportFilesStore','imp_files_store','*','4');
INSERT INTO `ms_oper_table` VALUES ('129','60','FUNC:GetImportTopicStore','imp_topic_store','*','6');
INSERT INTO `ms_oper_table` VALUES ('130','60','FUNC:GetImportStoreInfo','imp_store_info','*','7');
INSERT INTO `ms_oper_table` VALUES ('163','87','FUNC:GetPartPriceStore','part_price_store','*','1');
INSERT INTO `ms_oper_table` VALUES ('164','87','FUNC:GetPartPriceTopicStore','part_price_topic_store','*','2');
INSERT INTO `ms_oper_table` VALUES ('174','17','u_store_set','u_store_set','*','9');
INSERT INTO `ms_oper_table` VALUES ('175','18','u_store_set','u_store_set','*','5');
INSERT INTO `ms_oper_table` VALUES ('181','60','FUNC:GetImportStoreSet','imp_store_set','*','5');
INSERT INTO `ms_oper_table` VALUES ('183','99','disc_group','disc_group','*','183');
INSERT INTO `ms_oper_table` VALUES ('184','99','disc_rate','disc_rate','*','184');
INSERT INTO `ms_oper_table` VALUES ('185','100','disc_group','disc_group','*','185');
INSERT INTO `ms_oper_table` VALUES ('186','100','disc_rate','disc_rate','*','186');
INSERT INTO `ms_oper_table` VALUES ('187','99','currency','cut_currency','*','187');
INSERT INTO `ms_oper_table` VALUES ('188','99','key_value','cut_key_value','*','188');
INSERT INTO `ms_oper_table` VALUES ('189','99','files_key_value','cut_files_key_value','*','189');
INSERT INTO `ms_oper_table` VALUES ('193','50','store_set','','','3');
INSERT INTO `ms_oper_table` VALUES ('212','113','FUNC:GetRemoveStore','remove_store','*','212');
INSERT INTO `ms_oper_table` VALUES ('213','117','FUNC:GetPartControlStore','part_control_store','*','1');
INSERT INTO `ms_oper_table` VALUES ('214','117','FUNC:GetPartControlTopicStore','part_control_topic_store','*','2');
INSERT INTO `ms_oper_table` VALUES ('222','96','advert','advert','*','1');
INSERT INTO `ms_oper_table` VALUES ('223','97','advert','advert','*','223');
INSERT INTO `ms_oper_table` VALUES ('224','96','key_value','cut_key_value','*','7');
INSERT INTO `ms_oper_table` VALUES ('225','96','files_key_value','cut_files_key_value','*','8');
INSERT INTO `ms_oper_table` VALUES ('226','96','advert_text','advert_text','*','2');
INSERT INTO `ms_oper_table` VALUES ('227','96','files_advert_text','files_advert_text','*','3');
INSERT INTO `ms_oper_table` VALUES ('228','96','advert_goods','advert_goods','*','4');
INSERT INTO `ms_oper_table` VALUES ('229','96','advert_link','advert_link','*','5');
INSERT INTO `ms_oper_table` VALUES ('231','96','topic','cut_topic','*','6');
INSERT INTO `ms_oper_table` VALUES ('232','97','advert_text','advert_text','*','232');
INSERT INTO `ms_oper_table` VALUES ('233','97','files_advert_text','files_advert_text','*','233');
INSERT INTO `ms_oper_table` VALUES ('234','97','advert_goods','advert_goods','*','234');
INSERT INTO `ms_oper_table` VALUES ('235','97','advert_link','advert_link','*','235');
INSERT INTO `ms_oper_table` VALUES ('240','159','field','field','*','1');
INSERT INTO `ms_oper_table` VALUES ('241','159','field_value','field_value','*','3');
INSERT INTO `ms_oper_table` VALUES ('242','159','client_group','client_group','*','4');
INSERT INTO `ms_oper_table` VALUES ('243','159','client_rules','client_rules','*','5');
INSERT INTO `ms_oper_table` VALUES ('244','159','files_field','files_field','*','2');
INSERT INTO `ms_oper_table` VALUES ('245','159','key_value','cut_key_value','*','7');
INSERT INTO `ms_oper_table` VALUES ('246','159','files_key_value','cut_files_key_value','*','8');
INSERT INTO `ms_oper_table` VALUES ('247','160','field','field','*','1');
INSERT INTO `ms_oper_table` VALUES ('248','160','field_value','field_value','*','3');
INSERT INTO `ms_oper_table` VALUES ('249','160','files_field','files_field','*','2');
INSERT INTO `ms_oper_table` VALUES ('250','160','client_group','client_group','*','4');
INSERT INTO `ms_oper_table` VALUES ('251','160','client_rules','client_rules','*','5');
INSERT INTO `ms_oper_table` VALUES ('252','159','currency','cut_currency','*','6');
INSERT INTO `ms_oper_table` VALUES ('253','162','order_option','order_option','*','5');
INSERT INTO `ms_oper_table` VALUES ('254','162','files_order_option','files_order_option','*','7');
INSERT INTO `ms_oper_table` VALUES ('255','162','order_option_value','order_option_value','*','6');
INSERT INTO `ms_oper_table` VALUES ('256','162','files_order_option_value','files_order_option_value','*','8');
INSERT INTO `ms_oper_table` VALUES ('257','162','key_value','cut_key_value','*','19');
INSERT INTO `ms_oper_table` VALUES ('258','162','files_key_value','cut_files_key_value','*','20');
INSERT INTO `ms_oper_table` VALUES ('259','163','order_option','order_option','*','5');
INSERT INTO `ms_oper_table` VALUES ('260','163','order_option_value','order_option_value','*','6');
INSERT INTO `ms_oper_table` VALUES ('261','163','files_order_option','files_order_option','*','7');
INSERT INTO `ms_oper_table` VALUES ('262','163','files_order_option_value','files_order_option_value','*','8');
INSERT INTO `ms_oper_table` VALUES ('263','162','currency','cut_currency','*','14');
INSERT INTO `ms_oper_table` VALUES ('278','167','key_value','cut_key_value','*','1');
INSERT INTO `ms_oper_table` VALUES ('279','167','files_key_value','cut_files_key_value','*','2');
INSERT INTO `ms_oper_table` VALUES ('280','167','order_option','cut_order_option','*','3');
INSERT INTO `ms_oper_table` VALUES ('281','167','order_option_value','cut_order_option_value','*','4');
INSERT INTO `ms_oper_table` VALUES ('282','167','field','cut_field','*','10');
INSERT INTO `ms_oper_table` VALUES ('283','167','field_value','cut_field_value','*','11');
INSERT INTO `ms_oper_table` VALUES ('284','167','currency','cut_currency','*','12');
INSERT INTO `ms_oper_table` VALUES ('285','167','provider','cut_provider','id,skey,group_id,name,serv_addr,serv_phone,pos','14');
INSERT INTO `ms_oper_table` VALUES ('286','167','user','cut_user','id,group_id,login,name,phone,email,add_group_id','16');
INSERT INTO `ms_oper_table` VALUES ('287','167','user_group','cut_user_group','*','17');
INSERT INTO `ms_oper_table` VALUES ('288','175','FUNC:GetOrdersOrders','orders','*','1');
INSERT INTO `ms_oper_table` VALUES ('289','175','FUNC:GetOrdersClientField','orders_client_field','*','3');
INSERT INTO `ms_oper_table` VALUES ('290','175','FUNC:GetOrdersStore','orders_store','*','4');
INSERT INTO `ms_oper_table` VALUES ('291','175','FUNC:GetOrdersVersion','orders_version','*','2');
INSERT INTO `ms_oper_table` VALUES ('292','175','FUNC:GetOrdersOption','orders_option','*','5');
INSERT INTO `ms_oper_table` VALUES ('293','167','order_option_right','cut_order_option_right','*','18');
INSERT INTO `ms_oper_table` VALUES ('294','167','oper','cut_oper','*','19');
INSERT INTO `ms_oper_table` VALUES ('295','167','oper_right','cut_oper_right','*','20');
INSERT INTO `ms_oper_table` VALUES ('297','181','key_value','cut_key_value','*','7');
INSERT INTO `ms_oper_table` VALUES ('298','181','files_key_value','cut_files_key_value','*','8');
INSERT INTO `ms_oper_table` VALUES ('299','181','report','report','*','1');
INSERT INTO `ms_oper_table` VALUES ('300','182','report','report','*','300');
INSERT INTO `ms_oper_table` VALUES ('305','181','report_right','report_right','*','2');
INSERT INTO `ms_oper_table` VALUES ('306','182','report_right','report_right','*','306');
INSERT INTO `ms_oper_table` VALUES ('307','181','oper','cut_oper','*','3');
INSERT INTO `ms_oper_table` VALUES ('308','181','oper_right','cut_oper_right','*','4');
INSERT INTO `ms_oper_table` VALUES ('309','162','order_option_right','order_option_right','*','9');
INSERT INTO `ms_oper_table` VALUES ('310','162','order_right','order_right','*','10');
INSERT INTO `ms_oper_table` VALUES ('311','163','order_right','order_right','*','9');
INSERT INTO `ms_oper_table` VALUES ('312','163','order_option_right','order_option_right','*','10');
INSERT INTO `ms_oper_table` VALUES ('313','162','oper','cut_oper','*','15');
INSERT INTO `ms_oper_table` VALUES ('314','162','oper_right','cut_oper_right','*','16');
INSERT INTO `ms_oper_table` VALUES ('315','162','user','cut_user','id,group_id,login,name,phone,email,add_group_id','17');
INSERT INTO `ms_oper_table` VALUES ('316','162','user_group','cut_user_group','*','18');
INSERT INTO `ms_oper_table` VALUES ('317','181','user','cut_user','id,group_id,login,name,phone,email,add_group_id','5');
INSERT INTO `ms_oper_table` VALUES ('318','181','user_group','cut_user_group','*','6');
INSERT INTO `ms_oper_table` VALUES ('319','33','oper','cut_oper','*','8');
INSERT INTO `ms_oper_table` VALUES ('320','33','oper_right','cut_oper_right','*','9');
INSERT INTO `ms_oper_table` VALUES ('321','33','user','cut_user','id,group_id,login,name,phone,email,add_group_id','10');
INSERT INTO `ms_oper_table` VALUES ('322','33','user_group','cut_user_group','*','11');
INSERT INTO `ms_oper_table` VALUES ('323','33','topic_right','topic_right','*','3');
INSERT INTO `ms_oper_table` VALUES ('324','34','topic_right','topic_right','*','324');
INSERT INTO `ms_oper_table` VALUES ('331','167','report','cut_report','*','21');
INSERT INTO `ms_oper_table` VALUES ('332','167','report_right','cut_report_right','*','22');
INSERT INTO `ms_oper_table` VALUES ('333','186','topic','cut_topic','*','2');
INSERT INTO `ms_oper_table` VALUES ('334','186','topic_filter','topic_filter','*','1');
INSERT INTO `ms_oper_table` VALUES ('335','187','topic_filter','topic_filter','*','335');
INSERT INTO `ms_oper_table` VALUES ('336','186','info','cut_info','*','336');
INSERT INTO `ms_oper_table` VALUES ('337','186','key_value','cut_key_value','*','337');
INSERT INTO `ms_oper_table` VALUES ('338','186','files_key_value','cut_files_key_value','*','338');
INSERT INTO `ms_oper_table` VALUES ('340','190','param','param','*','340');
INSERT INTO `ms_oper_table` VALUES ('342','189','param','param','*','1');
INSERT INTO `ms_oper_table` VALUES ('343','189','key_value','cut_key_value','*','4');
INSERT INTO `ms_oper_table` VALUES ('344','189','files_key_value','cut_files_key_value','*','5');
INSERT INTO `ms_oper_table` VALUES ('346','87','FUNC:GetPartPriceStoreParam','part_price_store_param','*','3');
INSERT INTO `ms_oper_table` VALUES ('347','194','field','cut_field','*','4');
INSERT INTO `ms_oper_table` VALUES ('348','194','field_value','cut_field_value','*','5');
INSERT INTO `ms_oper_table` VALUES ('349','194','client_group','cut_client_group','*','6');
INSERT INTO `ms_oper_table` VALUES ('350','197','FUNC:GetClient','client','*','350');
INSERT INTO `ms_oper_table` VALUES ('351','197','FUNC:GetClientField','client_field','*','351');
INSERT INTO `ms_oper_table` VALUES ('352','194','key_value','cut_key_value','*','1');
INSERT INTO `ms_oper_table` VALUES ('353','194','files_key_value','cut_files_key_value','*','3');
INSERT INTO `ms_oper_table` VALUES ('354','194','user','cut_user','id,group_id,login,name,phone,email,add_group_id','7');
INSERT INTO `ms_oper_table` VALUES ('355','194','user_group','cut_user_group','*','8');
INSERT INTO `ms_oper_table` VALUES ('356','194','oper','cut_oper','*','9');
INSERT INTO `ms_oper_table` VALUES ('357','194','oper_right','cut_oper_right','*','10');
INSERT INTO `ms_oper_table` VALUES ('358','194','report','cut_report','*','11');
INSERT INTO `ms_oper_table` VALUES ('359','194','report_right','cut_report_right','*','12');
INSERT INTO `ms_oper_table` VALUES ('360','204','currency','cut_currency','*','1');
INSERT INTO `ms_oper_table` VALUES ('361','204','provider','cut_provider','id,skey,group_id,name,serv_addr,serv_phone,pos','3');
INSERT INTO `ms_oper_table` VALUES ('362','204','disc_group','cut_disc_group','*','5');
INSERT INTO `ms_oper_table` VALUES ('363','204','disc_rate','cut_disc_rate','*','6');
INSERT INTO `ms_oper_table` VALUES ('364','204','param','cut_param','*','7');
INSERT INTO `ms_oper_table` VALUES ('365','204','key_value','cut_key_value','*','9');
INSERT INTO `ms_oper_table` VALUES ('366','204','files_key_value','cut_files_key_value','*','10');
INSERT INTO `ms_oper_table` VALUES ('368','208','FUNC:GetExtendPriceTopicStore','part_price_topic_store','*','2');
INSERT INTO `ms_oper_table` VALUES ('369','208','FUNC:GetExtendPriceStore','part_price_store','*','1');
INSERT INTO `ms_oper_table` VALUES ('370','208','FUNC:GetExtendPriceStoreParam','part_price_store_param','*','370');
INSERT INTO `ms_oper_table` VALUES ('372','204','user','cut_user','id,group_id,login,name,phone,email,add_group_id','11');
INSERT INTO `ms_oper_table` VALUES ('373','204','user_group','cut_user_group','*','12');
INSERT INTO `ms_oper_table` VALUES ('374','204','oper','cut_oper','*','13');
INSERT INTO `ms_oper_table` VALUES ('375','204','oper_right','cut_oper_right','*','14');
INSERT INTO `ms_oper_table` VALUES ('376','204','report','cut_report','*','15');
INSERT INTO `ms_oper_table` VALUES ('377','204','report_right','cut_report_right','*','16');
INSERT INTO `ms_oper_table` VALUES ('380','210','key_value','cut_key_value','*','3');
INSERT INTO `ms_oper_table` VALUES ('381','210','files_key_value','cut_files_key_value','*','4');
INSERT INTO `ms_oper_table` VALUES ('382','216','provider','cut_provider','id,skey,group_id,name,serv_addr,serv_phone,pos','2');
INSERT INTO `ms_oper_table` VALUES ('383','220','topic','','','383');
INSERT INTO `ms_oper_table` VALUES ('384','221','topic','','','384');
INSERT INTO `ms_oper_table` VALUES ('387','225','topic','','','387');
INSERT INTO `ms_oper_table` VALUES ('389','220','topic_right','','','389');
INSERT INTO `ms_oper_table` VALUES ('391','228','info','','','391');
INSERT INTO `ms_oper_table` VALUES ('392','229','info','','','392');
INSERT INTO `ms_oper_table` VALUES ('393','230','info','','','393');
INSERT INTO `ms_oper_table` VALUES ('394','231','FUNC:GetPartOrdersVersion','part_orders_version','*','2');
INSERT INTO `ms_oper_table` VALUES ('395','231','FUNC:GetPartOrdersClientField','part_orders_client_field','*','3');
INSERT INTO `ms_oper_table` VALUES ('396','231','FUNC:GetPartOrdersStore','part_orders_store','*','4');
INSERT INTO `ms_oper_table` VALUES ('397','231','FUNC:GetPartOrdersOption','part_orders_option','*','5');
INSERT INTO `ms_oper_table` VALUES ('398','233','brand','brand','*','1');
INSERT INTO `ms_oper_table` VALUES ('399','233','files_brand','files_brand','*','2');
INSERT INTO `ms_oper_table` VALUES ('400','234','brand','brand','*','400');
INSERT INTO `ms_oper_table` VALUES ('401','234','files_brand','files_brand','*','401');
INSERT INTO `ms_oper_table` VALUES ('402','233','key_value','cut_key_value','*','6');
INSERT INTO `ms_oper_table` VALUES ('403','233','files_key_value','cut_files_key_value','*','7');
INSERT INTO `ms_oper_table` VALUES ('404','204','brand','cut_brand','id,skey,name,kind_key,params,seo_code,pos','4');
INSERT INTO `ms_oper_table` VALUES ('405','210','brand','cut_brand','id,skey,name,kind_key,params,seo_code,pos','1');
INSERT INTO `ms_oper_table` VALUES ('407','167','brand','cut_brand','id,skey,name,kind_key,params,seo_code,pos','15');
INSERT INTO `ms_oper_table` VALUES ('410','210','currency','cut_currency','*','2');
INSERT INTO `ms_oper_table` VALUES ('411','238','FUNC:GetStoreComment','store_comment','*','411');
INSERT INTO `ms_oper_table` VALUES ('412','242','store_comment_block','store_comment_block','*','412');
INSERT INTO `ms_oper_table` VALUES ('413','231','FUNC:GetPartOrdersOrders','part_orders','*','1');
INSERT INTO `ms_oper_table` VALUES ('414','162','order_store_option','order_store_option','*','1');
INSERT INTO `ms_oper_table` VALUES ('415','162','order_store_option_value','order_store_option_value','*','2');
INSERT INTO `ms_oper_table` VALUES ('417','163','order_store_option','order_store_option','*','1');
INSERT INTO `ms_oper_table` VALUES ('418','163','order_store_option_value','order_store_option_value','*','2');
INSERT INTO `ms_oper_table` VALUES ('419','167','order_store_option','cut_order_store_option','*','23');
INSERT INTO `ms_oper_table` VALUES ('420','167','order_store_option_value','cut_order_store_option_value','*','24');
INSERT INTO `ms_oper_table` VALUES ('421','175','FUNC:GetOrdersStoreOption','orders_store_option','*','421');
INSERT INTO `ms_oper_table` VALUES ('423','231','FUNC:GetPartOrdersStoreOption','part_orders_store_option','*','423');
INSERT INTO `ms_oper_table` VALUES ('429','210','info','cut_info','*','5');
INSERT INTO `ms_oper_table` VALUES ('432','258','web_outside','web_outside','*','1');
INSERT INTO `ms_oper_table` VALUES ('433','258','web_outside_right','web_outside_right','*','2');
INSERT INTO `ms_oper_table` VALUES ('434','258','oper','cut_oper','*','10');
INSERT INTO `ms_oper_table` VALUES ('435','258','oper_right','cut_oper_right','*','11');
INSERT INTO `ms_oper_table` VALUES ('436','258','user','cut_user','id,group_id,login,name,phone,email,add_group_id','12');
INSERT INTO `ms_oper_table` VALUES ('437','258','user_group','cut_user_group','*','13');
INSERT INTO `ms_oper_table` VALUES ('438','258','key_value','cut_key_value','*','14');
INSERT INTO `ms_oper_table` VALUES ('439','258','files_key_value','cut_files_key_value','*','15');
INSERT INTO `ms_oper_table` VALUES ('440','259','web_outside','web_outside','*','440');
INSERT INTO `ms_oper_table` VALUES ('441','259','web_outside_right','web_outside_right','*','441');
INSERT INTO `ms_oper_table` VALUES ('442','261','web_outside','cut_web_outside','*','442');
INSERT INTO `ms_oper_table` VALUES ('443','261','web_outside_right','cut_web_outside_right','*','443');
INSERT INTO `ms_oper_table` VALUES ('444','210','provider','cut_provider','id,skey,group_id,name,serv_addr,serv_phone,pos','7');
INSERT INTO `ms_oper_table` VALUES ('453','210','oper','cut_oper','*','8');
INSERT INTO `ms_oper_table` VALUES ('454','210','oper_right','cut_oper_right','*','9');
INSERT INTO `ms_oper_table` VALUES ('455','210','user','cut_user','id,group_id,login,name,phone,email,add_group_id','10');
INSERT INTO `ms_oper_table` VALUES ('456','210','user_group','cut_user_group','*','11');
INSERT INTO `ms_oper_table` VALUES ('457','269','provider','cut_provider','id,skey,group_id,name,serv_addr,serv_phone,pos','2');
INSERT INTO `ms_oper_table` VALUES ('459','269','brand','cut_brand','id,skey,name,kind_key,params,seo_code,pos','3');
INSERT INTO `ms_oper_table` VALUES ('460','269','currency','cut_currency','*','4');
INSERT INTO `ms_oper_table` VALUES ('461','269','key_value','cut_key_value','*','5');
INSERT INTO `ms_oper_table` VALUES ('462','269','files_key_value','cut_files_key_value','*','6');
INSERT INTO `ms_oper_table` VALUES ('464','269','oper','cut_oper','*','7');
INSERT INTO `ms_oper_table` VALUES ('465','269','oper_right','cut_oper_right','*','8');
INSERT INTO `ms_oper_table` VALUES ('466','269','user','cut_user','id,group_id,login,name,phone,email,add_group_id','9');
INSERT INTO `ms_oper_table` VALUES ('467','269','user_group','cut_user_group','*','10');
INSERT INTO `ms_oper_table` VALUES ('470','14','files_advert_text','d_files_advert_text','*','470');
INSERT INTO `ms_oper_table` VALUES ('471','14','files_brand','d_files_brand','*','471');
INSERT INTO `ms_oper_table` VALUES ('472','14','files_field','d_files_field','*','472');
INSERT INTO `ms_oper_table` VALUES ('473','14','files_info','d_files_info','*','473');
INSERT INTO `ms_oper_table` VALUES ('474','14','files_info_value','d_files_info_value','*','474');
INSERT INTO `ms_oper_table` VALUES ('475','14','files_key_value','d_files_key_value','*','475');
INSERT INTO `ms_oper_table` VALUES ('476','14','files_order_option','d_files_order_option','*','476');
INSERT INTO `ms_oper_table` VALUES ('477','14','files_order_option_value','d_files_order_option_value','*','477');
INSERT INTO `ms_oper_table` VALUES ('478','14','files_store','d_files_store','*','478');
INSERT INTO `ms_oper_table` VALUES ('479','14','files_topic','d_files_topic','*','479');
INSERT INTO `ms_oper_table` VALUES ('480','258','web_inside','web_inside','*','3');
INSERT INTO `ms_oper_table` VALUES ('482','258','web_inside_right','web_inside_right','*','4');
INSERT INTO `ms_oper_table` VALUES ('483','259','web_inside','web_inside','*','483');
INSERT INTO `ms_oper_table` VALUES ('484','259','web_inside_right','web_inside_right','*','484');
INSERT INTO `ms_oper_table` VALUES ('485','204','web_inside','cut_web_inside','*','17');
INSERT INTO `ms_oper_table` VALUES ('486','204','web_inside_right','cut_web_inside_right','*','18');
INSERT INTO `ms_oper_table` VALUES ('487','167','web_inside','cut_web_inside','*','25');
INSERT INTO `ms_oper_table` VALUES ('488','167','web_inside_right','cut_web_inside_right','*','26');
INSERT INTO `ms_oper_table` VALUES ('489','194','web_inside','cut_web_inside','*','489');
INSERT INTO `ms_oper_table` VALUES ('490','194','web_inside_right','cut_web_inside_right','*','490');
INSERT INTO `ms_oper_table` VALUES ('491','210','web_inside','cut_web_inside','*','12');
INSERT INTO `ms_oper_table` VALUES ('492','210','web_inside_right','cut_web_inside_right','*','13');
INSERT INTO `ms_oper_table` VALUES ('493','269','web_inside','cut_web_inside','*','11');
INSERT INTO `ms_oper_table` VALUES ('494','269','web_inside_right','cut_web_inside_right','*','12');
INSERT INTO `ms_oper_table` VALUES ('495','23','self_key','self_key','*','4');
INSERT INTO `ms_oper_table` VALUES ('496','23','self_key_right','self_key_right','*','5');
INSERT INTO `ms_oper_table` VALUES ('497','23','self_key_value','self_key_value','*','6');
INSERT INTO `ms_oper_table` VALUES ('498','24','self_key','self_key','*','4');
INSERT INTO `ms_oper_table` VALUES ('499','24','self_key_value','self_key_value','*','5');
INSERT INTO `ms_oper_table` VALUES ('500','24','self_key_right','self_key_right','*','6');
INSERT INTO `ms_oper_table` VALUES ('501','23','oper','cut_oper','*','7');
INSERT INTO `ms_oper_table` VALUES ('502','23','oper_right','cut_oper_right','*','8');
INSERT INTO `ms_oper_table` VALUES ('503','23','user','cut_user','id,group_id,login,name,phone,email,add_group_id','9');
INSERT INTO `ms_oper_table` VALUES ('504','23','user_group','cut_user_group','*','10');
INSERT INTO `ms_oper_table` VALUES ('505','272','FUNC:GetSelfKey','cut_self_key','*','1');
INSERT INTO `ms_oper_table` VALUES ('506','272','self_key_right','cut_self_key_right','*','3');
INSERT INTO `ms_oper_table` VALUES ('507','272','FUNC:GetSelfKeyValue','cut_self_key_value','*','2');
INSERT INTO `ms_oper_table` VALUES ('508','272','oper','cut_oper','*','4');
INSERT INTO `ms_oper_table` VALUES ('509','272','oper_right','cut_oper_right','*','5');
INSERT INTO `ms_oper_table` VALUES ('510','272','user','cut_user','id,group_id,login,name,phone,email,add_group_id','6');
INSERT INTO `ms_oper_table` VALUES ('511','272','user_group','cut_user_group','*','7');
INSERT INTO `ms_oper_table` VALUES ('512','274','currency','cut_currency','*','1');
INSERT INTO `ms_oper_table` VALUES ('514','274','key_value','cut_key_value','*','2');
INSERT INTO `ms_oper_table` VALUES ('515','274','files_key_value','cut_files_key_value','*','3');
INSERT INTO `ms_oper_table` VALUES ('516','274','brand','cut_brand','id,skey,name,kind_key,params,seo_code,pos','4');
INSERT INTO `ms_oper_table` VALUES ('517','274','provider','cut_provider','id,skey,group_id,name,serv_addr,serv_phone,pos','6');
INSERT INTO `ms_oper_table` VALUES ('518','274','web_inside','cut_web_inside','*','7');
INSERT INTO `ms_oper_table` VALUES ('519','274','web_inside_right','cut_web_inside_right','*','8');
INSERT INTO `ms_oper_table` VALUES ('520','204','self_key_value','cut_self_key_value','*','19');
INSERT INTO `ms_oper_table` VALUES ('521','167','self_key_value','cut_self_key_value','*','27');
INSERT INTO `ms_oper_table` VALUES ('522','194','self_key_value','cut_self_key_value','*','522');
INSERT INTO `ms_oper_table` VALUES ('523','23','user_filter','user_filter','*','11');
INSERT INTO `ms_oper_table` VALUES ('524','24','user_filter','user_filter','*','7');
INSERT INTO `ms_oper_table` VALUES ('525','204','user_filter','cut_user_filter','*','20');
INSERT INTO `ms_oper_table` VALUES ('526','167','user_filter','cut_user_filter','*','28');
INSERT INTO `ms_oper_table` VALUES ('527','194','user_filter','cut_user_filter','*','527');
INSERT INTO `ms_oper_table` VALUES ('528','210','user_filter','cut_user_filter','*','14');
INSERT INTO `ms_oper_table` VALUES ('530','275','topic','','','530');
INSERT INTO `ms_oper_table` VALUES ('531','276','topic','','','531');
INSERT INTO `ms_oper_table` VALUES ('532','277','topic','','','532');
INSERT INTO `ms_oper_table` VALUES ('533','278','info','','','533');
INSERT INTO `ms_oper_table` VALUES ('535','279','info','','','535');
INSERT INTO `ms_oper_table` VALUES ('536','280','info','','','536');
INSERT INTO `ms_oper_table` VALUES ('537','282','key_value','cut_key_value','*','537');
INSERT INTO `ms_oper_table` VALUES ('538','282','files_key_value','cut_files_key_value','*','538');
INSERT INTO `ms_oper_table` VALUES ('539','282','oper','cut_oper','*','539');
INSERT INTO `ms_oper_table` VALUES ('540','282','oper_right','cut_oper_right','*','540');
INSERT INTO `ms_oper_table` VALUES ('541','282','user','cut_user','id,group_id,login,name,phone,email,add_group_id','541');
INSERT INTO `ms_oper_table` VALUES ('542','282','user_group','cut_user_group','*','542');
INSERT INTO `ms_oper_table` VALUES ('543','282','web_inside','cut_web_inside','*','543');
INSERT INTO `ms_oper_table` VALUES ('544','282','web_inside_right','cut_web_inside_right','*','544');
INSERT INTO `ms_oper_table` VALUES ('545','258','web_key','web_key','*','5');
INSERT INTO `ms_oper_table` VALUES ('546','258','web_key_value','web_key_value','*','6');
INSERT INTO `ms_oper_table` VALUES ('547','258','web_key_right','web_key_right','*','7');
INSERT INTO `ms_oper_table` VALUES ('548','258','files_web_key','files_web_key','*','8');
INSERT INTO `ms_oper_table` VALUES ('549','258','files_web_key_value','files_web_key_value','*','9');
INSERT INTO `ms_oper_table` VALUES ('550','259','web_key','web_key','*','550');
INSERT INTO `ms_oper_table` VALUES ('551','259','web_key_value','web_key_value','*','551');
INSERT INTO `ms_oper_table` VALUES ('552','259','web_key_right','web_key_right','*','552');
INSERT INTO `ms_oper_table` VALUES ('553','259','files_web_key','files_web_key','*','553');
INSERT INTO `ms_oper_table` VALUES ('554','259','files_web_key_value','files_web_key_value','*','554');
INSERT INTO `ms_oper_table` VALUES ('555','27','key_value','cut_key_value','*','6');
INSERT INTO `ms_oper_table` VALUES ('556','27','files_key_value','cut_files_key_value','*','7');
INSERT INTO `ms_oper_table` VALUES ('557','18','u_info_value','u_info_value','*','1');
INSERT INTO `ms_oper_table` VALUES ('559','60','FUNC:GetImportStoreInfoValue','imp_info_value','*','559');
INSERT INTO `ms_oper_table` VALUES ('560','295','FUNC:GetImportInfoValue','imp_info_value','*','560');
INSERT INTO `ms_oper_table` VALUES ('561','292','brand','','','561');
INSERT INTO `ms_oper_table` VALUES ('562','60','FUNC:GetImportStoreFilesInfoValue','imp_files_info_value','*','562');
INSERT INTO `ms_oper_table` VALUES ('563','295','FUNC:GetImportFilesInfoValue','imp_files_info_value','*','563');
INSERT INTO `ms_oper_table` VALUES ('564','14','files_web_key','d_files_web_key','*','564');
INSERT INTO `ms_oper_table` VALUES ('565','14','files_web_key_value','d_files_web_key_value','*','565');
INSERT INTO `ms_oper_table` VALUES ('572','228','info_right','','','572');
INSERT INTO `ms_oper_table` VALUES ('574','209','FUNC:GetImportStore','imp_store','*','574');
INSERT INTO `ms_oper_table` VALUES ('575','209','FUNC:GetImportFilesStore','imp_files_store','*','575');
INSERT INTO `ms_oper_table` VALUES ('576','209','FUNC:GetImportStoreSet','imp_store_set','*','576');
INSERT INTO `ms_oper_table` VALUES ('577','209','FUNC:GetImportTopicStore','imp_topic_store','*','577');
INSERT INTO `ms_oper_table` VALUES ('578','209','FUNC:GetImportStoreInfo','imp_store_info','*','578');
INSERT INTO `ms_oper_table` VALUES ('579','209','FUNC:GetImportStoreInfoValue','imp_info_value','*','579');
INSERT INTO `ms_oper_table` VALUES ('580','209','FUNC:GetImportStoreFilesInfoValue','imp_files_info_value','*','580');
INSERT INTO `ms_oper_table` VALUES ('581','177','FUNC:GetOrdersOrders','orders','*','581');
INSERT INTO `ms_oper_table` VALUES ('582','177','FUNC:GetOrdersVersion','orders_version','*','582');
INSERT INTO `ms_oper_table` VALUES ('583','177','FUNC:GetOrdersClientField','orders_client_field','*','583');
INSERT INTO `ms_oper_table` VALUES ('584','177','FUNC:GetOrdersStore','orders_store','*','584');
INSERT INTO `ms_oper_table` VALUES ('585','177','FUNC:GetOrdersOption','orders_option','*','585');
INSERT INTO `ms_oper_table` VALUES ('586','177','FUNC:GetOrdersStoreOption','orders_store_option','*','586');
INSERT INTO `ms_oper_table` VALUES ('587','106','FUNC:GetPartSelectStore','part_select_store','*','587');
INSERT INTO `ms_oper_table` VALUES ('588','106','FUNC:GetPartSelectTopicStore','part_select_topic_store','*','588');
INSERT INTO `ms_oper_table` VALUES ('589','51','info_value','','','589');
INSERT INTO `ms_oper_table` VALUES ('590','51','files_info_value','','','590');
INSERT INTO `ms_oper_table` VALUES ('591','216','param','cut_param','*','3');
INSERT INTO `ms_oper_table` VALUES ('592','216','currency','cut_currency','*','4');
INSERT INTO `ms_oper_table` VALUES ('593','27','provider_group','provider_group','*','1');
INSERT INTO `ms_oper_table` VALUES ('594','27','provider_key','cut_provider_key','*','4');
INSERT INTO `ms_oper_table` VALUES ('595','27','provider_key_set','provider_key_set','*','3');
INSERT INTO `ms_oper_table` VALUES ('596','28','provider_group','provider_group','*','596');
INSERT INTO `ms_oper_table` VALUES ('598','28','provider_key_set','provider_key_set','*','598');
INSERT INTO `ms_oper_table` VALUES ('599','30','provider','cut_provider','id,skey,group_id,name,serv_addr,serv_phone,pos','599');
INSERT INTO `ms_oper_table` VALUES ('600','23','topic_key','topic_key','*','12');
INSERT INTO `ms_oper_table` VALUES ('601','23','provider_key','provider_key','*','14');
INSERT INTO `ms_oper_table` VALUES ('602','23','brand_key','brand_key','*','16');
INSERT INTO `ms_oper_table` VALUES ('603','24','brand_key','brand_key','*','12');
INSERT INTO `ms_oper_table` VALUES ('604','24','provider_key','provider_key','*','10');
INSERT INTO `ms_oper_table` VALUES ('605','24','topic_key','topic_key','*','8');
INSERT INTO `ms_oper_table` VALUES ('606','233','brand_key_set','brand_key_set','*','3');
INSERT INTO `ms_oper_table` VALUES ('607','234','brand_key_set','brand_key_set','*','607');
INSERT INTO `ms_oper_table` VALUES ('608','233','brand_key','cut_brand_key','*','4');
INSERT INTO `ms_oper_table` VALUES ('609','33','topic_key_set','topic_key_set','*','5');
INSERT INTO `ms_oper_table` VALUES ('611','34','topic_key_set','topic_key_set','*','611');
INSERT INTO `ms_oper_table` VALUES ('612','33','topic_key','cut_topic_key','*','6');
INSERT INTO `ms_oper_table` VALUES ('613','30','provider_group','cut_provider_group','*','613');
INSERT INTO `ms_oper_table` VALUES ('614','167','provider_group','cut_provider_group','*','13');
INSERT INTO `ms_oper_table` VALUES ('615','204','provider_group','cut_provider_group','*','2');
INSERT INTO `ms_oper_table` VALUES ('616','210','provider_group','cut_provider_group','*','6');
INSERT INTO `ms_oper_table` VALUES ('617','269','provider_group','cut_provider_group','*','1');
INSERT INTO `ms_oper_table` VALUES ('618','216','provider_group','cut_provider_group','*','1');
INSERT INTO `ms_oper_table` VALUES ('619','274','provider_group','cut_provider_group','*','5');
INSERT INTO `ms_oper_table` VALUES ('620','23','topic_key_value','topic_key_value','*','13');
INSERT INTO `ms_oper_table` VALUES ('622','24','topic_key_value','topic_key_value','*','9');
INSERT INTO `ms_oper_table` VALUES ('623','23','provider_key_value','provider_key_value','*','15');
INSERT INTO `ms_oper_table` VALUES ('624','24','provider_key_value','provider_key_value','*','11');
INSERT INTO `ms_oper_table` VALUES ('625','23','brand_key_value','brand_key_value','*','625');
INSERT INTO `ms_oper_table` VALUES ('626','24','brand_key_value','brand_key_value','*','626');
INSERT INTO `ms_oper_table` VALUES ('627','27','provider_key_value','cut_provider_key_value','*','5');
INSERT INTO `ms_oper_table` VALUES ('628','233','brand_key_value','cut_brand_key_value','*','5');
INSERT INTO `ms_oper_table` VALUES ('629','33','topic_key_value','cut_topic_key_value','*','7');
INSERT INTO `ms_oper_table` VALUES ('630','189','param_value','param_value','*','2');
INSERT INTO `ms_oper_table` VALUES ('631','190','param_value','param_value','*','631');
INSERT INTO `ms_oper_table` VALUES ('632','204','param_value','cut_param_value','*','8');
INSERT INTO `ms_oper_table` VALUES ('633','189','currency','cut_currency','*','3');
INSERT INTO `ms_oper_table` VALUES ('634','297','info_value','','','634');
INSERT INTO `ms_oper_table` VALUES ('635','216','key_value','cut_key_value','*','635');
INSERT INTO `ms_oper_table` VALUES ('636','216','files_key_value','cut_files_key_value','*','636');
INSERT INTO `ms_oper_table` VALUES ('637','297','store_info','','','637');
INSERT INTO `ms_oper_table` VALUES ('638','300','info_right','info_right','*','638');
INSERT INTO `ms_oper_table` VALUES ('639','301','info_right','info_right','*','639');
INSERT INTO `ms_oper_table` VALUES ('640','300','info','cut_info','*','640');
INSERT INTO `ms_oper_table` VALUES ('641','300','key_value','cut_key_value','*','641');
INSERT INTO `ms_oper_table` VALUES ('642','300','files_key_value','cut_files_key_value','*','642');
INSERT INTO `ms_oper_table` VALUES ('643','300','oper','cut_oper','*','643');
INSERT INTO `ms_oper_table` VALUES ('644','300','oper_right','cut_oper_right','*','644');
INSERT INTO `ms_oper_table` VALUES ('645','300','user','cut_user','id,group_id,login,name,phone,email,add_group_id','645');
INSERT INTO `ms_oper_table` VALUES ('646','300','user_group','cut_user_group','*','646');
INSERT INTO `ms_oper_table` VALUES ('647','20','info_right','info_right','*','3');
INSERT INTO `ms_oper_table` VALUES ('648','21','info_right','info_right','*','3');
INSERT INTO `ms_oper_table` VALUES ('649','20','oper','cut_oper','*','9');
INSERT INTO `ms_oper_table` VALUES ('650','20','oper_right','cut_oper_right','*','10');
INSERT INTO `ms_oper_table` VALUES ('651','20','user','cut_user','id,group_id,login,name,phone,email,add_group_id','11');
INSERT INTO `ms_oper_table` VALUES ('652','20','user_group','cut_user_group','*','12');
INSERT INTO `ms_oper_table` VALUES ('653','23','info_key','info_key','*','653');
INSERT INTO `ms_oper_table` VALUES ('654','23','info_key_value','info_key_value','*','654');
INSERT INTO `ms_oper_table` VALUES ('655','24','info_key','info_key','*','655');
INSERT INTO `ms_oper_table` VALUES ('656','24','info_key_value','info_key_value','*','656');
INSERT INTO `ms_oper_table` VALUES ('657','20','info_key_set','info_key_set','*','4');
INSERT INTO `ms_oper_table` VALUES ('658','20','info_key','cut_info_key','*','13');
INSERT INTO `ms_oper_table` VALUES ('659','20','info_key_value','cut_info_key_value','*','14');
INSERT INTO `ms_oper_table` VALUES ('660','21','info_key_set','info_key_set','*','4');
INSERT INTO `ms_oper_table` VALUES ('661','303','info_key_set','info_key_set','*','1');
INSERT INTO `ms_oper_table` VALUES ('662','303','info_key','cut_info_key','*','3');
INSERT INTO `ms_oper_table` VALUES ('663','303','info_key_value','cut_info_key_value','*','4');
INSERT INTO `ms_oper_table` VALUES ('664','304','info_key_set','info_key_set','*','664');
INSERT INTO `ms_oper_table` VALUES ('665','303','key_value','cut_key_value','*','5');
INSERT INTO `ms_oper_table` VALUES ('666','303','files_key_value','cut_files_key_value','*','6');
INSERT INTO `ms_oper_table` VALUES ('667','308','topic_right','topic_right','*','667');
INSERT INTO `ms_oper_table` VALUES ('668','309','topic_right','topic_right','*','668');
INSERT INTO `ms_oper_table` VALUES ('669','308','topic','cut_topic','*','669');
INSERT INTO `ms_oper_table` VALUES ('670','308','key_value','cut_key_value','*','670');
INSERT INTO `ms_oper_table` VALUES ('671','308','files_key_value','cut_files_key_value','*','671');
INSERT INTO `ms_oper_table` VALUES ('672','308','oper','cut_oper','*','672');
INSERT INTO `ms_oper_table` VALUES ('673','308','oper_right','cut_oper_right','*','673');
INSERT INTO `ms_oper_table` VALUES ('674','308','user','cut_user','id,group_id,login,name,phone,email,add_group_id','674');
INSERT INTO `ms_oper_table` VALUES ('675','308','user_group','cut_user_group','*','675');
INSERT INTO `ms_oper_table` VALUES ('676','303','info','cut_info','*','2');
INSERT INTO `ms_oper_table` VALUES ('677','310','topic_key_set','topic_key_set','*','677');
INSERT INTO `ms_oper_table` VALUES ('678','311','topic_key_set','topic_key_set','*','678');
INSERT INTO `ms_oper_table` VALUES ('681','310','topic','cut_topic','*','681');
INSERT INTO `ms_oper_table` VALUES ('682','310','topic_key','cut_topic_key','*','682');
INSERT INTO `ms_oper_table` VALUES ('683','310','topic_key_value','cut_topic_key_value','*','683');
INSERT INTO `ms_oper_table` VALUES ('684','310','key_value','cut_key_value','*','684');
INSERT INTO `ms_oper_table` VALUES ('685','310','files_key_value','cut_files_key_value','*','685');
INSERT INTO `ms_oper_table` VALUES ('693','162','order_option_block','order_option_block','*','11');
INSERT INTO `ms_oper_table` VALUES ('694','162','order_option_limit','order_option_limit','*','12');
INSERT INTO `ms_oper_table` VALUES ('695','162','order_option_limit_right','order_option_limit_right','*','13');
INSERT INTO `ms_oper_table` VALUES ('696','163','order_option_block','order_option_block','*','11');
INSERT INTO `ms_oper_table` VALUES ('697','163','order_option_limit','order_option_limit','*','12');
INSERT INTO `ms_oper_table` VALUES ('698','163','order_option_limit_right','order_option_limit_right','*','13');
INSERT INTO `ms_oper_table` VALUES ('699','162','order_store_option_right','order_store_option_right','*','3');
INSERT INTO `ms_oper_table` VALUES ('700','162','order_store_option_block','order_store_option_block','*','4');
INSERT INTO `ms_oper_table` VALUES ('701','163','order_store_option_block','order_store_option_block','*','4');
INSERT INTO `ms_oper_table` VALUES ('702','163','order_store_option_right','order_store_option_right','*','3');
INSERT INTO `ms_oper_table` VALUES ('703','167','order_option_block','cut_order_option_block','*','5');
INSERT INTO `ms_oper_table` VALUES ('704','167','order_option_limit','cut_order_option_limit','*','6');
INSERT INTO `ms_oper_table` VALUES ('705','167','order_option_limit_right','cut_order_option_limit_right','*','7');
INSERT INTO `ms_oper_table` VALUES ('706','167','order_store_option_right','cut_order_store_option_right','*','8');
INSERT INTO `ms_oper_table` VALUES ('707','167','order_store_option_block','cut_order_store_option_block','*','9');
INSERT INTO `ms_oper_table` VALUES ('708','316','topic_alt','topic_alt','*','1');
INSERT INTO `ms_oper_table` VALUES ('709','317','topic_alt','topic_alt','*','709');
INSERT INTO `ms_oper_table` VALUES ('710','316','key_value','cut_key_value','*','3');
INSERT INTO `ms_oper_table` VALUES ('711','316','files_key_value','cut_files_key_value','*','4');
INSERT INTO `ms_oper_table` VALUES ('712','316','topic','cut_topic','*','2');
INSERT INTO `ms_oper_table` VALUES ('716','322','lang','lang','*','2');
INSERT INTO `ms_oper_table` VALUES ('717','322','trans','trans','*','1');
INSERT INTO `ms_oper_table` VALUES ('718','322','files_lang','files_lang','*','3');
INSERT INTO `ms_oper_table` VALUES ('719','323','trans','trans','*','719');
INSERT INTO `ms_oper_table` VALUES ('720','323','lang','lang','*','720');
INSERT INTO `ms_oper_table` VALUES ('721','323','files_lang','files_lang','*','721');
INSERT INTO `ms_oper_table` VALUES ('722','322','key_value','cut_key_value','*','722');
INSERT INTO `ms_oper_table` VALUES ('723','322','files_key_value','cut_files_key_value','*','723');
INSERT INTO `ms_oper_table` VALUES ('724','326','lang','cut_lang','*','724');
INSERT INTO `ms_oper_table` VALUES ('725','326','trans','cut_trans','*','725');
INSERT INTO `ms_oper_table` VALUES ('726','326','key_value','cut_key_value','*','726');
INSERT INTO `ms_oper_table` VALUES ('728','326','files_key_value','cut_files_key_value','*','728');
INSERT INTO `ms_oper_table` VALUES ('729','327','FUNC:GetExtendTransOrigin','part_trans_origin','*','729');
INSERT INTO `ms_oper_table` VALUES ('730','327','FUNC:GetExtendTransLang','part_trans_lang','*','730');
INSERT INTO `ms_oper_table` VALUES ('731','329','FUNC:GetPartTransOrigin','part_trans_origin','*','731');
INSERT INTO `ms_oper_table` VALUES ('732','329','FUNC:GetPartTransLang','part_trans_lang','*','732');
INSERT INTO `ms_oper_table` VALUES ('733','326','oper','cut_oper','*','733');
INSERT INTO `ms_oper_table` VALUES ('734','326','oper_right','cut_oper_right','*','734');
INSERT INTO `ms_oper_table` VALUES ('735','326','user','cut_user','id,group_id,login,name,phone,email,add_group_id','735');
INSERT INTO `ms_oper_table` VALUES ('736','326','user_group','cut_user_group','*','736');
INSERT INTO `ms_oper_table` VALUES ('737','326','web_inside','cut_web_inside','*','737');
INSERT INTO `ms_oper_table` VALUES ('738','326','web_inside_right','cut_web_inside_right','*','738');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_order_option`
--

DROP TABLE IF EXISTS `ms_order_option`;

CREATE TABLE `ms_order_option` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `descr` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `kind_key` char(100) NOT NULL DEFAULT '',
  `fixed_set` tinyint unsigned NOT NULL DEFAULT '0',
  `needs_calc` tinyint unsigned NOT NULL DEFAULT '0',
  `custom_sum` tinyint unsigned NOT NULL DEFAULT '0',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_order_option`
--

LOCK TABLES `ms_order_option` WRITE;
INSERT INTO `ms_order_option` VALUES ('2','','Доставка','','kDefault','1','0','0','2');
INSERT INTO `ms_order_option` VALUES ('1','','Статус','','kDefault','1','0','0','1');
INSERT INTO `ms_order_option` VALUES ('3','','Оплата','','kDefault','1','0','0','3');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_order_option_block`
--

DROP TABLE IF EXISTS `ms_order_option_block`;

CREATE TABLE `ms_order_option_block` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `value1_id` int unsigned DEFAULT NULL,
  `value2_id` int unsigned DEFAULT NULL,
  `message` text NOT NULL DEFAULT (_utf8mb3''),
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_order_option_block`
--

LOCK TABLES `ms_order_option_block` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_order_option_limit`
--

DROP TABLE IF EXISTS `ms_order_option_limit`;

CREATE TABLE `ms_order_option_limit` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `option_id` int unsigned DEFAULT NULL,
  `was_value_id` int unsigned DEFAULT NULL,
  `set_value_id` int unsigned DEFAULT NULL,
  `message` text NOT NULL DEFAULT (_utf8mb3''),
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_order_option_limit`
--

LOCK TABLES `ms_order_option_limit` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_order_option_limit_right`
--

DROP TABLE IF EXISTS `ms_order_option_limit_right`;

CREATE TABLE `ms_order_option_limit_right` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `limit_id` int unsigned DEFAULT NULL,
  `user_id` int unsigned DEFAULT NULL,
  `group_id` int unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `limit_id` (`limit_id`),
  KEY `user_id` (`user_id`),
  KEY `group_id` (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_order_option_limit_right`
--

LOCK TABLES `ms_order_option_limit_right` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_order_option_right`
--

DROP TABLE IF EXISTS `ms_order_option_right`;

CREATE TABLE `ms_order_option_right` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `option_id` int unsigned DEFAULT NULL,
  `user_id` int unsigned DEFAULT NULL,
  `group_id` int unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `option_id` (`option_id`),
  KEY `user_id` (`user_id`),
  KEY `group_id` (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_order_option_right`
--

LOCK TABLES `ms_order_option_right` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_order_option_value`
--

DROP TABLE IF EXISTS `ms_order_option_value`;

CREATE TABLE `ms_order_option_value` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `option_id` int unsigned DEFAULT NULL,
  `name` char(255) NOT NULL DEFAULT '',
  `descr` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `kind_key` char(100) NOT NULL DEFAULT '',
  `modify_sum` decimal(10,4) NOT NULL DEFAULT '0.0000',
  `sum_curr_id` int unsigned DEFAULT NULL,
  `oper_num` tinyint unsigned NOT NULL DEFAULT '0',
  `source_num` tinyint unsigned NOT NULL DEFAULT '0',
  `message` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `color_set` char(32) NOT NULL DEFAULT '',
  `use_default` tinyint unsigned NOT NULL DEFAULT '0',
  `after_create` tinyint unsigned NOT NULL DEFAULT '0',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `option_id` (`option_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_order_option_value`
--

LOCK TABLES `ms_order_option_value` WRITE;
INSERT INTO `ms_order_option_value` VALUES ('7','','2','Транспортная компания','','kDefault','0.0000',NULL,'0','0','','','0','0','7');
INSERT INTO `ms_order_option_value` VALUES ('6','','2','Курьер','','kDefault','0.0000',NULL,'0','0','','','0','0','6');
INSERT INTO `ms_order_option_value` VALUES ('5','','1','Аннулирован','','kDefault','0.0000',NULL,'0','0','','','0','0','5');
INSERT INTO `ms_order_option_value` VALUES ('4','','1','Выполнен','','kDefault','0.0000',NULL,'0','0','','','0','0','4');
INSERT INTO `ms_order_option_value` VALUES ('3','','1','Доставляется','','kDefault','0.0000',NULL,'0','0','','','0','0','3');
INSERT INTO `ms_order_option_value` VALUES ('2','','1','Проконсультировать','','kDefault','0.0000',NULL,'0','0','','','0','0','2');
INSERT INTO `ms_order_option_value` VALUES ('1','','1','Новый заказ','','kDefault','0.0000',NULL,'0','0','','','0','0','1');
INSERT INTO `ms_order_option_value` VALUES ('8','','3','Наличными','','kDefault','0.0000',NULL,'0','0','','','0','0','8');
INSERT INTO `ms_order_option_value` VALUES ('9','','3','По счету','','kDefault','0.0000',NULL,'0','0','','','0','0','9');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_order_right`
--

DROP TABLE IF EXISTS `ms_order_right`;

CREATE TABLE `ms_order_right` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `value_id` int unsigned DEFAULT NULL,
  `user_id` int unsigned DEFAULT NULL,
  `group_id` int unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `value_id` (`value_id`),
  KEY `user_id` (`user_id`),
  KEY `group_id` (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_order_right`
--

LOCK TABLES `ms_order_right` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_order_store_option`
--

DROP TABLE IF EXISTS `ms_order_store_option`;

CREATE TABLE `ms_order_store_option` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `kind_key` char(100) NOT NULL DEFAULT '',
  `fixed_set` tinyint unsigned NOT NULL DEFAULT '0',
  `needs_calc` tinyint unsigned NOT NULL DEFAULT '0',
  `custom_sum` tinyint unsigned NOT NULL DEFAULT '0',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_order_store_option`
--

LOCK TABLES `ms_order_store_option` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_order_store_option_block`
--

DROP TABLE IF EXISTS `ms_order_store_option_block`;

CREATE TABLE `ms_order_store_option_block` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `value1_id` int unsigned DEFAULT NULL,
  `value2_id` int unsigned DEFAULT NULL,
  `message` text NOT NULL DEFAULT (_utf8mb3''),
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_order_store_option_block`
--

LOCK TABLES `ms_order_store_option_block` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_order_store_option_right`
--

DROP TABLE IF EXISTS `ms_order_store_option_right`;

CREATE TABLE `ms_order_store_option_right` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `option_id` int unsigned DEFAULT NULL,
  `user_id` int unsigned DEFAULT NULL,
  `group_id` int unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `option_id` (`option_id`),
  KEY `user_id` (`user_id`),
  KEY `group_id` (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_order_store_option_right`
--

LOCK TABLES `ms_order_store_option_right` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_order_store_option_value`
--

DROP TABLE IF EXISTS `ms_order_store_option_value`;

CREATE TABLE `ms_order_store_option_value` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `option_id` int unsigned DEFAULT NULL,
  `name` char(255) NOT NULL DEFAULT '',
  `modify_sum` decimal(10,4) NOT NULL DEFAULT '0.0000',
  `sum_curr_id` int unsigned DEFAULT NULL,
  `use_default` tinyint unsigned NOT NULL DEFAULT '0',
  `after_create` tinyint unsigned NOT NULL DEFAULT '0',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `option_id` (`option_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_order_store_option_value`
--

LOCK TABLES `ms_order_store_option_value` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_orders`
--

DROP TABLE IF EXISTS `ms_orders`;

CREATE TABLE `ms_orders` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `code` char(100) NOT NULL DEFAULT '',
  `version_id` int unsigned DEFAULT NULL,
  `date_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  PRIMARY KEY (`id`),
  KEY `version_id` (`version_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_orders`
--

LOCK TABLES `ms_orders` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_orders_client_field`
--

DROP TABLE IF EXISTS `ms_orders_client_field`;

CREATE TABLE `ms_orders_client_field` (
  `id` int unsigned NOT NULL AUTO_INCREMENT,
  `version_id` int unsigned DEFAULT NULL,
  `field_id` int unsigned DEFAULT NULL,
  `field_skey` char(32) NOT NULL DEFAULT '',
  `field_name` char(255) NOT NULL DEFAULT '',
  `field_tindex` int unsigned NOT NULL DEFAULT '0',
  `field_tlevel` int unsigned NOT NULL DEFAULT '0',
  `field_absindex` int unsigned NOT NULL DEFAULT '0',
  `field_folder` tinyint unsigned NOT NULL DEFAULT '0',
  `field_kind_key` char(100) NOT NULL DEFAULT '',
  `field_spec_key` char(100) NOT NULL DEFAULT '',
  `value_id` int unsigned DEFAULT NULL,
  `value_skey` char(32) NOT NULL DEFAULT '',
  `value_code` char(255) NOT NULL DEFAULT '',
  `value_kind_key` char(100) NOT NULL DEFAULT '',
  `value_txt` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  PRIMARY KEY (`id`),
  KEY `version_id` (`version_id`)
) ENGINE=MyISAM AUTO_INCREMENT=19 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_orders_client_field`
--

LOCK TABLES `ms_orders_client_field` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_orders_option`
--

DROP TABLE IF EXISTS `ms_orders_option`;

CREATE TABLE `ms_orders_option` (
  `id` int unsigned NOT NULL AUTO_INCREMENT,
  `version_id` int unsigned DEFAULT NULL,
  `option_id` int unsigned DEFAULT NULL,
  `option_skey` char(32) NOT NULL DEFAULT '',
  `option_name` char(255) NOT NULL DEFAULT '',
  `option_kind_key` char(100) NOT NULL DEFAULT '',
  `option_pos` int unsigned NOT NULL DEFAULT '0',
  `value_id` int unsigned DEFAULT NULL,
  `value_skey` char(32) NOT NULL DEFAULT '',
  `value_name` char(255) NOT NULL DEFAULT '',
  `value_kind_key` char(100) NOT NULL DEFAULT '',
  `value_modify_sum` decimal(10,4) NOT NULL DEFAULT '0.0000',
  `value_oper_num` tinyint unsigned NOT NULL DEFAULT '0',
  `value_source_num` tinyint unsigned NOT NULL DEFAULT '0',
  `notice` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  PRIMARY KEY (`id`),
  KEY `version_id` (`version_id`),
  KEY `option_value` (`option_id`,`value_id`)
) ENGINE=MyISAM AUTO_INCREMENT=10 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_orders_option`
--

LOCK TABLES `ms_orders_option` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_orders_store`
--

DROP TABLE IF EXISTS `ms_orders_store`;

CREATE TABLE `ms_orders_store` (
  `id` int unsigned NOT NULL AUTO_INCREMENT,
  `version_id` int unsigned DEFAULT NULL,
  `store_id` int unsigned DEFAULT NULL,
  `store_provider_id` int unsigned DEFAULT NULL,
  `store_brand_id` int unsigned DEFAULT NULL,
  `store_pprice` decimal(10,2) NOT NULL DEFAULT '0.00',
  `store_rprice` decimal(10,2) NOT NULL DEFAULT '0.00',
  `store_price` decimal(10,2) NOT NULL DEFAULT '0.00',
  `store_price2` decimal(10,2) NOT NULL DEFAULT '0.00',
  `store_price3` decimal(10,2) NOT NULL DEFAULT '0.00',
  `store_how` int NOT NULL DEFAULT '0',
  `store_code_shop` char(255) NOT NULL DEFAULT '',
  `store_code_prov` char(255) NOT NULL DEFAULT '',
  `store_code_made` char(255) NOT NULL DEFAULT '',
  `store_meas` char(32) NOT NULL DEFAULT '',
  `store_name` text NOT NULL DEFAULT (_utf8mb3''),
  `store_kind_key` char(100) NOT NULL DEFAULT '',
  `store_status_key` char(100) NOT NULL DEFAULT '',
  `store_state_key` char(100) NOT NULL DEFAULT '',
  `store_min_order` int NOT NULL DEFAULT '0',
  `store_step_order` int NOT NULL DEFAULT '0',
  `recalc` tinyint unsigned NOT NULL DEFAULT '0',
  `out_price` decimal(10,2) NOT NULL DEFAULT '0.00',
  `amount` int NOT NULL DEFAULT '0',
  `notice` char(255) NOT NULL DEFAULT '',
  `auto_notice` char(255) NOT NULL DEFAULT '',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `version_id` (`version_id`)
) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_orders_store`
--

LOCK TABLES `ms_orders_store` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_orders_store_option`
--

DROP TABLE IF EXISTS `ms_orders_store_option`;

CREATE TABLE `ms_orders_store_option` (
  `id` int unsigned NOT NULL AUTO_INCREMENT,
  `version_id` int unsigned DEFAULT NULL,
  `order_store_id` int unsigned DEFAULT NULL,
  `option_id` int unsigned DEFAULT NULL,
  `option_skey` char(32) NOT NULL DEFAULT '',
  `option_name` char(255) NOT NULL DEFAULT '',
  `option_kind_key` char(100) NOT NULL DEFAULT '',
  `option_pos` int unsigned NOT NULL DEFAULT '0',
  `value_id` int unsigned DEFAULT NULL,
  `value_skey` char(32) NOT NULL DEFAULT '',
  `value_name` char(255) NOT NULL DEFAULT '',
  `value_modify_sum` decimal(10,4) NOT NULL DEFAULT '0.0000',
  PRIMARY KEY (`id`),
  KEY `version_id` (`version_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_orders_store_option`
--

LOCK TABLES `ms_orders_store_option` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_orders_version`
--

DROP TABLE IF EXISTS `ms_orders_version`;

CREATE TABLE `ms_orders_version` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `order_id` int unsigned DEFAULT NULL,
  `user_id` int unsigned DEFAULT NULL,
  `client_id` int unsigned DEFAULT NULL,
  `date_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `total_sum` decimal(10,2) NOT NULL DEFAULT '0.00',
  PRIMARY KEY (`id`),
  KEY `order_id` (`order_id`),
  KEY `user_id` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_orders_version`
--

LOCK TABLES `ms_orders_version` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_param`
--

DROP TABLE IF EXISTS `ms_param`;

CREATE TABLE `ms_param` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `kind_key` char(100) NOT NULL DEFAULT '',
  `fixed_set` tinyint unsigned NOT NULL DEFAULT '0',
  `custom_sum` tinyint unsigned NOT NULL DEFAULT '0',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_param`
--

LOCK TABLES `ms_param` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_param_value`
--

DROP TABLE IF EXISTS `ms_param_value`;

CREATE TABLE `ms_param_value` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `param_id` int unsigned DEFAULT NULL,
  `name` char(255) NOT NULL DEFAULT '',
  `set_sum` decimal(10,2) NOT NULL DEFAULT '0.00',
  `sum_curr_id` int unsigned DEFAULT NULL,
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `param_id` (`param_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_param_value`
--

LOCK TABLES `ms_param_value` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_provider`
--

DROP TABLE IF EXISTS `ms_provider`;

CREATE TABLE `ms_provider` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `group_id` int unsigned DEFAULT NULL,
  `name` char(255) NOT NULL DEFAULT '',
  `kind_key` char(100) NOT NULL DEFAULT '',
  `state_key` char(100) NOT NULL DEFAULT '',
  `params` char(255) NOT NULL DEFAULT '',
  `manager` char(255) NOT NULL DEFAULT '',
  `phones` char(255) NOT NULL DEFAULT '',
  `emails` char(255) NOT NULL DEFAULT '',
  `store` char(255) NOT NULL DEFAULT '',
  `serv_addr` char(255) NOT NULL DEFAULT '',
  `serv_phone` char(255) NOT NULL DEFAULT '',
  `notice` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_provider`
--

LOCK TABLES `ms_provider` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_provider_group`
--

DROP TABLE IF EXISTS `ms_provider_group`;

CREATE TABLE `ms_provider_group` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `name` char(100) NOT NULL DEFAULT '',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_provider_group`
--

LOCK TABLES `ms_provider_group` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_provider_key`
--

DROP TABLE IF EXISTS `ms_provider_key`;

CREATE TABLE `ms_provider_key` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `tindex` int unsigned NOT NULL DEFAULT '0',
  `tlevel` int unsigned NOT NULL DEFAULT '0',
  `absindex` int unsigned NOT NULL DEFAULT '0',
  `folder` tinyint unsigned NOT NULL DEFAULT '0',
  `descr` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `mask_edit` char(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_provider_key`
--

LOCK TABLES `ms_provider_key` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_provider_key_set`
--

DROP TABLE IF EXISTS `ms_provider_key_set`;

CREATE TABLE `ms_provider_key_set` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `provider_id` int unsigned DEFAULT NULL,
  `key_id` int unsigned DEFAULT NULL,
  `value_id` int unsigned DEFAULT NULL,
  `value_txt` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  PRIMARY KEY (`id`),
  KEY `provider_id` (`provider_id`),
  KEY `key_id` (`key_id`),
  KEY `value_id` (`value_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_provider_key_set`
--

LOCK TABLES `ms_provider_key_set` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_provider_key_value`
--

DROP TABLE IF EXISTS `ms_provider_key_value`;

CREATE TABLE `ms_provider_key_value` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `key_id` int unsigned DEFAULT NULL,
  `name` char(255) NOT NULL DEFAULT '',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `key_id` (`key_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_provider_key_value`
--

LOCK TABLES `ms_provider_key_value` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_report`
--

DROP TABLE IF EXISTS `ms_report`;

CREATE TABLE `ms_report` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `name` char(255) NOT NULL DEFAULT '',
  `tindex` int unsigned NOT NULL DEFAULT '0',
  `tlevel` int unsigned NOT NULL DEFAULT '0',
  `absindex` int unsigned NOT NULL DEFAULT '0',
  `folder` tinyint unsigned NOT NULL DEFAULT '0',
  `report_file` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_report`
--

LOCK TABLES `ms_report` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_report_right`
--

DROP TABLE IF EXISTS `ms_report_right`;

CREATE TABLE `ms_report_right` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `report_id` int unsigned DEFAULT NULL,
  `user_id` int unsigned DEFAULT NULL,
  `group_id` int unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `report_id` (`report_id`),
  KEY `user_id` (`user_id`),
  KEY `group_id` (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_report_right`
--

LOCK TABLES `ms_report_right` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_self_key`
--

DROP TABLE IF EXISTS `ms_self_key`;

CREATE TABLE `ms_self_key` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `name` char(255) NOT NULL DEFAULT '',
  `tindex` int unsigned NOT NULL DEFAULT '0',
  `tlevel` int unsigned NOT NULL DEFAULT '0',
  `absindex` int unsigned NOT NULL DEFAULT '0',
  `folder` tinyint unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_self_key`
--

LOCK TABLES `ms_self_key` WRITE;
INSERT INTO `ms_self_key` VALUES ('2','Переводчик','0','0','1','0');
INSERT INTO `ms_self_key` VALUES ('1','Константы','0','0','0','0');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_self_key_right`
--

DROP TABLE IF EXISTS `ms_self_key_right`;

CREATE TABLE `ms_self_key_right` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `key_id` int unsigned DEFAULT NULL,
  `user_id` int unsigned DEFAULT NULL,
  `group_id` int unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `key_id` (`key_id`),
  KEY `user_id` (`user_id`),
  KEY `group_id` (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_self_key_right`
--

LOCK TABLES `ms_self_key_right` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_self_key_value`
--

DROP TABLE IF EXISTS `ms_self_key_value`;

CREATE TABLE `ms_self_key_value` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `key_id` int unsigned DEFAULT NULL,
  `code` char(100) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `descr` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `mask_edit` char(255) NOT NULL DEFAULT '',
  `value_txt` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `key_id` (`key_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_self_key_value`
--

LOCK TABLES `ms_self_key_value` WRITE;
INSERT INTO `ms_self_key_value` VALUES ('2','1','MELBIS_SHOP_DOMAIN','Домен сайта','','','shop.melbis.com','2');
INSERT INTO `ms_self_key_value` VALUES ('3','1','MELBIS_SHOP_EMAIL','Электронная почта','','','support@shop.melbis.com','3');
INSERT INTO `ms_self_key_value` VALUES ('4','2','MELBIS_DEEPL_API','Ключ DeepL','','','','4');
INSERT INTO `ms_self_key_value` VALUES ('5','2','MELBIS_GOOGLE_API','Ключ Google Translate','','','','5');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_store`
--

DROP TABLE IF EXISTS `ms_store`;

CREATE TABLE `ms_store` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `provider_id` int unsigned DEFAULT NULL,
  `brand_id` int unsigned DEFAULT NULL,
  `code_shop` char(255) NOT NULL DEFAULT '',
  `code_prov` char(255) NOT NULL DEFAULT '',
  `code_made` char(255) NOT NULL DEFAULT '',
  `meas` char(32) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `intro` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `descr` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `review` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `no_visible` tinyint unsigned NOT NULL DEFAULT '0',
  `status_key` char(100) NOT NULL DEFAULT '',
  `kind_key` char(100) NOT NULL DEFAULT '',
  `state_key` char(100) NOT NULL DEFAULT '',
  `clann` int unsigned NOT NULL DEFAULT '0',
  `clann_title` char(255) NOT NULL DEFAULT '',
  `clann_descr` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `clann_root` tinyint unsigned NOT NULL DEFAULT '0',
  `relate_id` int unsigned NOT NULL DEFAULT '0',
  `rating` tinyint NOT NULL DEFAULT '0',
  `disc_group_id` int unsigned DEFAULT NULL,
  `how` int NOT NULL DEFAULT '0',
  `pprice` decimal(10,2) NOT NULL DEFAULT '0.00',
  `pprice_curr_id` int unsigned DEFAULT NULL,
  `rprice` decimal(10,2) NOT NULL DEFAULT '0.00',
  `rprice_curr_id` int unsigned DEFAULT NULL,
  `price` decimal(10,2) NOT NULL DEFAULT '0.00',
  `price_curr_id` int unsigned DEFAULT NULL,
  `price2` decimal(10,2) NOT NULL DEFAULT '0.00',
  `price2_curr_id` int unsigned DEFAULT NULL,
  `price3` decimal(10,2) NOT NULL DEFAULT '0.00',
  `price3_curr_id` int unsigned DEFAULT NULL,
  `relate_type` tinyint unsigned NOT NULL DEFAULT '0',
  `relate_proc` decimal(10,2) NOT NULL DEFAULT '0.00',
  `proc_price2` decimal(10,2) NOT NULL DEFAULT '0.00',
  `proc_price3` decimal(10,2) NOT NULL DEFAULT '0.00',
  `min_order` int NOT NULL DEFAULT '0',
  `step_order` int NOT NULL DEFAULT '0',
  `seo_psu` char(255) NOT NULL DEFAULT '',
  `seo_title` char(255) NOT NULL DEFAULT '',
  `in_xml` tinyint unsigned NOT NULL DEFAULT '0',
  `templ_key` char(100) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `update_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `edit_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `exist_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `option_code` text NOT NULL DEFAULT (_utf8mb3''),
  `award_cnt` int NOT NULL DEFAULT '0',
  `award_avg` decimal(10,4) NOT NULL DEFAULT '0.0000',
  PRIMARY KEY (`id`),
  KEY `code_shop` (`code_shop`(10)),
  KEY `code_prov` (`code_prov`(10)),
  KEY `code_made` (`code_made`(10)),
  KEY `provider_id` (`provider_id`),
  KEY `brand_id` (`brand_id`),
  KEY `relate_id` (`relate_id`),
  KEY `clann` (`clann`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_store`
--

LOCK TABLES `ms_store` WRITE;
INSERT INTO `ms_store` VALUES ('1',NULL,NULL,'','','','','Демонстрационный магазин Melbis Shop','Демонстрационный магазин Melbis Shop','            <div class=\"jumbotron\">
                <div class=\"row\">
                    <div class=\"col-lg-4 text-center\">
                        <img class=\"img-fluid rounded border\" src=\"files/2025/03_29/14_38/u_files_store_1_1.png\">
                    </div>
                    <div class=\"col-lg-8\">
                        <h1 class=\"display-4\">Приветствуем в Melbis Shop 6!</h1>
                        <p class=\"lead\">Это простой скрипт для демонстрации базового функционала. Минимальный функционал призван без излишних сложностей раскрыть разные аспекты написания скриптов и обработки данных.</p>
                        <hr class=\"my-4\">
                        <p>Melbis Shop - это интеллектуальное программное обеспечение для создания онлайн-каталогов, интернет-магазинов, любых сайтов, которым требуется система управления контентом.</p>
                        <a class=\"btn btn-info btn-lg float-right\" href=\"https://melbis.com\">Постите melbis.com</a></div></div></div>{MELBIS:melbis_cataloge_center([MS:VAR:LANG])}&nbsp;{MELBIS:melbis_store_random(8)}','','0','kAbsent','kDefault','kDefault','0','','','0','0','0',NULL,'0','0.00',NULL,'0.00',NULL,'0.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-03-28 17:07:31','2025-04-01 11:10:52','2025-04-01 11:11:10','2000-01-01 00:00:00','','0','0.0000');
INSERT INTO `ms_store` VALUES ('2',NULL,NULL,'032645','','','','Бинокль Arsenal 10x50 Porro','Бинокль ARSENAL с классическим увеличением 10х будет превосходным прибором практически для любых наблюдений - полевых и астрономических, орнитологических и натуралистических. Подойдет он и для рыбалки, и охоты.','<p>Бинокль ARSENAL с классическим увеличением 10х будет превосходным прибором практически для любых наблюдений - полевых и астрономических, орнитологических и натуралистических. Подойдет он и для рыбалки, и охоты.</p><p>Увеличение 10 крат и достаточно широкое поле зрения позволяют отнести этот бинокль к разряду универсальных, многозадачных и многоцелевых. Для своей ценовой категории это одна из лучших моделей как по качеству оптики и механики, так и по дизайну.&nbsp;</p><p>Оборачивающая система этой модели выполнена по призменной схеме Porro, в которой используются довольно крупные призмы, расположенные не на одной оси. У биноклей такой конструкции оптические оси объективов разнесены больше, чем оптические оси окуляров, что дает больший эффект объемности наблюдаемого изображения. В тоже время такая конструкция является наибольшей по габаритам при тех же оптических параметрах.</p><p>В конструкции применены призмы из оптического стекла ВК7, которые позволят Вам наблюдать четкую и контрастную картинку на большей части поля зрения. И лишь по краям будут заметны небольшие искажения и падение освещености.</p><p>Оптика этой модели имеет многослойное просветление. Это означает, что на большинство оптических поверхностей нанесено специальное многослойное покрытие, уменьшающее потери света при отражении. Благодаря этому наблюдаемое изображение становится более ярким и контрастным.</p><p>Эта модель не герметична и относится к разряду водозащищенных, что позволяет проводить наблюдения в туман, мелкий дождь и даже очень сильный ливень. Однако кратковременное погружение в воду может нанести изделию существенный урон и Вам придется потратить немало времени на восстановление его работоспособности.</p><p>Эта модель имеет ударостойкую конструкцию, благодаря чему толчки, удары, вибрации при транспортировке, и даже падение с высоты человеческого роста не нанесут изделию существенного вреда. Вы сможете продолжить наблюдения и после таких досадных &nbsp;недоразумений.</p><p>Этот бинокль имеет центральную фокусировку обоих окуляров одновременно и диоптрийную подстройку на правом окуляре под разницу глаз. Это позволит вам максимально быстро провести настройку резкости при смене дистанции наблюдения.</p> <div><br></div>','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','0.00',NULL,'0.00',NULL,'2000.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-03-30 12:51:55','2025-04-01 11:09:11','2025-03-31 17:51:23','2000-01-01 00:00:00','','0','0.0000');
INSERT INTO `ms_store` VALUES ('3',NULL,NULL,'032914','','','','Бинокль Arsenal 10x42 ED (bw15)','Благодаря качественной оптике из ED-стекла и удачному соотношению диаметра и кратности, бинокль даёт очень хорошее качество изображения, как днём так и в сумерках.','<p>Благодаря качественной оптике из ED-стекла и удачному соотношению диаметра и кратности, бинокль даёт очень хорошее качество изображения, как днём так и в сумерках.</p><p>Изображение, даваемое биноклем, чистое – что называется, «хрустальное». Цветопередача нейтральная. Край поля зрения резко очерчен. Виньетирование не отмечается. Юстировка бинокля отличная. Хроматизм совершенно не заметен. Поле зрения практически плоское, хорошо исправленное. Проявления подушкообразной дисторсии невелики и почти не заметны примерно на 2/3 поля зрения.</p><p>Бинокль обеспечивает порядка 75% качественного поля зрения. По краю поля его качество ограничено кривизной и легким астигматизмом. Реальное поле зрения равно 7 градусам, что несколько меньше заявленных производителем 7,1 градусов или 124 метров на расстоянии в 1000 метров. Благодаря достаточно большому зрачку и отличным покрытиям, бинокль прекрасно работает в условиях пониженной освещенности, обеспечивая резкую и хорошо видимую картинку.</p><p>Оборачивающая система этой модели выполнена по призменной схеме Roof, в которой призмы, объектив и окуляр расположены на одной оптической оси, т.е на одной линии. Благодаря этому конструкция в целом более компактная и легкая, чем в классической системе Porro. Однако повышаются требования к точности и качеству оптике, и как результат -  большая стоимость таких моделей.<br></p><p>
Объектив выполнен из низкодисперсионного ED-стекла, что существенно уменьшает хроматизм изображения, присущий обычной линзовой оптике. Это позволит Вам наблюдать объекты с максимальной четкостью, с мельчайшими деталями и правильной цветопередачей.<br>
В конструкции применены призмы из стекла ВАК4, которые позволят Вам наблюдать наиболее четкую и контрастную картинку, с равномерным освещением по всему полю зрения и с минимальным количеством искажений.<br></p><p>
Призмы этой модели имеют фазовую коррекцию, благодаря чему не происходит потери света при отражениии и Вы получаете изображение с высокой яркостью и контрастом. <br></p><p>
Оптика этой модели имеет полное многослойное просветление. Это означает, что на каждую поверхность стекла нанесено специальное многослойное покрытие, уменьшающее потери света при отражении. Благодаря этому, при прочих равных характеристиках, наблюдаемое изображение будет наиболее ярким и контрастным.<br></p><p>
Эта модель герметична и относится к разряду водонепроницаемых, что позволяет проводить наблюдения даже в сильный ливень или снегопад. Кратковременное погружение в воду тоже не нанесет изделию ни какого урона.<br>
Корпус герметичен и газонаполнен, благодаря этому не происходит запотевания и выпадения росы на внутренних частях оптики и механики. Это позволит проводить наблюдения в неблагоприятных погодных условиях, а также значительно увеличит срок службы изделия.<br></p><p>
Эта модель имеет ударостойкую конструкцию, благодаря чему толчки, удары, вибрации при транспортировке, и даже падение с высоты человеческого роста не нанесут изделию существенного вреда. Вы сможете продолжить наблюдения и после таких досадных  недоразумений.</p><p>Этот бинокль имеет центральную фокусировку обоих окуляров одновременно и диоптрийную подстройку на правом окуляре под разницу глаз. Это позволит вам максимально быстро провести настройку резкости при смене дистанции наблюдения.</p><p></p>','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','0.00',NULL,'0.00',NULL,'3000.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-03-30 17:18:03','2025-04-01 11:09:11','2025-03-31 17:53:52','2000-01-01 00:00:00','','0','0.0000');
INSERT INTO `ms_store` VALUES ('4',NULL,NULL,'129608','','','','Бинокль Bresser Corvette II 7x50 WP','Bresser Corvette II 7x50 WP светосильный бинокль для применения в условиях низкой освещенности. Он отлично подходит для наблюдений за окружающим миром: птицами, природой, спортивными соревнованиями, для обзорных астрономических наблюдений. ','<p>Bresser Corvette II 7x50 WP светосильный бинокль для применения в условиях низкой освещенности. Он отлично подходит для наблюдений за окружающим миром: птицами, природой, спортивными соревнованиями, для обзорных астрономических наблюдений. Благодаря водонепроницаемой конструкции его c успехом можно применять в любую погоду, а также на морских и речных судах.</p><p>Обновленная серия биноклей Corvette II получила полную водонепроницаемость и напонение азотом, большее поле зрение, более качественное мультипросветление, а также меньшее расстояние фокусировки и больший вынос зрачка.</p><p>Оборачивающая система этой модели выполнена по призменной схеме Porro, в которой используются довольно крупные призмы, расположенные не на одной оси. У биноклей такой конструкции оптические оси объективов разнесены больше, чем оптические оси окуляров, что дает больший эффект объемности наблюдаемого изображения. В тоже время такая конструкция является наибольшей по габаритам при тех же оптических параметрах.<br>
В конструкции применены призмы из стекла ВАК4, которые позволят Вам наблюдать наиболее четкую и контрастную картинку, с равномерным освещением по всему полю зрения и с минимальным количеством искажений.</p><p>Оптика этой модели имеет полное многослойное просветление. Это означает, что на каждую поверхность стекла нанесено специальное многослойное покрытие, уменьшающее потери света при отражении. Благодаря этому, при прочих равных характеристиках, наблюдаемое изображение будет наиболее ярким и контрастным.</p><p>Эта модель герметична и относится к разряду водонепроницаемых, что позволяет проводить наблюдения даже в сильный ливень или снегопад. Кратковременное погружение в воду тоже не нанесет изделию ни какого урона.</p><p>Корпус герметичен и газонаполнен, благодаря этому не происходит запотевания и выпадения росы на внутренних частях оптики и механики. Это позволит проводить наблюдения в неблагоприятных погодных условиях, а также значительно увеличит срок службы изделия.</p><p>Эта модель имеет ударостойкую конструкцию, благодаря чему толчки, удары, вибрации при транспортировке, и даже падение с высоты человеческого роста не нанесут изделию существенного вреда. Вы сможете продолжить наблюдения и после таких досадных  недоразумений.</p><p>Этот бинокль имеет центральную фокусировку обоих окуляров одновременно и диоптрийную подстройку на правом окуляре под разницу глаз. Это позволит вам максимально быстро провести настройку резкости при смене дистанции наблюдения.</p>','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','0.00',NULL,'0.00',NULL,'2000.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-03-30 17:36:20','2025-04-01 11:09:11','2025-03-31 17:53:52','2000-01-01 00:00:00','','0','0.0000');
INSERT INTO `ms_store` VALUES ('5',NULL,NULL,'168457','','','','Бинокль Bresser Pirsch 8x56 UR WP','Бинокль Bresser Pirsch 8x56 отлично подойдет для наблюдений за объектами в условиях плохого освещения и в сумерках, в том числе слабосветящимися астрономическими объектами.','<p>Бинокль Bresser Pirsch 8x56 отлично подойдет для наблюдений за объектами в условиях плохого освещения и в сумерках, в том числе слабосветящимися астрономическими объектами.</p><p>Бинокль Bresser Pirsch 8x56 UR WP Phase Coating – это невероятно светосильный бинокль с небольшим увеличением и с двумя типами покрытий для улучшения светопропускания, которое улучшает видимость в сумерках, делая картинку более яркой и контрастной. Данная модель прекрасно подходит для обнаружения движущихся объектов и станет отличным выбором для наблюдения за птицами, охотников, для выполнения тактических задач на местности и для изучения ночного небосклона.</p><p>Серия Pirsch это бинокли премиум класса от немецкой компании Bresser - водонепроницаемые, наполненные азотом, удобные в эксплуатации. Все модели имеют призмы BaK-4 со специальным покрытием UR и фазовой коррекцией, благодаря чему достигаются исключительная яркость и контраст изображения. Все механизмы и корпуса окуляров выполнены из металла, оптические трубки из армированного поликарбоната.</p><p>Оборачивающая система этой модели выполнена по призменной схеме Roof, в которой призмы, объектив и окуляр расположены на одной оптической оси, т.е на одной линии. Благодаря этому конструкция в целом более компактная и легкая, чем в классической системе Porro. Однако повышаются требования к точности и качеству оптике, и как результат -  большая стоимость таких моделей.</p><p>В конструкции применены призмы из стекла ВАК4, которые позволят Вам наблюдать наиболее четкую и контрастную картинку, с равномерным освещением по всему полю зрения и с минимальным количеством искажений.</p><p>Призмы этой модели имеют фазовую коррекцию, благодаря чему не происходит потери света при отражениии и Вы получаете изображение с высокой яркостью и контрастом.&nbsp;</p><p>Оптика этой модели имеет полное многослойное просветление. Это означает, что на каждую поверхность стекла нанесено специальное многослойное покрытие, уменьшающее потери света при отражении. Благодаря этому, при прочих равных характеристиках, наблюдаемое изображение будет наиболее ярким и контрастным.</p><p>Эта модель герметична и относится к разряду водонепроницаемых, что позволяет проводить наблюдения даже в сильный ливень или снегопад. Кратковременное погружение в воду тоже не нанесет изделию ни какого урона.</p><p>Корпус герметичен и газонаполнен, благодаря этому не происходит запотевания и выпадения росы на внутренних частях оптики и механики. Это позволит проводить наблюдения в неблагоприятных погодных условиях, а также значительно увеличит срок службы изделия.</p><p>Эта модель имеет ударостойкую конструкцию, благодаря чему толчки, удары, вибрации при транспортировке, и даже падение с высоты человеческого роста не нанесут изделию существенного вреда. Вы сможете продолжить наблюдения и после таких досадных  недоразумений.</p><p>Этот бинокль имеет центральную фокусировку обоих окуляров одновременно и диоптрийную подстройку на правом окуляре под разницу глаз. Это позволит вам максимально быстро провести настройку резкости при смене дистанции наблюдения.</p>','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','0.00',NULL,'0.00',NULL,'3000.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-03-30 18:20:16','2025-04-01 11:09:11','2025-03-31 17:53:52','2000-01-01 00:00:00','','0','0.0000');
INSERT INTO `ms_store` VALUES ('6',NULL,NULL,'','','','','Оплата в магазине','','<h1 class=\"display-4 border-bottom\">Оплата в магазине</h1><div>Страница с информацией об оплате в магазине.</div><div><br></div>','','0','kAbsent','kDefault','kDefault','0','','','0','0','0',NULL,'0','0.00',NULL,'0.00',NULL,'0.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-03-31 18:24:45','2025-03-31 18:24:45','2025-03-31 18:26:43','2000-01-01 00:00:00','','0','0.0000');
INSERT INTO `ms_store` VALUES ('7',NULL,NULL,'','','','','Способы доставки в магазине','','<h1 class=\"display-4 border-bottom\">Способы доставки в магазине</h1><div>Страница с информацией о возможных способах оплаты в магазине.</div><div><br></div>','','0','kAbsent','kDefault','kDefault','0','','','0','0','0',NULL,'0','0.00',NULL,'0.00',NULL,'0.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-03-31 18:26:57','2025-03-31 18:27:22','2025-03-31 18:29:28','2000-01-01 00:00:00','','0','0.0000');
INSERT INTO `ms_store` VALUES ('8',NULL,NULL,'','','','','Правила покупи и возврата товара','','<h1 class=\"display-4 border-bottom\">Правила покупки в магазине</h1><div>Страница с правилами покупки в магазине.</div><div><br></div>','','0','kAbsent','kDefault','kDefault','0','','','0','0','0',NULL,'0','0.00',NULL,'0.00',NULL,'0.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-03-31 18:28:16','2025-03-31 18:28:16','2025-03-31 18:29:28','2000-01-01 00:00:00','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1233',NULL,NULL,'WMR86NS','','9025804090','','Погодная станция Oregon Scientific WMR86NS Pro Colour','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2394.00',NULL,'0.00',NULL,'2999.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1232',NULL,NULL,'WMR500','','9025804090','','Погодная станция Oregon Scientific WMR500 All-In-One Wi-Fi','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','5433.00',NULL,'0.00',NULL,'6790.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1231',NULL,NULL,'RAR502X','','9025804090','','Погодная станция Oregon Scientific RAR502X Multi-Zone Black c тремя датчиками','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1482.00',NULL,'0.00',NULL,'1849.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1230',NULL,NULL,'BAR223PN','','9025804090','','Погодная станция Oregon Scientific BAR223PN PRYSMA Blue','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1722.00',NULL,'0.00',NULL,'2149.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1229',NULL,NULL,'UM8','','9025804090','','Погодная станция Ea2 UM8 Ultra Metal','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1002.00',NULL,'0.00',NULL,'1250.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1228',NULL,NULL,'EN209','','9025804090','','Погодная станция Ea2 EN209 Eternity','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1842.00',NULL,'0.00',NULL,'2299.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1227',NULL,NULL,'EN208','','9025804090','','Погодная станция Ea2 EN208 Eternity','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1113.00',NULL,'0.00',NULL,'1389.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1226',NULL,NULL,'EN203','','9025804090','','Погодная станция Ea2 EN203 Eternity','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','738.00',NULL,'0.00',NULL,'920.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1225',NULL,NULL,'ED609','','9025804090','','Погодная станция Ea2 ED609 Edge','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1800.00',NULL,'0.00',NULL,'2249.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1224',NULL,NULL,'ED608','','9025804090','','Погодная станция Ea2 ED608 Edge','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1002.00',NULL,'0.00',NULL,'1250.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1223',NULL,NULL,'ED603','','9025804090','','Погодная станция Ea2 ED603 Edge','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','663.00',NULL,'0.00',NULL,'830.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1222',NULL,NULL,'BL508','','9025804090','','Погодная станция Ea2 BL508 Slim','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1002.00',NULL,'0.00',NULL,'1250.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1221',NULL,NULL,'BL503','','9025804090','','Погодная станция Ea2 BL503 Slim','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','663.00',NULL,'0.00',NULL,'830.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1220',NULL,NULL,'AL808','','9025804090','','Погодная станция Ea2 AL808 Aluminum Slim','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1032.00',NULL,'0.00',NULL,'1290.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1219',NULL,NULL,'AL803','','9025804090','','Погодная станция Ea2 AL803 Aluminum Slim','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','738.00',NULL,'0.00',NULL,'920.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1218',NULL,NULL,'9070100','','9025804090','','Метеостанция National Geographic Weather Stations Black','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1077.00',NULL,'0.00',NULL,'1399.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1217',NULL,NULL,'9068000','','9025804090','','Метеостанция National Geographic Weather Expert','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','3072.00',NULL,'0.00',NULL,'3990.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1216',NULL,NULL,'9080500','','9025804090','','Метеостанция National Geographic Weather Center 5-in-1 256 Colour Black','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','3996.00',NULL,'0.00',NULL,'5190.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1215',NULL,NULL,'9070300','','9025804090','','Метеостанция National Geographic Transparent Black','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','531.00',NULL,'0.00',NULL,'690.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1214',NULL,NULL,'9070500','','9025804090','','Метеостанция National Geographic Multi Colour Wireless Black','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2496.00',NULL,'0.00',NULL,'3240.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1213',NULL,NULL,'9070400','','9025804090','','Метеостанция National Geographic Multi Colour Black','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2226.00',NULL,'0.00',NULL,'2890.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1212',NULL,NULL,'7002580','','9025804090','','Метеостанция Bresser Weather Center 5-in-1 Wi-Fi Profi Sensor Color Black','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','3765.00',NULL,'0.00',NULL,'4890.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1211',NULL,NULL,'7002590','','9025804090','','Метеостанция Bresser Weather Center JC XXL 5-in-1 White','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','3459.00',NULL,'0.00',NULL,'4490.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1210',NULL,NULL,'7002420','','9025804090','','Метеостанция Bresser Weather Center ClimaTemp XXL Wooden','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','3765.00',NULL,'0.00',NULL,'4890.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1209',NULL,NULL,'7002410','','9025804090','','Метеостанция Bresser Weather Center ClimaTemp FW Wooden','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2541.00',NULL,'0.00',NULL,'3299.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1208',NULL,NULL,'7002512','','9025804090','','Метеостанция Bresser Weather Center 5-in-1 WTW Wooden','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2841.00',NULL,'0.00',NULL,'3690.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1207',NULL,NULL,'7002520CM3000','','9025804090','','Метеостанция Bresser Weather Center 5-in-1 Professional 256 Colour Black','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','3765.00',NULL,'0.00',NULL,'4890.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1206',NULL,NULL,'7002550CM3000','','9025804090','','Метеостанция Bresser Weather Center 5-in-1 Comfort Colour Black','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','3765.00',NULL,'0.00',NULL,'4890.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1205',NULL,NULL,'7007600QT5000','','9025804090','','Метеостанция Bresser Translucidus Grey','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','531.00',NULL,'0.00',NULL,'690.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1204',NULL,NULL,'7004404GYE000','','9025804090','','Метеостанция Bresser TemeoTrend JC White','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2112.00',NULL,'0.00',NULL,'2740.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1203',NULL,NULL,'7004404HZI000','','9025804090','','Метеостанция Bresser TemeoTrend JC Silver','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2112.00',NULL,'0.00',NULL,'2740.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1202',NULL,NULL,'7004404CM3000','','9025804090','','Метеостанция Bresser TemeoTrend JC Black','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2112.00',NULL,'0.00',NULL,'2740.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1201',NULL,NULL,'7060200','','9025804090','','Метеостанция Bresser TemeoTrend FSX','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1340.00',NULL,'0.00',NULL,'1740.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1200',NULL,NULL,'7007200','','9025804090','','Метеостанция Bresser Temeo TB Colour','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1956.00',NULL,'0.00',NULL,'2540.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1199',NULL,NULL,'7000023','','9025804090','','Метеостанция Bresser Quadro NLX Colour Black с 3 датчиками','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1380.00',NULL,'0.00',NULL,'1790.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1198',NULL,NULL,'7007310CM3000','','9025804090','','Метеостанция Bresser MeteoTrend Colour Black','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1386.00',NULL,'0.00',NULL,'1799.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1197',NULL,NULL,'7007510','','9025804090','','Метеостанция Bresser MeteoTemp WTM Color','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','840.00',NULL,'0.00',NULL,'1090.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1196',NULL,NULL,'7008000CM3000','','9025804090','','Метеостанция Bresser Colour Temeo Life H Black','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1917.00',NULL,'0.00',NULL,'2490.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1195',NULL,NULL,'7008001CM3000','','9025804090','','Метеостанция Bresser Colour Temeo Life Black','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2070.00',NULL,'0.00',NULL,'2690.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1194',NULL,NULL,'7007320','','9025804090','','Метеостанция Bresser ClimaTemp WS Colour Wooden','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1455.00',NULL,'0.00',NULL,'1890.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1193',NULL,NULL,'7007201','','9025804090','','Метеостанция Bresser ClimaTemp TB Сolour','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1917.00',NULL,'0.00',NULL,'2490.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:23','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1186',NULL,NULL,'9119000','','9011800000','','Микроскоп National Geographic Stereo 20x','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2124.00',NULL,'0.00',NULL,'2833.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1185',NULL,NULL,'9119100','','9011800000','','Микроскоп National Geographic Mono 20x с кейсом','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1950.00',NULL,'0.00',NULL,'2597.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1184',NULL,NULL,'9039500','','9011800000','','Микроскоп National Geographic Biolux 40x-800x с адаптером для смартфона','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1011.00',NULL,'0.00',NULL,'1347.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1183',NULL,NULL,'9039001','','9011800000','','Микроскоп National Geographic 40x-1280x с адаптером для смартфона','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','3300.00',NULL,'0.00',NULL,'4398.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1182',NULL,NULL,'9039100','','9011800000','','Микроскоп National Geographic 40x-1024x USB eyepiece с кейсом','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','4197.00',NULL,'0.00',NULL,'5593.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1181',NULL,NULL,'9119501','','9011800000','','Микроскоп National Geographic 40x-640x с адаптером для смартфона','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1122.00',NULL,'0.00',NULL,'1499.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1180',NULL,NULL,'5201000','','9011800000','','Микроскоп Bresser LCD 50x-2000x','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','7398.00',NULL,'0.00',NULL,'9799.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1179',NULL,NULL,'8852000','','9011800000','','Микроскоп Bresser Junior Stereo 20х','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1971.00',NULL,'0.00',NULL,'2630.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1178',NULL,NULL,'8855002','','9011800000','','Микроскоп Bresser Junior Biolux CA 40x-1024x с кейсом и адаптером для смартфона','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','3465.00',NULL,'0.00',NULL,'4620.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1177',NULL,NULL,'8855500','','9011800000','','Микроскоп Bresser Junior Biolux 40x-2000x с адаптером для смартфона','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2490.00',NULL,'0.00',NULL,'3321.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1176',NULL,NULL,'8855000','','9011800000','','Микроскоп Bresser Junior 40x-1024x USB Camera с кейсом','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','4395.00',NULL,'0.00',NULL,'5858.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1175',NULL,NULL,'8851310','','9011800000','','Микроскоп Bresser Junior 40x-640x Orange с кейсом','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1350.00',NULL,'0.00',NULL,'1797.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1174',NULL,NULL,'8851301','','9011800000','','Микроскоп Bresser Junior 40x-640x Orange','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','975.00',NULL,'0.00',NULL,'1299.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1173',NULL,NULL,'5803600','','9011800000','','Микроскоп Bresser Erudit ICD Stereo 20x-40x с кейсом и адаптером для смартфона','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','5832.00',NULL,'0.00',NULL,'7774.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1172',NULL,NULL,'5102000','','9011800000','','Микроскоп Bresser Erudit DLX 40x-1000x','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','8112.00',NULL,'0.00',NULL,'10813.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:30','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:30','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1171',NULL,NULL,'5102100','','9011800000','','Микроскоп Bresser Erudit Basic Mono 40x-400x','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','6045.00',NULL,'0.00',NULL,'7999.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1170',NULL,NULL,'5102200','','9011800000','','Микроскоп Bresser Erudit Basic Bino 40x-400x с кейсом и адаптером для смартфона','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','7785.00',NULL,'0.00',NULL,'10379.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1169',NULL,NULL,'8855610GYE000','','9011800000','','Микроскоп Bresser Biolux SEL Student 40x-1600x White с кейсом и адаптером для смартфона','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','3618.00',NULL,'0.00',NULL,'4823.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1168',NULL,NULL,'5116200','','9011800000','','Микроскоп Bresser Biolux NV 20x-1280x HD USB Camera с кейсом','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','4854.00',NULL,'0.00',NULL,'6470.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1167',NULL,NULL,'5802000','','9011800000','','Микроскоп Bresser Biolux ICD Stereo 20x','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2118.00',NULL,'0.00',NULL,'2823.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1166',NULL,NULL,'5013000','','9011800000','','Микроскоп Bresser BioDiscover 20x-1280x','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','4359.00',NULL,'0.00',NULL,'5799.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1165',NULL,NULL,'5722100','','9011800000','','Микроскоп Bresser Bino Researcher 40x-1000x','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','12801.00',NULL,'0.00',NULL,'16999.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1164',NULL,NULL,'9057000','','9005800000','','Подзорная труба National Geographic 20-60x60 + штатив','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2322.00',NULL,'0.00',NULL,'3092.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1163',NULL,NULL,'4311000','','9005800000','','Подзорная труба Bresser Travel 20-60x80 + штатив','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','3102.00',NULL,'0.00',NULL,'4134.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1162',NULL,NULL,'4310000','','9005800000','','Подзорная труба Bresser Travel 20-60x60 + штатив','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2322.00',NULL,'0.00',NULL,'3092.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1161',NULL,NULL,'4334500','','9005800000','','Подзорная труба Bresser Spektar 15-45x60 WP','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','4221.00',NULL,'0.00',NULL,'5627.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1160',NULL,NULL,'8820100','','9005800000','','Подзорная труба Bresser Junior Spotty 20-60x60 + штатив','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1815.00',NULL,'0.00',NULL,'2422.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1159',NULL,NULL,'4321000','','9005800000','','Подзорная труба Bresser Corvette 15-45x60 WP + штатив','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','3360.00',NULL,'0.00',NULL,'4482.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1153',NULL,NULL,'9076100','','9005100000','','Бинокль National Geographic 10x42 WP','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','4152.00',NULL,'0.00',NULL,'5535.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1152',NULL,NULL,'9076000','','9005100000','','Бинокль National Geographic 8x42 WP','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','3855.00',NULL,'0.00',NULL,'5140.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1151',NULL,NULL,'9076200','','9005100000','','Бинокль National Geographic 8x42','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','3000.00',NULL,'0.00',NULL,'3999.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1150',NULL,NULL,'9064000','','9005100000','','Бинокль National Geographic 8-24x50 ZOOM','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2070.00',NULL,'0.00',NULL,'2760.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1149',NULL,NULL,'9056000','','9005100000','','Бинокль National Geographic 10x50','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1650.00',NULL,'0.00',NULL,'2199.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1148',NULL,NULL,'9019000','','9005100000','','Бинокль National Geographic 7x50','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1650.00',NULL,'0.00',NULL,'2199.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1147',NULL,NULL,'9025000','','9005100000','','Бинокль National Geographic 10x25','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','900.00',NULL,'0.00',NULL,'1199.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1146',NULL,NULL,'9024000','','9005100000','','Бинокль National Geographic 8x21','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','561.00',NULL,'0.00',NULL,'749.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1145',NULL,NULL,'1252052','','9005100000','','Бинокль Bresser Travel 20x50','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1500.00',NULL,'0.00',NULL,'1999.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1144',NULL,NULL,'1251652','','9005100000','','Бинокль Bresser Travel 16x50','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1443.00',NULL,'0.00',NULL,'1924.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1143',NULL,NULL,'1251052','','9005100000','','Бинокль Bresser Travel 10x50','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1398.00',NULL,'0.00',NULL,'1863.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1142',NULL,NULL,'1250752','','9005100000','','Бинокль Bresser Travel 7x50','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1440.00',NULL,'0.00',NULL,'1920.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1141',NULL,NULL,'1211233','','9005100000','','Бинокль Bresser Travel 12x32','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','699.00',NULL,'0.00',NULL,'930.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1140',NULL,NULL,'1211026','','9005100000','','Бинокль Bresser Travel 10x25','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','525.00',NULL,'0.00',NULL,'699.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1139',NULL,NULL,'1210823','','9005100000','','Бинокль Bresser Travel 8x21','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','522.00',NULL,'0.00',NULL,'695.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1138',NULL,NULL,'1866932','','9005100000','','Бинокль Bresser Topas 7x50 WP Compass','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','3300.00',NULL,'0.00',NULL,'4399.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1137',NULL,NULL,'1866934','','9005100000','','Бинокль Bresser Topas 7x50 WP','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2758.00',NULL,'0.00',NULL,'3662.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1136',NULL,NULL,'8910102','','9005100000','','Бинокль Bresser S-Series 10x42','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1914.00',NULL,'0.00',NULL,'2553.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1135',NULL,NULL,'8910101','','9005100000','','Бинокль Bresser S-Series 8x42','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1806.00',NULL,'0.00',NULL,'2405.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1134',NULL,NULL,'8910110','','9005100000','','Бинокль Bresser Spektar 10x42 WP','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2469.00',NULL,'0.00',NULL,'3293.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1133',NULL,NULL,'8910100','','9005100000','','Бинокль Bresser Spektar 8x42 WP','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2358.00',NULL,'0.00',NULL,'3145.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1132',NULL,NULL,'1552060','','9005100000','','Бинокль Bresser Spezial-Saturn 20x60','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','3858.00',NULL,'0.00',NULL,'5142.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1131',NULL,NULL,'1551156','','9005100000','','Бинокль Bresser Spezial-Jagd 11x56','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','4134.00',NULL,'0.00',NULL,'5512.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1130',NULL,NULL,'1721042','','9005100000','','Бинокль Bresser Pirsch 10x42 PHASE COATING','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','6750.00',NULL,'0.00',NULL,'8999.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1129',NULL,NULL,'1720842','','9005100000','','Бинокль Bresser Pirsch 8x42 PHASE COATING','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','6750.00',NULL,'0.00',NULL,'8999.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1128',NULL,NULL,'1866815','','9005100000','','Бинокль Bresser Nautic 7x50 WD Compass','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','5520.00',NULL,'0.00',NULL,'7362.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1127',NULL,NULL,'1162450','','9005100000','','Бинокль Bresser Hunter 8-24x50 ZOOM','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2136.00',NULL,'0.00',NULL,'2846.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1126',NULL,NULL,'1152050','','9005100000','','Бинокль Bresser Hunter 20x50','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1608.00',NULL,'0.00',NULL,'2146.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1125',NULL,NULL,'1151650','','9005100000','','Бинокль Bresser Hunter 16x50','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1470.00',NULL,'0.00',NULL,'1961.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1124',NULL,NULL,'1151050','','9005100000','','Бинокль Bresser Hunter 10x50','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1320.00',NULL,'0.00',NULL,'1760.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1122',NULL,NULL,'1150840','','9005100000','','Бинокль Bresser Hunter 8x40','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','923.00',NULL,'0.00',NULL,'1230.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1123',NULL,NULL,'1150750','','9005100000','','Бинокль Bresser Hunter 7x50','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','1251.00',NULL,'0.00',NULL,'1665.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1121',NULL,NULL,'1111025','','9005100000','','Бинокль Bresser Hunter 10x25','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','594.00',NULL,'0.00',NULL,'794.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1120',NULL,NULL,'1110821','','9005100000','','Бинокль Bresser Hunter 8x21','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','582.00',NULL,'0.00',NULL,'777.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1119',NULL,NULL,'1461051','','9005100000','','Бинокль Bresser Corvette 10x50 WP','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','3300.00',NULL,'0.00',NULL,'4399.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1118',NULL,NULL,'1460751','','9005100000','','Бинокль Bresser Corvette 7x50 WP','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','3276.00',NULL,'0.00',NULL,'4365.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1117',NULL,NULL,'1441043','','9005100000','','Бинокль Bresser Corvette 10x42 WP','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2349.00',NULL,'0.00',NULL,'3131.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1116',NULL,NULL,'1440843','','9005100000','','Бинокль Bresser Corvette 8x42 WP','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2325.00',NULL,'0.00',NULL,'3100.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1115',NULL,NULL,'1821051','','9005100000','','Бинокль Bresser Condor 10x50 UR','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','5964.00',NULL,'0.00',NULL,'7954.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1114',NULL,NULL,'1821043','','9005100000','','Бинокль Bresser Condor 10x42 UR','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','5520.00',NULL,'0.00',NULL,'7362.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1113',NULL,NULL,'1820857','','9005100000','','Бинокль Bresser Condor 8x56 UR','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','6630.00',NULL,'0.00',NULL,'8841.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1112',NULL,NULL,'1820843','','9005100000','','Бинокль Bresser Condor 8x42 UR','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','5244.00',NULL,'0.00',NULL,'6992.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1111',NULL,NULL,'1821027','','9005100000','','Бинокль Bresser Condor 10x25 UR','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2748.00',NULL,'0.00',NULL,'3662.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1110',NULL,NULL,'1820826','','9005100000','','Бинокль Bresser Condor 8x25 UR','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','2637.00',NULL,'0.00',NULL,'3514.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
INSERT INTO `ms_store` VALUES ('1109',NULL,NULL,'1866805','','9005100000','','Бинокль Bresser Binocom 7x50 GAL Compass','','','','0','kExist','kDefault','kDefault','0','','','0','0','0',NULL,'0','5325.00',NULL,'0.00',NULL,'7099.00',NULL,'0.00',NULL,'0.00',NULL,'0','0.00','0.00','0.00','0','0','','','0','kDefault','2025-04-01 11:00:29','2025-04-01 11:09:11','2000-01-01 00:00:00','2025-04-01 11:00:29','','0','0.0000');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_store_comment`
--

DROP TABLE IF EXISTS `ms_store_comment`;

CREATE TABLE `ms_store_comment` (
  `id` int unsigned NOT NULL AUTO_INCREMENT,
  `store_id` int unsigned DEFAULT NULL,
  `parent_id` int unsigned DEFAULT NULL,
  `user_name` char(255) NOT NULL DEFAULT '',
  `user_email` char(255) NOT NULL DEFAULT '',
  `user_ip` int unsigned NOT NULL DEFAULT '0',
  `params` mediumtext DEFAULT (_utf8mb3''),
  `award` tinyint unsigned NOT NULL DEFAULT '0',
  `positive` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `negative` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `summary` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `pro_cnt` int NOT NULL DEFAULT '0',
  `contra_cnt` int NOT NULL DEFAULT '0',
  `create_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  PRIMARY KEY (`id`),
  KEY `store_id` (`store_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_store_comment`
--

LOCK TABLES `ms_store_comment` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_store_comment_block`
--

DROP TABLE IF EXISTS `ms_store_comment_block`;

CREATE TABLE `ms_store_comment_block` (
  `id` int unsigned NOT NULL AUTO_INCREMENT,
  `from_ip` int unsigned NOT NULL DEFAULT '0',
  `to_ip` int unsigned NOT NULL DEFAULT '0',
  `lock_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_store_comment_block`
--

LOCK TABLES `ms_store_comment_block` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_store_comment_vote`
--

DROP TABLE IF EXISTS `ms_store_comment_vote`;

CREATE TABLE `ms_store_comment_vote` (
  `id` int unsigned NOT NULL AUTO_INCREMENT,
  `comment_id` int unsigned DEFAULT NULL,
  `user_ip` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `comment_id` (`comment_id`),
  KEY `user_ip` (`user_ip`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_store_comment_vote`
--

LOCK TABLES `ms_store_comment_vote` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_store_info`
--

DROP TABLE IF EXISTS `ms_store_info`;

CREATE TABLE `ms_store_info` (
  `id` int unsigned NOT NULL AUTO_INCREMENT,
  `store_id` int unsigned DEFAULT NULL,
  `info_id` int unsigned DEFAULT NULL,
  `value_id` int unsigned DEFAULT NULL,
  `value_dec` decimal(10,4) NOT NULL DEFAULT '0.0000',
  `value_txt` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  PRIMARY KEY (`id`),
  KEY `store_id` (`store_id`),
  KEY `info_id` (`info_id`),
  KEY `value_id` (`value_id`),
  KEY `store_value` (`store_id`,`value_id`)
) ENGINE=MyISAM AUTO_INCREMENT=498 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_store_info`
--

LOCK TABLES `ms_store_info` WRITE;
INSERT INTO `ms_store_info` VALUES ('413','2','18','17','0.0000','');
INSERT INTO `ms_store_info` VALUES ('414','2','18','19','0.0000','');
INSERT INTO `ms_store_info` VALUES ('415','2','18','18','0.0000','');
INSERT INTO `ms_store_info` VALUES ('416','2','19',NULL,'0.0000','<ul><li>Бинокль&nbsp;</li><li>Мягкая качественная сумка&nbsp;</li><li>Ремень для сумки&nbsp;</li><li>Ремень для бинокля&nbsp;</li><li>Салфетка для протирки оптики&nbsp;</li><li>Защитные крышки на окуляры&nbsp;</li><li>Защитные крышки на объективы&nbsp;</li><li>Инструкция</li></ul>');
INSERT INTO `ms_store_info` VALUES ('412','2','17','16','0.0000','');
INSERT INTO `ms_store_info` VALUES ('411','2','16','15','0.0000','');
INSERT INTO `ms_store_info` VALUES ('410','2','15','12','0.0000','');
INSERT INTO `ms_store_info` VALUES ('409','2','15','11','0.0000','');
INSERT INTO `ms_store_info` VALUES ('408','2','14','6','0.0000','');
INSERT INTO `ms_store_info` VALUES ('407','2','14','5','0.0000','');
INSERT INTO `ms_store_info` VALUES ('406','2','13','3','0.0000','');
INSERT INTO `ms_store_info` VALUES ('405','2','11',NULL,'25.0000','');
INSERT INTO `ms_store_info` VALUES ('404','2','4',NULL,'10.0000','');
INSERT INTO `ms_store_info` VALUES ('403','2','3',NULL,'50.0000','');
INSERT INTO `ms_store_info` VALUES ('402','2','7','1','0.0000','');
INSERT INTO `ms_store_info` VALUES ('401','2','6',NULL,'0.8400','');
INSERT INTO `ms_store_info` VALUES ('400','2','5',NULL,'116.0000','');
INSERT INTO `ms_store_info` VALUES ('399','2','8',NULL,'6.6000','');
INSERT INTO `ms_store_info` VALUES ('397','2','10',NULL,'22.3600','');
INSERT INTO `ms_store_info` VALUES ('441','3','19',NULL,'0.0000','<ul><li>Бинокль&nbsp;</li><li>Качественная сумка&nbsp;</li><li>Ремень для сумки&nbsp;</li><li>Ремень для бинокля&nbsp;</li><li>Салфетка для протирки оптики&nbsp;</li><li>Защитные крышки на окуляры&nbsp;</li><li>Защитные крышки на объективы&nbsp;</li><li>Инструкция</li></ul>');
INSERT INTO `ms_store_info` VALUES ('440','3','18','19','0.0000','');
INSERT INTO `ms_store_info` VALUES ('439','3','18','18','0.0000','');
INSERT INTO `ms_store_info` VALUES ('438','3','18','20','0.0000','');
INSERT INTO `ms_store_info` VALUES ('437','3','17','16','0.0000','');
INSERT INTO `ms_store_info` VALUES ('436','3','16','15','0.0000','');
INSERT INTO `ms_store_info` VALUES ('435','3','15','12','0.0000','');
INSERT INTO `ms_store_info` VALUES ('434','3','15','14','0.0000','');
INSERT INTO `ms_store_info` VALUES ('433','3','15','13','0.0000','');
INSERT INTO `ms_store_info` VALUES ('432','3','14','10','0.0000','');
INSERT INTO `ms_store_info` VALUES ('431','3','14','9','0.0000','');
INSERT INTO `ms_store_info` VALUES ('430','3','14','8','0.0000','');
INSERT INTO `ms_store_info` VALUES ('418','3','5',NULL,'105.0000','');
INSERT INTO `ms_store_info` VALUES ('419','3','4',NULL,'10.0000','');
INSERT INTO `ms_store_info` VALUES ('420','3','3',NULL,'42.0000','');
INSERT INTO `ms_store_info` VALUES ('421','3','7','2','0.0000','');
INSERT INTO `ms_store_info` VALUES ('422','3','6',NULL,'0.6400','');
INSERT INTO `ms_store_info` VALUES ('423','3','9',NULL,'4.2000','');
INSERT INTO `ms_store_info` VALUES ('424','3','10',NULL,'20.4900','');
INSERT INTO `ms_store_info` VALUES ('425','3','11',NULL,'17.6400','');
INSERT INTO `ms_store_info` VALUES ('426','3','20',NULL,'1.9000','');
INSERT INTO `ms_store_info` VALUES ('427','3','21',NULL,'15.2000','');
INSERT INTO `ms_store_info` VALUES ('428','3','13','4','0.0000','');
INSERT INTO `ms_store_info` VALUES ('429','3','14','7','0.0000','');
INSERT INTO `ms_store_info` VALUES ('417','3','8',NULL,'6.0000','');
INSERT INTO `ms_store_info` VALUES ('468','4','19',NULL,'0.0000','<ul><li>Бинокль (цвет корпуса - черный)&nbsp;</li><li>Защитные крышки окуляров и объектива&nbsp;</li><li>Наплечный ремень&nbsp;</li><li>Мягкий кейс для хранения и транспортировки&nbsp;</li><li>Салфетка для чистки линз</li></ul>');
INSERT INTO `ms_store_info` VALUES ('467','4','18','19','0.0000','');
INSERT INTO `ms_store_info` VALUES ('466','4','18','18','0.0000','');
INSERT INTO `ms_store_info` VALUES ('465','4','18','20','0.0000','');
INSERT INTO `ms_store_info` VALUES ('464','4','18','17','0.0000','');
INSERT INTO `ms_store_info` VALUES ('463','4','23','21','0.0000','');
INSERT INTO `ms_store_info` VALUES ('462','4','22',NULL,'0.0000','57 - 72 мм');
INSERT INTO `ms_store_info` VALUES ('445','4','11',NULL,'51.0000','');
INSERT INTO `ms_store_info` VALUES ('446','4','9',NULL,'7.1400','');
INSERT INTO `ms_store_info` VALUES ('447','4','6',NULL,'0.9300','');
INSERT INTO `ms_store_info` VALUES ('448','4','7','22','0.0000','');
INSERT INTO `ms_store_info` VALUES ('449','4','3',NULL,'50.0000','');
INSERT INTO `ms_store_info` VALUES ('450','4','4',NULL,'7.0000','');
INSERT INTO `ms_store_info` VALUES ('451','4','5',NULL,'122.0000','');
INSERT INTO `ms_store_info` VALUES ('452','4','8',NULL,'7.0000','');
INSERT INTO `ms_store_info` VALUES ('453','4','20',NULL,'5.0000','');
INSERT INTO `ms_store_info` VALUES ('454','4','21',NULL,'20.0000','');
INSERT INTO `ms_store_info` VALUES ('455','4','14','8','0.0000','');
INSERT INTO `ms_store_info` VALUES ('456','4','14','10','0.0000','');
INSERT INTO `ms_store_info` VALUES ('457','4','15','13','0.0000','');
INSERT INTO `ms_store_info` VALUES ('458','4','15','14','0.0000','');
INSERT INTO `ms_store_info` VALUES ('459','4','15','12','0.0000','');
INSERT INTO `ms_store_info` VALUES ('460','4','17','16','0.0000','');
INSERT INTO `ms_store_info` VALUES ('494','5','18','25','0.0000','');
INSERT INTO `ms_store_info` VALUES ('495','5','18','18','0.0000','');
INSERT INTO `ms_store_info` VALUES ('496','5','18','19','0.0000','');
INSERT INTO `ms_store_info` VALUES ('497','5','19',NULL,'0.0000','<ul><li>Бинокль&nbsp;</li><li>Нейлоновая сумка с плечевым ремнем и поясным креплением&nbsp;</li><li>Широкий ремешок для переноски&nbsp;</li><li>Защитные крышки окуляров и объективов&nbsp;</li><li>Салфетка для очистки оптики&nbsp;</li><li>Инструкция по эксплуатации</li></ul>');
INSERT INTO `ms_store_info` VALUES ('493','5','18','17','0.0000','');
INSERT INTO `ms_store_info` VALUES ('492','5','23','21','0.0000','');
INSERT INTO `ms_store_info` VALUES ('489','5','17','16','0.0000','');
INSERT INTO `ms_store_info` VALUES ('485','5','15','13','0.0000','');
INSERT INTO `ms_store_info` VALUES ('486','5','15','14','0.0000','');
INSERT INTO `ms_store_info` VALUES ('487','5','15','12','0.0000','');
INSERT INTO `ms_store_info` VALUES ('488','5','16','15','0.0000','');
INSERT INTO `ms_store_info` VALUES ('480','5','13','4','0.0000','');
INSERT INTO `ms_store_info` VALUES ('481','5','14','8','0.0000','');
INSERT INTO `ms_store_info` VALUES ('482','5','14','9','0.0000','');
INSERT INTO `ms_store_info` VALUES ('483','5','14','24','0.0000','');
INSERT INTO `ms_store_info` VALUES ('484','5','14','10','0.0000','');
INSERT INTO `ms_store_info` VALUES ('470','5','11',NULL,'49.0000','');
INSERT INTO `ms_store_info` VALUES ('398','2','9',NULL,'5.0000','');
INSERT INTO `ms_store_info` VALUES ('461','4','16','15','0.0000','');
INSERT INTO `ms_store_info` VALUES ('444','4','13','3','0.0000','');
INSERT INTO `ms_store_info` VALUES ('490','5','22',NULL,'0.0000','60-72 мм');
INSERT INTO `ms_store_info` VALUES ('491','5','24',NULL,'0.0000','+/-4');
INSERT INTO `ms_store_info` VALUES ('471','5','9',NULL,'7.0000','');
INSERT INTO `ms_store_info` VALUES ('472','5','21',NULL,'19.6700','');
INSERT INTO `ms_store_info` VALUES ('473','5','6',NULL,'0.9700','');
INSERT INTO `ms_store_info` VALUES ('474','5','7','23','0.0000','');
INSERT INTO `ms_store_info` VALUES ('475','5','3',NULL,'56.0000','');
INSERT INTO `ms_store_info` VALUES ('476','5','4',NULL,'8.0000','');
INSERT INTO `ms_store_info` VALUES ('477','5','5',NULL,'114.0000','');
INSERT INTO `ms_store_info` VALUES ('478','5','8',NULL,'6.5100','');
INSERT INTO `ms_store_info` VALUES ('479','5','20',NULL,'3.5000','');
INSERT INTO `ms_store_info` VALUES ('442','3','22',NULL,'0.0000','57-75 мм');
INSERT INTO `ms_store_info` VALUES ('443','3','23','21','0.0000','');
INSERT INTO `ms_store_info` VALUES ('469','4','24',NULL,'0.0000','-2/+2');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_store_param`
--

DROP TABLE IF EXISTS `ms_store_param`;

CREATE TABLE `ms_store_param` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `store_id` int unsigned DEFAULT NULL,
  `param_id` int unsigned DEFAULT NULL,
  `value_id` int unsigned DEFAULT NULL,
  `value_name` char(255) NOT NULL DEFAULT '',
  `value_set_sum` decimal(10,2) NOT NULL DEFAULT '0.00',
  `value_curr_id` int unsigned DEFAULT NULL,
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `store_id` (`store_id`),
  KEY `param_id` (`param_id`),
  KEY `value_id` (`value_id`),
  KEY `store_value` (`store_id`,`value_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_store_param`
--

LOCK TABLES `ms_store_param` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_store_set`
--

DROP TABLE IF EXISTS `ms_store_set`;

CREATE TABLE `ms_store_set` (
  `id` int unsigned NOT NULL AUTO_INCREMENT,
  `store_id` int unsigned DEFAULT NULL,
  `obj_key` char(100) NOT NULL DEFAULT '',
  `kind_key` char(100) NOT NULL DEFAULT '',
  `elem_id` int unsigned DEFAULT NULL,
  `params` char(255) NOT NULL DEFAULT '',
  `comment` char(255) NOT NULL DEFAULT '',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `store_id` (`store_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_store_set`
--

LOCK TABLES `ms_store_set` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_tmp_client`
--

DROP TABLE IF EXISTS `ms_tmp_client`;

CREATE TABLE `ms_tmp_client` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `user_id` int unsigned DEFAULT NULL,
  UNIQUE KEY `user_id` (`user_id`,`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_tmp_client`
--

LOCK TABLES `ms_tmp_client` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_tmp_info`
--

DROP TABLE IF EXISTS `ms_tmp_info`;

CREATE TABLE `ms_tmp_info` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `user_id` int unsigned DEFAULT NULL,
  UNIQUE KEY `user_id` (`user_id`,`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_tmp_info`
--

LOCK TABLES `ms_tmp_info` WRITE;
INSERT INTO `ms_tmp_info` VALUES ('1','1');
INSERT INTO `ms_tmp_info` VALUES ('2','1');
INSERT INTO `ms_tmp_info` VALUES ('3','1');
INSERT INTO `ms_tmp_info` VALUES ('4','1');
INSERT INTO `ms_tmp_info` VALUES ('5','1');
INSERT INTO `ms_tmp_info` VALUES ('6','1');
INSERT INTO `ms_tmp_info` VALUES ('7','1');
INSERT INTO `ms_tmp_info` VALUES ('8','1');
INSERT INTO `ms_tmp_info` VALUES ('9','1');
INSERT INTO `ms_tmp_info` VALUES ('10','1');
INSERT INTO `ms_tmp_info` VALUES ('11','1');
INSERT INTO `ms_tmp_info` VALUES ('12','1');
INSERT INTO `ms_tmp_info` VALUES ('13','1');
INSERT INTO `ms_tmp_info` VALUES ('14','1');
INSERT INTO `ms_tmp_info` VALUES ('15','1');
INSERT INTO `ms_tmp_info` VALUES ('16','1');
INSERT INTO `ms_tmp_info` VALUES ('17','1');
INSERT INTO `ms_tmp_info` VALUES ('18','1');
INSERT INTO `ms_tmp_info` VALUES ('19','1');
INSERT INTO `ms_tmp_info` VALUES ('20','1');
INSERT INTO `ms_tmp_info` VALUES ('21','1');
INSERT INTO `ms_tmp_info` VALUES ('22','1');
INSERT INTO `ms_tmp_info` VALUES ('23','1');
INSERT INTO `ms_tmp_info` VALUES ('24','1');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_tmp_order_right`
--

DROP TABLE IF EXISTS `ms_tmp_order_right`;

CREATE TABLE `ms_tmp_order_right` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `user_id` int unsigned DEFAULT NULL,
  UNIQUE KEY `user_id` (`user_id`,`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_tmp_order_right`
--

LOCK TABLES `ms_tmp_order_right` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_tmp_orders`
--

DROP TABLE IF EXISTS `ms_tmp_orders`;

CREATE TABLE `ms_tmp_orders` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `user_id` int unsigned DEFAULT NULL,
  UNIQUE KEY `user_id` (`user_id`,`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_tmp_orders`
--

LOCK TABLES `ms_tmp_orders` WRITE;
INSERT INTO `ms_tmp_orders` VALUES ('1','1');
INSERT INTO `ms_tmp_orders` VALUES ('2','1');
INSERT INTO `ms_tmp_orders` VALUES ('3','1');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_tmp_self_key`
--

DROP TABLE IF EXISTS `ms_tmp_self_key`;

CREATE TABLE `ms_tmp_self_key` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `user_id` int unsigned DEFAULT NULL,
  UNIQUE KEY `user_id` (`user_id`,`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_tmp_self_key`
--

LOCK TABLES `ms_tmp_self_key` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_tmp_store`
--

DROP TABLE IF EXISTS `ms_tmp_store`;

CREATE TABLE `ms_tmp_store` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `user_id` int unsigned DEFAULT NULL,
  UNIQUE KEY `user_id` (`user_id`,`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_tmp_store`
--

LOCK TABLES `ms_tmp_store` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_tmp_store_comment`
--

DROP TABLE IF EXISTS `ms_tmp_store_comment`;

CREATE TABLE `ms_tmp_store_comment` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `user_id` int unsigned DEFAULT NULL,
  UNIQUE KEY `user_id` (`user_id`,`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_tmp_store_comment`
--

LOCK TABLES `ms_tmp_store_comment` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_tmp_topic`
--

DROP TABLE IF EXISTS `ms_tmp_topic`;

CREATE TABLE `ms_tmp_topic` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `user_id` int unsigned DEFAULT NULL,
  `access_exist` tinyint unsigned NOT NULL DEFAULT '0',
  UNIQUE KEY `user_id` (`user_id`,`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_tmp_topic`
--

LOCK TABLES `ms_tmp_topic` WRITE;
INSERT INTO `ms_tmp_topic` VALUES ('15','1','1');
INSERT INTO `ms_tmp_topic` VALUES ('14','1','1');
INSERT INTO `ms_tmp_topic` VALUES ('13','1','1');
INSERT INTO `ms_tmp_topic` VALUES ('20','1','1');
INSERT INTO `ms_tmp_topic` VALUES ('16','1','1');
INSERT INTO `ms_tmp_topic` VALUES ('17','1','1');
INSERT INTO `ms_tmp_topic` VALUES ('12','1','1');
INSERT INTO `ms_tmp_topic` VALUES ('11','1','1');
INSERT INTO `ms_tmp_topic` VALUES ('9','1','1');
INSERT INTO `ms_tmp_topic` VALUES ('6','1','1');
INSERT INTO `ms_tmp_topic` VALUES ('10','1','1');
INSERT INTO `ms_tmp_topic` VALUES ('19','1','1');
INSERT INTO `ms_tmp_topic` VALUES ('18','1','1');
INSERT INTO `ms_tmp_topic` VALUES ('4','1','1');
INSERT INTO `ms_tmp_topic` VALUES ('5','1','1');
INSERT INTO `ms_tmp_topic` VALUES ('3','1','1');
INSERT INTO `ms_tmp_topic` VALUES ('2','1','1');
INSERT INTO `ms_tmp_topic` VALUES ('1','1','1');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_tmp_trans`
--

DROP TABLE IF EXISTS `ms_tmp_trans`;

CREATE TABLE `ms_tmp_trans` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `user_id` int unsigned DEFAULT NULL,
  UNIQUE KEY `user_id` (`user_id`,`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_tmp_trans`
--

LOCK TABLES `ms_tmp_trans` WRITE;
INSERT INTO `ms_tmp_trans` VALUES ('11','1');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_tmp_web_key`
--

DROP TABLE IF EXISTS `ms_tmp_web_key`;

CREATE TABLE `ms_tmp_web_key` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `user_id` int unsigned DEFAULT NULL,
  `for_read` tinyint unsigned NOT NULL DEFAULT '0',
  `for_write` tinyint unsigned NOT NULL DEFAULT '0',
  `for_remove` tinyint unsigned NOT NULL DEFAULT '0',
  UNIQUE KEY `user_id` (`user_id`,`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_tmp_web_key`
--

LOCK TABLES `ms_tmp_web_key` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_topic`
--

DROP TABLE IF EXISTS `ms_topic`;

CREATE TABLE `ms_topic` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `intro` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `descr` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `tindex` int unsigned NOT NULL DEFAULT '0',
  `tlevel` int unsigned NOT NULL DEFAULT '0',
  `absindex` int unsigned NOT NULL DEFAULT '0',
  `no_visible` tinyint unsigned NOT NULL DEFAULT '0',
  `kind_key` char(100) NOT NULL DEFAULT '',
  `link` char(255) NOT NULL DEFAULT '',
  `seo_psu` char(255) NOT NULL DEFAULT '',
  `seo_title` char(255) NOT NULL DEFAULT '',
  `in_xml` tinyint unsigned NOT NULL DEFAULT '0',
  `templ_key` char(100) NOT NULL DEFAULT '',
  `order_key` char(100) NOT NULL DEFAULT '',
  `order_asc` tinyint unsigned NOT NULL DEFAULT '0',
  `option_code` text NOT NULL DEFAULT (_utf8mb3''),
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_topic`
--

LOCK TABLES `ms_topic` WRITE;
INSERT INTO `ms_topic` VALUES ('22','','National Geographic','','','4','4','7','1','kGoods','','','','1','kDefault','kDefault','0','');
INSERT INTO `ms_topic` VALUES ('23','','Bresser','','','10','4','9','1','kGoods','','','','1','kDefault','kDefault','0','');
INSERT INTO `ms_topic` VALUES ('24','','National Geographic','','','10','4','10','1','kGoods','','','','1','kDefault','kDefault','0','');
INSERT INTO `ms_topic` VALUES ('21','','Погодные станции','','','6','3','14','0','kGoods','','/weather/station/','fas fa-umbrella','1','kDefault','kDefault','0','');
INSERT INTO `ms_topic` VALUES ('20','','Правила','','','12','3','18','0','kText','','/shop/rules/','fas fa-book-open','1','kDefault','kDefault','0','');
INSERT INTO `ms_topic` VALUES ('14','','Telegram','','','13','3','20','0','kLink','https://telegram.org/','','fa-brands fa-telegram','1','kDefault','kDefault','0','');
INSERT INTO `ms_topic` VALUES ('15','','YouTube','','','13','3','21','0','kLink','https://youtube.com','','fa-brands fa-youtube','1','kDefault','kDefault','0','');
INSERT INTO `ms_topic` VALUES ('16','','Доставка','','','12','3','17','0','kText','','/shop/delivery/','fas fa-truck','1','kDefault','kDefault','0','');
INSERT INTO `ms_topic` VALUES ('17','','Оплата','','','12','3','16','0','kText','','/shop/payment/','fas fa-money-check-dollar','1','kDefault','kDefault','0','');
INSERT INTO `ms_topic` VALUES ('18','','Arsenal','','','4','4','5','0','kGoods','','/optic/binoculars/arsenal/','','1','kDefault','kDefault','0','');
INSERT INTO `ms_topic` VALUES ('19','','Bresser','','','4','4','6','0','kGoods','','/optic/binoculars/bresser/','','1','kDefault','kDefault','0','');
INSERT INTO `ms_topic` VALUES ('13','','О компании','','','2','2','19','0','kText','','','fas fa-award','1','kDefault','kDefault','0','');
INSERT INTO `ms_topic` VALUES ('11','','Подзорные трубы','','','5','3','11','0','kGoods','','/optic/spyglass/','fas fa-bullseye','1','kDefault','kDefault','0','');
INSERT INTO `ms_topic` VALUES ('12','','Покупателю','','','2','2','15','0','kText','','/shop/','fas fa-basket-shopping','1','kDefault','kDefault','0','');
INSERT INTO `ms_topic` VALUES ('1','','Основа','','','0','0','0','0','kFirst','','','','0','kDefault','kDefault','0','');
INSERT INTO `ms_topic` VALUES ('2','CATALOG','Магазин','','','1','1','1','0','kText','','','','1','kDefault','kDefault','0','');
INSERT INTO `ms_topic` VALUES ('3','','Начало','','','2','2','2','0','kText','','/','fas fa-flag','1','kDefault','kDefault','0','');
INSERT INTO `ms_topic` VALUES ('4','','Бинокли','','','5','3','4','0','kGoods','','/optic/binoculars/','fas fa-binoculars','1','kDefault','kDefault','0','');
INSERT INTO `ms_topic` VALUES ('10','','Микроскопы','','','5','3','8','0','kGoods','','/optic/microscope/','fas fa-microscope','1','kDefault','kDefault','0','');
INSERT INTO `ms_topic` VALUES ('9','','Метеостанции','','','6','3','13','0','kGoods','','/weather/meteo/','fas fa-cloud','1','kDefault','kDefault','0','');
INSERT INTO `ms_topic` VALUES ('6','','Погода','','','2','2','12','0','kGoods','','','fas fa-ranking-star','1','kDefault','kDefault','0','');
INSERT INTO `ms_topic` VALUES ('5','','Оптика','','','2','2','3','0','kGoods','','','fas fa-eye','1','kDefault','kDefault','0','');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_topic_alt`
--

DROP TABLE IF EXISTS `ms_topic_alt`;

CREATE TABLE `ms_topic_alt` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `kind_key` char(100) NOT NULL DEFAULT '',
  `topic_id` int unsigned DEFAULT NULL,
  `name` char(255) NOT NULL DEFAULT '',
  `tindex` int unsigned NOT NULL DEFAULT '0',
  `tlevel` int unsigned NOT NULL DEFAULT '0',
  `absindex` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `kind_key` (`kind_key`(10))
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_topic_alt`
--

LOCK TABLES `ms_topic_alt` WRITE;
INSERT INTO `ms_topic_alt` VALUES ('10','kCenter','9','Метеостанции','0','0','3');
INSERT INTO `ms_topic_alt` VALUES ('9','kCenter','11','Подзорные трубы','0','0','2');
INSERT INTO `ms_topic_alt` VALUES ('6','kCenter','10','Микроскопы','0','0','1');
INSERT INTO `ms_topic_alt` VALUES ('5','kCenter','4','Бинокли','0','0','0');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_topic_filter`
--

DROP TABLE IF EXISTS `ms_topic_filter`;

CREATE TABLE `ms_topic_filter` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `topic_id` int unsigned DEFAULT NULL,
  `info_id` int unsigned DEFAULT NULL,
  `name` char(255) NOT NULL DEFAULT '',
  `kind_key` char(100) NOT NULL DEFAULT '',
  `use_sub_topic` tinyint unsigned NOT NULL DEFAULT '0',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `topic_id` (`topic_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_topic_filter`
--

LOCK TABLES `ms_topic_filter` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_topic_key`
--

DROP TABLE IF EXISTS `ms_topic_key`;

CREATE TABLE `ms_topic_key` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `tindex` int unsigned NOT NULL DEFAULT '0',
  `tlevel` int unsigned NOT NULL DEFAULT '0',
  `absindex` int unsigned NOT NULL DEFAULT '0',
  `folder` tinyint unsigned NOT NULL DEFAULT '0',
  `descr` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `mask_edit` char(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_topic_key`
--

LOCK TABLES `ms_topic_key` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_topic_key_set`
--

DROP TABLE IF EXISTS `ms_topic_key_set`;

CREATE TABLE `ms_topic_key_set` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `topic_id` int unsigned DEFAULT NULL,
  `key_id` int unsigned DEFAULT NULL,
  `value_id` int unsigned DEFAULT NULL,
  `value_txt` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  PRIMARY KEY (`id`),
  KEY `topic_id` (`topic_id`),
  KEY `key_id` (`key_id`),
  KEY `value_id` (`value_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_topic_key_set`
--

LOCK TABLES `ms_topic_key_set` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_topic_key_value`
--

DROP TABLE IF EXISTS `ms_topic_key_value`;

CREATE TABLE `ms_topic_key_value` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `key_id` int unsigned DEFAULT NULL,
  `name` char(255) NOT NULL DEFAULT '',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `key_id` (`key_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_topic_key_value`
--

LOCK TABLES `ms_topic_key_value` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_topic_right`
--

DROP TABLE IF EXISTS `ms_topic_right`;

CREATE TABLE `ms_topic_right` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `topic_id` int unsigned DEFAULT NULL,
  `user_id` int unsigned DEFAULT NULL,
  `group_id` int unsigned DEFAULT NULL,
  `for_frame` tinyint unsigned NOT NULL DEFAULT '0',
  `for_price` tinyint unsigned NOT NULL DEFAULT '0',
  `for_ctrl` tinyint unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `topic_id` (`topic_id`),
  KEY `user_id` (`user_id`),
  KEY `group_id` (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_topic_right`
--

LOCK TABLES `ms_topic_right` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_topic_store`
--

DROP TABLE IF EXISTS `ms_topic_store`;

CREATE TABLE `ms_topic_store` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `topic_id` int unsigned DEFAULT NULL,
  `store_id` int unsigned DEFAULT NULL,
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `topic_id` (`topic_id`),
  KEY `store_id` (`store_id`),
  KEY `topic_store` (`topic_id`,`store_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_topic_store`
--

LOCK TABLES `ms_topic_store` WRITE;
INSERT INTO `ms_topic_store` VALUES ('1','3','1','1');
INSERT INTO `ms_topic_store` VALUES ('2','18','2','1');
INSERT INTO `ms_topic_store` VALUES ('3','18','3','2');
INSERT INTO `ms_topic_store` VALUES ('4','19','4','38');
INSERT INTO `ms_topic_store` VALUES ('5','19','5','39');
INSERT INTO `ms_topic_store` VALUES ('6','17','6','6');
INSERT INTO `ms_topic_store` VALUES ('7','16','7','7');
INSERT INTO `ms_topic_store` VALUES ('8','20','8','8');
INSERT INTO `ms_topic_store` VALUES ('1233','21','1233','15');
INSERT INTO `ms_topic_store` VALUES ('1232','21','1232','14');
INSERT INTO `ms_topic_store` VALUES ('1231','21','1231','13');
INSERT INTO `ms_topic_store` VALUES ('1230','21','1230','12');
INSERT INTO `ms_topic_store` VALUES ('1229','21','1229','11');
INSERT INTO `ms_topic_store` VALUES ('1228','21','1228','10');
INSERT INTO `ms_topic_store` VALUES ('1227','21','1227','9');
INSERT INTO `ms_topic_store` VALUES ('1226','21','1226','8');
INSERT INTO `ms_topic_store` VALUES ('1225','21','1225','7');
INSERT INTO `ms_topic_store` VALUES ('1224','21','1224','6');
INSERT INTO `ms_topic_store` VALUES ('1223','21','1223','5');
INSERT INTO `ms_topic_store` VALUES ('1222','21','1222','4');
INSERT INTO `ms_topic_store` VALUES ('1221','21','1221','3');
INSERT INTO `ms_topic_store` VALUES ('1220','21','1220','2');
INSERT INTO `ms_topic_store` VALUES ('1219','21','1219','1');
INSERT INTO `ms_topic_store` VALUES ('1218','9','1218','26');
INSERT INTO `ms_topic_store` VALUES ('1217','9','1217','25');
INSERT INTO `ms_topic_store` VALUES ('1216','9','1216','24');
INSERT INTO `ms_topic_store` VALUES ('1215','9','1215','23');
INSERT INTO `ms_topic_store` VALUES ('1214','9','1214','22');
INSERT INTO `ms_topic_store` VALUES ('1213','9','1213','21');
INSERT INTO `ms_topic_store` VALUES ('1212','9','1212','17');
INSERT INTO `ms_topic_store` VALUES ('1211','9','1211','20');
INSERT INTO `ms_topic_store` VALUES ('1210','9','1210','19');
INSERT INTO `ms_topic_store` VALUES ('1209','9','1209','18');
INSERT INTO `ms_topic_store` VALUES ('1208','9','1208','16');
INSERT INTO `ms_topic_store` VALUES ('1207','9','1207','15');
INSERT INTO `ms_topic_store` VALUES ('1206','9','1206','14');
INSERT INTO `ms_topic_store` VALUES ('1205','9','1205','13');
INSERT INTO `ms_topic_store` VALUES ('1204','9','1204','12');
INSERT INTO `ms_topic_store` VALUES ('1203','9','1203','11');
INSERT INTO `ms_topic_store` VALUES ('1202','9','1202','10');
INSERT INTO `ms_topic_store` VALUES ('1201','9','1201','9');
INSERT INTO `ms_topic_store` VALUES ('1200','9','1200','8');
INSERT INTO `ms_topic_store` VALUES ('1199','9','1199','7');
INSERT INTO `ms_topic_store` VALUES ('1198','9','1198','6');
INSERT INTO `ms_topic_store` VALUES ('1197','9','1197','5');
INSERT INTO `ms_topic_store` VALUES ('1196','9','1196','4');
INSERT INTO `ms_topic_store` VALUES ('1195','9','1195','3');
INSERT INTO `ms_topic_store` VALUES ('1194','9','1194','2');
INSERT INTO `ms_topic_store` VALUES ('1193','9','1193','1');
INSERT INTO `ms_topic_store` VALUES ('1186','24','1186','6');
INSERT INTO `ms_topic_store` VALUES ('1185','24','1185','5');
INSERT INTO `ms_topic_store` VALUES ('1184','24','1184','4');
INSERT INTO `ms_topic_store` VALUES ('1183','24','1183','2');
INSERT INTO `ms_topic_store` VALUES ('1182','24','1182','1');
INSERT INTO `ms_topic_store` VALUES ('1181','24','1181','3');
INSERT INTO `ms_topic_store` VALUES ('1180','23','1180','16');
INSERT INTO `ms_topic_store` VALUES ('1179','23','1179','15');
INSERT INTO `ms_topic_store` VALUES ('1178','23','1178','14');
INSERT INTO `ms_topic_store` VALUES ('1177','23','1177','13');
INSERT INTO `ms_topic_store` VALUES ('1176','23','1176','10');
INSERT INTO `ms_topic_store` VALUES ('1175','23','1175','12');
INSERT INTO `ms_topic_store` VALUES ('1174','23','1174','11');
INSERT INTO `ms_topic_store` VALUES ('1173','23','1173','9');
INSERT INTO `ms_topic_store` VALUES ('1172','23','1172','8');
INSERT INTO `ms_topic_store` VALUES ('1171','23','1171','7');
INSERT INTO `ms_topic_store` VALUES ('1170','23','1170','6');
INSERT INTO `ms_topic_store` VALUES ('1169','23','1169','5');
INSERT INTO `ms_topic_store` VALUES ('1168','23','1168','4');
INSERT INTO `ms_topic_store` VALUES ('1167','23','1167','3');
INSERT INTO `ms_topic_store` VALUES ('1166','23','1166','2');
INSERT INTO `ms_topic_store` VALUES ('1165','23','1165','1');
INSERT INTO `ms_topic_store` VALUES ('1164','11','1164','6');
INSERT INTO `ms_topic_store` VALUES ('1163','11','1163','5');
INSERT INTO `ms_topic_store` VALUES ('1162','11','1162','4');
INSERT INTO `ms_topic_store` VALUES ('1161','11','1161','3');
INSERT INTO `ms_topic_store` VALUES ('1160','11','1160','2');
INSERT INTO `ms_topic_store` VALUES ('1159','11','1159','1');
INSERT INTO `ms_topic_store` VALUES ('1153','22','1153','2');
INSERT INTO `ms_topic_store` VALUES ('1152','22','1152','8');
INSERT INTO `ms_topic_store` VALUES ('1151','22','1151','7');
INSERT INTO `ms_topic_store` VALUES ('1150','22','1150','5');
INSERT INTO `ms_topic_store` VALUES ('1149','22','1149','3');
INSERT INTO `ms_topic_store` VALUES ('1148','22','1148','4');
INSERT INTO `ms_topic_store` VALUES ('1147','22','1147','1');
INSERT INTO `ms_topic_store` VALUES ('1146','22','1146','6');
INSERT INTO `ms_topic_store` VALUES ('1145','19','1145','35');
INSERT INTO `ms_topic_store` VALUES ('1144','19','1144','34');
INSERT INTO `ms_topic_store` VALUES ('1143','19','1143','32');
INSERT INTO `ms_topic_store` VALUES ('1142','19','1142','36');
INSERT INTO `ms_topic_store` VALUES ('1141','19','1141','33');
INSERT INTO `ms_topic_store` VALUES ('1140','19','1140','31');
INSERT INTO `ms_topic_store` VALUES ('1139','19','1139','37');
INSERT INTO `ms_topic_store` VALUES ('1138','19','1138','30');
INSERT INTO `ms_topic_store` VALUES ('1137','19','1137','29');
INSERT INTO `ms_topic_store` VALUES ('1136','19','1136','23');
INSERT INTO `ms_topic_store` VALUES ('1135','19','1135','24');
INSERT INTO `ms_topic_store` VALUES ('1134','19','1134','25');
INSERT INTO `ms_topic_store` VALUES ('1133','19','1133','26');
INSERT INTO `ms_topic_store` VALUES ('1132','19','1132','28');
INSERT INTO `ms_topic_store` VALUES ('1131','19','1131','27');
INSERT INTO `ms_topic_store` VALUES ('1130','19','1130','21');
INSERT INTO `ms_topic_store` VALUES ('1129','19','1129','22');
INSERT INTO `ms_topic_store` VALUES ('1128','19','1128','20');
INSERT INTO `ms_topic_store` VALUES ('1127','19','1127','17');
INSERT INTO `ms_topic_store` VALUES ('1126','19','1126','15');
INSERT INTO `ms_topic_store` VALUES ('1125','19','1125','14');
INSERT INTO `ms_topic_store` VALUES ('1124','19','1124','13');
INSERT INTO `ms_topic_store` VALUES ('1123','19','1123','16');
INSERT INTO `ms_topic_store` VALUES ('1122','19','1122','19');
INSERT INTO `ms_topic_store` VALUES ('1121','19','1121','12');
INSERT INTO `ms_topic_store` VALUES ('1120','19','1120','18');
INSERT INTO `ms_topic_store` VALUES ('1119','19','1119','9');
INSERT INTO `ms_topic_store` VALUES ('1118','19','1118','10');
INSERT INTO `ms_topic_store` VALUES ('1117','19','1117','8');
INSERT INTO `ms_topic_store` VALUES ('1116','19','1116','11');
INSERT INTO `ms_topic_store` VALUES ('1115','19','1115','4');
INSERT INTO `ms_topic_store` VALUES ('1114','19','1114','3');
INSERT INTO `ms_topic_store` VALUES ('1113','19','1113','7');
INSERT INTO `ms_topic_store` VALUES ('1112','19','1112','6');
INSERT INTO `ms_topic_store` VALUES ('1111','19','1111','2');
INSERT INTO `ms_topic_store` VALUES ('1110','19','1110','5');
INSERT INTO `ms_topic_store` VALUES ('1109','19','1109','1');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_trans`
--

DROP TABLE IF EXISTS `ms_trans`;

CREATE TABLE `ms_trans` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `tindex` int unsigned NOT NULL DEFAULT '0',
  `tlevel` int unsigned NOT NULL DEFAULT '0',
  `absindex` int unsigned NOT NULL DEFAULT '0',
  `folder` tinyint unsigned NOT NULL DEFAULT '0',
  `kind_key` char(100) NOT NULL DEFAULT '',
  `table_key` char(32) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_trans`
--

LOCK TABLES `ms_trans` WRITE;
INSERT INTO `ms_trans` VALUES ('30','','STORE_IMAGE','1','1','4','0','kDefault','kTag');
INSERT INTO `ms_trans` VALUES ('29','VALUE','Значение','22','3','23','0','kDefault','kClient');
INSERT INTO `ms_trans` VALUES ('28','VALUE','Значение','25','3','26','0','kDefault','kOption');
INSERT INTO `ms_trans` VALUES ('27','FIELD','Поле','25','3','25','0','kDefault','kOption');
INSERT INTO `ms_trans` VALUES ('25','','Опции','24','2','24','1','kDefault','kDefault');
INSERT INTO `ms_trans` VALUES ('24','','Заказ','21','1','20','0','kDefault','kDefault');
INSERT INTO `ms_trans` VALUES ('23','FIELD','Поле','22','3','22','0','kDefault','kClient');
INSERT INTO `ms_trans` VALUES ('22','','Покупатель','24','2','21','1','kDefault','kDefault');
INSERT INTO `ms_trans` VALUES ('21','','Структура','0','0','7','1','kDefault','kDefault');
INSERT INTO `ms_trans` VALUES ('20','','BASKET_GOODS','1','1','6','0','kDefault','kTag');
INSERT INTO `ms_trans` VALUES ('18','TEXT','Текст','17','2','19','0','kDefault','kInfo');
INSERT INTO `ms_trans` VALUES ('17','','Характеристики','21','1','16','1','kDefault','kDefault');
INSERT INTO `ms_trans` VALUES ('16','VALUE','Значение','17','2','18','0','kDefault','kInfo');
INSERT INTO `ms_trans` VALUES ('15','NAME','Название','17','2','17','0','kDefault','kInfo');
INSERT INTO `ms_trans` VALUES ('14','','STORE_CARD','1','1','3','0','kDefault','kTag');
INSERT INTO `ms_trans` VALUES ('13','','STATUS','10','2','15','0','kDefault','kTag');
INSERT INTO `ms_trans` VALUES ('12','INTRO','Введение','10','2','14','0','kDefault','kStore');
INSERT INTO `ms_trans` VALUES ('11','NAME','Название','10','2','13','0','kDefault','kStore');
INSERT INTO `ms_trans` VALUES ('10','','Товары','21','1','12','1','kDefault','kDefault');
INSERT INTO `ms_trans` VALUES ('9','','BASE_FOOTER','1','1','2','0','kDefault','kTag');
INSERT INTO `ms_trans` VALUES ('8','','BASE_HEADER','1','1','1','0','kDefault','kTag');
INSERT INTO `ms_trans` VALUES ('7','DESCR','Содержимое','3','2','11','0','kDefault','kTopic');
INSERT INTO `ms_trans` VALUES ('5','TITLE','Заголовок','3','2','10','0','kDefault','kTopic');
INSERT INTO `ms_trans` VALUES ('4','NAME','Название','3','2','9','0','kDefault','kTopic');
INSERT INTO `ms_trans` VALUES ('3','','Каталог','21','1','8','1','kDefault','kDefault');
INSERT INTO `ms_trans` VALUES ('2','','BASE_PAGE','1','1','5','0','kDefault','kTag');
INSERT INTO `ms_trans` VALUES ('1','','Модули','0','0','0','1','kDefault','kDefault');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_trans_lang`
--

DROP TABLE IF EXISTS `ms_trans_lang`;

CREATE TABLE `ms_trans_lang` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `lang_id` int unsigned DEFAULT NULL,
  `trans_id` int unsigned DEFAULT NULL,
  `origin_id` int unsigned DEFAULT NULL,
  `translate` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `is_approve` tinyint unsigned NOT NULL DEFAULT '0',
  `is_error` tinyint unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `lang_id` (`lang_id`),
  KEY `trans_id` (`trans_id`),
  KEY `origin_id` (`origin_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_trans_lang`
--

LOCK TABLES `ms_trans_lang` WRITE;
INSERT INTO `ms_trans_lang` VALUES ('1','3','8','9','.Demo','0','0');
INSERT INTO `ms_trans_lang` VALUES ('2','3','4','27','Bresser','0','0');
INSERT INTO `ms_trans_lang` VALUES ('3','3','4','26','Arsenal','0','0');
INSERT INTO `ms_trans_lang` VALUES ('4','3','4','25','YouTube','0','0');
INSERT INTO `ms_trans_lang` VALUES ('5','3','4','24','Telegram','0','0');
INSERT INTO `ms_trans_lang` VALUES ('6','3','4','15','Weather','0','0');
INSERT INTO `ms_trans_lang` VALUES ('7','3','8','7','Melbis Shop','0','0');
INSERT INTO `ms_trans_lang` VALUES ('8','3','4','12','Beginning','0','0');
INSERT INTO `ms_trans_lang` VALUES ('9','3','4','14','Optics','0','0');
INSERT INTO `ms_trans_lang` VALUES ('10','3','4','21','Payment','0','0');
INSERT INTO `ms_trans_lang` VALUES ('11','2','8','9','.Demo','0','0');
INSERT INTO `ms_trans_lang` VALUES ('12','2','4','27','Bresser','0','0');
INSERT INTO `ms_trans_lang` VALUES ('13','2','4','26','Арсенал','0','0');
INSERT INTO `ms_trans_lang` VALUES ('14','2','4','25','YouTube','0','0');
INSERT INTO `ms_trans_lang` VALUES ('15','2','4','24','Telegram','0','0');
INSERT INTO `ms_trans_lang` VALUES ('16','2','4','15','Погода','0','0');
INSERT INTO `ms_trans_lang` VALUES ('17','2','8','7','Melbis Shop','0','0');
INSERT INTO `ms_trans_lang` VALUES ('18','2','4','14','Оптика','0','0');
INSERT INTO `ms_trans_lang` VALUES ('19','2','4','21','Оплата','0','0');
INSERT INTO `ms_trans_lang` VALUES ('20','2','4','12','Початок','0','0');
INSERT INTO `ms_trans_lang` VALUES ('21','3','8','11','Shopping cart','0','0');
INSERT INTO `ms_trans_lang` VALUES ('22','3','4','13','Binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('23','3','4','23','Rules','0','0');
INSERT INTO `ms_trans_lang` VALUES ('24','3','2','1','ERROR 404','0','0');
INSERT INTO `ms_trans_lang` VALUES ('25','3','9','8','Melbis Shop Demo','0','0');
INSERT INTO `ms_trans_lang` VALUES ('26','3','4','22','Delivery','0','0');
INSERT INTO `ms_trans_lang` VALUES ('27','3','4','19','Meteorological stations','0','0');
INSERT INTO `ms_trans_lang` VALUES ('28','3','4','17','About the company','0','0');
INSERT INTO `ms_trans_lang` VALUES ('29','3','4','16','To the buyer','0','0');
INSERT INTO `ms_trans_lang` VALUES ('30','3','4','18','Microscopes','0','0');
INSERT INTO `ms_trans_lang` VALUES ('31','2','8','11','Кошик','0','0');
INSERT INTO `ms_trans_lang` VALUES ('32','2','4','13','Біноклі','0','0');
INSERT INTO `ms_trans_lang` VALUES ('33','2','4','23','Правила','0','0');
INSERT INTO `ms_trans_lang` VALUES ('34','2','2','1','ПОМИЛКА 404','0','0');
INSERT INTO `ms_trans_lang` VALUES ('35','2','9','8','Демонстрація магазину Melbis Shop','0','0');
INSERT INTO `ms_trans_lang` VALUES ('36','2','4','22','Доставка','0','0');
INSERT INTO `ms_trans_lang` VALUES ('37','2','4','19','Метеостанції','0','0');
INSERT INTO `ms_trans_lang` VALUES ('38','2','4','17','Про компанію','0','0');
INSERT INTO `ms_trans_lang` VALUES ('39','2','4','16','Покупцеві','0','0');
INSERT INTO `ms_trans_lang` VALUES ('40','2','4','18','Мікроскопи','0','0');
INSERT INTO `ms_trans_lang` VALUES ('41','3','4','20','Spyglasses','0','0');
INSERT INTO `ms_trans_lang` VALUES ('42','3','2','2','404 error: page not found!','0','0');
INSERT INTO `ms_trans_lang` VALUES ('57','3','5','28','Payment in store','0','0');
INSERT INTO `ms_trans_lang` VALUES ('44','3','5','4','Melbis Shop demo store','0','0');
INSERT INTO `ms_trans_lang` VALUES ('45','3','2','3','REQUESTED PAGE NOT FOUND','0','0');
INSERT INTO `ms_trans_lang` VALUES ('46','3','8','10','Demonstration <b>Melbis Shop 6</b>','0','0');
INSERT INTO `ms_trans_lang` VALUES ('47','3','7','5','            <div class=\"jumbotron\">
                <div class=\"row\">
                    <div class=\"col-lg-4 text-center\">
                        <img class=\"img-fluid rounded border\" src=\"files/2025/03_29/14_38/u_files_store_1_1.png\">
                    </div>
                    <div class=\"col-lg-8\">
                        <h1 class=\"display-4\">Welcome to Melbis Shop 6!</h1>
                        <p class=\"lead\">This is a simple script to demonstrate basic functionality. The minimal functionality is intended to reveal different aspects of scripting and data processing without too much complexity.</p>
                       <hr class=\"my-4\">
                        <p>Melbis Shop is an intelligent software for creating online catalogs, online stores, any website that needs a content management system.</p>
                       <a class=\"btn btn-info btn-lg float-right\" href=\"https://melbis.com\">Post melbis.com.</a></div></div></div>{MELBIS:melbis_cataloge_center([MS:VAR:LANG])} {MELBIS:melbis_store_random(8)}','0','0');
INSERT INTO `ms_trans_lang` VALUES ('48','2','4','20','Підзорні труби','0','0');
INSERT INTO `ms_trans_lang` VALUES ('49','2','2','2','404 помилка: сторінка не знайдена!','0','0');
INSERT INTO `ms_trans_lang` VALUES ('55','3','13','35','Absent','0','0');
INSERT INTO `ms_trans_lang` VALUES ('56','3','13','34','In stock','0','0');
INSERT INTO `ms_trans_lang` VALUES ('51','2','5','4','Демонстраційний магазин Melbis Shop','0','0');
INSERT INTO `ms_trans_lang` VALUES ('52','2','2','3','ЗАПИТУВАНА СТОРІНКА НЕ ЗНАЙДЕНА','0','0');
INSERT INTO `ms_trans_lang` VALUES ('53','2','8','10','Демонстраційний магазин <b>Melbis Shop 6</b>','0','0');
INSERT INTO `ms_trans_lang` VALUES ('54','2','7','5','            <div class=\"jumbotron\">
                <div class=\"row\">
                    <div class=\"col-lg-4 text-center\">
                        <img class=\"img-fluid rounded border\" src=\"files/2025/03_29/14_38/u_files_store_1_1.png\">
                    </div>
                    <div class=\"col-lg-8\">
                        <h1 class=\"display-4\">Вітаємо в Melbis Shop 6!</h1>
                        <p class=\"lead\">Це простий скрипт для демонстрації базового функціоналу. Мінімальний функціонал покликаний без зайвих складнощів розкрити різні аспекти написання скриптів і обробки даних.</p>
                       <hr class=\"my-4\">
                        <p>Melbis Shop - це інтелектуальне програмне забезпечення для створення онлайн-каталогів, інтернет-магазинів, будь-яких сайтів, які потребують системи управління контентом.</p>
                       <a class=\"btn btn-info btn-lg float-right\" href=\"https://melbis.com\">Постіть melbis.com</a></div></div></div>{MELBIS:melbis_cataloge_center([MS:VAR:LANG])} {MELBIS:melbis_store_random(8)}','0','0');
INSERT INTO `ms_trans_lang` VALUES ('58','3','11','40','Binoculars Arsenal 10x50 Porro','0','0');
INSERT INTO `ms_trans_lang` VALUES ('59','3','11','42','Binoculars Arsenal 10x42 ED (bw15)','0','0');
INSERT INTO `ms_trans_lang` VALUES ('60','3','11','38','Bresser Pirsch 8x56 UR WP binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('61','3','11','36','Bresser Corvette II 7x50 WP binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('62','3','5','30','Delivery methods in the store','0','0');
INSERT INTO `ms_trans_lang` VALUES ('63','3','5','32','Purchase and return policy','0','0');
INSERT INTO `ms_trans_lang` VALUES ('64','3','7','29','<h1 class=\"display-4 border-bottom\">Payment in the store</h1><div>The page with information about payment in the store.</div><div><br></div>','0','0');
INSERT INTO `ms_trans_lang` VALUES ('65','2','13','35','Відсутня','0','0');
INSERT INTO `ms_trans_lang` VALUES ('66','2','13','34','Є на складі','0','0');
INSERT INTO `ms_trans_lang` VALUES ('67','2','5','28','Оплата в магазині','0','0');
INSERT INTO `ms_trans_lang` VALUES ('68','2','11','40','Бінокль Arsenal 10x50 Porro','0','0');
INSERT INTO `ms_trans_lang` VALUES ('69','2','11','42','Бінокль Arsenal 10x42 ED (bw15)','0','0');
INSERT INTO `ms_trans_lang` VALUES ('94','2','11','36','Бінокль Bresser Corvette II 7x50 WP Bresser Corvette II 7x50 WP','0','0');
INSERT INTO `ms_trans_lang` VALUES ('93','2','11','38','Бінокль Bresser Pirsch 8x56 UR WP Bresser Pirsch 8x56 UR WP','0','0');
INSERT INTO `ms_trans_lang` VALUES ('72','2','5','30','Способи доставки в магазині','0','0');
INSERT INTO `ms_trans_lang` VALUES ('73','2','5','32','Правила купівлі та повернення товару','0','0');
INSERT INTO `ms_trans_lang` VALUES ('74','2','7','29','<h1 class=\"display-4 border-bottom\">Оплата в магазині</h1><div>Сторінка з інформацією про оплату в магазині.</div><div><br></div>','0','0');
INSERT INTO `ms_trans_lang` VALUES ('75','3','7','33','<h1 class=\"display-4 border-bottom\">Store rules</h1><div>The page with the rules of purchase in the store.</div><div><br></div>','0','0');
INSERT INTO `ms_trans_lang` VALUES ('76','3','7','31','<h1 class=\"display-4 border-bottom\">Delivery methods in the store</h1><div>Page with information about possible payment methods in the store.</div><div><br></div>','0','0');
INSERT INTO `ms_trans_lang` VALUES ('77','3','12','43','Thanks to high-quality optics made of ED-glass and a good ratio of diameter and magnification, the binoculars give very good image quality, both in the daytime and at dusk.','0','0');
INSERT INTO `ms_trans_lang` VALUES ('78','3','12','39','The Bresser Pirsch 8x56 binoculars are perfect for observing objects in low light conditions and at dusk, including low-light astronomical objects.','0','0');
INSERT INTO `ms_trans_lang` VALUES ('79','3','12','41','ARSENAL binoculars with a classic magnification of 10x will be an excellent instrument for almost any observation - field and astronomical, ornithological and naturalistic. It is also suitable for fishing and hunting.','0','0');
INSERT INTO `ms_trans_lang` VALUES ('80','3','12','37','The Bresser Corvette II 7x50 WP is a fast binocular for use in low light conditions. It is perfect for observing the world around you: birds, nature, sporting events, astronomical observation.','0','0');
INSERT INTO `ms_trans_lang` VALUES ('81','2','7','33','<h1 class=\"display-4 border-bottom\">Правила купівлі в магазині</h1><div>Сторінка з правилами купівлі в магазині.</div><div><br></div>','0','0');
INSERT INTO `ms_trans_lang` VALUES ('82','2','7','31','<h1 class=\"display-4 border-bottom\">Способи доставки в магазині</h1><div>Сторінка з інформацією про можливі способи оплати в магазині.</div><div><br></div>','0','0');
INSERT INTO `ms_trans_lang` VALUES ('83','2','12','43','Завдяки якісній оптиці з ED-скла і вдалому співвідношенню діаметра і кратності, бінокль дає дуже хорошу якість зображення, як вдень так і в сутінках.','0','0');
INSERT INTO `ms_trans_lang` VALUES ('84','2','12','39','Бінокль Bresser Pirsch 8x56 чудово підійде для спостережень за об\'єктами в умовах поганого освітлення та в сутінках, зокрема астрономічними об\'єктами, які слабко світяться.','0','0');
INSERT INTO `ms_trans_lang` VALUES ('85','2','12','41','Бінокль ARSENAL з класичним збільшенням 10х буде чудовим приладом практично для будь-яких спостережень - польових і астрономічних, орнітологічних і натуралістичних. Підійде він і для риболовлі, і полювання.','0','0');
INSERT INTO `ms_trans_lang` VALUES ('86','2','12','37','Bresser Corvette II 7x50 WP світлосильний бінокль для застосування в умовах низької освітленості. Він чудово підходить для спостережень за навколишнім світом: птахами, природою, спортивними змаганнями, для оглядових астрономічних спостережень.','0','0');
INSERT INTO `ms_trans_lang` VALUES ('87','3','14','46','Item','0','0');
INSERT INTO `ms_trans_lang` VALUES ('88','3','14','45','Updated','0','0');
INSERT INTO `ms_trans_lang` VALUES ('89','3','14','44','In the cart','0','0');
INSERT INTO `ms_trans_lang` VALUES ('90','2','14','46','Артикул','0','0');
INSERT INTO `ms_trans_lang` VALUES ('91','2','14','45','Оновлено','0','0');
INSERT INTO `ms_trans_lang` VALUES ('92','2','14','44','У кошик','0','0');
INSERT INTO `ms_trans_lang` VALUES ('95','3','18','90','+/-4','0','0');
INSERT INTO `ms_trans_lang` VALUES ('96','3','16','70','Roof','0','0');
INSERT INTO `ms_trans_lang` VALUES ('97','3','18','91','-2/+2','0','0');
INSERT INTO `ms_trans_lang` VALUES ('98','3','16','82','Porro','0','0');
INSERT INTO `ms_trans_lang` VALUES ('99','3','15','71','Type','0','0');
INSERT INTO `ms_trans_lang` VALUES ('100','3','15','66','Series','0','0');
INSERT INTO `ms_trans_lang` VALUES ('101','3','16','65','Arsenal BW','0','0');
INSERT INTO `ms_trans_lang` VALUES ('102','3','15','76','Glasses','0','0');
INSERT INTO `ms_trans_lang` VALUES ('103','3','15','80','Defense','0','0');
INSERT INTO `ms_trans_lang` VALUES ('104','3','16','84','Bresser Pirsch','0','0');
INSERT INTO `ms_trans_lang` VALUES ('105','2','18','90','+/-4','0','0');
INSERT INTO `ms_trans_lang` VALUES ('106','2','16','70','Дах','0','0');
INSERT INTO `ms_trans_lang` VALUES ('107','2','18','91','-2/+2','0','0');
INSERT INTO `ms_trans_lang` VALUES ('108','2','16','82','Porro','0','0');
INSERT INTO `ms_trans_lang` VALUES ('109','2','15','71','Тип','0','0');
INSERT INTO `ms_trans_lang` VALUES ('110','2','15','66','Серія','0','0');
INSERT INTO `ms_trans_lang` VALUES ('111','2','16','65','\"Арсенал\" BW','0','0');
INSERT INTO `ms_trans_lang` VALUES ('112','2','15','76','Скло','0','0');
INSERT INTO `ms_trans_lang` VALUES ('113','2','15','80','Захист','0','0');
INSERT INTO `ms_trans_lang` VALUES ('114','2','16','84','Bresser Pirsch','0','0');
INSERT INTO `ms_trans_lang` VALUES ('115','3','16','75','ED-glass','0','0');
INSERT INTO `ms_trans_lang` VALUES ('116','3','16','88','BK7 prisms','0','0');
INSERT INTO `ms_trans_lang` VALUES ('117','3','16','81','Bresser Corvette','0','0');
INSERT INTO `ms_trans_lang` VALUES ('118','3','16','74','BAK4 prisms','0','0');
INSERT INTO `ms_trans_lang` VALUES ('119','3','16','86','Arsenal Porro NBN18','0','0');
INSERT INTO `ms_trans_lang` VALUES ('120','3','15','67','Diameter, mm','0','0');
INSERT INTO `ms_trans_lang` VALUES ('121','3','15','68','Max magnification','0','0');
INSERT INTO `ms_trans_lang` VALUES ('122','3','16','77','shockproof','0','0');
INSERT INTO `ms_trans_lang` VALUES ('123','3','16','89','waterproof','0','0');
INSERT INTO `ms_trans_lang` VALUES ('124','3','16','78','gas-filled','0','0');
INSERT INTO `ms_trans_lang` VALUES ('125','2','16','75','ED-скло','0','0');
INSERT INTO `ms_trans_lang` VALUES ('126','2','16','88','призми BK7','0','0');
INSERT INTO `ms_trans_lang` VALUES ('127','2','16','81','Bresser Corvette','0','0');
INSERT INTO `ms_trans_lang` VALUES ('128','2','16','74','призми BAK4','0','0');
INSERT INTO `ms_trans_lang` VALUES ('129','2','16','86','Arsenal Porro NBN18','0','0');
INSERT INTO `ms_trans_lang` VALUES ('130','2','15','67','Діаметр, мм','0','0');
INSERT INTO `ms_trans_lang` VALUES ('131','2','15','68','Максимальне збільшення','0','0');
INSERT INTO `ms_trans_lang` VALUES ('132','2','16','77','ударостійкий','0','0');
INSERT INTO `ms_trans_lang` VALUES ('133','2','16','89','водозахищений','0','0');
INSERT INTO `ms_trans_lang` VALUES ('134','2','16','78','газонаповнений','0','0');
INSERT INTO `ms_trans_lang` VALUES ('135','3','16','73','phase correction','0','0');
INSERT INTO `ms_trans_lang` VALUES ('136','3','15','69','Field of view at 1000m','0','0');
INSERT INTO `ms_trans_lang` VALUES ('137','3','16','79','waterproof','0','0');
INSERT INTO `ms_trans_lang` VALUES ('138','3','15','83','Diopter correction','0','0');
INSERT INTO `ms_trans_lang` VALUES ('139','3','16','85',' metal plating','0','0');
INSERT INTO `ms_trans_lang` VALUES ('140','3','16','87','multi-layer luminescence','0','0');
INSERT INTO `ms_trans_lang` VALUES ('141','3','16','72','full multi-layer enlightenment','0','0');
INSERT INTO `ms_trans_lang` VALUES ('142','2','16','73','фазова корекція','0','0');
INSERT INTO `ms_trans_lang` VALUES ('143','2','15','69','Поле зору на 1000м','0','0');
INSERT INTO `ms_trans_lang` VALUES ('144','2','16','79','водонепроникний','0','0');
INSERT INTO `ms_trans_lang` VALUES ('145','2','15','83','Корекція діоптрій','0','0');
INSERT INTO `ms_trans_lang` VALUES ('146','2','16','85',' металеве напилення','0','0');
INSERT INTO `ms_trans_lang` VALUES ('147','2','16','87','просвітлення багатошарове','0','0');
INSERT INTO `ms_trans_lang` VALUES ('148','2','16','72','просвітлення повне багатошарове','0','0');
INSERT INTO `ms_trans_lang` VALUES ('149','3','2','94','Close','0','0');
INSERT INTO `ms_trans_lang` VALUES ('150','3','2','95','Place an order','0','0');
INSERT INTO `ms_trans_lang` VALUES ('151','3','2','93','Shopping cart','0','0');
INSERT INTO `ms_trans_lang` VALUES ('152','3','2','92','Product has been successfully added to your cart!','0','0');
INSERT INTO `ms_trans_lang` VALUES ('153','2','2','94','Закрити','0','0');
INSERT INTO `ms_trans_lang` VALUES ('154','2','2','95','Оформити замовлення','0','0');
INSERT INTO `ms_trans_lang` VALUES ('155','2','2','93','Кошик покупок','0','0');
INSERT INTO `ms_trans_lang` VALUES ('156','2','2','92','Товар успішно додано до кошика!','0','0');
INSERT INTO `ms_trans_lang` VALUES ('157','3','23','109','Name','0','0');
INSERT INTO `ms_trans_lang` VALUES ('158','3','20','104','Price','0','0');
INSERT INTO `ms_trans_lang` VALUES ('159','3','23','111','City','0','0');
INSERT INTO `ms_trans_lang` VALUES ('160','3','23','112','Address','0','0');
INSERT INTO `ms_trans_lang` VALUES ('161','3','20','103','Packs','0','0');
INSERT INTO `ms_trans_lang` VALUES ('162','3','27','113','Status','0','0');
INSERT INTO `ms_trans_lang` VALUES ('163','3','27','115','Payment','0','0');
INSERT INTO `ms_trans_lang` VALUES ('164','3','20','106','Delete','0','0');
INSERT INTO `ms_trans_lang` VALUES ('165','3','23','110','Phone','0','0');
INSERT INTO `ms_trans_lang` VALUES ('166','3','20','105','Operation','0','0');
INSERT INTO `ms_trans_lang` VALUES ('167','2','23','109','Ім\'я','0','0');
INSERT INTO `ms_trans_lang` VALUES ('168','2','20','104','Ціна','0','0');
INSERT INTO `ms_trans_lang` VALUES ('169','2','23','111','Місто','0','0');
INSERT INTO `ms_trans_lang` VALUES ('170','2','23','112','Адреса','0','0');
INSERT INTO `ms_trans_lang` VALUES ('171','2','20','103','Кількість','0','0');
INSERT INTO `ms_trans_lang` VALUES ('172','2','27','113','Статус','0','0');
INSERT INTO `ms_trans_lang` VALUES ('173','2','27','115','Оплата','0','0');
INSERT INTO `ms_trans_lang` VALUES ('174','2','20','106','Видалити','0','0');
INSERT INTO `ms_trans_lang` VALUES ('175','2','23','110','Телефон','0','0');
INSERT INTO `ms_trans_lang` VALUES ('176','2','20','105','Операція','0','0');
INSERT INTO `ms_trans_lang` VALUES ('177','3','23','108','Delivery','0','0');
INSERT INTO `ms_trans_lang` VALUES ('178','3','27','114','Delivery','0','0');
INSERT INTO `ms_trans_lang` VALUES ('179','3','28','119','Done','0','0');
INSERT INTO `ms_trans_lang` VALUES ('180','3','2','96','Your order','0','0');
INSERT INTO `ms_trans_lang` VALUES ('181','3','2','100','Finalize','0','0');
INSERT INTO `ms_trans_lang` VALUES ('182','3','23','107','Buyer','0','0');
INSERT INTO `ms_trans_lang` VALUES ('183','3','28','116','New order','0','0');
INSERT INTO `ms_trans_lang` VALUES ('184','3','28','120','Canceled','0','0');
INSERT INTO `ms_trans_lang` VALUES ('185','3','2','99','Ordering options','0','0');
INSERT INTO `ms_trans_lang` VALUES ('186','3','20','102','Name','0','0');
INSERT INTO `ms_trans_lang` VALUES ('187','2','23','108','Доставка','0','0');
INSERT INTO `ms_trans_lang` VALUES ('188','2','27','114','Доставка','0','0');
INSERT INTO `ms_trans_lang` VALUES ('189','2','28','119','Виконано','0','0');
INSERT INTO `ms_trans_lang` VALUES ('190','2','2','96','Ваше замовлення','0','0');
INSERT INTO `ms_trans_lang` VALUES ('191','2','2','100','Завершити','0','0');
INSERT INTO `ms_trans_lang` VALUES ('192','2','23','107','Покупець','0','0');
INSERT INTO `ms_trans_lang` VALUES ('193','2','28','116','Нове замовлення','0','0');
INSERT INTO `ms_trans_lang` VALUES ('194','2','28','120','Анульовано','0','0');
INSERT INTO `ms_trans_lang` VALUES ('195','2','2','99','Опції замовлення','0','0');
INSERT INTO `ms_trans_lang` VALUES ('196','2','20','102','Найменування','0','0');
INSERT INTO `ms_trans_lang` VALUES ('197','3','28','118','Deliverable','0','0');
INSERT INTO `ms_trans_lang` VALUES ('198','3','2','97','Cart contents','0','0');
INSERT INTO `ms_trans_lang` VALUES ('199','3','28','117','Consult','0','0');
INSERT INTO `ms_trans_lang` VALUES ('200','3','2','98','Buyer registration','0','0');
INSERT INTO `ms_trans_lang` VALUES ('201','3','20','101','Cart is empty! <small class=\"text-muted\">Add item to cart</small>','0','0');
INSERT INTO `ms_trans_lang` VALUES ('202','2','28','118','Доставляється','0','0');
INSERT INTO `ms_trans_lang` VALUES ('203','2','2','97','Вміст кошика','0','0');
INSERT INTO `ms_trans_lang` VALUES ('204','2','28','117','Проконсультувати','0','0');
INSERT INTO `ms_trans_lang` VALUES ('205','2','2','98','Реєстрація покупця','0','0');
INSERT INTO `ms_trans_lang` VALUES ('206','2','20','101','Кошик порожній! <small class=\"text-muted\">Додайте товар у кошик</small>','0','0');
INSERT INTO `ms_trans_lang` VALUES ('207','3','2','121','Found a mistake!','0','0');
INSERT INTO `ms_trans_lang` VALUES ('208','3','2','122','Order successfully placed!','0','0');
INSERT INTO `ms_trans_lang` VALUES ('209','2','2','121','Знайдено помилку!','0','0');
INSERT INTO `ms_trans_lang` VALUES ('210','2','2','122','Замовлення успішно оформлено!','0','0');
INSERT INTO `ms_trans_lang` VALUES ('211','3','29','123','Kiev','0','0');
INSERT INTO `ms_trans_lang` VALUES ('212','3','29','126','Dnipro','0','0');
INSERT INTO `ms_trans_lang` VALUES ('213','3','29','127','Lviv','0','0');
INSERT INTO `ms_trans_lang` VALUES ('214','3','29','125','Odessa','0','0');
INSERT INTO `ms_trans_lang` VALUES ('215','3','28','128','Courier','0','0');
INSERT INTO `ms_trans_lang` VALUES ('216','3','29','124','Kharkiv','0','0');
INSERT INTO `ms_trans_lang` VALUES ('217','3','28','131','By the score.','0','0');
INSERT INTO `ms_trans_lang` VALUES ('218','3','28','130','Cash','0','0');
INSERT INTO `ms_trans_lang` VALUES ('219','3','28','129','Transportation company','0','0');
INSERT INTO `ms_trans_lang` VALUES ('220','2','29','123','Київ','0','0');
INSERT INTO `ms_trans_lang` VALUES ('221','2','29','126','Дніпро','0','0');
INSERT INTO `ms_trans_lang` VALUES ('222','2','29','127','Львів','0','0');
INSERT INTO `ms_trans_lang` VALUES ('223','2','29','125','Одеса','0','0');
INSERT INTO `ms_trans_lang` VALUES ('224','2','28','128','Кур\'єр','0','0');
INSERT INTO `ms_trans_lang` VALUES ('225','2','29','124','Харків','0','0');
INSERT INTO `ms_trans_lang` VALUES ('226','2','28','131','За рахунком','0','0');
INSERT INTO `ms_trans_lang` VALUES ('227','2','28','130','Готівкою','0','0');
INSERT INTO `ms_trans_lang` VALUES ('228','2','28','129','Транспортна компанія','0','0');
INSERT INTO `ms_trans_lang` VALUES ('248','2','4','138','Погодні станції','0','0');
INSERT INTO `ms_trans_lang` VALUES ('247','3','11','162','Bresser Hunter 20x50 binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('246','3','11','202','Bresser Travel 8x21 Binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('245','3','11','201','Bresser Travel 7x50 Binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('234','3','30','137','No product image available','0','0');
INSERT INTO `ms_trans_lang` VALUES ('244','3','11','185','Bresser Hunter 8x40 binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('243','3','11','184','Bresser Hunter 8x21 binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('242','3','11','182','Bresser Hunter 7x50 binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('241','3','4','138','Weather stations','0','0');
INSERT INTO `ms_trans_lang` VALUES ('240','2','30','137','Зображення товару відсутнє','0','0');
INSERT INTO `ms_trans_lang` VALUES ('249','2','11','182','Бінокль Bresser Hunter 7x50','0','0');
INSERT INTO `ms_trans_lang` VALUES ('250','2','11','184','Бінокль Bresser Hunter 8x21','0','0');
INSERT INTO `ms_trans_lang` VALUES ('251','2','11','185','Бінокль Bresser Hunter 8x40','0','0');
INSERT INTO `ms_trans_lang` VALUES ('252','2','11','201','Бінокль Bresser Travel 7x50','0','0');
INSERT INTO `ms_trans_lang` VALUES ('253','2','11','202','Бінокль Bresser Travel 8x21','0','0');
INSERT INTO `ms_trans_lang` VALUES ('254','2','11','162','Бінокль Bresser Hunter 20x50','0','0');
INSERT INTO `ms_trans_lang` VALUES ('255','3','11','179','Bresser Hunter 10x25 binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('256','3','11','180','Bresser Hunter 10x50 binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('257','3','11','181','Bresser Hunter 16x50 binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('258','3','11','196','Bresser Travel 10x25 Binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('259','3','11','197','Bresser Travel 10x50 Binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('260','3','11','198','Bresser Travel 12x32 Binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('261','3','11','199','Bresser Travel 16x50 Binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('262','3','11','200','Bresser Travel 20x50 Binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('263','3','11','190','Bresser S-Series 8x42 Binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('264','3','11','194','Bresser Topas 7x50 WP binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('265','2','11','179','Бінокль Bresser Hunter 10x25','0','0');
INSERT INTO `ms_trans_lang` VALUES ('266','2','11','180','Бінокль Bresser Hunter 10x50','0','0');
INSERT INTO `ms_trans_lang` VALUES ('267','2','11','181','Бінокль Bresser Hunter 16x50','0','0');
INSERT INTO `ms_trans_lang` VALUES ('268','2','11','196','Бінокль Bresser Travel 10x25','0','0');
INSERT INTO `ms_trans_lang` VALUES ('269','2','11','197','Бінокль Bresser Travel 10x50','0','0');
INSERT INTO `ms_trans_lang` VALUES ('270','2','11','198','Бінокль Bresser Travel 12x32','0','0');
INSERT INTO `ms_trans_lang` VALUES ('271','2','11','199','Бінокль Bresser Travel 16x50 Бінокль Bresser Travel 16x50','0','0');
INSERT INTO `ms_trans_lang` VALUES ('272','2','11','200','Бінокль Bresser Travel 20x50 Бінокль Bresser Travel 20x50','0','0');
INSERT INTO `ms_trans_lang` VALUES ('273','2','11','190','Бінокль Bresser S-Series 8x42','0','0');
INSERT INTO `ms_trans_lang` VALUES ('274','2','11','194','Бінокль Bresser Topas 7x50 WP Bresser Topas 7x50 WP','0','0');
INSERT INTO `ms_trans_lang` VALUES ('275','3','11','172','Bresser Condor 8x25 UR binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('276','3','11','173','Bresser Condor 8x42 UR binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('277','3','11','174','Bresser Condor 8x56 UR binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('278','3','11','189','Bresser S-Series 10x42 Binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('279','3','11','169','Bresser Condor 10x25 UR binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('280','3','11','170','Bresser Condor 10x42 UR binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('281','3','11','171','Bresser Binoculars Condor 10x50 UR','0','0');
INSERT INTO `ms_trans_lang` VALUES ('282','3','11','192','Bresser Spektar 8x42 WP binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('283','3','11','177','Bresser Corvette 7x50 WP binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('284','3','11','178','Bresser Corvette 8x42 WP binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('285','2','11','172','Бінокль Bresser Condor 8x25 UR Bresser Condor 8x25 UR','0','0');
INSERT INTO `ms_trans_lang` VALUES ('286','2','11','173','Бінокль Bresser Condor 8x42 UR Bresser Condor 8x42 UR','0','0');
INSERT INTO `ms_trans_lang` VALUES ('287','2','11','174','Бінокль Bresser Condor 8x56 UR Bresser Condor 8x56 UR','0','0');
INSERT INTO `ms_trans_lang` VALUES ('288','2','11','189','Бінокль Bresser S-Series 10x42','0','0');
INSERT INTO `ms_trans_lang` VALUES ('289','2','11','169','Бінокль Bresser Condor 10x25 UR Bresser Condor 10x25 UR','0','0');
INSERT INTO `ms_trans_lang` VALUES ('290','2','11','170','Бінокль Bresser Condor 10x42 UR Bresser Condor 10x42 UR','0','0');
INSERT INTO `ms_trans_lang` VALUES ('291','2','11','171','Бінокль Bresser Condor 10x50 UR Bresser Condor 10x50 UR','0','0');
INSERT INTO `ms_trans_lang` VALUES ('292','2','11','192','Бінокль Bresser Spektar 8x42 WP Bresser Spektar 8x42 WP','0','0');
INSERT INTO `ms_trans_lang` VALUES ('293','2','11','177','Бінокль Bresser Corvette 7x50 WP Bresser Corvette 7x50 WP','0','0');
INSERT INTO `ms_trans_lang` VALUES ('294','2','11','178','Бінокль Bresser Corvette 8x42 WP Bresser Corvette 8x42 WP','0','0');
INSERT INTO `ms_trans_lang` VALUES ('295','3','11','191','Bresser Spektar 10x42 WP Binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('296','3','11','206','National Geographic 7x50 Binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('297','3','11','208','National Geographic 8x21 Binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('298','3','11','209','National Geographic 8x42 Binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('299','3','11','154','Bresser LCD 50x-2000x Microscope','0','0');
INSERT INTO `ms_trans_lang` VALUES ('300','3','11','175','Bresser Corvette 10x42 WP Binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('301','3','11','176','Bresser Corvette 10x50 WP Binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('302','3','11','203','National Geographic 10x25 Binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('303','3','11','205','National Geographic 10x50 Binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('304','3','11','163','Bresser Spezial-Jagd 11x56 binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('305','2','11','191','Бінокль Bresser Spektar 10x42 WP Bresser Spektar 10x42 WP','0','0');
INSERT INTO `ms_trans_lang` VALUES ('306','2','11','206','Бінокль National Geographic 7x50','0','0');
INSERT INTO `ms_trans_lang` VALUES ('307','2','11','208','Бінокль National Geographic 8x21','0','0');
INSERT INTO `ms_trans_lang` VALUES ('308','2','11','209','Бінокль National Geographic 8x42','0','0');
INSERT INTO `ms_trans_lang` VALUES ('309','2','11','154','Мікроскоп Bresser LCD 50x-2000x','0','0');
INSERT INTO `ms_trans_lang` VALUES ('310','2','11','175','Бінокль Bresser Corvette 10x42 WP Bresser Corvette 10x42 WP','0','0');
INSERT INTO `ms_trans_lang` VALUES ('311','2','11','176','Бінокль Bresser Corvette 10x50 WP Bresser Corvette 10x50 WP','0','0');
INSERT INTO `ms_trans_lang` VALUES ('312','2','11','203','Бінокль National Geographic 10x25','0','0');
INSERT INTO `ms_trans_lang` VALUES ('313','2','11','205','Бінокль National Geographic 10x50','0','0');
INSERT INTO `ms_trans_lang` VALUES ('314','2','11','163','Бінокль Bresser Spezial-Jagd 11x56','0','0');
INSERT INTO `ms_trans_lang` VALUES ('315','3','11','183','Bresser Hunter 8-24x50 ZOOM binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('316','3','11','210','National Geographic 8x42 WP Binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('317','3','11','193','Bresser Spezial-Saturn 20x60 binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('318','3','11','204','National Geographic 10x42 WP Binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('319','3','11','195','Bresser Topas 7x50 WP Compass binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('320','3','11','153','Bresser Junior Stereo 20x Microscope','0','0');
INSERT INTO `ms_trans_lang` VALUES ('321','3','11','186','Bresser Nautic 7x50 WD Compass binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('322','3','11','167','Ea2 ED608 Edge weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('323','3','11','219','Ea2 BL508 Slim weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('324','3','11','220','Ea2 ED609 Edge weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('325','2','11','183','Бінокль Bresser Hunter 8-24x50 ZOOM','0','0');
INSERT INTO `ms_trans_lang` VALUES ('326','2','11','210','Бінокль National Geographic 8x42 WP','0','0');
INSERT INTO `ms_trans_lang` VALUES ('327','2','11','193','Бінокль Bresser Spezial-Saturn 20x60','0','0');
INSERT INTO `ms_trans_lang` VALUES ('328','2','11','204','Бінокль National Geographic 10x42 WP','0','0');
INSERT INTO `ms_trans_lang` VALUES ('329','2','11','195','Бінокль Bresser Topas 7x50 WP Compass Bresser Topas 7x50 WP Compass','0','0');
INSERT INTO `ms_trans_lang` VALUES ('330','2','11','153','Мікроскоп Bresser Junior Stereo 20х','0','0');
INSERT INTO `ms_trans_lang` VALUES ('331','2','11','186','Бінокль Bresser Nautic 7x50 WD Compass Bresser Nautic 7x50 WD Compass','0','0');
INSERT INTO `ms_trans_lang` VALUES ('332','2','11','167','Погодна станція Ea2 ED608 Edge Ea2 ED608 Edge','0','0');
INSERT INTO `ms_trans_lang` VALUES ('333','2','11','219','Погодна станція Ea2 BL508 Slim Ea2 BL508 Slim','0','0');
INSERT INTO `ms_trans_lang` VALUES ('334','2','11','220','Погодна станція Ea2 ED609 Edge Ea2 ED609 Edge','0','0');
INSERT INTO `ms_trans_lang` VALUES ('335','3','11','246','Ea2 BL503 Slim weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('336','3','11','247','Ea2 ED603 Edge weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('337','3','11','146','Bresser Erudit DLX 40x-1000x Microscope','0','0');
INSERT INTO `ms_trans_lang` VALUES ('338','3','11','168','Bresser Binocom 7x50 GAL Compass binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('339','3','11','207','National Geographic 8-24x50 ZOOM binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('340','3','11','212','Bresser TemeoTrend FSX weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('341','3','11','141','Bresser Biolux ICD Stereo 20x Microscope','0','0');
INSERT INTO `ms_trans_lang` VALUES ('342','3','11','140','Bresser BioDiscover 20x-1280x Microscope','0','0');
INSERT INTO `ms_trans_lang` VALUES ('343','3','11','188','Bresser Pirsch 8x42 PHASE COATING binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('344','3','11','232','Bresser Temeo TB Colour weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('345','2','11','246','Погодна станція Ea2 BL503 Slim Ea2 BL503 Slim','0','0');
INSERT INTO `ms_trans_lang` VALUES ('346','2','11','247','Погодна станція Ea2 ED603 Edge Ea2 ED603 Edge','0','0');
INSERT INTO `ms_trans_lang` VALUES ('347','2','11','146','Мікроскоп Bresser Erudit DLX 40x-1000x','0','0');
INSERT INTO `ms_trans_lang` VALUES ('348','2','11','168','Бінокль Bresser Binocom 7x50 GAL Compass Bresser Binocom 7x50 GAL Compass','0','0');
INSERT INTO `ms_trans_lang` VALUES ('349','2','11','207','Бінокль National Geographic 8-24x50 ZOOM','0','0');
INSERT INTO `ms_trans_lang` VALUES ('350','2','11','212','Метеостанція Bresser TemeoTrend FSX','0','0');
INSERT INTO `ms_trans_lang` VALUES ('351','2','11','141','Мікроскоп Bresser Biolux ICD Stereo 20x','0','0');
INSERT INTO `ms_trans_lang` VALUES ('352','2','11','140','Мікроскоп Bresser BioDiscover 20x-1280x','0','0');
INSERT INTO `ms_trans_lang` VALUES ('353','2','11','188','Бінокль Bresser Pirsch 8x42 PHASE COATING','0','0');
INSERT INTO `ms_trans_lang` VALUES ('354','2','11','232','Метеостанція Bresser Temeo TB Colour Bresser Temeo TB Colour','0','0');
INSERT INTO `ms_trans_lang` VALUES ('355','3','11','149','Bresser Junior Microscope 40x-640x Orange','0','0');
INSERT INTO `ms_trans_lang` VALUES ('356','3','11','160','National Geographic Stereo 20x Microscope','0','0');
INSERT INTO `ms_trans_lang` VALUES ('357','3','11','187','Bresser Pirsch 10x42 PHASE COATING Binoculars','0','0');
INSERT INTO `ms_trans_lang` VALUES ('358','3','11','215','Ea2 EN209 Eternity weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('359','3','11','235','Bresser Translucidus Grey weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('360','3','11','248','Ea2 EN203 Eternity weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('361','3','11','249','Ea2 EN208 Eternity weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('362','3','11','250','Ea2 UM8 Ultra Metal Weather Station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('363','3','11','139','Bresser Bino Researcher 40x-1000x microscope','0','0');
INSERT INTO `ms_trans_lang` VALUES ('364','3','11','161','Bresser TemeoTrend JC Black weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('365','2','11','149','Мікроскоп Bresser Junior 40x-640x Orange','0','0');
INSERT INTO `ms_trans_lang` VALUES ('366','2','11','160','Мікроскоп National Geographic Stereo 20x','0','0');
INSERT INTO `ms_trans_lang` VALUES ('367','2','11','187','Бінокль Bresser Pirsch 10x42 PHASE COATING','0','0');
INSERT INTO `ms_trans_lang` VALUES ('368','2','11','215','Погодна станція Ea2 EN209 Eternity Ea2 EN209 Eternity','0','0');
INSERT INTO `ms_trans_lang` VALUES ('369','2','11','235','Метеостанція Bresser Translucidus Grey Метеостанція Bresser Translucidus Grey','0','0');
INSERT INTO `ms_trans_lang` VALUES ('370','2','11','248','Погодна станція Ea2 EN203 Eternity Ea2 EN203 Eternity','0','0');
INSERT INTO `ms_trans_lang` VALUES ('371','2','11','249','Погодна станція Ea2 EN208 Eternity Ea2 EN208 Eternity','0','0');
INSERT INTO `ms_trans_lang` VALUES ('372','2','11','250','Погодна станція Ea2 UM8 Ultra Metal Ea2 UM8 Ultra Metal','0','0');
INSERT INTO `ms_trans_lang` VALUES ('373','2','11','139','Мікроскоп Bresser Bino Researcher 40x-1000x','0','0');
INSERT INTO `ms_trans_lang` VALUES ('374','2','11','161','Метеостанція Bresser TemeoTrend JC Black Метеостанція Bresser TemeoTrend JC Black','0','0');
INSERT INTO `ms_trans_lang` VALUES ('375','3','11','230','Bresser MeteoTemp WTM Color weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('376','3','11','234','Bresser TemeoTrend JC White weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('377','3','11','145','Bresser Erudit Basic Mono 40x-400x Microscope','0','0');
INSERT INTO `ms_trans_lang` VALUES ('378','3','11','223','Bresser ClimaTemp TB Coolor weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('379','3','11','233','Bresser TemeoTrend JC Silver weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('380','3','11','211','Ea2 AL808 Aluminum Slim Weather Station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('381','3','11','218','Ea2 AL803 Aluminum Slim Weather Station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('382','3','11','222','Bresser MeteoTrend Colour Black weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('383','3','11','229','Bresser Colour Temeo Life Weather Station Black','0','0');
INSERT INTO `ms_trans_lang` VALUES ('384','3','11','225','Bresser Spektar 15-45x60 WP Spyglass','0','0');
INSERT INTO `ms_trans_lang` VALUES ('385','2','11','230','Метеостанція Bresser MeteoTemp WTM Color','0','0');
INSERT INTO `ms_trans_lang` VALUES ('386','2','11','234','Метеостанція Bresser TemeoTrend JC White','0','0');
INSERT INTO `ms_trans_lang` VALUES ('387','2','11','145','Мікроскоп Bresser Erudit Basic Mono 40x-400x','0','0');
INSERT INTO `ms_trans_lang` VALUES ('388','2','11','223','Метеостанція Bresser ClimaTemp TB Сoolour','0','0');
INSERT INTO `ms_trans_lang` VALUES ('389','2','11','233','Метеостанція Bresser TemeoTrend JC Silver Метеостанція Bresser TemeoTrend JC Silver','0','0');
INSERT INTO `ms_trans_lang` VALUES ('390','2','11','211','Погодна станція Ea2 AL808 Aluminum Slim Ea2 AL808 Aluminum Slim','0','0');
INSERT INTO `ms_trans_lang` VALUES ('391','2','11','218','Погодна станція Ea2 AL803 Aluminum Slim Ea2 AL803 Aluminum Slim','0','0');
INSERT INTO `ms_trans_lang` VALUES ('392','2','11','222','Метеостанція Bresser MeteoTrend Colour Black','0','0');
INSERT INTO `ms_trans_lang` VALUES ('393','2','11','229','Метеостанція Bresser Colour Temeo Life Black Colour Temeo Life Black','0','0');
INSERT INTO `ms_trans_lang` VALUES ('394','2','11','225','Підзорна труба Bresser Spektar 15-45x60 WP','0','0');
INSERT INTO `ms_trans_lang` VALUES ('395','3','11','165','Bresser Colour Temeo Life H Black weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('396','3','11','228','Bresser ClimaTemp WS Colour Wooden weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('397','3','11','244','National Geographic Weather Expert weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('398','3','11','243','National Geographic Weather Station Transparent Black','0','0');
INSERT INTO `ms_trans_lang` VALUES ('399','3','11','159','National Geographic Mono 20x microscope with case','0','0');
INSERT INTO `ms_trans_lang` VALUES ('400','3','11','241','National Geographic Multi Colour Black weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('401','3','11','150','Bresser Junior 40x-640x Orange microscope with case','0','0');
INSERT INTO `ms_trans_lang` VALUES ('402','3','11','238','Bresser Weather Center 5-in-1 WTW Wooden weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('403','3','11','239','Bresser Weather Center ClimaTemp FW Wooden weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('404','3','11','240','Bresser Weather Center JC XXL 5-in-1 White weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('405','2','11','165','Метеостанція Bresser Colour Temeo Life H Black Colour Colour Temeo Life H Black','0','0');
INSERT INTO `ms_trans_lang` VALUES ('406','2','11','228','Метеостанція Bresser ClimaTemp WS Colour Wooden','0','0');
INSERT INTO `ms_trans_lang` VALUES ('407','2','11','244','Метеостанція National Geographic Weather Expert','0','0');
INSERT INTO `ms_trans_lang` VALUES ('408','2','11','243','Метеостанція National Geographic Transparent Black Метеостанція National Geographic Transparent Black','0','0');
INSERT INTO `ms_trans_lang` VALUES ('409','2','11','159','Мікроскоп National Geographic Mono 20x з кейсом','0','0');
INSERT INTO `ms_trans_lang` VALUES ('410','2','11','241','Метеостанція National Geographic Multi Colour Black Метеостанція National Geographic Multi Colour Black','0','0');
INSERT INTO `ms_trans_lang` VALUES ('411','2','11','150','Мікроскоп Bresser Junior 40x-640x Orange з кейсом','0','0');
INSERT INTO `ms_trans_lang` VALUES ('412','2','11','238','Метеостанція Bresser Weather Center 5-in-1 WTW Wooden','0','0');
INSERT INTO `ms_trans_lang` VALUES ('413','2','11','239','Метеостанція Bresser Weather Center ClimaTemp FW Wooden','0','0');
INSERT INTO `ms_trans_lang` VALUES ('414','2','11','240','Метеостанція Bresser Weather Center JC XXL JC XXL 5-in-1 White','0','0');
INSERT INTO `ms_trans_lang` VALUES ('415','3','11','245','National Geographic Weather Stations Black','0','0');
INSERT INTO `ms_trans_lang` VALUES ('416','3','11','213','Oregon Scientific WMR86NS Pro Color Weather Station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('417','3','11','214','Bresser Weather Center ClimaTemp XXL Wooden weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('418','3','11','226','Bresser Travel 20-60x60 telescope + tripod','0','0');
INSERT INTO `ms_trans_lang` VALUES ('419','3','11','227','Bresser Travel 20-60x80 telescope + tripod','0','0');
INSERT INTO `ms_trans_lang` VALUES ('420','3','11','148','Bresser Junior 40x-1024x USB Camera Microscope with Case','0','0');
INSERT INTO `ms_trans_lang` VALUES ('421','3','11','251','Oregon Scientific BAR223PN PRYSMA Blue Weather Station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('422','3','11','242','National Geographic Multi Colour Wireless Black Weather Station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('423','3','11','164','Bresser Corvette 15-45x60 WP telescope + tripod','0','0');
INSERT INTO `ms_trans_lang` VALUES ('424','3','11','221','National Geographic 20-60x60 Spyglass + Tripod','0','0');
INSERT INTO `ms_trans_lang` VALUES ('425','2','11','245','Метеостанція National Geographic Weather Stations Black','0','0');
INSERT INTO `ms_trans_lang` VALUES ('426','2','11','213','Погодна станція Oregon Scientific WMR86NS Pro Colour Oregon Scientific WMR86NS Pro Colour','0','0');
INSERT INTO `ms_trans_lang` VALUES ('427','2','11','214','Метеостанція Bresser Weather Center ClimaTemp XXL Wooden','0','0');
INSERT INTO `ms_trans_lang` VALUES ('428','2','11','226','Підзорна труба Bresser Travel 20-60x60 + штатив','0','0');
INSERT INTO `ms_trans_lang` VALUES ('429','2','11','227','Підзорна труба Bresser Travel 20-60x80 + штатив','0','0');
INSERT INTO `ms_trans_lang` VALUES ('430','2','11','148','Мікроскоп Bresser Junior 40x-1024x USB Camera з кейсом','0','0');
INSERT INTO `ms_trans_lang` VALUES ('431','2','11','251','Погодна станція Oregon Scientific BAR223PN PRYSMA Blue BAR223PN PRYSMA Blue','0','0');
INSERT INTO `ms_trans_lang` VALUES ('432','2','11','242','Метеостанція National Geographic Multi Colour Wireless National Geographic Black','0','0');
INSERT INTO `ms_trans_lang` VALUES ('433','2','11','164','Підзорна труба Bresser Corvette 15-45x60 WP + штатив','0','0');
INSERT INTO `ms_trans_lang` VALUES ('434','2','11','221','Підзорна труба National Geographic 20-60x60 + штатив','0','0');
INSERT INTO `ms_trans_lang` VALUES ('435','3','11','252','Oregon Scientific WMR500 All-In-One Wi-Fi Weather Station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('436','3','11','224','Bresser Junior Spotty 20-60x60 + Tripod','0','0');
INSERT INTO `ms_trans_lang` VALUES ('437','3','11','236','Bresser Weather Center 5-in-1 Comfort Colour Black weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('438','3','11','142','Bresser Biolux NV 20x-1280x HD USB Camera Microscope with Case','0','0');
INSERT INTO `ms_trans_lang` VALUES ('439','3','11','155','National Geographic 40x-1024x USB eyepiece microscope with case','0','0');
INSERT INTO `ms_trans_lang` VALUES ('440','3','11','231','Bresser Quadro NLX Colour Black weather station with 3 sensors','0','0');
INSERT INTO `ms_trans_lang` VALUES ('441','3','11','166','National Geographic Weather Center 5-in-1 256 Colour Black weather station','0','0');
INSERT INTO `ms_trans_lang` VALUES ('442','3','11','237','Bresser Weather Center 5-in-1 Weather Center Professional 256 Colour Black','0','0');
INSERT INTO `ms_trans_lang` VALUES ('443','3','11','216','Bresser Weather Center 5-in-1 Wi-Fi Wi-Fi Profi Sensor Color Black','0','0');
INSERT INTO `ms_trans_lang` VALUES ('444','3','11','157','National Geographic 40x-640x Microscope with Smartphone Adapter','0','0');
INSERT INTO `ms_trans_lang` VALUES ('445','2','11','252','Погодна станція Oregon Scientific WMR500 All-In-One Wi-Fi All-In-One Wi-Fi','0','0');
INSERT INTO `ms_trans_lang` VALUES ('446','2','11','224','Підзорна труба Bresser Junior Spotty 20-60x60 + штатив','0','0');
INSERT INTO `ms_trans_lang` VALUES ('447','2','11','236','Метеостанція Bresser Weather Center 5-in-1 Comfort Colour Black','0','0');
INSERT INTO `ms_trans_lang` VALUES ('448','2','11','142','Мікроскоп Bresser Biolux NV 20x-1280x HD USB Camera з кейсом','0','0');
INSERT INTO `ms_trans_lang` VALUES ('449','2','11','155','Мікроскоп National Geographic 40x-1024x USB eyepiece з кейсом','0','0');
INSERT INTO `ms_trans_lang` VALUES ('450','2','11','231','Метеостанція Bresser Quadro NLX Colour Black з 3 датчиками','0','0');
INSERT INTO `ms_trans_lang` VALUES ('451','2','11','166','Метеостанція National Geographic Weather Center 5-in-1 256 Colour Black','0','0');
INSERT INTO `ms_trans_lang` VALUES ('452','2','11','237','Метеостанція Bresser Weather Center 5-in-1 Professional 256 Colour Black','0','0');
INSERT INTO `ms_trans_lang` VALUES ('453','2','11','216','Метеостанція Bresser Weather Center 5-in-1 Wi-Fi Profi Sensor Color Black','0','0');
INSERT INTO `ms_trans_lang` VALUES ('454','2','11','157','Мікроскоп National Geographic 40x-640x з адаптером для смартфона','0','0');
INSERT INTO `ms_trans_lang` VALUES ('455','3','11','156','National Geographic 40x-1280x Microscope with Smartphone Adapter','0','0');
INSERT INTO `ms_trans_lang` VALUES ('456','3','11','151','Bresser Junior Biolux 40x-2000x microscope with smartphone adapter','0','0');
INSERT INTO `ms_trans_lang` VALUES ('457','3','11','158','National Geographic Biolux 40x-800x microscope with smartphone adapter','0','0');
INSERT INTO `ms_trans_lang` VALUES ('458','3','11','217','Oregon Scientific RAR502X Multi-Zone Black weather station with three sensors','0','0');
INSERT INTO `ms_trans_lang` VALUES ('459','3','11','147','Bresser Erudit ICD Stereo 20x-40x Microscope with case and smartphone adapter','0','0');
INSERT INTO `ms_trans_lang` VALUES ('460','3','11','144','Bresser Erudit Basic Bino 40x-400x microscope with case and smartphone adapter','0','0');
INSERT INTO `ms_trans_lang` VALUES ('461','3','11','152','Bresser Junior Biolux CA 40x-1024x microscope with case and smartphone adapter','0','0');
INSERT INTO `ms_trans_lang` VALUES ('462','3','11','143','Bresser Biolux SEL Student 40x-1600x White microscope with case and smartphone adapter','0','0');
INSERT INTO `ms_trans_lang` VALUES ('463','2','11','156','Мікроскоп National Geographic 40x-1280x з адаптером для смартфона','0','0');
INSERT INTO `ms_trans_lang` VALUES ('464','2','11','151','Мікроскоп Bresser Junior Biolux 40x-2000x з адаптером для смартфона','0','0');
INSERT INTO `ms_trans_lang` VALUES ('465','2','11','158','Мікроскоп National Geographic Biolux 40x-800x з адаптером для смартфона','0','0');
INSERT INTO `ms_trans_lang` VALUES ('466','2','11','217','Погодна станція Oregon Scientific RAR502X Multi-Zone Black c трьома датчиками','0','0');
INSERT INTO `ms_trans_lang` VALUES ('467','2','11','147','Мікроскоп Bresser Erudit ICD Stereo 20x-40x з кейсом і адаптером для смартфона','0','0');
INSERT INTO `ms_trans_lang` VALUES ('468','2','11','144','Мікроскоп Bresser Erudit Basic Bino 40x-400x з кейсом і адаптером для смартфона','0','0');
INSERT INTO `ms_trans_lang` VALUES ('469','2','11','152','Мікроскоп Bresser Junior Biolux CA 40x-1024x з кейсом і адаптером для смартфона','0','0');
INSERT INTO `ms_trans_lang` VALUES ('470','2','11','143','Мікроскоп Bresser Biolux SEL Student 40x-1600x White з кейсом і адаптером для смартфона','0','0');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_trans_origin`
--

DROP TABLE IF EXISTS `ms_trans_origin`;

CREATE TABLE `ms_trans_origin` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `trans_id` int unsigned DEFAULT NULL,
  `item_id` int unsigned DEFAULT NULL,
  `item_code` char(32) NOT NULL DEFAULT '',
  `context` char(255) NOT NULL DEFAULT '',
  `origin` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `crc` char(32) NOT NULL DEFAULT '',
  `kind_key` char(100) NOT NULL DEFAULT '',
  `params` char(255) NOT NULL DEFAULT '',
  `is_active` tinyint unsigned NOT NULL DEFAULT '0',
  `is_html` tinyint unsigned NOT NULL DEFAULT '0',
  `no_trans` tinyint unsigned NOT NULL DEFAULT '0',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `trans_id` (`trans_id`),
  KEY `item_id` (`item_id`),
  KEY `item_code` (`item_code`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_trans_origin`
--

LOCK TABLES `ms_trans_origin` WRITE;
INSERT INTO `ms_trans_origin` VALUES ('1','2',NULL,'404_NAME','','ОШИБКА 404','65eeedc6f07a7799b2d3831dbf280d25','kDefault','','1','0','0','1');
INSERT INTO `ms_trans_origin` VALUES ('2','2',NULL,'404_TITLE','','404 ошибка: страница не найдена!','1d5e2607079fc684ce46d06a67064b1c','kDefault','','1','0','0','2');
INSERT INTO `ms_trans_origin` VALUES ('3','2',NULL,'404_TXT','','ЗАПРАШИВАЕМАЯ СТРАНИЦА НЕ НАЙДЕНА','fdfe496ea5365d12ddf1904dd3a2a805','kDefault','','1','0','0','3');
INSERT INTO `ms_trans_origin` VALUES ('4','5','1','','','Демонстрационный магазин Melbis Shop','b976736e7f48d33834ed4522308b8301','kDefault','','0','0','0','4');
INSERT INTO `ms_trans_origin` VALUES ('5','7','1','','','            <div class=\"jumbotron\">
                <div class=\"row\">
                    <div class=\"col-lg-4 text-center\">
                        <img class=\"img-fluid rounded border\" src=\"files/2025/03_29/14_38/u_files_store_1_1.png\">
                    </div>
                    <div class=\"col-lg-8\">
                        <h1 class=\"display-4\">Приветствуем в Melbis Shop 6!</h1>
                        <p class=\"lead\">Это простой скрипт для демонстрации базового функционала. Минимальный функционал призван без излишних сложностей раскрыть разные аспекты написания скриптов и обработки данных.</p>
                        <hr class=\"my-4\">
                        <p>Melbis Shop - это интеллектуальное программное обеспечение для создания онлайн-каталогов, интернет-магазинов, любых сайтов, которым требуется система управления контентом.</p>
                        <a class=\"btn btn-info btn-lg float-right\" href=\"https://melbis.com\">Постите melbis.com</a></div></div></div>{MELBIS:melbis_cataloge_center([MS:VAR:LANG])}&nbsp;{MELBIS:melbis_store_random(8)}','fe19a7837fa2f1d934ad7cb2d8c65efa','kDefault','','0','1','0','5');
INSERT INTO `ms_trans_origin` VALUES ('34','13',NULL,'kExist','','Есть на складе','39cc08ac8a1ad4305f131bc8474e3be7','kDefault','','1','0','0','34');
INSERT INTO `ms_trans_origin` VALUES ('35','13',NULL,'kAbsent','','Отсутствует','d47559091d196e657482938ffb4720f3','kDefault','','1','0','0','35');
INSERT INTO `ms_trans_origin` VALUES ('7','8',NULL,'SITE_NAME','','Melbis Shop','8b063a26fa7dcf4ba7484d316e00a751','kDefault','','1','0','0','7');
INSERT INTO `ms_trans_origin` VALUES ('8','9',NULL,'SITE_NAME','','Melbis Shop Demo','a249cb1e87cc39357592a6a42286c239','kDefault','','1','0','0','8');
INSERT INTO `ms_trans_origin` VALUES ('9','8',NULL,'SITE_SUB','','.Demo','a5cb83ff956ab97885954229287cec47','kDefault','','1','0','0','9');
INSERT INTO `ms_trans_origin` VALUES ('10','8',NULL,'HELLO','','Демонстрационный магазин <b>Melbis Shop 6</b>','14ed4eb8b96eeec6089e2f6336fb70cc','kDefault','','1','1','0','10');
INSERT INTO `ms_trans_origin` VALUES ('11','8',NULL,'BASKET','','Корзина','b7697b9693d25ce37bc6a91130dc3cb7','kDefault','','1','0','0','11');
INSERT INTO `ms_trans_origin` VALUES ('12','4','3','','','Начало','0d1e0cd7fc49966f197e742af2f30e95','kDefault','','0','0','0','12');
INSERT INTO `ms_trans_origin` VALUES ('13','4','4','','','Бинокли','607912c95675c2d4f9b326d5541aff6e','kDefault','','0','0','0','13');
INSERT INTO `ms_trans_origin` VALUES ('14','4','5','','','Оптика','77a42f7fd8580470f6fc3280eb850489','kDefault','','0','0','0','14');
INSERT INTO `ms_trans_origin` VALUES ('15','4','6','','','Погода','888d4c1040aa2bf87114fcc23c9fbd5b','kDefault','','0','0','0','15');
INSERT INTO `ms_trans_origin` VALUES ('16','4','12','','','Покупателю','056ba901a032b4e9107fd20dfb6172f4','kDefault','','0','0','0','16');
INSERT INTO `ms_trans_origin` VALUES ('17','4','13','','','О компании','d43bbf2f76f993e3ea7df349207d5ff0','kDefault','','0','0','0','17');
INSERT INTO `ms_trans_origin` VALUES ('18','4','10','','','Микроскопы','707ffa367c97d5e9fddb33019fa2277f','kDefault','','0','0','0','18');
INSERT INTO `ms_trans_origin` VALUES ('19','4','9','','','Метеостанции','73f32b3fe1da1fcfc9de48966038d41f','kDefault','','0','0','0','19');
INSERT INTO `ms_trans_origin` VALUES ('20','4','11','','','Подзорные трубы','97a24ed373f9fc70e524b7f9fbbf9101','kDefault','','0','0','0','20');
INSERT INTO `ms_trans_origin` VALUES ('21','4','17','','','Оплата','e3c1f39b86bb7162bddb548e2cfd6077','kDefault','','0','0','0','21');
INSERT INTO `ms_trans_origin` VALUES ('22','4','16','','','Доставка','b973ee86903271172c9b4f5529bc19bb','kDefault','','0','0','0','22');
INSERT INTO `ms_trans_origin` VALUES ('23','4','20','','','Правила','bee4aa6d2e92734ce46467ce730e0a7a','kDefault','','0','0','0','23');
INSERT INTO `ms_trans_origin` VALUES ('24','4','14','','','Telegram','c915683f3ec888b8edcc7b06bd1428ec','kDefault','','0','0','0','24');
INSERT INTO `ms_trans_origin` VALUES ('25','4','15','','','YouTube','8dd1bae8da2e2408210d0656fbe6b7d1','kDefault','','0','0','0','25');
INSERT INTO `ms_trans_origin` VALUES ('26','4','18','','','Arsenal','4fc9baf210346939946d5a49f255588b','kDefault','','0','0','0','26');
INSERT INTO `ms_trans_origin` VALUES ('27','4','19','','','Bresser','80d7b4ba6b9e41d38b48c7c8b4c96031','kDefault','','0','0','0','27');
INSERT INTO `ms_trans_origin` VALUES ('28','5','6','','','Оплата в магазине','0d88b9a7038ce50b8058267ca1cef355','kDefault','','0','0','0','28');
INSERT INTO `ms_trans_origin` VALUES ('29','7','6','','','<h1 class=\"display-4 border-bottom\">Оплата в магазине</h1><div>Страница с информацией об оплате в магазине.</div><div><br></div>','c4f86cf70537734aa4ac5a99efd0299d','kDefault','','0','1','0','29');
INSERT INTO `ms_trans_origin` VALUES ('30','5','7','','','Способы доставки в магазине','c3cc02950bef7dcbfe6c9ae85764ad35','kDefault','','0','0','0','30');
INSERT INTO `ms_trans_origin` VALUES ('31','7','7','','','<h1 class=\"display-4 border-bottom\">Способы доставки в магазине</h1><div>Страница с информацией о возможных способах оплаты в магазине.</div><div><br></div>','fa4f679cfd40dc942f2805931b3bcb4f','kDefault','','0','1','0','31');
INSERT INTO `ms_trans_origin` VALUES ('32','5','8','','','Правила покупи и возврата товара','5ef75d973c107fb6c672546fb5b01a15','kDefault','','0','0','0','32');
INSERT INTO `ms_trans_origin` VALUES ('33','7','8','','','<h1 class=\"display-4 border-bottom\">Правила покупки в магазине</h1><div>Страница с правилами покупки в магазине.</div><div><br></div>','d16cf3ad913f577c2f9a2d17d469eb8a','kDefault','','0','1','0','33');
INSERT INTO `ms_trans_origin` VALUES ('36','11','4','','','Бинокль Bresser Corvette II 7x50 WP','c594584edfabb206f4ab51bce9a29764','kDefault','','0','0','0','36');
INSERT INTO `ms_trans_origin` VALUES ('37','12','4','','','Bresser Corvette II 7x50 WP светосильный бинокль для применения в условиях низкой освещенности. Он отлично подходит для наблюдений за окружающим миром: птицами, природой, спортивными соревнованиями, для обзорных астрономических наблюдений. ','0fa7981a8551f926cf29c00667a40096','kDefault','','0','0','0','37');
INSERT INTO `ms_trans_origin` VALUES ('38','11','5','','','Бинокль Bresser Pirsch 8x56 UR WP','2587cf099589f70e40a4aeba16ef48aa','kDefault','','0','0','0','38');
INSERT INTO `ms_trans_origin` VALUES ('39','12','5','','','Бинокль Bresser Pirsch 8x56 отлично подойдет для наблюдений за объектами в условиях плохого освещения и в сумерках, в том числе слабосветящимися астрономическими объектами.','2ca46d1e1780f8cf2b7f743e57f8497b','kDefault','','0','0','0','39');
INSERT INTO `ms_trans_origin` VALUES ('40','11','2','','','Бинокль Arsenal 10x50 Porro','fa76aff535d2d76e7116582486e6187a','kDefault','','0','0','0','40');
INSERT INTO `ms_trans_origin` VALUES ('41','12','2','','','Бинокль ARSENAL с классическим увеличением 10х будет превосходным прибором практически для любых наблюдений - полевых и астрономических, орнитологических и натуралистических. Подойдет он и для рыбалки, и охоты.','be9f06f2f07397e7bcd46032f1827f57','kDefault','','0','0','0','41');
INSERT INTO `ms_trans_origin` VALUES ('42','11','3','','','Бинокль Arsenal 10x42 ED (bw15)','925c0582eda87c872a6db6722c3f2629','kDefault','','0','0','0','42');
INSERT INTO `ms_trans_origin` VALUES ('43','12','3','','','Благодаря качественной оптике из ED-стекла и удачному соотношению диаметра и кратности, бинокль даёт очень хорошее качество изображения, как днём так и в сумерках.','dc0a454b9d98f8e63df40551bdbbbda9','kDefault','','0','0','0','43');
INSERT INTO `ms_trans_origin` VALUES ('44','14',NULL,'ADD','','В корзину','5aa28eac85643cd8b1d7be4570391d11','kDefault','','1','0','0','44');
INSERT INTO `ms_trans_origin` VALUES ('45','14',NULL,'UPDATE','','Обновлено','d1227a44b07d793ba8fafaf61c853e87','kDefault','','1','0','0','45');
INSERT INTO `ms_trans_origin` VALUES ('46','14',NULL,'CODE','','Артикул','ccaf15e5726fa7f0c648556ddff0140a','kDefault','','1','0','0','46');
INSERT INTO `ms_trans_origin` VALUES ('80','15','15','','','Защита','600d9ef6320de628a6ceeb0d44d0e79a','kDefault','','0','0','0','80');
INSERT INTO `ms_trans_origin` VALUES ('79','16','13','','','водонепроницаемый','25e2cb1453fd99fc359df3439a7c2733','kDefault','','0','0','0','79');
INSERT INTO `ms_trans_origin` VALUES ('78','16','14','','','газонаполненный','447e40e936c9287fe7e3d20ecc133229','kDefault','','0','0','0','78');
INSERT INTO `ms_trans_origin` VALUES ('77','16','12','','','ударостойкий','71d28e7fc25442d898bf20147be163fc','kDefault','','0','0','0','77');
INSERT INTO `ms_trans_origin` VALUES ('76','15','14','','','Стекла','3ca16d36501f11477db9f37b460c7d43','kDefault','','0','0','0','76');
INSERT INTO `ms_trans_origin` VALUES ('75','16','7','','','ED-стекло','9825b4495d89685f4235f1301d2ea1a7','kDefault','','0','0','0','75');
INSERT INTO `ms_trans_origin` VALUES ('74','16','8','','','призмы BAK4','d16a9471683a9a07d2563348ef282430','kDefault','','0','0','0','74');
INSERT INTO `ms_trans_origin` VALUES ('73','16','9','','','фазовая корреция','493bdc6806357c9cc7bbb48e5342b80f','kDefault','','0','0','0','73');
INSERT INTO `ms_trans_origin` VALUES ('71','15','13','','','Тип','345805b88b9ca1e189fa11ea817e5666','kDefault','','0','0','0','71');
INSERT INTO `ms_trans_origin` VALUES ('72','16','10','','','просветление полное многослойное','e0853cf22bbb65527dac478a42bbf268','kDefault','','0','0','0','72');
INSERT INTO `ms_trans_origin` VALUES ('70','16','4','','','Roof','64230583b0483604ea026c80b127f16a','kDefault','','0','0','0','70');
INSERT INTO `ms_trans_origin` VALUES ('69','15','5','','','Поле зрения на 1000м','1796b0a8aafc13d662e5fa556b547d6e','kDefault','','0','0','0','69');
INSERT INTO `ms_trans_origin` VALUES ('68','15','4','','','Max увеличение','a9f25937bf072aeb7450827f240cd8c3','kDefault','','0','0','0','68');
INSERT INTO `ms_trans_origin` VALUES ('67','15','3','','','Диаметр, мм','0e119ce93b1be7917c959d85d2328138','kDefault','','0','0','0','67');
INSERT INTO `ms_trans_origin` VALUES ('66','15','7','','','Серия','ef1f0f279b31e09375d1861debcfa6bb','kDefault','','0','0','0','66');
INSERT INTO `ms_trans_origin` VALUES ('65','16','2','','','Arsenal BW','5478cd12412cbf93e51f0ebc68b257c0','kDefault','','0','0','0','65');
INSERT INTO `ms_trans_origin` VALUES ('81','16','22','','','Bresser Corvette','363c54bccabc23a8e403aae63f3d365a','kDefault','','0','0','0','81');
INSERT INTO `ms_trans_origin` VALUES ('82','16','3','','','Porro','f471c2366dde4c67cb5c73bd3fdba6d9','kDefault','','0','0','0','82');
INSERT INTO `ms_trans_origin` VALUES ('83','15','24','','','Коррекция диоптрия','6c5973dd4eb59e2ebfe8756420892aba','kDefault','','0','0','0','83');
INSERT INTO `ms_trans_origin` VALUES ('84','16','23','','','Bresser Pirsch','9f83a848c4d36ee2168c03eec8d7db3c','kDefault','','0','0','0','84');
INSERT INTO `ms_trans_origin` VALUES ('85','16','24','','',' металлическое напыление','d8fef9368507a3547ffeeb9a3706e2b5','kDefault','','0','0','0','85');
INSERT INTO `ms_trans_origin` VALUES ('86','16','1','','','Arsenal Porro NBN18','761024abb1a0c4faa4b395afb7641135','kDefault','','0','0','0','86');
INSERT INTO `ms_trans_origin` VALUES ('87','16','6','','','просветление многослойное','0335151c2fe5b974614196183ed3fc5b','kDefault','','0','0','0','87');
INSERT INTO `ms_trans_origin` VALUES ('88','16','5','','','призмы BK7','9b00680a3c94d514f1b05b93ae15ce21','kDefault','','0','0','0','88');
INSERT INTO `ms_trans_origin` VALUES ('89','16','11','','','водозащищенный','87d205bfcc418ce89c553ed01615524a','kDefault','','0','0','0','89');
INSERT INTO `ms_trans_origin` VALUES ('90','18','491','','','+/-4','455b986cd7d5dfd28f5a53441170d970','kDefault','','0','0','0','90');
INSERT INTO `ms_trans_origin` VALUES ('91','18','469','','','-2/+2','38408972985628387e73c08767308765','kDefault','','0','0','0','91');
INSERT INTO `ms_trans_origin` VALUES ('92','2',NULL,'GOODS_ADD','','Товар успешно добавлен в корзину!','6fa9554b90b2bb1d5fb6116772aba179','kDefault','','1','0','0','92');
INSERT INTO `ms_trans_origin` VALUES ('93','2',NULL,'BASKET','','Корзина покупок','6be294e377b3f678731bc42fdba55db1','kDefault','','1','0','0','93');
INSERT INTO `ms_trans_origin` VALUES ('94','2',NULL,'CLOSE','','Закрыть','dd9463bd5d0c650b468fc5d6cfa1073c','kDefault','','1','0','0','94');
INSERT INTO `ms_trans_origin` VALUES ('95','2',NULL,'CHECKOUT','','Оформить заказ','826ea712d2e1d2a94e3bb177ba7747a0','kDefault','','1','0','0','95');
INSERT INTO `ms_trans_origin` VALUES ('96','2',NULL,'ORDER','','Ваш заказ','c6ff3b2901b7ad603f6194c379ba36ea','kDefault','','1','0','0','96');
INSERT INTO `ms_trans_origin` VALUES ('97','2',NULL,'CART','','Содержимое корзины','b3633d0895e7809ee04b9173d3d19522','kDefault','','1','0','0','97');
INSERT INTO `ms_trans_origin` VALUES ('98','2',NULL,'FIELDS','','Регистрация покупателя','1c08fcd8c9e59fd63999807f0497d25c','kDefault','','1','0','0','98');
INSERT INTO `ms_trans_origin` VALUES ('99','2',NULL,'OPTIONS','','Опции заказа','9186c4e397b55d9acf73abe18c888b66','kDefault','','1','0','0','99');
INSERT INTO `ms_trans_origin` VALUES ('100','2',NULL,'FINISH','','Завершить','b0e3a5e05849e5bc6f5807daf1d6f51a','kDefault','','1','0','0','100');
INSERT INTO `ms_trans_origin` VALUES ('101','20',NULL,'EMPTY','','Корзина пуста!  <small class=\"text-muted\">Добавьте товар в корзину</small>','bf1fffba2eeda14510a0fe4665d1c985','kDefault','','1','1','0','101');
INSERT INTO `ms_trans_origin` VALUES ('102','20',NULL,'NAME','','Наименование','dfde1ffd136702faa5d88f9317918b49','kDefault','','1','0','0','102');
INSERT INTO `ms_trans_origin` VALUES ('103','20',NULL,'HOW','','Кол-во','302e2bd6745f94ad88c421bd2f6dc954','kDefault','','1','0','0','103');
INSERT INTO `ms_trans_origin` VALUES ('104','20',NULL,'PRICE','','Цена','682fa8dbadd54fda355b27f124938c93','kDefault','','1','0','0','104');
INSERT INTO `ms_trans_origin` VALUES ('105','20',NULL,'OPER','','Операция','b480476bfee70dbd9f0b76740e54af55','kDefault','','1','0','0','105');
INSERT INTO `ms_trans_origin` VALUES ('106','20',NULL,'DELETE','','Удалить','ed2bbfbc53d83d3ad81f7fd6485ac6e8','kDefault','','1','0','0','106');
INSERT INTO `ms_trans_origin` VALUES ('107','23','4','','','Покупатель','91a72f953017cf1888e332146adacd83','kDefault','','0','0','0','107');
INSERT INTO `ms_trans_origin` VALUES ('108','23','5','','','Доставка','b973ee86903271172c9b4f5529bc19bb','kDefault','','0','0','0','108');
INSERT INTO `ms_trans_origin` VALUES ('109','23','1','','','Имя','d38d6d925c80a2267031f3f03d0a9070','kDefault','','0','0','0','109');
INSERT INTO `ms_trans_origin` VALUES ('110','23','2','','','Телефон','2928e19c705428df3c9f1e6d4ea8042f','kDefault','','0','0','0','110');
INSERT INTO `ms_trans_origin` VALUES ('111','23','3','','','Город','069c9cb17c0aca1e499f3a00fdeb9b3a','kDefault','','0','0','0','111');
INSERT INTO `ms_trans_origin` VALUES ('112','23','6','','','Адрес','80148fa5ada7bcd36bf3b351ee3ca3b0','kDefault','','0','0','0','112');
INSERT INTO `ms_trans_origin` VALUES ('113','27','1','','','Статус','7203f7a4ff564cb876e8db54c903dbfc','kDefault','','0','0','0','113');
INSERT INTO `ms_trans_origin` VALUES ('114','27','2','','','Доставка','b973ee86903271172c9b4f5529bc19bb','kDefault','','0','0','0','114');
INSERT INTO `ms_trans_origin` VALUES ('115','27','3','','','Оплата','e3c1f39b86bb7162bddb548e2cfd6077','kDefault','','0','0','0','115');
INSERT INTO `ms_trans_origin` VALUES ('116','28','1','','','Новый заказ','9a1a009d2c17ae652cf78989a5bf8813','kDefault','','0','0','0','116');
INSERT INTO `ms_trans_origin` VALUES ('117','28','2','','','Проконсультировать','03d23728f88e0decd70091f084935d7a','kDefault','','0','0','0','117');
INSERT INTO `ms_trans_origin` VALUES ('118','28','3','','','Доставляется','e3fae123e40c14737c2d1d6891775b64','kDefault','','0','0','0','118');
INSERT INTO `ms_trans_origin` VALUES ('119','28','4','','','Выполнен','ab3dd69009c1bc40f0503aa425a465c9','kDefault','','0','0','0','119');
INSERT INTO `ms_trans_origin` VALUES ('120','28','5','','','Аннулирован','5f13e0ea0e376a8864614aff5b0af39d','kDefault','','0','0','0','120');
INSERT INTO `ms_trans_origin` VALUES ('121','2',NULL,'ERROR','','Найдена ошибка!','cee8beebb1471c457eed42249ec0439a','kDefault','','1','0','0','121');
INSERT INTO `ms_trans_origin` VALUES ('122','2',NULL,'SUCCESS','','Заказ успешно оформлен!','b39104446276d00e7787937313bf99a8','kDefault','','1','0','0','122');
INSERT INTO `ms_trans_origin` VALUES ('123','29','1','','','Киев','dab4a1af4fb037f0c5f2fdd9fa33a46b','kDefault','','0','0','0','123');
INSERT INTO `ms_trans_origin` VALUES ('124','29','2','','','Харьков','4cb56403a21a34427afb34c00ad57f99','kDefault','','0','0','0','124');
INSERT INTO `ms_trans_origin` VALUES ('125','29','3','','','Одесса','0cd6fb16b1886bbdae3b7ceacc32a2d4','kDefault','','0','0','0','125');
INSERT INTO `ms_trans_origin` VALUES ('126','29','4','','','Днепр','1f4aa177c603fa3c8abc0934b7d3a682','kDefault','','0','0','0','126');
INSERT INTO `ms_trans_origin` VALUES ('127','29','5','','','Львов','3f853a48c25e2591414f252f45c7bac7','kDefault','','0','0','0','127');
INSERT INTO `ms_trans_origin` VALUES ('128','28','6','','','Курьер','d82629e01fc8751a95019f70231228ce','kDefault','','0','0','0','128');
INSERT INTO `ms_trans_origin` VALUES ('129','28','7','','','Транспортная компания','aa7f433c12c094d69f4491ced84df202','kDefault','','0','0','0','129');
INSERT INTO `ms_trans_origin` VALUES ('130','28','8','','','Наличными','04c15e50148f6fde296126e2ad32b4fe','kDefault','','0','0','0','130');
INSERT INTO `ms_trans_origin` VALUES ('131','28','9','','','По счету','004882de5a6106dc42a1d5c063307fee','kDefault','','0','0','0','131');
INSERT INTO `ms_trans_origin` VALUES ('141','11','1167','','','Микроскоп Bresser Biolux ICD Stereo 20x','2651989cccbc2b59a1f464b466bc0172','kDefault','','0','0','0','141');
INSERT INTO `ms_trans_origin` VALUES ('140','11','1166','','','Микроскоп Bresser BioDiscover 20x-1280x','ddf937653969560ad92c63c75e247135','kDefault','','0','0','0','140');
INSERT INTO `ms_trans_origin` VALUES ('139','11','1165','','','Микроскоп Bresser Bino Researcher 40x-1000x','6482d40a1b5fce9b811316bd32e82120','kDefault','','0','0','0','139');
INSERT INTO `ms_trans_origin` VALUES ('138','4','21','','','Погодные станции','eb97d8bb522f45a2aaa0fba305d99f01','kDefault','','0','0','0','138');
INSERT INTO `ms_trans_origin` VALUES ('137','30',NULL,'NO_IMAGE','','Изображение товара отсутствует','52eacdf2054466f4ca80332856625965','kDefault','','1','0','0','137');
INSERT INTO `ms_trans_origin` VALUES ('142','11','1168','','','Микроскоп Bresser Biolux NV 20x-1280x HD USB Camera с кейсом','be74b5c238131ee87b306a62b57dfc39','kDefault','','0','0','0','142');
INSERT INTO `ms_trans_origin` VALUES ('143','11','1169','','','Микроскоп Bresser Biolux SEL Student 40x-1600x White с кейсом и адаптером для смартфона','ba0af09b4bf3a4d6db3784b2d071a6d4','kDefault','','0','0','0','143');
INSERT INTO `ms_trans_origin` VALUES ('144','11','1170','','','Микроскоп Bresser Erudit Basic Bino 40x-400x с кейсом и адаптером для смартфона','2b8a969cbc656383f5fe8c32b9d13b90','kDefault','','0','0','0','144');
INSERT INTO `ms_trans_origin` VALUES ('145','11','1171','','','Микроскоп Bresser Erudit Basic Mono 40x-400x','f13e9515acf25a824896ceda070ac7f5','kDefault','','0','0','0','145');
INSERT INTO `ms_trans_origin` VALUES ('146','11','1172','','','Микроскоп Bresser Erudit DLX 40x-1000x','8d82b1c17da164ff8e30736addf59d7b','kDefault','','0','0','0','146');
INSERT INTO `ms_trans_origin` VALUES ('147','11','1173','','','Микроскоп Bresser Erudit ICD Stereo 20x-40x с кейсом и адаптером для смартфона','ab63499469f29197da9045cc92a3940c','kDefault','','0','0','0','147');
INSERT INTO `ms_trans_origin` VALUES ('148','11','1176','','','Микроскоп Bresser Junior 40x-1024x USB Camera с кейсом','0c9d847c9b15020f68adc1992d2a4eec','kDefault','','0','0','0','148');
INSERT INTO `ms_trans_origin` VALUES ('149','11','1174','','','Микроскоп Bresser Junior 40x-640x Orange','113dc76dbb06953f80bd4b16bdcea65c','kDefault','','0','0','0','149');
INSERT INTO `ms_trans_origin` VALUES ('150','11','1175','','','Микроскоп Bresser Junior 40x-640x Orange с кейсом','ed13f2fd88d8941c31a3dd7db93fb59f','kDefault','','0','0','0','150');
INSERT INTO `ms_trans_origin` VALUES ('151','11','1177','','','Микроскоп Bresser Junior Biolux 40x-2000x с адаптером для смартфона','8dc0e31e08864343b1224fc6c70b3c52','kDefault','','0','0','0','151');
INSERT INTO `ms_trans_origin` VALUES ('152','11','1178','','','Микроскоп Bresser Junior Biolux CA 40x-1024x с кейсом и адаптером для смартфона','0e6b1d4e3f88e3a75ce0fb39d892f948','kDefault','','0','0','0','152');
INSERT INTO `ms_trans_origin` VALUES ('153','11','1179','','','Микроскоп Bresser Junior Stereo 20х','6d67617bbdaca0fe9cac66c3f5bbc5bb','kDefault','','0','0','0','153');
INSERT INTO `ms_trans_origin` VALUES ('154','11','1180','','','Микроскоп Bresser LCD 50x-2000x','d21f0e54ebbd68b10287531d2274a809','kDefault','','0','0','0','154');
INSERT INTO `ms_trans_origin` VALUES ('155','11','1182','','','Микроскоп National Geographic 40x-1024x USB eyepiece с кейсом','ef7cd2330748acb1e375ec8b0fd4f783','kDefault','','0','0','0','155');
INSERT INTO `ms_trans_origin` VALUES ('156','11','1183','','','Микроскоп National Geographic 40x-1280x с адаптером для смартфона','fa3d7346563c75d6a7b9cf8e8e1f38c9','kDefault','','0','0','0','156');
INSERT INTO `ms_trans_origin` VALUES ('157','11','1181','','','Микроскоп National Geographic 40x-640x с адаптером для смартфона','542c69e72b9f2edcfc97e3ecfa69c641','kDefault','','0','0','0','157');
INSERT INTO `ms_trans_origin` VALUES ('158','11','1184','','','Микроскоп National Geographic Biolux 40x-800x с адаптером для смартфона','8e229293f52767b45d3081f42e312357','kDefault','','0','0','0','158');
INSERT INTO `ms_trans_origin` VALUES ('159','11','1185','','','Микроскоп National Geographic Mono 20x с кейсом','13b6de89d6fb78a098a740377aae2146','kDefault','','0','0','0','159');
INSERT INTO `ms_trans_origin` VALUES ('160','11','1186','','','Микроскоп National Geographic Stereo 20x','1579834bbde398c0fccc81fd657615ed','kDefault','','0','0','0','160');
INSERT INTO `ms_trans_origin` VALUES ('161','11','1202','','','Метеостанция Bresser TemeoTrend JC Black','d38a92a82e955e28645bd74a6c35fdd3','kDefault','','0','0','0','161');
INSERT INTO `ms_trans_origin` VALUES ('162','11','1126','','','Бинокль Bresser Hunter 20x50','5f6e02a6a6c1619db59479b9a423099d','kDefault','','0','0','0','162');
INSERT INTO `ms_trans_origin` VALUES ('163','11','1131','','','Бинокль Bresser Spezial-Jagd 11x56','2f8b7eb6ff59eb3a5eee55b1c9c83f3f','kDefault','','0','0','0','163');
INSERT INTO `ms_trans_origin` VALUES ('164','11','1159','','','Подзорная труба Bresser Corvette 15-45x60 WP + штатив','ef8eac1d3f132fcb7c84e7ca12715750','kDefault','','0','0','0','164');
INSERT INTO `ms_trans_origin` VALUES ('165','11','1196','','','Метеостанция Bresser Colour Temeo Life H Black','76cc371670a6946b1592f5357097d8cb','kDefault','','0','0','0','165');
INSERT INTO `ms_trans_origin` VALUES ('166','11','1216','','','Метеостанция National Geographic Weather Center 5-in-1 256 Colour Black','16e4f909ae5d0bd2f014cad2dcbf2fe8','kDefault','','0','0','0','166');
INSERT INTO `ms_trans_origin` VALUES ('167','11','1224','','','Погодная станция Ea2 ED608 Edge','0dceef19edb3cc472ce2601aee255ee6','kDefault','','0','0','0','167');
INSERT INTO `ms_trans_origin` VALUES ('168','11','1109','','','Бинокль Bresser Binocom 7x50 GAL Compass','9376ea267be3100e653ebe64e9f9a05e','kDefault','','0','0','0','168');
INSERT INTO `ms_trans_origin` VALUES ('169','11','1111','','','Бинокль Bresser Condor 10x25 UR','ca7558b174f51add6e274fb21256e05b','kDefault','','0','0','0','169');
INSERT INTO `ms_trans_origin` VALUES ('170','11','1114','','','Бинокль Bresser Condor 10x42 UR','0266ff14398505e1c43031872ef03f75','kDefault','','0','0','0','170');
INSERT INTO `ms_trans_origin` VALUES ('171','11','1115','','','Бинокль Bresser Condor 10x50 UR','5458a7bf02db0d80c8399545277e8b5e','kDefault','','0','0','0','171');
INSERT INTO `ms_trans_origin` VALUES ('172','11','1110','','','Бинокль Bresser Condor 8x25 UR','da1bc1481cbc80b8f5c9f18db056cc33','kDefault','','0','0','0','172');
INSERT INTO `ms_trans_origin` VALUES ('173','11','1112','','','Бинокль Bresser Condor 8x42 UR','1901133b87d4a88ba0f1a04579b51ba9','kDefault','','0','0','0','173');
INSERT INTO `ms_trans_origin` VALUES ('174','11','1113','','','Бинокль Bresser Condor 8x56 UR','e12dfc5418d922580b5b9d0977a669f5','kDefault','','0','0','0','174');
INSERT INTO `ms_trans_origin` VALUES ('175','11','1117','','','Бинокль Bresser Corvette 10x42 WP','40fcbd2e900be9b2f2bea9dc9c6cdefa','kDefault','','0','0','0','175');
INSERT INTO `ms_trans_origin` VALUES ('176','11','1119','','','Бинокль Bresser Corvette 10x50 WP','01c74ace7f2c2eeea9c6d2b56085ff39','kDefault','','0','0','0','176');
INSERT INTO `ms_trans_origin` VALUES ('177','11','1118','','','Бинокль Bresser Corvette 7x50 WP','652d67da2aa453cfc2a94d87e7fce136','kDefault','','0','0','0','177');
INSERT INTO `ms_trans_origin` VALUES ('178','11','1116','','','Бинокль Bresser Corvette 8x42 WP','3140833d6faf38d79ae6d031eefd8bd6','kDefault','','0','0','0','178');
INSERT INTO `ms_trans_origin` VALUES ('179','11','1121','','','Бинокль Bresser Hunter 10x25','95d3f6523628959e69aa7860ad86d05f','kDefault','','0','0','0','179');
INSERT INTO `ms_trans_origin` VALUES ('180','11','1124','','','Бинокль Bresser Hunter 10x50','17e32ab7c0f86734a09801fbe2f61efb','kDefault','','0','0','0','180');
INSERT INTO `ms_trans_origin` VALUES ('181','11','1125','','','Бинокль Bresser Hunter 16x50','1a15e5a22f45f846b22d597966c2cba8','kDefault','','0','0','0','181');
INSERT INTO `ms_trans_origin` VALUES ('182','11','1123','','','Бинокль Bresser Hunter 7x50','4d37a7d6f7cc5b7776c46f2692416b7e','kDefault','','0','0','0','182');
INSERT INTO `ms_trans_origin` VALUES ('183','11','1127','','','Бинокль Bresser Hunter 8-24x50 ZOOM','7d83fd099ca3f6e3ccce7c520388377a','kDefault','','0','0','0','183');
INSERT INTO `ms_trans_origin` VALUES ('184','11','1120','','','Бинокль Bresser Hunter 8x21','7809d0fff0a9c26b98b1af2c2ac9480c','kDefault','','0','0','0','184');
INSERT INTO `ms_trans_origin` VALUES ('185','11','1122','','','Бинокль Bresser Hunter 8x40','9c94f6fbd64aed4cd7dc4d1f07547800','kDefault','','0','0','0','185');
INSERT INTO `ms_trans_origin` VALUES ('186','11','1128','','','Бинокль Bresser Nautic 7x50 WD Compass','02b155bdcefc18801e00c6c0a927dba7','kDefault','','0','0','0','186');
INSERT INTO `ms_trans_origin` VALUES ('187','11','1130','','','Бинокль Bresser Pirsch 10x42 PHASE COATING','748b02a0056972b185e45a2072c1de64','kDefault','','0','0','0','187');
INSERT INTO `ms_trans_origin` VALUES ('188','11','1129','','','Бинокль Bresser Pirsch 8x42 PHASE COATING','5f7ab1562f02e87025055d93719e2c09','kDefault','','0','0','0','188');
INSERT INTO `ms_trans_origin` VALUES ('189','11','1136','','','Бинокль Bresser S-Series 10x42','86524795c70557c37cde9cb59c562510','kDefault','','0','0','0','189');
INSERT INTO `ms_trans_origin` VALUES ('190','11','1135','','','Бинокль Bresser S-Series 8x42','781bd4fa049ae441b1e5491339bcafe6','kDefault','','0','0','0','190');
INSERT INTO `ms_trans_origin` VALUES ('191','11','1134','','','Бинокль Bresser Spektar 10x42 WP','8aaaf2f0371ca15d9f29c6b35d0e0c6b','kDefault','','0','0','0','191');
INSERT INTO `ms_trans_origin` VALUES ('192','11','1133','','','Бинокль Bresser Spektar 8x42 WP','a6a8bfa40c805f1bc82757f1f78bb1ad','kDefault','','0','0','0','192');
INSERT INTO `ms_trans_origin` VALUES ('193','11','1132','','','Бинокль Bresser Spezial-Saturn 20x60','639512ab29a90b31470663ccef3afb01','kDefault','','0','0','0','193');
INSERT INTO `ms_trans_origin` VALUES ('194','11','1137','','','Бинокль Bresser Topas 7x50 WP','182049bf7295656e93f1e21fa7baf871','kDefault','','0','0','0','194');
INSERT INTO `ms_trans_origin` VALUES ('195','11','1138','','','Бинокль Bresser Topas 7x50 WP Compass','a41d3e157a5ec17df3f721d30dfff76b','kDefault','','0','0','0','195');
INSERT INTO `ms_trans_origin` VALUES ('196','11','1140','','','Бинокль Bresser Travel 10x25','a64dc8c4fd0ff474eaddd22625b4033f','kDefault','','0','0','0','196');
INSERT INTO `ms_trans_origin` VALUES ('197','11','1143','','','Бинокль Bresser Travel 10x50','fec9d91a11d6a0bd27f6c2cf8f458292','kDefault','','0','0','0','197');
INSERT INTO `ms_trans_origin` VALUES ('198','11','1141','','','Бинокль Bresser Travel 12x32','86a9e4c7cb4ba220c5db2f1c039b7040','kDefault','','0','0','0','198');
INSERT INTO `ms_trans_origin` VALUES ('199','11','1144','','','Бинокль Bresser Travel 16x50','18d0a74c9eb17f43eaf0935dabfc4ae6','kDefault','','0','0','0','199');
INSERT INTO `ms_trans_origin` VALUES ('200','11','1145','','','Бинокль Bresser Travel 20x50','f9f3c8116cb5fb5b8e635dfebb3366d6','kDefault','','0','0','0','200');
INSERT INTO `ms_trans_origin` VALUES ('201','11','1142','','','Бинокль Bresser Travel 7x50','6a871e1cce264c244026e1df0c129ce7','kDefault','','0','0','0','201');
INSERT INTO `ms_trans_origin` VALUES ('202','11','1139','','','Бинокль Bresser Travel 8x21','92fd5e410cf1bfdf9501cf855bb84cc1','kDefault','','0','0','0','202');
INSERT INTO `ms_trans_origin` VALUES ('203','11','1147','','','Бинокль National Geographic 10x25','690a4ca9dedc5f0ae8dc89999cac9f7a','kDefault','','0','0','0','203');
INSERT INTO `ms_trans_origin` VALUES ('204','11','1153','','','Бинокль National Geographic 10x42 WP','286d5c5a50a504c2493bafd6910a260d','kDefault','','0','0','0','204');
INSERT INTO `ms_trans_origin` VALUES ('205','11','1149','','','Бинокль National Geographic 10x50','a17688f688ea37f8b7dfdd46879624c9','kDefault','','0','0','0','205');
INSERT INTO `ms_trans_origin` VALUES ('206','11','1148','','','Бинокль National Geographic 7x50','6fff77e807cfaccf57cc8b5bf12a8e3c','kDefault','','0','0','0','206');
INSERT INTO `ms_trans_origin` VALUES ('207','11','1150','','','Бинокль National Geographic 8-24x50 ZOOM','2daf0ac88eeaa16560a8d0e160b6db06','kDefault','','0','0','0','207');
INSERT INTO `ms_trans_origin` VALUES ('208','11','1146','','','Бинокль National Geographic 8x21','ccb3b8478b540fd83c0113b2cd8cc0cb','kDefault','','0','0','0','208');
INSERT INTO `ms_trans_origin` VALUES ('209','11','1151','','','Бинокль National Geographic 8x42','bd58cc8dc20857a757ae01e2e2c5ebc6','kDefault','','0','0','0','209');
INSERT INTO `ms_trans_origin` VALUES ('210','11','1152','','','Бинокль National Geographic 8x42 WP','8e7b934473592acfca1112b484a326b6','kDefault','','0','0','0','210');
INSERT INTO `ms_trans_origin` VALUES ('211','11','1220','','','Погодная станция Ea2 AL808 Aluminum Slim','1e091d428836f2ed2f30c67c0aff659e','kDefault','','0','0','0','211');
INSERT INTO `ms_trans_origin` VALUES ('212','11','1201','','','Метеостанция Bresser TemeoTrend FSX','e997b131b1bd45a8d5a93387f1c3a8db','kDefault','','0','0','0','212');
INSERT INTO `ms_trans_origin` VALUES ('213','11','1233','','','Погодная станция Oregon Scientific WMR86NS Pro Colour','5ce29747014dda8d1d82a41d73666900','kDefault','','0','0','0','213');
INSERT INTO `ms_trans_origin` VALUES ('214','11','1210','','','Метеостанция Bresser Weather Center ClimaTemp XXL Wooden','dae576a8c43639331b498ab7c0a47a83','kDefault','','0','0','0','214');
INSERT INTO `ms_trans_origin` VALUES ('215','11','1228','','','Погодная станция Ea2 EN209 Eternity','e3104c7b7e6e8d45dc90b4ce6cddb2a6','kDefault','','0','0','0','215');
INSERT INTO `ms_trans_origin` VALUES ('216','11','1212','','','Метеостанция Bresser Weather Center 5-in-1 Wi-Fi Profi Sensor Color Black','275619cd3f4edc626082f1d6da355d0b','kDefault','','0','0','0','216');
INSERT INTO `ms_trans_origin` VALUES ('217','11','1231','','','Погодная станция Oregon Scientific RAR502X Multi-Zone Black c тремя датчиками','9cb91705951d3eeba7b0bb549ee3fe8d','kDefault','','0','0','0','217');
INSERT INTO `ms_trans_origin` VALUES ('218','11','1219','','','Погодная станция Ea2 AL803 Aluminum Slim','c41cf3b94d5a1751bdfec2145e2573bb','kDefault','','0','0','0','218');
INSERT INTO `ms_trans_origin` VALUES ('219','11','1222','','','Погодная станция Ea2 BL508 Slim','9d62fcd95647a00268af636d6e0b5649','kDefault','','0','0','0','219');
INSERT INTO `ms_trans_origin` VALUES ('220','11','1225','','','Погодная станция Ea2 ED609 Edge','737bf0088cddff5bc8b1067681039b5b','kDefault','','0','0','0','220');
INSERT INTO `ms_trans_origin` VALUES ('221','11','1164','','','Подзорная труба National Geographic 20-60x60 + штатив','9637bed03ddddc67e05308bdcd9eca38','kDefault','','0','0','0','221');
INSERT INTO `ms_trans_origin` VALUES ('222','11','1198','','','Метеостанция Bresser MeteoTrend Colour Black','ab3fbd74bd2b284db9d9d2c98f8ebbc6','kDefault','','0','0','0','222');
INSERT INTO `ms_trans_origin` VALUES ('223','11','1193','','','Метеостанция Bresser ClimaTemp TB Сolour','88735e7f7afe918e053e37861ddab4f4','kDefault','','0','0','0','223');
INSERT INTO `ms_trans_origin` VALUES ('224','11','1160','','','Подзорная труба Bresser Junior Spotty 20-60x60 + штатив','9e4627a9693e0ba84ee25beffca110ae','kDefault','','0','0','0','224');
INSERT INTO `ms_trans_origin` VALUES ('225','11','1161','','','Подзорная труба Bresser Spektar 15-45x60 WP','3ed012e0105846fa91fee97480b35d03','kDefault','','0','0','0','225');
INSERT INTO `ms_trans_origin` VALUES ('226','11','1162','','','Подзорная труба Bresser Travel 20-60x60 + штатив','177bd92f643b2cbd938b36b29e18e911','kDefault','','0','0','0','226');
INSERT INTO `ms_trans_origin` VALUES ('227','11','1163','','','Подзорная труба Bresser Travel 20-60x80 + штатив','364a366e1902dad951c0002dd1f7c0e0','kDefault','','0','0','0','227');
INSERT INTO `ms_trans_origin` VALUES ('228','11','1194','','','Метеостанция Bresser ClimaTemp WS Colour Wooden','fc0662a3efda986f7016b126da663e98','kDefault','','0','0','0','228');
INSERT INTO `ms_trans_origin` VALUES ('229','11','1195','','','Метеостанция Bresser Colour Temeo Life Black','d1a243ecf2d0dac94635dfdd46b0e7ce','kDefault','','0','0','0','229');
INSERT INTO `ms_trans_origin` VALUES ('230','11','1197','','','Метеостанция Bresser MeteoTemp WTM Color','170f1a63af925c9373f01fd8b050d771','kDefault','','0','0','0','230');
INSERT INTO `ms_trans_origin` VALUES ('231','11','1199','','','Метеостанция Bresser Quadro NLX Colour Black с 3 датчиками','1a2e1c4ed5d0b5cbb23aae29a60482c8','kDefault','','0','0','0','231');
INSERT INTO `ms_trans_origin` VALUES ('232','11','1200','','','Метеостанция Bresser Temeo TB Colour','42d1c586486f29645fbdf753ab8aaa7c','kDefault','','0','0','0','232');
INSERT INTO `ms_trans_origin` VALUES ('233','11','1203','','','Метеостанция Bresser TemeoTrend JC Silver','b2bcd7528420cb901ecd88c524bf98d7','kDefault','','0','0','0','233');
INSERT INTO `ms_trans_origin` VALUES ('234','11','1204','','','Метеостанция Bresser TemeoTrend JC White','94339bf49c919f8993d2d5a24969cc12','kDefault','','0','0','0','234');
INSERT INTO `ms_trans_origin` VALUES ('235','11','1205','','','Метеостанция Bresser Translucidus Grey','908013bbaf1d5feb855183248d3389d5','kDefault','','0','0','0','235');
INSERT INTO `ms_trans_origin` VALUES ('236','11','1206','','','Метеостанция Bresser Weather Center 5-in-1 Comfort Colour Black','48a21735400d73deec50f90c371d6038','kDefault','','0','0','0','236');
INSERT INTO `ms_trans_origin` VALUES ('237','11','1207','','','Метеостанция Bresser Weather Center 5-in-1 Professional 256 Colour Black','e875dd6305a4d9b42c53628d54836cd0','kDefault','','0','0','0','237');
INSERT INTO `ms_trans_origin` VALUES ('238','11','1208','','','Метеостанция Bresser Weather Center 5-in-1 WTW Wooden','0156967e904facc865ec45c7389f7e6f','kDefault','','0','0','0','238');
INSERT INTO `ms_trans_origin` VALUES ('239','11','1209','','','Метеостанция Bresser Weather Center ClimaTemp FW Wooden','a41256cabfe2733a4e18e9c6023a803e','kDefault','','0','0','0','239');
INSERT INTO `ms_trans_origin` VALUES ('240','11','1211','','','Метеостанция Bresser Weather Center JC XXL 5-in-1 White','d0c7e8ab8341f61541cd9926951446da','kDefault','','0','0','0','240');
INSERT INTO `ms_trans_origin` VALUES ('241','11','1213','','','Метеостанция National Geographic Multi Colour Black','4f59acc56e529a65b0d1d958dd6e7e03','kDefault','','0','0','0','241');
INSERT INTO `ms_trans_origin` VALUES ('242','11','1214','','','Метеостанция National Geographic Multi Colour Wireless Black','f7089b5dd5a3a049d9ec582b4bb7fa6e','kDefault','','0','0','0','242');
INSERT INTO `ms_trans_origin` VALUES ('243','11','1215','','','Метеостанция National Geographic Transparent Black','ff260e34b6ffc67bf59ac44c45120a4d','kDefault','','0','0','0','243');
INSERT INTO `ms_trans_origin` VALUES ('244','11','1217','','','Метеостанция National Geographic Weather Expert','8d44b08571958637e615ddbcf9b1a009','kDefault','','0','0','0','244');
INSERT INTO `ms_trans_origin` VALUES ('245','11','1218','','','Метеостанция National Geographic Weather Stations Black','d3e1d6c7c553e35966d044617cc25561','kDefault','','0','0','0','245');
INSERT INTO `ms_trans_origin` VALUES ('246','11','1221','','','Погодная станция Ea2 BL503 Slim','4dcc526c6b8469de612b0169109a36d4','kDefault','','0','0','0','246');
INSERT INTO `ms_trans_origin` VALUES ('247','11','1223','','','Погодная станция Ea2 ED603 Edge','a1d0368ec10dd573d697f859d2510f16','kDefault','','0','0','0','247');
INSERT INTO `ms_trans_origin` VALUES ('248','11','1226','','','Погодная станция Ea2 EN203 Eternity','c1d86f904e13467e7e7d2a1d1550e646','kDefault','','0','0','0','248');
INSERT INTO `ms_trans_origin` VALUES ('249','11','1227','','','Погодная станция Ea2 EN208 Eternity','d5d0b4563c051d07d3f2c351861e6ffb','kDefault','','0','0','0','249');
INSERT INTO `ms_trans_origin` VALUES ('250','11','1229','','','Погодная станция Ea2 UM8 Ultra Metal','11952b3fb8f0ace37bb8f0922749315e','kDefault','','0','0','0','250');
INSERT INTO `ms_trans_origin` VALUES ('251','11','1230','','','Погодная станция Oregon Scientific BAR223PN PRYSMA Blue','717ddeb73e5416325c1e698d3a90c637','kDefault','','0','0','0','251');
INSERT INTO `ms_trans_origin` VALUES ('252','11','1232','','','Погодная станция Oregon Scientific WMR500 All-In-One Wi-Fi','ee9d547aff82558cbe44978b16d8a602','kDefault','','0','0','0','252');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_u_files_info_value`
--

DROP TABLE IF EXISTS `ms_u_files_info_value`;

CREATE TABLE `ms_u_files_info_value` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `base_id` int unsigned DEFAULT NULL,
  `user_id` int unsigned DEFAULT NULL,
  `elem_id` int unsigned DEFAULT NULL,
  `kind_key` char(100) NOT NULL DEFAULT '',
  `file_name` char(100) NOT NULL DEFAULT '',
  `file_size` int unsigned NOT NULL DEFAULT '0',
  `upload_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `upload_ok` tinyint unsigned NOT NULL DEFAULT '0',
  `real_name` char(255) NOT NULL DEFAULT '',
  `parent_id` int unsigned DEFAULT NULL,
  `format_xml` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `pos` int unsigned NOT NULL DEFAULT '0',
  UNIQUE KEY `user_id` (`user_id`,`id`),
  KEY `elem_id` (`elem_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_u_files_info_value`
--

LOCK TABLES `ms_u_files_info_value` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_u_files_store`
--

DROP TABLE IF EXISTS `ms_u_files_store`;

CREATE TABLE `ms_u_files_store` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `base_id` int unsigned DEFAULT NULL,
  `user_id` int unsigned DEFAULT NULL,
  `elem_id` int unsigned DEFAULT NULL,
  `kind_key` char(100) NOT NULL DEFAULT '',
  `file_name` char(100) NOT NULL DEFAULT '',
  `file_size` int unsigned NOT NULL DEFAULT '0',
  `upload_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `upload_ok` tinyint unsigned NOT NULL DEFAULT '0',
  `real_name` char(255) NOT NULL DEFAULT '',
  `parent_id` int unsigned DEFAULT NULL,
  `format_xml` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `pos` int unsigned NOT NULL DEFAULT '0',
  UNIQUE KEY `user_id` (`user_id`,`id`),
  KEY `elem_id` (`elem_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_u_files_store`
--

LOCK TABLES `ms_u_files_store` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_u_info_value`
--

DROP TABLE IF EXISTS `ms_u_info_value`;

CREATE TABLE `ms_u_info_value` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `user_id` int unsigned DEFAULT NULL,
  `base_id` int unsigned DEFAULT NULL,
  `was_update` tinyint unsigned NOT NULL DEFAULT '0',
  `info_id` int unsigned DEFAULT NULL,
  `name` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `descr` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `kind_key` char(100) NOT NULL DEFAULT '',
  `params` char(255) NOT NULL DEFAULT '',
  `seo_code` char(255) NOT NULL DEFAULT '',
  `pos` int unsigned NOT NULL DEFAULT '0',
  UNIQUE KEY `user_id` (`user_id`,`id`),
  KEY `base_id` (`base_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_u_info_value`
--

LOCK TABLES `ms_u_info_value` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_u_store`
--

DROP TABLE IF EXISTS `ms_u_store`;

CREATE TABLE `ms_u_store` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `user_id` int unsigned DEFAULT NULL,
  `base_id` int unsigned DEFAULT NULL,
  `was_update` tinyint unsigned NOT NULL DEFAULT '0',
  `was_edit` tinyint unsigned NOT NULL DEFAULT '0',
  `provider_id` int unsigned DEFAULT NULL,
  `brand_id` int unsigned DEFAULT NULL,
  `code_shop` char(255) NOT NULL DEFAULT '',
  `code_prov` char(255) NOT NULL DEFAULT '',
  `code_made` char(255) NOT NULL DEFAULT '',
  `meas` char(32) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `intro` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `descr` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `review` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `no_visible` tinyint unsigned NOT NULL DEFAULT '0',
  `status_key` char(100) NOT NULL DEFAULT '',
  `kind_key` char(100) NOT NULL DEFAULT '',
  `state_key` char(100) NOT NULL DEFAULT '',
  `clann` int unsigned NOT NULL DEFAULT '0',
  `clann_title` char(255) NOT NULL DEFAULT '',
  `clann_descr` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `clann_root` tinyint unsigned NOT NULL DEFAULT '0',
  `relate_id` int unsigned NOT NULL DEFAULT '0',
  `price` decimal(10,2) NOT NULL DEFAULT '0.00',
  `price_curr_id` int unsigned DEFAULT NULL,
  `seo_psu` char(255) NOT NULL DEFAULT '',
  `seo_title` char(255) NOT NULL DEFAULT '',
  `templ_key` char(100) NOT NULL DEFAULT '',
  `create_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `update_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `exist_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `edit_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  `option_code` text NOT NULL DEFAULT (_utf8mb3''),
  UNIQUE KEY `user_id` (`user_id`,`id`),
  KEY `base_id` (`base_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_u_store`
--

LOCK TABLES `ms_u_store` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_u_store_info`
--

DROP TABLE IF EXISTS `ms_u_store_info`;

CREATE TABLE `ms_u_store_info` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `user_id` int unsigned DEFAULT NULL,
  `store_id` int unsigned DEFAULT NULL,
  `info_id` int unsigned DEFAULT NULL,
  `value_id` int unsigned DEFAULT NULL,
  `value_dec` decimal(10,4) NOT NULL DEFAULT '0.0000',
  `value_txt` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  UNIQUE KEY `user_id` (`user_id`,`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_u_store_info`
--

LOCK TABLES `ms_u_store_info` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_u_store_set`
--

DROP TABLE IF EXISTS `ms_u_store_set`;

CREATE TABLE `ms_u_store_set` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `user_id` int unsigned DEFAULT NULL,
  `store_id` int unsigned DEFAULT NULL,
  `obj_key` char(100) NOT NULL DEFAULT '',
  `kind_key` char(100) NOT NULL DEFAULT '',
  `elem_id` int unsigned DEFAULT NULL,
  `params` char(255) NOT NULL DEFAULT '',
  `comment` char(255) NOT NULL DEFAULT '',
  `pos` int unsigned NOT NULL DEFAULT '0',
  UNIQUE KEY `user_id` (`user_id`,`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_u_store_set`
--

LOCK TABLES `ms_u_store_set` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_u_topic_store`
--

DROP TABLE IF EXISTS `ms_u_topic_store`;

CREATE TABLE `ms_u_topic_store` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `user_id` int unsigned DEFAULT NULL,
  `base_id` int unsigned DEFAULT NULL,
  `topic_id` int unsigned DEFAULT NULL,
  `store_id` int unsigned DEFAULT NULL,
  `pos` int unsigned NOT NULL DEFAULT '0',
  UNIQUE KEY `user_id` (`user_id`,`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_u_topic_store`
--

LOCK TABLES `ms_u_topic_store` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_user`
--

DROP TABLE IF EXISTS `ms_user`;

CREATE TABLE `ms_user` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `group_id` int unsigned DEFAULT NULL,
  `login` char(100) NOT NULL DEFAULT '',
  `pass_code` char(32) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `phone` char(255) NOT NULL DEFAULT '',
  `email` char(255) NOT NULL DEFAULT '',
  `params` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `add_group_id` int unsigned DEFAULT NULL,
  `is_blocked` tinyint unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `group_id` (`group_id`),
  KEY `add_group_id` (`add_group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_user`
--

LOCK TABLES `ms_user` WRITE;
INSERT INTO `ms_user` VALUES ('1','1','admin','21232f297a57a5a743894a0e4a801fc3','Администратор','','','',NULL,'0');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_user_chat`
--

DROP TABLE IF EXISTS `ms_user_chat`;

CREATE TABLE `ms_user_chat` (
  `user_id` int unsigned DEFAULT NULL,
  `to_user_id` int unsigned DEFAULT NULL,
  `message_txt` text NOT NULL DEFAULT (_utf8mb3''),
  `date_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  KEY `date_time` (`date_time`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_user_chat`
--

LOCK TABLES `ms_user_chat` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_user_file_version`
--

DROP TABLE IF EXISTS `ms_user_file_version`;

CREATE TABLE `ms_user_file_version` (
  `id` int unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int unsigned DEFAULT NULL,
  `path` char(255) NOT NULL DEFAULT '',
  `content` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `version` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`),
  KEY `path` (`path`(50))
) ENGINE=MyISAM AUTO_INCREMENT=689 DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_user_file_version`
--

LOCK TABLES `ms_user_file_version` WRITE;
INSERT INTO `ms_user_file_version` VALUES ('1','1','./../index.php','<?php
/***************************************************************************************************
 * 
 * index.php - index page
 * 
 ***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/                             

// Require
require_once(\'config.php\');
require_once(\'units/melbis_inc.php\');

// Create connect with DataBase 
$gDb = new MySql(\'MELBIS_INC_halt\');
$gDb->Connect(__FILE__, __LINE__);

// Create Parser
$gParser = new Parser(\'MELBIS_INC_halt\', $gDb);

// Define self constants
$gParser->DefineSelfConst();

// Define session
$gSession = $gParser->DefineSession(DB_USER_NAME.\'_MELBIS_SHOP\');

// Define lazy load script
$gParser->DefineLazyScript($gSitePath.\'/lazy.php\');

// Get languges
$command = \"SELECT * FROM ms_lang\";               
$langs = $gParser->SqlSelect(__LINE__, $command);
foreach ($langs as $lang)
{
    $gLangList[] = $lang[\'skey\'];   
}

// Set active language      
$gLang = $gGet[\'lang\'] ?? \'en\';
if ( !in_array($gLang, $gLangList) ) $gLang = \'en\';

// Define module
if ( isset($gGet[\'topic_id\']) ) $gGet[\'mod\'] = \'melbis_base_topic\';
if ( !isset($gGet[\'mod\']) ) $gGet[\'mod\'] = \'melbis_base_index\'; 

// Parse
$gParser->Parse($gSitePath, $gTemplate, $gGet[\'mod\'], [serialize($gGet), serialize($gPost)], $gUseCache, $gBuild);

// Publish
$gParser->Publish();

// Possible report
$gParser->Report();

?>','2025-03-28 12:00:03');
INSERT INTO `ms_user_file_version` VALUES ('2','1','./../index.php','<?php
/***************************************************************************************************
 * 
 * index.php - index page
 * 
 ***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/                             

// Require
require_once(\'config.php\');
require_once(\'units/melbis_inc.php\');

// Create connect with DataBase 
$gDb = new MySql(\'MELBIS_INC_halt\');
$gDb->Connect(__FILE__, __LINE__);

// Create Parser
$gParser = new Parser(\'MELBIS_INC_halt\', $gDb);

// Define self constants
$gParser->DefineSelfConst();

// Define session
$gSession = $gParser->DefineSession(DB_USER_NAME.\'_MELBIS_SHOP\');

// Define lazy load script
$gParser->DefineLazyScript($gSitePath.\'/lazy.php\');

// Get languges
$command = \"SELECT * FROM ms_lang\";               
$langs = $gParser->SqlSelect(__LINE__, $command);
foreach ($langs as $lang)
{
    $gLangList[] = $lang[\'skey\'];   
}

// Set active language      
$gLang = $gGet[\'lang\'] ?? \'en\';
if ( !in_array($gLang, $gLangList) ) $gLang = \'en\';

// Define module
if ( !isset($gGet[\'mod\']) ) $gGet[\'mod\'] = \'melbis_base_index\'; 

// Parse
$gParser->Parse($gSitePath, $gTemplate, $gGet[\'mod\'], [$gLang, ($gGet), serialize($gPost)], $gUseCache, $gBuild);

// Publish
$gParser->Publish();

// Possible report
$gParser->Report();

?>','2025-03-28 12:00:28');
INSERT INTO `ms_user_file_version` VALUES ('3','1','./../.htaccess','# Basic rules
AddDefaultCharset UTF-8
DirectoryIndex index.html index.htm index.php
Options -Indexes

ErrorDocument 404 /en/404/

RewriteEngine on

# Default
RewriteRule ^$ /en/ [L,R=301]






','2025-03-28 12:04:44');
INSERT INTO `ms_user_file_version` VALUES ('4','1','./../.htaccess','# Basic rules
AddDefaultCharset UTF-8
DirectoryIndex index.html index.htm index.php
Options -Indexes

ErrorDocument 404 /en/404/

RewriteEngine on

# Default
RewriteRule ^$ /en/ [L,R=301]

# Base page  
RewriteRule ^([a-z]{2})/$ index.php?lang=$1 [L,QSA]





','2025-03-28 12:05:34');
INSERT INTO `ms_user_file_version` VALUES ('5','1','./../.htaccess','# Basic rules
AddDefaultCharset UTF-8
DirectoryIndex index.html index.htm index.php
Options -Indexes

ErrorDocument 404 /en/404/

RewriteEngine on

# Default
RewriteRule ^$ /en/ [L,R=301]

# Base page  
RewriteRule ^([a-z]{2})/$ index.php?lang=$1 [L,QSA]

# Modules
RewriteRule ^([a-z]{2})\\/([A-Za-z0-9_\\-]+)\\.php$ $2.php?lang=$1 [L,QSA]

# Core
RewriteRule ^core\\/([A-Za-z0-9_\\-\\.\\+]+)\\/$ index.php?mod=kasdim_core_$1 [L,B,QSA]

# Cataloge pages
RewriteCond %{REQUEST_FILENAME} !-d
RewriteCond %{REQUEST_FILENAME} !-f
RewriteRule ^([a-z]{2})\\/(.+)$ index.php?mod=melbis_base_page&psu=$2&lang=$1 [L,QSA]






','2025-03-28 12:07:17');
INSERT INTO `ms_user_file_version` VALUES ('6','1','./../index.php','<?php
/***************************************************************************************************
 * 
 * index.php - index page
 * 
 ***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/                             

// Require
require_once(\'config.php\');
require_once(\'units/melbis_inc.php\');

// Create connect with DataBase 
$gDb = new MySql(\'MELBIS_INC_halt\');
$gDb->Connect(__FILE__, __LINE__);

// Create Parser
$gParser = new Parser(\'MELBIS_INC_halt\', $gDb);

// Define self constants
$gParser->DefineSelfConst();

// Define session
$gSession = $gParser->DefineSession(DB_USER_NAME.\'_MELBIS_SHOP\');

// Define lazy load script
$gParser->DefineLazyScript($gSitePath.\'/lazy.php\');

// Get languges
$command = \"SELECT * FROM ms_lang\";               
$langs = $gParser->SqlSelect(__LINE__, $command);
foreach ($langs as $lang)
{
    $gLangList[] = $lang[\'skey\'];   
}

// Set active language      
$gLang = $gGet[\'lang\'] ?? \'en\';
if ( !in_array($gLang, $gLangList) ) $gLang = \'en\';

// Define module
if ( !isset($gGet[\'mod\']) ) $gGet[\'mod\'] = \'melbis_base_index\'; 

// Parse
$gParser->Parse($gSitePath, $gTemplate, $gGet[\'mod\'], [$gLang, serialize($gGet), serialize($gPost)], $gUseCache, $gBuild);

// Publish
$gParser->Publish();

// Possible report
$gParser->Report();

?>','2025-03-28 12:09:07');
INSERT INTO `ms_user_file_version` VALUES ('7','1','./../.htaccess','# Basic rules
AddDefaultCharset UTF-8
DirectoryIndex index.html index.htm index.php
Options -Indexes

ErrorDocument 404 /en/404/

RewriteEngine on

# Language auto 
RewriteCond %{HTTP:Accept-Language} ^en [NC]
RewriteRule ^$ /en/ [L,R=301]

RewriteCond %{HTTP:Accept-Language} ^ru [NC]
RewriteRule ^$ /ru/ [L,R=301]

RewriteCond %{HTTP:Accept-Language} ^uk [NC]
RewriteRule ^$ /uk/ [L,R=301]

# Default
RewriteRule ^$ /en/ [L,R=301]

# Base page  
RewriteRule ^([a-z]{2})/$ index.php?lang=$1 [L,QSA]

# Modules
RewriteRule ^([a-z]{2})\\/([A-Za-z0-9_\\-]+)\\.php$ $2.php?lang=$1 [L,QSA]

# Core
RewriteRule ^core\\/([A-Za-z0-9_\\-\\.\\+]+)\\/$ index.php?mod=kasdim_core_$1 [L,B,QSA]

# Cataloge pages
RewriteCond %{REQUEST_FILENAME} !-d
RewriteCond %{REQUEST_FILENAME} !-f
RewriteRule ^([a-z]{2})\\/(.+)$ index.php?mod=melbis_base_page&psu=$2&lang=$1 [L,QSA]






','2025-03-28 12:10:20');
INSERT INTO `ms_user_file_version` VALUES ('8','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Sample DB Query
    /*
    $command = \"SELECT *
                  FROM ms_store
                 WHERE id > \'$mVars[var_name_1]\'
              ORDER BY id
                \";                    
    $store = $gParser->SqlSelect(__LINE__, $command);
    foreach ($store as $row)
    {
        $gParser->TplAssign($tpl, array(\'ID\'   => $row[\'id\'],
                                        \'NAME\' => htmlspecialchars($row[\'name\']),
                                        \'INFO\' => $mVars[\'var_name_2\']
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }
    */

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-28 12:15:17');
INSERT INTO `ms_user_file_version` VALUES ('9','1','./../templates/default/units/melbis_base_page/404.htm','<div class=\"container\">             
    <div class=\"jumbotron\">
        <h1 class=\"display-3 text-danger\">{TAG_404_NAME}</h1>
        <p class=\"lead\">{TAG_404_TXT}</p>
        <hr class=\"my-4\">
        <div class=\"text-center\">      
            <i class=\"fas fa-bug text-muted\" style=\"font-size: 200pt\"></i>
        </div>            
    </div>                
</div>      



','2025-03-28 12:38:32');
INSERT INTO `ms_user_file_version` VALUES ('10','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[KASDIM:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:kasdim_base_head(page)}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {MELBIS:kasdim_base_header([KASDIM:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {MELBIS:kasdim_base_footer([KASDIM:VAR:LANG])}
    
    </body>
</html>
','2025-03-28 12:38:49');
INSERT INTO `ms_user_file_version` VALUES ('11','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Auto image preview
//==================================================================================================

// Get image
$(\'main\').on(\'click\', \'.img_preview\', function() 
{
    if ( $(this).hasClass(\'img_max\') )
    {
        $(\'#kasdim_win_imageview img\').removeClass(\'img-fluid\').addClass(\'kasdim_css_img_detail\');    
    }                                                            
    else
    {
        $(\'#kasdim_win_imageview img\').addClass(\'img-fluid\').removeClass(\'kasdim_css_img_detail\');
    }
    $(\'#kasdim_win_imageview img\').attr(\'src\', $(this).attr(\'src\'));
                     
    $(\'#kasdim_win_imageview\').modal(\'show\'); 
});


// Get prev image 
$(\'#kasdim_win_imageview .prev\').on(\'click\', function() 
{        
    var src = $(\'#kasdim_win_imageview img\').attr(\'src\');
    $(\'main .img_preview\').each(function(i)
    {        
        if ( src == $(this).attr(\'src\') )                         
        {            
            if ( i > 0 )
            {
                src =  $(\'main .img_preview\').eq(i-1).attr(\'src\');
                if ( $(\'main .img_preview\').eq(i-1).hasClass(\'img_max\') )
                {
                    $(\'#kasdim_win_imageview img\').removeClass(\'img-fluid\').addClass(\'kasdim_css_img_detail\');    
                }                                                            
                else
                {
                    $(\'#kasdim_win_imageview img\').addClass(\'img-fluid\').removeClass(\'kasdim_css_img_detail\');
                }              
            }
            return false;             
        }          
    }); 
    $(\'#kasdim_win_imageview img\').attr(\'src\', src);            
});


// Get next image 
$(\'#kasdim_win_imageview .next\').on(\'click\', function() 
{            
    var src = $(\'#kasdim_win_imageview img\').attr(\'src\');
    $(\'main .img_preview\').each(function(i)
    {                        
        if ( src == $(this).attr(\'src\') && i < $(\'main .img_preview\').length )                         
        {                        
            src =  $(\'main .img_preview\').eq(i+1).attr(\'src\');
            if ( $(\'main .img_preview\').eq(i+1).hasClass(\'img_max\') )
            {
                $(\'#kasdim_win_imageview img\').removeClass(\'img-fluid\').addClass(\'kasdim_css_img_detail\');    
            }                                                            
            else
            {
                $(\'#kasdim_win_imageview img\').addClass(\'img-fluid\').removeClass(\'kasdim_css_img_detail\');
            }                 
            return false;             
        }          
    });    
    $(\'#kasdim_win_imageview img\').attr(\'src\', src);
});


// Close preview 
$(\'#kasdim_win_imageview img\').on(\'click\', function() 
{            
    $(\'#kasdim_win_imageview\').modal(\'hide\');
});
     

</script>','2025-03-28 12:39:16');
INSERT INTO `ms_user_file_version` VALUES ('12','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__);   
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        $gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'kasdim\'][\'page\'][\'id\'] = 0;
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Print
        $gParser->gVars[\'kasdim\'][\'page\'] = $topic; 
        
        
            
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0 
                           AND s.kind_key LIKE \'kPage%\'
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Blank      
                $gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'BLANK_TITLE\');
                $gParser->gVars[\'kasdim\'][\'page\'][\'descr\'] = \'\';
                $gParser->TplParse($tpl, \'CONTENT\', \'blank\');  
            }           
            else
            {
                // Content   
                $gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                $gParser->gVars[\'kasdim\'][\'page\'][\'descr\'] = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'intro\']);
                $consist = KASDIM_INC_LANG(\'kTopic\', \'CONSIST\', $page[\'id\'], $page[\'descr\'], true);                                            
                $gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                                           \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  
            
                // Page type   
                switch ($page[\'kind_key\']) 
                {
                    case \'kPage\':                 
                        // Simple                                       
                        $gParser->TplParse($tpl, \'CONTENT\', \'content\');                
                        break;
                    case \'kPageFluid\':
                        // Fluid
                        $gParser->TplParse($tpl, \'CONTENT\', \'content_fluid\');                
                        break;
                    case \'kPageMenu\':
                        // Menu
                        $gParser->TplParse($tpl, \'CONTENT\', \'content_menu\');   
                        break;
                    default:
                    $gParser->TplAssign($tpl, \'CONTENT\', \'\');
                }    
            } 
        }                
    }           
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-28 12:47:48');
INSERT INTO `ms_user_file_version` VALUES ('13','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__);   
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        $gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'kasdim\'][\'page\'][\'id\'] = 0;
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'kasdim\'][\'page\'] = $topic;
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\')
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                $gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                                           \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kText\' )  
        {
        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-28 13:33:25');
INSERT INTO `ms_user_file_version` VALUES ('14','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__);   
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        $gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'kasdim\'][\'page\'][\'id\'] = 0;
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'kasdim\'][\'page\'] = $topic;
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\')
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                $gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                                           \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-28 13:43:11');
INSERT INTO `ms_user_file_version` VALUES ('15','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MELBIS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:kasdim_base_head(page)}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {MELBIS:kasdim_base_header([MELBIS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {MELBIS:kasdim_base_footer([MELBIS:VAR:LANG])}
    
    </body>
</html>
','2025-03-28 13:47:43');
INSERT INTO `ms_user_file_version` VALUES ('16','1','./../index.php','<?php
/***************************************************************************************************
 * 
 * index.php - index page
 * 
 ***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/                             

// Require
require_once(\'config.php\');
require_once(\'units/melbis_inc.php\');

// Create connect with DataBase 
$gDb = new MySql(\'MELBIS_INC_halt\');
$gDb->Connect(__FILE__, __LINE__);

// Create Parser
$gParser = new Parser(\'MELBIS_INC_halt\', $gDb);

// Define self constants
$gParser->DefineSelfConst();

// Define session
$gSession = $gParser->DefineSession(DB_USER_NAME.\'_MELBIS_SHOP\');

// Define lazy load script
$gParser->DefineLazyScript($gSitePath.\'/lazy.php\');

// Set languges
$command = \"SELECT * FROM ms_lang\";               
$langs = $gParser->SqlSelect(__LINE__, $command);
$gLangList = [];
foreach ($langs as $lang)
{
    $gLangList[] = $lang[\'skey\'];   
}

// Set active language      
$gLang = $gGet[\'lang\'] ?? \'en\';
if ( !in_array($gLang, $gLangList) ) $gLang = \'en\';

// Define module
if ( !isset($gGet[\'mod\']) ) $gGet[\'mod\'] = \'melbis_base_index\'; 

// Parse
$gParser->Parse($gSitePath, $gTemplate, $gGet[\'mod\'], [$gLang, serialize($gGet), serialize($gPost)], $gUseCache, $gBuild);

// Publish
$gParser->Publish();

// Possible report
$gParser->Report();

?>','2025-03-28 13:53:50');
INSERT INTO `ms_user_file_version` VALUES ('17','1','./../index.php','<?php
/***************************************************************************************************
 * 
 * index.php - index page
 * 
 ***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/                             

// Require
require_once(\'config.php\');
require_once(\'units/melbis_inc.php\');

// Create connect with DataBase 
$gDb = new MySql(\'MELBIS_INC_halt\');
$gDb->Connect(__FILE__, __LINE__);

// Create Parser
$gParser = new Parser(\'MELBIS_INC_halt\', $gDb);

// Define self constants
$gParser->DefineSelfConst();

// Define session
$gSession = $gParser->DefineSession(DB_USER_NAME.\'_MELBIS_SHOP\');

// Define lazy load script
$gParser->DefineLazyScript($gSitePath.\'/lazy.php\');

// Set languges
$command = \"SELECT * FROM ms_lang\";               
$langs = $gParser->SqlSelect(__LINE__, $command);
$gLangList = [];
foreach ($langs as $lang)
{
    $gLangList[] = $lang[\'skey\'];   
}

// Set active language      
$gLang = $gGet[\'lang\'] ?? \'en\';
if ( !in_array($gLang, $gLangList) ) $gLang = \'en\';

// Define module
if ( !isset($gGet[\'mod\']) ) $gGet[\'mod\'] = \'melbis_base_page\'; 

// Parse
$gParser->Parse($gSitePath, $gTemplate, $gGet[\'mod\'], [$gLang, serialize($gGet), serialize($gPost)], $gUseCache, $gBuild);

// Publish
$gParser->Publish();

// Possible report
$gParser->Report();

?>','2025-03-28 13:54:30');
INSERT INTO `ms_user_file_version` VALUES ('18','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__);   
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        $gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'kasdim\'][\'page\'][\'id\'] = 0;
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'kasdim\'][\'page\'] = $topic;
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                $gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                                           \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-28 13:54:41');
INSERT INTO `ms_user_file_version` VALUES ('19','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__);   
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        $gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'kasdim\'][\'page\'][\'id\'] = 0;
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'kasdim\'][\'page\'] = $topic;
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                $gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                                           \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-28 13:54:58');
INSERT INTO `ms_user_file_version` VALUES ('20','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__);   
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        $gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'kasdim\'][\'page\'][\'id\'] = 0;
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'kasdim\'][\'page\'] = $topic;
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                $gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                                           \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-28 13:55:55');
INSERT INTO `ms_user_file_version` VALUES ('21','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__);   
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'kasdim\'][\'page\'][\'id\'] = 0;
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'kasdim\'][\'page\'] = $topic;
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                $gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                                           \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-28 13:56:07');
INSERT INTO `ms_user_file_version` VALUES ('22','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MELBIS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:kasdim_base_head(page)}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {MELBIS:melbis_base_header([MELBIS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {MELBIS:melbis_base_footer([MELBIS:VAR:LANG])}
    
    </body>
</html>
','2025-03-28 13:56:32');
INSERT INTO `ms_user_file_version` VALUES ('23','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MELBIS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head(page)}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {MELBIS:melbis_base_header([MELBIS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {MELBIS:melbis_base_footer([MELBIS:VAR:LANG])}
    
    </body>
</html>
','2025-03-28 13:56:46');
INSERT INTO `ms_user_file_version` VALUES ('24','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\"></span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy;  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\"><div class=\"d-none d-sm-block\">{TAG_CHANNEL}</div></div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-28 14:01:29');
INSERT INTO `ms_user_file_version` VALUES ('25','1','./../units/melbis_base_head.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_HEAD
 **/
function MELBIS_BASE_HEAD($mVars)
{ 
    global $gParser, $gLang, $gLangList;
                       
    // Create 
    $tpl = $gParser->TplCreate();           
                     
    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__);    
    
    // Alternate languages
    foreach ( $gLangList as $lang )
    {
        $gParser->TplAssign($tpl, \'LANG\', $lang);
        $gParser->TplParse($tpl, \'ALTER\', \'.alter\');
    }    
    
    // Meta kind
    $gParser->TplParse($tpl, \'META\', \'meta_\'.$mVars[\'type\']);
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 




?>','2025-03-28 14:50:10');
INSERT INTO `ms_user_file_version` VALUES ('26','1','./../templates/default/units/melbis_base_head/main.htm','<head>
    <meta charset=\"utf8mb4\">          
    <meta name=\"generator\" content=\"Melbis Shop v6.4.0\">        
    <meta name=\"author\" content=\"{TAG_AUTHOR}\">
    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1, shrink-to-fit=no\">  
    <meta http-equiv=\"Last-Modified\" content=\"{LASTMODIFY}\">                    
    {META}       
</head>','2025-03-28 14:50:14');
INSERT INTO `ms_user_file_version` VALUES ('27','1','./../templates/default/units/melbis_base_head/alter.htm','<link rel=\"alternate\" hreflang=\"{LANG}\" href=\"/{LANG}{KASDIM:PAGE:PATH}\" />
','2025-03-28 14:54:01');
INSERT INTO `ms_user_file_version` VALUES ('28','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__);   
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'kasdim\'][\'page\'][\'id\'] = 0;
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'kasdim\'][\'page\'] = $topic;
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                //$gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                  //                         \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-28 17:09:51');
INSERT INTO `ms_user_file_version` VALUES ('29','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MELBIS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head()}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {MELBIS:melbis_base_header([MELBIS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {MELBIS:melbis_base_footer([MELBIS:VAR:LANG])}
    
    </body>
</html>
','2025-03-28 17:10:15');
INSERT INTO `ms_user_file_version` VALUES ('30','1','./../index.php','<?php
/***************************************************************************************************
 * 
 * index.php - index page
 * 
 ***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/                             

// Require
require_once(\'config.php\');
require_once(\'units/melbis_inc.php\');

// Create connect with DataBase 
$gDb = new MySql(\'MELBIS_INC_halt\');
$gDb->Connect(__FILE__, __LINE__);

// Create Parser
$gParser = new Parser(\'MELBIS_INC_halt\', $gDb);

// Define self constants
$gParser->DefineSelfConst();

$gParser->DefineSelfVars(\'CONST\');


// Define session
$gSession = $gParser->DefineSession(DB_USER_NAME.\'_MELBIS_SHOP\');

// Define lazy load script
$gParser->DefineLazyScript($gSitePath.\'/lazy.php\');

// Set languges
$command = \"SELECT * FROM ms_lang\";               
$langs = $gParser->SqlSelect(__LINE__, $command);
$gLangList = [];
foreach ($langs as $lang)
{
    $gLangList[] = $lang[\'skey\'];   
}

// Set active language      
$gLang = $gGet[\'lang\'] ?? \'en\';
if ( !in_array($gLang, $gLangList) ) $gLang = \'en\';

// Define module
if ( !isset($gGet[\'mod\']) ) $gGet[\'mod\'] = \'melbis_base_page\'; 

// Parse
$gParser->Parse($gSitePath, $gTemplate, $gGet[\'mod\'], [$gLang, serialize($gGet), serialize($gPost)], $gUseCache, $gBuild);

// Publish
$gParser->Publish();

// Possible report
$gParser->Report();

?>','2025-03-28 17:29:35');
INSERT INTO `ms_user_file_version` VALUES ('31','1','./../index.php','<?php
/***************************************************************************************************
 * 
 * index.php - index page
 * 
 ***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/                             

// Require
require_once(\'config.php\');
require_once(\'units/melbis_inc.php\');

// Create connect with DataBase 
$gDb = new MySql(\'MELBIS_INC_halt\');
$gDb->Connect(__FILE__, __LINE__);

// Create Parser
$gParser = new Parser(\'MELBIS_INC_halt\', $gDb);

// Define self constants
$gParser->DefineSelfConst();

$gParser->DefineSelfVars(\'CONST\');
echo \"SDFSFD\";

// Define session
$gSession = $gParser->DefineSession(DB_USER_NAME.\'_MELBIS_SHOP\');

// Define lazy load script
$gParser->DefineLazyScript($gSitePath.\'/lazy.php\');

// Set languges
$command = \"SELECT * FROM ms_lang\";               
$langs = $gParser->SqlSelect(__LINE__, $command);
$gLangList = [];
foreach ($langs as $lang)
{
    $gLangList[] = $lang[\'skey\'];   
}

// Set active language      
$gLang = $gGet[\'lang\'] ?? \'en\';
if ( !in_array($gLang, $gLangList) ) $gLang = \'en\';

// Define module
if ( !isset($gGet[\'mod\']) ) $gGet[\'mod\'] = \'melbis_base_page\'; 

// Parse
$gParser->Parse($gSitePath, $gTemplate, $gGet[\'mod\'], [$gLang, serialize($gGet), serialize($gPost)], $gUseCache, $gBuild);

// Publish
$gParser->Publish();

// Possible report
$gParser->Report();

?>','2025-03-28 17:30:41');
INSERT INTO `ms_user_file_version` VALUES ('32','1','./../index.php','<?php
/***************************************************************************************************
 * 
 * index.php - index page
 * 
 ***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/                             

// Require
require_once(\'config.php\');
require_once(\'units/melbis_inc.php\');

// Create connect with DataBase 
$gDb = new MySql(\'MELBIS_INC_halt\');
$gDb->Connect(__FILE__, __LINE__);

// Create Parser
$gParser = new Parser(\'MELBIS_INC_halt\', $gDb);

// Define self constants
$gParser->DefineSelfConst();

$gParser->DefineSelfVars(\'CONST\');

// Define session
$gSession = $gParser->DefineSession(DB_USER_NAME.\'_MELBIS_SHOP\');

// Define lazy load script
$gParser->DefineLazyScript($gSitePath.\'/lazy.php\');

// Set languges
$command = \"SELECT * FROM ms_lang\";               
$langs = $gParser->SqlSelect(__LINE__, $command);
$gLangList = [];
foreach ($langs as $lang)
{
    $gLangList[] = $lang[\'skey\'];   
}

// Set active language      
$gLang = $gGet[\'lang\'] ?? \'en\';
if ( !in_array($gLang, $gLangList) ) $gLang = \'en\';

// Define module
if ( !isset($gGet[\'mod\']) ) $gGet[\'mod\'] = \'melbis_base_page\'; 

// Parse
$gParser->Parse($gSitePath, $gTemplate, $gGet[\'mod\'], [$gLang, serialize($gGet), serialize($gPost)], $gUseCache, $gBuild);

// Publish
$gParser->Publish();

// Possible report
$gParser->Report();

?>','2025-03-28 17:31:32');
INSERT INTO `ms_user_file_version` VALUES ('33','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MELBIS:VAR:LANG]\" class=\"h-100\">
    
    {1MELBIS:melbis_base_head()}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {1MELBIS:melbis_base_header([MELBIS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {1MELBIS:melbis_base_footer([MELBIS:VAR:LANG])}
    
    </body>
</html>
','2025-03-28 17:31:48');
INSERT INTO `ms_user_file_version` VALUES ('34','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MELBIS:VAR:LANG]\" class=\"h-100\">
    
    {1MELBIS:melbis_base_head()}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {1MELBIS:melbis_base_header([MELBIS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   {CONST:MELBIS_SHOP_DOMAIN}
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {1MELBIS:melbis_base_footer([MELBIS:VAR:LANG])}
    
    </body>
</html>
','2025-03-28 17:36:03');
INSERT INTO `ms_user_file_version` VALUES ('35','1','./../templates/default/units/melbis_base_head/main.htm','<head>
    <meta charset=\"utf8mb4\">          
    <meta name=\"generator\" content=\"Melbis Shop v6.4.0\">        
    <meta name=\"author\" content=\"{TAG_AUTHOR}\">
    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1, shrink-to-fit=no\">  
    <meta http-equiv=\"Last-Modified\" content=\"{LASTMODIFY}\">                    
    <title>{KASDIM:PAGE:TITLE}</title>
    <meta name=\"description\" content=\"{KASDIM:PAGE:DESCR}\">
    <meta name=\"robots\" content=\"index,follow\">

    <link rel=\"canonical\" href=\"https://{CONST:MELBIS_SHOP_DOMAIN}/{KASDIM:VAR:LANG}{KASDIM:PAGE:PATH}\">
    <link rel=\"alternate\" hreflang=\"x-default\" href=\"https://{CONST:MELBIS_SHOP_DOMAIN}/en{KASDIM:PAGE:PATH}\" />
    {ALTER}     

    <link rel=\"icon\" href=\"{PATH}/images/icon.png\"> 
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/bootstrap.css\">  
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/icons/css/all.css\">
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/prism.css\">   
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/kasdim.css?{BUILD}\">

    <script src=\"{PATH}/jquery.js\"></script>      
    <script src=\"{PATH}/bootstrap.js\"></script>
    <script src=\"{PATH}/inputmask.js\"></script>
    <script src=\"{PATH}/bootbox.js\"></script>
    <script src=\"{PATH}/moment.js\"></script>         
    <script src=\"{PATH}/prism.js\"></script>   
    <script src=\"{PATH}/kasdim.js?{BUILD}\"></script>       
</head>','2025-03-28 17:37:19');
INSERT INTO `ms_user_file_version` VALUES ('36','1','./../index.php','<?php
/***************************************************************************************************
 * 
 * index.php - index page
 * 
 ***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/                             

// Require
require_once(\'config.php\');
require_once(\'units/melbis_inc.php\');

// Create connect with DataBase 
$gDb = new MySql(\'MELBIS_INC_halt\');
$gDb->Connect(__FILE__, __LINE__);

// Create Parser
$gParser = new Parser(\'MELBIS_INC_halt\', $gDb);

// Define self constants
$gParser->DefineSelfConst();
$gParser->DefineSelfVars(\'CONST\');

// Define session
$gSession = $gParser->DefineSession(DB_USER_NAME.\'_MELBIS_SHOP\');

// Define lazy load script
$gParser->DefineLazyScript($gSitePath.\'/lazy.php\');

// Set languges
$command = \"SELECT * FROM ms_lang\";               
$langs = $gParser->SqlSelect(__LINE__, $command);
$gLangList = [];
foreach ($langs as $lang)
{
    $gLangList[] = $lang[\'skey\'];   
}

// Set active language      
$gLang = $gGet[\'lang\'] ?? \'en\';
if ( !in_array($gLang, $gLangList) ) $gLang = \'en\';

// Define module
if ( !isset($gGet[\'mod\']) ) $gGet[\'mod\'] = \'melbis_base_page\'; 

// Parse
$gParser->Parse($gSitePath, $gTemplate, $gGet[\'mod\'], [$gLang, serialize($gGet), serialize($gPost)], $gUseCache, $gBuild);

// Publish
$gParser->Publish();

// Possible report
$gParser->Report();

?>','2025-03-28 17:39:59');
INSERT INTO `ms_user_file_version` VALUES ('37','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__); 
    
    // Vars
    $gParser->gVars[\'melbis\'][\'var\'][\'lang\'] = $gLang;
    $gParser->gVars[\'melbis\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'kasdim\'][\'page\'][\'id\'] = 0;
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'kasdim\'][\'page\'] = $topic;
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                //$gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                  //                         \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-28 17:41:26');
INSERT INTO `ms_user_file_version` VALUES ('38','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__); 
    
    // Vars
    $gParser->gVars[\'melbis\'][\'var\'][\'lang\'] = $gLang;        
    $gParser->gVars[\'melbis\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'kasdim\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'melbis\'][\'page\'][\'path\'] = \'/\';
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'kasdim\'][\'page\'] = $topic;  
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                //$gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                  //                         \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-28 17:43:48');
INSERT INTO `ms_user_file_version` VALUES ('39','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__); 
    
    // Vars
    $gParser->gVars[\'melbis\'][\'var\'][\'lang\'] = $gLang;        
    $gParser->gVars[\'melbis\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        //$gParser->gVars[\'melbis\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'melbis\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'melbis\'][\'page\'][\'path\'] = \'/\';
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'melbis\'][\'page\'] = $topic;  
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                //$gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                  //                         \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-28 17:44:15');
INSERT INTO `ms_user_file_version` VALUES ('40','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\"></span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MELBIS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\"><div class=\"d-none d-sm-block\">{TAG_CHANNEL}</div></div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-28 17:45:17');
INSERT INTO `ms_user_file_version` VALUES ('41','1','./../templates/default/units/melbis_base_head/main.htm','<head>
    <meta charset=\"utf8mb4\">          
    <meta name=\"generator\" content=\"Melbis Shop v6.4.0\">        
    <meta name=\"author\" content=\"{TAG_AUTHOR}\">
    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1, shrink-to-fit=no\">  
    <meta http-equiv=\"Last-Modified\" content=\"{LASTMODIFY}\">                    
    <title>{MELBIS:PAGE:TITLE}</title>
    <meta name=\"description\" content=\"{KASDIM:PAGE:DESCR}\">
    <meta name=\"robots\" content=\"index,follow\">

    <link rel=\"canonical\" href=\"https://{CONST:MELBIS_SHOP_DOMAIN}/{KASDIM:VAR:LANG}{KASDIM:PAGE:PATH}\">
    <link rel=\"alternate\" hreflang=\"x-default\" href=\"https://{CONST:MELBIS_SHOP_DOMAIN}/en{KASDIM:PAGE:PATH}\" />
    {ALTER}     

    <link rel=\"icon\" href=\"{PATH}/images/icon.png\"> 
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/bootstrap.css\">  
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/icons/css/all.css\">
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/prism.css\">   
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/kasdim.css?{BUILD}\">

    <script src=\"{PATH}/jquery.js\"></script>      
    <script src=\"{PATH}/bootstrap.js\"></script>
    <script src=\"{PATH}/inputmask.js\"></script>
    <script src=\"{PATH}/bootbox.js\"></script>
    <script src=\"{PATH}/moment.js\"></script>         
    <script src=\"{PATH}/prism.js\"></script>   
    <script src=\"{PATH}/kasdim.js?{BUILD}\"></script>       
</head>','2025-03-28 17:45:53');
INSERT INTO `ms_user_file_version` VALUES ('42','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__); 
    
    // Vars
    $gParser->gVars[\'const\'][\'var\'][\'lang\'] = $gLang;        
    $gParser->gVars[\'const\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        //$gParser->gVars[\'melbis\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'melbis\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'melbis\'][\'page\'][\'path\'] = \'/\';
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'melbis\'][\'page\'] = $topic;  
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                //$gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                  //                         \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-28 17:46:55');
INSERT INTO `ms_user_file_version` VALUES ('43','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\"></span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {CONST:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\"><div class=\"d-none d-sm-block\">{TAG_CHANNEL}</div></div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-28 17:47:24');
INSERT INTO `ms_user_file_version` VALUES ('44','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\"></span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\"><div class=\"d-none d-sm-block\">{TAG_CHANNEL}</div></div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-28 17:49:43');
INSERT INTO `ms_user_file_version` VALUES ('45','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__); 
    
    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $gLang;        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        //$gParser->gVars[\'melbis\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'ms\'][\'page\'] = $topic;  
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                //$gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                  //                         \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-28 17:51:30');
INSERT INTO `ms_user_file_version` VALUES ('46','1','./../templates/default/units/melbis_base_head/main.htm','<head>
    <meta charset=\"utf8mb4\">          
    <meta name=\"generator\" content=\"Melbis Shop v6.4.0\">        
    <meta name=\"author\" content=\"{TAG_AUTHOR}\">
    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1, shrink-to-fit=no\">  
    <meta http-equiv=\"Last-Modified\" content=\"{LASTMODIFY}\">                    
    <title>{MS:PAGE:TITLE}</title>
    <meta name=\"description\" content=\"{MS:PAGE:DESCR}\">
    <meta name=\"robots\" content=\"index,follow\">

    <link rel=\"canonical\" href=\"https://{CONST:MELBIS_SHOP_DOMAIN}/{MS:VAR:LANG}{MS:PAGE:PATH}\">
    <link rel=\"alternate\" hreflang=\"x-default\" href=\"https://{CONST:MELBIS_SHOP_DOMAIN}/en{MS:PAGE:PATH}\" />
    {ALTER}     

    <link rel=\"icon\" href=\"{PATH}/images/icon.png\"> 
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/bootstrap.css\">  
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/icons/css/all.css\">
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/prism.css\">   
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/kasdim.css?{BUILD}\">

    <script src=\"{PATH}/jquery.js\"></script>      
    <script src=\"{PATH}/bootstrap.js\"></script>
    <script src=\"{PATH}/inputmask.js\"></script>
    <script src=\"{PATH}/bootbox.js\"></script>
    <script src=\"{PATH}/moment.js\"></script>         
    <script src=\"{PATH}/prism.js\"></script>   
    <script src=\"{PATH}/kasdim.js?{BUILD}\"></script>       
</head>','2025-03-28 17:52:19');
INSERT INTO `ms_user_file_version` VALUES ('47','1','./../templates/default/units/melbis_base_head/main.htm','<head>
    <meta charset=\"utf8mb4\">          
    <meta name=\"generator\" content=\"Melbis Shop v6.4.0\">        
    <meta name=\"author\" content=\"{TAG_AUTHOR}\">
    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1, shrink-to-fit=no\">  
    <meta http-equiv=\"Last-Modified\" content=\"{LASTMODIFY}\">                    
    <title>{MS:PAGE:TITLE}</title>
    <meta name=\"description\" content=\"{MS:PAGE:DESCR}\">
    <meta name=\"robots\" content=\"index,follow\">

    <link rel=\"canonical\" href=\"https://{CONST:MELBIS_SHOP_DOMAIN}/{MS:VAR:LANG}{MS:PAGE:PATH}\">
    <link rel=\"alternate\" hreflang=\"x-default\" href=\"https://{CONST:MELBIS_SHOP_DOMAIN}/en{MS:PAGE:PATH}\" />
    {ALTER}     

    <link rel=\"icon\" href=\"{PATH}/images/icon.png\"> 
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/bootstrap.css\">  
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/icons/css/all.css\">
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/prism.css\">   
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/kasdim.css?{BUILD}\">

    <script src=\"{PATH}/jquery.js\"></script>      
    <script src=\"{PATH}/bootstrap.js\"></script>
    <script src=\"{PATH}/inputmask.js\"></script>
    <script src=\"{PATH}/bootbox.js\"></script>
    <script src=\"{PATH}/moment.js\"></script>         
    <script src=\"{PATH}/prism.js\"></script>   
    <script src=\"{PATH}/kasdim.js?{BUILD}\"></script>       
</head>','2025-03-28 17:52:33');
INSERT INTO `ms_user_file_version` VALUES ('48','1','./../templates/default/units/melbis_base_head/alter.htm','<link rel=\"alternate\" hreflang=\"{LANG}\" href=\"/{LANG}{MS:PAGE:PATH}\" />
','2025-03-28 17:52:43');
INSERT INTO `ms_user_file_version` VALUES ('49','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__); 
    
    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        //$gParser->gVars[\'melbis\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'ms\'][\'page\'] = $topic;  
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                //$gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                  //                         \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-28 17:59:15');
INSERT INTO `ms_user_file_version` VALUES ('50','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer;
                       
    // Create 
    $tpl = $gParser->TplCreate();
                                           
    // Define languge                   
    $default_lang = \'ru\';
    $lang = addslashes($mVars[\'get\'][\'lang\'] ?? $default_lang);
    $command = \"SELECT * FROM ms_lang WHERE skey = \'$lang\'\";
    $langs = $gParser->SqlSelectToArray(__LINE__, $command);               
    $lang = ( $langs[\'skey\'] ?? $default_lang ); 

    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__);      

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $lang;        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        //$gParser->gVars[\'melbis\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'ms\'][\'page\'] = $topic;  
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                //$gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                  //                         \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-28 18:09:21');
INSERT INTO `ms_user_file_version` VALUES ('51','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MELBIS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head([MELBIS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {1MELBIS:melbis_base_header([MELBIS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {1MELBIS:melbis_base_footer([MELBIS:VAR:LANG])}
    
    </body>
</html>
','2025-03-28 18:09:47');
INSERT INTO `ms_user_file_version` VALUES ('52','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MELBIS:VAR:LANG]\" class=\"h-100\">
    
    {1MELBIS:melbis_base_head([MELBIS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {1MELBIS:melbis_base_header([MELBIS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {1MELBIS:melbis_base_footer([MELBIS:VAR:LANG])}
    
    </body>
</html>
','2025-03-28 18:10:14');
INSERT INTO `ms_user_file_version` VALUES ('53','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {1MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {1MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {1MELBIS:melbis_base_footer([MELBIS:VAR:LANG])}
    
    </body>
</html>
','2025-03-28 18:10:48');
INSERT INTO `ms_user_file_version` VALUES ('54','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {1MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {1MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {1MELBIS:melbis_base_footer([MS:VAR:LANG])}
    
    </body>
</html>
','2025-03-28 18:11:08');
INSERT INTO `ms_user_file_version` VALUES ('55','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {1MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {1MELBIS:melbis_base_footer([MS:VAR:LANG])}
    
    </body>
</html>
','2025-03-28 18:11:15');
INSERT INTO `ms_user_file_version` VALUES ('56','1','./../index.php','<?php
/***************************************************************************************************
 * 
 * index.php - index page
 * 
 ***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/                             

// Require
require_once(\'config.php\');
require_once(\'units/melbis_inc.php\');

// Create connect with DataBase 
$gDb = new MySql(\'MELBIS_INC_halt\');
$gDb->Connect(__FILE__, __LINE__);

// Create Parser
$gParser = new Parser(\'MELBIS_INC_halt\', $gDb);

// Define self constants
$gParser->DefineSelfConst();
$gParser->DefineSelfVars(\'CONST\');

// Define session
$gSession = $gParser->DefineSession(DB_USER_NAME.\'_MELBIS_SHOP\');

// Define lazy load script
$gParser->DefineLazyScript($gSitePath.\'/lazy.php\');

// Define module
if ( !isset($gGet[\'mod\']) ) $gGet[\'mod\'] = \'melbis_base_page\'; 

// Parse
$gParser->Parse($gSitePath, $gTemplate, $gGet[\'mod\'], [serialize($gGet), serialize($gPost)], $gUseCache, $gBuild);

// Publish
$gParser->Publish();

// Possible report
$gParser->Report();

?>','2025-03-28 18:13:00');
INSERT INTO `ms_user_file_version` VALUES ('57','1','./../units/melbis_base_head.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_HEAD
 **/
function MELBIS_BASE_HEAD($mVars)
{ 
    global $gParser, $gLang, $gLangList;
                       
    // Create 
    $tpl = $gParser->TplCreate();           
                     
    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__); 
                                                                
    // Alternate languages
    $command = \"SELECT * FROM ms_lang ORDER BY pos\";
    $langs = $gParser->SqlSelect(__LINE__, $command);        
    foreach ( $langs as $lang )
    {
        $gParser->TplAssign($tpl, \'LANG\', $lang[\'skey\']);
        $gParser->TplParse($tpl, \'ALTER\', \'.alter\');
    }    
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 




?>','2025-03-28 18:16:32');
INSERT INTO `ms_user_file_version` VALUES ('58','1','./../.htaccess','# Basic rules
AddDefaultCharset UTF-8
DirectoryIndex index.html index.htm index.php
Options -Indexes

ErrorDocument 404 /en/404/

RewriteEngine on

# Language auto 
RewriteCond %{HTTP:Accept-Language} ^en [NC]
RewriteRule ^$ /en/ [L,R=301]

RewriteCond %{HTTP:Accept-Language} ^ru [NC]
RewriteRule ^$ /ru/ [L,R=301]

RewriteCond %{HTTP:Accept-Language} ^uk [NC]
RewriteRule ^$ /uk/ [L,R=301]

# Default
RewriteRule ^$ /ru/ [L,R=301]

# Base page  
RewriteRule ^([a-z]{2})/$ index.php?lang=$1 [L,QSA]

# Modules
RewriteRule ^([a-z]{2})\\/([A-Za-z0-9_\\-]+)\\.php$ $2.php?lang=$1 [L,QSA]

# Core
RewriteRule ^core\\/([A-Za-z0-9_\\-\\.\\+]+)\\/$ index.php?mod=kasdim_core_$1 [L,B,QSA]

# Cataloge pages
RewriteCond %{REQUEST_FILENAME} !-d
RewriteCond %{REQUEST_FILENAME} !-f
RewriteRule ^([a-z]{2})\\/(.+)$ index.php?mod=melbis_base_page&psu=$2&lang=$1 [L,QSA]






','2025-03-28 18:17:11');
INSERT INTO `ms_user_file_version` VALUES ('59','1','./../templates/default/units/melbis_base_head/main.htm','<head>
    <meta charset=\"utf8mb4\">          
    <meta name=\"generator\" content=\"Melbis Shop v6.4.0\">        
    <meta name=\"author\" content=\"{TAG_AUTHOR}\">
    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1, shrink-to-fit=no\">  
    <meta http-equiv=\"Last-Modified\" content=\"{LASTMODIFY}\">                    
    <title>{MS:PAGE:TITLE}</title>
    <meta name=\"description\" content=\"{MS:PAGE:DESCR}\">
    <meta name=\"robots\" content=\"index,follow\">

    <link rel=\"canonical\" href=\"https://{CONST:MELBIS_SHOP_DOMAIN}/{MS:VAR:LANG}{MS:PAGE:PATH}\">
    <link rel=\"alternate\" hreflang=\"x-default\" href=\"https://{CONST:MELBIS_SHOP_DOMAIN}/en{MS:PAGE:PATH}\" />
    {ALTER}     

    <link rel=\"icon\" href=\"{PATH}/images/icon.png\"> 
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/bootstrap.css\">  
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/icons/css/all.css\">
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/kasdim.css?{BUILD}\">

    <script src=\"{PATH}/jquery.js\"></script>      
    <script src=\"{PATH}/bootstrap.js\"></script>
    <script src=\"{PATH}/bootbox.js\"></script>
    <script src=\"{PATH}/kasdim.js?{BUILD}\"></script>       
</head>','2025-03-28 18:38:39');
INSERT INTO `ms_user_file_version` VALUES ('60','1','./../units/melbis_base_footer.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_FOOTER
 **/
function MELBIS_BASE_FOOTER($mVars)
{ 
    global $gParser;
    
    // Create 
    $tpl = $gParser->TplCreate();    
    
    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__);                                                                 
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-28 18:40:12');
INSERT INTO `ms_user_file_version` VALUES ('61','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {1MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}
    
    </body>
</html>
','2025-03-28 18:40:33');
INSERT INTO `ms_user_file_version` VALUES ('62','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head()}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {1MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}
    
    </body>
</html>
','2025-03-28 18:40:58');
INSERT INTO `ms_user_file_version` VALUES ('63','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head()}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {1MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {MELBIS:melbis_base_footer()}
    
    </body>
</html>
','2025-03-28 18:41:08');
INSERT INTO `ms_user_file_version` VALUES ('64','1','./../units/melbis_base_footer.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_FOOTER
 **/
function MELBIS_BASE_FOOTER($mVars)
{ 
    global $gParser;
    
    // Create 
    $tpl = $gParser->TplCreate();    
    
    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__);                                                                 
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-28 18:42:11');
INSERT INTO `ms_user_file_version` VALUES ('65','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\"> </span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\"><div class=\"d-none d-sm-block\">{TAG_CHANNEL}</div></div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-28 18:42:17');
INSERT INTO `ms_user_file_version` VALUES ('66','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {1MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}
    
    </body>
</html>
','2025-03-28 18:42:35');
INSERT INTO `ms_user_file_version` VALUES ('67','1','./../units/melbis_base_head.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_HEAD
 **/
function MELBIS_BASE_HEAD($mVars)
{ 
    global $gParser, $gLang, $gLangList;
                       
    // Create 
    $tpl = $gParser->TplCreate();           
                     
    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__); 
                                                                
    // Alternate languages
    $command = \"SELECT * FROM ms_lang ORDER BY pos\";
    $langs = $gParser->SqlSelect(__LINE__, $command);        
    foreach ( $langs as $lang )
    {
        $gParser->TplAssign($tpl, \'LANG\', $lang[\'skey\']);
        $gParser->TplParse($tpl, \'ALTER\', \'.alter\');
    }    
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 




?>','2025-03-28 18:42:59');
INSERT INTO `ms_user_file_version` VALUES ('68','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\"><i class=\"fa-solid fa-shop\"></i> Melbis Shop Demo </span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\"><div class=\"d-none d-sm-block\">{TAG_CHANNEL}</div></div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-28 18:43:41');
INSERT INTO `ms_user_file_version` VALUES ('69','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\" style=\"font-size: 1rem\"><i class=\"fa-solid fa-shop\"></i> Melbis Shop Demo </span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\"><div class=\"d-none d-sm-block\">{TAG_CHANNEL}</div></div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-28 18:44:18');
INSERT INTO `ms_user_file_version` VALUES ('70','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\" style=\"font-size: 2rem\"><i class=\"fa-solid fa-shop\"></i> Melbis Shop Demo </span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\"><div class=\"d-none d-sm-block\">{TAG_CHANNEL}</div></div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-28 18:44:23');
INSERT INTO `ms_user_file_version` VALUES ('71','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\" style=\"font-size: 1.5rem\"><i class=\"fa-solid fa-shop\"></i> Melbis Shop Demo </span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\"><div class=\"d-none d-sm-block\">{TAG_CHANNEL}</div></div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-28 18:44:29');
INSERT INTO `ms_user_file_version` VALUES ('72','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\" style=\"font-size: 1.5rem\"><i class=\"fa-solid fa-shop\"></i> Melbis Shop Demo </span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block\"><i class=\"fa-brands fa-telegram\"></i> </div>
            </div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-28 18:48:03');
INSERT INTO `ms_user_file_version` VALUES ('73','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\" style=\"font-size: 1.5rem\"><i class=\"fa-solid fa-shop\"></i> Melbis Shop Demo </span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block lead\"><i class=\"fa-brands fa-telegram\"></i> </div>
            </div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-28 18:48:45');
INSERT INTO `ms_user_file_version` VALUES ('74','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\" style=\"font-size: 1.5rem\"><i class=\"fa-solid fa-shop\"></i> Melbis Shop Demo </span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block lead\">     
                    <a href=\"https://telegram.org/\"><i class=\"fa-brands fa-telegram\"></i></a> 
                </div>
            </div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-28 18:50:22');
INSERT INTO `ms_user_file_version` VALUES ('75','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\" style=\"font-size: 1.5rem\"><i class=\"fa-solid fa-shop\"></i> Melbis Shop Demo </span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block lead\">     
                    <a href=\"https://telegram.org/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-telegram\"></i></a> 
                </div>
            </div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-28 18:51:27');
INSERT INTO `ms_user_file_version` VALUES ('76','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\" style=\"font-size: 1.5rem\"><i class=\"fa-solid fa-shop\"></i> Melbis Shop Demo </span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block lead\">     
                    <a href=\"https://telegram.org/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-telegram\"></i></a> 
                    <a href=\"https://www.youtube.com/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-youtube\"></i></a>
                </div>
            </div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-28 18:52:25');
INSERT INTO `ms_user_file_version` VALUES ('77','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\" style=\"font-size: 1.5rem\"><i class=\"fa-solid fa-shop\"></i> Melbis Shop Demo </span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block lead\">     
                    <a href=\"https://telegram.org/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-telegram\"></i> Telegram</a> 
                    <a href=\"https://www.youtube.com/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-youtube\"> YouTube</i></a>
                </div>
            </div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-28 18:52:59');
INSERT INTO `ms_user_file_version` VALUES ('78','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\" style=\"font-size: 1.5rem\"><i class=\"fa-solid fa-shop\"></i> Melbis Shop Demo </span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block lead\">     
                    <a href=\"https://telegram.org/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-telegram\"></i> Telegram</a> 
                    <a href=\"https://www.youtube.com/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-youtube\"></i> YouTube</a>
                </div>
            </div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-28 18:53:33');
INSERT INTO `ms_user_file_version` VALUES ('79','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\" style=\"font-size: 1.5rem\"><i class=\"fa-solid fa-shop\"></i> Melbis Shop Demo </span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block lead\">     
                    <a href=\"https://telegram.org/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-telegram\"></i> Telegram</a>
                    &nbsp; 
                    <a href=\"https://www.youtube.com/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-youtube\"></i> YouTube</a>
                </div>
            </div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-28 18:53:43');
INSERT INTO `ms_user_file_version` VALUES ('80','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\" style=\"font-size: 1.5rem\"><i class=\"fa-solid fa-shop\"></i> Melbis Shop Demo </span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block lead\">     
                    <a href=\"https://telegram.org/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-telegram\"></i> Telegram</a>
                    &nbsp; 
                    <a href=\"https://www.youtube.com/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-youtube\"></i> YouTube</a>
                    &nbsp;
                    <a href=\"mailto:{CONST:MELBIS_SHOP_EMAIL}\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-youtube\"></i> YouTube</a>
                </div>
            </div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-28 18:54:43');
INSERT INTO `ms_user_file_version` VALUES ('81','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\" style=\"font-size: 1.5rem\"><i class=\"fa-solid fa-shop\"></i> Melbis Shop Demo </span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block lead\">     
                    <a href=\"https://telegram.org/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-telegram\"></i> Telegram</a>
                    &nbsp; 
                    <a href=\"https://www.youtube.com/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-youtube\"></i> YouTube</a>
                    &nbsp;
                    <a href=\"mailto:{CONST:MELBIS_SHOP_EMAIL}\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-youtube\"></i> Email</a>
                </div>
            </div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-28 18:54:59');
INSERT INTO `ms_user_file_version` VALUES ('82','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\" style=\"font-size: 1.5rem\"><i class=\"fa-solid fa-shop\"></i> Melbis Shop Demo </span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block lead\">     
                    <a href=\"https://telegram.org/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-telegram\"></i> Telegram</a>
                    &nbsp; 
                    <a href=\"https://www.youtube.com/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-youtube\"></i> YouTube</a>
                    &nbsp;
                    <a href=\"mailto:{CONST:MELBIS_SHOP_EMAIL}\" class=\"text-decoration-none text-muted\"><i class=\"fa-solid fa-envelope\"></i> Email</a>
                </div>
            </div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-28 18:55:42');
INSERT INTO `ms_user_file_version` VALUES ('83','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\" style=\"font-size: 1.5rem\"><i class=\"fa-solid fa-shop\"></i> Melbis Shop Demo </span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block lead\">     
                    <a href=\"https://telegram.org/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-telegram\"></i> Telegram</a>
                    &nbsp; 
                    <a href=\"https://www.youtube.com/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-youtube\"></i> YouTube</a>
                    &nbsp;
                    <a href=\"mailto:{CONST:MELBIS_SHOP_EMAIL}\" class=\"text-decoration-none text-muted\"><i class=\"fa-solid fa-envelope\"></i> Email</a>
                </div>
            </div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-28 18:57:07');
INSERT INTO `ms_user_file_version` VALUES ('84','1','./../.htaccess','# Basic rules
AddDefaultCharset UTF-8
DirectoryIndex index.html index.htm index.php
Options -Indexes

ErrorDocument 404 /en/404/

RewriteEngine on

# Language auto 
RewriteCond %{HTTP:Accept-Language} ^en [NC]
RewriteRule ^$ /en/ [L,R=301]

RewriteCond %{HTTP:Accept-Language} ^ru [NC]
RewriteRule ^$ /ru/ [L,R=301]

RewriteCond %{HTTP:Accept-Language} ^uk [NC]
RewriteRule ^$ /uk/ [L,R=301]



# Base page  
RewriteRule ^([a-z]{2})/$ index.php?lang=$1 [L,QSA]

# Modules
RewriteRule ^([a-z]{2})\\/([A-Za-z0-9_\\-]+)\\.php$ $2.php?lang=$1 [L,QSA]

# Core
RewriteRule ^core\\/([A-Za-z0-9_\\-\\.\\+]+)\\/$ index.php?mod=kasdim_core_$1 [L,B,QSA]

# Cataloge pages
RewriteCond %{REQUEST_FILENAME} !-d
RewriteCond %{REQUEST_FILENAME} !-f
RewriteRule ^([a-z]{2})\\/(.+)$ index.php?mod=melbis_base_page&psu=$2&lang=$1 [L,QSA]






','2025-03-28 21:05:14');
INSERT INTO `ms_user_file_version` VALUES ('85','1','./../.htaccess','# Basic rules
AddDefaultCharset UTF-8
DirectoryIndex index.html index.htm index.php
Options -Indexes

ErrorDocument 404 /en/404/

RewriteEngine on



# Default
RewriteRule ^$ /ru/ [L,R=301]

# Base page  
RewriteRule ^([a-z]{2})/$ index.php?lang=$1 [L,QSA]

# Modules
RewriteRule ^([a-z]{2})\\/([A-Za-z0-9_\\-]+)\\.php$ $2.php?lang=$1 [L,QSA]

# Core
RewriteRule ^core\\/([A-Za-z0-9_\\-\\.\\+]+)\\/$ index.php?mod=kasdim_core_$1 [L,B,QSA]

# Cataloge pages
RewriteCond %{REQUEST_FILENAME} !-d
RewriteCond %{REQUEST_FILENAME} !-f
RewriteRule ^([a-z]{2})\\/(.+)$ index.php?mod=melbis_base_page&psu=$2&lang=$1 [L,QSA]






','2025-03-28 21:05:35');
INSERT INTO `ms_user_file_version` VALUES ('86','1','./../.htaccess','# Basic rules
AddDefaultCharset UTF-8
DirectoryIndex index.html index.htm index.php
Options -Indexes

ErrorDocument 404 /en/404/

RewriteEngine on

# Language auto 
RewriteCond %{HTTP:Accept-Language} ^en [NC]
RewriteRule ^$ /en/ [L,R=301]

RewriteCond %{HTTP:Accept-Language} ^ru [NC]
RewriteRule ^$ /ru/ [L,R=301]

RewriteCond %{HTTP:Accept-Language} ^uk [NC]
RewriteRule ^$ /uk/ [L,R=301]

# Default
RewriteRule ^$ /ru/ [L,R=301]

# Base page  
RewriteRule ^([a-z]{2})/$ index.php?lang=$1 [L,QSA]

# Modules
RewriteRule ^([a-z]{2})\\/([A-Za-z0-9_\\-]+)\\.php$ $2.php?lang=$1 [L,QSA]

# Core
RewriteRule ^core\\/([A-Za-z0-9_\\-\\.\\+]+)\\/$ index.php?mod=kasdim_core_$1 [L,B,QSA]

# Cataloge pages
RewriteCond %{REQUEST_FILENAME} !-d
RewriteCond %{REQUEST_FILENAME} !-f
RewriteRule ^([a-z]{2})\\/(.+)$ index.php?mod=melbis_base_page&psu=$2&lang=$1 [L,QSA]






','2025-03-28 21:06:01');
INSERT INTO `ms_user_file_version` VALUES ('87','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__);      
                                           
    // Define languge                   
    $default_lang = \'ru\';
    $lang = addslashes($mVars[\'get\'][\'lang\'] ?? $default_lang);
    $command = \"SELECT * FROM ms_lang WHERE skey = \'$lang\'\";
    $langs = $gParser->SqlSelectToArray(__LINE__, $command);               
    $lang = ( $langs[\'skey\'] ?? $default_lang );     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $lang;        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    echo $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        //$gParser->gVars[\'melbis\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'ms\'][\'page\'] = $topic;  
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                //$gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                  //                         \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-28 21:10:34');
INSERT INTO `ms_user_file_version` VALUES ('88','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__);      
                                           
    // Define languge                   
    $default_lang = \'ru\';
    $lang = addslashes($mVars[\'get\'][\'lang\'] ?? $default_lang);
    $command = \"SELECT * FROM ms_lang WHERE skey = \'$lang\'\";
    $langs = $gParser->SqlSelectToArray(__LINE__, $command);               
    $lang = ( $langs[\'skey\'] ?? $default_lang );     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $lang;        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        //$gParser->gVars[\'melbis\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'ms\'][\'page\'] = $topic;  
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                //$gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                  //                         \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-28 21:11:06');
INSERT INTO `ms_user_file_version` VALUES ('89','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer, $gLang;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Auto tag    
    //KASDIM_INC_LANG_tags($tpl, __FUNCTION__);      
                                           
    // Define languge                   
    $default_lang = \'ru\';
    $lang = addslashes($mVars[\'get\'][\'lang\'] ?? $default_lang);
    $command = \"SELECT * FROM ms_lang WHERE skey = \'$lang\'\";
    $langs = $gParser->SqlSelectToArray(__LINE__, $command);               
    $gLang = ( $langs[\'skey\'] ?? $default_lang );     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $gLang;        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        //$gParser->gVars[\'melbis\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'ms\'][\'page\'] = $topic;  
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                //$gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                  //                         \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-28 21:19:16');
INSERT INTO `ms_user_file_version` VALUES ('90','1','./../units/melbis_inc_lang.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************
 *
 * MELBIS_INC_LANG                      - Smart user authorization start
 * MELBIS_INC_LANG_tags                 - Authorization user by login and password
 * MELBIS_INC_LANG_tags                 - Verify user access to system command
 * MELBIS_INC_AUTH_web                  - Authorization user for web or application 
 * MELBIS_INC_AUTH_web_access           - Verify user access for inside or outside module
 * MELBIS_INC_AUTH_web_key_prepare      - Prepare user rights for web_key
 * MELBIS_INC_AUTH_web_key_access       - Verify user access to web_key
 * MELBIS_INC_AUTH_order_right_prepare  - Prepare user access to order     
 * 
 **************************************************************************************************/
   

/** 
 * Function MELBIS_INC_LANG
 **/
function MELBIS_INC_LANG($mTable, $mKey, $mId, $mTxt, $mIsHtml = false)
{ 
    global $gParser, $gLang;                                             
            
    // Vars
    $result = \'\';       
    
    // Empty
    if ( $mTxt == \'\' ) return \'\';
               
    // Get data      
    $command = \"SELECT t.id, tl.translate, o.origin, o.crc, o.id AS oid   
                  FROM ms_trans t
             LEFT JOIN ms_trans_origin o
                    ON t.id = o.trans_id
                   AND o.item_id = \'$mId\'
             LEFT JOIN ms_trans_lang tl
                    ON o.id = tl.origin_id 
                   AND tl.lang_id = ( SELECT id FROM ms_lang where skey = \'$gLang\' )                    
                 WHERE t.table_key = \'$mTable\'
                   AND t.skey = \'$mKey\'                                     
                \";  
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( isset($item[\'origin\']) )
    {        
        // Found origin
        if ( $item[\'crc\'] == md5($mTxt) )     
        {
            // CRC ok
            if ( isset($item[\'translate\']) )
            {
                // Translate exists
                $result = $item[\'translate\']; 
            }
            else
            {
                // No translate
                $result = $mTxt;        
            }
        }                                                                     
        else
        {
            // Crc fail
            $result = $mTxt;  
            $gParser->SqlUpdate(__LINE__, \'ms_trans_origin\', [\'id\' => $item[\'oid\'], \'origin\' => $mTxt], \'id\');    
        }    
    }
    else
    {
        // Not found  
        $result = $mTxt;
        if ( isset($item[\'id\']) )
        {                                                    
            $hash = [];
            $hash[\'id\'] = $gParser->SqlGenId(\'trans_origin\');        
            $hash[\'trans_id\'] = $item[\'id\'];
            $hash[\'item_id\'] = $mId;
            $hash[\'origin\'] = $mTxt;
            $hash[\'crc\'] = md5($mTxt);
            $hash[\'kind_key\'] = \'kDefault\';
            $hash[\'is_html\'] = ( $mIsHtml ) ? 1 : 0;
            $hash[\'pos\'] = $hash[\'id\'];  
            $gParser->SqlInsert(__LINE__, \'ms_trans_origin\', $hash);
        }  
    }       
    
    // Html
    if ( $mIsHtml )
    {
        return $result;
    }
    else
    {
        return htmlspecialchars($result);
    }                                
}   
 
 
/** 
 * Function MELBIS_INC_LANG_tag
 **/
function MELBIS_INC_LANG_tag($mMod, $mName)
{ 
    global $gParser, $gLang;    
    
    $command = \"SELECT IFNULL(tl.translate, o.origin) AS value, 
                       o.is_active,
                       o.is_html   
                  FROM ms_trans t
                  JOIN ms_trans_origin o
                    ON t.id = o.trans_id
             LEFT JOIN ms_trans_lang tl
                    ON o.id = tl.origin_id 
                   AND tl.lang_id = ( SELECT id FROM ms_lang where skey = \'$gLang\' )                    
                 WHERE t.table_key = \'kTag\'
                   AND t.name = \'$mMod\'
                   AND o.item_code = \'$mName\'
               \";                         
    $tag = $gParser->SqlSelectToArray(__LINE__, $command);    
    if ( !isset($tag[\'is_active\']) || $tag[\'is_active\'] == 0  )
    {
        return \'\';
    }
    else
    {
        if ( $tag[\'is_html\'] == 0 )
        {
            return htmlspecialchars($tag[\'value\']);
        }
        else
        {
            return $tag[\'value\'];
        }    
    }                                     
} 

/** 
 * Function MELBIS_INC_LANG_tags
 **/
function MELBIS_INC_LANG_tags($mTpl, $mModule)
{ 
    global $gParser, $gLang;
                       
    $parts = explode(\'_\', $mModule);
    $page_short =$parts[1];    
    $page_full = $parts[1].\'_\'.$parts[2];    
            
    $command = \"SELECT o.item_code AS name, 
                       IFNULL(tl.translate, o.origin) AS value, 
                       o.is_active,
                       o.is_html   
                  FROM ms_trans t
                  JOIN ms_trans_origin o
                    ON t.id = o.trans_id
             LEFT JOIN ms_trans_lang tl
                    ON o.id = tl.origin_id 
                   AND tl.lang_id = ( SELECT id FROM ms_lang where skey = \'$gLang\' )                    
                 WHERE t.table_key = \'kTag\'
                   AND ( t.name = \'$page_short\' OR t.name = \'$page_full\' )     
               \";                                                     
    $tags = $gParser->SqlSelect(__LINE__, $command);
    foreach ($tags as $tag)
    {                
        if ( $tag[\'is_active\'] == 0 )
        {
            $gParser->TplAssign($mTpl, \'TAG_\'.$tag[\'name\'], \'\');
        }
        else
        {
            if ( $tag[\'is_html\'] == 0 )
            {                                                    
                $gParser->TplAssign($mTpl, \'TAG_\'.$tag[\'name\'], htmlspecialchars($tag[\'value\']));
                $gParser->TplAssign($mTpl, \'TAGS_\'.$tag[\'name\'], addcslashes($tag[\'value\'], \"\'\"));
            }
            else
            {
                $gParser->TplAssign($mTpl, \'TAG_\'.$tag[\'name\'], $tag[\'value\']);                
            }
        }        
    }
} 

 
 
?>','2025-03-28 21:21:47');
INSERT INTO `ms_user_file_version` VALUES ('91','1','./../units/melbis_inc_lang.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************
 *
 * MELBIS_INC_LANG                      - Translater from origin
 * MELBIS_INC_LANG_tag                  - One tag parser in script
 * MELBIS_INC_LANG_tags                 - All Tags parser on page
 * 
 **************************************************************************************************/
   

/** 
 * Function MELBIS_INC_LANG
 **/
function MELBIS_INC_LANG($mTable, $mKey, $mId, $mTxt, $mIsHtml = false)
{ 
    global $gParser, $gLang;                                             
            
    // Vars
    $result = \'\';       
    
    // Empty
    if ( $mTxt == \'\' ) return \'\';
               
    // Get data      
    $command = \"SELECT t.id, tl.translate, o.origin, o.crc, o.id AS oid   
                  FROM ms_trans t
             LEFT JOIN ms_trans_origin o
                    ON t.id = o.trans_id
                   AND o.item_id = \'$mId\'
             LEFT JOIN ms_trans_lang tl
                    ON o.id = tl.origin_id 
                   AND tl.lang_id = ( SELECT id FROM ms_lang where skey = \'$gLang\' )                    
                 WHERE t.table_key = \'$mTable\'
                   AND t.skey = \'$mKey\'                                     
                \";  
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( isset($item[\'origin\']) )
    {        
        // Found origin
        if ( $item[\'crc\'] == md5($mTxt) )     
        {
            // CRC ok
            if ( isset($item[\'translate\']) )
            {
                // Translate exists
                $result = $item[\'translate\']; 
            }
            else
            {
                // No translate
                $result = $mTxt;        
            }
        }                                                                     
        else
        {
            // Crc fail
            $result = $mTxt;  
            $gParser->SqlUpdate(__LINE__, \'ms_trans_origin\', [\'id\' => $item[\'oid\'], \'origin\' => $mTxt], \'id\');    
        }    
    }
    else
    {
        // Not found  
        $result = $mTxt;
        if ( isset($item[\'id\']) )
        {                                                    
            $hash = [];
            $hash[\'id\'] = $gParser->SqlGenId(\'trans_origin\');        
            $hash[\'trans_id\'] = $item[\'id\'];
            $hash[\'item_id\'] = $mId;
            $hash[\'origin\'] = $mTxt;
            $hash[\'crc\'] = md5($mTxt);
            $hash[\'kind_key\'] = \'kDefault\';
            $hash[\'is_html\'] = ( $mIsHtml ) ? 1 : 0;
            $hash[\'pos\'] = $hash[\'id\'];  
            $gParser->SqlInsert(__LINE__, \'ms_trans_origin\', $hash);
        }  
    }       
    
    // Html
    if ( $mIsHtml )
    {
        return $result;
    }
    else
    {
        return htmlspecialchars($result);
    }                                
}   
 
 
/** 
 * Function MELBIS_INC_LANG_tag
 **/
function MELBIS_INC_LANG_tag($mMod, $mName)
{ 
    global $gParser, $gLang;    
    
    $command = \"SELECT IFNULL(tl.translate, o.origin) AS value, 
                       o.is_active,
                       o.is_html   
                  FROM ms_trans t
                  JOIN ms_trans_origin o
                    ON t.id = o.trans_id
             LEFT JOIN ms_trans_lang tl
                    ON o.id = tl.origin_id 
                   AND tl.lang_id = ( SELECT id FROM ms_lang where skey = \'$gLang\' )                    
                 WHERE t.table_key = \'kTag\'
                   AND t.name = \'$mMod\'
                   AND o.item_code = \'$mName\'
               \";                         
    $tag = $gParser->SqlSelectToArray(__LINE__, $command);    
    if ( !isset($tag[\'is_active\']) || $tag[\'is_active\'] == 0  )
    {
        return \'\';
    }
    else
    {
        if ( $tag[\'is_html\'] == 0 )
        {
            return htmlspecialchars($tag[\'value\']);
        }
        else
        {
            return $tag[\'value\'];
        }    
    }                                     
} 

/** 
 * Function MELBIS_INC_LANG_tags
 **/
function MELBIS_INC_LANG_tags($mTpl, $mModule)
{ 
    global $gParser, $gLang;
                       
    $parts = explode(\'_\', $mModule);
    $page_short =$parts[1];    
    $page_full = $parts[1].\'_\'.$parts[2];    
            
    $command = \"SELECT o.item_code AS name, 
                       IFNULL(tl.translate, o.origin) AS value, 
                       o.is_active,
                       o.is_html   
                  FROM ms_trans t
                  JOIN ms_trans_origin o
                    ON t.id = o.trans_id
             LEFT JOIN ms_trans_lang tl
                    ON o.id = tl.origin_id 
                   AND tl.lang_id = ( SELECT id FROM ms_lang where skey = \'$gLang\' )                    
                 WHERE t.table_key = \'kTag\'
                   AND ( t.name = \'$page_short\' OR t.name = \'$page_full\' )     
               \";                                                     
    $tags = $gParser->SqlSelect(__LINE__, $command);
    foreach ($tags as $tag)
    {                
        if ( $tag[\'is_active\'] == 0 )
        {
            $gParser->TplAssign($mTpl, \'TAG_\'.$tag[\'name\'], \'\');
        }
        else
        {
            if ( $tag[\'is_html\'] == 0 )
            {                                                    
                $gParser->TplAssign($mTpl, \'TAG_\'.$tag[\'name\'], htmlspecialchars($tag[\'value\']));
                $gParser->TplAssign($mTpl, \'TAGS_\'.$tag[\'name\'], addcslashes($tag[\'value\'], \"\'\"));
            }
            else
            {
                $gParser->TplAssign($mTpl, \'TAG_\'.$tag[\'name\'], $tag[\'value\']);                
            }
        }        
    }
} 

 
 
?>','2025-03-28 21:26:09');
INSERT INTO `ms_user_file_version` VALUES ('92','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer, $gLang;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Auto tag    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);      
                                           
    // Define languge                   
    $default_lang = \'ru\';
    $lang = addslashes($mVars[\'get\'][\'lang\'] ?? $default_lang);
    $command = \"SELECT * FROM ms_lang WHERE skey = \'$lang\'\";
    $langs = $gParser->SqlSelectToArray(__LINE__, $command);               
    $gLang = ( $langs[\'skey\'] ?? $default_lang );     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $gLang;        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        //$gParser->gVars[\'melbis\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'ms\'][\'page\'] = $topic;  
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                //$gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                  //                         \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-28 21:26:44');
INSERT INTO `ms_user_file_version` VALUES ('93','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer, $gLang;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Auto tag    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);      
                                           
    // Define languge                   
    $default_lang = \'ru\';
    $lang = addslashes($mVars[\'get\'][\'lang\'] ?? $default_lang);
    $command = \"SELECT * FROM ms_lang WHERE skey = \'$lang\'\";
    $langs = $gParser->SqlSelectToArray(__LINE__, $command);               
    $gLang = ( $langs[\'skey\'] ?? $default_lang );     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $gLang;        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        //$gParser->gVars[\'melbis\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'ms\'][\'page\'] = $topic;  
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                //$gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                  //                         \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-29 08:23:38');
INSERT INTO `ms_user_file_version` VALUES ('94','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer, $gLang;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Lang tag    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);      
                                           
    // Define languge                   
    $default_lang = \'ru\';
    $lang = addslashes($mVars[\'get\'][\'lang\'] ?? $default_lang);
    $command = \"SELECT * FROM ms_lang WHERE skey = \'$lang\'\";
    $langs = $gParser->SqlSelectToArray(__LINE__, $command);               
    $gLang = ( $langs[\'skey\'] ?? $default_lang );     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $gLang;        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        //$gParser->gVars[\'melbis\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'ms\'][\'page\'] = $topic;  
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                //$gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                  //                         \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-29 08:28:04');
INSERT INTO `ms_user_file_version` VALUES ('95','1','./../units/melbis_base_head.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_HEAD
 **/
function MELBIS_BASE_HEAD($mVars)
{ 
    global $gParser, $gLang, $gLangList;
                       
    // Create 
    $tpl = $gParser->TplCreate();           
                     
    // Lang tags    
    KASDIM_INC_LANG_tags($tpl, __FUNCTION__); 
                                                                
    // Alternate languages
    $command = \"SELECT * FROM ms_lang ORDER BY pos\";
    $langs = $gParser->SqlSelect(__LINE__, $command);        
    foreach ( $langs as $lang )
    {
        $gParser->TplAssign($tpl, \'LANG\', $lang[\'skey\']);
        $gParser->TplParse($tpl, \'ALTER\', \'.alter\');
    }    
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 




?>','2025-03-29 08:28:22');
INSERT INTO `ms_user_file_version` VALUES ('96','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer, $gLang;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);      
                                           
    // Define languge                   
    $default_lang = \'ru\';
    $lang = addslashes($mVars[\'get\'][\'lang\'] ?? $default_lang);
    $command = \"SELECT * FROM ms_lang WHERE skey = \'$lang\'\";
    $langs = $gParser->SqlSelectToArray(__LINE__, $command);               
    $gLang = ( $langs[\'skey\'] ?? $default_lang );     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $gLang;        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        //$gParser->gVars[\'melbis\'][\'page\'][\'title\'] = KASDIM_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'ms\'][\'page\'] = $topic;  
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                //$gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                  //                         \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-29 08:28:26');
INSERT INTO `ms_user_file_version` VALUES ('97','1','./../units/melbis_inc_lang.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************
 *
 * MELBIS_INC_LANG                      - Translater from origin
 * MELBIS_INC_LANG_tag                  - One tag parser in script
 * MELBIS_INC_LANG_tags                 - All Tags parser on page
 * 
 **************************************************************************************************/
   

/** 
 * Function MELBIS_INC_LANG
 **/
function MELBIS_INC_LANG($mTable, $mKey, $mId, $mTxt, $mIsHtml = false)
{ 
    global $gParser, $gLang;                                             
            
    // Vars
    $result = \'\';       
    
    // Empty
    if ( $mTxt == \'\' ) return \'\';
               
    // Get data      
    $command = \"SELECT t.id, tl.translate, o.origin, o.crc, o.id AS oid   
                  FROM ms_trans t
             LEFT JOIN ms_trans_origin o
                    ON t.id = o.trans_id
                   AND o.item_id = \'$mId\'
             LEFT JOIN ms_trans_lang tl
                    ON o.id = tl.origin_id 
                   AND tl.lang_id = ( SELECT id FROM ms_lang where skey = \'$gLang\' )                    
                 WHERE t.table_key = \'$mTable\'
                   AND t.skey = \'$mKey\'                                     
                \";  
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( isset($item[\'origin\']) )
    {        
        // Found origin
        if ( $item[\'crc\'] == md5($mTxt) )     
        {
            // CRC ok
            if ( isset($item[\'translate\']) )
            {
                // Translate exists
                $result = $item[\'translate\']; 
            }
            else
            {
                // No translate
                $result = $mTxt;        
            }
        }                                                                     
        else
        {
            // Crc fail
            $result = $mTxt;  
            $gParser->SqlUpdate(__LINE__, \'ms_trans_origin\', [\'id\' => $item[\'oid\'], \'origin\' => $mTxt], \'id\');    
        }    
    }
    else
    {
        // Not found  
        $result = $mTxt;
        if ( isset($item[\'id\']) )
        {                                                    
            $hash = [];
            $hash[\'id\'] = $gParser->SqlGenId(\'trans_origin\');        
            $hash[\'trans_id\'] = $item[\'id\'];
            $hash[\'item_id\'] = $mId;
            $hash[\'origin\'] = $mTxt;
            $hash[\'crc\'] = md5($mTxt);
            $hash[\'kind_key\'] = \'kDefault\';
            $hash[\'is_html\'] = ( $mIsHtml ) ? 1 : 0;
            $hash[\'pos\'] = $hash[\'id\'];  
            $gParser->SqlInsert(__LINE__, \'ms_trans_origin\', $hash);
        }  
    }       
    
    // Html
    if ( $mIsHtml )
    {
        return $result;
    }
    else
    {
        return htmlspecialchars($result);
    }                                
}   
 
 
/** 
 * Function MELBIS_INC_LANG_tag
 **/
function MELBIS_INC_LANG_tag($mMod, $mName)
{ 
    global $gParser, $gLang;    
    
    $command = \"SELECT IFNULL(tl.translate, o.origin) AS value, 
                       o.is_active,
                       o.is_html   
                  FROM ms_trans t
                  JOIN ms_trans_origin o
                    ON t.id = o.trans_id
             LEFT JOIN ms_trans_lang tl
                    ON o.id = tl.origin_id 
                   AND tl.lang_id = ( SELECT id FROM ms_lang where skey = \'$gLang\' )                    
                 WHERE t.table_key = \'kTag\'
                   AND t.name = \'$mMod\'
                   AND o.item_code = \'$mName\'
               \";                         
    $tag = $gParser->SqlSelectToArray(__LINE__, $command);    
    if ( !isset($tag[\'is_active\']) || $tag[\'is_active\'] == 0  )
    {
        return \'\';
    }
    else
    {
        if ( $tag[\'is_html\'] == 0 )
        {
            return htmlspecialchars($tag[\'value\']);
        }
        else
        {
            return $tag[\'value\'];
        }    
    }                                     
} 

/** 
 * Function MELBIS_INC_LANG_tags
 **/
function MELBIS_INC_LANG_tags($mTpl, $mModule)
{ 
    global $gParser, $gLang;
                       
    $parts = explode(\'_\', $mModule);
    $page_short =$parts[1];    
    $page_full = $parts[1].\'_\'.$parts[2];    
            
    $command = \"SELECT o.item_code AS name, 
                       IFNULL(tl.translate, o.origin) AS value, 
                       o.is_active,
                       o.is_html   
                  FROM ms_trans t
                  JOIN ms_trans_origin o
                    ON t.id = o.trans_id
             LEFT JOIN ms_trans_lang tl
                    ON o.id = tl.origin_id 
                   AND tl.lang_id = ( SELECT id FROM ms_lang where skey = \'$gLang\' )                    
                 WHERE t.table_key = \'kTag\'
                   AND ( t.name = \'$page_short\' OR t.name = \'$page_full\' )     
               \";                                                     
    $tags = $gParser->SqlSelect(__LINE__, $command);
    foreach ($tags as $tag)
    {                
        if ( $tag[\'is_active\'] == 0 )
        {
            $gParser->TplAssign($mTpl, \'TAG_\'.$tag[\'name\'], \'\');
        }
        else
        {
            if ( $tag[\'is_html\'] == 0 )
            {                                                    
                $gParser->TplAssign($mTpl, \'TAG_\'.$tag[\'name\'], htmlspecialchars($tag[\'value\']));
                $gParser->TplAssign($mTpl, \'TAGS_\'.$tag[\'name\'], addcslashes($tag[\'value\'], \"\'\"));
            }
            else
            {
                $gParser->TplAssign($mTpl, \'TAG_\'.$tag[\'name\'], $tag[\'value\']);                
            }
        }        
    }
} 

 
 
?>','2025-03-29 08:29:12');
INSERT INTO `ms_user_file_version` VALUES ('98','1','./../units/melbis_base_head.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_HEAD
 **/
function MELBIS_BASE_HEAD($mVars)
{ 
    global $gParser, $gLang, $gLangList;
                       
    // Create 
    $tpl = $gParser->TplCreate();           
                     
    // Lang tags    
    KASDIM_INC_LANG_tags($tpl, __FUNCTION__); 
                                                                
    // Alternate languages
    $command = \"SELECT * FROM ms_lang ORDER BY pos\";
    $langs = $gParser->SqlSelect(__LINE__, $command);        
    foreach ( $langs as $lang )
    {
        $gParser->TplAssign($tpl, \'LANG\', $lang[\'skey\']);
        $gParser->TplParse($tpl, \'ALTER\', \'.alter\');
    }    
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 




?>','2025-03-29 08:30:33');
INSERT INTO `ms_user_file_version` VALUES ('99','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {1MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {1MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}
    
    </body>
</html>
','2025-03-29 08:32:13');
INSERT INTO `ms_user_file_version` VALUES ('100','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {1MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {1MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}
    
    </body>
</html>
','2025-03-29 08:32:25');
INSERT INTO `ms_user_file_version` VALUES ('101','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {1MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {1MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}
    
    </body>
</html>
','2025-03-29 08:32:41');
INSERT INTO `ms_user_file_version` VALUES ('102','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {1MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {1MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {1MELBIS:melbis_base_footer([MS:VAR:LANG])}
    
    </body>
</html>
','2025-03-29 08:32:55');
INSERT INTO `ms_user_file_version` VALUES ('103','1','./../units/melbis_inc_lang.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************
 *
 * MELBIS_INC_LANG                      - Translater from origin
 * MELBIS_INC_LANG_tag                  - One tag parser in script
 * MELBIS_INC_LANG_tags                 - All Tags parser on page
 * 
 **************************************************************************************************/
   

/** 
 * Function MELBIS_INC_LANG
 **/
function MELBIS_INC_LANG($mTable, $mKey, $mId, $mTxt, $mIsHtml = false)
{ 
    global $gParser, $gLang;                                             
            
    // Vars
    $result = \'\';       
    
    // Empty
    if ( $mTxt == \'\' ) return \'\';
               
    // Get data      
    $command = \"SELECT t.id, tl.translate, o.origin, o.crc, o.id AS oid   
                  FROM ms_trans t
             LEFT JOIN ms_trans_origin o
                    ON t.id = o.trans_id
                   AND o.item_id = \'$mId\'
             LEFT JOIN ms_trans_lang tl
                    ON o.id = tl.origin_id 
                   AND tl.lang_id = ( SELECT id FROM ms_lang where skey = \'$gLang\' )                    
                 WHERE t.table_key = \'$mTable\'
                   AND t.skey = \'$mKey\'                                     
                \";  
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( isset($item[\'origin\']) )
    {        
        // Found origin
        if ( $item[\'crc\'] == md5($mTxt) )     
        {
            // CRC ok
            if ( isset($item[\'translate\']) )
            {
                // Translate exists
                $result = $item[\'translate\']; 
            }
            else
            {
                // No translate
                $result = $mTxt;        
            }
        }                                                                     
        else
        {
            // Crc fail
            $result = $mTxt;  
            $gParser->SqlUpdate(__LINE__, \'ms_trans_origin\', [\'id\' => $item[\'oid\'], \'origin\' => $mTxt], \'id\');    
        }    
    }
    else
    {
        // Not found  
        $result = $mTxt;
        if ( isset($item[\'id\']) )
        {                                                    
            $hash = [];
            $hash[\'id\'] = $gParser->SqlGenId(\'trans_origin\');        
            $hash[\'trans_id\'] = $item[\'id\'];
            $hash[\'item_id\'] = $mId;
            $hash[\'origin\'] = $mTxt;
            $hash[\'crc\'] = md5($mTxt);
            $hash[\'kind_key\'] = \'kDefault\';
            $hash[\'is_html\'] = ( $mIsHtml ) ? 1 : 0;
            $hash[\'pos\'] = $hash[\'id\'];  
            $gParser->SqlInsert(__LINE__, \'ms_trans_origin\', $hash);
        }  
    }       
    
    // Html
    if ( $mIsHtml )
    {
        return $result;
    }
    else
    {
        return htmlspecialchars($result);
    }                                
}   
 
 
/** 
 * Function MELBIS_INC_LANG_tag
 **/
function MELBIS_INC_LANG_tag($mMod, $mName)
{ 
    global $gParser, $gLang;    
    
    $command = \"SELECT IFNULL(tl.translate, o.origin) AS value, 
                       o.is_active,
                       o.is_html   
                  FROM ms_trans t
                  JOIN ms_trans_origin o
                    ON t.id = o.trans_id
             LEFT JOIN ms_trans_lang tl
                    ON o.id = tl.origin_id 
                   AND tl.lang_id = ( SELECT id FROM ms_lang where skey = \'$gLang\' )                    
                 WHERE t.table_key = \'kTag\'
                   AND t.name = \'$mMod\'
                   AND o.item_code = \'$mName\'
               \";                         
    $tag = $gParser->SqlSelectToArray(__LINE__, $command);    
    if ( !isset($tag[\'is_active\']) || $tag[\'is_active\'] == 0  )
    {
        return \'\';
    }
    else
    {
        if ( $tag[\'is_html\'] == 0 )
        {
            return htmlspecialchars($tag[\'value\']);
        }
        else
        {
            return $tag[\'value\'];
        }    
    }                                     
} 

/** 
 * Function MELBIS_INC_LANG_tags
 **/
function MELBIS_INC_LANG_tags($mTpl, $mModule)
{ 
    global $gParser, $gLang;
                       
    $parts = explode(\'_\', $mModule);
    $page_short =$parts[1];    
    $page_full = $parts[1].\'_\'.$parts[2];    
            
    $command = \"SELECT o.item_code AS name, 
                       IFNULL(tl.translate, o.origin) AS value, 
                       o.is_active,
                       o.is_html   
                  FROM ms_trans t
                  JOIN ms_trans_origin o
                    ON t.id = o.trans_id
             LEFT JOIN ms_trans_lang tl
                    ON o.id = tl.origin_id 
                   AND tl.lang_id = ( SELECT id FROM ms_lang where skey = \'$gLang\' )                    
                 WHERE t.table_key = \'kTag\'
                   AND ( t.name = \'$page_short\' OR t.name = \'$page_full\' )     
               \";                                                     
    $tags = $gParser->SqlSelect(__LINE__, $command);
    foreach ($tags as $tag)
    {                
        if ( $tag[\'is_active\'] == 0 )
        {
            $gParser->TplAssign($mTpl, \'TAG_\'.$tag[\'name\'], \'\');
        }
        else
        {
            if ( $tag[\'is_html\'] == 0 )
            {                                                    
                $gParser->TplAssign($mTpl, \'TAG_\'.$tag[\'name\'], htmlspecialchars($tag[\'value\']));
                $gParser->TplAssign($mTpl, \'TAGS_\'.$tag[\'name\'], addcslashes($tag[\'value\'], \"\'\"));
            }
            else
            {
                $gParser->TplAssign($mTpl, \'TAG_\'.$tag[\'name\'], $tag[\'value\']);                
            }
        }        
    }
} 

 
 
?>','2025-03-29 08:33:21');
INSERT INTO `ms_user_file_version` VALUES ('104','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {1MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {1MELBIS:melbis_base_footer([MS:VAR:LANG])}
    
    </body>
</html>
','2025-03-29 08:33:39');
INSERT INTO `ms_user_file_version` VALUES ('105','1','./../units/melbis_base_head.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_HEAD
 **/
function MELBIS_BASE_HEAD($mVars)
{ 
    global $gParser, $gLang, $gLangList;
                       
    // Create 
    $tpl = $gParser->TplCreate();           
                     
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__); 
                                                                
    // Alternate languages
    $command = \"SELECT * FROM ms_lang ORDER BY pos\";
    $langs = $gParser->SqlSelect(__LINE__, $command);        
    foreach ( $langs as $lang )
    {
        $gParser->TplAssign($tpl, \'LANG\', $lang[\'skey\']);
        $gParser->TplParse($tpl, \'ALTER\', \'.alter\');
    }    
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 




?>','2025-03-29 08:34:05');
INSERT INTO `ms_user_file_version` VALUES ('106','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {1MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}
    
    </body>
</html>
','2025-03-29 08:34:15');
INSERT INTO `ms_user_file_version` VALUES ('107','1','./../templates/default/units/melbis_base_head/main.htm','<head>
    <meta charset=\"utf8mb4\">          
    <meta name=\"generator\" content=\"Melbis Shop v6.4.0\">        
    <meta name=\"author\" content=\"KasDim\">
    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1, shrink-to-fit=no\">  
    <meta http-equiv=\"Last-Modified\" content=\"{LASTMODIFY}\">                    
    <title>{MS:PAGE:TITLE}</title>
    <meta name=\"description\" content=\"{MS:PAGE:DESCR}\">
    <meta name=\"robots\" content=\"index,follow\">

    <link rel=\"canonical\" href=\"https://{CONST:MELBIS_SHOP_DOMAIN}/{MS:VAR:LANG}{MS:PAGE:PATH}\">
    <link rel=\"alternate\" hreflang=\"x-default\" href=\"https://{CONST:MELBIS_SHOP_DOMAIN}/en{MS:PAGE:PATH}\" />
    {ALTER}     

    <link rel=\"icon\" href=\"{PATH}/images/icon.png\"> 
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/bootstrap.css\">  
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/icons/css/all.css\">
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/kasdim.css?{BUILD}\">

    <script src=\"{PATH}/jquery.js\"></script>      
    <script src=\"{PATH}/bootstrap.js\"></script>
    <script src=\"{PATH}/bootbox.js\"></script>
    <script src=\"{PATH}/kasdim.js?{BUILD}\"></script>       
</head>','2025-03-29 08:35:58');
INSERT INTO `ms_user_file_version` VALUES ('108','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer, $gLang;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);      
                                           
    // Define languge                   
    $default_lang = \'ru\';
    $lang = addslashes($mVars[\'get\'][\'lang\'] ?? $default_lang);
    $command = \"SELECT * FROM ms_lang WHERE skey = \'$lang\'\";
    $langs = $gParser->SqlSelectToArray(__LINE__, $command);               
    $gLang = ( $langs[\'skey\'] ?? $default_lang );     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $gLang;        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        $gParser->gVars[\'melbis\'][\'page\'][\'title\'] = MELBIS_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'ms\'][\'page\'] = $topic;  
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                //$gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                  //                         \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-29 08:43:13');
INSERT INTO `ms_user_file_version` VALUES ('109','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer, $gLang;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);      
                                           
    // Define languge                   
    $default_lang = \'ru\';
    $lang = addslashes($mVars[\'get\'][\'lang\'] ?? $default_lang);
    $command = \"SELECT * FROM ms_lang WHERE skey = \'$lang\'\";
    $langs = $gParser->SqlSelectToArray(__LINE__, $command);               
    $gLang = ( $langs[\'skey\'] ?? $default_lang );     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $gLang;        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");
        $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');   
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'ms\'][\'page\'] = $topic;  
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                //$gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                  //                         \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-29 08:43:30');
INSERT INTO `ms_user_file_version` VALUES ('110','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer, $gLang;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);      
                                           
    // Define languge                   
    $default_lang = \'ru\';
    $lang = addslashes($mVars[\'get\'][\'lang\'] ?? $default_lang);
    $command = \"SELECT * FROM ms_lang WHERE skey = \'$lang\'\";
    $langs = $gParser->SqlSelectToArray(__LINE__, $command);               
    $gLang = ( $langs[\'skey\'] ?? $default_lang );     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $gLang;        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");           
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';         
        $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'ms\'][\'page\'] = $topic;  
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                //$gParser->gVars[\'kasdim\'][\'page\'][\'title\'] = KASDIM_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                //$consist = KASDIM_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                //$gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                  //                         \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-29 08:43:37');
INSERT INTO `ms_user_file_version` VALUES ('111','1','./../templates/default/units/melbis_base_page/content_text.htm','<div class=\"container\">

    {CONSIST}

</div>','2025-03-29 08:45:24');
INSERT INTO `ms_user_file_version` VALUES ('112','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer, $gLang;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);      
                                           
    // Define languge                   
    $default_lang = \'ru\';
    $lang = addslashes($mVars[\'get\'][\'lang\'] ?? $default_lang);
    $command = \"SELECT * FROM ms_lang WHERE skey = \'$lang\'\";
    $langs = $gParser->SqlSelectToArray(__LINE__, $command);               
    $gLang = ( $langs[\'skey\'] ?? $default_lang );     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $gLang;        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");           
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';         
        $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'ms\'][\'page\'] = $topic;  
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                $consist = MELBIS_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                $gParser->TplAssign($tpl, [\'ID\'         => $topic[\'id\'], 
                                           \'CONSIST\'    => MELBIS_INC_STD_text($consist)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-29 08:46:04');
INSERT INTO `ms_user_file_version` VALUES ('113','1','./../templates/default/units/melbis_base_head/main.htm','<head>
    <meta charset=\"utf8mb4\">          
    <meta name=\"generator\" content=\"Melbis Shop v6.4.0\">        
    <meta name=\"author\" content=\"KasDim\">
    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1, shrink-to-fit=no\">  
    <meta http-equiv=\"Last-Modified\" content=\"{LASTMODIFY}\">                    
    <title>{MS:PAGE:TITLE}</title>
    <meta name=\"description\" content=\"{MS:PAGE:INTRO}\">
    <meta name=\"robots\" content=\"index,follow\">

    <link rel=\"canonical\" href=\"https://{CONST:MELBIS_SHOP_DOMAIN}/{MS:VAR:LANG}{MS:PAGE:PATH}\">
    <link rel=\"alternate\" hreflang=\"x-default\" href=\"https://{CONST:MELBIS_SHOP_DOMAIN}/en{MS:PAGE:PATH}\" />
    {ALTER}     

    <link rel=\"icon\" href=\"{PATH}/images/icon.png\"> 
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/bootstrap.css\">  
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/icons/css/all.css\">
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/kasdim.css?{BUILD}\">

    <script src=\"{PATH}/jquery.js\"></script>      
    <script src=\"{PATH}/bootstrap.js\"></script>
    <script src=\"{PATH}/bootbox.js\"></script>
    <script src=\"{PATH}/kasdim.js?{BUILD}\"></script>       
</head>','2025-03-29 08:46:52');
INSERT INTO `ms_user_file_version` VALUES ('114','1','./../templates/default/units/melbis_base_page/content_text.htm','<div class=\"container\">

    {DESCR}

</div>','2025-03-29 08:55:34');
INSERT INTO `ms_user_file_version` VALUES ('115','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer, $gLang;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);      
                                           
    // Define languge                   
    $default_lang = \'ru\';
    $lang = addslashes($mVars[\'get\'][\'lang\'] ?? $default_lang);
    $command = \"SELECT * FROM ms_lang WHERE skey = \'$lang\'\";
    $langs = $gParser->SqlSelectToArray(__LINE__, $command);               
    $gLang = ( $langs[\'skey\'] ?? $default_lang );     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $gLang;        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");           
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';         
        $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'ms\'][\'page\'] = $topic;  
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                $gParser->gVars[\'ms\'][\'page\'][\'intro\'] = MELBIS_INC_LANG(\'kTopic\', \'INTRO\', $page[\'id\'], $page[\'intro\']);
                $dsecr = MELBIS_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                $gParser->TplAssign($tpl, [\'ID\'     => $topic[\'id\'], 
                                           \'DESCR\'  => MELBIS_INC_STD_text($descr)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-29 08:55:55');
INSERT INTO `ms_user_file_version` VALUES ('116','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer, $gLang;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);      
                                           
    // Define languge                   
    $default_lang = \'ru\';
    $lang = addslashes($mVars[\'get\'][\'lang\'] ?? $default_lang);
    $command = \"SELECT * FROM ms_lang WHERE skey = \'$lang\'\";
    $langs = $gParser->SqlSelectToArray(__LINE__, $command);               
    $gLang = ( $langs[\'skey\'] ?? $default_lang );     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $gLang;        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");           
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';         
        $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'ms\'][\'page\'] = $topic;  
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                $gParser->gVars[\'ms\'][\'page\'][\'intro\'] = MELBIS_INC_LANG(\'kTopic\', \'INTRO\', $page[\'id\'], $page[\'intro\']);
                $descr = MELBIS_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                $gParser->TplAssign($tpl, [\'ID\'     => $topic[\'id\'], 
                                           \'DESCR\'  => MELBIS_INC_STD_text($descr)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-29 08:56:50');
INSERT INTO `ms_user_file_version` VALUES ('117','1','./../templates/default/units/melbis_base_header/lang.htm','<a href=\"/{LINK}{KASDIM:PAGE:PATH}\" hreflang=\"{LINK}\" class=\"dropdown-item\">{NAME}</a>
','2025-03-29 11:50:08');
INSERT INTO `ms_user_file_version` VALUES ('118','1','./../units/melbis_base_header.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_HEADER
 **/
function MELBIS_BASE_HEADER($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();         
    
    // Auto tag    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);     
    
    // Make language switcher
    $command = \"SELECT * 
                  FROM ms_lang                 
              ORDER BY pos
                \";                  
    $langs = $gParser->SqlSelect(__LINE__, $command);  
    foreach ( $langs as $lang )
    {        
        $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($lang[\'name\']),
                                        \'LINK\'  => $lang[\'skey\'] 
                                        ));                        
        $gParser->TplParse($tpl, \'LANG\', \'.lang\');
    }               
    
    if ( $mVars[\'login\'] )
    {
        $gParser->TplParse($tpl, \'ACCOUNT\', \'logout\');
    }
    else
    {
        $gParser->TplParse($tpl, \'ACCOUNT\', \'login\');
    }  
    
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');               
      
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-29 11:50:14');
INSERT INTO `ms_user_file_version` VALUES ('119','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">
                    <a href=\"/{KASDIM:VAR:LANG}/\"><img src=\"{PATH}/images/melbis_logo_hd.png\" class=\"img-fluid mt-2\" style=\"max-height: 97px;\"></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">     
                    <a href=\"/{KASDIM:VAR:LANG}/\"><img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 25px;\"> Melbis Shop<sup>6</sup></a>
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    {ACCOUNT}
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                        {ACCOUNT}
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 11:51:52');
INSERT INTO `ms_user_file_version` VALUES ('120','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">
                    <a href=\"/{KASDIM:VAR:LANG}/\"><img src=\"{PATH}/images/melbis_logo_hd.png\" class=\"img-fluid mt-2\" style=\"max-height: 97px;\"></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">     
                    <a href=\"/{KASDIM:VAR:LANG}/\"><img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 25px;\"> Melbis Shop<sup>6</sup></a>
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    {ACCOUNT}
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                        {ACCOUNT}
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 11:52:04');
INSERT INTO `ms_user_file_version` VALUES ('121','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [KASDIM:PAGE:ID] </script>
        
        {MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}
    
    </body>
</html>
','2025-03-29 11:52:22');
INSERT INTO `ms_user_file_version` VALUES ('122','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">
                    <a href=\"/{KASDIM:VAR:LANG}/\"><img src=\"{PATH}/images/melbis_logo_hd.png\" class=\"img-fluid mt-2\" style=\"max-height: 97px;\"></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">     
                    <a href=\"/{KASDIM:VAR:LANG}/\"><img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 25px;\"> Melbis Shop<sup>6</sup></a>
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 11:54:18');
INSERT INTO `ms_user_file_version` VALUES ('123','1','./../units/melbis_base_header.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_HEADER
 **/
function MELBIS_BASE_HEADER($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();         
    
    // Auto tag    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);     
    
    // Make language switcher
    $command = \"SELECT * 
                  FROM ms_lang                 
              ORDER BY pos
                \";                  
    $langs = $gParser->SqlSelect(__LINE__, $command);  
    foreach ( $langs as $lang )
    {        
        $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($lang[\'name\']),
                                        \'LINK\'  => $lang[\'skey\'] 
                                        ));                        
        $gParser->TplParse($tpl, \'LANG\', \'.lang\');
    }                   
    
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');               
      
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-29 11:54:40');
INSERT INTO `ms_user_file_version` VALUES ('124','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fas fa-dove\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.3em; margin-left: -20px\">.net</small><sup><small class=\"text-danger\" style=\"font-size: 0.2em; position: relative; top:-15px; left:-10px\">beta</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fas fa-dove\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 11:58:20');
INSERT INTO `ms_user_file_version` VALUES ('125','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\" style=\"font-size: 1.5rem\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block lead\">     
                    <a href=\"https://telegram.org/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-telegram\"></i> Telegram</a>
                    &nbsp; 
                    <a href=\"https://www.youtube.com/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-youtube\"></i> YouTube</a>
                    &nbsp;
                    <a href=\"mailto:{CONST:MELBIS_SHOP_EMAIL}\" class=\"text-decoration-none text-muted\"><i class=\"fa-solid fa-envelope\"></i> Email</a>
                </div>
            </div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-29 12:01:45');
INSERT INTO `ms_user_file_version` VALUES ('126','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.3em; margin-left: -20px\">.net</small><sup><small class=\"text-danger\" style=\"font-size: 0.2em; position: relative; top:-15px; left:-10px\">beta</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:02:27');
INSERT INTO `ms_user_file_version` VALUES ('127','1','./../units/melbis_base_footer.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_FOOTER
 **/
function MELBIS_BASE_FOOTER($mVars)
{ 
    global $gParser;
    
    // Create 
    $tpl = $gParser->TplCreate();    
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);                                                                 
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-29 12:02:45');
INSERT INTO `ms_user_file_version` VALUES ('128','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block lead\">     
                    <a href=\"https://telegram.org/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-telegram\"></i> Telegram</a>
                    &nbsp; 
                    <a href=\"https://www.youtube.com/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-youtube\"></i> YouTube</a>
                    &nbsp;
                    <a href=\"mailto:{CONST:MELBIS_SHOP_EMAIL}\" class=\"text-decoration-none text-muted\"><i class=\"fa-solid fa-envelope\"></i> Email</a>
                </div>
            </div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-29 12:03:47');
INSERT INTO `ms_user_file_version` VALUES ('129','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted display-4\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block lead\">     
                    <a href=\"https://telegram.org/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-telegram\"></i> Telegram</a>
                    &nbsp; 
                    <a href=\"https://www.youtube.com/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-youtube\"></i> YouTube</a>
                    &nbsp;
                    <a href=\"mailto:{CONST:MELBIS_SHOP_EMAIL}\" class=\"text-decoration-none text-muted\"><i class=\"fa-solid fa-envelope\"></i> Email</a>
                </div>
            </div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-29 12:03:59');
INSERT INTO `ms_user_file_version` VALUES ('130','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted display-1\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block lead\">     
                    <a href=\"https://telegram.org/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-telegram\"></i> Telegram</a>
                    &nbsp; 
                    <a href=\"https://www.youtube.com/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-youtube\"></i> YouTube</a>
                    &nbsp;
                    <a href=\"mailto:{CONST:MELBIS_SHOP_EMAIL}\" class=\"text-decoration-none text-muted\"><i class=\"fa-solid fa-envelope\"></i> Email</a>
                </div>
            </div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-29 12:04:03');
INSERT INTO `ms_user_file_version` VALUES ('131','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted display-5\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block lead\">     
                    <a href=\"https://telegram.org/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-telegram\"></i> Telegram</a>
                    &nbsp; 
                    <a href=\"https://www.youtube.com/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-youtube\"></i> YouTube</a>
                    &nbsp;
                    <a href=\"mailto:{CONST:MELBIS_SHOP_EMAIL}\" class=\"text-decoration-none text-muted\"><i class=\"fa-solid fa-envelope\"></i> Email</a>
                </div>
            </div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-29 12:04:08');
INSERT INTO `ms_user_file_version` VALUES ('132','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted display-4\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block lead\">     
                    <a href=\"https://telegram.org/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-telegram\"></i> Telegram</a>
                    &nbsp; 
                    <a href=\"https://www.youtube.com/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-youtube\"></i> YouTube</a>
                    &nbsp;
                    <a href=\"mailto:{CONST:MELBIS_SHOP_EMAIL}\" class=\"text-decoration-none text-muted\"><i class=\"fa-solid fa-envelope\"></i> Email</a>
                </div>
            </div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-29 12:04:15');
INSERT INTO `ms_user_file_version` VALUES ('133','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted display-5\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block lead\">     
                    <a href=\"https://telegram.org/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-telegram\"></i> Telegram</a>
                    &nbsp; 
                    <a href=\"https://www.youtube.com/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-youtube\"></i> YouTube</a>
                    &nbsp;
                    <a href=\"mailto:{CONST:MELBIS_SHOP_EMAIL}\" class=\"text-decoration-none text-muted\"><i class=\"fa-solid fa-envelope\"></i> Email</a>
                </div>
            </div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-29 12:04:32');
INSERT INTO `ms_user_file_version` VALUES ('134','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block lead\">     
                    <a href=\"https://telegram.org/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-telegram\"></i> Telegram</a>
                    &nbsp; 
                    <a href=\"https://www.youtube.com/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-youtube\"></i> YouTube</a>
                    &nbsp;
                    <a href=\"mailto:{CONST:MELBIS_SHOP_EMAIL}\" class=\"text-decoration-none text-muted\"><i class=\"fa-solid fa-envelope\"></i> Email</a>
                </div>
            </div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-29 12:05:00');
INSERT INTO `ms_user_file_version` VALUES ('135','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid kasdim_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\" style=\"font-size: 1.5rem\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block lead\">     
                    <a href=\"https://telegram.org/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-telegram\"></i> Telegram</a>
                    &nbsp; 
                    <a href=\"https://www.youtube.com/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-youtube\"></i> YouTube</a>
                    &nbsp;
                    <a href=\"mailto:{CONST:MELBIS_SHOP_EMAIL}\" class=\"text-decoration-none text-muted\"><i class=\"fa-solid fa-envelope\"></i> Email</a>
                </div>
            </div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-29 12:05:06');
INSERT INTO `ms_user_file_version` VALUES ('136','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.3em; margin-left: -20px\">{TAG_SITE_SUB}</small></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:10:21');
INSERT INTO `ms_user_file_version` VALUES ('137','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em; margin-left: -10px\">{TAG_SITE_SUB}</small></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:10:40');
INSERT INTO `ms_user_file_version` VALUES ('138','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em; margin-left: 10px\">{TAG_SITE_SUB}</small></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:10:51');
INSERT INTO `ms_user_file_version` VALUES ('139','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em; margin-left: 0px\">{TAG_SITE_SUB}</small></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:11:02');
INSERT INTO `ms_user_file_version` VALUES ('140','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em; margin-left: 10px\">{TAG_SITE_SUB}</small></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:11:09');
INSERT INTO `ms_user_file_version` VALUES ('141','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em; margin-left: 0px\">{TAG_SITE_SUB}</small></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:11:48');
INSERT INTO `ms_user_file_version` VALUES ('142','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:11:56');
INSERT INTO `ms_user_file_version` VALUES ('143','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.2em; position: relative; top:-15px; left:-10px\">beta</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:14:11');
INSERT INTO `ms_user_file_version` VALUES ('144','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.2em; position: relative; top:-15px; left:-10px\">{SCRIPT_VERSION}{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:15:56');
INSERT INTO `ms_user_file_version` VALUES ('145','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.2em; position: relative; top:-15px; left:-10px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:16:06');
INSERT INTO `ms_user_file_version` VALUES ('146','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.3em; position: relative; top:-15px; left:-10px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:16:14');
INSERT INTO `ms_user_file_version` VALUES ('147','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-15px; left:-10px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:16:20');
INSERT INTO `ms_user_file_version` VALUES ('148','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-55px; left:-10px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:16:30');
INSERT INTO `ms_user_file_version` VALUES ('149','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-15px; left:-100px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:16:37');
INSERT INTO `ms_user_file_version` VALUES ('150','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-15px; left:-150px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:16:43');
INSERT INTO `ms_user_file_version` VALUES ('151','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-25px; left:-150px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:16:52');
INSERT INTO `ms_user_file_version` VALUES ('152','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-150px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:16:59');
INSERT INTO `ms_user_file_version` VALUES ('153','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-250px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:17:08');
INSERT INTO `ms_user_file_version` VALUES ('154','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-200px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:17:12');
INSERT INTO `ms_user_file_version` VALUES ('155','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.2em; position: relative; top:-20px; left:-200px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:17:27');
INSERT INTO `ms_user_file_version` VALUES ('156','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.2em; position: relative; top:-20px; left:-20px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:17:51');
INSERT INTO `ms_user_file_version` VALUES ('157','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.2em; position: relative; top:-20px; left:-100px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:17:58');
INSERT INTO `ms_user_file_version` VALUES ('158','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.2em; position: relative; top:-20px; left:-120px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:18:05');
INSERT INTO `ms_user_file_version` VALUES ('159','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.2em; position: relative; top:-20px; left:-100px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:18:14');
INSERT INTO `ms_user_file_version` VALUES ('160','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.2em; position: relative; top:-15px; left:-100px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:18:26');
INSERT INTO `ms_user_file_version` VALUES ('161','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.2em; position: relative; top:-250px; left:-100px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:18:46');
INSERT INTO `ms_user_file_version` VALUES ('162','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.2em; position: relative; top:-15px; left:-200px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:18:54');
INSERT INTO `ms_user_file_version` VALUES ('163','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.2em; position: relative; top:-20px; left:-200px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:19:02');
INSERT INTO `ms_user_file_version` VALUES ('164','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.2em; position: relative; top:-20px; left:-10px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:19:44');
INSERT INTO `ms_user_file_version` VALUES ('165','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.2em; position: relative; top:-20px; left:-100px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:19:51');
INSERT INTO `ms_user_file_version` VALUES ('166','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-100px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:20:02');
INSERT INTO `ms_user_file_version` VALUES ('167','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-120px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{KASDIM:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:20:11');
INSERT INTO `ms_user_file_version` VALUES ('168','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer, $gLang;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);      
                                           
    // Define languge                   
    $default_lang = \'ru\';
    $lang = addslashes($mVars[\'get\'][\'lang\'] ?? $default_lang);
    $command = \"SELECT * FROM ms_lang WHERE skey = \'$lang\'\";
    $langs = $gParser->SqlSelectToArray(__LINE__, $command);               
    $gLang = ( $langs[\'skey\'] ?? $default_lang );     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $gLang;        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM ms_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");           
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';         
        $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'ms\'][\'page\'] = $topic;  
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM ms_store s
                          JOIN ms_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                $gParser->gVars[\'ms\'][\'page\'][\'intro\'] = MELBIS_INC_LANG(\'kTopic\', \'INTRO\', $page[\'id\'], $page[\'intro\']);
                $descr = MELBIS_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                $gParser->TplAssign($tpl, [\'ID\'     => $topic[\'id\'], 
                                           \'DESCR\'  => MELBIS_INC_STD_text($descr)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-29 12:31:07');
INSERT INTO `ms_user_file_version` VALUES ('169','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{MS:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-120px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{MS:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{KASDIM:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([KASDIM:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{KASDIM:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:31:20');
INSERT INTO `ms_user_file_version` VALUES ('170','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{MS:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-120px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{MS:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{MS:VAR:LANG}/\">
                    <img src=\"{PATH}/images/logo_small_hd.png\" class=\"d-inline-block align-top\" style=\"height: 28px;\"> Melbis Shop<sup>6</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{MS:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([MS:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{MS:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:31:42');
INSERT INTO `ms_user_file_version` VALUES ('171','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{MS:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-120px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{MS:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{MS:VAR:LANG}/\">                    
                    <span class=\"text-primary\"><i class=\"fas fa-dove\"></i></span> &nbsp;{TAG_SITE_NAME} <sup>{TAG_SITE_SUB}</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{MS:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([MS:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{MS:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:37:40');
INSERT INTO `ms_user_file_version` VALUES ('172','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{MS:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-120px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{MS:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{MS:VAR:LANG}/\">                    
                    <span class=\"text-primary\"><i class=\"fas fa-shop\"></i></span> &nbsp;{TAG_SITE_NAME} <sup>{TAG_SITE_SUB}</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{MS:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([MS:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{MS:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:38:18');
INSERT INTO `ms_user_file_version` VALUES ('173','1','./../templates/default/units/melbis_base_header/scripts.htm','<script type=\"text/javascript\">

// Language
//==================================================================================================
$(\'div.language_set a[hreflang={KASDIM:VAR:LANG}]\').addClass(\'active\');
$(\'div.language_set\').prev().html($(\'div.language_set a[hreflang={KASDIM:VAR:LANG}]\').html())


</script>
  ','2025-03-29 12:40:11');
INSERT INTO `ms_user_file_version` VALUES ('174','1','./../templates/default/units/melbis_base_header/scripts.htm','<script type=\"text/javascript\">

// Language
//==================================================================================================
$(\'div.language_set a[hreflang={KASDIM:VAR:LANG}]\').addClass(\'active\');
$(\'div.language_set\').prev().html($(\'div.language_set a[hreflang={KASDIM:VAR:LANG}]\').html())


</script>
  ','2025-03-29 12:40:24');
INSERT INTO `ms_user_file_version` VALUES ('175','1','./../templates/default/units/melbis_base_header/scripts.htm','<script type=\"text/javascript\">

// Language
//==================================================================================================
$(\'div.language_set a[hreflang={MS:VAR:LANG}]\').addClass(\'active\');
$(\'div.language_set\').prev().html($(\'div.language_set a[hreflang={MS:VAR:LANG}]\').html())


</script>
  ','2025-03-29 12:41:47');
INSERT INTO `ms_user_file_version` VALUES ('176','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var kasdim_topic_id = [MS:PAGE:ID] </script>
        
        {MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}
    
    </body>
</html>
','2025-03-29 12:42:10');
INSERT INTO `ms_user_file_version` VALUES ('177','1','./../templates/default/melbis.js','/*
// Vars
var melbis_topic_id = 0;

// Start
$( document ).ready(function() 
{
    melbis_navbar_active();    
});

// Navbar: set active menu item
function melbis_navbar_active()
{
    for( var item of $(\'.navbar-nav a\')) 
    {   
        if ( $(item).data(\'id\') == melbis_topic_id )
        {
            $(item).addClass(\'text-white\');
            $(item).parent(\'li\').addClass(\'bg-primary\');
        }
    }
}

// Navbar: dropdown menu
$(\'.dropdown-menu\').on(\'click\', \'a.dropdown-toggle\', function(event) 
{    
    if ( !$(this).next().hasClass(\'show\') ) 
    {
        $(this).parents(\'.dropdown-menu\').first().find(\'.show\').removeClass(\'show\');
    }                                         
    var sub = $(this).next(\'.dropdown-menu\');    
    if ( sub.children().length > 0 )
    {
        sub.toggleClass(\'show\');
    }
    else
    {           
        sub.html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
        sub.toggleClass(\'show\');        
        $.post(\'/?mod=melbis_cataloge_sub\',        
            { id: $(this).data(\'id\') },
            function(data) 
            {            
               sub.html(data);               
               melbis_navbar_active();               
            }
        );
    }
    $(this).parents(\'li.nav-item.dropdown.show\').on(\'hidden.bs.dropdown\', function(e) 
    {
        $(\'.dropdown-submenu .show\').removeClass(\'show\');
    });
    
    return false;
});
*/


// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card-body\').find(\'h5\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});


// Serialize Object
$.fn.melbis_serial = function()
{
   var o = {};
   var a = this.serializeArray();
   $.each(a, function() {
       if (o[this.name]) {
           if (!o[this.name].push) {
               o[this.name] = [o[this.name]];
           }
           o[this.name].push(this.value || \'\');
       } else {
           o[this.name] = this.value || \'\';
       }
   });   
   
   return o;
};


// Numbers round and format
function melbis_num(n, c)
{
    var n = n, 
    c = isNaN(c = Math.abs(c)) ? 2 : c, 
    d = d == undefined ? \".\" : d, 
    t = t == undefined ? \"\'\" : t, 
    s = n < 0 ? \"-\" : \"\", 
    i = parseInt(n = Math.abs(+n || 0).toFixed(c)) + \"\", 
    j = (j = i.length) > 3 ? j % 3 : 0;
   return s + (j ? i.substr(0, j) + t : \"\") + i.substr(j).replace(/(\\d{3})(?=\\d)/g, \"$1\" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : \"\");
}


','2025-03-29 12:43:05');
INSERT INTO `ms_user_file_version` VALUES ('178','1','./../templates/default/units/melbis_base_header/lang.htm','<a href=\"/{LINK}{MS:PAGE:PATH}\" hreflang=\"{LINK}\" class=\"dropdown-item\">{NAME}</a>
','2025-03-29 12:44:07');
INSERT INTO `ms_user_file_version` VALUES ('179','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var melbis_topic_id = [MS:PAGE:ID] </script>
        
        {MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"kasdim_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}
    
    </body>
</html>
','2025-03-29 12:47:14');
INSERT INTO `ms_user_file_version` VALUES ('180','1','./../templates/default/units/melbis_base_header/scripts.htm','<script type=\"text/javascript\">

// Language
//==================================================================================================
$(\'div.language_set a[hreflang={MS:VAR:LANG}]\').addClass(\'active\');
$(\'div.language_set\').prev().html($(\'div.language_set a[hreflang={MS:VAR:LANG}]\').html())

// Navbar
//==================================================================================================

// Start
$( document ).ready(function() 
{
    melbis_navbar_active();    
});

// Navbar: set active menu item
function melbis_navbar_active()
{    
    for( var item of $(\'.navbar-nav a\')) 
    {   
        if ( $(item).data(\'id\') == melbis_topic_id )
        {
            $(item).addClass(\'text-white\');
            $(item).parent(\'li\').addClass(\'bg-primary\');
        }
    }
}

// Client nav bar
if ( $(\'header div.logo\').length == 0 )
{
    $(\'.navbar-brand\').removeClass(\'invisible\');
    $(\'.navbar-brand\').addClass(\'visible\');
    $(\'nav.site_title\').addClass(\'fixed-top\');     
}


// Navbar: Show small logo on scroll
$(window).on(\'scroll\', function(event) 
{    
    if ( $(\'header div.logo\').length != 0 )
    {
        if ( $(window).scrollTop() >= 120 )
        {        
            $(\'.navbar-brand\').removeClass(\'invisible\');
            $(\'.navbar-brand\').addClass(\'visible\');
            $(\'nav.site_title\').addClass(\'fixed-top\'); 
        }
        else
        {
            $(\'.navbar-brand\').removeClass(\'visible\');
            $(\'.navbar-brand\').addClass(\'invisible\');
            $(\'nav.site_title\').removeClass(\'fixed-top\');     
        }
    } 
});

// Navbar: dropdown menu
$(\'.dropdown-menu\').on(\'click\', \'a.dropdown-toggle\', function(event) 
{    
    if ( !$(this).next().hasClass(\'show\') ) 
    {
        $(this).parents(\'.dropdown-menu\').first().find(\'.show\').removeClass(\'show\');
    }                                         
    var sub = $(this).next(\'.dropdown-menu\');    
    if ( sub.children().length > 0 )
    {
        sub.toggleClass(\'show\');
    }
    else
    {           
        sub.html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
        sub.toggleClass(\'show\');                
        $.post(\'/{MS:VAR:LANG}/?mod=melbis_cataloge_sub\',        
            { id: $(this).data(\'id\') },
            function(data) 
            {            
               sub.html(data);               
               melbis_navbar_active();               
            }
        );
    }
    $(this).parents(\'li.nav-item.dropdown.show\').on(\'hidden.bs.dropdown\', function(e) 
    {
        $(\'.dropdown-submenu .show\').removeClass(\'show\');
    });
    
    return false;
});



</script>
  ','2025-03-29 12:54:03');
INSERT INTO `ms_user_file_version` VALUES ('181','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{MS:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-120px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{MS:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{MS:VAR:LANG}/\">                    
                    <span class=\"text-primary\"><i class=\"fas fa-shop\"></i></span> &nbsp;{TAG_SITE_NAME} <sub>{TAG_SITE_SUB}</sub>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{MS:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([MS:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{MS:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:54:45');
INSERT INTO `ms_user_file_version` VALUES ('182','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{MS:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-120px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{MS:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{MS:VAR:LANG}/\">                    
                    <span class=\"text-primary\"><i class=\"fas fa-shop\"></i></span> &nbsp;{TAG_SITE_NAME} <sup>{TAG_SITE_SUB}</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{MS:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([MS:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{MS:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_LOGIN}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 12:54:59');
INSERT INTO `ms_user_file_version` VALUES ('183','1','./../templates/default/units/melbis_base_head/main.htm','<head>
    <meta charset=\"utf8mb4\">          
    <meta name=\"generator\" content=\"Melbis Shop v6.4.0\">        
    <meta name=\"author\" content=\"KasDim\">
    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1, shrink-to-fit=no\">  
    <meta http-equiv=\"Last-Modified\" content=\"{LASTMODIFY}\">                    
    <title>{MS:PAGE:TITLE}</title>
    <meta name=\"description\" content=\"{MS:PAGE:INTRO}\">
    <meta name=\"robots\" content=\"index,follow\">

    <link rel=\"canonical\" href=\"https://{CONST:MELBIS_SHOP_DOMAIN}/{MS:VAR:LANG}{MS:PAGE:PATH}\">
    <link rel=\"alternate\" hreflang=\"x-default\" href=\"https://{CONST:MELBIS_SHOP_DOMAIN}/en{MS:PAGE:PATH}\" />
    {ALTER}     

    <link rel=\"icon\" href=\"{PATH}/images/icon.png\"> 
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/bootstrap.css\">  
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/icons/css/all.css\">
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/melbis.css?{BUILD}\">

    <script src=\"{PATH}/jquery.js\"></script>      
    <script src=\"{PATH}/bootstrap.js\"></script>
    <script src=\"{PATH}/bootbox.js\"></script>
    <script src=\"{PATH}/melbis.js?{BUILD}\"></script>       
</head>','2025-03-29 13:01:01');
INSERT INTO `ms_user_file_version` VALUES ('184','1','./../templates/default/units/melbis_base_head/main.htm','<head>
    <meta charset=\"utf8mb4\">          
    <meta name=\"generator\" content=\"Melbis Shop v6.4.0\">        
    <meta name=\"author\" content=\"KasDim\">
    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1, shrink-to-fit=no\">  
    <meta http-equiv=\"Last-Modified\" content=\"{LASTMODIFY}\">                    
    <title>{MS:PAGE:TITLE}</title>
    <meta name=\"description\" content=\"{MS:PAGE:INTRO}\">
    <meta name=\"robots\" content=\"index,follow\">

    <link rel=\"canonical\" href=\"https://{CONST:MELBIS_SHOP_DOMAIN}/{MS:VAR:LANG}{MS:PAGE:PATH}\">
    <link rel=\"alternate\" hreflang=\"x-default\" href=\"https://{CONST:MELBIS_SHOP_DOMAIN}/en{MS:PAGE:PATH}\" />
    {ALTER}     

    <link rel=\"icon\" href=\"{PATH}/images/demo_logo.png\"> 
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/bootstrap.css\">  
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/icons/css/all.css\">
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/melbis.css?{BUILD}\">

    <script src=\"{PATH}/jquery.js\"></script>      
    <script src=\"{PATH}/bootstrap.js\"></script>
    <script src=\"{PATH}/bootbox.js\"></script>
    <script src=\"{PATH}/melbis.js?{BUILD}\"></script>       
</head>','2025-03-29 13:07:03');
INSERT INTO `ms_user_file_version` VALUES ('185','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{MS:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-120px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{MS:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{MS:VAR:LANG}/\">                    
                    <span class=\"text-primary\"><i class=\"fas fa-shop\"></i></span> &nbsp;{TAG_SITE_NAME} <sup>{TAG_SITE_SUB}</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{MS:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([MS:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{MS:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-user\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 13:18:48');
INSERT INTO `ms_user_file_version` VALUES ('186','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{MS:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-120px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{MS:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{MS:VAR:LANG}/\">                    
                    <span class=\"text-primary\"><i class=\"fas fa-shop\"></i></span> &nbsp;{TAG_SITE_NAME} <sup>{TAG_SITE_SUB}</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{MS:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-cart-shopping\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([MS:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                    <a href=\"/{MS:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-cart-shopping\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 13:20:10');
INSERT INTO `ms_user_file_version` VALUES ('187','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{MS:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-120px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{MS:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{MS:VAR:LANG}/\">                    
                    <span class=\"text-primary\"><i class=\"fas fa-shop\"></i></span> &nbsp;{TAG_SITE_NAME} <sup>{TAG_SITE_SUB}</sup>
                </a>
                <span class=\"d-block d-xl-none\">                    
                    <a href=\"/{MS:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-cart-shopping\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([MS:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">    
                    <button class=\"btn btn-light my-2 my-sm-0\" data-toggle=\"modal\" data-target=\"#melbis_win_checkout\"><i class=\"fas fa-shopping-cart\"></i>  Checkout</button> 
                    <a href=\"/{MS:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-cart-shopping\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 13:25:03');
INSERT INTO `ms_user_file_version` VALUES ('188','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{MS:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-120px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{MS:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{MS:VAR:LANG}/\">                    
                    <span class=\"text-primary\"><i class=\"fas fa-shop\"></i></span> &nbsp;{TAG_SITE_NAME} <sup>{TAG_SITE_SUB}</sup>
                </a>
                <span class=\"d-block d-xl-none\">        
                    <button class=\"btn btn-light my-2 my-sm-0\" data-toggle=\"modal\" data-target=\"#melbis_win_checkout\"><i class=\"fas fa-shopping-cart\"></i>  Checkout</button>            
                    <a href=\"/{MS:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-cart-shopping\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([MS:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">                         
                    <a href=\"/{MS:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-cart-shopping\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 13:25:17');
INSERT INTO `ms_user_file_version` VALUES ('189','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{MS:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-120px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{MS:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{MS:VAR:LANG}/\">                    
                    <span class=\"text-primary\"><i class=\"fas fa-shop\"></i></span> &nbsp;{TAG_SITE_NAME} <sup>{TAG_SITE_SUB}</sup>
                </a>
                <span class=\"d-block d-xl-none\">        
                    <button class=\"btn btn-light my-2 my-sm-0\" data-toggle=\"modal\" data-target=\"#melbis_win_checkout\"><i class=\"fas fa-shopping-cart\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></button>            
                    <a href=\"/{MS:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-cart-shopping\"></i><span class=\"d-none d-sm-inline\">  </span></a>
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([MS:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">                         
                    <a href=\"/{MS:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-cart-shopping\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 13:26:58');
INSERT INTO `ms_user_file_version` VALUES ('190','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{MS:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-120px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{MS:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{MS:VAR:LANG}/\">                    
                    <span class=\"text-primary\"><i class=\"fas fa-shop\"></i></span> &nbsp;{TAG_SITE_NAME} <sup>{TAG_SITE_SUB}</sup>
                </a>
                <span class=\"d-block d-xl-none\">        
                    <button class=\"btn btn-light my-2 my-sm-0\" data-toggle=\"modal\" data-target=\"#melbis_win_checkout\"><i class=\"fas fa-shopping-cart\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></button>            
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([MS:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">                         
                    <a href=\"/{MS:VAR:LANG}/account/\" class=\"btn btn-light my-2 my-sm-0 text-nowrap\"><i class=\"fas fa-cart-shopping\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></a>                          
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 13:27:12');
INSERT INTO `ms_user_file_version` VALUES ('191','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo kasdim_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{MS:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-120px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{MS:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid kasdim_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{MS:VAR:LANG}/\">                    
                    <span class=\"text-primary\"><i class=\"fas fa-shop\"></i></span> &nbsp;{TAG_SITE_NAME} <sup>{TAG_SITE_SUB}</sup>
                </a>
                <span class=\"d-block d-xl-none\">        
                    <button class=\"btn btn-light my-2 my-sm-0\" data-toggle=\"modal\" data-target=\"#melbis_win_checkout\"><i class=\"fas fa-shopping-cart\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></button>            
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([MS:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                        <button class=\"btn btn-light my-2 my-sm-0\" data-toggle=\"modal\" data-target=\"#melbis_win_checkout\"><i class=\"fas fa-shopping-cart\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></button>                         
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 13:27:40');
INSERT INTO `ms_user_file_version` VALUES ('192','1','./../units/melbis_base_head.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_HEAD
 **/
function MELBIS_BASE_HEAD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();           
                     
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__); 
                                                                
    // Alternate languages
    $command = \"SELECT * FROM ms_lang ORDER BY pos\";
    $langs = $gParser->SqlSelect(__LINE__, $command);        
    foreach ( $langs as $lang )
    {
        $gParser->TplAssign($tpl, \'LANG\', $lang[\'skey\']);
        $gParser->TplParse($tpl, \'ALTER\', \'.alter\');
    }    
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 




?>','2025-03-29 14:03:05');
INSERT INTO `ms_user_file_version` VALUES ('193','1','./../units/melbis_core_translate.php','<?php
/***************************************************************************************************
 * @version 1.0
 * @copyright ...
 * @link ...
 * @author ...
 **************************************************************************************************/


/** 
 * Function MELBIS_CORE_TRANSLATE
 **/
function MELBIS_CORE_TRANSLATE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Sample DB Query
    /*
    $command = \"SELECT *
                  FROM ms_store
                 WHERE id > \'$mVars[var_name_1]\'
              ORDER BY id
                \";                    
    $store = $gParser->SqlSelect(__LINE__, $command);
    foreach ($store as $row)
    {
        $gParser->TplAssign($tpl, array(\'ID\'   => $row[\'id\'],
                                        \'NAME\' => htmlspecialchars($row[\'name\']),
                                        \'INFO\' => $mVars[\'var_name_2\']
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }
    */

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-29 14:11:17');
INSERT INTO `ms_user_file_version` VALUES ('194','1','./../units/melbis_core_translate.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_CORE_TRANSLATE
 **/
function MELBIS_CORE_TRANSLATE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Sample DB Query
    /*
    $command = \"SELECT *
                  FROM ms_store
                 WHERE id > \'$mVars[var_name_1]\'
              ORDER BY id
                \";                    
    $store = $gParser->SqlSelect(__LINE__, $command);
    foreach ($store as $row)
    {
        $gParser->TplAssign($tpl, array(\'ID\'   => $row[\'id\'],
                                        \'NAME\' => htmlspecialchars($row[\'name\']),
                                        \'INFO\' => $mVars[\'var_name_2\']
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }
    */

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-29 14:11:30');
INSERT INTO `ms_user_file_version` VALUES ('195','1','./../units/melbis_core_translate.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/

/** 
 * Function MELBIS_CORE_TRANSLATE
 **/
function MELBIS_CORE_TRANSLATE($mVars)
{ 
    global $gParser; 

    // Header
    header(\'Content-Type: text/plain; charset=utf-8\');   
                                      
    // Vars   
    $update = [];
    $now = MELBIS_INC_STD_get_now();
    $pagetime = $gParser->RunTime();
    echo \"> Running at the $now \\r\\n\";             
         
    // From lang
    $command = \"SELECT * FROM ms_lang WHERE is_origin = 1\";               
    $from = $gParser->SqlSelectToArray(__LINE__, $command);    
           
    // To lang
    $command = \"SELECT * 
                  FROM ms_lang
                 WHERE is_origin <> 1
              ORDER BY pos
              \";                
    $langs = $gParser->SqlSelect(__LINE__, $command);
    foreach ($langs as $lang) 
    {         
        echo \"\\r\\n> Translate to: $lang[name] \\r\\n\";

        // Content        
        $command = \"SELECT o.id, o.trans_id, o.context, o.origin, o.is_html, tl.id AS tl_id, LENGTH(o.origin) AS size   
                      FROM ms_trans_origin o
                 LEFT JOIN ms_trans_lang tl
                        ON o.id = tl.origin_id 
                       AND tl.lang_id = \'$lang[id]\'  
                     WHERE md5(CONCAT(o.context, o.origin)) <> o.crc 
                        OR tl.id IS NULL
                    HAVING size < 15000
                  ORDER BY size ASC                    
                     LIMIT 10
                   \";
        $origins = $gParser->SqlSelect(__LINE__, $command);
        foreach ($origins as $origin)
        {
            echo \'[\'.$origin[\'id\'].\"]: \";
            
            $translate = KASDIM_INC_TRANSLATE_deepl($origin[\'origin\'], 
                                                    $origin[\'context\'], 
                                                    $from[\'skey\'], 
                                                    $lang[\'skey\'], 
                                                    $origin[\'is_html\']);
            echo $translate.\"\\r\\n\"; 
            
            if ( is_null($origin[\'tl_id\']) )
            {   
                // Add translate
                $hash = [];
                $hash[\'id\'] = $gParser->SqlGenId(\'trans_lang\');
                $hash[\'lang_id\'] = $lang[\'id\'];
                $hash[\'trans_id\'] = $origin[\'trans_id\'];
                $hash[\'origin_id\'] = $origin[\'id\'];            
                $hash[\'translate\'] = $translate;            
                $gParser->SqlInsert(__LINE__, \'ms_trans_lang\', $hash);            
            }
            else
            {    
                // Change translate
                $hash = [];
                $hash[\'id\'] = $origin[\'tl_id\'];
                $hash[\'translate\'] = $translate;
                $gParser->SqlUpdate(__LINE__, \'ms_trans_lang\', $hash, \'id\');                          
            }
            // Save Update
            $update[$origin[\'id\']] = md5($origin[\'context\'].$origin[\'origin\']); 
        }                                      
    } 
    
    // Update
    foreach ( $update as $id => $crc )
    {    
        $hash = [];
        $hash[\'id\'] = $id;
        $hash[\'crc\'] = $crc;
        $gParser->SqlUpdate(__LINE__, \'ms_trans_origin\', $hash, \'id\');
    }                                        
    
    return \'\';                    
} 

?>','2025-03-29 14:12:23');
INSERT INTO `ms_user_file_version` VALUES ('196','1','./../units/melbis_core_translate.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/

/** 
 * Function MELBIS_CORE_TRANSLATE
 **/
function MELBIS_CORE_TRANSLATE($mVars)
{ 
    global $gParser; 

    // Header
    header(\'Content-Type: text/plain; charset=utf-8\');   
                                      
    // Vars   
    $update = [];
    $now = MELBIS_INC_STD_get_now();
    $pagetime = $gParser->RunTime();
    echo \"> Running at the $now \\r\\n\";             
         
    // From lang
    $command = \"SELECT * FROM ms_lang WHERE is_origin = 1\";               
    $from = $gParser->SqlSelectToArray(__LINE__, $command);    
           
    // To lang
    $command = \"SELECT * 
                  FROM ms_lang
                 WHERE is_origin <> 1
              ORDER BY pos
              \";                
    $langs = $gParser->SqlSelect(__LINE__, $command);
    foreach ($langs as $lang) 
    {         
        echo \"\\r\\n> Translate to: $lang[name] \\r\\n\";

        // Content        
        $command = \"SELECT o.id, o.trans_id, o.context, o.origin, o.is_html, tl.id AS tl_id, LENGTH(o.origin) AS size   
                      FROM ms_trans_origin o
                 LEFT JOIN ms_trans_lang tl
                        ON o.id = tl.origin_id 
                       AND tl.lang_id = \'$lang[id]\'  
                     WHERE md5(CONCAT(o.context, o.origin)) <> o.crc 
                        OR tl.id IS NULL
                    HAVING size < 15000
                  ORDER BY size ASC                    
                     LIMIT 10
                   \";
        $origins = $gParser->SqlSelect(__LINE__, $command);
        foreach ($origins as $origin)
        {
            echo \'[\'.$origin[\'id\'].\"]: \";
            
            $translate = KASDIM_INC_TRANSLATE_deepl($origin[\'origin\'], 
                                                    $origin[\'context\'], 
                                                    $from[\'skey\'], 
                                                    $lang[\'skey\'], 
                                                    $origin[\'is_html\']);
            echo $translate.\"\\r\\n\"; 
            
            if ( is_null($origin[\'tl_id\']) )
            {   
                // Add translate
                $hash = [];
                $hash[\'id\'] = $gParser->SqlGenId(\'trans_lang\');
                $hash[\'lang_id\'] = $lang[\'id\'];
                $hash[\'trans_id\'] = $origin[\'trans_id\'];
                $hash[\'origin_id\'] = $origin[\'id\'];            
                $hash[\'translate\'] = $translate;            
                $gParser->SqlInsert(__LINE__, \'ms_trans_lang\', $hash);            
            }
            else
            {    
                // Change translate
                $hash = [];
                $hash[\'id\'] = $origin[\'tl_id\'];
                $hash[\'translate\'] = $translate;
                $gParser->SqlUpdate(__LINE__, \'ms_trans_lang\', $hash, \'id\');                          
            }
            // Save Update
            $update[$origin[\'id\']] = md5($origin[\'context\'].$origin[\'origin\']); 
        }                                      
    } 
    
    // Update
    foreach ( $update as $id => $crc )
    {    
        $hash = [];
        $hash[\'id\'] = $id;
        $hash[\'crc\'] = $crc;
        $gParser->SqlUpdate(__LINE__, \'ms_trans_origin\', $hash, \'id\');
    }                                        
    
    return \'\';                    
} 

?>','2025-03-29 14:12:29');
INSERT INTO `ms_user_file_version` VALUES ('197','1','./../units/melbis_inc_translate.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff     
 **************************************************************************************************
 * 
 * MELBIS_INC_TRANSLATE_service          - Return file path from time
 * MELBIS_INC_TRANSLATE_service          - Convert HTML to plain text      
 *     
 **************************************************************************************************/

/** 
 * Function MELBIS_INC_TRANSLATE_service
 **/
function MELBIS_INC_TRANSLATE_service($mUserId, $mVars)
{ 
    global $gParser;
                       
    $command = \"SELECT * FROM ms_lang WHERE is_origin = 1\";               
    $from = $gParser->SqlSelectToArray(__LINE__, $command);    

    $command = \"SELECT * FROM ms_lang WHERE id = \'$mVars[lang_id]\'\";               
    $to = $gParser->SqlSelectToArray(__LINE__, $command);   

    $html = ( $mVars[\'is_html\'] > 0 );
    
    $result = MELBIS_INC_TRANSLATE_deepl($mVars[\'origin\'], $mVars[\'context\'], $from[\'skey\'], $to[\'skey\'], $html);

    return $result;
} 


/** 
 * Function MELBIS_INC_TRANSLATE_google
 **/
function MELBIS_INC_TRANSLATE_google($mText, $mContext, $mLangFrom, $mLangTo, $mHtml = false)
{    
    $data = array(\'q\'           => \'!\'.$mText,
                  \'target\'      => $mLangTo,
                  \'format\'      => ( $mHtml ) ? \'html\' : \'text\',
                  \'source\'      => $mLangFrom,
                  \'model\'       => \'nmt\',
                  \'key\'         => MELBIS_GOOGLE_API
                  );
    $ch = curl_init();    
    curl_setopt($ch, CURLOPT_URL, \'https://translation.googleapis.com/language/translate/v2\');
    curl_setopt($ch, CURLOPT_REFERER, \'https://site.com\');
    curl_setopt($ch, CURLOPT_POST, true);  
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
    curl_setopt($ch, CURLOPT_ENCODING, \"gzip\");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30);                
    $response = curl_exec($ch);
    if ( $response === false ) 
    {
        $error = curl_error($ch);
        curl_close($ch);
        die(\'PHP_ERROR: \'.$error);
    }
    $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    curl_close($ch);    
    if ( $http_code >= 200 && $http_code < 300 ) 
    {
        $data = json_decode($response, true);
        $result = ltrim($data[\'data\'][\'translations\'][0][\'translatedText\'], \'!\');  

        return $result;
    } 
    else 
    {        
        $error = json_decode($response, true);
        die(\"PHP_ERROR: \".$http_code.\" - \".($error[\'message\'] ?? \'Unkhown error\'));
    }  
}     


/** 
 * Function MELBIS_INC_TRANSLATE_deepl
 **/
function MELBIS_INC_TRANSLATE_deepl($mText, $mContext, $mLangFrom, $mLangTo, $mHtml = false)
{     
    $data = [
        \'text\'          => [ $mText ],
        \'context\'       => $mContext,
        \'tag_handling\'  => ( $mHtml ) ? \'html\' : \'\',
        \'source_lang\'   => $mLangFrom,
        \'target_lang\'   => $mLangTo
    ];
    
    // cURL
    //$ch = curl_init(\'https://api.deepl.com/v2/translate\'); 
    $ch = curl_init(\'https://api-free.deepl.com/v2/translate\');
    curl_setopt($ch, CURLOPT_HTTPHEADER, [
        \'Authorization: DeepL-Auth-Key \'.MELBIS_DEEPL_API,
        \'Content-Type: application/json\',
    ]);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    $response = curl_exec($ch);
    if ( $response === false ) 
    {
        $error = curl_error($ch);
        curl_close($ch);
        die(\'PHP_ERROR: \'.$error);
    }
    $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    curl_close($ch);    
    if ( $http_code >= 200 && $http_code < 300 ) 
    {
        $data = json_decode($response, true);
        $result = $data[\'translations\'][0][\'text\'];    

        return $result;
    } 
    else 
    {        
        $error = json_decode($response, true);
        die(\"PHP_ERROR: \".$http_code.\" - \".($error[\'message\'] ?? \'Unkhown error\'));
    }                             
} 



?>','2025-03-29 14:36:33');
INSERT INTO `ms_user_file_version` VALUES ('198','1','./../templates/default/melbis.css','/* Additional styles */

.dropdown-submenu {
  position: relative;
}

.dropdown-submenu a::after {
  transform: rotate(-90deg);
  position: absolute;
  right: 6px;
  top: .8em;
}

.dropdown-submenu .dropdown-menu {
  top: 0;
  left: 100%;
  margin-left: .1rem;
  margin-right: .1rem;
} 

.melbis_css_max_width {
    max-width: 1500px; 
}','2025-03-29 15:23:11');
INSERT INTO `ms_user_file_version` VALUES ('199','1','./../templates/default/units/melbis_base_page/content_text.htm','<div class=\"container-fluid mb-5 kasdim_css_max_width\">

    {DESCR}

</div>','2025-03-29 15:23:28');
INSERT INTO `ms_user_file_version` VALUES ('200','1','./../templates/default/units/melbis_base_page/content_goods.htm','<div class=\"container-fluid mb-5 kasdim_css_max_width\">

    {CONSIST}

</div>','2025-03-29 15:23:32');
INSERT INTO `ms_user_file_version` VALUES ('201','1','./../templates/default/units/melbis_base_page/content_goods.htm','<div class=\"container-fluid mb-5 melbis_css_max_width\">

    {CONSIST}

</div>','2025-03-29 15:23:38');
INSERT INTO `ms_user_file_version` VALUES ('202','1','./../templates/default/units/melbis_base_page/content_text.htm','<div class=\"container-fluid mb-5 melbis_css_max_width\">

    {DESCR}

</div>','2025-03-29 15:23:45');
INSERT INTO `ms_user_file_version` VALUES ('203','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo melbis_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{MS:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-120px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{MS:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid melbis_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{MS:VAR:LANG}/\">                    
                    <span class=\"text-primary\"><i class=\"fas fa-shop\"></i></span> &nbsp;{TAG_SITE_NAME} <sup>{TAG_SITE_SUB}</sup>
                </a>
                <span class=\"d-block d-xl-none\">        
                    <button class=\"btn btn-light my-2 my-sm-0\" data-toggle=\"modal\" data-target=\"#melbis_win_checkout\"><i class=\"fas fa-shopping-cart\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></button>            
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:kasdim_cataloge([MS:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                        <button class=\"btn btn-light my-2 my-sm-0\" data-toggle=\"modal\" data-target=\"#melbis_win_checkout\"><i class=\"fas fa-shopping-cart\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></button>                         
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 15:24:47');
INSERT INTO `ms_user_file_version` VALUES ('204','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid melbis_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\" style=\"font-size: 1.5rem\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block lead\">     
                    <a href=\"https://telegram.org/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-telegram\"></i> Telegram</a>
                    &nbsp; 
                    <a href=\"https://www.youtube.com/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-youtube\"></i> YouTube</a>
                    &nbsp;
                    <a href=\"mailto:{CONST:MELBIS_SHOP_EMAIL}\" class=\"text-decoration-none text-muted\"><i class=\"fa-solid fa-envelope\"></i> Email</a>
                </div>
            </div>
        </div>            
    </div>
</footer>                  

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>','2025-03-29 15:25:16');
INSERT INTO `ms_user_file_version` VALUES ('205','1','./../.htaccess','# Basic rules
AddDefaultCharset UTF-8
DirectoryIndex index.html index.htm index.php
Options -Indexes

ErrorDocument 404 /en/404/

RewriteEngine on

# Language auto 
RewriteCond %{HTTP:Accept-Language} ^en [NC]
RewriteRule ^$ /en/ [L,R=301]

RewriteCond %{HTTP:Accept-Language} ^ru [NC]
RewriteRule ^$ /ru/ [L,R=301]

RewriteCond %{HTTP:Accept-Language} ^uk [NC]
RewriteRule ^$ /uk/ [L,R=301]

# Default
RewriteRule ^$ /ru/ [L,R=301]

# Base page  
RewriteRule ^([a-z]{2})/$ index.php?lang=$1 [L,QSA]

# Modules
RewriteRule ^([a-z]{2})\\/([A-Za-z0-9_\\-]+)\\.php$ $2.php?lang=$1 [L,QSA]

# Core
RewriteRule ^core\\/([A-Za-z0-9_\\-\\.\\+]+)\\/$ index.php?mod=melbis_core_$1 [L,B,QSA]

# Cataloge pages
RewriteCond %{REQUEST_FILENAME} !-d
RewriteCond %{REQUEST_FILENAME} !-f
RewriteRule ^([a-z]{2})\\/(.+)$ index.php?mod=melbis_base_page&psu=$2&lang=$1 [L,QSA]






','2025-03-29 18:23:19');
INSERT INTO `ms_user_file_version` VALUES ('206','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var melbis_topic_id = [MS:PAGE:ID] </script>
        
        {MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main> 
        
        <div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_imageview\" data-backdrop=\"static\">
            <div class=\"modal-dialog modal-dialog-centered modal-xl modal-dialog-scrollable\" style=\"min-width: 95vw;\">
                <div class=\"modal-content\">
                    <div class=\"modal-body text-center p-1\" style=\"min-height: calc(100vh - 10rem)\">
                        <img src=\"\" style=\"cursor: pointer; max-height: calc(100vh - 10rem)\">                
                    </div>                
                    <div class=\"modal-footer\">                                                         
                        <button type=\"button\" class=\"btn btn-sm btn-secondary prev\">{TAG_IMG_PREV}</button>   
                        <button type=\"button\" class=\"btn btn-sm btn-secondary next\">{TAG_IMG_NEXT}</button>
                        <button type=\"button\" class=\"btn btn-sm btn-primary ml-auto\" data-dismiss=\"modal\">{TAG_IMG_CLOSE}</button>
                    </div>            
                </div>
            </div>
        </div>     
        
        {SCRIPTS}
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}
    
    </body>
</html>
','2025-03-29 18:25:15');
INSERT INTO `ms_user_file_version` VALUES ('207','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Auto image preview
//==================================================================================================

// Get image
$(\'main\').on(\'click\', \'.img_preview\', function() 
{
    if ( $(this).hasClass(\'img_max\') )
    {
        $(\'#melbis_win_imageview img\').removeClass(\'img-fluid\').addClass(\'melbis_css_img_detail\');    
    }                                                            
    else
    {
        $(\'#melbis_win_imageview img\').addClass(\'img-fluid\').removeClass(\'melbis_css_img_detail\');
    }
    $(\'#melbis_win_imageview img\').attr(\'src\', $(this).attr(\'src\'));
                     
    $(\'#melbis_win_imageview\').modal(\'show\'); 
});


// Get prev image 
$(\'#melbis_win_imageview .prev\').on(\'click\', function() 
{        
    var src = $(\'#melbis_win_imageview img\').attr(\'src\');
    $(\'main .img_preview\').each(function(i)
    {        
        if ( src == $(this).attr(\'src\') )                         
        {            
            if ( i > 0 )
            {
                src =  $(\'main .img_preview\').eq(i-1).attr(\'src\');
                if ( $(\'main .img_preview\').eq(i-1).hasClass(\'img_max\') )
                {
                    $(\'#melbis_win_imageview img\').removeClass(\'img-fluid\').addClass(\'melbis_css_img_detail\');    
                }                                                            
                else
                {
                    $(\'#melbis_win_imageview img\').addClass(\'img-fluid\').removeClass(\'melbis_css_img_detail\');
                }              
            }
            return false;             
        }          
    }); 
    $(\'#melbis_win_imageview img\').attr(\'src\', src);            
});


// Get next image 
$(\'#melbis_win_imageview .next\').on(\'click\', function() 
{            
    var src = $(\'#melbis_win_imageview img\').attr(\'src\');
    $(\'main .img_preview\').each(function(i)
    {                        
        if ( src == $(this).attr(\'src\') && i < $(\'main .img_preview\').length )                         
        {                        
            src =  $(\'main .img_preview\').eq(i+1).attr(\'src\');
            if ( $(\'main .img_preview\').eq(i+1).hasClass(\'img_max\') )
            {
                $(\'#melbis_win_imageview img\').removeClass(\'img-fluid\').addClass(\'melbis_css_img_detail\');    
            }                                                            
            else
            {
                $(\'#melbis_win_imageview img\').addClass(\'img-fluid\').removeClass(\'melbis_css_img_detail\');
            }                 
            return false;             
        }          
    });    
    $(\'#melbis_win_imageview img\').attr(\'src\', src);
});


// Close preview 
$(\'#melbis_win_imageview img\').on(\'click\', function() 
{            
    $(\'#melbis_win_imageview\').modal(\'hide\');
});
     

</script>','2025-03-29 18:25:37');
INSERT INTO `ms_user_file_version` VALUES ('208','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo melbis_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{MS:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-120px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{MS:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid melbis_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{MS:VAR:LANG}/\">                    
                    <span class=\"text-primary\"><i class=\"fas fa-shop\"></i></span> &nbsp;{TAG_SITE_NAME} <sup>{TAG_SITE_SUB}</sup>
                </a>
                <span class=\"d-block d-xl-none\">        
                    <button class=\"btn btn-light my-2 my-sm-0\" data-toggle=\"modal\" data-target=\"#melbis_win_checkout\"><i class=\"fas fa-shopping-cart\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></button>            
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {1MELBIS:melbis_cataloge([MS:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                        <button class=\"btn btn-light my-2 my-sm-0\" data-toggle=\"modal\" data-target=\"#melbis_win_checkout\"><i class=\"fas fa-shopping-cart\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></button>                         
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 18:25:56');
INSERT INTO `ms_user_file_version` VALUES ('209','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo melbis_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{MS:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-120px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{MS:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid melbis_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{MS:VAR:LANG}/\">                    
                    <span class=\"text-primary\"><i class=\"fas fa-shop\"></i></span> &nbsp;{TAG_SITE_NAME} <sup>{TAG_SITE_SUB}</sup>
                </a>
                <span class=\"d-block d-xl-none\">        
                    <button class=\"btn btn-light my-2 my-sm-0\" data-toggle=\"modal\" data-target=\"#melbis_win_checkout\"><i class=\"fas fa-shopping-cart\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></button>            
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">
                    {MELBIS:melbis_cataloge([MS:VAR:LANG])} 
                    <div class=\"d-none d-xl-inline\">
                        <button class=\"btn btn-light my-2 my-sm-0\" data-toggle=\"modal\" data-target=\"#melbis_win_checkout\"><i class=\"fas fa-shopping-cart\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></button>                         
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 18:56:21');
INSERT INTO `ms_user_file_version` VALUES ('210','1','./../templates/default/units/melbis_cataloge/item.htm','<li class=\"nav-item px-2\">
    <a class=\"nav-link\" href=\"/{MS:VAR:LANG}{LINK}\" data-id=\"{ID}\"><i class=\"{ICON}\"></i> {NAME}</a>
</li> ','2025-03-29 18:58:26');
INSERT INTO `ms_user_file_version` VALUES ('211','1','./../templates/default/units/melbis_cataloge/item_sub.htm','<li class=\"nav-item dropdown px-2\">
    <a class=\"nav-link dropdown-toggle\" href=\"#\" data-id=\"{ID}\" data-toggle=\"dropdown\"><i class=\"{ICON}\"></i> {NAME}</a>
    <ul class=\"dropdown-menu\">
        {MELBIS:melbis_cataloge_sub([MS:VAR:LANG],,[SUB])} 
    </ul>                            
</li>
','2025-03-29 19:00:16');
INSERT INTO `ms_user_file_version` VALUES ('212','1','./../units/melbis_cataloge.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/

/** 
 * Function MELBIS_CATALOGE
 **/
function MELBIS_CATALOGE($mVars)
{
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();      
    
    // Find root
    $command = \"SELECT id, tindex, tlevel
                  FROM {DBNICK}_topic
                 WHERE skey = \'CATALOG\'              
               \";                    
    $root = $gParser->SqlSelectToArray(__LINE__, $command);         
        
    // Get item
    $command = \"SELECT t.id, t.name, t.seo_psu, t.seo_title, t_s.how
                  FROM {DBNICK}_topic t                                                                           
             LEFT JOIN ( SELECT tindex, COUNT(*) AS how 
                           FROM {DBNICK}_topic
                          WHERE no_visible = \'0\'
                            AND tlevel = \'$root[tlevel]\' + 2                                
                       GROUP BY tindex
                       ) AS t_s 
                    ON t.id = t_s.tindex                                                            
                 WHERE t.tindex = \'$root[id]\'
                   AND t.no_visible = \'0\'                                                                
              ORDER BY t.absindex   
                \";                    
    $menu = $gParser->SqlSelect(__LINE__, $command);
    foreach ($menu as $item)
    {                        
        $gParser->TplAssign($tpl, [\'ID\'    => $item[\'id\'],
                                   \'SUB\'   => serialize([\'id\' => $item[\'id\']]),
                                   \'NAME\'  => KASDIM_INC_LANG(\'kTopic\', \'NAME\', $item[\'id\'], $item[\'name\']),
                                   \'LINK\'  => $item[\'seo_psu\'],
                                   \'ICON\'  => $item[\'seo_title\']                                        
                                   ]);                         
        if ( is_null($item[\'how\']) )
        {
            $gParser->TplParse($tpl, \'ITEM\', \'.item\');
        }                      
        else
        {
            $gParser->TplParse($tpl, \'ITEM\', \'.item_sub\');
        }
    } 
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 

?>','2025-03-29 19:00:31');
INSERT INTO `ms_user_file_version` VALUES ('213','1','./../units/melbis_cataloge.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/

/** 
 * Function MELBIS_CATALOGE
 **/
function MELBIS_CATALOGE($mVars)
{
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();      
    
    // Find root
    $command = \"SELECT id, tindex, tlevel
                  FROM {DBNICK}_topic
                 WHERE skey = \'CATALOG\'              
               \";                    
    $root = $gParser->SqlSelectToArray(__LINE__, $command);         
        
    // Get item
    $command = \"SELECT t.id, t.name, t.seo_psu, t.seo_title, t_s.how
                  FROM {DBNICK}_topic t                                                                           
             LEFT JOIN ( SELECT tindex, COUNT(*) AS how 
                           FROM {DBNICK}_topic
                          WHERE no_visible = \'0\'
                            AND tlevel = \'$root[tlevel]\' + 2                                
                       GROUP BY tindex
                       ) AS t_s 
                    ON t.id = t_s.tindex                                                            
                 WHERE t.tindex = \'$root[id]\'
                   AND t.no_visible = \'0\'                                                                
              ORDER BY t.absindex   
                \";                    
    $menu = $gParser->SqlSelect(__LINE__, $command);
    foreach ($menu as $item)
    {                        
        $gParser->TplAssign($tpl, [\'ID\'    => $item[\'id\'],
                                   \'SUB\'   => serialize([\'id\' => $item[\'id\']]),
                                   \'NAME\'  => MELBIS_INC_LANG(\'kTopic\', \'NAME\', $item[\'id\'], $item[\'name\']),
                                   \'LINK\'  => $item[\'seo_psu\'],
                                   \'ICON\'  => $item[\'seo_title\']                                        
                                   ]);                         
        if ( is_null($item[\'how\']) )
        {
            $gParser->TplParse($tpl, \'ITEM\', \'.item\');
        }                      
        else
        {
            $gParser->TplParse($tpl, \'ITEM\', \'.item_sub\');
        }
    } 
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 

?>','2025-03-29 19:01:36');
INSERT INTO `ms_user_file_version` VALUES ('214','1','./../templates/default/units/melbis_cataloge/item_sub.htm','<li class=\"nav-item dropdown px-2\">
    <a class=\"nav-link dropdown-toggle\" href=\"#\" data-id=\"{ID}\" data-toggle=\"dropdown\"><i class=\"{ICON}\"></i> {NAME}</a>
    <ul class=\"dropdown-menu\">
        {1MELBIS:melbis_cataloge_sub([MS:VAR:LANG],,[SUB])} 
    </ul>                            
</li>
','2025-03-29 19:01:59');
INSERT INTO `ms_user_file_version` VALUES ('215','1','./../templates/default/units/melbis_cataloge/main.htm','<ul class=\"navbar-nav my-auto\">
    {ITEM}
</ul>

','2025-03-29 19:34:26');
INSERT INTO `ms_user_file_version` VALUES ('216','1','./../templates/default/units/melbis_cataloge/main.htm','<ul class=\"navbar-nav mr-auto\">
    {ITEM}
</ul>

','2025-03-29 19:34:31');
INSERT INTO `ms_user_file_version` VALUES ('217','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo melbis_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{MS:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-120px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{MS:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid melbis_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{MS:VAR:LANG}/\">                    
                    <span class=\"text-primary\"><i class=\"fas fa-shop\"></i></span> &nbsp;{TAG_SITE_NAME} <sup>{TAG_SITE_SUB}</sup>
                </a>
                <span class=\"d-block d-xl-none\">        
                    <button class=\"btn btn-light my-2 my-sm-0\" data-toggle=\"modal\" data-target=\"#melbis_win_checkout\"><i class=\"fas fa-shopping-cart\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></button>            
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">   
                    <div class=\"d-flex bd-highlight\">      
                        <div class=\"p-2 flex-grow-1 bd-highlight\">
                            {MELBIS:melbis_cataloge([MS:VAR:LANG])}
                        </div> 
                        <div class=\"d-none d-xl-inline\">
                            <button class=\"btn btn-light my-2 my-sm-0\" data-toggle=\"modal\" data-target=\"#melbis_win_checkout\"><i class=\"fas fa-shopping-cart\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></button>                         
                        </div>
                    </div>                                      
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 19:37:40');
INSERT INTO `ms_user_file_version` VALUES ('218','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo melbis_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{MS:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-120px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{MS:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid melbis_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{MS:VAR:LANG}/\">                    
                    <span class=\"text-primary\"><i class=\"fas fa-shop\"></i></span> &nbsp;{TAG_SITE_NAME} <sup>{TAG_SITE_SUB}</sup>
                </a>
                <span class=\"d-block d-xl-none\">        
                    <button class=\"btn btn-light my-2 my-sm-0\" data-toggle=\"modal\" data-target=\"#melbis_win_checkout\"><i class=\"fas fa-shopping-cart\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></button>            
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">                  
                        {MELBIS:melbis_cataloge([MS:VAR:LANG])}
                 
                        <div class=\"d-none d-xl-inline\">
                            <button class=\"btn btn-light my-2 my-sm-0\" data-toggle=\"modal\" data-target=\"#melbis_win_checkout\"><i class=\"fas fa-shopping-cart\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></button>                         
                        </div>
                                                          
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 19:39:11');
INSERT INTO `ms_user_file_version` VALUES ('219','1','./../templates/default/units/melbis_base_header/main.htm','<header>
    <div class=\"container-fluid logo melbis_css_max_width\">         
        <div class=\"row\">
            <div class=\"col-8 col-sm-8 col-md-5 col-lg-5 col-xl-6\">
                <div class=\"d-none d-sm-block\">                    
                    <a href=\"/{MS:VAR:LANG}/\" class=\"display-3 text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}<small class=\"text-muted font-weight-light\" style=\"font-size: 0.5em;\">{TAG_SITE_SUB}</small><sup><small class=\"text-danger\" style=\"font-size: 0.25em; position: relative; top:-20px; left:-120px\">v{SCRIPT_VERSION}.{SCRIPT_BUILD}</small></sup></a>
                </div>
                <div class=\"d-block d-sm-none mt-1\">
                    <a href=\"/{MS:VAR:LANG}/\" class=\"lead text-primary text-nowrap text-decoration-none\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</a>                         
                </div>
            </div>
            <div class=\"col-4 col-sm-4 col-md-7 col-lg-7 col-xl-6\">
                <div class=\"text-right\">
                    <div class=\"btn-group my-2\">                         
                        <div class=\"btn-group\">
                            <button type=\"button\" class=\"btn btn-secondary btn-sm  dropdown-toggle\" data-toggle=\"dropdown\" aria-haspopup=\"true\" aria-expanded=\"false\"></button>
                            <div class=\"dropdown-menu dropdown-menu-right language_set\">
                                {LANG}
                            </div>
                        </div>                                                
                    </div>                                                      
                    <p class=\"text-muted d-none d-lg-block mt-2\">{TAG_HELLO}</p>
                </div>                                         
            </div>
        </div>     
    </div>
    <div style=\"height: 56px;\">    
        <nav class=\"navbar navbar-expand-xl navbar-light site_title\" style=\"background-color: #e3f2fd; z-index: 100;\">
            <div class=\"container-fluid melbis_css_max_width\">
                <button class=\"navbar-toggler\" type=\"button\" data-toggle=\"collapse\" data-target=\"#melbis_navbar\">
                    <span class=\"navbar-toggler-icon\"></span>                                          
                </button>        

                <a class=\"navbar-brand invisible\" href=\"/{MS:VAR:LANG}/\">                    
                    <span class=\"text-primary\"><i class=\"fas fa-shop\"></i></span> &nbsp;{TAG_SITE_NAME} <sup>{TAG_SITE_SUB}</sup>
                </a>
                <span class=\"d-block d-xl-none\">        
                    <button class=\"btn btn-light my-2 my-sm-0\" data-toggle=\"modal\" data-target=\"#melbis_win_checkout\"><i class=\"fas fa-shopping-cart\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></button>            
                </span>
                                        
                <div class=\"collapse navbar-collapse\" id=\"melbis_navbar\">                  
                    {MELBIS:melbis_cataloge([MS:VAR:LANG])}
                    <div class=\"d-none d-xl-inline\">
                        <button class=\"btn btn-light my-2 my-sm-0\" data-toggle=\"modal\" data-target=\"#melbis_win_checkout\"><i class=\"fas fa-shopping-cart\"></i><span class=\"d-none d-sm-inline\">  {TAG_BASKET}</span></button>                         
                    </div>                                                          
                </div>
            </div>
        </nav>
    </div>               
</header>
             

{SCRIPTS}

','2025-03-29 19:40:17');
INSERT INTO `ms_user_file_version` VALUES ('220','1','./../units/melbis_cataloge_sub.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_CATALOGE_SUB
 **/
function MELBIS_CATALOGE_SUB($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
            
    // Vars
    $id = $mVars[\'post\'][\'id\']*1;   
    
    $command = \"SELECT id, tlevel
                  FROM {DBNICK}_topic
                 WHERE id = \'$id\' 
                \";                    
    $root = $gParser->SqlSelectToArray(__LINE__, $command);       
        
    // Get menu items     
    $command = \"SELECT t.id, t.name, t.seo_psu, t.seo_title, t.kind_key, t.link, t.in_xml, t_s.how
                  FROM {DBNICK}_topic t                                                                           
             LEFT JOIN ( SELECT tindex, COUNT(*) AS how 
                           FROM {DBNICK}_topic
                          WHERE no_visible = \'0\'
                            AND tlevel = \'$root[tlevel]\' + 2                                
                       GROUP BY tindex
                       ) AS t_s 
                    ON t.id = t_s.tindex                                                            
                 WHERE t.tindex = \'$root[id]\'
                   AND t.no_visible = \'0\'                                                                
              ORDER BY t.absindex                
                \";                    
    $menu = $gParser->SqlSelect(__LINE__, $command);    
    foreach ($menu as $item)
    {        
        if ( $item[\'name\'] == \'-\' )
        {
            $gParser->TplParse($tpl, \'ITEM\', \'.item_div\');
        }
        else
        {                                    
            $link = ( $item[\'kind_key\'] == \'kLink\' ) ? $item[\'link\'] : \'/\'.$mVars[\'lang\'].$item[\'seo_psu\'] ;                                    
            $gParser->TplAssign($tpl, [\'ID\'    => $item[\'id\'],
                                       \'NAME\'  => KASDIM_INC_LANG(\'kTopic\', \'NAME\', $item[\'id\'], $item[\'name\']),
                                       \'LINK\'  => $link,
                                       \'ICON\'  => $item[\'seo_title\'],
                                       \'MUTE\'  => ( $item[\'in_xml\'] == 1 ) ? \'\' : \'text-muted\'                                        
                                       ]);        
            if ( is_null($item[\'how\']) )
            {
                $gParser->TplParse($tpl, \'ITEM\', \'.item\');
            }            
            else
            {
                $gParser->TplParse($tpl, \'ITEM\', \'.item_sub\');
            }
        }
    } 
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 




?>','2025-03-29 21:26:22');
INSERT INTO `ms_user_file_version` VALUES ('221','1','./../units/melbis_cataloge_sub.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_CATALOGE_SUB
 **/
function MELBIS_CATALOGE_SUB($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
            
    // Vars
    $id = $mVars[\'post\'][\'id\']*1;   
    
    $command = \"SELECT id, tlevel
                  FROM {DBNICK}_topic
                 WHERE id = \'$id\' 
                \";                    
    $root = $gParser->SqlSelectToArray(__LINE__, $command);       
        
    // Get menu items     
    $command = \"SELECT t.id, t.name, t.seo_psu, t.seo_title, t.kind_key, t.link, t.in_xml, t_s.how
                  FROM {DBNICK}_topic t                                                                           
             LEFT JOIN ( SELECT tindex, COUNT(*) AS how 
                           FROM {DBNICK}_topic
                          WHERE no_visible = \'0\'
                            AND tlevel = \'$root[tlevel]\' + 2                                
                       GROUP BY tindex
                       ) AS t_s 
                    ON t.id = t_s.tindex                                                            
                 WHERE t.tindex = \'$root[id]\'
                   AND t.no_visible = \'0\'                                                                
              ORDER BY t.absindex                
                \";                    
    $menu = $gParser->SqlSelect(__LINE__, $command);    
    foreach ($menu as $item)
    {        
        if ( $item[\'name\'] == \'-\' )
        {
            $gParser->TplParse($tpl, \'ITEM\', \'.item_div\');
        }
        else
        {                                    
            $link = ( $item[\'kind_key\'] == \'kLink\' ) ? $item[\'link\'] : \'/\'.$mVars[\'lang\'].$item[\'seo_psu\'] ;                                    
            $gParser->TplAssign($tpl, [\'ID\'    => $item[\'id\'],
                                       \'NAME\'  => KASDIM_INC_LANG(\'kTopic\', \'NAME\', $item[\'id\'], $item[\'name\']),
                                       \'LINK\'  => $link,
                                       \'ICON\'  => $item[\'seo_title\'],
                                       \'MUTE\'  => ( $item[\'in_xml\'] == 1 ) ? \'\' : \'text-muted\'                                        
                                       ]);        
            if ( is_null($item[\'how\']) )
            {
                $gParser->TplParse($tpl, \'ITEM\', \'.item\');
            }            
            else
            {
                $gParser->TplParse($tpl, \'ITEM\', \'.item_sub\');
            }
        }
    } 
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 




?>','2025-03-29 21:26:36');
INSERT INTO `ms_user_file_version` VALUES ('222','1','./../index.php','<?php
/***************************************************************************************************
 * 
 * index.php - index page
 * 
 ***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/                             

// Require
require_once(\'config.php\');
require_once(\'units/melbis_inc.php\');

// Create connect with DataBase 
$gDb = new MySql(\'MELBIS_INC_halt\');
$gDb->Connect(__FILE__, __LINE__);

// Create Parser
$gParser = new Parser(\'MELBIS_INC_halt\', $gDb);

// Define self constants
$gParser->DefineSelfConst();
$gParser->DefineSelfVars(\'CONST\');

// Define session
$gSession = $gParser->DefineSession(DB_USER_NAME.\'_MELBIS_SHOP\');

// Define lazy load script
$gParser->DefineLazyScript($gSitePath.\'/lazy.php\');

// Define languge                   
$default_lang = \'ru\';
$lang = addslashes($gGet[\'lang\'] ?? $default_lang);
$command = \"SELECT * FROM {DBNICK}_lang WHERE skey = \'$lang\'\";
$langs = $gParser->SqlSelectToArray(__LINE__, $command);               
$gLang = ( $langs[\'skey\'] ?? $default_lang ); 

// Define module
if ( !isset($gGet[\'mod\']) ) $gGet[\'mod\'] = \'melbis_base_page\'; 

// Parse
$gParser->Parse($gSitePath, $gTemplate, $gGet[\'mod\'], [serialize($gGet), serialize($gPost)], $gUseCache, $gBuild);

// Publish
$gParser->Publish();

// Possible report
$gParser->Report();

?>','2025-03-29 21:50:19');
INSERT INTO `ms_user_file_version` VALUES ('223','1','./../.htaccess','# Basic rules
AddDefaultCharset UTF-8
DirectoryIndex index.html index.htm index.php
Options -Indexes

ErrorDocument 404 /en/404/

RewriteEngine on

# Language auto 
RewriteCond %{HTTP:Accept-Language} ^ru [NC]
RewriteRule ^$ /ru/ [L,R=301]

RewriteCond %{HTTP:Accept-Language} ^en [NC]
RewriteRule ^$ /en/ [L,R=301]

RewriteCond %{HTTP:Accept-Language} ^uk [NC]
RewriteRule ^$ /uk/ [L,R=301]

# Default
RewriteRule ^$ /ru/ [L,R=301]

# Base page  
RewriteRule ^([a-z]{2})/$ index.php?lang=$1 [L,QSA]

# Modules
RewriteRule ^([a-z]{2})\\/([A-Za-z0-9_\\-]+)\\.php$ $2.php?lang=$1 [L,QSA]

# Core
RewriteRule ^core\\/([A-Za-z0-9_\\-\\.\\+]+)\\/$ index.php?mod=melbis_core_$1 [L,B,QSA]

# Cataloge pages
RewriteCond %{REQUEST_FILENAME} !-d
RewriteCond %{REQUEST_FILENAME} !-f
RewriteRule ^([a-z]{2})\\/(.+)$ index.php?mod=melbis_base_page&psu=$2&lang=$1 [L,QSA]






','2025-03-29 21:50:51');
INSERT INTO `ms_user_file_version` VALUES ('224','1','./../.htaccess','# Basic rules
AddDefaultCharset UTF-8
DirectoryIndex index.html index.htm index.php
Options -Indexes

ErrorDocument 404 /en/404/

RewriteEngine on



# Base page  
RewriteRule ^([a-z]{2})/$ index.php?lang=$1 [L,QSA]

# Modules
RewriteRule ^([a-z]{2})\\/([A-Za-z0-9_\\-]+)\\.php$ $2.php?lang=$1 [L,QSA]

# Core
RewriteRule ^core\\/([A-Za-z0-9_\\-\\.\\+]+)\\/$ index.php?mod=melbis_core_$1 [L,B,QSA]

# Cataloge pages
RewriteCond %{REQUEST_FILENAME} !-d
RewriteCond %{REQUEST_FILENAME} !-f
RewriteRule ^([a-z]{2})\\/(.+)$ index.php?mod=melbis_base_page&psu=$2&lang=$1 [L,QSA]






','2025-03-29 21:51:28');
INSERT INTO `ms_user_file_version` VALUES ('225','1','./../.htaccess','# Basic rules
AddDefaultCharset UTF-8
DirectoryIndex index.html index.htm index.php
Options -Indexes

ErrorDocument 404 /en/404/

RewriteEngine on

# Language auto 
RewriteCond %{HTTP:Accept-Language} ^ru [NC]
RewriteRule ^$ /ru/ [L,R=301]

RewriteCond %{HTTP:Accept-Language} ^en [NC]
RewriteRule ^$ /en/ [L,R=301]

RewriteCond %{HTTP:Accept-Language} ^uk [NC]
RewriteRule ^$ /uk/ [L,R=301]

# Default
RewriteRule ^$ /ru/ [L,R=301]

# Base page  
RewriteRule ^([a-z]{2})/$ index.php?lang=$1 [L,QSA]

# Modules
RewriteRule ^([a-z]{2})\\/([A-Za-z0-9_\\-]+)\\.php$ $2.php?lang=$1 [L,QSA]

# Core
RewriteRule ^core\\/([A-Za-z0-9_\\-\\.\\+]+)\\/$ index.php?mod=melbis_core_$1 [L,B,QSA]

# Cataloge pages
RewriteCond %{REQUEST_FILENAME} !-d
RewriteCond %{REQUEST_FILENAME} !-f
RewriteRule ^([a-z]{2})\\/(.+)$ index.php?mod=melbis_base_page&psu=$2&lang=$1 [L,QSA]






','2025-03-29 21:52:20');
INSERT INTO `ms_user_file_version` VALUES ('226','1','./../index.php','<?php
/***************************************************************************************************
 * 
 * index.php - index page
 * 
 ***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/                             

// Require
require_once(\'config.php\');
require_once(\'units/melbis_inc.php\');

// Create connect with DataBase 
$gDb = new MySql(\'MELBIS_INC_halt\');
$gDb->Connect(__FILE__, __LINE__);

// Create Parser
$gParser = new Parser(\'MELBIS_INC_halt\', $gDb);

// Define self constants
$gParser->DefineSelfConst();
$gParser->DefineSelfVars(\'CONST\');

// Define session
$gSession = $gParser->DefineSession(DB_USER_NAME.\'_MELBIS_SHOP\');

// Define lazy load script
$gParser->DefineLazyScript($gSitePath.\'/lazy.php\');

// Define languge                   
$default_lang = \'ru\';
$lang = addslashes($gGet[\'lang\'] ?? $default_lang);
$command = \"SELECT * FROM {DBNICK}_lang WHERE skey = \'$lang\'\";
$langs = $gParser->SqlSelectToArray(__LINE__, $command);               
$gLang = ( $langs[\'skey\'] ?? $default_lang ); 

// Define module
if ( !isset($gGet[\'mod\']) ) $gGet[\'mod\'] = \'melbis_base_page\'; 

// Parse
$gParser->Parse($gSitePath, $gTemplate, $gGet[\'mod\'], [$gLang, serialize($gGet), serialize($gPost)], $gUseCache, $gBuild);

// Publish
$gParser->Publish();

// Possible report
$gParser->Report();

?>','2025-03-29 21:55:33');
INSERT INTO `ms_user_file_version` VALUES ('227','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);                                                     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM {DBNICK}_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");           
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';         
        $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'ms\'][\'page\'] = $topic;  
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM {DBNICK}_store s
                          JOIN {DBNICK}_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                $gParser->gVars[\'ms\'][\'page\'][\'intro\'] = MELBIS_INC_LANG(\'kTopic\', \'INTRO\', $page[\'id\'], $page[\'intro\']);
                $descr = MELBIS_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                $gParser->TplAssign($tpl, [\'ID\'     => $topic[\'id\'], 
                                           \'DESCR\'  => MELBIS_INC_STD_text($descr)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {           
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-29 21:56:40');
INSERT INTO `ms_user_file_version` VALUES ('228','1','./../units/melbis_cataloge_sub.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_CATALOGE_SUB
 **/
function MELBIS_CATALOGE_SUB($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
            
    // Vars
    $id = $mVars[\'post\'][\'id\']*1;   
    
    $command = \"SELECT id, tlevel
                  FROM {DBNICK}_topic
                 WHERE id = \'$id\' 
                \";                    
    $root = $gParser->SqlSelectToArray(__LINE__, $command);       
        
    // Get menu items     
    $command = \"SELECT t.id, t.name, t.seo_psu, t.seo_title, t.kind_key, t.link, t.in_xml, t_s.how
                  FROM {DBNICK}_topic t                                                                           
             LEFT JOIN ( SELECT tindex, COUNT(*) AS how 
                           FROM {DBNICK}_topic
                          WHERE no_visible = \'0\'
                            AND tlevel = \'$root[tlevel]\' + 2                                
                       GROUP BY tindex
                       ) AS t_s 
                    ON t.id = t_s.tindex                                                            
                 WHERE t.tindex = \'$root[id]\'
                   AND t.no_visible = \'0\'                                                                
              ORDER BY t.absindex                
                \";                    
    $menu = $gParser->SqlSelect(__LINE__, $command);    
    foreach ($menu as $item)
    {        
        if ( $item[\'name\'] == \'-\' )
        {
            $gParser->TplParse($tpl, \'ITEM\', \'.item_div\');
        }
        else
        {                                    
            $link = ( $item[\'kind_key\'] == \'kLink\' ) ? $item[\'link\'] : \'/\'.$mVars[\'lang\'].$item[\'seo_psu\'] ;                                    
            $gParser->TplAssign($tpl, [\'ID\'    => $item[\'id\'],
                                       \'NAME\'  => KASDIM_INC_LANG(\'kTopic\', \'NAME\', $item[\'id\'], $item[\'name\']),
                                       \'LINK\'  => $link,
                                       \'ICON\'  => $item[\'seo_title\'],
                                       \'MUTE\'  => ( $item[\'in_xml\'] == 1 ) ? \'\' : \'text-muted\'                                        
                                       ]);        
            if ( is_null($item[\'how\']) )
            {
                $gParser->TplParse($tpl, \'ITEM\', \'.item\');
            }            
            else
            {
                $gParser->TplParse($tpl, \'ITEM\', \'.item_sub\');
            }
        }
    } 
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 




?>','2025-03-29 21:58:29');
INSERT INTO `ms_user_file_version` VALUES ('229','1','./../units/melbis_cataloge_sub.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_CATALOGE_SUB
 **/
function MELBIS_CATALOGE_SUB($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
            
    // Vars
    $id = $mVars[\'post\'][\'id\']*1;   
    
    $command = \"SELECT id, tlevel
                  FROM {DBNICK}_topic
                 WHERE id = \'$id\' 
                \";                    
    $root = $gParser->SqlSelectToArray(__LINE__, $command);       
        
    // Get menu items     
    $command = \"SELECT t.id, t.name, t.seo_psu, t.seo_title, t.kind_key, t.link, t.in_xml, t_s.how
                  FROM {DBNICK}_topic t                                                                           
             LEFT JOIN ( SELECT tindex, COUNT(*) AS how 
                           FROM {DBNICK}_topic
                          WHERE no_visible = \'0\'
                            AND tlevel = \'$root[tlevel]\' + 2                                
                       GROUP BY tindex
                       ) AS t_s 
                    ON t.id = t_s.tindex                                                            
                 WHERE t.tindex = \'$root[id]\'
                   AND t.no_visible = \'0\'                                                                
              ORDER BY t.absindex                
                \";                    
    $menu = $gParser->SqlSelect(__LINE__, $command);    
    foreach ($menu as $item)
    {        
        if ( $item[\'name\'] == \'-\' )
        {
            $gParser->TplParse($tpl, \'ITEM\', \'.item_div\');
        }
        else
        {                                    
            $link = ( $item[\'kind_key\'] == \'kLink\' ) ? $item[\'link\'] : \'/\'.$mVars[\'lang\'].$item[\'seo_psu\'] ;                                    
            $gParser->TplAssign($tpl, [\'ID\'    => $item[\'id\'],
                                       \'NAME\'  => MELBIS_INC_LANG(\'kTopic\', \'NAME\', $item[\'id\'], $item[\'name\']),
                                       \'LINK\'  => $link,
                                       \'ICON\'  => $item[\'seo_title\'],
                                       \'MUTE\'  => ( $item[\'in_xml\'] == 1 ) ? \'\' : \'text-muted\'                                        
                                       ]);        
            if ( is_null($item[\'how\']) )
            {
                $gParser->TplParse($tpl, \'ITEM\', \'.item\');
            }            
            else
            {
                $gParser->TplParse($tpl, \'ITEM\', \'.item_sub\');
            }
        }
    } 
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 




?>','2025-03-29 21:58:57');
INSERT INTO `ms_user_file_version` VALUES ('230','1','./../templates/default/units/melbis_cataloge/item_sub.htm','<li class=\"nav-item dropdown px-2\">
    <a class=\"nav-link dropdown-toggle\" href=\"#\" data-id=\"{ID}\" data-toggle=\"dropdown\"><i class=\"{ICON}\"></i> {NAME}</a>
    <ul class=\"dropdown-menu\">
        {MELBIS:melbis_cataloge_sub([MS:VAR:LANG],,[SUB])} 
    </ul>                            
</li>
','2025-03-29 21:59:05');
INSERT INTO `ms_user_file_version` VALUES ('231','1','./../units/melbis_cataloge_sub.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_CATALOGE_SUB
 **/
function MELBIS_CATALOGE_SUB($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
            
    // Vars
    $id = $mVars[\'post\'][\'id\']*1;   
    
    $command = \"SELECT id, tlevel
                  FROM {DBNICK}_topic
                 WHERE id = \'$id\' 
                \";                    
    $root = $gParser->SqlSelectToArray(__LINE__, $command);       
        
    // Get menu items     
    $command = \"SELECT t.id, t.name, t.seo_psu, t.seo_title, t.kind_key, t.link, t.in_xml, t_s.how
                  FROM {DBNICK}_topic t                                                                           
             LEFT JOIN ( SELECT tindex, COUNT(*) AS how 
                           FROM {DBNICK}_topic
                          WHERE no_visible = \'0\'
                            AND tlevel = \'$root[tlevel]\' + 2                                
                       GROUP BY tindex
                       ) AS t_s 
                    ON t.id = t_s.tindex                                                            
                 WHERE t.tindex = \'$root[id]\'
                   AND t.no_visible = \'0\'                                                                
              ORDER BY t.absindex                
                \";                    
    $menu = $gParser->SqlSelect(__LINE__, $command);    
    foreach ($menu as $item)
    {        
        if ( $item[\'name\'] == \'-\' )
        {
            $gParser->TplParse($tpl, \'ITEM\', \'.item_div\');
        }
        else
        {                                    
            $link = ( $item[\'kind_key\'] == \'kLink\' ) ? $item[\'link\'] : \'/\'.$mVars[\'lang\'].$item[\'seo_psu\'] ;                                    
            $gParser->TplAssign($tpl, [\'ID\'    => $item[\'id\'],
                                       \'NAME\'  => MELBIS_INC_LANG(\'kTopic\', \'NAME\', $item[\'id\'], $item[\'name\']),
                                       \'LINK\'  => $link,
                                       \'ICON\'  => $item[\'seo_title\']
                                       ]);        
            if ( is_null($item[\'how\']) )
            {
                $gParser->TplParse($tpl, \'ITEM\', \'.item\');
            }            
            else
            {
                $gParser->TplParse($tpl, \'ITEM\', \'.item_sub\');
            }
        }
    } 
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 




?>','2025-03-29 22:00:25');
INSERT INTO `ms_user_file_version` VALUES ('232','1','./../templates/default/units/melbis_cataloge_sub/item.htm','<li>
    <a class=\"dropdown-item\" href=\"{LINK}\" data-id=\"{ID}\"><i class=\"{ICON}\"></i> &nbsp; {NAME}</a>
</li>
','2025-03-29 22:00:31');
INSERT INTO `ms_user_file_version` VALUES ('233','1','./../templates/default/units/melbis_cataloge_sub/item_sub.htm','<li class=\"dropdown-submenu\">
    <a class=\"dropdown-item dropdown-toggle\" href=\"#\" data-id=\"{ID}\"><i class=\"{ICON}\"></i> &nbsp; {NAME}</a>
    <ul class=\"dropdown-menu\"></ul>
</li>','2025-03-29 22:01:43');
INSERT INTO `ms_user_file_version` VALUES ('234','1','./../templates/default/units/melbis_cataloge_sub/item_div.htm','<li class=\"dropdown-divider\"></li>','2025-03-29 22:01:58');
INSERT INTO `ms_user_file_version` VALUES ('235','1','./../units/melbis_core_translate.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/

/** 
 * Function MELBIS_CORE_TRANSLATE
 **/
function MELBIS_CORE_TRANSLATE($mVars)
{ 
    global $gParser; 

    // Header
    header(\'Content-Type: text/plain; charset=utf-8\');   
                                      
    // Vars   
    $update = [];
    $now = MELBIS_INC_STD_get_now();
    $pagetime = $gParser->RunTime();
    echo \"> Running at the $now \\r\\n\";             
         
    // From lang
    $command = \"SELECT * FROM {DBNICK}_lang WHERE is_origin = 1\";               
    $from = $gParser->SqlSelectToArray(__LINE__, $command);    
           
    // To lang
    $command = \"SELECT * 
                  FROM {DBNICK}_lang
                 WHERE is_origin <> 1
              ORDER BY pos
              \";                
    $langs = $gParser->SqlSelect(__LINE__, $command);
    foreach ($langs as $lang) 
    {         
        echo \"\\r\\n> Translate to: $lang[name] \\r\\n\";

        // Content        
        $command = \"SELECT o.id, o.trans_id, o.context, o.origin, o.is_html, tl.id AS tl_id, LENGTH(o.origin) AS size   
                      FROM {DBNICK}_trans_origin o
                 LEFT JOIN {DBNICK}_trans_lang tl
                        ON o.id = tl.origin_id 
                       AND tl.lang_id = \'$lang[id]\'  
                     WHERE md5(CONCAT(o.context, o.origin)) <> o.crc 
                        OR tl.id IS NULL
                    HAVING size < 15000
                  ORDER BY size ASC                    
                     LIMIT 10
                   \";
        $origins = $gParser->SqlSelect(__LINE__, $command);
        foreach ($origins as $origin)
        {
            echo \'[\'.$origin[\'id\'].\"]: \";
            
            $translate = KASDIM_INC_TRANSLATE_deepl($origin[\'origin\'], 
                                                    $origin[\'context\'], 
                                                    $from[\'skey\'], 
                                                    $lang[\'skey\'], 
                                                    $origin[\'is_html\']);
            echo $translate.\"\\r\\n\"; 
            
            if ( is_null($origin[\'tl_id\']) )
            {   
                // Add translate
                $hash = [];
                $hash[\'id\'] = $gParser->SqlGenId(\'trans_lang\');
                $hash[\'lang_id\'] = $lang[\'id\'];
                $hash[\'trans_id\'] = $origin[\'trans_id\'];
                $hash[\'origin_id\'] = $origin[\'id\'];            
                $hash[\'translate\'] = $translate;            
                $gParser->SqlInsert(__LINE__, \'{DBNICK}_trans_lang\', $hash);            
            }
            else
            {    
                // Change translate
                $hash = [];
                $hash[\'id\'] = $origin[\'tl_id\'];
                $hash[\'translate\'] = $translate;
                $gParser->SqlUpdate(__LINE__, \'{DBNICK}_trans_lang\', $hash, \'id\');                          
            }
            // Save Update
            $update[$origin[\'id\']] = md5($origin[\'context\'].$origin[\'origin\']); 
        }                                      
    } 
    
    // Update
    foreach ( $update as $id => $crc )
    {    
        $hash = [];
        $hash[\'id\'] = $id;
        $hash[\'crc\'] = $crc;
        $gParser->SqlUpdate(__LINE__, \'{DBNICK}_trans_origin\', $hash, \'id\');
    }                                        
    
    return \'\';                    
} 

?>','2025-03-29 22:04:54');
INSERT INTO `ms_user_file_version` VALUES ('236','1','./../units/melbis_core_translate.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/

/** 
 * Function MELBIS_CORE_TRANSLATE
 **/
function MELBIS_CORE_TRANSLATE($mVars)
{ 
    global $gParser; 

    // Header
    header(\'Content-Type: text/plain; charset=utf-8\');   
                                      
    // Vars   
    $update = [];
    $now = MELBIS_INC_STD_get_now();
    $pagetime = $gParser->RunTime();
    echo \"> Running at the $now \\r\\n\";             
         
    // From lang
    $command = \"SELECT * FROM {DBNICK}_lang WHERE is_origin = 1\";               
    $from = $gParser->SqlSelectToArray(__LINE__, $command);    
           
    // To lang
    $command = \"SELECT * 
                  FROM {DBNICK}_lang
                 WHERE is_origin <> 1
              ORDER BY pos
              \";                
    $langs = $gParser->SqlSelect(__LINE__, $command);
    foreach ($langs as $lang) 
    {         
        echo \"\\r\\n> Translate to: $lang[name] \\r\\n\";

        // Content        
        $command = \"SELECT o.id, o.trans_id, o.context, o.origin, o.is_html, tl.id AS tl_id, LENGTH(o.origin) AS size   
                      FROM {DBNICK}_trans_origin o
                 LEFT JOIN {DBNICK}_trans_lang tl
                        ON o.id = tl.origin_id 
                       AND tl.lang_id = \'$lang[id]\'  
                     WHERE md5(CONCAT(o.context, o.origin)) <> o.crc 
                        OR tl.id IS NULL
                    HAVING size < 15000
                  ORDER BY size ASC                    
                     LIMIT 10
                   \";
        $origins = $gParser->SqlSelect(__LINE__, $command);
        foreach ($origins as $origin)
        {
            echo \'[\'.$origin[\'id\'].\"]: \";
            
            $translate = MELBIS_INC_TRANSLATE_deepl($origin[\'origin\'], 
                                                    $origin[\'context\'], 
                                                    $from[\'skey\'], 
                                                    $lang[\'skey\'], 
                                                    $origin[\'is_html\']);
            echo $translate.\"\\r\\n\"; 
            
            if ( is_null($origin[\'tl_id\']) )
            {   
                // Add translate
                $hash = [];
                $hash[\'id\'] = $gParser->SqlGenId(\'trans_lang\');
                $hash[\'lang_id\'] = $lang[\'id\'];
                $hash[\'trans_id\'] = $origin[\'trans_id\'];
                $hash[\'origin_id\'] = $origin[\'id\'];            
                $hash[\'translate\'] = $translate;            
                $gParser->SqlInsert(__LINE__, \'{DBNICK}_trans_lang\', $hash);            
            }
            else
            {    
                // Change translate
                $hash = [];
                $hash[\'id\'] = $origin[\'tl_id\'];
                $hash[\'translate\'] = $translate;
                $gParser->SqlUpdate(__LINE__, \'{DBNICK}_trans_lang\', $hash, \'id\');                          
            }
            // Save Update
            $update[$origin[\'id\']] = md5($origin[\'context\'].$origin[\'origin\']); 
        }                                      
    } 
    
    // Update
    foreach ( $update as $id => $crc )
    {    
        $hash = [];
        $hash[\'id\'] = $id;
        $hash[\'crc\'] = $crc;
        $gParser->SqlUpdate(__LINE__, \'{DBNICK}_trans_origin\', $hash, \'id\');
    }                                        
    
    return \'\';                    
} 

?>','2025-03-29 22:05:17');
INSERT INTO `ms_user_file_version` VALUES ('237','1','./../units/melbis_inc_translate.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff     
 **************************************************************************************************
 * 
 * MELBIS_INC_TRANSLATE_service          - Return file path from time
 * MELBIS_INC_TRANSLATE_service          - Convert HTML to plain text      
 *     
 **************************************************************************************************/

/** 
 * Function MELBIS_INC_TRANSLATE_service
 **/
function MELBIS_INC_TRANSLATE_service($mUserId, $mVars)
{ 
    global $gParser;
                       
    $command = \"SELECT * FROM {DBNICK}_lang WHERE is_origin = 1\";               
    $from = $gParser->SqlSelectToArray(__LINE__, $command);    

    $command = \"SELECT * FROM {DBNICK}_lang WHERE id = \'$mVars[lang_id]\'\";               
    $to = $gParser->SqlSelectToArray(__LINE__, $command);   

    $html = ( $mVars[\'is_html\'] > 0 );
    
    $result = MELBIS_INC_TRANSLATE_deepl($mVars[\'origin\'], $mVars[\'context\'], $from[\'skey\'], $to[\'skey\'], $html);

    return $result;
} 


/** 
 * Function MELBIS_INC_TRANSLATE_google
 **/
function MELBIS_INC_TRANSLATE_google($mText, $mContext, $mLangFrom, $mLangTo, $mHtml = false)
{    
    $data = array(\'q\'           => \'!\'.$mText,
                  \'target\'      => $mLangTo,
                  \'format\'      => ( $mHtml ) ? \'html\' : \'text\',
                  \'source\'      => $mLangFrom,
                  \'model\'       => \'nmt\',
                  \'key\'         => MELBIS_GOOGLE_API
                  );
    $ch = curl_init();    
    curl_setopt($ch, CURLOPT_URL, \'https://translation.googleapis.com/language/translate/v2\');
    curl_setopt($ch, CURLOPT_REFERER, \'https://site.com\');
    curl_setopt($ch, CURLOPT_POST, true);  
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
    curl_setopt($ch, CURLOPT_ENCODING, \"gzip\");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30);                
    $response = curl_exec($ch);
    if ( $response === false ) 
    {
        $error = curl_error($ch);
        curl_close($ch);
        die(\'PHP_ERROR: \'.$error);
    }
    $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    curl_close($ch);    
    if ( $http_code >= 200 && $http_code < 300 ) 
    {
        $data = json_decode($response, true);
        $result = ltrim($data[\'data\'][\'translations\'][0][\'translatedText\'], \'!\');  

        return $result;
    } 
    else 
    {        
        $error = json_decode($response, true);
        die(\"PHP_ERROR: \".$http_code.\" - \".($error[\'message\'] ?? \'Unkhown error\'));
    }  
}     


/** 
 * Function MELBIS_INC_TRANSLATE_deepl
 **/
function MELBIS_INC_TRANSLATE_deepl($mText, $mContext, $mLangFrom, $mLangTo, $mHtml = false)
{     
    $data = [
        \'text\'          => [ $mText ],
        \'context\'       => $mContext,
        \'tag_handling\'  => ( $mHtml ) ? \'html\' : \'\',
        \'source_lang\'   => $mLangFrom,
        \'target_lang\'   => $mLangTo
    ];
    
    // cURL
    $ch = curl_init(\'https://api.deepl.com/v2/translate\'); 
    //$ch = curl_init(\'https://api-free.deepl.com/v2/translate\');
    curl_setopt($ch, CURLOPT_HTTPHEADER, [
        \'Authorization: DeepL-Auth-Key \'.MELBIS_DEEPL_API,
        \'Content-Type: application/json\',
    ]);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    $response = curl_exec($ch);
    if ( $response === false ) 
    {
        $error = curl_error($ch);
        curl_close($ch);
        die(\'PHP_ERROR: \'.$error);
    }
    $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    curl_close($ch);    
    if ( $http_code >= 200 && $http_code < 300 ) 
    {
        $data = json_decode($response, true);
        $result = $data[\'translations\'][0][\'text\'];    

        return $result;
    } 
    else 
    {        
        $error = json_decode($response, true);
        die(\"PHP_ERROR: \".$http_code.\" - \".($error[\'message\'] ?? \'Unkhown error\'));
    }                             
} 



?>','2025-03-29 22:05:36');
INSERT INTO `ms_user_file_version` VALUES ('238','1','./../units/melbis_cataloge_center.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_CATALOGE_CENTER
 **/
function MELBIS_CATALOGE_CENTER($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Sample DB Query
    /*
    $command = \"SELECT *
                  FROM {DBNICK}_store
                 WHERE id > \'$mVars[var_name_1]\'
              ORDER BY id
                \";                    
    $store = $gParser->SqlSelect(__LINE__, $command);
    foreach ($store as $row)
    {
        $gParser->TplAssign($tpl, array(\'ID\'   => $row[\'id\'],
                                        \'NAME\' => htmlspecialchars($row[\'name\']),
                                        \'INFO\' => $mVars[\'var_name_2\']
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }
    */

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 11:09:53');
INSERT INTO `ms_user_file_version` VALUES ('239','1','./../units/melbis_cataloge_center.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_CATALOGE_CENTER
 **/
function MELBIS_CATALOGE_CENTER($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Sample DB Query

    $command = \"SELECT ta.name, t.seo_psu, ft.*
                  FROM {DBNICK}_topic_alt ta
                  JOIN {DBNICK}_topic t
                    ON t.id = ta.topic_id                  
                  JOIN {DBNICK}_files_topic ft
                    ON ft.elem_id = t.id 
                 WHERE ta.kind_key = \'kCenter\'
                   AND ft.kind_key = \'kDefault\'                                     
              ORDER BY ta.absindex
                \";                    
    $topics = $gParser->SqlSelect(__LINE__, $command);
    foreach ($topics as $topic)
    {
        $gParser->TplAssign($tpl, array(\'ID\'   => $row[\'id\'],
                                        \'NAME\' => htmlspecialchars($row[\'name\']),
                                        \'INFO\' => $mVars[\'var_name_2\']
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }


    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 11:26:07');
INSERT INTO `ms_user_file_version` VALUES ('240','1','./../templates/default/units/melbis_cataloge_center/main.htm','<div class=\"row row-cols-1 row-cols-md-2\">
    {ITEM}
</div>','2025-03-30 11:31:22');
INSERT INTO `ms_user_file_version` VALUES ('241','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"card bg-dark text-white\">
  <img src=\"...\" class=\"card-img\" alt=\"...\">
  <div class=\"card-img-overlay\">
    <h5 class=\"card-title\">Card title</h5>
    <p class=\"card-text\">This is a wider card with supporting text below as a natural lead-in to additional content. This content is a little bit longer.</p>
    <p class=\"card-text\">Last updated 3 mins ago</p>
  </div>
</div>','2025-03-30 11:31:25');
INSERT INTO `ms_user_file_version` VALUES ('242','1','./../units/melbis_cataloge_center.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_CATALOGE_CENTER
 **/
function MELBIS_CATALOGE_CENTER($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Sample DB Query

    $command = \"SELECT ta.name, t.seo_psu, ft.*
                  FROM {DBNICK}_topic_alt ta
                  JOIN {DBNICK}_topic t
                    ON t.id = ta.topic_id                  
                  JOIN {DBNICK}_files_topic ft
                    ON ft.elem_id = t.id 
                 WHERE ta.kind_key = \'kCenter\'
                   AND ft.kind_key = \'kDefault\'                                     
              ORDER BY ta.absindex
                \";                    
    $topics = $gParser->SqlSelect(__LINE__, $command);
    foreach ($topics as $topic)
    {
        $gParser->TplAssign($tpl, array(\'ID\'   => $topic[\'id\'],
                                        \'NAME\' => $topic[\'name\'])
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }


    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 11:32:45');
INSERT INTO `ms_user_file_version` VALUES ('243','1','./../units/melbis_cataloge_center.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_CATALOGE_CENTER
 **/
function MELBIS_CATALOGE_CENTER($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Sample DB Query

    $command = \"SELECT ta.name, t.seo_psu, ft.*
                  FROM {DBNICK}_topic_alt ta
                  JOIN {DBNICK}_topic t
                    ON t.id = ta.topic_id                  
                  JOIN {DBNICK}_files_topic ft
                    ON ft.elem_id = t.id 
                 WHERE ta.kind_key = \'kCenter\'
                   AND ft.kind_key = \'kDefault\'                                     
              ORDER BY ta.absindex
                \";                    
    $topics = $gParser->SqlSelect(__LINE__, $command);
    foreach ($topics as $topic)
    {
        $gParser->TplAssign($tpl, [\'ID\'   => $topic[\'id\'],
                                        \'NAME\' => $topic[\'name\'])
                                        ]); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }


    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 11:33:01');
INSERT INTO `ms_user_file_version` VALUES ('244','1','./../units/melbis_cataloge_center.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_CATALOGE_CENTER
 **/
function MELBIS_CATALOGE_CENTER($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Sample DB Query

    $command = \"SELECT ta.name, t.seo_psu, ft.*
                  FROM {DBNICK}_topic_alt ta
                  JOIN {DBNICK}_topic t
                    ON t.id = ta.topic_id                  
                  JOIN {DBNICK}_files_topic ft
                    ON ft.elem_id = t.id 
                 WHERE ta.kind_key = \'kCenter\'
                   AND ft.kind_key = \'kDefault\'                                     
              ORDER BY ta.absindex
                \";                    
    $topics = $gParser->SqlSelect(__LINE__, $command);
    foreach ($topics as $topic)
    {
        $gParser->TplAssign($tpl, [\'ID\'   => $topic[\'id\'],
                                        \'NAME\' => $topic[\'name\']
                                        ]); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }


    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 11:33:10');
INSERT INTO `ms_user_file_version` VALUES ('245','1','./../units/melbis_cataloge_center.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_CATALOGE_CENTER
 **/
function MELBIS_CATALOGE_CENTER($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Sample DB Query

    $command = \"SELECT ta.name, t.seo_psu, ft.*
                  FROM {DBNICK}_topic_alt ta
                  JOIN {DBNICK}_topic t
                    ON t.id = ta.topic_id                  
                  JOIN {DBNICK}_files_topic ft
                    ON ft.elem_id = t.id 
                 WHERE ta.kind_key = \'kCenter\'
                   AND ft.kind_key = \'kDefault\'                                     
              ORDER BY ta.absindex
                \";                    
    $topics = $gParser->SqlSelect(__LINE__, $command);
    foreach ($topics as $topic)
    {
        $gParser->TplAssign($tpl, [\'ID\'   => $topic[\'id\'], 
                                   \'IMAGE\'  => MELBIS_INC_STD_path($topic),
                                        \'NAME\' => $topic[\'name\']
                                        ]); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }


    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 11:53:29');
INSERT INTO `ms_user_file_version` VALUES ('246','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"card bg-dark text-white\">
  <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\">
  <div class=\"card-img-overlay\">
    <h5 class=\"card-title\">Card title</h5>
    <p class=\"card-text\">This is a wider card with supporting text below as a natural lead-in to additional content. This content is a little bit longer.</p>
    <p class=\"card-text\">Last updated 3 mins ago</p>
  </div>
</div>','2025-03-30 11:53:51');
INSERT INTO `ms_user_file_version` VALUES ('247','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"card bg-dark text-white\">
  <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:200px;>
  <div class=\"card-img-overlay\">
    <h5 class=\"card-title\">Card title</h5>
    <p class=\"card-text\">This is a wider card with supporting text below as a natural lead-in to additional content. This content is a little bit longer.</p>
    <p class=\"card-text\">Last updated 3 mins ago</p>
  </div>
</div>','2025-03-30 11:54:31');
INSERT INTO `ms_user_file_version` VALUES ('248','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"card bg-dark text-white\">
  <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px;>
  <div class=\"card-img-overlay\">
    <h5 class=\"card-title\">Card title</h5>
    <p class=\"card-text\">This is a wider card with supporting text below as a natural lead-in to additional content. This content is a little bit longer.</p>
    <p class=\"card-text\">Last updated 3 mins ago</p>
  </div>
</div>','2025-03-30 11:54:56');
INSERT INTO `ms_user_file_version` VALUES ('249','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"card bg-dark text-white\">
  <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px;\">
  <div class=\"card-img-overlay\">
    <h5 class=\"card-title\">Card title</h5>
    <p class=\"card-text\">This is a wider card with supporting text below as a natural lead-in to additional content. This content is a little bit longer.</p>
    <p class=\"card-text\">Last updated 3 mins ago</p>
  </div>
</div>','2025-03-30 11:56:13');
INSERT INTO `ms_user_file_version` VALUES ('250','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"card bg-white text-dark\">
  <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px;\">
  <div class=\"card-img-overlay\">
    <h5 class=\"card-title\">Card title</h5>
    <p class=\"card-text\">This is a wider card with supporting text below as a natural lead-in to additional content. This content is a little bit longer.</p>
    <p class=\"card-text\">Last updated 3 mins ago</p>
  </div>
</div>','2025-03-30 11:56:33');
INSERT INTO `ms_user_file_version` VALUES ('251','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"card bg-white text-dark\">
  <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
  <div class=\"card-img-overlay\">
    <h5 class=\"card-title\">Card title</h5>
    <p class=\"card-text\">This is a wider card with supporting text below as a natural lead-in to additional content. This content is a little bit longer.</p>
    <p class=\"card-text\">Last updated 3 mins ago</p>
  </div>
</div>','2025-03-30 11:56:52');
INSERT INTO `ms_user_file_version` VALUES ('252','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"card bg-white text-dark\">
  <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
  <div class=\"card-img-overlay\">
    <h5 class=\"card-title\">Card title</h5>
  </div>
</div>','2025-03-30 11:57:36');
INSERT INTO `ms_user_file_version` VALUES ('253','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"card bg-white text-dark\">
  <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
  <div class=\"card-img-overlay\">
    <h2 class=\"card-title\">Card title</h2>
  </div>
</div>','2025-03-30 11:57:52');
INSERT INTO `ms_user_file_version` VALUES ('254','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"card bg-white text-dark\">
  <img src=\"{IMAGE}\" class=\"card-imgs\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
  <div class=\"card-img-overlay\">
    <h2 class=\"card-title\">Card title</h2>
  </div>
</div>','2025-03-30 11:58:16');
INSERT INTO `ms_user_file_version` VALUES ('255','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"card bg-white text-dark\">
  <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
  <div class=\"card-img-overlay\">
    <h2 class=\"card-title\">Card title</h2>
  </div>
</div>','2025-03-30 11:58:21');
INSERT INTO `ms_user_file_version` VALUES ('256','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"card bg-white text-dark\">
  <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-widsth:300px; max-height:300px;\">
  <div class=\"card-img-overlay\">
    <h2 class=\"card-title\">Card title</h2>
  </div>
</div>','2025-03-30 11:58:34');
INSERT INTO `ms_user_file_version` VALUES ('257','1','./../templates/default/units/melbis_cataloge_center/main.htm','<div class=\"row row-cols-2 row-cols-md-4\">
    {ITEM}
</div>','2025-03-30 11:58:56');
INSERT INTO `ms_user_file_version` VALUES ('258','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"card bg-white text-dark mb-4\">
  <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-widsth:300px; max-height:300px;\">
  <div class=\"card-img-overlay\">
    <h2 class=\"card-title\">Card title</h2>
  </div>
</div>','2025-03-30 11:59:12');
INSERT INTO `ms_user_file_version` VALUES ('259','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"card bg-white text-dark mx-4\">
  <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-widsth:300px; max-height:300px;\">
  <div class=\"card-img-overlay\">
    <h2 class=\"card-title\">Card title</h2>
  </div>
</div>','2025-03-30 11:59:23');
INSERT INTO `ms_user_file_version` VALUES ('260','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"card bg-white text-dark px-4\">
  <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-widsth:300px; max-height:300px;\">
  <div class=\"card-img-overlay\">
    <h2 class=\"card-title\">Card title</h2>
  </div>
</div>','2025-03-30 11:59:34');
INSERT INTO `ms_user_file_version` VALUES ('261','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"card bg-white text-dark mx-4\">
  <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-widsth:300px; max-height:300px;\">
  <div class=\"card-img-overlay\">
    <h2 class=\"card-title\">Card title</h2>                                
  </div>
</div>','2025-03-30 11:59:48');
INSERT INTO `ms_user_file_version` VALUES ('262','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"card bg-white text-dark mr-4\">
  <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-widsth:300px; max-height:300px;\">
  <div class=\"card-img-overlay\">
    <h2 class=\"card-title\">Card title</h2>                                
  </div>
</div>','2025-03-30 11:59:57');
INSERT INTO `ms_user_file_version` VALUES ('263','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"card bg-white text-dark\">
  <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-widsth:300px; max-height:300px;\">
  <div class=\"card-img-overlay\">
    <h2 class=\"card-title\">Card title</h2>                                
  </div>
</div>','2025-03-30 12:00:13');
INSERT INTO `ms_user_file_version` VALUES ('264','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"card-deck bg-white text-dark\">
  <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-widsth:300px; max-height:300px;\">
  <div class=\"card-img-overlay\">
    <h2 class=\"card-title\">Card title</h2>                                
  </div>
</div>','2025-03-30 12:02:07');
INSERT INTO `ms_user_file_version` VALUES ('265','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"card-deck bg-white text-dark\">
  <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
  <div class=\"card-img-overlay\">
    <h2 class=\"card-title\">Card title</h2>                                
  </div>
</div>','2025-03-30 12:02:25');
INSERT INTO `ms_user_file_version` VALUES ('266','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"card bg-white text-dark\">
  <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
  <div class=\"card-img-overlay\">
    <h2 class=\"card-title\">Card title</h2>                                
  </div>
</div>','2025-03-30 12:02:37');
INSERT INTO `ms_user_file_version` VALUES ('267','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:03:58');
INSERT INTO `ms_user_file_version` VALUES ('268','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card-deck bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:04:18');
INSERT INTO `ms_user_file_version` VALUES ('269','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:04:23');
INSERT INTO `ms_user_file_version` VALUES ('270','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:04:49');
INSERT INTO `ms_user_file_version` VALUES ('271','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title shadows\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:05:51');
INSERT INTO `ms_user_file_version` VALUES ('272','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title shadow\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:07:14');
INSERT INTO `ms_user_file_version` VALUES ('273','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title bg-white shadow\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:07:53');
INSERT INTO `ms_user_file_version` VALUES ('274','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark pt-4\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title bg-white shadow\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:08:19');
INSERT INTO `ms_user_file_version` VALUES ('275','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"top: 20px;max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title bg-white shadow\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:08:33');
INSERT INTO `ms_user_file_version` VALUES ('276','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"top: 120px;max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title bg-white shadow\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:08:40');
INSERT INTO `ms_user_file_version` VALUES ('277','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"mergin: 20px; max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title bg-white shadow\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:08:57');
INSERT INTO `ms_user_file_version` VALUES ('278','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"margin: 20px; max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title bg-white shadow\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:09:04');
INSERT INTO `ms_user_file_version` VALUES ('279','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title bg-white shadow\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:09:14');
INSERT INTO `ms_user_file_version` VALUES ('280','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title bg-white\" style=\"text-shadow: 2px 2px 4px #000000;\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:23:55');
INSERT INTO `ms_user_file_version` VALUES ('281','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title\" style=\"text-shadow: 2px 2px 4px #000000;\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:24:11');
INSERT INTO `ms_user_file_version` VALUES ('282','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-white\" style=\"text-shadow: 2px 2px 4px #000000;\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:24:52');
INSERT INTO `ms_user_file_version` VALUES ('283','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-white\" style=\"text-shadow: 0 1px black, 2px 2px 4px #000000;\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:26:15');
INSERT INTO `ms_user_file_version` VALUES ('284','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-white\" style=\"text-shadow: 1px 1px black, 2px 2px 4px #000000;\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:26:33');
INSERT INTO `ms_user_file_version` VALUES ('285','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-white\" style=\"text-shadow: 10px 1px black, 2px 2px 4px #000000;\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:26:42');
INSERT INTO `ms_user_file_version` VALUES ('286','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-white\" style=\"text-shadow: 1px 1px black, 2px 2px 4px #000000;\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:26:54');
INSERT INTO `ms_user_file_version` VALUES ('287','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-white\" style=\"text-shadow: -1px -11px black, 2px 2px 4px #000000;\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:27:03');
INSERT INTO `ms_user_file_version` VALUES ('288','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-white\" style=\"text-shadow: -1px -1px black, 2px 2px 4px #000000;\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:27:05');
INSERT INTO `ms_user_file_version` VALUES ('289','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-white\" style=\"text-shadow: -1px -1px black, 1px 1px black, 2px 2px 4px black;\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:27:33');
INSERT INTO `ms_user_file_version` VALUES ('290','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-white\" style=\"text-shadow: -1px -1px 1px black, 1px 1px black, 2px 2px 4px black;\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:27:48');
INSERT INTO `ms_user_file_version` VALUES ('291','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-white\" style=\"text-shadow: -1px -1px 2px black, 1px 1px black, 2px 2px 4px black;\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:27:55');
INSERT INTO `ms_user_file_version` VALUES ('292','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <div class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-white\" style=\"text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 4px black;\">Card title</h2>                                
        </div>
    </div>
</div>    ','2025-03-30 12:28:03');
INSERT INTO `ms_user_file_version` VALUES ('293','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-white\" style=\"text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 4px black;\">Card title</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:30:21');
INSERT INTO `ms_user_file_version` VALUES ('294','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"#\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-white\" style=\"text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 4px black;\">Card title</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:30:40');
INSERT INTO `ms_user_file_version` VALUES ('295','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-white\" style=\"text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 4px black;\">Card title</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:31:14');
INSERT INTO `ms_user_file_version` VALUES ('296','1','./../units/melbis_cataloge_center.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_CATALOGE_CENTER
 **/
function MELBIS_CATALOGE_CENTER($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Sample DB Query

    $command = \"SELECT ta.name, t.seo_psu, ft.*
                  FROM {DBNICK}_topic_alt ta
                  JOIN {DBNICK}_topic t
                    ON t.id = ta.topic_id                  
                  JOIN {DBNICK}_files_topic ft
                    ON ft.elem_id = t.id 
                 WHERE ta.kind_key = \'kCenter\'
                   AND ft.kind_key = \'kDefault\'                                     
              ORDER BY ta.absindex
                \";                    
    $topics = $gParser->SqlSelect(__LINE__, $command);
    foreach ($topics as $topic)
    {
        $gParser->TplAssign($tpl, [\'ID\'   => $topic[\'id\'], 
                                   \'IMAGE\'  => MELBIS_INC_STD_path($topic),
                                        \'NAME\' => $topic[\'name\'],
                                        \'LINK\'  => $item[\'seo_psu\']
                                        ]); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }


    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 12:31:38');
INSERT INTO `ms_user_file_version` VALUES ('297','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-white\" style=\"text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 4px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:31:50');
INSERT INTO `ms_user_file_version` VALUES ('298','1','./../units/melbis_cataloge_center.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_CATALOGE_CENTER
 **/
function MELBIS_CATALOGE_CENTER($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Sample DB Query

    $command = \"SELECT ta.name, t.seo_psu, ft.*
                  FROM {DBNICK}_topic_alt ta
                  JOIN {DBNICK}_topic t
                    ON t.id = ta.topic_id                  
                  JOIN {DBNICK}_files_topic ft
                    ON ft.elem_id = t.id 
                 WHERE ta.kind_key = \'kCenter\'
                   AND ft.kind_key = \'kDefault\'                                     
              ORDER BY ta.absindex
                \";                    
    $topics = $gParser->SqlSelect(__LINE__, $command);
    foreach ($topics as $topic)
    {
        $gParser->TplAssign($tpl, [\'ID\'   => $topic[\'id\'], 
                                   \'IMAGE\'  => MELBIS_INC_STD_path($topic),
                                        \'NAME\' => $topic[\'name\'],
                                        \'LINK\'  => $topic[\'seo_psu\']
                                        ]); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }


    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 12:32:05');
INSERT INTO `ms_user_file_version` VALUES ('299','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-info\" style=\"text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 4px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:32:20');
INSERT INTO `ms_user_file_version` VALUES ('300','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-primary\" style=\"text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 4px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:32:33');
INSERT INTO `ms_user_file_version` VALUES ('301','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-info\" style=\"text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 4px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:32:40');
INSERT INTO `ms_user_file_version` VALUES ('302','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-info\" style=\"text-shadow:  2px 2px 4px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:33:22');
INSERT INTO `ms_user_file_version` VALUES ('303','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-info\" style=\"text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 4px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:33:29');
INSERT INTO `ms_user_file_version` VALUES ('304','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-info display-4\" style=\"text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 4px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:34:02');
INSERT INTO `ms_user_file_version` VALUES ('305','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-info display-3\" style=\"text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 4px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:34:09');
INSERT INTO `ms_user_file_version` VALUES ('306','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-info display-5\" style=\"text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 4px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:34:15');
INSERT INTO `ms_user_file_version` VALUES ('307','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-info display-4\" style=\"text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 4px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:34:21');
INSERT INTO `ms_user_file_version` VALUES ('308','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-info\" style=\"text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 4px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:34:31');
INSERT INTO `ms_user_file_version` VALUES ('309','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-info\" style=\"font-size: 1rem; text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 4px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:34:55');
INSERT INTO `ms_user_file_version` VALUES ('310','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-info\" style=\"font-size: 1em; text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 4px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:35:00');
INSERT INTO `ms_user_file_version` VALUES ('311','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-info\" style=\"font-size: 5em; text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 4px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:35:06');
INSERT INTO `ms_user_file_version` VALUES ('312','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-info\" style=\"font-size: 2em; text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 4px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:35:11');
INSERT INTO `ms_user_file_version` VALUES ('313','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-info\" style=\"font-size: 2rem; text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 4px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:35:15');
INSERT INTO `ms_user_file_version` VALUES ('314','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay\">
            <h2 class=\"card-title text-info\" style=\"font-size: 3rem; text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 4px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:35:19');
INSERT INTO `ms_user_file_version` VALUES ('315','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay text-center\">
            <h2 class=\"card-title text-info\" style=\"font-size: 3rem; text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 4px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:35:40');
INSERT INTO `ms_user_file_version` VALUES ('316','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay text-center\">
            <h2 class=\"card-title text-info\" style=\"font-size: 3rem; text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 6px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:36:00');
INSERT INTO `ms_user_file_version` VALUES ('317','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay text-center\">
            <h2 class=\"card-title text-warning\" style=\"font-size: 3rem; text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 6px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:37:08');
INSERT INTO `ms_user_file_version` VALUES ('318','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay text-center\">
            <h2 class=\"card-title text-info\" style=\"font-size: 3rem; text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 6px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 12:37:25');
INSERT INTO `ms_user_file_version` VALUES ('319','1','./../templates/default/units/melbis_cataloge_center/main.htm','<div class=\"row row-cols-2 row-cols-md-2\">
    {ITEM}
</div>','2025-03-30 12:40:12');
INSERT INTO `ms_user_file_version` VALUES ('320','1','./../templates/default/units/melbis_cataloge_center/main.htm','<div class=\"row row-cols-2 row-cols-md-6\">
    {ITEM}
</div>','2025-03-30 12:40:23');
INSERT INTO `ms_user_file_version` VALUES ('321','1','./../templates/default/units/melbis_cataloge_center/main.htm','<div class=\"row row-cols-2 row-cols-md-3\">
    {ITEM}
</div>','2025-03-30 12:40:35');
INSERT INTO `ms_user_file_version` VALUES ('322','1','./../templates/default/units/melbis_cataloge_center/main.htm','<div class=\"row row-cols-2 row-cols-md-4\">
    {ITEM}
</div>','2025-03-30 12:40:44');
INSERT INTO `ms_user_file_version` VALUES ('323','1','./../units/melbis_cataloge_center.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_CATALOGE_CENTER
 **/
function MELBIS_CATALOGE_CENTER($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Sample DB Query

    $command = \"SELECT t.id, ta.name, t.seo_psu, 
                        ft.file_name, ft.real_name
                  FROM {DBNICK}_topic_alt ta
                  JOIN {DBNICK}_topic t
                    ON t.id = ta.topic_id                  
                  JOIN {DBNICK}_files_topic ft
                    ON ft.elem_id = t.id 
                 WHERE ta.kind_key = \'kCenter\'
                   AND ft.kind_key = \'kDefault\'                                     
              ORDER BY ta.absindex
                \";                    
    $topics = $gParser->SqlSelect(__LINE__, $command);
    foreach ($topics as $topic)
    {
        $gParser->TplAssign($tpl, [\'ID\'   => $topic[\'id\'], 
                                   \'IMAGE\'  => MELBIS_INC_STD_path($topic),
                                        \'NAME\' => $topic[\'name\'], 
                                        MELBIS_INC_LANG(\'kTopic\', \'NAME\', $item[\'id\'], $item[\'name\']),
                                        \'LINK\'  => $topic[\'seo_psu\']
                                        ]); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }


    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 12:44:50');
INSERT INTO `ms_user_file_version` VALUES ('324','1','./../units/melbis_cataloge_center.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_CATALOGE_CENTER
 **/
function MELBIS_CATALOGE_CENTER($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Sample DB Query

    $command = \"SELECT t.id, ta.name, t.seo_psu, 
                        ft.file_name, ft.upload_time
                  FROM {DBNICK}_topic_alt ta
                  JOIN {DBNICK}_topic t
                    ON t.id = ta.topic_id                  
                  JOIN {DBNICK}_files_topic ft
                    ON ft.elem_id = t.id 
                 WHERE ta.kind_key = \'kCenter\'
                   AND ft.kind_key = \'kDefault\'                                     
              ORDER BY ta.absindex
                \";                    
    $topics = $gParser->SqlSelect(__LINE__, $command);
    foreach ($topics as $topic)
    {
        $gParser->TplAssign($tpl, [\'ID\'   => $topic[\'id\'], 
                                   \'IMAGE\'  => MELBIS_INC_STD_path($topic),
                                        \'NAME\' => $topic[\'name\'], 
                                        MELBIS_INC_LANG(\'kTopic\', \'NAME\', $item[\'id\'], $item[\'name\']),
                                        \'LINK\'  => $topic[\'seo_psu\']
                                        ]); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }


    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 12:45:04');
INSERT INTO `ms_user_file_version` VALUES ('325','1','./../units/melbis_cataloge_center.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_CATALOGE_CENTER
 **/
function MELBIS_CATALOGE_CENTER($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Sample DB Query

    $command = \"SELECT t.id, ta.name, t.seo_psu, 
                        ft.file_name, ft.upload_time
                  FROM {DBNICK}_topic_alt ta
                  JOIN {DBNICK}_topic t
                    ON t.id = ta.topic_id                  
                  JOIN {DBNICK}_files_topic ft
                    ON ft.elem_id = t.id 
                 WHERE ta.kind_key = \'kCenter\'
                   AND ft.kind_key = \'kDefault\'                                     
              ORDER BY ta.absindex
                \";                    
    $topics = $gParser->SqlSelect(__LINE__, $command);
    foreach ($topics as $topic)
    {
        $gParser->TplAssign($tpl, [\'ID\'   => $topic[\'id\'], 
                                   \'IMAGE\'  => MELBIS_INC_STD_path($topic),
                                        \'NAME\' => 
                                        MELBIS_INC_LANG(\'kTopic\', \'NAME\', $topic[\'id\'], $topic[\'name\']),
                                        \'LINK\'  => $topic[\'seo_psu\']
                                        ]); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }


    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 12:45:20');
INSERT INTO `ms_user_file_version` VALUES ('326','1','./../units/melbis_cataloge_center.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_CATALOGE_CENTER
 **/
function MELBIS_CATALOGE_CENTER($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Sample DB Query

    $command = \"SELECT t.id, ta.name, t.seo_psu, 
                        ft.file_name, ft.upload_time
                  FROM {DBNICK}_topic_alt ta
                  JOIN {DBNICK}_topic t
                    ON t.id = ta.topic_id                  
                  JOIN {DBNICK}_files_topic ft
                    ON ft.elem_id = t.id 
                 WHERE ta.kind_key = \'kCenter\'
                   AND ft.kind_key = \'kDefault\'                                     
              ORDER BY ta.absindex
                \";                    
    $topics = $gParser->SqlSelect(__LINE__, $command);
    foreach ($topics as $topic)
    {
        $gParser->TplAssign($tpl, [\'ID\'     => $topic[\'id\'], 
                                   \'IMAGE\'  => MELBIS_INC_STD_path($topic),
                                   \'NAME\'   => MELBIS_INC_LANG(\'kTopic\', \'NAME\', $topic[\'id\'], $topic[\'name\']),
                                   \'LINK\'  => $topic[\'seo_psu\']
                                   ]); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }


    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 12:45:56');
INSERT INTO `ms_user_file_version` VALUES ('327','1','./../units/melbis_cataloge_center.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_CATALOGE_CENTER
 **/
function MELBIS_CATALOGE_CENTER($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get topics
    $command = \"SELECT t.id, ta.name, t.seo_psu, 
                        ft.file_name, ft.upload_time
                  FROM {DBNICK}_topic_alt ta
                  JOIN {DBNICK}_topic t
                    ON t.id = ta.topic_id                  
                  JOIN {DBNICK}_files_topic ft
                    ON ft.elem_id = t.id 
                 WHERE ta.kind_key = \'kCenter\'
                   AND ft.kind_key = \'kDefault\'                                     
              ORDER BY ta.absindex
                \";                    
    $topics = $gParser->SqlSelect(__LINE__, $command);
    foreach ($topics as $topic)
    {
        $gParser->TplAssign($tpl, [\'ID\'     => $topic[\'id\'], 
                                   \'IMAGE\'  => MELBIS_INC_STD_path($topic),
                                   \'NAME\'   => MELBIS_INC_LANG(\'kTopic\', \'NAME\', $topic[\'id\'], $topic[\'name\']),
                                   \'LINK\'  => $topic[\'seo_psu\']
                                   ]); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }


    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 12:47:14');
INSERT INTO `ms_user_file_version` VALUES ('328','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay text-center\">
            <h2 class=\"card-title text-info\" style=\"font-size: 3rem; text-shadow: -1px -1px 4px black, 1px 1px 2px black, 2px 2px 6px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 17:49:57');
INSERT INTO `ms_user_file_version` VALUES ('329','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay text-center\">
            <h2 class=\"card-title text-info\" style=\"font-size: 3rem; text-shadow: -1px -1px 4px black, 1px 1px 2px black, 2px 2px 10px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 17:50:07');
INSERT INTO `ms_user_file_version` VALUES ('330','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay text-center\">
            <h2 class=\"card-title text-info\" style=\"font-size: 3rem; text-shadow: -1px -1px 1px black, 1px 1px 2px black, 2px 2px 10px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 17:50:20');
INSERT INTO `ms_user_file_version` VALUES ('331','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay text-center\">
            <h2 class=\"card-title text-info\" style=\"font-size: 3rem; text-shadow: -1px -1px 1px black, 1px 1px 1px black, 2px 2px 10px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 17:50:28');
INSERT INTO `ms_user_file_version` VALUES ('332','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay text-center\">
            <h2 class=\"card-title text-info\" style=\"font-size: 3rem; text-shadow: -1px -1px 14px black, 1px 1px 2px black, 2px 2px 10px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 17:50:37');
INSERT INTO `ms_user_file_version` VALUES ('333','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay text-center\">
            <h2 class=\"card-title text-info\" style=\"font-size: 3rem; text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 10px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 17:50:46');
INSERT INTO `ms_user_file_version` VALUES ('334','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay text-center\" style=\"padding-top: 200px;\">
            <h2 class=\"card-title text-info\" style=\"font-size: 3rem; text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 10px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 17:51:51');
INSERT INTO `ms_user_file_version` VALUES ('335','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay text-center\" style=\"padding-top: 250px;\">
            <h2 class=\"card-title text-info\" style=\"font-size: 3rem; text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 10px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 17:51:58');
INSERT INTO `ms_user_file_version` VALUES ('336','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay text-center\" style=\"padding-top: 220px;\">
            <h2 class=\"card-title text-info\" style=\"font-size: 3rem; text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 10px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 17:52:03');
INSERT INTO `ms_user_file_version` VALUES ('337','1','./../templates/default/units/melbis_cataloge_center/main.htm','<div class=\"row row-cols-2 row-cols-xl-4\">
    {ITEM}
</div>','2025-03-30 17:53:03');
INSERT INTO `ms_user_file_version` VALUES ('338','1','./../templates/default/units/melbis_cataloge_center/main.htm','<div class=\"row row-cols-2 row-cols-md-3 row-cols-xl-4\">
    {ITEM}
</div>','2025-03-30 17:53:34');
INSERT INTO `ms_user_file_version` VALUES ('339','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay text-center\" style=\"padding-top: 200px;\">
            <h2 class=\"card-title text-info\" style=\"font-size: 3rem; text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 10px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-03-30 17:53:48');
INSERT INTO `ms_user_file_version` VALUES ('340','1','./../templates/default/melbis.js','
// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card-body\').find(\'h5\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});


// Serialize Object
$.fn.melbis_serial = function()
{
   var o = {};
   var a = this.serializeArray();
   $.each(a, function() {
       if (o[this.name]) {
           if (!o[this.name].push) {
               o[this.name] = [o[this.name]];
           }
           o[this.name].push(this.value || \'\');
       } else {
           o[this.name] = this.value || \'\';
       }
   });   
   
   return o;
};


// Numbers round and format
function melbis_num(n, c)
{
    var n = n, 
    c = isNaN(c = Math.abs(c)) ? 2 : c, 
    d = d == undefined ? \".\" : d, 
    t = t == undefined ? \"\'\" : t, 
    s = n < 0 ? \"-\" : \"\", 
    i = parseInt(n = Math.abs(+n || 0).toFixed(c)) + \"\", 
    j = (j = i.length) > 3 ? j % 3 : 0;
   return s + (j ? i.substr(0, j) + t : \"\") + i.substr(j).replace(/(\\d{3})(?=\\d)/g, \"$1\" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : \"\");
}


','2025-03-30 17:57:59');
INSERT INTO `ms_user_file_version` VALUES ('341','1','./../templates/default/units/melbis_cataloge_center/main.htm','<div class=\"row row-cols-2 row-cols-md-3 row-cols-xl-4\">
    {ITEM}
</div>','2025-03-30 17:59:57');
INSERT INTO `ms_user_file_version` VALUES ('342','1','./../templates/default/units/melbis_store_random/item.htm','<div class=\"col-lg-4 col-md-6 mb-3\">
    {1MELBIS:melbis_store_card([ID])}
</div>','2025-03-30 18:02:07');
INSERT INTO `ms_user_file_version` VALUES ('343','1','./../templates/default/units/melbis_store_random/item.htm','<div class=\"col-lg-4 col-md-6 mb-3\">
    {MELBIS:melbis_store_card([ID])}
</div>','2025-03-30 18:02:13');
INSERT INTO `ms_user_file_version` VALUES ('344','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100 shadow-sm\">
    {1MELBIS:melbis_store_image([ID],kDefault)}      
    <div class=\"card-body\">
        <h5 class=\"card-title\">{NAME}</h5>
        <p class=\"card-text\">{INTRO} Some quick example text to build on the card title and make up the bulk of the card\'s content.</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>','2025-03-30 18:03:07');
INSERT INTO `ms_user_file_version` VALUES ('345','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100 shadow-sm\">
    {MELBIS:melbis_store_image([ID],kDefault)}      
    <div class=\"card-body\">
        <h5 class=\"card-title\">{NAME}</h5>
        <p class=\"card-text\">{INTRO} Some quick example text to build on the card title and make up the bulk of the card\'s content.</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>','2025-03-30 18:03:12');
INSERT INTO `ms_user_file_version` VALUES ('346','1','./../templates/default/units/melbis_store_random/item.htm','<div class=\"col-lg-4 col-md-6 mb-3\">
    {1MELBIS:melbis_store_card([ID])}
</div>','2025-03-30 18:03:46');
INSERT INTO `ms_user_file_version` VALUES ('347','1','./../templates/default/units/melbis_store_random/item.htm','<div class=\"col-lg-4 col-md-6 mb-3\">
    {MELBIS:melbis_store_card([ID])}
</div>','2025-03-30 18:03:52');
INSERT INTO `ms_user_file_version` VALUES ('348','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();

    // Get goods                  
    echo $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                   ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"j F Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 18:04:29');
INSERT INTO `ms_user_file_version` VALUES ('349','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();

    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                   ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"j F Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 18:04:36');
INSERT INTO `ms_user_file_version` VALUES ('350','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();

    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                   ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"j F Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 18:05:07');
INSERT INTO `ms_user_file_version` VALUES ('351','1','./../units/melbis_store_random.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_RANDOM($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
            
    // Get random goods
    $lim = $mVars[\'limit\']*1;
    $command = \"SELECT s.id
                  FROM {DBNICK}_store s
                  JOIN {DBNICK}_topic_store ts
                    ON s.id = ts.store_id
                  JOIN {DBNICK}_topic t
                    ON t.id = ts.topic_id                    
                 WHERE s.no_visible = 0   
                   AND s.kind_key = \'kGoods\'
              ORDER BY RAND()
                 LIMIT $lim 
                \";                    
    $goods = $gParser->SqlSelect(__LINE__, $command);
    if ( count($goods) == 0 ) $gParser->TplAssign($tpl, \'ITEM\', \'\');
    foreach ( $goods as $item )
    {
        $gParser->TplAssign($tpl, \'ID\', $item[\'id\']);
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }         
    
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 18:06:40');
INSERT INTO `ms_user_file_version` VALUES ('352','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();

    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                   ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"j F Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 18:07:20');
INSERT INTO `ms_user_file_version` VALUES ('353','1','./../units/melbis_store_random.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_RANDOM($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
            
    // Get random goods
    $lim = $mVars[\'limit\']*1;
    $command = \"SELECT s.id
                  FROM {DBNICK}_store s
                  JOIN {DBNICK}_topic_store ts
                    ON s.id = ts.store_id
                  JOIN {DBNICK}_topic t
                    ON t.id = ts.topic_id                    
                 WHERE s.no_visible = 0   
                   AND t.kind_key = \'kGoods\'
              ORDER BY RAND()
                 LIMIT $lim 
                \";                    
    $goods = $gParser->SqlSelect(__LINE__, $command);
    if ( count($goods) == 0 ) $gParser->TplAssign($tpl, \'ITEM\', \'\');
    foreach ( $goods as $item )
    {
        $gParser->TplAssign($tpl, \'ID\', $item[\'id\']);
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }         
    
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 18:08:24');
INSERT INTO `ms_user_file_version` VALUES ('354','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();

    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                   ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"j F Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 18:08:55');
INSERT INTO `ms_user_file_version` VALUES ('355','1','./../templates/default/units/melbis_store_random/item.htm','<div class=\"col-lg-4 col-md-6 mb-3\">
    {MELBIS:melbis_store_card([MS:VAR:LANG],[ID])}
</div>','2025-03-30 18:09:23');
INSERT INTO `ms_user_file_version` VALUES ('356','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();

    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                   ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"j F Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 18:09:34');
INSERT INTO `ms_user_file_version` VALUES ('357','1','./../lazy.php','<?php
/***************************************************************************************************
 * 
 * lazy.php - Lazy loading module via AJAX
 * 
 ***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/

// Require
require_once(\'config.php\');
require_once(\'units/melbis_inc.php\');

// Create connect with DataBase
$gDb = new MySql(\'MELBIS_INC_halt\');
$gDb->Connect(__FILE__, __LINE__);

// Create Parser
$gParser = new Parser(\'MELBIS_INC_halt\', $gDb);

// Define self constants
$gParser->DefineSelfConst();

// Define session
$gSession = $gParser->DefineSession(DB_USER_NAME.\'_MELBIS_SHOP\');

print_r($gPost);

// Parse 
$gParser->ParseLazy($gSitePath, $gTemplate, $gPost[\'mod\'], $gPost[\'params\'], $gUseCache, $gBuild);

// Publish
$gParser->Publish();

?>','2025-03-30 18:11:44');
INSERT INTO `ms_user_file_version` VALUES ('358','1','./../index.php','<?php
/***************************************************************************************************
 * 
 * index.php - index page
 * 
 ***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/                             

// Require
require_once(\'config.php\');
require_once(\'units/melbis_inc.php\');

// Create connect with DataBase 
$gDb = new MySql(\'MELBIS_INC_halt\');
$gDb->Connect(__FILE__, __LINE__);

// Create Parser
$gParser = new Parser(\'MELBIS_INC_halt\', $gDb);

// Define self constants
$gParser->DefineSelfConst();
$gParser->DefineSelfVars(\'CONST\');

// Define session
$gSession = $gParser->DefineSession(DB_USER_NAME.\'_MELBIS_SHOP\');

// Define lazy load script
$gParser->DefineLazyScript($gSitePath.\'lazy.php\');

// Define languge                   
$default_lang = \'ru\';
$lang = addslashes($gGet[\'lang\'] ?? $default_lang);
$command = \"SELECT * FROM {DBNICK}_lang WHERE skey = \'$lang\'\";
$langs = $gParser->SqlSelectToArray(__LINE__, $command);               
$gLang = ( $langs[\'skey\'] ?? $default_lang ); 

// Define module
if ( !isset($gGet[\'mod\']) ) $gGet[\'mod\'] = \'melbis_base_page\'; 

// Parse
$gParser->Parse($gSitePath, $gTemplate, $gGet[\'mod\'], [$gLang, serialize($gGet), serialize($gPost)], $gUseCache, $gBuild);

// Publish
$gParser->Publish();

// Possible report
$gParser->Report();

?>','2025-03-30 18:13:22');
INSERT INTO `ms_user_file_version` VALUES ('359','1','./../lazy.php','<?php
/***************************************************************************************************
 * 
 * lazy.php - Lazy loading module via AJAX
 * 
 ***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/

// Require
require_once(\'config.php\');
require_once(\'units/melbis_inc.php\');

// Create connect with DataBase
$gDb = new MySql(\'MELBIS_INC_halt\');
$gDb->Connect(__FILE__, __LINE__);

// Create Parser
$gParser = new Parser(\'MELBIS_INC_halt\', $gDb);

// Define self constants
$gParser->DefineSelfConst();

// Define session
$gSession = $gParser->DefineSession(DB_USER_NAME.\'_MELBIS_SHOP\');

// Parse 
$gParser->ParseLazy($gSitePath, $gTemplate, $gPost[\'mod\'], $gPost[\'params\'], $gUseCache, $gBuild);

// Publish
$gParser->Publish();

?>','2025-03-30 18:14:23');
INSERT INTO `ms_user_file_version` VALUES ('360','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate(); 
    
    print_r($mVars);

    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                   ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"j F Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 18:15:08');
INSERT INTO `ms_user_file_version` VALUES ('361','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate(); 
    
    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                   ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"j F Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 18:15:23');
INSERT INTO `ms_user_file_version` VALUES ('362','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate(); 
    
    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                   ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"j F Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 18:16:38');
INSERT INTO `ms_user_file_version` VALUES ('363','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate(); 
    
    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                   ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"j F Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 18:16:46');
INSERT INTO `ms_user_file_version` VALUES ('364','1','./../templates/default/units/melbis_store_random/item.htm','<div class=\"col-lg-3 col-md-4 mb-3\">
    {MELBIS:melbis_store_card([MS:VAR:LANG],[ID])}
</div>','2025-03-30 18:30:12');
INSERT INTO `ms_user_file_version` VALUES ('365','1','./../templates/default/units/melbis_store_random/item.htm','<div class=\"col-lg-4 col-md-3 mb-3\">
    {MELBIS:melbis_store_card([MS:VAR:LANG],[ID])}
</div>','2025-03-30 18:30:38');
INSERT INTO `ms_user_file_version` VALUES ('366','1','./../templates/default/units/melbis_store_random/main.htm','<div class=\"container\">
    <div class=\"row row-cols-1 row-cols-md-2 melbis_goods\">
        {ITEM}
    </div>
</div>','2025-03-30 18:35:14');
INSERT INTO `ms_user_file_version` VALUES ('367','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"col mb-4\">
<div class=\"card h-100 shadow-sm\">
    {MELBIS:melbis_store_image([ID],kDefault)}      
    <div class=\"card-body\">
        <h5 class=\"card-title\">{NAME}</h5>
        <p class=\"card-text\">{INTRO} Some quick example text to build on the card title and make up the bulk of the card\'s content.</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
</div>','2025-03-30 18:35:39');
INSERT INTO `ms_user_file_version` VALUES ('368','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-top\" style=\"max-height: 200px;\">','2025-03-30 18:36:25');
INSERT INTO `ms_user_file_version` VALUES ('369','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-top\" style=\"height: 200px;\">','2025-03-30 18:36:47');
INSERT INTO `ms_user_file_version` VALUES ('370','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-top\" style=\"max-height: 200px;\">','2025-03-30 18:37:00');
INSERT INTO `ms_user_file_version` VALUES ('371','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"2card-img-top\" style=\"max-height: 200px;\">','2025-03-30 18:37:09');
INSERT INTO `ms_user_file_version` VALUES ('372','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-tope\" style=\"max-height: 200px;\">','2025-03-30 18:37:18');
INSERT INTO `ms_user_file_version` VALUES ('373','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-top\" style=\"max-height: 200px;\">','2025-03-30 18:37:25');
INSERT INTO `ms_user_file_version` VALUES ('374','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-top\" style=\"max-width: 200px;\">','2025-03-30 18:37:34');
INSERT INTO `ms_user_file_version` VALUES ('375','1','./../templates/default/units/melbis_store_random/main.htm','<div class=\"container\">
    <div class=\"row row-cols-1 row-cols-md-4 melbis_goods\">
        {ITEM}
    </div>
</div>','2025-03-30 18:38:33');
INSERT INTO `ms_user_file_version` VALUES ('376','1','./../templates/default/units/melbis_store_random/main.htm','<div class=\"container\">
    <div class=\"row row-cols-1 row-cols-md-1 melbis_goods\">
        {ITEM}
    </div>
</div>','2025-03-30 18:38:42');
INSERT INTO `ms_user_file_version` VALUES ('377','1','./../templates/default/units/melbis_store_random/main.htm','<div class=\"row row-cols-1 row-cols-md-1 melbis_goods\">
    {ITEM}
</div>','2025-03-30 18:39:07');
INSERT INTO `ms_user_file_version` VALUES ('378','1','./../templates/default/units/melbis_store_random/main.htm','<div class=\"row row-cols-1 row-cols-md-4 melbis_goods\">
    {ITEM}
</div>','2025-03-30 18:39:24');
INSERT INTO `ms_user_file_version` VALUES ('379','1','./../templates/default/units/melbis_store_random/main.htm','<div class=\"row row-cols-2 row-cols-md-4 melbis_goods\">
    {ITEM}
</div>','2025-03-30 18:39:40');
INSERT INTO `ms_user_file_version` VALUES ('380','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"col mb-4\">
<div class=\"card h-100\">
    {MELBIS:melbis_store_image([ID],kDefault)}      
    <div class=\"card-body\">
        <h5 class=\"card-title\">{NAME}</h5>
        <p class=\"card-text\">{INTRO} Some quick example text to build on the card title and make up the bulk of the card\'s content.</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
</div>','2025-03-30 18:40:40');
INSERT INTO `ms_user_file_version` VALUES ('381','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-top\" style=\"max-width: 200px; max-height: 200px\">','2025-03-30 18:47:11');
INSERT INTO `ms_user_file_version` VALUES ('382','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-top\" style=\"max-width: 300px; max-height: 200px\">','2025-03-30 18:47:24');
INSERT INTO `ms_user_file_version` VALUES ('383','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-top\">','2025-03-30 18:47:34');
INSERT INTO `ms_user_file_version` VALUES ('384','1','./../templates/default/units/melbis_store_random/item.htm','<div class=\"col-lg-4 col-md-4 mb-3\">
    {MELBIS:melbis_store_card([MS:VAR:LANG],[ID])}
</div>','2025-03-30 18:49:02');
INSERT INTO `ms_user_file_version` VALUES ('385','1','./../templates/default/units/melbis_store_random/item.htm','<div class=\"col mb-4\">
    {MELBIS:melbis_store_card([MS:VAR:LANG],[ID])}
</div>','2025-03-30 18:49:48');
INSERT INTO `ms_user_file_version` VALUES ('386','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    {MELBIS:melbis_store_image([ID],kDefault)}      
    <div class=\"card-body\">
        <h5 class=\"card-title\">{NAME}</h5>
        <p class=\"card-text\">{INTRO} Some quick example text to build on the card title and make up the bulk of the card\'s content.</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-30 18:50:27');
INSERT INTO `ms_user_file_version` VALUES ('387','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-top\" style=\"max-height: 200px;\">','2025-03-30 18:50:54');
INSERT INTO `ms_user_file_version` VALUES ('388','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-top\" style=\"max-width: 200px;\">','2025-03-30 18:51:07');
INSERT INTO `ms_user_file_version` VALUES ('389','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-top\">','2025-03-30 18:51:15');
INSERT INTO `ms_user_file_version` VALUES ('390','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-to2p\">','2025-03-30 18:51:38');
INSERT INTO `ms_user_file_version` VALUES ('391','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-top\">','2025-03-30 18:51:46');
INSERT INTO `ms_user_file_version` VALUES ('392','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-1200\">
    {MELBIS:melbis_store_image([ID],kDefault)}      
    <div class=\"card-body\">
        <h5 class=\"card-title\">{NAME}</h5>
        <p class=\"card-text\">{INTRO} Some quick example text to build on the card title and make up the bulk of the card\'s content.</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-30 18:51:52');
INSERT INTO `ms_user_file_version` VALUES ('393','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    {MELBIS:melbis_store_image([ID],kDefault)}      
    <div class=\"card-body\">
        <h5 class=\"card-title\">{NAME}</h5>
        <p class=\"card-text\">{INTRO} Some quick example text to build on the card title and make up the bulk of the card\'s content.</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-30 18:52:10');
INSERT INTO `ms_user_file_version` VALUES ('394','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    {MELBIS:melbis_store_image([ID],kDefault)} 
    <h5 class=\"card-header\">Featured</h5>     
    <div class=\"card-body\">
        <h5 class=\"card-title\">{NAME}</h5>
        <p class=\"card-text\">{INTRO} Some quick example text to build on the card title and make up the bulk of the card\'s content.</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-30 18:54:30');
INSERT INTO `ms_user_file_version` VALUES ('395','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h5 class=\"card-header\">Featured</h5>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <h5 class=\"card-title\">{NAME}</h5>
        <p class=\"card-text\">{INTRO} Some quick example text to build on the card title and make up the bulk of the card\'s content.</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-30 18:54:49');
INSERT INTO `ms_user_file_version` VALUES ('396','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h3 class=\"card-header\">Featured</h3>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <h5 class=\"card-title\">{NAME}</h5>
        <p class=\"card-text\">{INTRO} Some quick example text to build on the card title and make up the bulk of the card\'s content.</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-30 18:55:08');
INSERT INTO `ms_user_file_version` VALUES ('397','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h3 class=\"card-header\">{NAME}</h3>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <h5 class=\"card-title\">{NAME}</h5>
        <p class=\"card-text\">{INTRO} Some quick example text to build on the card title and make up the bulk of the card\'s content.</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-30 18:55:17');
INSERT INTO `ms_user_file_version` VALUES ('398','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h3 class=\"card-header text-center\">{NAME}</h3>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <h5 class=\"card-title\">{NAME}</h5>
        <p class=\"card-text\">{INTRO} Some quick example text to build on the card title and make up the bulk of the card\'s content.</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-30 18:55:29');
INSERT INTO `ms_user_file_version` VALUES ('399','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <h5 class=\"card-title\">{NAME}</h5>
        <p class=\"card-text\">{INTRO} Some quick example text to build on the card title and make up the bulk of the card\'s content.</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-30 18:55:43');
INSERT INTO `ms_user_file_version` VALUES ('400','1','./../templates/default/units/melbis_store_random/main.htm','<div class=\"card-group melbis_goods\">
    {ITEM}
</div>','2025-03-30 18:58:05');
INSERT INTO `ms_user_file_version` VALUES ('401','1','./../templates/default/units/melbis_store_random/main.htm','<div class=\"row row-cols-2 row-cols-md-4 melbis_goods\">
    {ITEM}
</div>','2025-03-30 18:58:14');
INSERT INTO `ms_user_file_version` VALUES ('402','1','./../templates/default/units/melbis_store_random/main.htm','<div class=\"card-deck melbis_goods\">
    {ITEM}
</div>','2025-03-30 18:59:35');
INSERT INTO `ms_user_file_version` VALUES ('403','1','./../templates/default/units/melbis_store_random/item.htm','<div class=\"cwol mb-4\">
    {MELBIS:melbis_store_card([MS:VAR:LANG],[ID])}
</div>','2025-03-30 18:59:42');
INSERT INTO `ms_user_file_version` VALUES ('404','1','./../templates/default/units/melbis_store_random/item.htm','<div class=\"col mb-4\">
    {MELBIS:melbis_store_card([MS:VAR:LANG],[ID])}
</div>','2025-03-30 18:59:56');
INSERT INTO `ms_user_file_version` VALUES ('405','1','./../templates/default/units/melbis_store_random/main.htm','<div class=\"row row-cols-2 row-cols-md-4 melbis_goods\">
    {ITEM}
</div>','2025-03-30 19:00:08');
INSERT INTO `ms_user_file_version` VALUES ('406','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <h5 class=\"card-title\">{NAME}</h5>
        <p class=\"card-text\">{INTRO} Some quick example text to build on the card title and make up the bulk of the card\'s content.</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-30 19:01:20');
INSERT INTO `ms_user_file_version` VALUES ('407','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <h5 class=\"card-title\">{NAME}</h5>
        <p class=\"card-text\">{INTRO} Some quick example text to build on the card title and make up the bulk of the card\'s content.</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-30 19:08:08');
INSERT INTO `ms_user_file_version` VALUES ('408','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <h5 class=\"card-title\">{NAME}</h5>
        <p class=\"card-text\">{INTRO} Some quick example text to build on the card title and make up the bulk of the card\'s content.</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-30 19:08:28');
INSERT INTO `ms_user_file_version` VALUES ('409','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <h5 class=\"card-title\">{NAME}</h5>
        <p class=\"card-text\">{INTRO}</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-30 19:08:46');
INSERT INTO `ms_user_file_version` VALUES ('410','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate(); 
    
    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                   ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"j F Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-30 19:09:09');
INSERT INTO `ms_user_file_version` VALUES ('411','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <p class=\"card-text\">{INTRO}</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-30 19:10:05');
INSERT INTO `ms_user_file_version` VALUES ('412','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-top m-2\">','2025-03-30 19:10:49');
INSERT INTO `ms_user_file_version` VALUES ('413','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-top m-4\">','2025-03-30 19:10:57');
INSERT INTO `ms_user_file_version` VALUES ('414','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-top\">','2025-03-30 19:11:09');
INSERT INTO `ms_user_file_version` VALUES ('415','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-top p-4\">','2025-03-30 19:11:15');
INSERT INTO `ms_user_file_version` VALUES ('416','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-top p-5\">','2025-03-30 19:11:23');
INSERT INTO `ms_user_file_version` VALUES ('417','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-top p-4\">','2025-03-30 19:11:31');
INSERT INTO `ms_user_file_version` VALUES ('418','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <p class=\"card-text\">{INTRO}</p>    

    </div>   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-30 19:14:00');
INSERT INTO `ms_user_file_version` VALUES ('419','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <p class=\"card-text\">{INTRO}</p>    

    </div>   
   
</div>
','2025-03-30 19:14:20');
INSERT INTO `ms_user_file_version` VALUES ('420','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <p class=\"card-text\">{INTRO}</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-30 19:14:50');
INSERT INTO `ms_user_file_version` VALUES ('421','1','./../templates/default/units/melbis_store_random/main.htm','<div class=\"row row-cols-2 row-cols-md-3 melbis_goods\">
    {ITEM}
</div>','2025-03-30 19:15:37');
INSERT INTO `ms_user_file_version` VALUES ('422','1','./../templates/default/units/melbis_store_random/main.htm','<div class=\"row row-cols-2 row-cols-xl-3 melbis_goods\">
    {ITEM}
</div>','2025-03-30 19:15:53');
INSERT INTO `ms_user_file_version` VALUES ('423','1','./../templates/default/units/melbis_store_random/main.htm','<div class=\"row row-cols-2 row-cols-xl-4 melbis_goods\">
    {ITEM}
</div>','2025-03-30 19:16:13');
INSERT INTO `ms_user_file_version` VALUES ('424','1','./../units/melbis_core_translate.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/

/** 
 * Function MELBIS_CORE_TRANSLATE
 **/
function MELBIS_CORE_TRANSLATE($mVars)
{ 
    global $gParser; 

    // Header
    header(\'Content-Type: text/plain; charset=utf-8\');   
                                      
    // Vars   
    $update = [];
    $now = MELBIS_INC_STD_get_now();
    $pagetime = $gParser->RunTime();
    echo \"> Running at the $now \\r\\n\";             
         
    // From lang
    $command = \"SELECT * FROM {DBNICK}_lang WHERE is_origin = 1\";               
    $from = $gParser->SqlSelectToArray(__LINE__, $command);    
           
    // To lang
    $command = \"SELECT * 
                  FROM {DBNICK}_lang
                 WHERE is_origin <> 1
              ORDER BY pos
              \";                
    $langs = $gParser->SqlSelect(__LINE__, $command);
    foreach ($langs as $lang) 
    {         
        echo \"\\r\\n> Translate to: $lang[name] \\r\\n\";

        // Content        
        $command = \"SELECT o.id, o.trans_id, o.context, o.origin, o.is_html, tl.id AS tl_id, LENGTH(o.origin) AS size   
                      FROM {DBNICK}_trans_origin o
                 LEFT JOIN {DBNICK}_trans_lang tl
                        ON o.id = tl.origin_id 
                       AND tl.lang_id = \'$lang[id]\'  
                     WHERE md5(CONCAT(o.context, o.origin)) <> o.crc 
                        OR tl.id IS NULL
                  ORDER BY size ASC                    
                     LIMIT 10
                   \";
        $origins = $gParser->SqlSelect(__LINE__, $command);
        foreach ($origins as $origin)
        {
            echo \'[\'.$origin[\'id\'].\"]: \";
            
            $translate = MELBIS_INC_TRANSLATE_deepl($origin[\'origin\'], 
                                                    $origin[\'context\'], 
                                                    $from[\'skey\'], 
                                                    $lang[\'skey\'], 
                                                    $origin[\'is_html\']);
            echo $translate.\"\\r\\n\"; 
            
            if ( is_null($origin[\'tl_id\']) )
            {   
                // Add translate
                $hash = [];
                $hash[\'id\'] = $gParser->SqlGenId(\'trans_lang\');
                $hash[\'lang_id\'] = $lang[\'id\'];
                $hash[\'trans_id\'] = $origin[\'trans_id\'];
                $hash[\'origin_id\'] = $origin[\'id\'];            
                $hash[\'translate\'] = $translate;            
                $gParser->SqlInsert(__LINE__, \'{DBNICK}_trans_lang\', $hash);            
            }
            else
            {    
                // Change translate
                $hash = [];
                $hash[\'id\'] = $origin[\'tl_id\'];
                $hash[\'translate\'] = $translate;
                $gParser->SqlUpdate(__LINE__, \'{DBNICK}_trans_lang\', $hash, \'id\');                          
            }
            // Save Update
            $update[$origin[\'id\']] = md5($origin[\'context\'].$origin[\'origin\']); 
        }                                      
    } 
    
    // Update
    foreach ( $update as $id => $crc )
    {    
        $hash = [];
        $hash[\'id\'] = $id;
        $hash[\'crc\'] = $crc;
        $gParser->SqlUpdate(__LINE__, \'{DBNICK}_trans_origin\', $hash, \'id\');
    }                                        
    
    return \'\';                    
} 

?>','2025-03-31 14:39:41');
INSERT INTO `ms_user_file_version` VALUES ('425','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate(); 
    
    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                   ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"j F Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 14:50:11');
INSERT INTO `ms_user_file_version` VALUES ('426','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate(); 
    
    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                   ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"j F Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 14:50:32');
INSERT INTO `ms_user_file_version` VALUES ('427','1','./../templates/default/melbis.js','
// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    alert();
    var name = $(this).parents(\'.card-body\').find(\'h5\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});


// Serialize Object
$.fn.melbis_serial = function()
{
   var o = {};
   var a = this.serializeArray();
   $.each(a, function() {
       if (o[this.name]) {
           if (!o[this.name].push) {
               o[this.name] = [o[this.name]];
           }
           o[this.name].push(this.value || \'\');
       } else {
           o[this.name] = this.value || \'\';
       }
   });   
   
   return o;
};


// Numbers round and format
function melbis_num(n, c)
{
    var n = n, 
    c = isNaN(c = Math.abs(c)) ? 2 : c, 
    d = d == undefined ? \".\" : d, 
    t = t == undefined ? \"\'\" : t, 
    s = n < 0 ? \"-\" : \"\", 
    i = parseInt(n = Math.abs(+n || 0).toFixed(c)) + \"\", 
    j = (j = i.length) > 3 ? j % 3 : 0;
   return s + (j ? i.substr(0, j) + t : \"\") + i.substr(j).replace(/(\\d{3})(?=\\d)/g, \"$1\" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : \"\");
}


','2025-03-31 14:53:23');
INSERT INTO `ms_user_file_version` VALUES ('428','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate(); 
    
    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                   ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"j F Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 14:55:40');
INSERT INTO `ms_user_file_version` VALUES ('429','1','./../templates/default/units/melbis_store_image/no_image.htm','<svg class=\"bd-placeholder-img card-img-top\" width=\"100%\" height=\"200\" xmlns=\"http://www.w3.org/2000/svg\" preserveAspectRatio=\"xMidYMid slice\" focusable=\"false\">        
    <rect width=\"100%\" height=\"100%\" fill=\"#55595c\"></rect>
    <text x=\"33%\" y=\"150%\" fill=\"#eceeef\">Place for image</text>
</svg>                                                        
','2025-03-31 14:57:24');
INSERT INTO `ms_user_file_version` VALUES ('430','1','./../templates/default/units/melbis_store_image/no_image.htm','<svg class=\"bd-placeholder-img card-img-top\" width=\"100%\" height=\"200\" xmlns=\"http://www.w3.org/2000/svg\" preserveAspectRatio=\"xMidYMid slice\" focusable=\"false\">        
    <rect width=\"100%\" height=\"100%\" fill=\"#55595c\"></rect>
    <text x=\"33%\" y=\"50%\" fill=\"#eceeef\">Place for image</text>
</svg>                                                        
','2025-03-31 14:57:32');
INSERT INTO `ms_user_file_version` VALUES ('431','1','./../templates/default/units/melbis_store_image/no_image.htm','<svg class=\"bd-placeholder-img card-img-top\" width=\"100%\" height=\"200\" xmlns=\"http://www.w3.org/2000/svg\" preserveAspectRatio=\"xMidYMid slice\" focusable=\"false\">        
    <rect width=\"100%\" height=\"100%\" fill=\"#55595c\"></rect>
    <text x=\"35%\" y=\"50%\" fill=\"#eceeef\">Place for image</text>
</svg>                                                        
','2025-03-31 14:57:51');
INSERT INTO `ms_user_file_version` VALUES ('432','1','./../templates/default/melbis.js','
// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card-body\').find(\'h5\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});


// Serialize Object
$.fn.melbis_serial = function()
{
   var o = {};
   var a = this.serializeArray();
   $.each(a, function() {
       if (o[this.name]) {
           if (!o[this.name].push) {
               o[this.name] = [o[this.name]];
           }
           o[this.name].push(this.value || \'\');
       } else {
           o[this.name] = this.value || \'\';
       }
   });   
   
   return o;
};


// Numbers round and format
function melbis_num(n, c)
{
    var n = n, 
    c = isNaN(c = Math.abs(c)) ? 2 : c, 
    d = d == undefined ? \".\" : d, 
    t = t == undefined ? \"\'\" : t, 
    s = n < 0 ? \"-\" : \"\", 
    i = parseInt(n = Math.abs(+n || 0).toFixed(c)) + \"\", 
    j = (j = i.length) > 3 ? j % 3 : 0;
   return s + (j ? i.substr(0, j) + t : \"\") + i.substr(j).replace(/(\\d{3})(?=\\d)/g, \"$1\" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : \"\");
}


','2025-03-31 15:04:45');
INSERT INTO `ms_user_file_version` VALUES ('433','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate(); 
    
    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                   ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"j F Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 15:23:33');
INSERT INTO `ms_user_file_version` VALUES ('434','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate(); 
    
    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                   ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"j F Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 15:23:53');
INSERT INTO `ms_user_file_version` VALUES ('435','1','./../templates/default/melbis.js','alert();

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card-body\').find(\'h5\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});


// Serialize Object
$.fn.melbis_serial = function()
{
   var o = {};
   var a = this.serializeArray();
   $.each(a, function() {
       if (o[this.name]) {
           if (!o[this.name].push) {
               o[this.name] = [o[this.name]];
           }
           o[this.name].push(this.value || \'\');
       } else {
           o[this.name] = this.value || \'\';
       }
   });   
   
   return o;
};


// Numbers round and format
function melbis_num(n, c)
{
    var n = n, 
    c = isNaN(c = Math.abs(c)) ? 2 : c, 
    d = d == undefined ? \".\" : d, 
    t = t == undefined ? \"\'\" : t, 
    s = n < 0 ? \"-\" : \"\", 
    i = parseInt(n = Math.abs(+n || 0).toFixed(c)) + \"\", 
    j = (j = i.length) > 3 ? j % 3 : 0;
   return s + (j ? i.substr(0, j) + t : \"\") + i.substr(j).replace(/(\\d{3})(?=\\d)/g, \"$1\" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : \"\");
}


','2025-03-31 15:26:28');
INSERT INTO `ms_user_file_version` VALUES ('436','1','./../templates/default/melbis.js','

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card-body\').find(\'h5\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});


// Serialize Object
$.fn.melbis_serial = function()
{
   var o = {};
   var a = this.serializeArray();
   $.each(a, function() {
       if (o[this.name]) {
           if (!o[this.name].push) {
               o[this.name] = [o[this.name]];
           }
           o[this.name].push(this.value || \'\');
       } else {
           o[this.name] = this.value || \'\';
       }
   });   
   
   return o;
};


// Numbers round and format
function melbis_num(n, c)
{
    var n = n, 
    c = isNaN(c = Math.abs(c)) ? 2 : c, 
    d = d == undefined ? \".\" : d, 
    t = t == undefined ? \"\'\" : t, 
    s = n < 0 ? \"-\" : \"\", 
    i = parseInt(n = Math.abs(+n || 0).toFixed(c)) + \"\", 
    j = (j = i.length) > 3 ? j % 3 : 0;
   return s + (j ? i.substr(0, j) + t : \"\") + i.substr(j).replace(/(\\d{3})(?=\\d)/g, \"$1\" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : \"\");
}


','2025-03-31 15:26:37');
INSERT INTO `ms_user_file_version` VALUES ('437','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card-body\').find(\'h5\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});


// Auto image preview
//==================================================================================================

// Get image
$(\'main\').on(\'click\', \'.img_preview\', function() 
{
    if ( $(this).hasClass(\'img_max\') )
    {
        $(\'#melbis_win_imageview img\').removeClass(\'img-fluid\').addClass(\'melbis_css_img_detail\');    
    }                                                            
    else
    {
        $(\'#melbis_win_imageview img\').addClass(\'img-fluid\').removeClass(\'melbis_css_img_detail\');
    }
    $(\'#melbis_win_imageview img\').attr(\'src\', $(this).attr(\'src\'));
                     
    $(\'#melbis_win_imageview\').modal(\'show\'); 
});


// Get prev image 
$(\'#melbis_win_imageview .prev\').on(\'click\', function() 
{        
    var src = $(\'#melbis_win_imageview img\').attr(\'src\');
    $(\'main .img_preview\').each(function(i)
    {        
        if ( src == $(this).attr(\'src\') )                         
        {            
            if ( i > 0 )
            {
                src =  $(\'main .img_preview\').eq(i-1).attr(\'src\');
                if ( $(\'main .img_preview\').eq(i-1).hasClass(\'img_max\') )
                {
                    $(\'#melbis_win_imageview img\').removeClass(\'img-fluid\').addClass(\'melbis_css_img_detail\');    
                }                                                            
                else
                {
                    $(\'#melbis_win_imageview img\').addClass(\'img-fluid\').removeClass(\'melbis_css_img_detail\');
                }              
            }
            return false;             
        }          
    }); 
    $(\'#melbis_win_imageview img\').attr(\'src\', src);            
});


// Get next image 
$(\'#melbis_win_imageview .next\').on(\'click\', function() 
{            
    var src = $(\'#melbis_win_imageview img\').attr(\'src\');
    $(\'main .img_preview\').each(function(i)
    {                        
        if ( src == $(this).attr(\'src\') && i < $(\'main .img_preview\').length )                         
        {                        
            src =  $(\'main .img_preview\').eq(i+1).attr(\'src\');
            if ( $(\'main .img_preview\').eq(i+1).hasClass(\'img_max\') )
            {
                $(\'#melbis_win_imageview img\').removeClass(\'img-fluid\').addClass(\'melbis_css_img_detail\');    
            }                                                            
            else
            {
                $(\'#melbis_win_imageview img\').addClass(\'img-fluid\').removeClass(\'melbis_css_img_detail\');
            }                 
            return false;             
        }          
    });    
    $(\'#melbis_win_imageview img\').attr(\'src\', src);
});


// Close preview 
$(\'#melbis_win_imageview img\').on(\'click\', function() 
{            
    $(\'#melbis_win_imageview\').modal(\'hide\');
});
     

</script>','2025-03-31 15:28:36');
INSERT INTO `ms_user_file_version` VALUES ('438','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">



// Auto image preview
//==================================================================================================

// Get image
$(\'main\').on(\'click\', \'.img_preview\', function() 
{
    if ( $(this).hasClass(\'img_max\') )
    {
        $(\'#melbis_win_imageview img\').removeClass(\'img-fluid\').addClass(\'melbis_css_img_detail\');    
    }                                                            
    else
    {
        $(\'#melbis_win_imageview img\').addClass(\'img-fluid\').removeClass(\'melbis_css_img_detail\');
    }
    $(\'#melbis_win_imageview img\').attr(\'src\', $(this).attr(\'src\'));
                     
    $(\'#melbis_win_imageview\').modal(\'show\'); 
});


// Get prev image 
$(\'#melbis_win_imageview .prev\').on(\'click\', function() 
{        
    var src = $(\'#melbis_win_imageview img\').attr(\'src\');
    $(\'main .img_preview\').each(function(i)
    {        
        if ( src == $(this).attr(\'src\') )                         
        {            
            if ( i > 0 )
            {
                src =  $(\'main .img_preview\').eq(i-1).attr(\'src\');
                if ( $(\'main .img_preview\').eq(i-1).hasClass(\'img_max\') )
                {
                    $(\'#melbis_win_imageview img\').removeClass(\'img-fluid\').addClass(\'melbis_css_img_detail\');    
                }                                                            
                else
                {
                    $(\'#melbis_win_imageview img\').addClass(\'img-fluid\').removeClass(\'melbis_css_img_detail\');
                }              
            }
            return false;             
        }          
    }); 
    $(\'#melbis_win_imageview img\').attr(\'src\', src);            
});


// Get next image 
$(\'#melbis_win_imageview .next\').on(\'click\', function() 
{            
    var src = $(\'#melbis_win_imageview img\').attr(\'src\');
    $(\'main .img_preview\').each(function(i)
    {                        
        if ( src == $(this).attr(\'src\') && i < $(\'main .img_preview\').length )                         
        {                        
            src =  $(\'main .img_preview\').eq(i+1).attr(\'src\');
            if ( $(\'main .img_preview\').eq(i+1).hasClass(\'img_max\') )
            {
                $(\'#melbis_win_imageview img\').removeClass(\'img-fluid\').addClass(\'melbis_css_img_detail\');    
            }                                                            
            else
            {
                $(\'#melbis_win_imageview img\').addClass(\'img-fluid\').removeClass(\'melbis_css_img_detail\');
            }                 
            return false;             
        }          
    });    
    $(\'#melbis_win_imageview img\').attr(\'src\', src);
});


// Close preview 
$(\'#melbis_win_imageview img\').on(\'click\', function() 
{            
    $(\'#melbis_win_imageview\').modal(\'hide\');
});
     

</script>','2025-03-31 15:28:57');
INSERT INTO `ms_user_file_version` VALUES ('439','1','./../templates/default/melbis.js','
// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card-body\').find(\'h5\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});


// Serialize Object
$.fn.melbis_serial = function()
{
   var o = {};
   var a = this.serializeArray();
   $.each(a, function() {
       if (o[this.name]) {
           if (!o[this.name].push) {
               o[this.name] = [o[this.name]];
           }
           o[this.name].push(this.value || \'\');
       } else {
           o[this.name] = this.value || \'\';
       }
   });   
   
   return o;
};


// Numbers round and format
function melbis_num(n, c)
{
    var n = n, 
    c = isNaN(c = Math.abs(c)) ? 2 : c, 
    d = d == undefined ? \".\" : d, 
    t = t == undefined ? \"\'\" : t, 
    s = n < 0 ? \"-\" : \"\", 
    i = parseInt(n = Math.abs(+n || 0).toFixed(c)) + \"\", 
    j = (j = i.length) > 3 ? j % 3 : 0;
   return s + (j ? i.substr(0, j) + t : \"\") + i.substr(j).replace(/(\\d{3})(?=\\d)/g, \"$1\" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : \"\");
}


','2025-03-31 15:30:25');
INSERT INTO `ms_user_file_version` VALUES ('440','1','./../templates/default/melbis.js','
alert();

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card-body\').find(\'h5\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});


// Serialize Object
$.fn.melbis_serial = function()
{
   var o = {};
   var a = this.serializeArray();
   $.each(a, function() {
       if (o[this.name]) {
           if (!o[this.name].push) {
               o[this.name] = [o[this.name]];
           }
           o[this.name].push(this.value || \'\');
       } else {
           o[this.name] = this.value || \'\';
       }
   });   
   
   return o;
};


// Numbers round and format
function melbis_num(n, c)
{
    var n = n, 
    c = isNaN(c = Math.abs(c)) ? 2 : c, 
    d = d == undefined ? \".\" : d, 
    t = t == undefined ? \"\'\" : t, 
    s = n < 0 ? \"-\" : \"\", 
    i = parseInt(n = Math.abs(+n || 0).toFixed(c)) + \"\", 
    j = (j = i.length) > 3 ? j % 3 : 0;
   return s + (j ? i.substr(0, j) + t : \"\") + i.substr(j).replace(/(\\d{3})(?=\\d)/g, \"$1\" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : \"\");
}


','2025-03-31 15:43:01');
INSERT INTO `ms_user_file_version` VALUES ('441','1','./../templates/default/melbis.js','

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
alert();
    var name = $(this).parents(\'.card-body\').find(\'h5\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});


// Serialize Object
$.fn.melbis_serial = function()
{
   var o = {};
   var a = this.serializeArray();
   $.each(a, function() {
       if (o[this.name]) {
           if (!o[this.name].push) {
               o[this.name] = [o[this.name]];
           }
           o[this.name].push(this.value || \'\');
       } else {
           o[this.name] = this.value || \'\';
       }
   });   
   
   return o;
};


// Numbers round and format
function melbis_num(n, c)
{
    var n = n, 
    c = isNaN(c = Math.abs(c)) ? 2 : c, 
    d = d == undefined ? \".\" : d, 
    t = t == undefined ? \"\'\" : t, 
    s = n < 0 ? \"-\" : \"\", 
    i = parseInt(n = Math.abs(+n || 0).toFixed(c)) + \"\", 
    j = (j = i.length) > 3 ? j % 3 : 0;
   return s + (j ? i.substr(0, j) + t : \"\") + i.substr(j).replace(/(\\d{3})(?=\\d)/g, \"$1\" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : \"\");
}


','2025-03-31 15:43:11');
INSERT INTO `ms_user_file_version` VALUES ('442','1','./../templates/default/melbis.js','

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card-body\').find(\'h5\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});


// Serialize Object
$.fn.melbis_serial = function()
{
   var o = {};
   var a = this.serializeArray();
   $.each(a, function() {
       if (o[this.name]) {
           if (!o[this.name].push) {
               o[this.name] = [o[this.name]];
           }
           o[this.name].push(this.value || \'\');
       } else {
           o[this.name] = this.value || \'\';
       }
   });   
   
   return o;
};


// Numbers round and format
function melbis_num(n, c)
{
    var n = n, 
    c = isNaN(c = Math.abs(c)) ? 2 : c, 
    d = d == undefined ? \".\" : d, 
    t = t == undefined ? \"\'\" : t, 
    s = n < 0 ? \"-\" : \"\", 
    i = parseInt(n = Math.abs(+n || 0).toFixed(c)) + \"\", 
    j = (j = i.length) > 3 ? j % 3 : 0;
   return s + (j ? i.substr(0, j) + t : \"\") + i.substr(j).replace(/(\\d{3})(?=\\d)/g, \"$1\" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : \"\");
}


','2025-03-31 15:43:21');
INSERT INTO `ms_user_file_version` VALUES ('443','1','./../units/melbis_inc.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff         
 **************************************************************************************************/

// Core
require_once(\'core/core.php\');
 
// PHP error control
error_reporting(E_ALL);  
ini_set(\'display_errors\', \'off\');      
set_error_handler(function ($mError, $mMessage, $mFile, $mLine) 
    {    
        $error = error_reporting();
        if ( $error !== 0 && $error != 4437 ) 
            MELBIS_INC_halt(\'PHP Runtime Exception\', $mFile.\' : \'.$mLine, $mMessage); 
    });
register_shutdown_function(function ()
    {
        $error = error_get_last();
        if ( isset($error) && ( $error[\"type\"] == E_ERROR || $error[\"type\"] == E_WARNING || $error[\"type\"] == E_PARSE ) )
            MELBIS_INC_halt(\'PHP Shutdown Exception\', $error[\"file\"].\' : \'.$error[\"line\"], $error[\"message\"]); 
    });

// Set Local Setting 
if ( strlen(SHOP_LOCALE) > 0 ) setlocale(LC_ALL, SHOP_LOCALE); 
if ( strlen(SHOP_CHARSET) > 0 ) mb_internal_encoding(SHOP_CHARSET);

// Autoload class
if ( !function_exists(\'MELBIS_INC_autoload\') ) 
{
    function MELBIS_INC_autoload($mClassName)
    {        
        require_once(\'core/class/class.\'.$mClassName.\'.php\');
    }

    spl_autoload_register(\'MELBIS_INC_autoload\');
}


// Set path of shop on the domain, for sample: \"www.site.com/shop\", right path is \"/shop/\"
$gSitePath = \'/\'; 

// For switch off caching system set the value \"false\", it\'s useful in developing process
$gUseCache = false;

// Set default shop template
$gTemplate = TEMPLATE;

// Set current build counter
$gBuild = 1;

// GET vars array
$gGet = $_GET;

// POST vars array
$gPost = $_POST;

// FILES vars array
$gFiles = $_FILES;

// SERVER vars array
$gServer = $_SERVER;


 // Shop available?
 if ( file_exists(\'shop.lock\') ) 
 {
     MELBIS_INC_halt(\'SHOP LOCKED\', __FILE__.\':\'.__LINE__, \'Shop locked!\', \'shop.lock\');
 } 
 

/** 
 * Function MELBIS_INC
 * Manual include module
 **/                  
function MELBIS_INC($mInclude) 
{
    if ( file_exists(\'units/\'.$mInclude.\'.php\') )
    {
        require_once(\'units/\'.$mInclude.\'.php\');
    
        return true;
    }
    else 
    {
        MELBIS_INC_halt(\'INCLUDE ABSENT\', __FILE__.\':\'.__LINE__, \'Require include is absent!\', \'units/\'.$mInclude.\'.php\');
    }
} 


/** 
 * Function MELBIS_INC_halt
 * Returm info message about error and die
 **/    
function MELBIS_INC_halt($mErrorType, $mErrorFile, $mError, $mErrorInfo = \'\') 
{
    // So, print error message 
?>    
<!doctype html>
<html lang=\"en\" class=\"h-100\">
  <head>
    <meta charset=\"utf-8\">
    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1, shrink-to-fit=no\">
    <link rel=\"stylesheet\" href=\"<?php echo \'/templates/\'.TEMPLATE.\'/bootstrap.css\'; ?>\">
    <title>System error in Melbis Shop <?php echo SCRIPT_VERSION.\'.\'.SCRIPT_BUILD; ?></title>
  </head>
  <body class=\"d-flex flex-column h-100 \">
    <main class=\"m-auto\">
        <div class=\"card text-white bg-danger\">
            <h3 class=\"card-header text-center\">An exception occurred in shop\'s script</h3>
            <div class=\"card-body bg-white text-dark\">
                <ul class=\"list-group list-group-flush\">
                    <li class=\"list-group-item\"><strong>Error type:</strong> <code><?php echo $mErrorType; ?></code></li>
                    <li class=\"list-group-item\"><strong>Source, line:</strong> <code><?php echo $mErrorFile; ?></code></li>
                    <li class=\"list-group-item\"><strong>Error message:</strong> <code><?php echo $mError; ?></code> </li>
                </ul>                                
                <pre class=\"pre-scrollable my-2\" style=\"white-space: pre-wrap\"> <?php echo $mErrorInfo; ?> </pre>
            </div>
            <div class=\"card-footer bg-light text-muted text-right\">
                <?php echo date(\"H:i:s d-m-Y\"); ?>   
            </div>  
        </div>        
    </main>
    <footer class=\"footer mt-auto py-3 bg-light\">
        <div class=\"container\">
            <div class=\"d-flex justify-content-between\">
                <span class=\"text-muted mr-1\">Powered by Melbis Shop <?php echo SCRIPT_VERSION.\'.\'.SCRIPT_BUILD; ?></span>
                <span class=\"text-muted\"><a href=\"https://melbis.com\" target=\"_blank\">https://melbis.com</a></span>
            </div>            
        </div>
    </footer>  
  </body>
</html>
<?php

    // Now stop all scripts 
    exit;
}


?>','2025-03-31 15:44:40');
INSERT INTO `ms_user_file_version` VALUES ('444','1','./../units/melbis_inc.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff         
 **************************************************************************************************/

// Core
require_once(\'core/core.php\');
 
// PHP error control
error_reporting(E_ALL);  
ini_set(\'display_errors\', \'off\');      
set_error_handler(function ($mError, $mMessage, $mFile, $mLine) 
    {    
        $error = error_reporting();
        if ( $error !== 0 && $error != 4437 ) 
            MELBIS_INC_halt(\'PHP Runtime Exception\', $mFile.\' : \'.$mLine, $mMessage); 
    });
register_shutdown_function(function ()
    {
        $error = error_get_last();
        if ( isset($error) && ( $error[\"type\"] == E_ERROR || $error[\"type\"] == E_WARNING || $error[\"type\"] == E_PARSE ) )
            MELBIS_INC_halt(\'PHP Shutdown Exception\', $error[\"file\"].\' : \'.$error[\"line\"], $error[\"message\"]); 
    });

// Set Local Setting 
if ( strlen(SHOP_LOCALE) > 0 ) setlocale(LC_CTYPE, SHOP_LOCALE); 
if ( strlen(SHOP_CHARSET) > 0 ) mb_internal_encoding(SHOP_CHARSET);

// Autoload class
if ( !function_exists(\'MELBIS_INC_autoload\') ) 
{
    function MELBIS_INC_autoload($mClassName)
    {        
        require_once(\'core/class/class.\'.$mClassName.\'.php\');
    }

    spl_autoload_register(\'MELBIS_INC_autoload\');
}


// Set path of shop on the domain, for sample: \"www.site.com/shop\", right path is \"/shop/\"
$gSitePath = \'/\'; 

// For switch off caching system set the value \"false\", it\'s useful in developing process
$gUseCache = false;

// Set default shop template
$gTemplate = TEMPLATE;

// Set current build counter
$gBuild = 1;

// GET vars array
$gGet = $_GET;

// POST vars array
$gPost = $_POST;

// FILES vars array
$gFiles = $_FILES;

// SERVER vars array
$gServer = $_SERVER;


 // Shop available?
 if ( file_exists(\'shop.lock\') ) 
 {
     MELBIS_INC_halt(\'SHOP LOCKED\', __FILE__.\':\'.__LINE__, \'Shop locked!\', \'shop.lock\');
 } 
 

/** 
 * Function MELBIS_INC
 * Manual include module
 **/                  
function MELBIS_INC($mInclude) 
{
    if ( file_exists(\'units/\'.$mInclude.\'.php\') )
    {
        require_once(\'units/\'.$mInclude.\'.php\');
    
        return true;
    }
    else 
    {
        MELBIS_INC_halt(\'INCLUDE ABSENT\', __FILE__.\':\'.__LINE__, \'Require include is absent!\', \'units/\'.$mInclude.\'.php\');
    }
} 


/** 
 * Function MELBIS_INC_halt
 * Returm info message about error and die
 **/    
function MELBIS_INC_halt($mErrorType, $mErrorFile, $mError, $mErrorInfo = \'\') 
{
    // So, print error message 
?>    
<!doctype html>
<html lang=\"en\" class=\"h-100\">
  <head>
    <meta charset=\"utf-8\">
    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1, shrink-to-fit=no\">
    <link rel=\"stylesheet\" href=\"<?php echo \'/templates/\'.TEMPLATE.\'/bootstrap.css\'; ?>\">
    <title>System error in Melbis Shop <?php echo SCRIPT_VERSION.\'.\'.SCRIPT_BUILD; ?></title>
  </head>
  <body class=\"d-flex flex-column h-100 \">
    <main class=\"m-auto\">
        <div class=\"card text-white bg-danger\">
            <h3 class=\"card-header text-center\">An exception occurred in shop\'s script</h3>
            <div class=\"card-body bg-white text-dark\">
                <ul class=\"list-group list-group-flush\">
                    <li class=\"list-group-item\"><strong>Error type:</strong> <code><?php echo $mErrorType; ?></code></li>
                    <li class=\"list-group-item\"><strong>Source, line:</strong> <code><?php echo $mErrorFile; ?></code></li>
                    <li class=\"list-group-item\"><strong>Error message:</strong> <code><?php echo $mError; ?></code> </li>
                </ul>                                
                <pre class=\"pre-scrollable my-2\" style=\"white-space: pre-wrap\"> <?php echo $mErrorInfo; ?> </pre>
            </div>
            <div class=\"card-footer bg-light text-muted text-right\">
                <?php echo date(\"H:i:s d-m-Y\"); ?>   
            </div>  
        </div>        
    </main>
    <footer class=\"footer mt-auto py-3 bg-light\">
        <div class=\"container\">
            <div class=\"d-flex justify-content-between\">
                <span class=\"text-muted mr-1\">Powered by Melbis Shop <?php echo SCRIPT_VERSION.\'.\'.SCRIPT_BUILD; ?></span>
                <span class=\"text-muted\"><a href=\"https://melbis.com\" target=\"_blank\">https://melbis.com</a></span>
            </div>            
        </div>
    </footer>  
  </body>
</html>
<?php

    // Now stop all scripts 
    exit;
}


?>','2025-03-31 15:44:53');
INSERT INTO `ms_user_file_version` VALUES ('445','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate(); 
    
    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                   ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"dd.mm.Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 15:49:05');
INSERT INTO `ms_user_file_version` VALUES ('446','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate(); 
    
    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                   ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"d.m.Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 15:49:17');
INSERT INTO `ms_user_file_version` VALUES ('447','1','./../templates/default/melbis.js','


// Serialize Object
$.fn.melbis_serial = function()
{
   var o = {};
   var a = this.serializeArray();
   $.each(a, function() {
       if (o[this.name]) {
           if (!o[this.name].push) {
               o[this.name] = [o[this.name]];
           }
           o[this.name].push(this.value || \'\');
       } else {
           o[this.name] = this.value || \'\';
       }
   });   
   
   return o;
};


// Numbers round and format
function melbis_num(n, c)
{
    var n = n, 
    c = isNaN(c = Math.abs(c)) ? 2 : c, 
    d = d == undefined ? \".\" : d, 
    t = t == undefined ? \"\'\" : t, 
    s = n < 0 ? \"-\" : \"\", 
    i = parseInt(n = Math.abs(+n || 0).toFixed(c)) + \"\", 
    j = (j = i.length) > 3 ? j % 3 : 0;
   return s + (j ? i.substr(0, j) + t : \"\") + i.substr(j).replace(/(\\d{3})(?=\\d)/g, \"$1\" + t) + (c ? d + Math.abs(n - i).toFixed(c).slice(2) : \"\");
}


','2025-03-31 15:50:56');
INSERT INTO `ms_user_file_version` VALUES ('448','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">


// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card-body\').find(\'h5\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 15:51:03');
INSERT INTO `ms_user_file_version` VALUES ('449','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">


// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card-header\')text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 15:51:59');
INSERT INTO `ms_user_file_version` VALUES ('450','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">


// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card-header\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 15:52:22');
INSERT INTO `ms_user_file_version` VALUES ('451','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">


// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\')..text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 15:53:03');
INSERT INTO `ms_user_file_version` VALUES ('452','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">


// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 15:53:21');
INSERT INTO `ms_user_file_version` VALUES ('453','1','./../templates/default/units/melbis_base_page/content_goods.htm','<div class=\"container-fluid mb-5 melbis_css_max_width\">

    {MELBIS:melbis_store_topic([MS:PAGE:ID])}

</div>','2025-03-31 16:01:06');
INSERT INTO `ms_user_file_version` VALUES ('454','1','./../templates/default/units/melbis_base_page/content_goods.htm','<div class=\"container-fluid mb-5 melbis_css_max_width\">

    {1MELBIS:melbis_store_topic([MS:PAGE:ID])}

</div>','2025-03-31 16:01:13');
INSERT INTO `ms_user_file_version` VALUES ('455','1','./../templates/default/units/melbis_base_page/content_goods.htm','<div class=\"container-fluid mb-5 melbis_css_max_width\">

    {MELBIS:melbis_store_topic([MS:PAGE:ID])}

</div>','2025-03-31 16:01:18');
INSERT INTO `ms_user_file_version` VALUES ('456','1','./../templates/default/units/melbis_store_topic/item.htm','<div class=\"col-lg-4 col-md-6 mb-3\">
    {MELBIS:melbis_store_card([MS:VAR:LANG],[ID])}
</div>','2025-03-31 16:01:58');
INSERT INTO `ms_user_file_version` VALUES ('457','1','./../templates/default/units/melbis_store_topic/item.htm','<div class=\"col mb-4\">
    {MELBIS:melbis_store_card([MS:VAR:LANG],[ID])}
</div>','2025-03-31 16:02:49');
INSERT INTO `ms_user_file_version` VALUES ('458','1','./../templates/default/units/melbis_store_topic/main.htm','<div class=\"row row-cols-2 row-cols-xl-4 melbis_goods\">
    {ITEM}
</div>

<div class=\"container\">
    <div class=\"row melbis_goods\">
        {ITEM}
    </div>
</div>','2025-03-31 16:02:51');
INSERT INTO `ms_user_file_version` VALUES ('459','1','./../templates/default/units/melbis_store_topic/main.htm','<div class=\"row row-cols-2 row-cols-xl-4 melbis_goods\">
    {ITEM}
</div>
','2025-03-31 16:02:56');
INSERT INTO `ms_user_file_version` VALUES ('460','1','./../units/melbis_store_topic.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_TOPIC
 **/
function MELBIS_STORE_TOPIC($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
            
    // Get random goods
    $id = $mVars[\'topic_id\']*1;  
    
    $command = \"SELECT s.id
                  FROM {DBNICK}_store s
                  JOIN {DBNICK}_topic_store ts
                    ON s.id = ts.store_id
                 WHERE s.no_visible = 0
                   AND ts.topic_id = \'$id\'
              ORDER BY ts.pos
                 LIMIT 1000 
                \";                    
    $goods = $gParser->SqlSelect(__LINE__, $command);
    if ( count($goods) == 0 ) $gParser->TplAssign($tpl, \'ITEM\', \'\');
    foreach ( $goods as $item )
    {
        $gParser->TplAssign($tpl, \'ID\', $item[\'id\']);
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }    
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 16:11:30');
INSERT INTO `ms_user_file_version` VALUES ('461','1','./../units/melbis_store_topic.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_TOPIC
 **/
function MELBIS_STORE_TOPIC($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
            
    // Get random goods
    $id = $mVars[\'topic_id\']*1;  
    
    $command = \"WITH RECURSIVE topic_tree AS ( 
                    SELECT *
                      FROM {DBNICK}_topic
                     WHERE id = \'$id\'
                     UNION ALL     
                    SELECT t.* 
                      FROM {DBNICK}_topic t
                      JOIN topic_tree tt 
                        ON t.tindex = tt.id
                     WHERE t.kind_key = \'kGoods\')                  
                SELECT s.name 
                  FROM topic_tree tt
                  JOIN {DBNICK}_topic_store ts
                    ON ts.topic_id = tt.id
                  JOIN {DBNICK}_store s
                    ON ts.store_id = s.id
                 WHERE s.no_visible = 0 
              ORDER BY tt.absindex, ts.pos
                 LIMIT 100 
                \";                    
    $goods = $gParser->SqlSelect(__LINE__, $command);
    if ( count($goods) == 0 ) $gParser->TplAssign($tpl, \'ITEM\', \'\');
    foreach ( $goods as $item )
    {
        $gParser->TplAssign($tpl, \'ID\', $item[\'id\']);
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }    
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 16:24:19');
INSERT INTO `ms_user_file_version` VALUES ('462','1','./../units/melbis_store_topic.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_TOPIC
 **/
function MELBIS_STORE_TOPIC($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
            
    // Get random goods
    $id = $mVars[\'topic_id\']*1;  
    
    $command = \"WITH RECURSIVE topic_tree AS ( 
                    SELECT *
                      FROM {DBNICK}_topic
                     WHERE id = \'$id\'
                     UNION ALL     
                    SELECT t.* 
                      FROM {DBNICK}_topic t
                      JOIN topic_tree tt 
                        ON t.tindex = tt.id
                     WHERE t.kind_key = \'kGoods\')                  
                SELECT s.id 
                  FROM topic_tree tt
                  JOIN {DBNICK}_topic_store ts
                    ON ts.topic_id = tt.id
                  JOIN {DBNICK}_store s
                    ON ts.store_id = s.id
                 WHERE s.no_visible = 0 
              ORDER BY tt.absindex, ts.pos
                 LIMIT 100 
                \";                    
    $goods = $gParser->SqlSelect(__LINE__, $command);
    if ( count($goods) == 0 ) $gParser->TplAssign($tpl, \'ITEM\', \'\');
    foreach ( $goods as $item )
    {
        $gParser->TplAssign($tpl, \'ID\', $item[\'id\']);
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }    
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 16:24:46');
INSERT INTO `ms_user_file_version` VALUES ('463','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <p class=\"card-text\">{INTRO}</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>   
      <ul class=\"list-group list-group-flush\">
    <li class=\"list-group-item\">An item</li>
    <li class=\"list-group-item\">A second item</li>
    <li class=\"list-group-item\">A third item</li>
  </ul>
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-31 16:28:26');
INSERT INTO `ms_user_file_version` VALUES ('464','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 1.0
 * @copyright ...
 * @link ...
 * @author ...
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Sample DB Query
    /*
    $command = \"SELECT *
                  FROM {DBNICK}_store
                 WHERE id > \'$mVars[var_name_1]\'
              ORDER BY id
                \";                    
    $store = $gParser->SqlSelect(__LINE__, $command);
    foreach ($store as $row)
    {
        $gParser->TplAssign($tpl, array(\'ID\'   => $row[\'id\'],
                                        \'NAME\' => htmlspecialchars($row[\'name\']),
                                        \'INFO\' => $mVars[\'var_name_2\']
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }
    */

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 16:29:44');
INSERT INTO `ms_user_file_version` VALUES ('465','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <p class=\"card-text\">{INTRO}</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>
       
      <ul class=\"list-group list-group-flush\">
    <li class=\"list-group-item\">An item</li>
    <li class=\"list-group-item\">A second item</li>
    <li class=\"list-group-item\">A third item</li>
  </ul>
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-31 16:29:53');
INSERT INTO `ms_user_file_version` VALUES ('466','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate(); 
    
    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                   ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"d.m.Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 16:30:46');
INSERT INTO `ms_user_file_version` VALUES ('467','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <p class=\"card-text\">{INTRO}</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>
    {MELBIS:melbis_store_features([MS:VAR:LANG],[ID])}   
      <ul class=\"list-group list-group-flush\">
    <li class=\"list-group-item\">An item</li>
    <li class=\"list-group-item\">A second item</li>
    <li class=\"list-group-item\">A third item</li>
  </ul>
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-31 16:31:10');
INSERT INTO `ms_user_file_version` VALUES ('468','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 1.0
 * @copyright ...
 * @link ...
 * @author ...
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Sample DB Query
    /*
    $command = \"SELECT *
                  FROM {DBNICK}_store
                 WHERE id > \'$mVars[var_name_1]\'
              ORDER BY id
                \";                    
    $store = $gParser->SqlSelect(__LINE__, $command);
    foreach ($store as $row)
    {
        $gParser->TplAssign($tpl, array(\'ID\'   => $row[\'id\'],
                                        \'NAME\' => htmlspecialchars($row[\'name\']),
                                        \'INFO\' => $mVars[\'var_name_2\']
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }
    */

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 16:31:35');
INSERT INTO `ms_user_file_version` VALUES ('469','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Sample DB Query
    /*
    $command = \"SELECT *
                  FROM {DBNICK}_store
                 WHERE id > \'$mVars[var_name_1]\'
              ORDER BY id
                \";                    
    $store = $gParser->SqlSelect(__LINE__, $command);
    foreach ($store as $row)
    {
        $gParser->TplAssign($tpl, array(\'ID\'   => $row[\'id\'],
                                        \'NAME\' => htmlspecialchars($row[\'name\']),
                                        \'INFO\' => $mVars[\'var_name_2\']
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }
    */

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 16:32:01');
INSERT INTO `ms_user_file_version` VALUES ('470','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <p class=\"card-text\">{INTRO}</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>
    {MELBIS:melbis_store_features([MS:VAR:LANG],[ID])}   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-31 16:32:26');
INSERT INTO `ms_user_file_version` VALUES ('471','1','./../templates/default/units/melbis_store_features/main.htm','      <ul class=\"list-group list-group-flush\">
    <li class=\"list-group-item\">An item</li>
    <li class=\"list-group-item\">A second item</li>
    <li class=\"list-group-item\">A third item</li>
  </ul>','2025-03-31 16:32:29');
INSERT INTO `ms_user_file_version` VALUES ('472','1','./../templates/default/units/melbis_store_features/main.htm','<ul class=\"list-group list-group-flush\">
    {ITEM}
</ul>','2025-03-31 16:33:20');
INSERT INTO `ms_user_file_version` VALUES ('473','1','./../templates/default/units/melbis_store_features/item.htm','<li class=\"list-group-item\">{NAME}: <b>{VALUE}</b<</li>

','2025-03-31 16:34:02');
INSERT INTO `ms_user_file_version` VALUES ('474','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT *
                  FROM {DBNICK}_store
                 WHERE id > \'$mVars[var_name_1]\'
              ORDER BY id
                \";                    
    $store = $gParser->SqlSelect(__LINE__, $command);
    foreach ($store as $row)
    {
        $gParser->TplAssign($tpl, array(\'ID\'   => $row[\'id\'],
                                        \'NAME\' => htmlspecialchars($row[\'name\']),
                                        \'INFO\' => $mVars[\'var_name_2\']
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 16:36:40');
INSERT INTO `ms_user_file_version` VALUES ('475','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT *
                  FROM {DBNICK}_store
                 WHERE id > \'$mVars[var_name_1]\'
              ORDER BY id
                \";                    
    $store = $gParser->SqlSelect(__LINE__, $command);
    foreach ($store as $row)
    {
        $gParser->TplAssign($tpl, array(\'ID\'   => $row[\'id\'],
                                        \'NAME\' => htmlspecialchars($row[\'name\']),
                                        \'INFO\' => $mVars[\'var_name_2\']
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 16:45:23');
INSERT INTO `ms_user_file_version` VALUES ('476','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT *
                  FROM {DBNICK}_store
                 WHERE id > \'$mVars[var_name_1]\'
              ORDER BY id
                \";                    
    $store = $gParser->SqlSelect(__LINE__, $command);
    foreach ($store as $row)
    {
        $gParser->TplAssign($tpl, array(\'ID\'   => $row[\'id\'],
                                        \'NAME\' => htmlspecialchars($row[\'name\']),
                                        \'INFO\' => $mVars[\'var_name_2\']
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 16:46:24');
INSERT INTO `ms_user_file_version` VALUES ('477','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT MAX(i.name) AS name, MAX(i.type_key) AS type_key, 
                       MAX(si.value_dec) AS value_dec, MAX(si.value_txt) AS value_txt, 
                       GROUP_CONCAT(iv.name SEPARATOR \', \') AS value_set
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = 4
                   AND i.in_topic = 1   
              GROUP BY i.id
              ORDER BY i.absindex
                \";                    
    $list = $gParser->SqlSelect(__LINE__, $command);
    foreach ($list as $row)
    {           
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value = $row[\'value_txt\'];
                break;
            case \'kDecimal\':
                $value = $row[\'value_dec\'];
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
            default: 
                continue;
        }    
        $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'name\']),
                                        \'VALUE\' => $mVars[\'var_name_2\']
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 16:55:28');
INSERT INTO `ms_user_file_version` VALUES ('478','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT MAX(i.name) AS name, MAX(i.type_key) AS type_key, 
                       MAX(si.value_dec) AS value_dec, MAX(si.value_txt) AS value_txt, 
                       GROUP_CONCAT(iv.name SEPARATOR \', \') AS value_set
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = 4
                   AND i.in_topic = 1   
              GROUP BY i.id
              ORDER BY i.absindex
                \";                    
    $list = $gParser->SqlSelect(__LINE__, $command);
    foreach ($list as $row)
    {           
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value = $row[\'value_txt\'];
                break;
            case \'kDecimal\':
                $value = $row[\'value_dec\'];
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
            default: 
                continue;
        }    
        $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'name\']),
                                        \'VALUE\' => $value
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 16:55:56');
INSERT INTO `ms_user_file_version` VALUES ('479','1','./../templates/default/units/melbis_store_features/item.htm','<li class=\"list-group-item\">{NAME}: <b>{VALUE}</b></li>

','2025-03-31 16:56:06');
INSERT INTO `ms_user_file_version` VALUES ('480','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT MAX(i.name) AS name, MAX(i.type_key) AS type_key, 
                       MAX(si.value_dec) AS value_dec, MAX(si.value_txt) AS value_txt, 
                       GROUP_CONCAT(iv.name SEPARATOR \', \') AS value_set
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = 4
                   AND i.in_topic = 1   
              GROUP BY i.id
              ORDER BY i.absindex
                \";                    
    $list = $gParser->SqlSelect(__LINE__, $command);
    foreach ($list as $row)
    {           
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value = $row[\'value_set\'];
                break;
            case \'kDecimal\':
                $value = $row[\'value_dec\'];
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
            default: 
                continue;
        }    
        $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'name\']),
                                        \'VALUE\' => $value
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 16:56:23');
INSERT INTO `ms_user_file_version` VALUES ('481','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT MAX(i.name) AS name, MAX(i.type_key) AS type_key, 
                       MAX(si.value_dec) AS value_dec, MAX(si.value_txt) AS value_txt, 
                       GROUP_CONCAT(iv.name SEPARATOR \', \') AS value_set
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = 4
                   AND i.in_topic = 1   
              GROUP BY i.id
              ORDER BY i.absindex
                \";                    
    $list = $gParser->SqlSelect(__LINE__, $command);
    foreach ($list as $row)
    {           
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value = $row[\'value_set\'];
                break;
            case \'kDecimal\':
                $value = $row[\'value_dec\'];
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
            default: 
                break;
        }    
        $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'name\']),
                                        \'VALUE\' => $value
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 16:56:44');
INSERT INTO `ms_user_file_version` VALUES ('482','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT MAX(i.name) AS name, MAX(i.type_key) AS type_key, 
                       MAX(si.value_dec) AS value_dec, MAX(si.value_txt) AS value_txt, 
                       GROUP_CONCAT(iv.name SEPARATOR \', \') AS value_set
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = 4
                   AND i.in_topic = 1   
              GROUP BY i.id
              ORDER BY i.absindex
                \";                    
    $list = $gParser->SqlSelect(__LINE__, $command);
    foreach ($list as $row)
    {           
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value = $row[\'value_set\'];
                break;
            case \'kDecimal\':
                $value = $row[\'value_dec\'];
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }    
        $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'name\']),
                                        \'VALUE\' => $value
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 16:57:28');
INSERT INTO `ms_user_file_version` VALUES ('483','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-top p-4\">
 <div style=\"position: absolute;
            bottom: 10px;
            left: 10px;
            display: flex;
            gap: 5px;\">
                <img src=\"https://via.placeholder.com/60\" class=\"thumbnail active\" onclick=\"changeImage(this)\">
                <img src=\"https://via.placeholder.com/60/ff0000\" class=\"thumbnail\" onclick=\"changeImage(this)\">
                <img src=\"https://via.placeholder.com/60/00ff00\" class=\"thumbnail\" onclick=\"changeImage(this)\">
                <img src=\"https://via.placeholder.com/60/0000ff\" class=\"thumbnail\" onclick=\"changeImage(this)\">
 </div>','2025-03-31 17:09:38');
INSERT INTO `ms_user_file_version` VALUES ('484','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-top p-4\">
 <div style=\"position: absolute;
            bottom: 10px;
            left: 10px;
            display: flex;
            gap: 5px;\">   qwqw
                <img src=\"https://via.placeholder.com/60\" class=\"thumbnail active\" onclick=\"changeImage(this)\">
                <img src=\"https://via.placeholder.com/60/ff0000\" class=\"thumbnail\" onclick=\"changeImage(this)\">
                <img src=\"https://via.placeholder.com/60/00ff00\" class=\"thumbnail\" onclick=\"changeImage(this)\">
                <img src=\"https://via.placeholder.com/60/0000ff\" class=\"thumbnail\" onclick=\"changeImage(this)\">
 </div>','2025-03-31 17:09:57');
INSERT INTO `ms_user_file_version` VALUES ('485','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-top p-4\">  wewewe
 <div style=\"position: absolute;
            bottom: 10px;
            left: 10px;
            display: flex;
            gap: 5px;\">   qwqw
                <img src=\"https://via.placeholder.com/60\" class=\"thumbnail active\" onclick=\"changeImage(this)\">
                <img src=\"https://via.placeholder.com/60/ff0000\" class=\"thumbnail\" onclick=\"changeImage(this)\">
                <img src=\"https://via.placeholder.com/60/00ff00\" class=\"thumbnail\" onclick=\"changeImage(this)\">
                <img src=\"https://via.placeholder.com/60/0000ff\" class=\"thumbnail\" onclick=\"changeImage(this)\">
 </div>','2025-03-31 17:10:11');
INSERT INTO `ms_user_file_version` VALUES ('486','1','./../templates/default/units/melbis_store_image/image.htm','<img src=\"{IMAGE_FILE}\" class=\"card-img-top p-4\">
 <div style=\"position: absolute;
            bottom: 10px;
            left: 10px;
            display: flex;
            gap: 5px;\">   qwqw
                <img src=\"https://via.placeholder.com/60\" class=\"thumbnail active\" onclick=\"changeImage(this)\">
                <img src=\"https://via.placeholder.com/60/ff0000\" class=\"thumbnail\" onclick=\"changeImage(this)\">
                <img src=\"https://via.placeholder.com/60/00ff00\" class=\"thumbnail\" onclick=\"changeImage(this)\">
                <img src=\"https://via.placeholder.com/60/0000ff\" class=\"thumbnail\" onclick=\"changeImage(this)\">
 </div>','2025-03-31 17:10:20');
INSERT INTO `ms_user_file_version` VALUES ('487','1','./../templates/default/units/melbis_store_image/image.htm','<div style=\"position: relative;\">
<img src=\"{IMAGE_FILE}\" class=\"card-img-top p-4\">
 <div style=\"position: absolute;
            bottom: 10px;
            left: 10px;
            display: flex;
            gap: 5px;\">   qwqw
                <img src=\"https://via.placeholder.com/60\" class=\"thumbnail active\" onclick=\"changeImage(this)\">
                <img src=\"https://via.placeholder.com/60/ff0000\" class=\"thumbnail\" onclick=\"changeImage(this)\">
                <img src=\"https://via.placeholder.com/60/00ff00\" class=\"thumbnail\" onclick=\"changeImage(this)\">
                <img src=\"https://via.placeholder.com/60/0000ff\" class=\"thumbnail\" onclick=\"changeImage(this)\">
 </div>
 </div>','2025-03-31 17:11:02');
INSERT INTO `ms_user_file_version` VALUES ('488','1','./../templates/default/units/melbis_store_image/image.htm','<div style=\"position: relative;\">
<img src=\"{IMAGE_FILE}\" class=\"card-img-top p-4\">
 <div style=\"position: absolute;
            bottom: 10px;
            left: 10px;
            display: flex;
            gap: 5px;\">   
                <img src=\"https://via.placeholder.com/60\" class=\"thumbnail active\" onclick=\"changeImage(this)\">
                <img src=\"https://via.placeholder.com/60/ff0000\" class=\"thumbnail\" onclick=\"changeImage(this)\">
                <img src=\"https://via.placeholder.com/60/00ff00\" class=\"thumbnail\" onclick=\"changeImage(this)\">
                <img src=\"https://via.placeholder.com/60/0000ff\" class=\"thumbnail\" onclick=\"changeImage(this)\">
 </div>
 </div>','2025-03-31 17:11:15');
INSERT INTO `ms_user_file_version` VALUES ('489','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    //$mVars[\'id\'] = 11;
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    $gParser->TplAssign($tpl, \'ADD\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');
        
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);
        foreach ($imgs as $img) 
        {
            $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'ADD\', \'.add\');
        }
         
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 17:16:25');
INSERT INTO `ms_user_file_version` VALUES ('490','1','./../templates/default/units/melbis_store_image/add.htm','<img src=\"{IMAGE_FILE}\" class=\"img-thumbnail\">','2025-03-31 17:16:47');
INSERT INTO `ms_user_file_version` VALUES ('491','1','./../templates/default/units/melbis_store_image/image.htm','<div style=\"position: relative;\">
<img src=\"{IMAGE_FILE}\" class=\"card-img-top p-4\">
 <div style=\"position: absolute;
            bottom: 10px;
            left: 10px;
            display: flex;
            gap: 5px;\">   
               {ADD}
 </div>
 </div>','2025-03-31 17:16:56');
INSERT INTO `ms_user_file_version` VALUES ('492','1','./../templates/default/units/melbis_store_image/image.htm','<div style=\"position: relative;\">
<img src=\"{IMAGE_FILE}\" class=\"card-img-top p-4\">
 <div style=\"position: absolute;
            bottom: 10px;
            left: 10px;
            display: flex;
            gap: 5px;\">   
               {ADD_IMAGE}
 </div>
 </div>','2025-03-31 17:17:44');
INSERT INTO `ms_user_file_version` VALUES ('493','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    //$mVars[\'id\'] = 11;
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    $gParser->TplAssign($tpl, \'ADD_IMAGE\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');
        
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);
        foreach ($imgs as $img) 
        {
            $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'ADD_IMAGE\', \'.add\');
        }
         
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 17:18:08');
INSERT INTO `ms_user_file_version` VALUES ('494','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    //$mVars[\'id\'] = 11;
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    $gParser->TplAssign($tpl, \'ADD_IMAGE\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');
        
        // Additional
        echo $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);
        foreach ($imgs as $img) 
        {
            $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'ADD_IMAGE\', \'.add\');
        }
         
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 17:19:20');
INSERT INTO `ms_user_file_version` VALUES ('495','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    //$mVars[\'id\'] = 11;
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    $gParser->TplAssign($tpl, \'ADD_IMAGE\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');
        
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);
        foreach ($imgs as $img) 
        {
            $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'ADD_IMAGE\', \'.add\');
        }
         
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 17:19:30');
INSERT INTO `ms_user_file_version` VALUES ('496','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    //$mVars[\'id\'] = 11;
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    $gParser->TplAssign($tpl, \'ADD_IMAGE\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');
        
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);
        foreach ($imgs as $img) 
        {
            $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'ADD_IMAGE\', \'.add\');
        }
         
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 17:20:42');
INSERT INTO `ms_user_file_version` VALUES ('497','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    //$mVars[\'id\'] = 11;
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    $gParser->TplAssign($tpl, \'ADD_IMAGE\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');
        
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);   
        print_r($imgs);
        foreach ($imgs as $img) 
        {
            $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'ADD_IMAGE\', \'.add\');
        }
         
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 17:21:03');
INSERT INTO `ms_user_file_version` VALUES ('498','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    //$mVars[\'id\'] = 11;
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    $gParser->TplAssign($tpl, \'ADD_IMAGE\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');
        
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);   
        foreach ($imgs as $img) 
        {
            $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'ADD_IMAGE\', \'.add\');
        }
         
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 17:22:53');
INSERT INTO `ms_user_file_version` VALUES ('499','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    //$mVars[\'id\'] = 11;
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    $gParser->TplAssign($tpl, \'ADD_IMAGE\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');
        
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);   
        foreach ($imgs as $img) 
        {
            echo \"DFDF\";
            $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'ADD_IMAGE\', \'.add\');
        }
         
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 17:23:20');
INSERT INTO `ms_user_file_version` VALUES ('500','1','./../templates/default/units/melbis_store_image/image.htm','<div style=\"position: relative;\">
<img src=\"{IMAGE_FILE}\" class=\"card-img-top p-4\">
 <div style=\"position: absolute;
            bottom: 10px;
            left: 10px;
            display: flex;
            gap: 5px;\">   
               {ADD_IMAGE}
    </div>
 </div>','2025-03-31 17:23:49');
INSERT INTO `ms_user_file_version` VALUES ('501','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    //$mVars[\'id\'] = 11;
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    $gParser->TplAssign($tpl, \'ADD_IMAGE\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');
        
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);   
        foreach ($imgs as $img) 
        {
            $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'ADD_IMAGE\', \'.add\');
        }
         
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 17:23:51');
INSERT INTO `ms_user_file_version` VALUES ('502','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    //$mVars[\'id\'] = 11;
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    $gParser->TplAssign($tpl, \'ADD_IMAGE\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');
        
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);   
        foreach ($imgs as $img) 
        {
            $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'ADD_IMAGE\', \'add\');
        }
         
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 17:25:12');
INSERT INTO `ms_user_file_version` VALUES ('503','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    //$mVars[\'id\'] = 11;
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    //$gParser->TplAssign($tpl, \'ADD_IMAGE\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');
        
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);   
        foreach ($imgs as $img) 
        {
            $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'ADD_IMAGE\', \'add\');
        }
         
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 17:25:27');
INSERT INTO `ms_user_file_version` VALUES ('504','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    //$mVars[\'id\'] = 11;
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    //$gParser->TplAssign($tpl, \'ADD_IMAGE\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');
        
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);   
        foreach ($imgs as $img) 
        {
            $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'ADD_IMAGE\', \'add\');
        }
         
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 17:25:36');
INSERT INTO `ms_user_file_version` VALUES ('505','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    //$mVars[\'id\'] = 11;
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    //$gParser->TplAssign($tpl, \'ADD_IMAGE\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');
        
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);   
        foreach ($imgs as $img) 
        {
            $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'ADD_IMAGE\', \'image\');
        }
         
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 17:25:59');
INSERT INTO `ms_user_file_version` VALUES ('506','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    //$mVars[\'id\'] = 11;
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    //$gParser->TplAssign($tpl, \'ADD_IMAGE\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');
        
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);   
        foreach ($imgs as $img) 
        {
            $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'ADD_IMAGE\', \'.add\');
        }
         
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 17:26:08');
INSERT INTO `ms_user_file_version` VALUES ('507','1','./../templates/default/units/melbis_store_image/add.htm','<img src=\"{IMAGE_FILE}\" class=\"img-thumbnail\">','2025-03-31 17:26:33');
INSERT INTO `ms_user_file_version` VALUES ('508','1','./../templates/default/units/melbis_store_image/add.htm','<1img src=\"{IMAGE_FILE}\" class=\"img-thumbnail\">','2025-03-31 17:26:45');
INSERT INTO `ms_user_file_version` VALUES ('509','1','./../templates/default/units/melbis_store_image/add.htm','<img src=\"{IMAGE_FILE}\" class=\"img-thumbnail\">','2025-03-31 17:26:49');
INSERT INTO `ms_user_file_version` VALUES ('510','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    //$mVars[\'id\'] = 11;
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    //$gParser->TplAssign($tpl, \'ADD_IMAGE\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');
        
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);   
        foreach ($imgs as $img) 
        {
            //$gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'ADD_IMAGE\', \'.add\');
        }
         
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 17:27:06');
INSERT INTO `ms_user_file_version` VALUES ('511','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    //$mVars[\'id\'] = 11;
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    //$gParser->TplAssign($tpl, \'ADD_IMAGE\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');
        
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);   
        foreach ($imgs as $img) 
        {
            //$gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'ADD_IMAGE\', \'.add\');
            $gParser->TplParse($tpl, \'ADD_IMAGE\', \'.add\');      
        }
         
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 17:27:41');
INSERT INTO `ms_user_file_version` VALUES ('512','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    //$mVars[\'id\'] = 11;
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    //$gParser->TplAssign($tpl, \'ADD_IMAGE\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');
        
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);   
        foreach ($imgs as $img) 
        {
            //$gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'ADD_IMAGE\', \'.add\');
            $gParser->TplParse($tpl, \'ADD_IMAGE\', \'.img\');      
        }
         
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 17:28:20');
INSERT INTO `ms_user_file_version` VALUES ('513','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    //$mVars[\'id\'] = 11;
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    //$gParser->TplAssign($tpl, \'ADD_IMAGE\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');
        
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);   
        foreach ($imgs as $img) 
        {
            //$gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'ADD_IMAGE\', \'.img\');      
        }
         
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 17:28:26');
INSERT INTO `ms_user_file_version` VALUES ('514','1','./../templates/default/units/melbis_store_image/image.htm','<div style=\"position: relative;\">
<img src=\"{IMAGE_FILE}\" class=\"card-img-top p-4\">
 <div style=\"position: absolute;
            bottom: 10px;
            left: 10px;
            display: flex;
            gap: 5px;\">   
               {IMAGES}
    </div>
 </div>','2025-03-31 17:28:35');
INSERT INTO `ms_user_file_version` VALUES ('515','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    //$mVars[\'id\'] = 11;
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    //$gParser->TplAssign($tpl, \'ADD_IMAGE\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        $gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');
        
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);   
        foreach ($imgs as $img) 
        {
            //$gParser->TplAssign($tpl, \'IMAGE_FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'IMAGES\', \'.img\');      
        }
         
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 17:28:41');
INSERT INTO `ms_user_file_version` VALUES ('516','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    //$mVars[\'id\'] = 11;
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    //$gParser->TplAssign($tpl, \'ADD_IMAGE\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        $gParser->TplAssign($tpl, \'FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');
        
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);   
        foreach ($imgs as $img) 
        {
            $gParser->TplAssign($tpl, \'FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'IMAGES\', \'.img\');      
        }
         
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 17:29:01');
INSERT INTO `ms_user_file_version` VALUES ('517','1','./../templates/default/units/melbis_store_image/image.htm','<div style=\"position: relative;\">
<img src=\"{FILE}\" class=\"card-img-top p-4\">
 <div style=\"position: absolute;
            bottom: 10px;
            left: 10px;
            display: flex;
            gap: 5px;\">   
               {IMAGES}
    </div>
 </div>','2025-03-31 17:29:06');
INSERT INTO `ms_user_file_version` VALUES ('518','1','./../templates/default/units/melbis_store_image/img.htm','<img src=\"{FILE}\" class=\"img-thumbnail\">','2025-03-31 17:29:11');
INSERT INTO `ms_user_file_version` VALUES ('519','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    //$mVars[\'id\'] = 11;
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    //$gParser->TplAssign($tpl, \'IMAGES\', \'\');
    if ( isset($hash[\'id\']) )
    {    

        
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);   
        foreach ($imgs as $img) 
        {
            $gParser->TplAssign($tpl, \'FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'IMAGES\', \'.img\');                              
        }                                                           
        
        $gParser->TplAssign($tpl, \'FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');        
         
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 17:30:14');
INSERT INTO `ms_user_file_version` VALUES ('520','1','./../templates/default/units/melbis_store_image/img.htm','<img src=\"{FILE}\" class=\"img-thumbnail\" style=\"max-width: 50px\">','2025-03-31 17:31:14');
INSERT INTO `ms_user_file_version` VALUES ('521','1','./../templates/default/units/melbis_store_image/img.htm','<img src=\"{FILE}\" class=\"img-thumbnail\" style=\"max-width: 70px\">','2025-03-31 17:31:29');
INSERT INTO `ms_user_file_version` VALUES ('522','1','./../templates/default/units/melbis_store_image/img.htm','<img src=\"{FILE}\" class=\"img-thumbnail\" style=\"width: 70px\">','2025-03-31 17:32:10');
INSERT INTO `ms_user_file_version` VALUES ('523','1','./../templates/default/units/melbis_store_image/img.htm','<img src=\"{FILE}\" class=\"img-thumbnail\" style=\"width: 50px\">','2025-03-31 17:32:42');
INSERT INTO `ms_user_file_version` VALUES ('524','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    //$mVars[\'id\'] = 11;
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    
    $gParser->TplAssign($tpl, \'IMAGES\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);   
        foreach ($imgs as $img) 
        {
            $gParser->TplAssign($tpl, \'FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'IMAGES\', \'.img\');                              
        }                                                           
                                                           
        // Base
        $gParser->TplAssign($tpl, \'FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');                 
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 17:33:17');
INSERT INTO `ms_user_file_version` VALUES ('525','1','./../templates/default/units/melbis_store_image/image.htm','<div style=\"position: relative;\">
    <img src=\"{FILE}\" class=\"card-img-top p-4\">
    <div style=\"position: absolute; bottom: 10px; left: 10px; display: flex; gap: 5px;\">   
        {IMAGES}
    </div>
</div>','2025-03-31 17:33:58');
INSERT INTO `ms_user_file_version` VALUES ('526','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var melbis_topic_id = [MS:PAGE:ID] </script>
        
        {MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main>              
        
        {SCRIPTS}
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}
    
    </body>
</html>
','2025-03-31 17:35:14');
INSERT INTO `ms_user_file_version` VALUES ('527','1','./../templates/default/units/melbis_store_image/img.htm','<img src=\"{FILE}\" class=\"img-thumbnail\" style=\"width: 50px\" onclick=\"melbis_images(this)\">','2025-03-31 17:37:03');
INSERT INTO `ms_user_file_version` VALUES ('528','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    console.log(img);


}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 17:37:52');
INSERT INTO `ms_user_file_version` VALUES ('529','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    console.log($(img));


}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 17:38:11');
INSERT INTO `ms_user_file_version` VALUES ('530','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    console.logimg);


}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 17:38:24');
INSERT INTO `ms_user_file_version` VALUES ('531','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    console.log(img);


}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 17:38:26');
INSERT INTO `ms_user_file_version` VALUES ('532','1','./../templates/default/units/melbis_store_image/img.htm','<img src=\"{FILE}\" class=\"img-thumbnail\" style=\"width: 50px\" onclick=\"melbis_images($(this))\">','2025-03-31 17:38:44');
INSERT INTO `ms_user_file_version` VALUES ('533','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    console.log(img);
}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 17:39:25');
INSERT INTO `ms_user_file_version` VALUES ('534','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    console.log(img.parents(\'img\'));
}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 17:40:49');
INSERT INTO `ms_user_file_version` VALUES ('535','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    console.log(img);
}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 17:41:08');
INSERT INTO `ms_user_file_version` VALUES ('536','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    var src = img.parents(\'div\').find(\'img:first\').attr(\'src\');         
    img.parents(\'div\').find(\'img:first\').attr(\'src\', img.attr(\'src\'))
    img.attr(\'src\', src);
}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 17:46:01');
INSERT INTO `ms_user_file_version` VALUES ('537','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    console.log(img);
    var src = img.parents(\'div\').find(\'img:first\').attr(\'src\');         
    img.parents(\'div\').find(\'img:first\').attr(\'src\', img.attr(\'src\'))
    img.attr(\'src\', src);
}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 17:46:56');
INSERT INTO `ms_user_file_version` VALUES ('538','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    console.log(img);
    var src = img.parent(\'div\').prev().attr(\'src\');         
    img.parent(\'div\').prev().attr(\'src\', img.attr(\'src\'))
    img.attr(\'src\', src);
}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 17:49:06');
INSERT INTO `ms_user_file_version` VALUES ('539','1','./../templates/default/units/melbis_store_image/img.htm','<img src=\"{FILE}\" class=\"img-thumbnail active\" style=\"width: 50px\" onclick=\"melbis_images($(this))\">','2025-03-31 17:50:07');
INSERT INTO `ms_user_file_version` VALUES ('540','1','./../templates/default/units/melbis_store_image/img.htm','<img src=\"{FILE}\" class=\"img-thumbnail\" style=\"width: 50px\" onclick=\"melbis_images($(this))\">','2025-03-31 17:50:14');
INSERT INTO `ms_user_file_version` VALUES ('541','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate(); 
    
    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                   ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"d.m.Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 17:52:02');
INSERT INTO `ms_user_file_version` VALUES ('542','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body h-100\">
        <p class=\"card-text\">{INTRO}</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>
    {MELBIS:melbis_store_features([MS:VAR:LANG],[ID])}   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-31 17:54:46');
INSERT INTO `ms_user_file_version` VALUES ('543','1','./../templates/default/units/melbis_store_topic/main.htm','<div class=\"row row-cols-2 row-cols-xl-4 melbis_goods\">
    {ITEM}
</div>
<div class=\"row row-cols-1 row-cols-md-3\">
  <div class=\"col mb-4\">
    <div class=\"card h-100\">
      <img src=\"...\" class=\"card-img-top\" alt=\"...\">
      <div class=\"card-body\">
        <h5 class=\"card-title\">Card title</h5>
        <p class=\"card-text\">This is a longer card with supporting text below as a natural lead-in to additional content. This content is a little bit longer.</p>
      </div>
    </div>
  </div>
  <div class=\"col mb-4\">
    <div class=\"card h-100\">
      <img src=\"...\" class=\"card-img-top\" alt=\"...\">
      <div class=\"card-body\">
        <h5 class=\"card-title\">Card title</h5>
        <p class=\"card-text\">This is a short card.</p>
      </div>
    </div>
  </div>
  <div class=\"col mb-4\">
    <div class=\"card h-100\">
      <img src=\"...\" class=\"card-img-top\" alt=\"...\">
      <div class=\"card-body\">
        <h5 class=\"card-title\">Card title</h5>
        <p class=\"card-text\">This is a longer card with supporting text below as a natural lead-in to additional content.</p>
      </div>
    </div>
  </div>
  <div class=\"col mb-4\">
    <div class=\"card h-100\">
      <img src=\"...\" class=\"card-img-top\" alt=\"...\">
      <div class=\"card-body\">
        <h5 class=\"card-title\">Card title</h5>
        <p class=\"card-text\">This is a longer card with supporting text below as a natural lead-in to additional content. This content is a little bit longer.</p>
      </div>
    </div>
  </div>
</div>','2025-03-31 17:56:17');
INSERT INTO `ms_user_file_version` VALUES ('544','1','./../templates/default/units/melbis_store_topic/main.htm','<div class=\"row row-cols-2 row-cols-xl-4 melbis_goods\">
    {ITEM}
</div>
<div class=\"row row-cols-1 row-cols-md-3\">
  <div class=\"col mb-4\">
    <div class=\"card h-100\">
      <img src=\"...\" class=\"card-img-top\" alt=\"...\">
      <div class=\"card-body\">
        <h5 class=\"card-title\">Card title</h5>
        <p class=\"card-text\">This is a longer card with supporting text below as a natural lead-in to additional content. This content is a little bit longer.</p>
      </div>
    </div>
  </div>
  <div class=\"col mb-4\">
    <div class=\"card \">
      <img src=\"...\" class=\"card-img-top\" alt=\"...\">
      <div class=\"card-body\">
        <h5 class=\"card-title\">Card title</h5>
        <p class=\"card-text\">This is a short card.</p>
      </div>
    </div>
  </div>
  <div class=\"col mb-4\">
    <div class=\"card h-100\">
      <img src=\"...\" class=\"card-img-top\" alt=\"...\">
      <div class=\"card-body\">
        <h5 class=\"card-title\">Card title</h5>
        <p class=\"card-text\">This is a longer card with supporting text below as a natural lead-in to additional content.</p>
      </div>
    </div>
  </div>
  <div class=\"col mb-4\">
    <div class=\"card h-100\">
      <img src=\"...\" class=\"card-img-top\" alt=\"...\">
      <div class=\"card-body\">
        <h5 class=\"card-title\">Card title</h5>
        <p class=\"card-text\">This is a longer card with supporting text below as a natural lead-in to additional content. This content is a little bit longer.</p>
      </div>
    </div>
  </div>
</div>','2025-03-31 17:56:34');
INSERT INTO `ms_user_file_version` VALUES ('545','1','./../templates/default/units/melbis_store_topic/main.htm','<div class=\"row row-cols-2 row-cols-xl-4 melbis_goods\">
    {ITEM}
</div>

<div class=\"row row-cols-2 row-cols-xl-4 melbis_goods\">
  <div class=\"col mb-4\">
    <div class=\"card h-100\">
      <img src=\"...\" class=\"card-img-top\" alt=\"...\">
      <div class=\"card-body\">
        <h5 class=\"card-title\">Card title</h5>
        <p class=\"card-text\">This is a longer card with supporting text below as a natural lead-in to additional content. This content is a little bit longer.</p>
      </div>
    </div>
  </div>
  <div class=\"col mb-4\">
    <div class=\"card h-100\">
      <img src=\"...\" class=\"card-img-top\" alt=\"...\">
      <div class=\"card-body\">
        <h5 class=\"card-title\">Card title</h5>
        <p class=\"card-text\">This is a short card.</p>
      </div>
    </div>
  </div>
  <div class=\"col mb-4\">
    <div class=\"card h-100\">
      <img src=\"...\" class=\"card-img-top\" alt=\"...\">
      <div class=\"card-body\">
        <h5 class=\"card-title\">Card title</h5>
        <p class=\"card-text\">This is a longer card with supporting text below as a natural lead-in to additional content.</p>
      </div>
    </div>
  </div>
  <div class=\"col mb-4\">
    <div class=\"card h-100\">
      <img src=\"...\" class=\"card-img-top\" alt=\"...\">
      <div class=\"card-body\">
        <h5 class=\"card-title\">Card title</h5>
        <p class=\"card-text\">This is a longer card with supporting text below as a natural lead-in to additional content. This content is a little bit longer.</p>
      </div>
    </div>
  </div>
</div>','2025-03-31 17:56:58');
INSERT INTO `ms_user_file_version` VALUES ('546','1','./../templates/default/units/melbis_store_topic/main.htm','<div class=\"row row-cols-2 row-cols-xl-4 melbis_goods\">
    {ITEM}
</div>
','2025-03-31 17:57:28');
INSERT INTO `ms_user_file_version` VALUES ('547','1','./../templates/default/units/melbis_store_topic/main.htm','<div class=\"row row-cols-2 row-cols-xl-4 melbis_goods\">
    {ITEM}
</div>
','2025-03-31 17:57:35');
INSERT INTO `ms_user_file_version` VALUES ('548','1','./../templates/default/units/melbis_store_card/main.htm','
  <div class=\"col mb-4\">
    <div class=\"card h-100\">
      <img src=\"...\" class=\"card-img-top\" alt=\"...\">
      <div class=\"card-body\">
        <h5 class=\"card-title\">Card title</h5>
        <p class=\"card-text\">This is a longer card with supporting text below as a natural lead-in to additional content. This content is a little bit longer.</p>
      </div>
    </div>
  </div>','2025-03-31 17:57:51');
INSERT INTO `ms_user_file_version` VALUES ('549','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body h-100\">
        <p class=\"card-text\">{INTRO}</p>    
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>
    {MELBIS:melbis_store_features([MS:VAR:LANG],[ID])}   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-31 17:58:29');
INSERT INTO `ms_user_file_version` VALUES ('550','1','./../templates/default/units/melbis_store_topic/item.htm','<div class=\"col mb-4\">
    {MELBIS:melbis_store_card([MS:VAR:LANG],[ID])}
</div>','2025-03-31 17:58:44');
INSERT INTO `ms_user_file_version` VALUES ('551','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate(); 
    
    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                   ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"d.m.Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 17:59:13');
INSERT INTO `ms_user_file_version` VALUES ('552','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate(); 
    
    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                   ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"d.m.Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 17:59:29');
INSERT INTO `ms_user_file_version` VALUES ('553','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <p class=\"card-text\">{INTRO}</p>
    </div>
    <div class=\"card-body\">        
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>
    {MELBIS:melbis_store_features([MS:VAR:LANG],[ID])}   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-31 18:04:06');
INSERT INTO `ms_user_file_version` VALUES ('554','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <p class=\"card-text\">{INTRO}</p>
    </div>
    <div class=\"1card-body\">        
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>
    {MELBIS:melbis_store_features([MS:VAR:LANG],[ID])}   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-31 18:05:56');
INSERT INTO `ms_user_file_version` VALUES ('555','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <p class=\"card-text\">{INTRO}</p>
    </div>
    <div class=\"card-footer \">        
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>
    {MELBIS:melbis_store_features([MS:VAR:LANG],[ID])}   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-31 18:06:26');
INSERT INTO `ms_user_file_version` VALUES ('556','1','./../units/melbis_store_topic.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_TOPIC
 **/
function MELBIS_STORE_TOPIC($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
            
    // Get random goods
    $id = $mVars[\'topic_id\']*1;  
    
    $command = \"WITH RECURSIVE topic_tree AS ( 
                    SELECT *
                      FROM {DBNICK}_topic
                     WHERE id = \'$id\'
                     UNION ALL     
                    SELECT t.* 
                      FROM {DBNICK}_topic t
                      JOIN topic_tree tt 
                        ON t.tindex = tt.id
                     WHERE t.kind_key = \'kGoods\')                  
                SELECT s.id 
                  FROM topic_tree tt
                  JOIN {DBNICK}_topic_store ts
                    ON ts.topic_id = tt.id
                  JOIN {DBNICK}_store s
                    ON ts.store_id = s.id
                 WHERE s.no_visible = 0 
              ORDER BY tt.absindex, ts.pos
                 LIMIT 100 
                \";                    
    $goods = $gParser->SqlSelect(__LINE__, $command);
    if ( count($goods) == 0 ) $gParser->TplAssign($tpl, \'ITEM\', \'\');
    foreach ( $goods as $item )
    {
        $gParser->TplAssign($tpl, \'ID\', $item[\'id\']);
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }    
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 18:13:36');
INSERT INTO `ms_user_file_version` VALUES ('557','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);                                                     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM {DBNICK}_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");           
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';         
        $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {           
        // Page vars
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = $topic[\'id\'];  
        $gParser->gVars[\'ms\'][\'page\'][\'title\'] = $topic[\'name\']; //MELBIS_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');
                
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM {DBNICK}_store s
                          JOIN {DBNICK}_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                $gParser->gVars[\'ms\'][\'page\'][\'intro\'] = MELBIS_INC_LANG(\'kTopic\', \'INTRO\', $page[\'id\'], $page[\'intro\']);
                $descr = MELBIS_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                $gParser->TplAssign($tpl, [\'ID\'     => $topic[\'id\'], 
                                           \'DESCR\'  => MELBIS_INC_STD_text($descr)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {                       
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 18:17:39');
INSERT INTO `ms_user_file_version` VALUES ('558','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);                                                     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM {DBNICK}_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");           
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';         
        $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {                           
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM {DBNICK}_store s
                          JOIN {DBNICK}_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                $gParser->gVars[\'ms\'][\'page\'][\'intro\'] = MELBIS_INC_LANG(\'kTopic\', \'INTRO\', $page[\'id\'], $page[\'intro\']);
                $descr = MELBIS_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                $gParser->TplAssign($tpl, [\'ID\'     => $topic[\'id\'], 
                                           \'DESCR\'  => MELBIS_INC_STD_text($descr)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {                  
            $gParser->gVars[\'ms\'][\'page\'][\'id\'] = $topic[\'id\'];  
            $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG(\'kTopic\', \'NAME\', $topic[\'id\'], $topic[\'name\']);
                                     
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 18:21:03');
INSERT INTO `ms_user_file_version` VALUES ('559','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);                                                     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM {DBNICK}_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");           
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';         
        $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {                           
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM {DBNICK}_store s
                          JOIN {DBNICK}_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content   
                $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                $gParser->gVars[\'ms\'][\'page\'][\'intro\'] = MELBIS_INC_LANG(\'kTopic\', \'INTRO\', $page[\'id\'], $page[\'intro\']);
                $descr = MELBIS_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                $gParser->TplAssign($tpl, [\'ID\'     => $topic[\'id\'], 
                                           \'DESCR\'  => MELBIS_INC_STD_text($descr)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {                  
            $gParser->gVars[\'ms\'][\'page\'][\'id\'] = $topic[\'id\'];  
            $gParser->gVars[\'ms\'][\'page\'][\'path\'] = $topic[\'path\'];
            $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG(\'kTopic\', \'NAME\', $topic[\'id\'], $topic[\'name\']);
                                     
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 18:22:08');
INSERT INTO `ms_user_file_version` VALUES ('560','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);                                                     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM {DBNICK}_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");           
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';         
        $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {                           
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM {DBNICK}_store s
                          JOIN {DBNICK}_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content
                $gParser->gVars[\'ms\'][\'page\'][\'path\'] = $topic[\'path\'];   
                $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                $gParser->gVars[\'ms\'][\'page\'][\'intro\'] = MELBIS_INC_LANG(\'kTopic\', \'INTRO\', $page[\'id\'], $page[\'intro\']);
                $descr = MELBIS_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                $gParser->TplAssign($tpl, [\'ID\'     => $topic[\'id\'], 
                                           \'DESCR\'  => MELBIS_INC_STD_text($descr)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {                  
            $gParser->gVars[\'ms\'][\'page\'][\'id\'] = $topic[\'id\'];  
            $gParser->gVars[\'ms\'][\'page\'][\'path\'] = $topic[\'path\'];
            $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG(\'kTopic\', \'NAME\', $topic[\'id\'], $topic[\'name\']);
                                     
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 18:22:49');
INSERT INTO `ms_user_file_version` VALUES ('561','1','./../templates/default/units/melbis_base_head/main.htm','<head>
    <meta charset=\"{CHARSET}\">          
    <meta name=\"generator\" content=\"Melbis Shop v6.4.0\">        
    <meta name=\"author\" content=\"KasDim\">
    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1, shrink-to-fit=no\">  
    <meta http-equiv=\"Last-Modified\" content=\"{LASTMODIFY}\">                    
    <title>{MS:PAGE:TITLE}</title>
    <meta name=\"robots\" content=\"index,follow\">

    <link rel=\"canonical\" href=\"https://{CONST:MELBIS_SHOP_DOMAIN}/{MS:VAR:LANG}{MS:PAGE:PATH}\">
    <link rel=\"alternate\" hreflang=\"x-default\" href=\"https://{CONST:MELBIS_SHOP_DOMAIN}/en{MS:PAGE:PATH}\" />
    {ALTER}     

    <link rel=\"icon\" href=\"{PATH}/images/demo_logo.png\"> 
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/bootstrap.css\">  
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/icons/css/all.css\">
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/melbis.css?{BUILD}\">

    <script src=\"{PATH}/jquery.js\"></script>      
    <script src=\"{PATH}/bootstrap.js\"></script>
    <script src=\"{PATH}/bootbox.js\"></script>
    <script src=\"{PATH}/melbis.js?{BUILD}\"></script>       
</head>','2025-03-31 18:23:35');
INSERT INTO `ms_user_file_version` VALUES ('562','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);                                                     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM {DBNICK}_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");           
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';         
        $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {                           
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM {DBNICK}_store s
                          JOIN {DBNICK}_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content
                $gParser->gVars[\'ms\'][\'page\'][\'path\'] = $topic[\'path\'];   
                $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                $descr = MELBIS_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                $gParser->TplAssign($tpl, [\'ID\'     => $topic[\'id\'], 
                                           \'DESCR\'  => MELBIS_INC_STD_text($descr)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {                  
            $gParser->gVars[\'ms\'][\'page\'][\'id\'] = $topic[\'id\'];  
            $gParser->gVars[\'ms\'][\'page\'][\'path\'] = $topic[\'path\'];
            $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG(\'kTopic\', \'NAME\', $topic[\'id\'], $topic[\'name\']);
                                     
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 18:23:44');
INSERT INTO `ms_user_file_version` VALUES ('563','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <p class=\"card-text\">{INTRO}</p>
    </div>
    <div class=\"card-footer \">        
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>
    {1MELBIS:melbis_store_features([MS:VAR:LANG],[ID])}   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-31 18:45:13');
INSERT INTO `ms_user_file_version` VALUES ('564','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <p class=\"card-text\">{INTRO}</p>
    </div>
    <div class=\"card-footer \">        
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>
    {MELBIS:melbis_store_features([MS:VAR:LANG],[ID])}   
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-31 18:45:20');
INSERT INTO `ms_user_file_version` VALUES ('565','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT MAX(i.name) AS name, MAX(i.type_key) AS type_key, 
                       MAX(si.value_dec) AS value_dec, MAX(si.value_txt) AS value_txt, 
                       GROUP_CONCAT(iv.name SEPARATOR \', \') AS value_set
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              GROUP BY i.id
              ORDER BY i.absindex
                \";                    
    $list = $gParser->SqlSelect(__LINE__, $command);
    foreach ($list as $row)
    {           
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value = $row[\'value_set\'];
                break;
            case \'kDecimal\':
                $value = $row[\'value_dec\'];
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }    
        $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'name\']),
                                        \'VALUE\' => $value
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 18:45:34');
INSERT INTO `ms_user_file_version` VALUES ('566','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <p class=\"card-text\">{INTRO}</p>
    </div>
    {MELBIS:melbis_store_features([MS:VAR:LANG],[ID])}
    <div class=\"card-footer \">        
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> Add to Basket</button>
        </div>
    </div>       
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">Last updated {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-31 18:46:37');
INSERT INTO `ms_user_file_version` VALUES ('567','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate(); 
    
    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                    ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'NAME\'       => htmlspecialchars($item[\'name\']),
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'INTRO\'      => htmlspecialchars($item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"d.m.Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 18:48:58');
INSERT INTO `ms_user_file_version` VALUES ('568','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate(); 
    
    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                    ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'NAME\'       => MELBIS_INC_LANG(\'kStore\', \'NAME\', $item[\'id\'], $item[\'name\']),                               
                               \'INTRO\'      => MELBIS_INC_LANG(\'kStore\', \'INTRO\', $item[\'id\'], $item[\'intro\']),
                               \'STATUS\'     => htmlspecialchars($item[\'status_name\']),
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"d.m.Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 18:57:06');
INSERT INTO `ms_user_file_version` VALUES ('569','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate(); 
    
    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                    ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'NAME\'       => MELBIS_INC_LANG(\'kStore\', \'NAME\', $item[\'id\'], $item[\'name\']),                               
                               \'INTRO\'      => MELBIS_INC_LANG(\'kStore\', \'INTRO\', $item[\'id\'], $item[\'intro\']),
                               \'STATUS\'     => MELBIS_INC_LANG_tag(\'STATUS\', $item[\'status_key\']); 
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"d.m.Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 19:07:45');
INSERT INTO `ms_user_file_version` VALUES ('570','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate(); 
    
    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                    ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'NAME\'       => MELBIS_INC_LANG(\'kStore\', \'NAME\', $item[\'id\'], $item[\'name\']),                               
                               \'INTRO\'      => MELBIS_INC_LANG(\'kStore\', \'INTRO\', $item[\'id\'], $item[\'intro\']),
                               \'STATUS\'     => MELBIS_INC_LANG_tag(\'STATUS\', $item[\'status_key\']); 
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"d.m.Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 19:08:00');
INSERT INTO `ms_user_file_version` VALUES ('571','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate(); 
    
    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                    ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'NAME\'       => MELBIS_INC_LANG(\'kStore\', \'NAME\', $item[\'id\'], $item[\'name\']),                               
                               \'INTRO\'      => MELBIS_INC_LANG(\'kStore\', \'INTRO\', $item[\'id\'], $item[\'intro\']),
                               \'STATUS\'     => MELBIS_INC_LANG_tag(\'STATUS\', $item[\'status_key\']), 
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"d.m.Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 19:08:16');
INSERT INTO `ms_user_file_version` VALUES ('572','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT MAX(i.name) AS name, MAX(i.type_key) AS type_key, 
                       MAX(si.value_dec) AS value_dec, MAX(si.value_txt) AS value_txt, 
                       GROUP_CONCAT(iv.name SEPARATOR \', \') AS value_set
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              GROUP BY i.id
              ORDER BY i.absindex
                \";                    
    $list = $gParser->SqlSelect(__LINE__, $command);
    foreach ($list as $row)
    {           
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value = $row[\'value_set\'];
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }    
        $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'name\']),
                                        \'VALUE\' => $value
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 19:12:15');
INSERT INTO `ms_user_file_version` VALUES ('573','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <p class=\"card-text\">{INTRO}</p>
    </div>
    {MELBIS:melbis_store_features([MS:VAR:LANG],[ID])}
    <div class=\"card-footer \">        
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> {TAG_ADD}</button>
        </div>
    </div>       
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">{TAG_UPDATE} {UPDATE}</small>
        <span class=\"badge badge-info float-right\">Code: {CODE}</span>
    </div>  
</div>
','2025-03-31 19:20:31');
INSERT INTO `ms_user_file_version` VALUES ('574','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <p class=\"card-text\">{INTRO}</p>
    </div>
    {MELBIS:melbis_store_features([MS:VAR:LANG],[ID])}
    <div class=\"card-footer \">        
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">${PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> {TAG_ADD}</button>
        </div>
    </div>       
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">{TAG_UPDATE} {UPDATE}</small>
        <span class=\"badge badge-info float-right\">{TAG_CODE}: {CODE}</span>
    </div>  
</div>
','2025-03-31 19:20:56');
INSERT INTO `ms_user_file_version` VALUES ('575','1','./../units/melbis_store_card.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_CARD($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate(); 
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);                                     
    
    // Get goods                  
    $command = \"SELECT s.*,
                       IF(c.id IS NULL, s.price, 
                        IF(c.division = 0, s.price*c.multiplex,
                         IF(c.multiplex <> 0, s.price/c.multiplex, 0))) AS price_curr,
                       kv.value_txt status_name                            
                  FROM {DBNICK}_store s
             LEFT JOIN {DBNICK}_currency c
                    ON c.id = s.price_curr_id             
             LEFT JOIN {DBNICK}_key_value kv
                    ON ( s.status_key = kv.key_name AND kv.key_code = \'STORE_STATUS_KEY\' )                                  
                 WHERE s.id = \'$mVars[id]\'
              ORDER BY id
                \";                    
    $item = $gParser->SqlSelectToArray(__LINE__, $command);
    $gParser->TplAssign($tpl, [\'ID\'         => $item[\'id\'],                               
                               \'CODE\'       => htmlspecialchars($item[\'code_shop\']),
                               \'NAME\'       => MELBIS_INC_LANG(\'kStore\', \'NAME\', $item[\'id\'], $item[\'name\']),                               
                               \'INTRO\'      => MELBIS_INC_LANG(\'kStore\', \'INTRO\', $item[\'id\'], $item[\'intro\']),
                               \'STATUS\'     => MELBIS_INC_LANG_tag(\'STATUS\', $item[\'status_key\']), 
                               \'PRICE\'      => MELBIS_INC_STD_number($item[\'price_curr\'], 2),
                               \'UPDATE\'     => date(\"d.m.Y\", strtotime($item[\'update_time\'])),                                        
                               ]);   
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 19:22:07');
INSERT INTO `ms_user_file_version` VALUES ('576','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT i.name, i.type_key, 
                       si.value_dec, si.value_txt, si.value_id, si.info_id, 
                       iv.name 
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              ORDER BY i.absindex
                \";                    
    $list = $gParser->SqlSelect(__LINE__, $command);
    foreach ($list as $row)
    {           
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value = $row[\'value_set\'];
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }    
        $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'name\']),
                                        \'VALUE\' => $value
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 20:06:36');
INSERT INTO `ms_user_file_version` VALUES ('577','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT i.name AS info_name, i.type_key, 
                       si.value_dec, si.value_txt, si.value_id, si.info_id, 
                       iv.name AS value_name 
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              ORDER BY i.absindex
                \";                    
    $list = $gParser->SqlSelect(__LINE__, $command);
    foreach ($list as $row)
    {           
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value = $row[\'value_name\'];
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }    
        $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'info_name\']),
                                        \'VALUE\' => $value
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 20:07:23');
INSERT INTO `ms_user_file_version` VALUES ('578','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT i.name AS info_name, i.type_key, 
                       si.value_dec, si.value_txt, si.value_id, si.info_id, 
                       iv.name AS value_name 
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              ORDER BY i.absindex
                \";                    
    $list = $gParser->SqlSelect(__LINE__, $command);
    $value_id = 0;
    foreach ($list as $row)
    {           
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value = $row[\'value_name\'];
                $value_id = $row[\'value_id\'];
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }    
        $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'info_name\']),
                                        \'VALUE\' => $value
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 20:10:08');
INSERT INTO `ms_user_file_version` VALUES ('579','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT i.name AS info_name, i.type_key, 
                       si.value_dec, si.value_txt, si.value_id, si.info_id, 
                       iv.name AS value_name 
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              ORDER BY i.absindex
                \";                    
    $list = $gParser->SqlSelect(__LINE__, $command);
    $value_id = 0;
    foreach ($list as $row)
    {           
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value = $row[\'value_name\'];
                $value_id = $row[\'value_id\'];
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }    
        $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'info_name\']),
                                        \'VALUE\' => $value
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 20:11:10');
INSERT INTO `ms_user_file_version` VALUES ('580','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT i.name AS info_name, i.type_key, 
                       si.value_dec, si.value_txt, si.value_id, si.info_id, 
                       iv.name AS value_name 
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              ORDER BY i.absindex
                \";                    
    $list = $gParser->SqlSelect(__LINE__, $command);
    $info_id = 0;
    foreach ($list as $row)
    {           
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value = $row[\'value_name\'];
                $info_id = $row[\'info_id\'];
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }    
        $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'info_name\']),
                                        \'VALUE\' => $value
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 20:13:30');
INSERT INTO `ms_user_file_version` VALUES ('581','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT MAX(i.name) AS name, MAX(i.type_key) AS type_key, 
                       MAX(si.value_dec) AS value_dec, MAX(si.value_txt) AS value_txt, 
                       GROUP_CONCAT(iv.name SEPARATOR \', \') AS value_set
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              GROUP BY i.id
              ORDER BY i.absindex
                \";                    
    $list = $gParser->SqlSelect(__LINE__, $command);
    foreach ($list as $row)
    {           
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value = $row[\'value_set\'];
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }    
        $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'name\']),
                                        \'VALUE\' => $value
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 20:16:52');
INSERT INTO `ms_user_file_version` VALUES ('582','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT MAX(i.name) AS name, MAX(i.type_key) AS type_key, 
                       MAX(si.value_dec) AS value_dec, MAX(si.value_txt) AS value_txt, 
                       GROUP_CONCAT(iv.name SEPARATOR \'|\') AS value_set
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              GROUP BY i.id
              ORDER BY i.absindex
                \";                    
    $list = $gParser->SqlSelect(__LINE__, $command);
    foreach ($list as $row)
    {           
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value = $row[\'value_set\'];
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }    
        $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'name\']),
                                        \'VALUE\' => $value
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 20:16:58');
INSERT INTO `ms_user_file_version` VALUES ('583','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT i.name AS info_name, i.type_key, 
                       si.value_dec, si.value_txt, si.value_id, si.info_id, 
                       iv.name AS value_name 
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              ORDER BY i.absindex
                \";                    
    $query = $gParser->SqlQuery(__LINE__, $command);
    $rows = $gParser->SqlNumRows($query);
    for ( $i = 1; $i <= $rows; $i++ )
    {           
        // Get feature values               
        $gParser->SqlDataSeek($query, $i - 1);
        $row = $gParser->SqlFetchHash($query);
        $next = $gParser->SqlFetchHash($query);
            
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value = $row[\'value_name\'];
                $info_id = $row[\'info_id\'];
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }    
        $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'info_name\']),
                                        \'VALUE\' => $value
                                        )); 
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 21:12:04');
INSERT INTO `ms_user_file_version` VALUES ('584','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT i.name AS info_name, i.type_key, 
                       si.value_dec, si.value_txt, si.value_id, si.info_id, 
                       iv.name AS value_name 
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              ORDER BY i.absindex
                \";                    
    $query = $gParser->SqlQuery(__LINE__, $command);
    $rows = $gParser->SqlNumRows($query);
    for ( $i = 1; $i <= $rows; $i++ )
    {           
        // Get feature values               
        $gParser->SqlDataSeek($query, $i - 1);
        $row = $gParser->SqlFetchHash($query);        
            
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value = $row[\'value_name\'];
                $info_id = $row[\'info_id\'];
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }
            
        $next = $gParser->SqlFetchHash($query);
        if ( $next[\'info_id\'] != $row[\'info_id\'] )
        {                                              
            $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'info_name\']),
                                            \'VALUE\' => $value
                                            )); 
            $gParser->TplParse($tpl, \'ITEM\', \'.item\');
        }  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 21:13:23');
INSERT INTO `ms_user_file_version` VALUES ('585','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT i.name AS info_name, i.type_key, 
                       si.value_dec, si.value_txt, si.value_id, si.info_id, 
                       iv.name AS value_name 
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              ORDER BY i.absindex
                \";                    
    $query = $gParser->SqlQuery(__LINE__, $command);
    $rows = $gParser->SqlNumRows($query);
    for ( $i = 1; $i <= $rows; $i++ )
    {           
        // Get feature values               
        $gParser->SqlDataSeek($query, $i - 1);
        $row = $gParser->SqlFetchHash($query);        
            
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value = $row[\'value_name\'];
                $info_id = $row[\'info_id\'];
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }
            
        $next = $gParser->SqlFetchHash($query);
        if ( ( $next[\'info_id\'] ?? 0 ) != $row[\'info_id\'] )
        {                                              
            $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'info_name\']),
                                            \'VALUE\' => $value
                                            )); 
            $gParser->TplParse($tpl, \'ITEM\', \'.item\');
        }  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 21:13:54');
INSERT INTO `ms_user_file_version` VALUES ('586','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT i.name AS info_name, i.type_key, 
                       si.value_dec, si.value_txt, si.value_id, si.info_id, 
                       iv.name AS value_name 
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              ORDER BY i.absindex
                \";                    
    $query = $gParser->SqlQuery(__LINE__, $command);
    $rows = $gParser->SqlNumRows($query);
    for ( $i = 1; $i <= $rows; $i++ )
    {           
        // Get feature values               
        $gParser->SqlDataSeek($query, $i - 1);
        $row = $gParser->SqlFetchHash($query);        
            
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value .= $row[\'value_name\'];
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }
            
        $next = $gParser->SqlFetchHash($query);
        if ( ( $next[\'info_id\'] ?? 0 ) != $row[\'info_id\'] )
        {                                              
            $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'info_name\']),
                                            \'VALUE\' => $value
                                            )); 
            $gParser->TplParse($tpl, \'ITEM\', \'.item\');
        }  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 21:19:41');
INSERT INTO `ms_user_file_version` VALUES ('587','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT i.name AS info_name, i.type_key, 
                       si.value_dec, si.value_txt, si.value_id, si.info_id, 
                       iv.name AS value_name 
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              ORDER BY i.absindex
                \";                    
    $query = $gParser->SqlQuery(__LINE__, $command);
    $rows = $gParser->SqlNumRows($query);
    for ( $i = 1; $i <= $rows; $i++ )
    {           
        // Get feature values               
        $gParser->SqlDataSeek($query, $i - 1);
        $row = $gParser->SqlFetchHash($query);        
            
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value .= $row[\'value_name\'];
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }
            
        $next = $gParser->SqlFetchHash($query);
        if ( ( $next[\'info_id\'] ?? 0 ) != $row[\'info_id\'] )
        {                                              
            $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'info_name\']),
                                            \'VALUE\' => $value
                                            )); 
            $gParser->TplParse($tpl, \'ITEM\', \'.item\');
            $value = \'\';
        }  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 21:20:03');
INSERT INTO `ms_user_file_version` VALUES ('588','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT i.name AS info_name, i.type_key, 
                       si.value_dec, si.value_txt, si.value_id, si.info_id, 
                       iv.name AS value_name 
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              ORDER BY i.absindex
                \";                    
    $query = $gParser->SqlQuery(__LINE__, $command);
    $rows = $gParser->SqlNumRows($query); 
    $value = \'\';
    for ( $i = 1; $i <= $rows; $i++ )
    {           
        // Get feature values               
        $gParser->SqlDataSeek($query, $i - 1);
        $row = $gParser->SqlFetchHash($query);        
            
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value .= $row[\'value_name\'];
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }
            
        $next = $gParser->SqlFetchHash($query);
        if ( ( $next[\'info_id\'] ?? 0 ) != $row[\'info_id\'] )
        {                                              
            $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'info_name\']),
                                            \'VALUE\' => $value
                                            )); 
            $gParser->TplParse($tpl, \'ITEM\', \'.item\');
            $value = \'\';
        }  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 21:20:20');
INSERT INTO `ms_user_file_version` VALUES ('589','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT i.name AS info_name, i.type_key, 
                       si.value_dec, si.value_txt, si.value_id, si.info_id, 
                       iv.name AS value_name 
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              ORDER BY i.absindex
                \";                    
    $query = $gParser->SqlQuery(__LINE__, $command);
    $rows = $gParser->SqlNumRows($query); 
    $value = \'\';
    for ( $i = 1; $i <= $rows; $i++ )
    {           
        // Get feature values               
        $gParser->SqlDataSeek($query, $i - 1);
        $row = $gParser->SqlFetchHash($query);        
            
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value .= $row[\'value_name\'];
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }
            
        $next = $gParser->SqlFetchHash($query);
        if ( ( $next[\'info_id\'] ?? 0 ) != $row[\'info_id\'] )
        {                                              
            $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'info_name\']),
                                            \'VALUE\' => $value
                                            )); 
            $gParser->TplParse($tpl, \'ITEM\', \'.item\');
            $value = \'\';
        }  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 21:22:08');
INSERT INTO `ms_user_file_version` VALUES ('590','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT i.name AS info_name, i.type_key, 
                       si.value_dec, si.value_txt, si.value_id, si.info_id, 
                       iv.name AS value_name 
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              ORDER BY i.absindex
                \";                    
    $query = $gParser->SqlQuery(__LINE__, $command);
    $rows = $gParser->SqlNumRows($query); 
    $value = \'\';
    for ( $i = 1; $i <= $rows; $i++ )
    {           
        // Get feature values               
        $gParser->SqlDataSeek($query, $i - 1);
        $row = $gParser->SqlFetchHash($query);        
            
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value .= $row[\'value_name\'].\', \';
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }
            
        $next = $gParser->SqlFetchHash($query);
        if ( ( $next[\'info_id\'] ?? 0 ) != $row[\'info_id\'] )
        {                                              
            $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'info_name\']),
                                            \'VALUE\' => $value
                                            )); 
            $gParser->TplParse($tpl, \'ITEM\', \'.item\');
            $value = \'\';
        }  
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 21:26:17');
INSERT INTO `ms_user_file_version` VALUES ('591','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT i.name AS info_name, i.type_key, 
                       si.value_dec, si.value_txt, si.value_id, si.info_id, 
                       iv.name AS value_name 
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              ORDER BY i.absindex
                \";                    
    $query = $gParser->SqlQuery(__LINE__, $command);
    $rows = $gParser->SqlNumRows($query); 
    $value = \'\';
    for ( $i = 1; $i <= $rows; $i++ )
    {           
        // Get feature values               
        $gParser->SqlDataSeek($query, $i - 1);
        $row = $gParser->SqlFetchHash($query);        
            
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value .= $row[\'value_name\'];
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }
            
        $next = $gParser->SqlFetchHash($query);
        if ( ( $next[\'info_id\'] ?? 0 ) != $row[\'info_id\'] )
        {                                              
            $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'info_name\']),
                                            \'VALUE\' => $value
                                            )); 
            $gParser->TplParse($tpl, \'ITEM\', \'.item\');
            $value = \'\';
        }  
        else
        {
            $value .= \', \';
        }
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 21:28:46');
INSERT INTO `ms_user_file_version` VALUES ('592','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT i.name AS info_name, i.type_key, 
                       si.value_dec, si.value_txt, si.value_id, si.info_id, 
                       iv.name AS value_name 
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              ORDER BY i.absindex
                \";                    
    $query = $gParser->SqlQuery(__LINE__, $command);
    $rows = $gParser->SqlNumRows($query); 
    $value = \'\';
    for ( $i = 1; $i <= $rows; $i++ )
    {           
        // Get feature values               
        $gParser->SqlDataSeek($query, $i - 1);
        $row = $gParser->SqlFetchHash($query);        
            
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value .= $row[\'value_name\'];
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }
                             
        // Verify next
        $next = $gParser->SqlFetchHash($query);
        if ( ( $next[\'info_id\'] ?? 0 ) != $row[\'info_id\'] )
        {                                              
            $gParser->TplAssign($tpl, array(\'NAME\'  => htmlspecialchars($row[\'info_name\']),
                                            \'VALUE\' => $value
                                            )); 
            $gParser->TplParse($tpl, \'ITEM\', \'.item\');
            $value = \'\';
        }  
        else
        {
            $value .= \', \';
        }
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 21:29:34');
INSERT INTO `ms_user_file_version` VALUES ('593','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT i.name AS info_name, i.type_key, 
                       si.value_dec, si.value_txt, si.value_id, si.info_id, 
                       iv.name AS value_name 
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              ORDER BY i.absindex
                \";                    
    $query = $gParser->SqlQuery(__LINE__, $command);
    $rows = $gParser->SqlNumRows($query); 
    $value = \'\';
    for ( $i = 1; $i <= $rows; $i++ )
    {           
        // Get feature values               
        $gParser->SqlDataSeek($query, $i - 1);
        $row = $gParser->SqlFetchHash($query);        
            
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value .= $row[\'value_name\'];
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }
                             
        // Verify next
        $next = $gParser->SqlFetchHash($query);
        if ( ( $next[\'info_id\'] ?? 0 ) != $row[\'info_id\'] )
        {                                              
            $gParser->TplAssign($tpl, array(\'NAME\'  => MELBIS_INC_LANG(\'kStore\', \'INFO_NAME\', $row[\'info_id\'], $item[\'info_name\']), 
                                            \'VALUE\' => $value
                                            )); 
            $gParser->TplParse($tpl, \'ITEM\', \'.item\');
            $value = \'\';
        }  
        else
        {
            $value .= \', \';
        }
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 21:31:00');
INSERT INTO `ms_user_file_version` VALUES ('594','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT i.name AS info_name, i.type_key, 
                       si.value_dec, si.value_txt, si.value_id, si.info_id, 
                       iv.name AS value_name 
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              ORDER BY i.absindex
                \";                    
    $query = $gParser->SqlQuery(__LINE__, $command);
    $rows = $gParser->SqlNumRows($query); 
    $value = \'\';
    for ( $i = 1; $i <= $rows; $i++ )
    {           
        // Get feature values               
        $gParser->SqlDataSeek($query, $i - 1);
        $row = $gParser->SqlFetchHash($query);        
            
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value .= $row[\'value_name\'];
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }
                             
        // Verify next
        $next = $gParser->SqlFetchHash($query);
        if ( ( $next[\'info_id\'] ?? 0 ) != $row[\'info_id\'] )
        {                                              
            $gParser->TplAssign($tpl, array(\'NAME\'  => MELBIS_INC_LANG(\'kStore\', \'INFO_NAME\', $row[\'info_id\'], $row[\'info_name\']), 
                                            \'VALUE\' => $value
                                            )); 
            $gParser->TplParse($tpl, \'ITEM\', \'.item\');
            $value = \'\';
        }  
        else
        {
            $value .= \', \';
        }
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 21:31:36');
INSERT INTO `ms_user_file_version` VALUES ('595','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT i.name AS info_name, i.type_key, 
                       si.value_dec, si.value_txt, si.value_id, si.info_id, 
                       iv.name AS value_name 
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              ORDER BY i.absindex
                \";                    
    $query = $gParser->SqlQuery(__LINE__, $command);
    $rows = $gParser->SqlNumRows($query); 
    $value = \'\';
    for ( $i = 1; $i <= $rows; $i++ )
    {           
        // Get feature values               
        $gParser->SqlDataSeek($query, $i - 1);
        $row = $gParser->SqlFetchHash($query);        
            
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value .= MELBIS_INC_LANG(\'kStore\', \'INFO_NAME\', $row[\'value_id\'], $row[\'value_name\']);
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }
                             
        // Verify next
        $next = $gParser->SqlFetchHash($query);
        if ( ( $next[\'info_id\'] ?? 0 ) != $row[\'info_id\'] )
        {                                              
            $gParser->TplAssign($tpl, array(\'NAME\'  => MELBIS_INC_LANG(\'kStore\', \'INFO_NAME\', $row[\'info_id\'], $row[\'info_name\']), 
                                            \'VALUE\' => $value
                                            )); 
            $gParser->TplParse($tpl, \'ITEM\', \'.item\');
            $value = \'\';
        }  
        else
        {
            $value .= \', \';
        }
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 21:32:41');
INSERT INTO `ms_user_file_version` VALUES ('596','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT i.name AS info_name, i.type_key, 
                       si.value_dec, si.value_txt, si.value_id, si.info_id, 
                       iv.name AS value_name 
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              ORDER BY i.absindex
                \";                    
    $query = $gParser->SqlQuery(__LINE__, $command);
    $rows = $gParser->SqlNumRows($query); 
    $value = \'\';
    for ( $i = 1; $i <= $rows; $i++ )
    {           
        // Get feature values               
        $gParser->SqlDataSeek($query, $i - 1);
        $row = $gParser->SqlFetchHash($query);        
            
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value .= MELBIS_INC_LANG(\'kInfo\', \'VALUE\', $row[\'value_id\'], $row[\'value_name\']);
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }
                             
        // Verify next
        $next = $gParser->SqlFetchHash($query);
        if ( ( $next[\'info_id\'] ?? 0 ) != $row[\'info_id\'] )
        {                                              
            $gParser->TplAssign($tpl, array(\'NAME\'  => MELBIS_INC_LANG(\'kInfo\', \'NAME\', $row[\'info_id\'], $row[\'info_name\']), 
                                            \'VALUE\' => $value
                                            )); 
            $gParser->TplParse($tpl, \'ITEM\', \'.item\');
            $value = \'\';
        }  
        else
        {
            $value .= \', \';
        }
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 21:36:20');
INSERT INTO `ms_user_file_version` VALUES ('597','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT i.name AS info_name, i.type_key, 
                       si.value_dec, si.value_txt, si.value_id, si.info_id, 
                       iv.name AS value_name 
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              ORDER BY i.absindex
                \";                    
    $query = $gParser->SqlQuery(__LINE__, $command);
    $rows = $gParser->SqlNumRows($query); 
    $value = \'\';
    for ( $i = 1; $i <= $rows; $i++ )
    {           
        // Get feature values               
        $gParser->SqlDataSeek($query, $i - 1);
        $row = $gParser->SqlFetchHash($query);        
            
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value .= MELBIS_INC_LANG(\'kInfo\', \'VALUE\', $row[\'value_id\'], $row[\'value_name\']);
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = $row[\'value_txt\'];
                break;                                  
        }
                             
        // Verify next
        $next = $gParser->SqlFetchHash($query);
        if ( ( $next[\'info_id\'] ?? 0 ) != $row[\'info_id\'] )
        {                                              
            $gParser->TplAssign($tpl, array(\'NAME\'  => MELBIS_INC_LANG(\'kInfo\', \'NAME\', $row[\'info_id\'], $row[\'info_name\']), 
                                            \'VALUE\' => $value
                                            )); 
            $gParser->TplParse($tpl, \'ITEM\', \'.item\');
            $value = \'\';
        }  
        else
        {
            $value .= \', \';
        }
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 21:37:30');
INSERT INTO `ms_user_file_version` VALUES ('598','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT i.name AS info_name, i.type_key, 
                       si.id, si.value_dec, si.value_txt, si.value_id, si.info_id, 
                       iv.name AS value_name 
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              ORDER BY i.absindex
                \";                    
    $query = $gParser->SqlQuery(__LINE__, $command);
    $rows = $gParser->SqlNumRows($query); 
    $value = \'\';
    for ( $i = 1; $i <= $rows; $i++ )
    {           
        // Get feature values               
        $gParser->SqlDataSeek($query, $i - 1);
        $row = $gParser->SqlFetchHash($query);        
            
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value .= MELBIS_INC_LANG(\'kInfo\', \'VALUE\', $row[\'value_id\'], $row[\'value_name\']);
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = MELBIS_INC_LANG(\'kInfo\', \'TEXT\', $row[\'id\'], $row[\'value_txt\']);
                break;                                  
        }
                             
        // Verify next
        $next = $gParser->SqlFetchHash($query);
        if ( ( $next[\'info_id\'] ?? 0 ) != $row[\'info_id\'] )
        {                                              
            $gParser->TplAssign($tpl, array(\'NAME\'  => MELBIS_INC_LANG(\'kInfo\', \'NAME\', $row[\'info_id\'], $row[\'info_name\']), 
                                            \'VALUE\' => $value
                                            )); 
            $gParser->TplParse($tpl, \'ITEM\', \'.item\');
            $value = \'\';
        }  
        else
        {
            $value .= \', \';
        }
    }

    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 21:40:27');
INSERT INTO `ms_user_file_version` VALUES ('599','1','./../templates/default/units/melbis_store_card/main.htm','<div class=\"card h-100\">
    <h4 class=\"card-header text-center\">{NAME}</h4>
    {MELBIS:melbis_store_image([ID],kDefault)}          
    <div class=\"card-body\">
        <p class=\"card-text\">{INTRO}</p>
    </div>
    {MELBIS:melbis_store_features([MS:VAR:LANG],[ID])}
    <div class=\"card-footer \">        
        <div class=\"d-flex justify-content-around align-items-center\">
            <div class=\"text-center\">    
                <p class=\"lead m-0\">{PRICE}</p>
                <p class=\"badge badge-warning m-0\">{STATUS}</p>                                                                          
            </div>
            <button class=\"btn btn-primary melbis_btn_add\" data-id=\"{ID}\"><i class=\"fas fa-cart-plus\"></i> {TAG_ADD}</button>
        </div>
    </div>       
    <div class=\"card-footer d-flex justify-content-between\">  
        <small class=\"text-muted\">{TAG_UPDATE} {UPDATE}</small>
        <span class=\"badge badge-info float-right\">{TAG_CODE}: {CODE}</span>
    </div>  
</div>
','2025-03-31 21:43:37');
INSERT INTO `ms_user_file_version` VALUES ('600','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
       
    // Get image    
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    
    $gParser->TplAssign($tpl, \'IMAGES\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);   
        foreach ($imgs as $img) 
        {
            $gParser->TplAssign($tpl, \'FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'IMAGES\', \'.img\');                              
        }                                                           
                                                           
        // Base
        $gParser->TplAssign($tpl, \'FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');                 
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-03-31 21:56:47');
INSERT INTO `ms_user_file_version` VALUES ('601','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    var src = img.parent(\'div\').prev().attr(\'src\');         
    img.parent(\'div\').prev().attr(\'src\', img.attr(\'src\'))
    img.attr(\'src\', src);
}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 22:04:46');
INSERT INTO `ms_user_file_version` VALUES ('602','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    var src = img.parent(\'div\').prev().attr(\'src\');         
    img.parent(\'div\').prev().attr(\'src\', img.attr(\'src\'))
    img.attr(\'src\', src);
}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 22:07:26');
INSERT INTO `ms_user_file_version` VALUES ('603','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);                                                     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM {DBNICK}_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");           
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';         
        $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {                           
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM {DBNICK}_store s
                          JOIN {DBNICK}_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content                     
                $gParser->gVars[\'ms\'][\'page\'][\'id\'] = $topic[\'id\'];
                $gParser->gVars[\'ms\'][\'page\'][\'path\'] = $topic[\'path\'];   
                $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                $descr = MELBIS_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                $gParser->TplAssign($tpl, [\'ID\'     => $topic[\'id\'], 
                                           \'DESCR\'  => MELBIS_INC_STD_text($descr)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {                  
            $gParser->gVars[\'ms\'][\'page\'][\'id\'] = $topic[\'id\'];  
            $gParser->gVars[\'ms\'][\'page\'][\'path\'] = $topic[\'path\'];
            $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG(\'kTopic\', \'NAME\', $topic[\'id\'], $topic[\'name\']);
                                     
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 22:08:26');
INSERT INTO `ms_user_file_version` VALUES ('604','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    var src = img.parent(\'div\').prev().attr(\'src\');         
    img.parent(\'div\').prev().attr(\'src\', img.attr(\'src\'))
    img.attr(\'src\', src);
}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 22:10:06');
INSERT INTO `ms_user_file_version` VALUES ('605','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    var src = img.parent(\'div\').prev().attr(\'src\');         
    img.parent(\'div\').prev().attr(\'src\', img.attr(\'src\'))
    img.attr(\'src\', src);
}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 22:10:14');
INSERT INTO `ms_user_file_version` VALUES ('606','1','./../templates/default/units/melbis_base_footer/main.htm','
<footer class=\"footer mt-auto py-3 bg-light\">
    <div class=\"container-fluid melbis_css_max_width\">
        <div class=\"d-flex justify-content-between\">                                   
            <div class=\"d-flex align-items-center mr-1\"><span class=\"lead text-muted\" style=\"font-size: 1.5rem\"><i class=\"fa-solid fa-shop\"></i> {TAG_SITE_NAME}</span></div>
            <div class=\"d-flex align-items-center text-muted text-center\"><small class=\"d-none d-md-block\">&copy; {MS:VAR:YEAR}  Melbis. <span class=\"text-nowrap\">{MELBIS_COPY}</span></small></div>
            <div class=\"d-flex align-items-center ml-1\">
                <div class=\"d-none d-sm-block lead\">     
                    <a href=\"https://telegram.org/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-telegram\"></i> Telegram</a>
                    &nbsp; 
                    <a href=\"https://www.youtube.com/\" class=\"text-decoration-none text-muted\"><i class=\"fa-brands fa-youtube\"></i> YouTube</a>
                    &nbsp;
                    <a href=\"mailto:{CONST:MELBIS_SHOP_EMAIL}\" class=\"text-decoration-none text-muted\"><i class=\"fa-solid fa-envelope\"></i> Email</a>
                </div>
            </div>
        </div>            
    </div>
</footer>                  

','2025-03-31 22:11:44');
INSERT INTO `ms_user_file_version` VALUES ('607','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var melbis_topic_id = [MS:PAGE:ID] </script>
        
        {MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main>              
        
        {SCRIPTS}
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}    
    </body>                                       
    
<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>    
    
</html>
','2025-03-31 22:11:59');
INSERT INTO `ms_user_file_version` VALUES ('608','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    var src = img.parent(\'div\').prev().attr(\'src\');         
    img.parent(\'div\').prev().attr(\'src\', img.attr(\'src\'))
    img.attr(\'src\', src);
}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 22:12:34');
INSERT INTO `ms_user_file_version` VALUES ('609','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);                                                     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM {DBNICK}_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");           
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';         
        $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {                           
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM {DBNICK}_store s
                          JOIN {DBNICK}_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content                     
                $gParser->gVars[\'ms\'][\'page\'][\'id\'] = $topic[\'id\'];
                $gParser->gVars[\'ms\'][\'page\'][\'path\'] = $topic[\'path\'];   
                $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                $descr = MELBIS_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                $gParser->TplAssign($tpl, [\'ID\'     => $topic[\'id\'], 
                                           \'DESCR\'  => MELBIS_INC_STD_text($descr)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {                  
            $gParser->gVars[\'ms\'][\'page\'][\'id\'] = $topic[\'id\'];  
            $gParser->gVars[\'ms\'][\'page\'][\'path\'] = $topic[\'path\'];
            $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG(\'kTopic\', \'NAME\', $topic[\'id\'], $topic[\'name\']);
                                     
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 22:14:58');
INSERT INTO `ms_user_file_version` VALUES ('610','1','./../units/melbis_base_page.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASE_PAGE
 **/
function MELBIS_BASE_PAGE($mVars)
{ 
    global $gParser, $gServer;
                       
    // Create 
    $tpl = $gParser->TplCreate();                
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);                                                     

    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];        
    $gParser->gVars[\'ms\'][\'var\'][\'year\'] = MELBIS_INC_STD_get_now(\'Y\');      
                
    // Define page
    $psu = \'/\'.addslashes($mVars[\'get\'][\'psu\'] ?? \'\');       
    $command = \"SELECT t.id, t.name, t.kind_key, t.seo_psu AS path
                  FROM {DBNICK}_topic t   
                 WHERE t.no_visible = 0
                   AND t.seo_psu = \'$psu\'                                                                                                              
                \";     
    $topic = $gParser->SqlSelectToArray(__LINE__, $command);
    if ( !isset($topic[\'id\']) ) 
    {
        // Not found
        header($gServer[\'SERVER_PROTOCOL\'].\" 404 Not Found\");           
        $gParser->gVars[\'ms\'][\'page\'][\'id\'] = 0;
        $gParser->gVars[\'ms\'][\'page\'][\'path\'] = \'/\';         
        $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG_tag(\'BASE_PAGE\', \'404_TITLE\');
        
        $gParser->TplParse($tpl, \'CONTENT\', \'404\'); 
    }
    else 
    {                           
        if ( $topic[\'kind_key\'] == \'kText\' )  
        { 
            // Get page content                  
            $command = \"SELECT s.*
                          FROM {DBNICK}_store s
                          JOIN {DBNICK}_topic_store ts
                            ON s.id = ts.store_id
                         WHERE ts.topic_id = \'$topic[id]\'  
                           AND s.no_visible = 0                          
                      ORDER BY ts.pos
                         LIMIT 1             
                        \";                    
            $page = $gParser->SqlSelectToArray(__LINE__, $command);
            if ( !isset($page[\'id\']) )
            {
                // Error 
                MELBIS_INC_halt(\'CONTENT NOT FOUND\', __FILE__.\':\'.__LINE__, \'\');
            }           
            else
            {
                // Content                     
                $gParser->gVars[\'ms\'][\'page\'][\'id\'] = $topic[\'id\'];
                $gParser->gVars[\'ms\'][\'page\'][\'path\'] = $topic[\'path\'];   
                $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG(\'kTopic\', \'TITLE\', $page[\'id\'], $page[\'name\']); 
                $descr = MELBIS_INC_LANG(\'kTopic\', \'DESCR\', $page[\'id\'], $page[\'descr\'], true);                                                            
                $gParser->TplAssign($tpl, [\'ID\'     => $topic[\'id\'], 
                                           \'DESCR\'  => MELBIS_INC_STD_text($descr)]);  

                $gParser->TplParse($tpl, \'CONTENT\', \'content_text\');                
            } 
        }
        
        // Page goods 
        if ( $topic[\'kind_key\'] == \'kGoods\' )  
        {                  
            $gParser->gVars[\'ms\'][\'page\'][\'id\'] = $topic[\'id\'];  
            $gParser->gVars[\'ms\'][\'page\'][\'path\'] = $topic[\'path\'];
            $gParser->gVars[\'ms\'][\'page\'][\'title\'] = MELBIS_INC_LANG(\'kTopic\', \'NAME\', $topic[\'id\'], $topic[\'name\']);
                                     
            $gParser->TplParse($tpl, \'CONTENT\', \'content_goods\');        
        }                
    }      
         
    $gParser->TplParse($tpl, \'SCRIPTS\', \'scripts\');
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');   
        
    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-03-31 22:15:03');
INSERT INTO `ms_user_file_version` VALUES ('611','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    var src = img.parent(\'div\').prev().attr(\'src\');         
    img.parent(\'div\').prev().attr(\'src\', img.attr(\'src\'))
    img.attr(\'src\', src);
}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
console.log($(\'#melbis_win_checkout\'));
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 22:19:41');
INSERT INTO `ms_user_file_version` VALUES ('612','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    var src = img.parent(\'div\').prev().attr(\'src\');         
    img.parent(\'div\').prev().attr(\'src\', img.attr(\'src\'))
    img.attr(\'src\', src);
}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
console.log($(\'#melbis_btn_checkout\'));
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 22:20:13');
INSERT INTO `ms_user_file_version` VALUES ('613','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var melbis_topic_id = [MS:PAGE:ID] </script>
        
        {MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main>              
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}    
    </body>                                       
    
<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Your Basket</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> Checkout</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>   

{SCRIPTS} 
    
</html>
','2025-03-31 22:21:39');
INSERT INTO `ms_user_file_version` VALUES ('614','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    var src = img.parent(\'div\').prev().attr(\'src\');         
    img.parent(\'div\').prev().attr(\'src\', img.attr(\'src\'))
    img.attr(\'src\', src);
}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>Goods \"\' + name + \'\" added to basket!</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 22:21:56');
INSERT INTO `ms_user_file_version` VALUES ('615','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    var src = img.parent(\'div\').prev().attr(\'src\');         
    img.parent(\'div\').prev().attr(\'src\', img.attr(\'src\'))
    img.attr(\'src\', src);
}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>\"\' + name + \'\"</p><p>{TAGS_ADD_GOODS}</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 22:25:31');
INSERT INTO `ms_user_file_version` VALUES ('616','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    var src = img.parent(\'div\').prev().attr(\'src\');         
    img.parent(\'div\').prev().attr(\'src\', img.attr(\'src\'))
    img.attr(\'src\', src);
}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>\"\' + name + \'\"</p><p>{TAGS_GOODS_ADD}</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 22:25:48');
INSERT INTO `ms_user_file_version` VALUES ('617','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    var src = img.parent(\'div\').prev().attr(\'src\');         
    img.parent(\'div\').prev().attr(\'src\', img.attr(\'src\'))
    img.attr(\'src\', src);
}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>\' + name + \'</p><p>{TAGS_GOODS_ADD}</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 22:27:13');
INSERT INTO `ms_user_file_version` VALUES ('618','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var melbis_topic_id = [MS:PAGE:ID] </script>
        
        {MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main>              
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}    
    </body>                                       
    
<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">{TAG_BASKET}</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">{TAG_CLOSE}</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> {TAG_CHECKOUT}</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">Your order</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>   

{SCRIPTS} 
    
</html>
','2025-03-31 22:29:07');
INSERT INTO `ms_user_file_version` VALUES ('619','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var melbis_topic_id = [MS:PAGE:ID] </script>
        
        {MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main>              
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}    
    </body>                                       
    
<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">{TAG_BASKET}</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">{TAG_CLOSE}</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> {TAG_CHECKOUT}</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">{TAG_ORDER}</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">Cart</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">Billing</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">Options</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>   

{SCRIPTS} 
    
</html>
','2025-03-31 22:36:52');
INSERT INTO `ms_user_file_version` VALUES ('620','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var melbis_topic_id = [MS:PAGE:ID] </script>
        
        {MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main>              
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}    
    </body>                                       
    
<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">{TAG_BASKET}</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">{TAG_CLOSE}</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> {TAG_CHECKOUT}</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">{TAG_ORDER}</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">{TAG_CART}</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">{TAG_FIELDS}</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">{TAG_OPTIONS}</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> Finish</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>   

{SCRIPTS} 
    
</html>
','2025-03-31 22:41:34');
INSERT INTO `ms_user_file_version` VALUES ('621','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var melbis_topic_id = [MS:PAGE:ID] </script>
        
        {MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main>              
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}    
    </body>                                       
    
<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">{TAG_BASKET}</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">{TAG_CLOSE}</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> {TAG_CHECKOUT}</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">{TAG_ORDER}</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">{TAG_CART}</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">{TAG_FIELDS}</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">{TAG_OPTIONS}</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">{TAG_CLOSE}</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> {TAG_FINISH}</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>   

{SCRIPTS} 
    
</html>
','2025-03-31 22:42:07');
INSERT INTO `ms_user_file_version` VALUES ('622','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var melbis_topic_id = [MS:PAGE:ID] </script>
        
        {MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main>              
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}    
    </body>                                       
    
<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">{TAG_BASKET}</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">{TAG_CLOSE}</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> {TAG_CHECKOUT}</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">{TAG_ORDER}</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">{TAG_CART}</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">{TAG_FIELDS}</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">{TAG_OPTIONS}</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>Oh! Error found</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">{TAG_CLOSE}</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> {TAG_FINISH}</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>   

{SCRIPTS} 
    
</html>
','2025-03-31 22:42:32');
INSERT INTO `ms_user_file_version` VALUES ('623','1','./../units/melbis_basket.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASKET
 **/
function MELBIS_BASKET($mVars)
{ 
    global $gParser;  
    
    // Vars
    $func = __FUNCTION__.\'_\'.$mVars[\'post\'][\'func\'];
    
    // Call function    
    if ( function_exists($func) )
    {
        return call_user_func($func, $mVars);    
    }  
    else
    {
        return \'Function \'.$func.\' is absent!\';
    }     
} 


/** 
 * Function MELBIS_BASKET_plus
 **/
function MELBIS_BASKET_plus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Add goods
    $version = MELBIS_INC_LOGIC_order_goods_add($version, $store_id);
     
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);    
                        
    return \'\';                         
}    


/** 
 * Function MELBIS_BASKET_minus
 **/
function MELBIS_BASKET_minus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Remove goods
    $version = MELBIS_INC_LOGIC_order_goods_remove($version, $store_id);    
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);        
                               
    // Go to list
    return MELBIS_BASKET_goods($mVars);     
} 


/** 
 * Function MELBIS_BASKET_goods
 **/
function MELBIS_BASKET_goods($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get Goods
    if ( count($version[\'store\']) > 0 )
    {   
        foreach($version[\'store\'] as $hash )
        {
            $gParser->TplAssign($tpl, array(\'ID\'            => $hash[\'store_id\'],
                                            \'AMOUNT\'        => $hash[\'amount\'],
                                            \'MEAS\'          => htmlspecialchars($hash[\'store_meas\']),                                            
                                            \'PRICE\'         => MELBIS_INC_STD_number($hash[\'out_price\'], 0),
                                            \'NAME\'          => htmlspecialchars($hash[\'store_name\'])
                                            ));         
            $gParser->TplParse($tpl, \'ITEM\', \'.goods_item\');  
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'goods\');                
    }
    else
    {
        $gParser->TplParse($tpl, \'MAIN\', \'goods_empty\');
    }
    
    return $gParser->TplFree($tpl, \'MAIN\');     
}      


/** 
 * Function MELBIS_BASKET_fields
 **/
function MELBIS_BASKET_fields($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get fields
    if ( count($version[\'client\']) > 0 )
    {   
        foreach($version[\'client\'] as $hash )
        {
            if ( $hash[\'field_folder\'] == 1 )
            {
                $gParser->TplAssign($tpl, \'NAME\', htmlspecialchars($hash[\'field_name\']));
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_group\');
                continue;                        
            }
                                              
            $command = \"SELECT *
                          FROM {DBNICK}_field
                         WHERE id = \'$hash[field_id]\' 
                        \";                              
            $field = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_field_value
                         WHERE field_id = \'$field[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $field[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.fields_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'field_id\'],
                                                \'NAME\'  => htmlspecialchars($hash[\'field_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'field_id\'], 
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_txt\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'field_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.fields_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'fields\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
}      


/** 
 * Function MELBIS_BASKET_options
 **/
function MELBIS_BASKET_options($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get options
    if ( count($version[\'option\']) > 0 )
    {   
        foreach($version[\'option\'] as $hash )
        {     
            $command = \"SELECT *
                          FROM {DBNICK}_order_option
                         WHERE id = \'$hash[option_id]\' 
                        \";                              
            $option = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_order_option_value
                         WHERE option_id = \'$option[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $option[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.options_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'option_id\'],
                                                \'NAME\'  => htmlspecialchars($hash[\'option_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'OPTION\', \'.options_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'option_id\'],  
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_name\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'option_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.options_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'OPTION\', \'.options_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'options\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
} 


/** 
 * Function MELBIS_BASKET_auto_field
 **/
function MELBIS_BASKET_auto_field($mVars)
{ 
    global $gParser;       
                
    // Vars   
    $id = $mVars[\'post\'][\'id\']*1;                     
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_field_value
                 WHERE name LIKE \'%$query%\' 
                   AND field_id = \'$id\'                
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_auto_option
 **/
function MELBIS_BASKET_auto_option($mVars)
{ 
    global $gParser;       
                
    // Vars                                      
    $id = $mVars[\'post\'][\'id\']*1;
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_order_option_value                  
                 WHERE name LIKE \'%$query%\'
                   AND option_id = \'$id\'                 
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_save
 **/
function MELBIS_BASKET_save($mVars)
{ 
    global $gParser, $gSession; 
                               
    // Vars
    $data[\'result\'] = \'OK\';
    $data[\'message\'] = \'\';    
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }  
    
    // Update fields
    $rows = count($version[\'client\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'client\'][$i][\'field_id\'];
        $value_id = $mVars[\'post\'][\'field\'.$id.\'_id\'] ?? 0;        
        $version[\'client\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'client\'][$i][\'value_txt\'] = $mVars[\'post\'][\'field\'.$id.\'_text\'];
    }
        
    // Update options
    $rows = count($version[\'option\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'option\'][$i][\'option_id\'];
        $value_id = $mVars[\'post\'][\'option\'.$id.\'_id\'] ?? 0;        
        $version[\'option\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'option\'][$i][\'value_name\'] = $mVars[\'post\'][\'option\'.$id.\'_text\'];
    }
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
    
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);                                          

    // Verify cart    
    if ( count($version[\'store\']) == 0 )
    {  
        $data[\'result\'] = \'ERROR_EMPTY\';
        $data[\'message\'] = \'No goods found!\';    
        
        return json_encode($data);    
    }   

    // Verify calculation
    if ( $version[\'result\'][\'value\'] != \'OK\' )
    {
        $data[\'result\'] = $version[\'result\'][\'value\'];
        $data[\'message\'] = $version[\'result\'][\'message\'];
        
        return json_encode($data);  
    }     
    
    // Create order    
    $result = MELBIS_INC_LOGIC_order_edit($version);
    
    // Error exists?
    if ( $result[\'value\'] != \'OK\' )
    {  
        $data[\'result\'] = $result[\'value\'];
        $data[\'message\'] = $result[\'message\'];
        
        return json_encode($data);
    }
    else
    {
        // Close order session
        $gSession->RemoveValue(\'melbis_version\');
    }       
                        
    return json_encode($data);   
}       

?>','2025-03-31 22:44:28');
INSERT INTO `ms_user_file_version` VALUES ('624','1','./../units/melbis_basket.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASKET
 **/
function MELBIS_BASKET($mVars)
{ 
    global $gParser;  
    
    // Vars
    $func = __FUNCTION__.\'_\'.$mVars[\'post\'][\'func\'];
    
    // Call function    
    if ( function_exists($func) )
    {
        return call_user_func($func, $mVars);    
    }  
    else
    {
        return \'Function \'.$func.\' is absent!\';
    }     
} 


/** 
 * Function MELBIS_BASKET_plus
 **/
function MELBIS_BASKET_plus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Add goods
    $version = MELBIS_INC_LOGIC_order_goods_add($version, $store_id);
     
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);    
                        
    return \'\';                         
}    


/** 
 * Function MELBIS_BASKET_minus
 **/
function MELBIS_BASKET_minus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Remove goods
    $version = MELBIS_INC_LOGIC_order_goods_remove($version, $store_id);    
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);        
                               
    // Go to list
    return MELBIS_BASKET_goods($mVars);     
} 


/** 
 * Function MELBIS_BASKET_goods
 **/
function MELBIS_BASKET_goods($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get Goods
    if ( count($version[\'store\']) > 0 )
    {   
        foreach($version[\'store\'] as $hash )
        {
            $gParser->TplAssign($tpl, array(\'ID\'            => $hash[\'store_id\'],
                                            \'AMOUNT\'        => $hash[\'amount\'],
                                            \'MEAS\'          => htmlspecialchars($hash[\'store_meas\']),                                            
                                            \'PRICE\'         => MELBIS_INC_STD_number($hash[\'out_price\'], 0),
                                            \'NAME\'          => htmlspecialchars($hash[\'store_name\'])
                                            ));         
            $gParser->TplParse($tpl, \'ITEM\', \'.goods_item\');  
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'goods\');                
    }
    else
    {
        $gParser->TplParse($tpl, \'MAIN\', \'goods_empty\');
    }
    
    return $gParser->TplFree($tpl, \'MAIN\');     
}      


/** 
 * Function MELBIS_BASKET_fields
 **/
function MELBIS_BASKET_fields($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get fields
    if ( count($version[\'client\']) > 0 )
    {   
        foreach($version[\'client\'] as $hash )
        {
            if ( $hash[\'field_folder\'] == 1 )
            {
                $gParser->TplAssign($tpl, \'NAME\', htmlspecialchars($hash[\'field_name\']));
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_group\');
                continue;                        
            }
                                              
            $command = \"SELECT *
                          FROM {DBNICK}_field
                         WHERE id = \'$hash[field_id]\' 
                        \";                              
            $field = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_field_value
                         WHERE field_id = \'$field[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $field[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.fields_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'field_id\'],
                                                \'NAME\'  => htmlspecialchars($hash[\'field_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'field_id\'], 
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_txt\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'field_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.fields_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'fields\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
}      


/** 
 * Function MELBIS_BASKET_options
 **/
function MELBIS_BASKET_options($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get options
    if ( count($version[\'option\']) > 0 )
    {   
        foreach($version[\'option\'] as $hash )
        {     
            $command = \"SELECT *
                          FROM {DBNICK}_order_option
                         WHERE id = \'$hash[option_id]\' 
                        \";                              
            $option = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_order_option_value
                         WHERE option_id = \'$option[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $option[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.options_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'option_id\'],
                                                \'NAME\'  => htmlspecialchars($hash[\'option_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'OPTION\', \'.options_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'option_id\'],  
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_name\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'option_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.options_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'OPTION\', \'.options_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'options\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
} 


/** 
 * Function MELBIS_BASKET_auto_field
 **/
function MELBIS_BASKET_auto_field($mVars)
{ 
    global $gParser;       
                
    // Vars   
    $id = $mVars[\'post\'][\'id\']*1;                     
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_field_value
                 WHERE name LIKE \'%$query%\' 
                   AND field_id = \'$id\'                
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_auto_option
 **/
function MELBIS_BASKET_auto_option($mVars)
{ 
    global $gParser;       
                
    // Vars                                      
    $id = $mVars[\'post\'][\'id\']*1;
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_order_option_value                  
                 WHERE name LIKE \'%$query%\'
                   AND option_id = \'$id\'                 
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_save
 **/
function MELBIS_BASKET_save($mVars)
{ 
    global $gParser, $gSession; 
                               
    // Vars
    $data[\'result\'] = \'OK\';
    $data[\'message\'] = \'\';    
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }  
    
    // Update fields
    $rows = count($version[\'client\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'client\'][$i][\'field_id\'];
        $value_id = $mVars[\'post\'][\'field\'.$id.\'_id\'] ?? 0;        
        $version[\'client\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'client\'][$i][\'value_txt\'] = $mVars[\'post\'][\'field\'.$id.\'_text\'];
    }
        
    // Update options
    $rows = count($version[\'option\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'option\'][$i][\'option_id\'];
        $value_id = $mVars[\'post\'][\'option\'.$id.\'_id\'] ?? 0;        
        $version[\'option\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'option\'][$i][\'value_name\'] = $mVars[\'post\'][\'option\'.$id.\'_text\'];
    }
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
    
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);                                          

    // Verify cart    
    if ( count($version[\'store\']) == 0 )
    {  
        $data[\'result\'] = \'ERROR_EMPTY\';
        $data[\'message\'] = \'No goods found!\';    
        
        return json_encode($data);    
    }   

    // Verify calculation
    if ( $version[\'result\'][\'value\'] != \'OK\' )
    {
        $data[\'result\'] = $version[\'result\'][\'value\'];
        $data[\'message\'] = $version[\'result\'][\'message\'];
        
        return json_encode($data);  
    }     
    
    // Create order    
    $result = MELBIS_INC_LOGIC_order_edit($version);
    
    // Error exists?
    if ( $result[\'value\'] != \'OK\' )
    {  
        $data[\'result\'] = $result[\'value\'];
        $data[\'message\'] = $result[\'message\'];
        
        return json_encode($data);
    }
    else
    {
        // Close order session
        $gSession->RemoveValue(\'melbis_version\');
    }       
                        
    return json_encode($data);   
}       

?>','2025-03-31 22:46:23');
INSERT INTO `ms_user_file_version` VALUES ('625','1','./../units/melbis_basket.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASKET
 **/
function MELBIS_BASKET($mVars)
{ 
    global $gParser;  
    
    // Vars
    $func = __FUNCTION__.\'_\'.$mVars[\'post\'][\'func\'];
    
    // Call function    
    if ( function_exists($func) )
    {
        return call_user_func($func, $mVars);    
    }  
    else
    {
        return \'Function \'.$func.\' is absent!\';
    }     
} 


/** 
 * Function MELBIS_BASKET_plus
 **/
function MELBIS_BASKET_plus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Add goods
    $version = MELBIS_INC_LOGIC_order_goods_add($version, $store_id);
     
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);    
                        
    return \'\';                         
}    


/** 
 * Function MELBIS_BASKET_minus
 **/
function MELBIS_BASKET_minus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Remove goods
    $version = MELBIS_INC_LOGIC_order_goods_remove($version, $store_id);    
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);        
                               
    // Go to list
    return MELBIS_BASKET_goods($mVars);     
} 


/** 
 * Function MELBIS_BASKET_goods
 **/
function MELBIS_BASKET_goods($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);         
             
    // Get Goods
    if ( count($version[\'store\']) > 0 )
    {   
        foreach($version[\'store\'] as $hash )
        {
            $gParser->TplAssign($tpl, array(\'ID\'            => $hash[\'store_id\'],
                                            \'AMOUNT\'        => $hash[\'amount\'],
                                            \'MEAS\'          => htmlspecialchars($hash[\'store_meas\']),                                            
                                            \'PRICE\'         => MELBIS_INC_STD_number($hash[\'out_price\'], 0),
                                            \'NAME\'          => htmlspecialchars($hash[\'store_name\'])
                                            ));         
            $gParser->TplParse($tpl, \'ITEM\', \'.goods_item\');  
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'goods\');                
    }
    else
    {
        $gParser->TplParse($tpl, \'MAIN\', \'goods_empty\');
    }
    
    return $gParser->TplFree($tpl, \'MAIN\');     
}      


/** 
 * Function MELBIS_BASKET_fields
 **/
function MELBIS_BASKET_fields($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get fields
    if ( count($version[\'client\']) > 0 )
    {   
        foreach($version[\'client\'] as $hash )
        {
            if ( $hash[\'field_folder\'] == 1 )
            {
                $gParser->TplAssign($tpl, \'NAME\', htmlspecialchars($hash[\'field_name\']));
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_group\');
                continue;                        
            }
                                              
            $command = \"SELECT *
                          FROM {DBNICK}_field
                         WHERE id = \'$hash[field_id]\' 
                        \";                              
            $field = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_field_value
                         WHERE field_id = \'$field[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $field[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.fields_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'field_id\'],
                                                \'NAME\'  => htmlspecialchars($hash[\'field_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'field_id\'], 
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_txt\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'field_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.fields_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'fields\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
}      


/** 
 * Function MELBIS_BASKET_options
 **/
function MELBIS_BASKET_options($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get options
    if ( count($version[\'option\']) > 0 )
    {   
        foreach($version[\'option\'] as $hash )
        {     
            $command = \"SELECT *
                          FROM {DBNICK}_order_option
                         WHERE id = \'$hash[option_id]\' 
                        \";                              
            $option = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_order_option_value
                         WHERE option_id = \'$option[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $option[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.options_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'option_id\'],
                                                \'NAME\'  => htmlspecialchars($hash[\'option_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'OPTION\', \'.options_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'option_id\'],  
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_name\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'option_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.options_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'OPTION\', \'.options_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'options\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
} 


/** 
 * Function MELBIS_BASKET_auto_field
 **/
function MELBIS_BASKET_auto_field($mVars)
{ 
    global $gParser;       
                
    // Vars   
    $id = $mVars[\'post\'][\'id\']*1;                     
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_field_value
                 WHERE name LIKE \'%$query%\' 
                   AND field_id = \'$id\'                
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_auto_option
 **/
function MELBIS_BASKET_auto_option($mVars)
{ 
    global $gParser;       
                
    // Vars                                      
    $id = $mVars[\'post\'][\'id\']*1;
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_order_option_value                  
                 WHERE name LIKE \'%$query%\'
                   AND option_id = \'$id\'                 
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_save
 **/
function MELBIS_BASKET_save($mVars)
{ 
    global $gParser, $gSession; 
                               
    // Vars
    $data[\'result\'] = \'OK\';
    $data[\'message\'] = \'\';    
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }  
    
    // Update fields
    $rows = count($version[\'client\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'client\'][$i][\'field_id\'];
        $value_id = $mVars[\'post\'][\'field\'.$id.\'_id\'] ?? 0;        
        $version[\'client\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'client\'][$i][\'value_txt\'] = $mVars[\'post\'][\'field\'.$id.\'_text\'];
    }
        
    // Update options
    $rows = count($version[\'option\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'option\'][$i][\'option_id\'];
        $value_id = $mVars[\'post\'][\'option\'.$id.\'_id\'] ?? 0;        
        $version[\'option\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'option\'][$i][\'value_name\'] = $mVars[\'post\'][\'option\'.$id.\'_text\'];
    }
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
    
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);                                          

    // Verify cart    
    if ( count($version[\'store\']) == 0 )
    {  
        $data[\'result\'] = \'ERROR_EMPTY\';
        $data[\'message\'] = \'No goods found!\';    
        
        return json_encode($data);    
    }   

    // Verify calculation
    if ( $version[\'result\'][\'value\'] != \'OK\' )
    {
        $data[\'result\'] = $version[\'result\'][\'value\'];
        $data[\'message\'] = $version[\'result\'][\'message\'];
        
        return json_encode($data);  
    }     
    
    // Create order    
    $result = MELBIS_INC_LOGIC_order_edit($version);
    
    // Error exists?
    if ( $result[\'value\'] != \'OK\' )
    {  
        $data[\'result\'] = $result[\'value\'];
        $data[\'message\'] = $result[\'message\'];
        
        return json_encode($data);
    }
    else
    {
        // Close order session
        $gSession->RemoveValue(\'melbis_version\');
    }       
                        
    return json_encode($data);   
}       

?>','2025-03-31 22:47:04');
INSERT INTO `ms_user_file_version` VALUES ('626','1','./../templates/default/units/melbis_basket/goods_empty.htm','<h3 class=\"text-center m-4\">
   {TAG_EMPTY_BASKET}
</h3>','2025-03-31 22:48:46');
INSERT INTO `ms_user_file_version` VALUES ('627','1','./../templates/default/units/melbis_basket/goods_empty.htm','<h3 class=\"text-center m-4\">
   {TAG_EMPTY}
</h3>','2025-03-31 22:48:49');
INSERT INTO `ms_user_file_version` VALUES ('628','1','./../templates/default/units/melbis_store_image/image.htm','<div style=\"position: relative;\">
    <img src=\"{FILE}\" class=\"card-img-top p-4\">
    <div style=\"position: absolute; bottom: 10px; top: 10px; display: flex; gap: 5px;\">   
        {IMAGES}
    </div>
</div>','2025-03-31 22:51:41');
INSERT INTO `ms_user_file_version` VALUES ('629','1','./../templates/default/units/melbis_store_image/image.htm','<div style=\"position: relative;\">
    <img src=\"{FILE}\" class=\"card-img-top p-4\">
    <div style=\"position: absolute; top: 10px; left: 10px; display: flex; gap: 5px;\">   
        {IMAGES}
    </div>
</div>','2025-03-31 22:51:53');
INSERT INTO `ms_user_file_version` VALUES ('630','1','./../templates/default/units/melbis_store_image/image.htm','<div style=\"position: relative;\">
    <img src=\"{FILE}\" class=\"card-img-top p-4\">
    <div style=\"position: absolute; top: 200px; left: 10px; display: flex; gap: 5px;\">   
        {IMAGES}
    </div>
</div>','2025-03-31 22:52:04');
INSERT INTO `ms_user_file_version` VALUES ('631','1','./../templates/default/units/melbis_store_image/image.htm','<div style=\"position: relative;\">
    <img src=\"{FILE}\" class=\"card-img-top p-4\">
    <div style=\"position: absolute; top: 250px; left: 10px; display: flex; gap: 5px;\">   
        {IMAGES}
    </div>
</div>','2025-03-31 22:52:10');
INSERT INTO `ms_user_file_version` VALUES ('632','1','./../templates/default/units/melbis_store_image/image.htm','<div style=\"position: relative;\">
    <img src=\"{FILE}\" class=\"card-img-top p-4\">
    <div style=\"position: absolute; top: 3000px; left: 10px; display: flex; gap: 5px;\">   
        {IMAGES}
    </div>
</div>','2025-03-31 22:52:16');
INSERT INTO `ms_user_file_version` VALUES ('633','1','./../templates/default/units/melbis_store_image/image.htm','<div style=\"position: relative;\">
    <img src=\"{FILE}\" class=\"card-img-top p-4\">
    <div style=\"position: absolute; top: 300px; left: 10px; display: flex; gap: 5px;\">   
        {IMAGES}
    </div>
</div>','2025-03-31 22:52:18');
INSERT INTO `ms_user_file_version` VALUES ('634','1','./../templates/default/units/melbis_store_image/image.htm','<div style=\"position: relative;\">
    <img src=\"{FILE}\" class=\"card-img-top p-4\">
    <div style=\"position: absolute; top: 10px; left: 10px; display: flex; gap: 5px;\">   
        {IMAGES}
    </div>
</div>','2025-03-31 22:52:35');
INSERT INTO `ms_user_file_version` VALUES ('635','1','./../templates/default/units/melbis_store_image/image.htm','<div style=\"position: relative;\">
    <img src=\"{FILE}\" class=\"card-img-top p-1\">
    <div style=\"position: absolute; top: 10px; left: 10px; display: flex; gap: 5px;\">   
        {IMAGES}
    </div>
</div>','2025-03-31 22:53:05');
INSERT INTO `ms_user_file_version` VALUES ('636','1','./../templates/default/units/melbis_store_image/image.htm','<div style=\"position: relative;\">
    <img src=\"{FILE}\" class=\"card-img-top p-2 pt-4\">
    <div style=\"position: absolute; top: 10px; left: 10px; display: flex; gap: 5px;\">   
        {IMAGES}
    </div>
</div>','2025-03-31 22:53:25');
INSERT INTO `ms_user_file_version` VALUES ('637','1','./../templates/default/units/melbis_store_image/image.htm','<div style=\"position: relative;\">
    <img src=\"{FILE}\" class=\"card-img-top p-2\" style=\"padding-top: 50px;\">
    <div style=\"position: absolute; top: 10px; left: 10px; display: flex; gap: 5px;\">   
        {IMAGES}
    </div>
</div>','2025-03-31 22:54:01');
INSERT INTO `ms_user_file_version` VALUES ('638','1','./../templates/default/units/melbis_store_image/image.htm','<div style=\"position: relative;\">
    <img src=\"{FILE}\" class=\"card-img-top p-2\" style=\"padding-top: 150px;\">
    <div style=\"position: absolute; top: 10px; left: 10px; display: flex; gap: 5px;\">   
        {IMAGES}
    </div>
</div>','2025-03-31 22:54:07');
INSERT INTO `ms_user_file_version` VALUES ('639','1','./../templates/default/units/melbis_store_image/image.htm','<div style=\"position: relative;\">
    <img src=\"{FILE}\" class=\"card-img-top p-2\" style=\"padding-top: 150px;\">
    <div style=\"position: absolute; top: 10px; left: 10px; display: flex; gap: 5px;\">   
        {IMAGES}
    </div>
</div>','2025-03-31 22:54:22');
INSERT INTO `ms_user_file_version` VALUES ('640','1','./../templates/default/units/melbis_store_image/image.htm','<div style=\"position: relative;\">
    <img src=\"{FILE}\" class=\"card-img-top p-2\" style=\"margin-top: 150px;\">
    <div style=\"position: absolute; top: 10px; left: 10px; display: flex; gap: 5px;\">   
        {IMAGES}
    </div>
</div>','2025-03-31 22:54:37');
INSERT INTO `ms_user_file_version` VALUES ('641','1','./../templates/default/units/melbis_store_image/image.htm','<div style=\"position: relative;\">
    <img src=\"{FILE}\" class=\"card-img-top p-2\" style=\"margin-top: 50px;\">
    <div style=\"position: absolute; top: 10px; left: 10px; display: flex; gap: 5px;\">   
        {IMAGES}
    </div>
</div>','2025-03-31 22:54:46');
INSERT INTO `ms_user_file_version` VALUES ('642','1','./../templates/default/units/melbis_store_image/img.htm','<img src=\"{FILE}\" class=\"img-thumbnail\" style=\"width: 50px\" onclick=\"melbis_images($(this))\" style=\"cursor: poitner;\">','2025-03-31 22:55:39');
INSERT INTO `ms_user_file_version` VALUES ('643','1','./../templates/default/units/melbis_store_image/img.htm','<img src=\"{FILE}\" class=\"img-thumbnail\" style=\"width: 50px\" onclick=\"melbis_images($(this))\" style=\"cursor: pointer;\">','2025-03-31 22:55:41');
INSERT INTO `ms_user_file_version` VALUES ('644','1','./../templates/default/units/melbis_store_image/img.htm','<img src=\"{FILE}\" class=\"img-thumbnail\" style=\"width: 50px\" onclick=\"melbis_images($(this))\" style=\"cursor: hand;\">','2025-03-31 22:55:50');
INSERT INTO `ms_user_file_version` VALUES ('645','1','./../templates/default/units/melbis_store_image/img.htm','<img src=\"{FILE}\" class=\"img-thumbnail\" style=\"width: 50px\" onclick=\"melbis_images($(this))\" style=\"cursor: pointer;\">','2025-03-31 22:56:27');
INSERT INTO `ms_user_file_version` VALUES ('646','1','./../templates/default/units/melbis_store_image/img.htm','<img src=\"{FILE}\" class=\"img-thumbnail\" style=\"width: 50px\" onclick=\"melbis_images($(this))\" style=\"cursor: pointer;\">','2025-03-31 22:56:33');
INSERT INTO `ms_user_file_version` VALUES ('647','1','./../templates/default/units/melbis_store_image/img.htm','<img src=\"{FILE}\" class=\"img-thumbnail\" style=\"width: 50px\" onclick=\"melbis_images($(this))\" style=\"cursor: pointer;\">','2025-03-31 22:56:41');
INSERT INTO `ms_user_file_version` VALUES ('648','1','./../templates/default/units/melbis_store_image/img.htm','<div  style=\"cursor: pointer;\"><img src=\"{FILE}\" class=\"img-thumbnail\" style=\"width: 50px\" onclick=\"melbis_images($(this))\"></div>','2025-03-31 22:57:19');
INSERT INTO `ms_user_file_version` VALUES ('649','1','./../templates/default/units/melbis_store_image/img.htm','<div  style=\"cursor: pointer;\"><img src=\"{FILE}\" class=\"img-thumbnail\" style=\"width: 50px\" onclick=\"melbis_images($(this))\"></div>','2025-03-31 22:57:37');
INSERT INTO `ms_user_file_version` VALUES ('650','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    var src = img.parents(\'div\').prev().attr(\'src\');         
    img.parents(\'div\').prev().attr(\'src\', img.attr(\'src\'))
    img.attr(\'src\', src);
}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>\' + name + \'</p><p>{TAGS_GOODS_ADD}</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 22:58:53');
INSERT INTO `ms_user_file_version` VALUES ('651','1','./../templates/default/units/melbis_base_page/scripts.htm','<script type=\"text/javascript\">

// Change images
function melbis_images(img)
{
    var src = img.parents(\'div\').prev(\'img\').attr(\'src\');         
    img.parents(\'div\').prev(\'img\').attr(\'src\', img.attr(\'src\'))
    img.attr(\'src\', src);
}

// Add to basket
$(\'.melbis_goods\').on(\'click\', \'.melbis_btn_add\', function(event)
{
    var name = $(this).parents(\'.card\').find(\'h4\').text();
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'plus\', id: $(this).data(\'id\') },
        function(data) 
        {             
            $(\'#melbis_win_basket .modal-body\').html(\'<p>\' + name + \'</p><p>{TAGS_GOODS_ADD}</p>\');
            $(\'#melbis_win_basket\').modal(\'show\');                       
        }
    );    
});

// Remove from basket
$(\'#melbis_win_checkout\').on(\'click\', \'.melbis_btn_remove\', function(event)
{    
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\',        
        { func: \'minus\', id: $(this).data(\'id\') },
        function(data) 
        {                                     
            $(\'#melbis_order_goods\').html(data);                           
        }
    );    
});

// Go to checkout
$(\'#melbis_btn_checkout\').on(\'click\', function(event)
{
    $(\'#melbis_win_basket\').modal(\'hide\');
    $(\'#melbis_win_checkout\').modal(\'show\');      
});

// Load checkout
$(\'#melbis_win_checkout\').on(\'show.bs.modal\', function (event) 
{
    $(\'.alert\').hide();
    $(\'#melbis_order_fields\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_goods\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $(\'#melbis_order_options\').html(\'<li class=\"d-flex justify-content-center\"><div class=\"spinner-border m-3\"><span class=\"sr-only\"></span></div></li>\');
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'fields\' }, function(data) { $(\'#melbis_order_fields\').html(data); } );
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'goods\' }, function(data) { $(\'#melbis_order_goods\').html(data); } );
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'options\' }, function(data) { $(\'#melbis_order_options\').html(data); } );       
});


// Finish
$(\'#melbis_btn_finish\').on(\'click\', function(event)
{
    for( var item of $(\'#melbis_form_order select\') )
    { 
        $(item).prev(\'input\').val($(\'option:selected\', $(item)).text());
    }
        
    var form = $(\'#melbis_form_order\').melbis_serial();
    form.func = \'save\';
    $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', form, function(data) 
        {                     
            if ( data.result != \'OK\' )
            {
                $(\'.alert span\').html(\'[\' + data.result + \'] \' + data.message);
                $(\'.alert\').addClass(\'show\').show();        
            }
            else
            {
                $(\'#melbis_win_checkout\').modal(\'hide\');    
                $(\'#melbis_win_finish\').modal(\'show\');
            }         
        }, 
        \'json\');                
});

 

</script>','2025-03-31 23:02:23');
INSERT INTO `ms_user_file_version` VALUES ('652','1','./../templates/default/units/melbis_basket/goods.htm','<table class=\"table\">
  <thead class=\"thead-light\">
    <tr>
      <th scope=\"col\">#</th>
      <th scope=\"col\">{TAG_NAME}</th>
      <th scope=\"col\">{TAG_HOW}</th>
      <th scope=\"col\">{TAG_PRICE}</th>
      <th scope=\"col\">{TAG_OPER}</th>      
    </tr>
  </thead>
  <tbody>
    {ITEM}
  </tbody>
</table>','2025-04-01 08:58:16');
INSERT INTO `ms_user_file_version` VALUES ('653','1','./../templates/default/units/melbis_basket/goods_item.htm','<tr>
  <th scope=\"row\">{ID}</th>
  <td>{NAME}</td>
  <td>{AMOUNT} {MEAS}</td>
  <td>${PRICE}</td>
  <td><button type=\"button\" class=\"btn btn-warning melbis_btn_remove btn-sm\" data-id=\"{ID}\"><i class=\"fas fa-minus-circle\"></i> {TAG_DELETE}</button></td>
</tr>
','2025-04-01 08:58:57');
INSERT INTO `ms_user_file_version` VALUES ('654','1','./../templates/default/units/melbis_basket/goods_item.htm','<tr>
  <th scope=\"row\">{ID}</th>
  <td>{NAME}</td>
  <td>{AMOUNT} {MEAS}</td>
  <td>${PRICE}</td>
  <td><button type=\"button\" class=\"btn btn-warning melbis_btn_remove btn-sm\" data-id=\"{ID}\"><i class=\"fas fa-minus-circle\"></i> {TAG_DELETE}</button></td>
</tr>
','2025-04-01 08:59:16');
INSERT INTO `ms_user_file_version` VALUES ('655','1','./../units/melbis_basket.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASKET
 **/
function MELBIS_BASKET($mVars)
{ 
    global $gParser;  
    
    // Vars
    $func = __FUNCTION__.\'_\'.$mVars[\'post\'][\'func\'];
    
    // Call function    
    if ( function_exists($func) )
    {
        return call_user_func($func, $mVars);    
    }  
    else
    {
        return \'Function \'.$func.\' is absent!\';
    }     
} 


/** 
 * Function MELBIS_BASKET_plus
 **/
function MELBIS_BASKET_plus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Add goods
    $version = MELBIS_INC_LOGIC_order_goods_add($version, $store_id);
     
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);    
                        
    return \'\';                         
}    


/** 
 * Function MELBIS_BASKET_minus
 **/
function MELBIS_BASKET_minus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Remove goods
    $version = MELBIS_INC_LOGIC_order_goods_remove($version, $store_id);    
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);        
                               
    // Go to list
    return MELBIS_BASKET_goods($mVars);     
} 


/** 
 * Function MELBIS_BASKET_goods
 **/
function MELBIS_BASKET_goods($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);         
             
    // Get Goods
    if ( count($version[\'store\']) > 0 )
    {   
        foreach($version[\'store\'] as $hash )
        {
            $gParser->TplAssign($tpl, array(\'ID\'            => $hash[\'store_id\'],
                                            \'AMOUNT\'        => $hash[\'amount\'],
                                            \'PRICE\'         => MELBIS_INC_STD_number($hash[\'out_price\'], 0),
                                            \'NAME\'          => htmlspecialchars($hash[\'store_name\'])
                                            ));         
            $gParser->TplParse($tpl, \'ITEM\', \'.goods_item\');  
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'goods\');                
    }
    else
    {
        $gParser->TplParse($tpl, \'MAIN\', \'goods_empty\');
    }
    
    return $gParser->TplFree($tpl, \'MAIN\');     
}      


/** 
 * Function MELBIS_BASKET_fields
 **/
function MELBIS_BASKET_fields($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get fields
    if ( count($version[\'client\']) > 0 )
    {   
        foreach($version[\'client\'] as $hash )
        {
            if ( $hash[\'field_folder\'] == 1 )
            {
                $gParser->TplAssign($tpl, \'NAME\', htmlspecialchars($hash[\'field_name\']));
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_group\');
                continue;                        
            }
                                              
            $command = \"SELECT *
                          FROM {DBNICK}_field
                         WHERE id = \'$hash[field_id]\' 
                        \";                              
            $field = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_field_value
                         WHERE field_id = \'$field[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $field[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.fields_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'field_id\'],
                                                \'NAME\'  => htmlspecialchars($hash[\'field_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'field_id\'], 
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_txt\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'field_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.fields_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'fields\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
}      


/** 
 * Function MELBIS_BASKET_options
 **/
function MELBIS_BASKET_options($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get options
    if ( count($version[\'option\']) > 0 )
    {   
        foreach($version[\'option\'] as $hash )
        {     
            $command = \"SELECT *
                          FROM {DBNICK}_order_option
                         WHERE id = \'$hash[option_id]\' 
                        \";                              
            $option = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_order_option_value
                         WHERE option_id = \'$option[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $option[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.options_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'option_id\'],
                                                \'NAME\'  => htmlspecialchars($hash[\'option_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'OPTION\', \'.options_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'option_id\'],  
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_name\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'option_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.options_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'OPTION\', \'.options_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'options\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
} 


/** 
 * Function MELBIS_BASKET_auto_field
 **/
function MELBIS_BASKET_auto_field($mVars)
{ 
    global $gParser;       
                
    // Vars   
    $id = $mVars[\'post\'][\'id\']*1;                     
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_field_value
                 WHERE name LIKE \'%$query%\' 
                   AND field_id = \'$id\'                
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_auto_option
 **/
function MELBIS_BASKET_auto_option($mVars)
{ 
    global $gParser;       
                
    // Vars                                      
    $id = $mVars[\'post\'][\'id\']*1;
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_order_option_value                  
                 WHERE name LIKE \'%$query%\'
                   AND option_id = \'$id\'                 
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_save
 **/
function MELBIS_BASKET_save($mVars)
{ 
    global $gParser, $gSession; 
                               
    // Vars
    $data[\'result\'] = \'OK\';
    $data[\'message\'] = \'\';    
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }  
    
    // Update fields
    $rows = count($version[\'client\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'client\'][$i][\'field_id\'];
        $value_id = $mVars[\'post\'][\'field\'.$id.\'_id\'] ?? 0;        
        $version[\'client\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'client\'][$i][\'value_txt\'] = $mVars[\'post\'][\'field\'.$id.\'_text\'];
    }
        
    // Update options
    $rows = count($version[\'option\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'option\'][$i][\'option_id\'];
        $value_id = $mVars[\'post\'][\'option\'.$id.\'_id\'] ?? 0;        
        $version[\'option\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'option\'][$i][\'value_name\'] = $mVars[\'post\'][\'option\'.$id.\'_text\'];
    }
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
    
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);                                          

    // Verify cart    
    if ( count($version[\'store\']) == 0 )
    {  
        $data[\'result\'] = \'ERROR_EMPTY\';
        $data[\'message\'] = \'No goods found!\';    
        
        return json_encode($data);    
    }   

    // Verify calculation
    if ( $version[\'result\'][\'value\'] != \'OK\' )
    {
        $data[\'result\'] = $version[\'result\'][\'value\'];
        $data[\'message\'] = $version[\'result\'][\'message\'];
        
        return json_encode($data);  
    }     
    
    // Create order    
    $result = MELBIS_INC_LOGIC_order_edit($version);
    
    // Error exists?
    if ( $result[\'value\'] != \'OK\' )
    {  
        $data[\'result\'] = $result[\'value\'];
        $data[\'message\'] = $result[\'message\'];
        
        return json_encode($data);
    }
    else
    {
        // Close order session
        $gSession->RemoveValue(\'melbis_version\');
    }       
                        
    return json_encode($data);   
}       

?>','2025-04-01 09:02:19');
INSERT INTO `ms_user_file_version` VALUES ('656','1','./../units/melbis_basket.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASKET
 **/
function MELBIS_BASKET($mVars)
{ 
    global $gParser;  
    
    // Vars
    $func = __FUNCTION__.\'_\'.$mVars[\'post\'][\'func\'];
    
    // Call function    
    if ( function_exists($func) )
    {
        return call_user_func($func, $mVars);    
    }  
    else
    {
        return \'Function \'.$func.\' is absent!\';
    }     
} 


/** 
 * Function MELBIS_BASKET_plus
 **/
function MELBIS_BASKET_plus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Add goods
    $version = MELBIS_INC_LOGIC_order_goods_add($version, $store_id);
     
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);    
                        
    return \'\';                         
}    


/** 
 * Function MELBIS_BASKET_minus
 **/
function MELBIS_BASKET_minus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Remove goods
    $version = MELBIS_INC_LOGIC_order_goods_remove($version, $store_id);    
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);        
                               
    // Go to list
    return MELBIS_BASKET_goods($mVars);     
} 


/** 
 * Function MELBIS_BASKET_goods
 **/
function MELBIS_BASKET_goods($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);         
             
    // Get Goods
    if ( count($version[\'store\']) > 0 )
    {   
        foreach($version[\'store\'] as $hash )
        {
            $gParser->TplAssign($tpl, array(\'ID\'            => $hash[\'store_id\'],
                                            \'AMOUNT\'        => $hash[\'amount\'],
                                            \'PRICE\'         => MELBIS_INC_STD_number($hash[\'out_price\'], 0),
                                            \'NAME\'          => MELBIS_INC_LANG(\'kStore\', \'NAME\', $hash[\'store_id\'], $hash[\'store_name\'])
                                            ));         
            $gParser->TplParse($tpl, \'ITEM\', \'.goods_item\');  
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'goods\');                
    }
    else
    {
        $gParser->TplParse($tpl, \'MAIN\', \'goods_empty\');
    }
    
    return $gParser->TplFree($tpl, \'MAIN\');     
}      


/** 
 * Function MELBIS_BASKET_fields
 **/
function MELBIS_BASKET_fields($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get fields
    if ( count($version[\'client\']) > 0 )
    {   
        foreach($version[\'client\'] as $hash )
        {
            if ( $hash[\'field_folder\'] == 1 )
            {
                $gParser->TplAssign($tpl, \'NAME\', htmlspecialchars($hash[\'field_name\']));
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_group\');
                continue;                        
            }
                                              
            $command = \"SELECT *
                          FROM {DBNICK}_field
                         WHERE id = \'$hash[field_id]\' 
                        \";                              
            $field = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_field_value
                         WHERE field_id = \'$field[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $field[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.fields_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'field_id\'],
                                                \'NAME\'  => htmlspecialchars($hash[\'field_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'field_id\'], 
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_txt\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'field_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.fields_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'fields\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
}      


/** 
 * Function MELBIS_BASKET_options
 **/
function MELBIS_BASKET_options($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get options
    if ( count($version[\'option\']) > 0 )
    {   
        foreach($version[\'option\'] as $hash )
        {     
            $command = \"SELECT *
                          FROM {DBNICK}_order_option
                         WHERE id = \'$hash[option_id]\' 
                        \";                              
            $option = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_order_option_value
                         WHERE option_id = \'$option[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $option[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.options_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'option_id\'],
                                                \'NAME\'  => htmlspecialchars($hash[\'option_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'OPTION\', \'.options_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'option_id\'],  
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_name\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'option_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.options_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'OPTION\', \'.options_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'options\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
} 


/** 
 * Function MELBIS_BASKET_auto_field
 **/
function MELBIS_BASKET_auto_field($mVars)
{ 
    global $gParser;       
                
    // Vars   
    $id = $mVars[\'post\'][\'id\']*1;                     
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_field_value
                 WHERE name LIKE \'%$query%\' 
                   AND field_id = \'$id\'                
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_auto_option
 **/
function MELBIS_BASKET_auto_option($mVars)
{ 
    global $gParser;       
                
    // Vars                                      
    $id = $mVars[\'post\'][\'id\']*1;
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_order_option_value                  
                 WHERE name LIKE \'%$query%\'
                   AND option_id = \'$id\'                 
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_save
 **/
function MELBIS_BASKET_save($mVars)
{ 
    global $gParser, $gSession; 
                               
    // Vars
    $data[\'result\'] = \'OK\';
    $data[\'message\'] = \'\';    
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }  
    
    // Update fields
    $rows = count($version[\'client\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'client\'][$i][\'field_id\'];
        $value_id = $mVars[\'post\'][\'field\'.$id.\'_id\'] ?? 0;        
        $version[\'client\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'client\'][$i][\'value_txt\'] = $mVars[\'post\'][\'field\'.$id.\'_text\'];
    }
        
    // Update options
    $rows = count($version[\'option\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'option\'][$i][\'option_id\'];
        $value_id = $mVars[\'post\'][\'option\'.$id.\'_id\'] ?? 0;        
        $version[\'option\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'option\'][$i][\'value_name\'] = $mVars[\'post\'][\'option\'.$id.\'_text\'];
    }
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
    
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);                                          

    // Verify cart    
    if ( count($version[\'store\']) == 0 )
    {  
        $data[\'result\'] = \'ERROR_EMPTY\';
        $data[\'message\'] = \'No goods found!\';    
        
        return json_encode($data);    
    }   

    // Verify calculation
    if ( $version[\'result\'][\'value\'] != \'OK\' )
    {
        $data[\'result\'] = $version[\'result\'][\'value\'];
        $data[\'message\'] = $version[\'result\'][\'message\'];
        
        return json_encode($data);  
    }     
    
    // Create order    
    $result = MELBIS_INC_LOGIC_order_edit($version);
    
    // Error exists?
    if ( $result[\'value\'] != \'OK\' )
    {  
        $data[\'result\'] = $result[\'value\'];
        $data[\'message\'] = $result[\'message\'];
        
        return json_encode($data);
    }
    else
    {
        // Close order session
        $gSession->RemoveValue(\'melbis_version\');
    }       
                        
    return json_encode($data);   
}       

?>','2025-04-01 09:03:27');
INSERT INTO `ms_user_file_version` VALUES ('657','1','./../templates/default/units/melbis_basket/goods_item.htm','<tr>
  <th scope=\"row\">{ID}</th>
  <td>{NAME}</td>
  <td>{AMOUNT}</td>
  <td>${PRICE}</td>
  <td><button type=\"button\" class=\"btn btn-warning melbis_btn_remove btn-sm\" data-id=\"{ID}\"><i class=\"fas fa-minus-circle\"></i> {TAG_DELETE}</button></td>
</tr>
','2025-04-01 09:04:44');
INSERT INTO `ms_user_file_version` VALUES ('658','1','./../templates/default/units/melbis_basket/fields_text_auto.htm','<input type=\"hidden\" name=\"field{ID}_id\" value=\"{VALUE_ID}\">

<script>

$(\'input[name=field{ID}_text]\').autocomplete(
{    
    lookup: function (query, done) 
    {
        $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'auto_field\', query: query, id: {ID} }, function(data) { done(data); }, \'json\');        
    },
    onSelect: function (sugg) 
    {
        $(\'input[name=field{ID}_id\').val(sugg.data);
    }
});

</script>
','2025-04-01 09:12:43');
INSERT INTO `ms_user_file_version` VALUES ('659','1','./../units/melbis_basket.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASKET
 **/
function MELBIS_BASKET($mVars)
{ 
    global $gParser;  
    
    // Vars
    $func = __FUNCTION__.\'_\'.$mVars[\'post\'][\'func\'];
    
    // Call function    
    if ( function_exists($func) )
    {
        return call_user_func($func, $mVars);    
    }  
    else
    {
        return \'Function \'.$func.\' is absent!\';
    }     
} 


/** 
 * Function MELBIS_BASKET_plus
 **/
function MELBIS_BASKET_plus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Add goods
    $version = MELBIS_INC_LOGIC_order_goods_add($version, $store_id);
     
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);    
                        
    return \'\';                         
}    


/** 
 * Function MELBIS_BASKET_minus
 **/
function MELBIS_BASKET_minus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Remove goods
    $version = MELBIS_INC_LOGIC_order_goods_remove($version, $store_id);    
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);        
                               
    // Go to list
    return MELBIS_BASKET_goods($mVars);     
} 


/** 
 * Function MELBIS_BASKET_goods
 **/
function MELBIS_BASKET_goods($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);         
             
    // Get Goods
    if ( count($version[\'store\']) > 0 )
    {   
        foreach($version[\'store\'] as $hash )
        {
            $gParser->TplAssign($tpl, array(\'ID\'            => $hash[\'store_id\'],
                                            \'AMOUNT\'        => $hash[\'amount\'],
                                            \'PRICE\'         => MELBIS_INC_STD_number($hash[\'out_price\'], 0),
                                            \'NAME\'          => MELBIS_INC_LANG(\'kStore\', \'NAME\', $hash[\'store_id\'], $hash[\'store_name\'])
                                            ));         
            $gParser->TplParse($tpl, \'ITEM\', \'.goods_item\');  
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'goods\');                
    }
    else
    {
        $gParser->TplParse($tpl, \'MAIN\', \'goods_empty\');
    }
    
    return $gParser->TplFree($tpl, \'MAIN\');     
}      


/** 
 * Function MELBIS_BASKET_fields
 **/
function MELBIS_BASKET_fields($mVars)
{ 
    global $gParser, $gSession; 
    
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];      
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get fields
    if ( count($version[\'client\']) > 0 )
    {   
        foreach($version[\'client\'] as $hash )
        {
            if ( $hash[\'field_folder\'] == 1 )
            {
                $gParser->TplAssign($tpl, \'NAME\', htmlspecialchars($hash[\'field_name\']));
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_group\');
                continue;                        
            }
                                              
            $command = \"SELECT *
                          FROM {DBNICK}_field
                         WHERE id = \'$hash[field_id]\' 
                        \";                              
            $field = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_field_value
                         WHERE field_id = \'$field[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $field[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.fields_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'field_id\'],
                                                \'NAME\'  => htmlspecialchars($hash[\'field_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'field_id\'], 
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_txt\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'field_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.fields_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'fields\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
}      


/** 
 * Function MELBIS_BASKET_options
 **/
function MELBIS_BASKET_options($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get options
    if ( count($version[\'option\']) > 0 )
    {   
        foreach($version[\'option\'] as $hash )
        {     
            $command = \"SELECT *
                          FROM {DBNICK}_order_option
                         WHERE id = \'$hash[option_id]\' 
                        \";                              
            $option = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_order_option_value
                         WHERE option_id = \'$option[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $option[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.options_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'option_id\'],
                                                \'NAME\'  => htmlspecialchars($hash[\'option_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'OPTION\', \'.options_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'option_id\'],  
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_name\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'option_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.options_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'OPTION\', \'.options_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'options\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
} 


/** 
 * Function MELBIS_BASKET_auto_field
 **/
function MELBIS_BASKET_auto_field($mVars)
{ 
    global $gParser;       
                
    // Vars   
    $id = $mVars[\'post\'][\'id\']*1;                     
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_field_value
                 WHERE name LIKE \'%$query%\' 
                   AND field_id = \'$id\'                
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_auto_option
 **/
function MELBIS_BASKET_auto_option($mVars)
{ 
    global $gParser;       
                
    // Vars                                      
    $id = $mVars[\'post\'][\'id\']*1;
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_order_option_value                  
                 WHERE name LIKE \'%$query%\'
                   AND option_id = \'$id\'                 
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_save
 **/
function MELBIS_BASKET_save($mVars)
{ 
    global $gParser, $gSession; 
                               
    // Vars
    $data[\'result\'] = \'OK\';
    $data[\'message\'] = \'\';    
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }  
    
    // Update fields
    $rows = count($version[\'client\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'client\'][$i][\'field_id\'];
        $value_id = $mVars[\'post\'][\'field\'.$id.\'_id\'] ?? 0;        
        $version[\'client\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'client\'][$i][\'value_txt\'] = $mVars[\'post\'][\'field\'.$id.\'_text\'];
    }
        
    // Update options
    $rows = count($version[\'option\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'option\'][$i][\'option_id\'];
        $value_id = $mVars[\'post\'][\'option\'.$id.\'_id\'] ?? 0;        
        $version[\'option\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'option\'][$i][\'value_name\'] = $mVars[\'post\'][\'option\'.$id.\'_text\'];
    }
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
    
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);                                          

    // Verify cart    
    if ( count($version[\'store\']) == 0 )
    {  
        $data[\'result\'] = \'ERROR_EMPTY\';
        $data[\'message\'] = \'No goods found!\';    
        
        return json_encode($data);    
    }   

    // Verify calculation
    if ( $version[\'result\'][\'value\'] != \'OK\' )
    {
        $data[\'result\'] = $version[\'result\'][\'value\'];
        $data[\'message\'] = $version[\'result\'][\'message\'];
        
        return json_encode($data);  
    }     
    
    // Create order    
    $result = MELBIS_INC_LOGIC_order_edit($version);
    
    // Error exists?
    if ( $result[\'value\'] != \'OK\' )
    {  
        $data[\'result\'] = $result[\'value\'];
        $data[\'message\'] = $result[\'message\'];
        
        return json_encode($data);
    }
    else
    {
        // Close order session
        $gSession->RemoveValue(\'melbis_version\');
    }       
                        
    return json_encode($data);   
}       

?>','2025-04-01 09:13:33');
INSERT INTO `ms_user_file_version` VALUES ('660','1','./../units/melbis_basket.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASKET
 **/
function MELBIS_BASKET($mVars)
{ 
    global $gParser;  
    
    // Vars
    $func = __FUNCTION__.\'_\'.$mVars[\'post\'][\'func\'];
    
    // Call function    
    if ( function_exists($func) )
    {
        return call_user_func($func, $mVars);    
    }  
    else
    {
        return \'Function \'.$func.\' is absent!\';
    }     
} 


/** 
 * Function MELBIS_BASKET_plus
 **/
function MELBIS_BASKET_plus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Add goods
    $version = MELBIS_INC_LOGIC_order_goods_add($version, $store_id);
     
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);    
                        
    return \'\';                         
}    


/** 
 * Function MELBIS_BASKET_minus
 **/
function MELBIS_BASKET_minus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Remove goods
    $version = MELBIS_INC_LOGIC_order_goods_remove($version, $store_id);    
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);        
                               
    // Go to list
    return MELBIS_BASKET_goods($mVars);     
} 


/** 
 * Function MELBIS_BASKET_goods
 **/
function MELBIS_BASKET_goods($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);         
             
    // Get Goods
    if ( count($version[\'store\']) > 0 )
    {   
        foreach($version[\'store\'] as $hash )
        {
            $gParser->TplAssign($tpl, array(\'ID\'            => $hash[\'store_id\'],
                                            \'AMOUNT\'        => $hash[\'amount\'],
                                            \'PRICE\'         => MELBIS_INC_STD_number($hash[\'out_price\'], 0),
                                            \'NAME\'          => MELBIS_INC_LANG(\'kStore\', \'NAME\', $hash[\'store_id\'], $hash[\'store_name\'])
                                            ));         
            $gParser->TplParse($tpl, \'ITEM\', \'.goods_item\');  
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'goods\');                
    }
    else
    {
        $gParser->TplParse($tpl, \'MAIN\', \'goods_empty\');
    }
    
    return $gParser->TplFree($tpl, \'MAIN\');     
}      


/** 
 * Function MELBIS_BASKET_fields
 **/
function MELBIS_BASKET_fields($mVars)
{ 
    global $gParser, $gSession; 
                                        
    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];      
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get fields
    if ( count($version[\'client\']) > 0 )
    {   
        foreach($version[\'client\'] as $hash )
        {
            if ( $hash[\'field_folder\'] == 1 )
            {
                $gParser->TplAssign($tpl, \'NAME\', htmlspecialchars($hash[\'field_name\']));
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_group\');
                continue;                        
            }
                                              
            $command = \"SELECT *
                          FROM {DBNICK}_field
                         WHERE id = \'$hash[field_id]\' 
                        \";                              
            $field = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_field_value
                         WHERE field_id = \'$field[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $field[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.fields_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'field_id\'],
                                                \'NAME\'  => htmlspecialchars($hash[\'field_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'field_id\'], 
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_txt\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'field_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.fields_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'fields\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
}      


/** 
 * Function MELBIS_BASKET_options
 **/
function MELBIS_BASKET_options($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get options
    if ( count($version[\'option\']) > 0 )
    {   
        foreach($version[\'option\'] as $hash )
        {     
            $command = \"SELECT *
                          FROM {DBNICK}_order_option
                         WHERE id = \'$hash[option_id]\' 
                        \";                              
            $option = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_order_option_value
                         WHERE option_id = \'$option[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $option[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.options_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'option_id\'],
                                                \'NAME\'  => htmlspecialchars($hash[\'option_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'OPTION\', \'.options_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'option_id\'],  
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_name\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'option_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.options_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'OPTION\', \'.options_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'options\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
} 


/** 
 * Function MELBIS_BASKET_auto_field
 **/
function MELBIS_BASKET_auto_field($mVars)
{ 
    global $gParser;       
                
    // Vars   
    $id = $mVars[\'post\'][\'id\']*1;                     
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_field_value
                 WHERE name LIKE \'%$query%\' 
                   AND field_id = \'$id\'                
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_auto_option
 **/
function MELBIS_BASKET_auto_option($mVars)
{ 
    global $gParser;       
                
    // Vars                                      
    $id = $mVars[\'post\'][\'id\']*1;
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_order_option_value                  
                 WHERE name LIKE \'%$query%\'
                   AND option_id = \'$id\'                 
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_save
 **/
function MELBIS_BASKET_save($mVars)
{ 
    global $gParser, $gSession; 
                               
    // Vars
    $data[\'result\'] = \'OK\';
    $data[\'message\'] = \'\';    
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }  
    
    // Update fields
    $rows = count($version[\'client\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'client\'][$i][\'field_id\'];
        $value_id = $mVars[\'post\'][\'field\'.$id.\'_id\'] ?? 0;        
        $version[\'client\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'client\'][$i][\'value_txt\'] = $mVars[\'post\'][\'field\'.$id.\'_text\'];
    }
        
    // Update options
    $rows = count($version[\'option\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'option\'][$i][\'option_id\'];
        $value_id = $mVars[\'post\'][\'option\'.$id.\'_id\'] ?? 0;        
        $version[\'option\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'option\'][$i][\'value_name\'] = $mVars[\'post\'][\'option\'.$id.\'_text\'];
    }
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
    
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);                                          

    // Verify cart    
    if ( count($version[\'store\']) == 0 )
    {  
        $data[\'result\'] = \'ERROR_EMPTY\';
        $data[\'message\'] = \'No goods found!\';    
        
        return json_encode($data);    
    }   

    // Verify calculation
    if ( $version[\'result\'][\'value\'] != \'OK\' )
    {
        $data[\'result\'] = $version[\'result\'][\'value\'];
        $data[\'message\'] = $version[\'result\'][\'message\'];
        
        return json_encode($data);  
    }     
    
    // Create order    
    $result = MELBIS_INC_LOGIC_order_edit($version);
    
    // Error exists?
    if ( $result[\'value\'] != \'OK\' )
    {  
        $data[\'result\'] = $result[\'value\'];
        $data[\'message\'] = $result[\'message\'];
        
        return json_encode($data);
    }
    else
    {
        // Close order session
        $gSession->RemoveValue(\'melbis_version\');
    }       
                        
    return json_encode($data);   
}       

?>','2025-04-01 09:13:42');
INSERT INTO `ms_user_file_version` VALUES ('661','1','./../units/melbis_basket.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASKET
 **/
function MELBIS_BASKET($mVars)
{ 
    global $gParser;  
    
    // Vars
    $func = __FUNCTION__.\'_\'.$mVars[\'post\'][\'func\'];
    
    // Call function    
    if ( function_exists($func) )
    {
        return call_user_func($func, $mVars);    
    }  
    else
    {
        return \'Function \'.$func.\' is absent!\';
    }     
} 


/** 
 * Function MELBIS_BASKET_plus
 **/
function MELBIS_BASKET_plus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Add goods
    $version = MELBIS_INC_LOGIC_order_goods_add($version, $store_id);
     
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);    
                        
    return \'\';                         
}    


/** 
 * Function MELBIS_BASKET_minus
 **/
function MELBIS_BASKET_minus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Remove goods
    $version = MELBIS_INC_LOGIC_order_goods_remove($version, $store_id);    
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);        
                               
    // Go to list
    return MELBIS_BASKET_goods($mVars);     
} 


/** 
 * Function MELBIS_BASKET_goods
 **/
function MELBIS_BASKET_goods($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);         
             
    // Get Goods
    if ( count($version[\'store\']) > 0 )
    {   
        foreach($version[\'store\'] as $hash )
        {
            $gParser->TplAssign($tpl, array(\'ID\'            => $hash[\'store_id\'],
                                            \'AMOUNT\'        => $hash[\'amount\'],
                                            \'PRICE\'         => MELBIS_INC_STD_number($hash[\'out_price\'], 0),
                                            \'NAME\'          => MELBIS_INC_LANG(\'kStore\', \'NAME\', $hash[\'store_id\'], $hash[\'store_name\'])
                                            ));         
            $gParser->TplParse($tpl, \'ITEM\', \'.goods_item\');  
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'goods\');                
    }
    else
    {
        $gParser->TplParse($tpl, \'MAIN\', \'goods_empty\');
    }
    
    return $gParser->TplFree($tpl, \'MAIN\');     
}      


/** 
 * Function MELBIS_BASKET_fields
 **/
function MELBIS_BASKET_fields($mVars)
{ 
    global $gParser, $gSession; 
                                        
    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];      
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get fields
    if ( count($version[\'client\']) > 0 )
    {   
        foreach($version[\'client\'] as $hash )
        {
            if ( $hash[\'field_folder\'] == 1 )
            {
                $gParser->TplAssign($tpl, \'NAME\', MELBIS_INC_LANG(\'kClient\', \'NAME\', $hash[\'field_id\'], $hash[\'field_name\']));
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_group\');
                continue;                        
            }
                                              
            $command = \"SELECT *
                          FROM {DBNICK}_field
                         WHERE id = \'$hash[field_id]\' 
                        \";                              
            $field = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_field_value
                         WHERE field_id = \'$field[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $field[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.fields_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'field_id\'],
                                                \'NAME\'  => htmlspecialchars($hash[\'field_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'field_id\'], 
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_txt\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'field_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.fields_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'fields\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
}      


/** 
 * Function MELBIS_BASKET_options
 **/
function MELBIS_BASKET_options($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get options
    if ( count($version[\'option\']) > 0 )
    {   
        foreach($version[\'option\'] as $hash )
        {     
            $command = \"SELECT *
                          FROM {DBNICK}_order_option
                         WHERE id = \'$hash[option_id]\' 
                        \";                              
            $option = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_order_option_value
                         WHERE option_id = \'$option[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $option[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.options_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'option_id\'],
                                                \'NAME\'  => htmlspecialchars($hash[\'option_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'OPTION\', \'.options_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'option_id\'],  
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_name\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'option_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.options_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'OPTION\', \'.options_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'options\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
} 


/** 
 * Function MELBIS_BASKET_auto_field
 **/
function MELBIS_BASKET_auto_field($mVars)
{ 
    global $gParser;       
                
    // Vars   
    $id = $mVars[\'post\'][\'id\']*1;                     
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_field_value
                 WHERE name LIKE \'%$query%\' 
                   AND field_id = \'$id\'                
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_auto_option
 **/
function MELBIS_BASKET_auto_option($mVars)
{ 
    global $gParser;       
                
    // Vars                                      
    $id = $mVars[\'post\'][\'id\']*1;
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_order_option_value                  
                 WHERE name LIKE \'%$query%\'
                   AND option_id = \'$id\'                 
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_save
 **/
function MELBIS_BASKET_save($mVars)
{ 
    global $gParser, $gSession; 
                               
    // Vars
    $data[\'result\'] = \'OK\';
    $data[\'message\'] = \'\';    
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }  
    
    // Update fields
    $rows = count($version[\'client\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'client\'][$i][\'field_id\'];
        $value_id = $mVars[\'post\'][\'field\'.$id.\'_id\'] ?? 0;        
        $version[\'client\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'client\'][$i][\'value_txt\'] = $mVars[\'post\'][\'field\'.$id.\'_text\'];
    }
        
    // Update options
    $rows = count($version[\'option\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'option\'][$i][\'option_id\'];
        $value_id = $mVars[\'post\'][\'option\'.$id.\'_id\'] ?? 0;        
        $version[\'option\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'option\'][$i][\'value_name\'] = $mVars[\'post\'][\'option\'.$id.\'_text\'];
    }
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
    
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);                                          

    // Verify cart    
    if ( count($version[\'store\']) == 0 )
    {  
        $data[\'result\'] = \'ERROR_EMPTY\';
        $data[\'message\'] = \'No goods found!\';    
        
        return json_encode($data);    
    }   

    // Verify calculation
    if ( $version[\'result\'][\'value\'] != \'OK\' )
    {
        $data[\'result\'] = $version[\'result\'][\'value\'];
        $data[\'message\'] = $version[\'result\'][\'message\'];
        
        return json_encode($data);  
    }     
    
    // Create order    
    $result = MELBIS_INC_LOGIC_order_edit($version);
    
    // Error exists?
    if ( $result[\'value\'] != \'OK\' )
    {  
        $data[\'result\'] = $result[\'value\'];
        $data[\'message\'] = $result[\'message\'];
        
        return json_encode($data);
    }
    else
    {
        // Close order session
        $gSession->RemoveValue(\'melbis_version\');
    }       
                        
    return json_encode($data);   
}       

?>','2025-04-01 09:31:12');
INSERT INTO `ms_user_file_version` VALUES ('662','1','./../units/melbis_basket.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASKET
 **/
function MELBIS_BASKET($mVars)
{ 
    global $gParser;  
    
    // Vars
    $func = __FUNCTION__.\'_\'.$mVars[\'post\'][\'func\'];
    
    // Call function    
    if ( function_exists($func) )
    {
        return call_user_func($func, $mVars);    
    }  
    else
    {
        return \'Function \'.$func.\' is absent!\';
    }     
} 


/** 
 * Function MELBIS_BASKET_plus
 **/
function MELBIS_BASKET_plus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Add goods
    $version = MELBIS_INC_LOGIC_order_goods_add($version, $store_id);
     
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);    
                        
    return \'\';                         
}    


/** 
 * Function MELBIS_BASKET_minus
 **/
function MELBIS_BASKET_minus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Remove goods
    $version = MELBIS_INC_LOGIC_order_goods_remove($version, $store_id);    
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);        
                               
    // Go to list
    return MELBIS_BASKET_goods($mVars);     
} 


/** 
 * Function MELBIS_BASKET_goods
 **/
function MELBIS_BASKET_goods($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);         
             
    // Get Goods
    if ( count($version[\'store\']) > 0 )
    {   
        foreach($version[\'store\'] as $hash )
        {
            $gParser->TplAssign($tpl, array(\'ID\'            => $hash[\'store_id\'],
                                            \'AMOUNT\'        => $hash[\'amount\'],
                                            \'PRICE\'         => MELBIS_INC_STD_number($hash[\'out_price\'], 0),
                                            \'NAME\'          => MELBIS_INC_LANG(\'kStore\', \'NAME\', $hash[\'store_id\'], $hash[\'store_name\'])
                                            ));         
            $gParser->TplParse($tpl, \'ITEM\', \'.goods_item\');  
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'goods\');                
    }
    else
    {
        $gParser->TplParse($tpl, \'MAIN\', \'goods_empty\');
    }
    
    return $gParser->TplFree($tpl, \'MAIN\');     
}      


/** 
 * Function MELBIS_BASKET_fields
 **/
function MELBIS_BASKET_fields($mVars)
{ 
    global $gParser, $gSession; 
                                        
    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];      
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get fields
    if ( count($version[\'client\']) > 0 )
    {   
        foreach($version[\'client\'] as $hash )
        {
            if ( $hash[\'field_folder\'] == 1 )
            {
                $gParser->TplAssign($tpl, \'FIELD\', MELBIS_INC_LANG(\'kClient\', \'NAME\', $hash[\'field_id\'], $hash[\'field_name\']));
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_group\');
                continue;                        
            }
                                              
            $command = \"SELECT *
                          FROM {DBNICK}_field
                         WHERE id = \'$hash[field_id]\' 
                        \";                              
            $field = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_field_value
                         WHERE field_id = \'$field[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $field[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.fields_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'field_id\'],
                                                \'NAME\'  => htmlspecialchars($hash[\'field_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'field_id\'], 
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_txt\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'field_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.fields_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'fields\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
}      


/** 
 * Function MELBIS_BASKET_options
 **/
function MELBIS_BASKET_options($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get options
    if ( count($version[\'option\']) > 0 )
    {   
        foreach($version[\'option\'] as $hash )
        {     
            $command = \"SELECT *
                          FROM {DBNICK}_order_option
                         WHERE id = \'$hash[option_id]\' 
                        \";                              
            $option = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_order_option_value
                         WHERE option_id = \'$option[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $option[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.options_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'option_id\'],
                                                \'NAME\'  => htmlspecialchars($hash[\'option_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'OPTION\', \'.options_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'option_id\'],  
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_name\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'option_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.options_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'OPTION\', \'.options_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'options\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
} 


/** 
 * Function MELBIS_BASKET_auto_field
 **/
function MELBIS_BASKET_auto_field($mVars)
{ 
    global $gParser;       
                
    // Vars   
    $id = $mVars[\'post\'][\'id\']*1;                     
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_field_value
                 WHERE name LIKE \'%$query%\' 
                   AND field_id = \'$id\'                
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_auto_option
 **/
function MELBIS_BASKET_auto_option($mVars)
{ 
    global $gParser;       
                
    // Vars                                      
    $id = $mVars[\'post\'][\'id\']*1;
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_order_option_value                  
                 WHERE name LIKE \'%$query%\'
                   AND option_id = \'$id\'                 
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_save
 **/
function MELBIS_BASKET_save($mVars)
{ 
    global $gParser, $gSession; 
                               
    // Vars
    $data[\'result\'] = \'OK\';
    $data[\'message\'] = \'\';    
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }  
    
    // Update fields
    $rows = count($version[\'client\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'client\'][$i][\'field_id\'];
        $value_id = $mVars[\'post\'][\'field\'.$id.\'_id\'] ?? 0;        
        $version[\'client\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'client\'][$i][\'value_txt\'] = $mVars[\'post\'][\'field\'.$id.\'_text\'];
    }
        
    // Update options
    $rows = count($version[\'option\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'option\'][$i][\'option_id\'];
        $value_id = $mVars[\'post\'][\'option\'.$id.\'_id\'] ?? 0;        
        $version[\'option\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'option\'][$i][\'value_name\'] = $mVars[\'post\'][\'option\'.$id.\'_text\'];
    }
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
    
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);                                          

    // Verify cart    
    if ( count($version[\'store\']) == 0 )
    {  
        $data[\'result\'] = \'ERROR_EMPTY\';
        $data[\'message\'] = \'No goods found!\';    
        
        return json_encode($data);    
    }   

    // Verify calculation
    if ( $version[\'result\'][\'value\'] != \'OK\' )
    {
        $data[\'result\'] = $version[\'result\'][\'value\'];
        $data[\'message\'] = $version[\'result\'][\'message\'];
        
        return json_encode($data);  
    }     
    
    // Create order    
    $result = MELBIS_INC_LOGIC_order_edit($version);
    
    // Error exists?
    if ( $result[\'value\'] != \'OK\' )
    {  
        $data[\'result\'] = $result[\'value\'];
        $data[\'message\'] = $result[\'message\'];
        
        return json_encode($data);
    }
    else
    {
        // Close order session
        $gSession->RemoveValue(\'melbis_version\');
    }       
                        
    return json_encode($data);   
}       

?>','2025-04-01 09:31:55');
INSERT INTO `ms_user_file_version` VALUES ('663','1','./../units/melbis_basket.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASKET
 **/
function MELBIS_BASKET($mVars)
{ 
    global $gParser;  
    
    // Vars
    $func = __FUNCTION__.\'_\'.$mVars[\'post\'][\'func\'];
    
    // Call function    
    if ( function_exists($func) )
    {
        return call_user_func($func, $mVars);    
    }  
    else
    {
        return \'Function \'.$func.\' is absent!\';
    }     
} 


/** 
 * Function MELBIS_BASKET_plus
 **/
function MELBIS_BASKET_plus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Add goods
    $version = MELBIS_INC_LOGIC_order_goods_add($version, $store_id);
     
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);    
                        
    return \'\';                         
}    


/** 
 * Function MELBIS_BASKET_minus
 **/
function MELBIS_BASKET_minus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Remove goods
    $version = MELBIS_INC_LOGIC_order_goods_remove($version, $store_id);    
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);        
                               
    // Go to list
    return MELBIS_BASKET_goods($mVars);     
} 


/** 
 * Function MELBIS_BASKET_goods
 **/
function MELBIS_BASKET_goods($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);         
             
    // Get Goods
    if ( count($version[\'store\']) > 0 )
    {   
        foreach($version[\'store\'] as $hash )
        {
            $gParser->TplAssign($tpl, array(\'ID\'            => $hash[\'store_id\'],
                                            \'AMOUNT\'        => $hash[\'amount\'],
                                            \'PRICE\'         => MELBIS_INC_STD_number($hash[\'out_price\'], 0),
                                            \'NAME\'          => MELBIS_INC_LANG(\'kStore\', \'NAME\', $hash[\'store_id\'], $hash[\'store_name\'])
                                            ));         
            $gParser->TplParse($tpl, \'ITEM\', \'.goods_item\');  
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'goods\');                
    }
    else
    {
        $gParser->TplParse($tpl, \'MAIN\', \'goods_empty\');
    }
    
    return $gParser->TplFree($tpl, \'MAIN\');     
}      


/** 
 * Function MELBIS_BASKET_fields
 **/
function MELBIS_BASKET_fields($mVars)
{ 
    global $gParser, $gSession; 
                                        
    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];      
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get fields
    if ( count($version[\'client\']) > 0 )
    {   
        foreach($version[\'client\'] as $hash )
        {
            if ( $hash[\'field_folder\'] == 1 )
            {
                $gParser->TplAssign($tpl, \'NAME\', MELBIS_INC_LANG(\'kClient\', \'FIELD\', $hash[\'field_id\'], $hash[\'field_name\']));
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_group\');
                continue;                        
            }
                                              
            $command = \"SELECT *
                          FROM {DBNICK}_field
                         WHERE id = \'$hash[field_id]\' 
                        \";                              
            $field = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_field_value
                         WHERE field_id = \'$field[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $field[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.fields_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'field_id\'],
                                                \'NAME\'  => htmlspecialchars($hash[\'field_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'field_id\'], 
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_txt\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'field_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.fields_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'fields\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
}      


/** 
 * Function MELBIS_BASKET_options
 **/
function MELBIS_BASKET_options($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get options
    if ( count($version[\'option\']) > 0 )
    {   
        foreach($version[\'option\'] as $hash )
        {     
            $command = \"SELECT *
                          FROM {DBNICK}_order_option
                         WHERE id = \'$hash[option_id]\' 
                        \";                              
            $option = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_order_option_value
                         WHERE option_id = \'$option[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $option[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.options_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'option_id\'],
                                                \'NAME\'  => htmlspecialchars($hash[\'option_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'OPTION\', \'.options_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'option_id\'],  
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_name\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'option_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.options_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'OPTION\', \'.options_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'options\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
} 


/** 
 * Function MELBIS_BASKET_auto_field
 **/
function MELBIS_BASKET_auto_field($mVars)
{ 
    global $gParser;       
                
    // Vars   
    $id = $mVars[\'post\'][\'id\']*1;                     
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_field_value
                 WHERE name LIKE \'%$query%\' 
                   AND field_id = \'$id\'                
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_auto_option
 **/
function MELBIS_BASKET_auto_option($mVars)
{ 
    global $gParser;       
                
    // Vars                                      
    $id = $mVars[\'post\'][\'id\']*1;
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_order_option_value                  
                 WHERE name LIKE \'%$query%\'
                   AND option_id = \'$id\'                 
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_save
 **/
function MELBIS_BASKET_save($mVars)
{ 
    global $gParser, $gSession; 
                               
    // Vars
    $data[\'result\'] = \'OK\';
    $data[\'message\'] = \'\';    
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }  
    
    // Update fields
    $rows = count($version[\'client\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'client\'][$i][\'field_id\'];
        $value_id = $mVars[\'post\'][\'field\'.$id.\'_id\'] ?? 0;        
        $version[\'client\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'client\'][$i][\'value_txt\'] = $mVars[\'post\'][\'field\'.$id.\'_text\'];
    }
        
    // Update options
    $rows = count($version[\'option\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'option\'][$i][\'option_id\'];
        $value_id = $mVars[\'post\'][\'option\'.$id.\'_id\'] ?? 0;        
        $version[\'option\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'option\'][$i][\'value_name\'] = $mVars[\'post\'][\'option\'.$id.\'_text\'];
    }
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
    
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);                                          

    // Verify cart    
    if ( count($version[\'store\']) == 0 )
    {  
        $data[\'result\'] = \'ERROR_EMPTY\';
        $data[\'message\'] = \'No goods found!\';    
        
        return json_encode($data);    
    }   

    // Verify calculation
    if ( $version[\'result\'][\'value\'] != \'OK\' )
    {
        $data[\'result\'] = $version[\'result\'][\'value\'];
        $data[\'message\'] = $version[\'result\'][\'message\'];
        
        return json_encode($data);  
    }     
    
    // Create order    
    $result = MELBIS_INC_LOGIC_order_edit($version);
    
    // Error exists?
    if ( $result[\'value\'] != \'OK\' )
    {  
        $data[\'result\'] = $result[\'value\'];
        $data[\'message\'] = $result[\'message\'];
        
        return json_encode($data);
    }
    else
    {
        // Close order session
        $gSession->RemoveValue(\'melbis_version\');
    }       
                        
    return json_encode($data);   
}       

?>','2025-04-01 09:33:05');
INSERT INTO `ms_user_file_version` VALUES ('664','1','./../units/melbis_basket.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASKET
 **/
function MELBIS_BASKET($mVars)
{ 
    global $gParser;  
    
    // Vars
    $func = __FUNCTION__.\'_\'.$mVars[\'post\'][\'func\'];
    
    // Call function    
    if ( function_exists($func) )
    {
        return call_user_func($func, $mVars);    
    }  
    else
    {
        return \'Function \'.$func.\' is absent!\';
    }     
} 


/** 
 * Function MELBIS_BASKET_plus
 **/
function MELBIS_BASKET_plus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Add goods
    $version = MELBIS_INC_LOGIC_order_goods_add($version, $store_id);
     
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);    
                        
    return \'\';                         
}    


/** 
 * Function MELBIS_BASKET_minus
 **/
function MELBIS_BASKET_minus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Remove goods
    $version = MELBIS_INC_LOGIC_order_goods_remove($version, $store_id);    
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);        
                               
    // Go to list
    return MELBIS_BASKET_goods($mVars);     
} 


/** 
 * Function MELBIS_BASKET_goods
 **/
function MELBIS_BASKET_goods($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);         
             
    // Get Goods
    if ( count($version[\'store\']) > 0 )
    {   
        foreach($version[\'store\'] as $hash )
        {
            $gParser->TplAssign($tpl, array(\'ID\'            => $hash[\'store_id\'],
                                            \'AMOUNT\'        => $hash[\'amount\'],
                                            \'PRICE\'         => MELBIS_INC_STD_number($hash[\'out_price\'], 0),
                                            \'NAME\'          => MELBIS_INC_LANG(\'kStore\', \'NAME\', $hash[\'store_id\'], $hash[\'store_name\'])
                                            ));         
            $gParser->TplParse($tpl, \'ITEM\', \'.goods_item\');  
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'goods\');                
    }
    else
    {
        $gParser->TplParse($tpl, \'MAIN\', \'goods_empty\');
    }
    
    return $gParser->TplFree($tpl, \'MAIN\');     
}      


/** 
 * Function MELBIS_BASKET_fields
 **/
function MELBIS_BASKET_fields($mVars)
{ 
    global $gParser, $gSession; 
                                        
    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];      
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get fields
    if ( count($version[\'client\']) > 0 )
    {   
        foreach($version[\'client\'] as $hash )
        {
            if ( $hash[\'field_folder\'] == 1 )
            {
                $gParser->TplAssign($tpl, \'NAME\', MELBIS_INC_LANG(\'kClient\', \'FIELD\', $hash[\'field_id\'], $hash[\'field_name\']));
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_group\');
                continue;                        
            }
                                              
            $command = \"SELECT *
                          FROM {DBNICK}_field
                         WHERE id = \'$hash[field_id]\' 
                        \";                              
            $field = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_field_value
                         WHERE field_id = \'$field[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $field[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.fields_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'field_id\'],
                                                \'NAME\'  => MELBIS_INC_LANG(\'kClient\', \'FIELD\', $hash[\'field_id\'], $hash[\'field_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'field_id\'], 
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_txt\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'field_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.fields_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'fields\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
}      


/** 
 * Function MELBIS_BASKET_options
 **/
function MELBIS_BASKET_options($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get options
    if ( count($version[\'option\']) > 0 )
    {   
        foreach($version[\'option\'] as $hash )
        {     
            $command = \"SELECT *
                          FROM {DBNICK}_order_option
                         WHERE id = \'$hash[option_id]\' 
                        \";                              
            $option = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_order_option_value
                         WHERE option_id = \'$option[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $option[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.options_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'option_id\'],
                                                \'NAME\'  => htmlspecialchars($hash[\'option_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'OPTION\', \'.options_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'option_id\'],  
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_name\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'option_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.options_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'OPTION\', \'.options_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'options\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
} 


/** 
 * Function MELBIS_BASKET_auto_field
 **/
function MELBIS_BASKET_auto_field($mVars)
{ 
    global $gParser;       
                
    // Vars   
    $id = $mVars[\'post\'][\'id\']*1;                     
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_field_value
                 WHERE name LIKE \'%$query%\' 
                   AND field_id = \'$id\'                
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_auto_option
 **/
function MELBIS_BASKET_auto_option($mVars)
{ 
    global $gParser;       
                
    // Vars                                      
    $id = $mVars[\'post\'][\'id\']*1;
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_order_option_value                  
                 WHERE name LIKE \'%$query%\'
                   AND option_id = \'$id\'                 
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_save
 **/
function MELBIS_BASKET_save($mVars)
{ 
    global $gParser, $gSession; 
                               
    // Vars
    $data[\'result\'] = \'OK\';
    $data[\'message\'] = \'\';    
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }  
    
    // Update fields
    $rows = count($version[\'client\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'client\'][$i][\'field_id\'];
        $value_id = $mVars[\'post\'][\'field\'.$id.\'_id\'] ?? 0;        
        $version[\'client\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'client\'][$i][\'value_txt\'] = $mVars[\'post\'][\'field\'.$id.\'_text\'];
    }
        
    // Update options
    $rows = count($version[\'option\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'option\'][$i][\'option_id\'];
        $value_id = $mVars[\'post\'][\'option\'.$id.\'_id\'] ?? 0;        
        $version[\'option\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'option\'][$i][\'value_name\'] = $mVars[\'post\'][\'option\'.$id.\'_text\'];
    }
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
    
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);                                          

    // Verify cart    
    if ( count($version[\'store\']) == 0 )
    {  
        $data[\'result\'] = \'ERROR_EMPTY\';
        $data[\'message\'] = \'No goods found!\';    
        
        return json_encode($data);    
    }   

    // Verify calculation
    if ( $version[\'result\'][\'value\'] != \'OK\' )
    {
        $data[\'result\'] = $version[\'result\'][\'value\'];
        $data[\'message\'] = $version[\'result\'][\'message\'];
        
        return json_encode($data);  
    }     
    
    // Create order    
    $result = MELBIS_INC_LOGIC_order_edit($version);
    
    // Error exists?
    if ( $result[\'value\'] != \'OK\' )
    {  
        $data[\'result\'] = $result[\'value\'];
        $data[\'message\'] = $result[\'message\'];
        
        return json_encode($data);
    }
    else
    {
        // Close order session
        $gSession->RemoveValue(\'melbis_version\');
    }       
                        
    return json_encode($data);   
}       

?>','2025-04-01 09:33:56');
INSERT INTO `ms_user_file_version` VALUES ('665','1','./../units/melbis_basket.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASKET
 **/
function MELBIS_BASKET($mVars)
{ 
    global $gParser;  
    
    // Vars
    $func = __FUNCTION__.\'_\'.$mVars[\'post\'][\'func\'];
    
    // Call function    
    if ( function_exists($func) )
    {
        return call_user_func($func, $mVars);    
    }  
    else
    {
        return \'Function \'.$func.\' is absent!\';
    }     
} 


/** 
 * Function MELBIS_BASKET_plus
 **/
function MELBIS_BASKET_plus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Add goods
    $version = MELBIS_INC_LOGIC_order_goods_add($version, $store_id);
     
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);    
                        
    return \'\';                         
}    


/** 
 * Function MELBIS_BASKET_minus
 **/
function MELBIS_BASKET_minus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Remove goods
    $version = MELBIS_INC_LOGIC_order_goods_remove($version, $store_id);    
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);        
                               
    // Go to list
    return MELBIS_BASKET_goods($mVars);     
} 


/** 
 * Function MELBIS_BASKET_goods
 **/
function MELBIS_BASKET_goods($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);         
             
    // Get Goods
    if ( count($version[\'store\']) > 0 )
    {   
        foreach($version[\'store\'] as $hash )
        {
            $gParser->TplAssign($tpl, array(\'ID\'            => $hash[\'store_id\'],
                                            \'AMOUNT\'        => $hash[\'amount\'],
                                            \'PRICE\'         => MELBIS_INC_STD_number($hash[\'out_price\'], 0),
                                            \'NAME\'          => MELBIS_INC_LANG(\'kStore\', \'NAME\', $hash[\'store_id\'], $hash[\'store_name\'])
                                            ));         
            $gParser->TplParse($tpl, \'ITEM\', \'.goods_item\');  
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'goods\');                
    }
    else
    {
        $gParser->TplParse($tpl, \'MAIN\', \'goods_empty\');
    }
    
    return $gParser->TplFree($tpl, \'MAIN\');     
}      


/** 
 * Function MELBIS_BASKET_fields
 **/
function MELBIS_BASKET_fields($mVars)
{ 
    global $gParser, $gSession; 
                                        
    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];      
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get fields
    if ( count($version[\'client\']) > 0 )
    {   
        foreach($version[\'client\'] as $hash )
        {
            if ( $hash[\'field_folder\'] == 1 )
            {
                $gParser->TplAssign($tpl, \'NAME\', MELBIS_INC_LANG(\'kClient\', \'FIELD\', $hash[\'field_id\'], $hash[\'field_name\']));
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_group\');
                continue;                        
            }
                                              
            $command = \"SELECT *
                          FROM {DBNICK}_field
                         WHERE id = \'$hash[field_id]\' 
                        \";                              
            $field = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_field_value
                         WHERE field_id = \'$field[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $field[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.fields_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'field_id\'],
                                                \'NAME\'  => MELBIS_INC_LANG(\'kClient\', \'FIELD\', $hash[\'field_id\'], $hash[\'field_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'field_id\'], 
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_txt\']),                                            
                                                \'NAME\'      => MELBIS_INC_LANG(\'kClient\', \'FIELD\', $hash[\'field_id\'], $hash[\'field_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.fields_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'fields\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
}      


/** 
 * Function MELBIS_BASKET_options
 **/
function MELBIS_BASKET_options($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get options
    if ( count($version[\'option\']) > 0 )
    {   
        foreach($version[\'option\'] as $hash )
        {     
            $command = \"SELECT *
                          FROM {DBNICK}_order_option
                         WHERE id = \'$hash[option_id]\' 
                        \";                              
            $option = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_order_option_value
                         WHERE option_id = \'$option[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $option[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.options_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'option_id\'],
                                                \'NAME\'  => htmlspecialchars($hash[\'option_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'OPTION\', \'.options_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'option_id\'],  
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_name\']),                                            
                                                \'NAME\'      => htmlspecialchars($hash[\'option_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.options_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'OPTION\', \'.options_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'options\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
} 


/** 
 * Function MELBIS_BASKET_auto_field
 **/
function MELBIS_BASKET_auto_field($mVars)
{ 
    global $gParser;       
                
    // Vars   
    $id = $mVars[\'post\'][\'id\']*1;                     
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_field_value
                 WHERE name LIKE \'%$query%\' 
                   AND field_id = \'$id\'                
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_auto_option
 **/
function MELBIS_BASKET_auto_option($mVars)
{ 
    global $gParser;       
                
    // Vars                                      
    $id = $mVars[\'post\'][\'id\']*1;
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_order_option_value                  
                 WHERE name LIKE \'%$query%\'
                   AND option_id = \'$id\'                 
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_save
 **/
function MELBIS_BASKET_save($mVars)
{ 
    global $gParser, $gSession; 
                               
    // Vars
    $data[\'result\'] = \'OK\';
    $data[\'message\'] = \'\';    
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }  
    
    // Update fields
    $rows = count($version[\'client\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'client\'][$i][\'field_id\'];
        $value_id = $mVars[\'post\'][\'field\'.$id.\'_id\'] ?? 0;        
        $version[\'client\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'client\'][$i][\'value_txt\'] = $mVars[\'post\'][\'field\'.$id.\'_text\'];
    }
        
    // Update options
    $rows = count($version[\'option\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'option\'][$i][\'option_id\'];
        $value_id = $mVars[\'post\'][\'option\'.$id.\'_id\'] ?? 0;        
        $version[\'option\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'option\'][$i][\'value_name\'] = $mVars[\'post\'][\'option\'.$id.\'_text\'];
    }
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
    
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);                                          

    // Verify cart    
    if ( count($version[\'store\']) == 0 )
    {  
        $data[\'result\'] = \'ERROR_EMPTY\';
        $data[\'message\'] = \'No goods found!\';    
        
        return json_encode($data);    
    }   

    // Verify calculation
    if ( $version[\'result\'][\'value\'] != \'OK\' )
    {
        $data[\'result\'] = $version[\'result\'][\'value\'];
        $data[\'message\'] = $version[\'result\'][\'message\'];
        
        return json_encode($data);  
    }     
    
    // Create order    
    $result = MELBIS_INC_LOGIC_order_edit($version);
    
    // Error exists?
    if ( $result[\'value\'] != \'OK\' )
    {  
        $data[\'result\'] = $result[\'value\'];
        $data[\'message\'] = $result[\'message\'];
        
        return json_encode($data);
    }
    else
    {
        // Close order session
        $gSession->RemoveValue(\'melbis_version\');
    }       
                        
    return json_encode($data);   
}       

?>','2025-04-01 09:34:55');
INSERT INTO `ms_user_file_version` VALUES ('666','1','./../templates/default/autocomplete.js','/**
*  Ajax Autocomplete for jQuery, version 1.4.11
*  (c) 2017 Tomas Kirda
*
*  Ajax Autocomplete for jQuery is freely distributable under the terms of an MIT-style license.
*  For details, see the web site: https://github.com/devbridge/jQuery-Autocomplete
*/

/*jslint  browser: true, white: true, single: true, this: true, multivar: true */
/*global define, window, document, jQuery, exports, require */

// Expose plugin as an AMD module if AMD loader is present:
(function (factory) {
    \"use strict\";
    if (typeof define === \'function\' && define.amd) {
        // AMD. Register as an anonymous module.
        define([\'jquery\'], factory);
    } else if (typeof exports === \'object\' && typeof require === \'function\') {
        // Browserify
        factory(require(\'jquery\'));
    } else {
        // Browser globals
        factory(jQuery);
    }
}(function ($) {
    \'use strict\';

    var
        utils = (function () {
            return {
                escapeRegExChars: function (value) {
                    return value.replace(/[|\\\\{}()[\\]^$+*?.]/g, \"\\\\$&\");
                },
                createNode: function (containerClass) {
                    var div = document.createElement(\'div\');
                    div.className = containerClass;
                    div.style.position = \'absolute\';
                    div.style.display = \'none\';
                    return div;
                }
            };
        }()),

        keys = {
            ESC: 27,
            TAB: 9,
            RETURN: 13,
            LEFT: 37,
            UP: 38,
            RIGHT: 39,
            DOWN: 40
        },

        noop = $.noop;

    function Autocomplete(el, options) {
        var that = this;

        // Shared variables:
        that.element = el;
        that.el = $(el);
        that.suggestions = [];
        that.badQueries = [];
        that.selectedIndex = -1;
        that.currentValue = that.element.value;
        that.timeoutId = null;
        that.cachedResponse = {};
        that.onChangeTimeout = null;
        that.onChange = null;
        that.isLocal = false;
        that.suggestionsContainer = null;
        that.noSuggestionsContainer = null;
        that.options = $.extend(true, {}, Autocomplete.defaults, options);
        that.classes = {
            selected: \'autocomplete-selected\',
            suggestion: \'autocomplete-suggestion\'
        };
        that.hint = null;
        that.hintValue = \'\';
        that.selection = null;

        // Initialize and set options:
        that.initialize();
        that.setOptions(options);
    }

    Autocomplete.utils = utils;

    $.Autocomplete = Autocomplete;

    Autocomplete.defaults = {
            ajaxSettings: {},
            autoSelectFirst: false,
            appendTo: \'body\',
            serviceUrl: null,
            lookup: null,
            onSelect: null,
            onHint: null,
            width: \'auto\',
            minChars: 1,
            maxHeight: 300,
            deferRequestBy: 0,
            params: {},
            formatResult: _formatResult,
            formatGroup: _formatGroup,
            delimiter: null,
            zIndex: 9999,
            type: \'GET\',
            noCache: false,
            onSearchStart: noop,
            onSearchComplete: noop,
            onSearchError: noop,
            preserveInput: false,
            containerClass: \'autocomplete-suggestions\',
            tabDisabled: false,
            dataType: \'text\',
            currentRequest: null,
            triggerSelectOnValidInput: true,
            preventBadQueries: true,
            lookupFilter: _lookupFilter,
            paramName: \'query\',
            transformResult: _transformResult,
            showNoSuggestionNotice: false,
            noSuggestionNotice: \'No results\',
            orientation: \'bottom\',
            forceFixPosition: false
    };

    function _lookupFilter(suggestion, originalQuery, queryLowerCase) {
        return suggestion.value.toLowerCase().indexOf(queryLowerCase) !== -1;
    };

    function _transformResult(response) {
        return typeof response === \'string\' ? $.parseJSON(response) : response;
    };

    function _formatResult(suggestion, currentValue) {
        // Do not replace anything if the current value is empty
        if (!currentValue) {
            return suggestion.value;
        }

        var pattern = \'(\' + utils.escapeRegExChars(currentValue) + \')\';

        return suggestion.value
            .replace(new RegExp(pattern, \'gi\'), \'<strong>$1<\\/strong>\')
            .replace(/&/g, \'&amp;\')
            .replace(/</g, \'&lt;\')
            .replace(/>/g, \'&gt;\')
            .replace(/\"/g, \'&quot;\')
            .replace(/&lt;(\\/?strong)&gt;/g, \'<$1>\');
    };

    function _formatGroup(suggestion, category) {
        return \'<div class=\"autocomplete-group\">\' + category + \'</div>\';
    };

    Autocomplete.prototype = {

        initialize: function () {
            var that = this,
                suggestionSelector = \'.\' + that.classes.suggestion,
                selected = that.classes.selected,
                options = that.options,
                container;

            that.element.setAttribute(\'autocomplete\', \'off\');

            // html() deals with many types: htmlString or Element or Array or jQuery
            that.noSuggestionsContainer = $(\'<div class=\"autocomplete-no-suggestion\"></div>\')
                                          .html(this.options.noSuggestionNotice).get(0);

            that.suggestionsContainer = Autocomplete.utils.createNode(options.containerClass);

            container = $(that.suggestionsContainer);

            container.appendTo(options.appendTo || \'body\');

            // Only set width if it was provided:
            if (options.width !== \'auto\') {
                container.css(\'width\', options.width);
            }

            // Listen for mouse over event on suggestions list:
            container.on(\'mouseover.autocomplete\', suggestionSelector, function () {
                that.activate($(this).data(\'index\'));
            });

            // Deselect active element when mouse leaves suggestions container:
            container.on(\'mouseout.autocomplete\', function () {
                that.selectedIndex = -1;
                container.children(\'.\' + selected).removeClass(selected);
            });

            // Listen for click event on suggestions list:
            container.on(\'click.autocomplete\', suggestionSelector, function () {
                that.select($(this).data(\'index\'));
            });

            container.on(\'click.autocomplete\', function () {
                clearTimeout(that.blurTimeoutId);
            })

            that.fixPositionCapture = function () {
                if (that.visible) {
                    that.fixPosition();
                }
            };

            $(window).on(\'resize.autocomplete\', that.fixPositionCapture);

            that.el.on(\'keydown.autocomplete\', function (e) { that.onKeyPress(e); });
            that.el.on(\'keyup.autocomplete\', function (e) { that.onKeyUp(e); });
            that.el.on(\'blur.autocomplete\', function () { that.onBlur(); });
            that.el.on(\'focus.autocomplete\', function () { that.onFocus(); });
            that.el.on(\'change.autocomplete\', function (e) { that.onKeyUp(e); });
            that.el.on(\'input.autocomplete\', function (e) { that.onKeyUp(e); });
        },

        onFocus: function () {
            var that = this;

            if (that.disabled) {
                return;
            }

            that.fixPosition();

            if (that.el.val().length >= that.options.minChars) {
                that.onValueChange();
            }
        },

        onBlur: function () {
            var that = this,
                options = that.options,
                value = that.el.val(),
                query = that.getQuery(value);

            // If user clicked on a suggestion, hide() will
            // be canceled, otherwise close suggestions
            that.blurTimeoutId = setTimeout(function () {
                that.hide();

                if (that.selection && that.currentValue !== query) {
                    (options.onInvalidateSelection || $.noop).call(that.element);
                }
            }, 200);
        },

        abortAjax: function () {
            var that = this;
            if (that.currentRequest) {
                that.currentRequest.abort();
                that.currentRequest = null;
            }
        },

        setOptions: function (suppliedOptions) {
            var that = this,
                options = $.extend({}, that.options, suppliedOptions);

            that.isLocal = Array.isArray(options.lookup);

            if (that.isLocal) {
                options.lookup = that.verifySuggestionsFormat(options.lookup);
            }

            options.orientation = that.validateOrientation(options.orientation, \'bottom\');

            // Adjust height, width and z-index:
            $(that.suggestionsContainer).css({
                \'max-height\': options.maxHeight + \'px\',
                \'width\': options.width + \'px\',
                \'z-index\': options.zIndex
            });

            this.options = options;
        },


        clearCache: function () {
            this.cachedResponse = {};
            this.badQueries = [];
        },

        clear: function () {
            this.clearCache();
            this.currentValue = \'\';
            this.suggestions = [];
        },

        disable: function () {
            var that = this;
            that.disabled = true;
            clearTimeout(that.onChangeTimeout);
            that.abortAjax();
        },

        enable: function () {
            this.disabled = false;
        },

        fixPosition: function () {
            // Use only when container has already its content

            var that = this,
                $container = $(that.suggestionsContainer),
                containerParent = $container.parent().get(0);
            // Fix position automatically when appended to body.
            // In other cases force parameter must be given.
            if (containerParent !== document.body && !that.options.forceFixPosition) {
                return;
            }

            // Choose orientation
            var orientation = that.options.orientation,
                containerHeight = $container.outerHeight(),
                height = that.el.outerHeight(),
                offset = that.el.offset(),
                styles = { \'top\': offset.top, \'left\': offset.left };

            if (orientation === \'auto\') {
                var viewPortHeight = $(window).height(),
                    scrollTop = $(window).scrollTop(),
                    topOverflow = -scrollTop + offset.top - containerHeight,
                    bottomOverflow = scrollTop + viewPortHeight - (offset.top + height + containerHeight);

                orientation = (Math.max(topOverflow, bottomOverflow) === topOverflow) ? \'top\' : \'bottom\';
            }

            if (orientation === \'top\') {
                styles.top += -containerHeight;
            } else {
                styles.top += height;
            }

            // If container is not positioned to body,
            // correct its position using offset parent offset
            if(containerParent !== document.body) {
                var opacity = $container.css(\'opacity\'),
                    parentOffsetDiff;

                    if (!that.visible){
                        $container.css(\'opacity\', 0).show();
                    }

                parentOffsetDiff = $container.offsetParent().offset();
                styles.top -= parentOffsetDiff.top;
                styles.top += containerParent.scrollTop;
                styles.left -= parentOffsetDiff.left;

                if (!that.visible){
                    $container.css(\'opacity\', opacity).hide();
                }
            }

            if (that.options.width === \'auto\') {
                styles.width = that.el.outerWidth() + \'px\';
            }

            $container.css(styles);
        },

        isCursorAtEnd: function () {
            var that = this,
                valLength = that.el.val().length,
                selectionStart = that.element.selectionStart,
                range;

            if (typeof selectionStart === \'number\') {
                return selectionStart === valLength;
            }
            if (document.selection) {
                range = document.selection.createRange();
                range.moveStart(\'character\', -valLength);
                return valLength === range.text.length;
            }
            return true;
        },

        onKeyPress: function (e) {
            var that = this;

            // If suggestions are hidden and user presses arrow down, display suggestions:
            if (!that.disabled && !that.visible && e.which === keys.DOWN && that.currentValue) {
                that.suggest();
                return;
            }

            if (that.disabled || !that.visible) {
                return;
            }

            switch (e.which) {
                case keys.ESC:
                    that.el.val(that.currentValue);
                    that.hide();
                    break;
                case keys.RIGHT:
                    if (that.hint && that.options.onHint && that.isCursorAtEnd()) {
                        that.selectHint();
                        break;
                    }
                    return;
                case keys.TAB:
                    if (that.hint && that.options.onHint) {
                        that.selectHint();
                        return;
                    }
                    if (that.selectedIndex === -1) {
                        that.hide();
                        return;
                    }
                    that.select(that.selectedIndex);
                    if (that.options.tabDisabled === false) {
                        return;
                    }
                    break;
                case keys.RETURN:
                    if (that.selectedIndex === -1) {
                        that.hide();
                        return;
                    }
                    that.select(that.selectedIndex);
                    break;
                case keys.UP:
                    that.moveUp();
                    break;
                case keys.DOWN:
                    that.moveDown();
                    break;
                default:
                    return;
            }

            // Cancel event if function did not return:
            e.stopImmediatePropagation();
            e.preventDefault();
        },

        onKeyUp: function (e) {
            var that = this;

            if (that.disabled) {
                return;
            }

            switch (e.which) {
                case keys.UP:
                case keys.DOWN:
                    return;
            }

            clearTimeout(that.onChangeTimeout);

            if (that.currentValue !== that.el.val()) {
                that.findBestHint();
                if (that.options.deferRequestBy > 0) {
                    // Defer lookup in case when value changes very quickly:
                    that.onChangeTimeout = setTimeout(function () {
                        that.onValueChange();
                    }, that.options.deferRequestBy);
                } else {
                    that.onValueChange();
                }
            }
        },

        onValueChange: function () {
            if (this.ignoreValueChange) {
                this.ignoreValueChange = false;
                return;
            }

            var that = this,
                options = that.options,
                value = that.el.val(),
                query = that.getQuery(value);

            if (that.selection && that.currentValue !== query) {
                that.selection = null;
                (options.onInvalidateSelection || $.noop).call(that.element);
            }

            clearTimeout(that.onChangeTimeout);
            that.currentValue = value;
            that.selectedIndex = -1;

            // Check existing suggestion for the match before proceeding:
            if (options.triggerSelectOnValidInput && that.isExactMatch(query)) {
                that.select(0);
                return;
            }

            if (query.length < options.minChars) {
                that.hide();
            } else {
                that.getSuggestions(query);
            }
        },

        isExactMatch: function (query) {
            var suggestions = this.suggestions;

            return (suggestions.length === 1 && suggestions[0].value.toLowerCase() === query.toLowerCase());
        },

        getQuery: function (value) {
            var delimiter = this.options.delimiter,
                parts;

            if (!delimiter) {
                return value;
            }
            parts = value.split(delimiter);
            return $.trim(parts[parts.length - 1]);
        },

        getSuggestionsLocal: function (query) {
            var that = this,
                options = that.options,
                queryLowerCase = query.toLowerCase(),
                filter = options.lookupFilter,
                limit = parseInt(options.lookupLimit, 10),
                data;

            data = {
                suggestions: $.grep(options.lookup, function (suggestion) {
                    return filter(suggestion, query, queryLowerCase);
                })
            };

            if (limit && data.suggestions.length > limit) {
                data.suggestions = data.suggestions.slice(0, limit);
            }

            return data;
        },

        getSuggestions: function (q) {
            var response,
                that = this,
                options = that.options,
                serviceUrl = options.serviceUrl,
                params,
                cacheKey,
                ajaxSettings;

            options.params[options.paramName] = q;

            if (options.onSearchStart.call(that.element, options.params) === false) {
                return;
            }

            params = options.ignoreParams ? null : options.params;

            if ($.isFunction(options.lookup)){
                options.lookup(q, function (data) {
                    that.suggestions = data.suggestions;
                    that.suggest();
                    options.onSearchComplete.call(that.element, q, data.suggestions);
                });
                return;
            }

            if (that.isLocal) {
                response = that.getSuggestionsLocal(q);
            } else {
                if ($.isFunction(serviceUrl)) {
                    serviceUrl = serviceUrl.call(that.element, q);
                }
                cacheKey = serviceUrl + \'?\' + $.param(params || {});
                response = that.cachedResponse[cacheKey];
            }

            if (response && Array.isArray(response.suggestions)) {
                that.suggestions = response.suggestions;
                that.suggest();
                options.onSearchComplete.call(that.element, q, response.suggestions);
            } else if (!that.isBadQuery(q)) {
                that.abortAjax();

                ajaxSettings = {
                    url: serviceUrl,
                    data: params,
                    type: options.type,
                    dataType: options.dataType
                };

                $.extend(ajaxSettings, options.ajaxSettings);

                that.currentRequest = $.ajax(ajaxSettings).done(function (data) {
                    var result;
                    that.currentRequest = null;
                    result = options.transformResult(data, q);
                    that.processResponse(result, q, cacheKey);
                    options.onSearchComplete.call(that.element, q, result.suggestions);
                }).fail(function (jqXHR, textStatus, errorThrown) {
                    options.onSearchError.call(that.element, q, jqXHR, textStatus, errorThrown);
                });
            } else {
                options.onSearchComplete.call(that.element, q, []);
            }
        },

        isBadQuery: function (q) {
            if (!this.options.preventBadQueries){
                return false;
            }

            var badQueries = this.badQueries,
                i = badQueries.length;

            while (i--) {
                if (q.indexOf(badQueries[i]) === 0) {
                    return true;
                }
            }

            return false;
        },

        hide: function () {
            var that = this,
                container = $(that.suggestionsContainer);

            if ($.isFunction(that.options.onHide) && that.visible) {
                that.options.onHide.call(that.element, container);
            }

            that.visible = false;
            that.selectedIndex = -1;
            clearTimeout(that.onChangeTimeout);
            $(that.suggestionsContainer).hide();
            that.onHint(null);
        },

        suggest: function () {
            if (!this.suggestions.length) {
                if (this.options.showNoSuggestionNotice) {
                    this.noSuggestions();
                } else {
                    this.hide();
                }
                return;
            }

            var that = this,
                options = that.options,
                groupBy = options.groupBy,
                formatResult = options.formatResult,
                value = that.getQuery(that.currentValue),
                className = that.classes.suggestion,
                classSelected = that.classes.selected,
                container = $(that.suggestionsContainer),
                noSuggestionsContainer = $(that.noSuggestionsContainer),
                beforeRender = options.beforeRender,
                html = \'\',
                category,
                formatGroup = function (suggestion, index) {
                        var currentCategory = suggestion.data[groupBy];

                        if (category === currentCategory){
                            return \'\';
                        }

                        category = currentCategory;

                        return options.formatGroup(suggestion, category);
                    };

            if (options.triggerSelectOnValidInput && that.isExactMatch(value)) {
                that.select(0);
                return;
            }

            // Build suggestions inner HTML:
            $.each(that.suggestions, function (i, suggestion) {
                if (groupBy){
                    html += formatGroup(suggestion, value, i);
                }

                html += \'<div class=\"\' + className + \'\" data-index=\"\' + i + \'\">\' + formatResult(suggestion, value, i) + \'</div>\';
            });

            this.adjustContainerWidth();

            noSuggestionsContainer.detach();
            container.html(html);

            if ($.isFunction(beforeRender)) {
                beforeRender.call(that.element, container, that.suggestions);
            }

            that.fixPosition();
            container.show();

            // Select first value by default:
            if (options.autoSelectFirst) {
                that.selectedIndex = 0;
                container.scrollTop(0);
                container.children(\'.\' + className).first().addClass(classSelected);
            }

            that.visible = true;
            that.findBestHint();
        },

        noSuggestions: function() {
             var that = this,
                 beforeRender = that.options.beforeRender,
                 container = $(that.suggestionsContainer),
                 noSuggestionsContainer = $(that.noSuggestionsContainer);

            this.adjustContainerWidth();

            // Some explicit steps. Be careful here as it easy to get
            // noSuggestionsContainer removed from DOM if not detached properly.
            noSuggestionsContainer.detach();

            // clean suggestions if any
            container.empty();
            container.append(noSuggestionsContainer);

            if ($.isFunction(beforeRender)) {
                beforeRender.call(that.element, container, that.suggestions);
            }

            that.fixPosition();

            container.show();
            that.visible = true;
        },

        adjustContainerWidth: function() {
            var that = this,
                options = that.options,
                width,
                container = $(that.suggestionsContainer);

            // If width is auto, adjust width before displaying suggestions,
            // because if instance was created before input had width, it will be zero.
            // Also it adjusts if input width has changed.
            if (options.width === \'auto\') {
                width = that.el.outerWidth();
                container.css(\'width\', width > 0 ? width : 300);
            } else if(options.width === \'flex\') {
                // Trust the source! Unset the width property so it will be the max length
                // the containing elements.
                container.css(\'width\', \'\');
            }
        },

        findBestHint: function () {
            var that = this,
                value = that.el.val().toLowerCase(),
                bestMatch = null;

            if (!value) {
                return;
            }

            $.each(that.suggestions, function (i, suggestion) {
                var foundMatch = suggestion.value.toLowerCase().indexOf(value) === 0;
                if (foundMatch) {
                    bestMatch = suggestion;
                }
                return !foundMatch;
            });

            that.onHint(bestMatch);
        },

        onHint: function (suggestion) {
            var that = this,
                onHintCallback = that.options.onHint,
                hintValue = \'\';
            
            if (suggestion) {
                hintValue = that.currentValue + suggestion.value.substr(that.currentValue.length);
            }
            if (that.hintValue !== hintValue) {
                that.hintValue = hintValue;
                that.hint = suggestion;
                if ($.isFunction(onHintCallback)) {
                    onHintCallback.call(that.element, hintValue);
                }
            }  
        },

        verifySuggestionsFormat: function (suggestions) {
            // If suggestions is string array, convert them to supported format:
            if (suggestions.length && typeof suggestions[0] === \'string\') {
                return $.map(suggestions, function (value) {
                    return { value: value, data: null };
                });
            }

            return suggestions;
        },

        validateOrientation: function(orientation, fallback) {
            orientation = $.trim(orientation || \'\').toLowerCase();

            if($.inArray(orientation, [\'auto\', \'bottom\', \'top\']) === -1){
                orientation = fallback;
            }

            return orientation;
        },

        processResponse: function (result, originalQuery, cacheKey) {
            var that = this,
                options = that.options;

            result.suggestions = that.verifySuggestionsFormat(result.suggestions);

            // Cache results if cache is not disabled:
            if (!options.noCache) {
                that.cachedResponse[cacheKey] = result;
                if (options.preventBadQueries && !result.suggestions.length) {
                    that.badQueries.push(originalQuery);
                }
            }

            // Return if originalQuery is not matching current query:
            if (originalQuery !== that.getQuery(that.currentValue)) {
                return;
            }

            that.suggestions = result.suggestions;
            that.suggest();
        },

        activate: function (index) {
            var that = this,
                activeItem,
                selected = that.classes.selected,
                container = $(that.suggestionsContainer),
                children = container.find(\'.\' + that.classes.suggestion);

            container.find(\'.\' + selected).removeClass(selected);

            that.selectedIndex = index;

            if (that.selectedIndex !== -1 && children.length > that.selectedIndex) {
                activeItem = children.get(that.selectedIndex);
                $(activeItem).addClass(selected);
                return activeItem;
            }

            return null;
        },

        selectHint: function () {
            var that = this,
                i = $.inArray(that.hint, that.suggestions);

            that.select(i);
        },

        select: function (i) {
            var that = this;
            that.hide();
            that.onSelect(i);
        },

        moveUp: function () {
            var that = this;

            if (that.selectedIndex === -1) {
                return;
            }

            if (that.selectedIndex === 0) {
                $(that.suggestionsContainer).children(\'.\' + that.classes.suggestion).first().removeClass(that.classes.selected);
                that.selectedIndex = -1;
                that.ignoreValueChange = false;
                that.el.val(that.currentValue);
                that.findBestHint();
                return;
            }

            that.adjustScroll(that.selectedIndex - 1);
        },

        moveDown: function () {
            var that = this;

            if (that.selectedIndex === (that.suggestions.length - 1)) {
                return;
            }

            that.adjustScroll(that.selectedIndex + 1);
        },

        adjustScroll: function (index) {
            var that = this,
                activeItem = that.activate(index);

            if (!activeItem) {
                return;
            }

            var offsetTop,
                upperBound,
                lowerBound,
                heightDelta = $(activeItem).outerHeight();

            offsetTop = activeItem.offsetTop;
            upperBound = $(that.suggestionsContainer).scrollTop();
            lowerBound = upperBound + that.options.maxHeight - heightDelta;

            if (offsetTop < upperBound) {
                $(that.suggestionsContainer).scrollTop(offsetTop);
            } else if (offsetTop > lowerBound) {
                $(that.suggestionsContainer).scrollTop(offsetTop - that.options.maxHeight + heightDelta);
            }

            if (!that.options.preserveInput) {
                // During onBlur event, browser will trigger \"change\" event,
                // because value has changed, to avoid side effect ignore,
                // that event, so that correct suggestion can be selected
                // when clicking on suggestion with a mouse
                that.ignoreValueChange = true;
                that.el.val(that.getValue(that.suggestions[index].value));
            }

            that.onHint(null);
        },

        onSelect: function (index) {
            var that = this,
                onSelectCallback = that.options.onSelect,
                suggestion = that.suggestions[index];

            that.currentValue = that.getValue(suggestion.value);

            if (that.currentValue !== that.el.val() && !that.options.preserveInput) {
                that.el.val(that.currentValue);
            }

            that.onHint(null);
            that.suggestions = [];
            that.selection = suggestion;

            if ($.isFunction(onSelectCallback)) {
                onSelectCallback.call(that.element, suggestion);
            }
        },

        getValue: function (value) {
            var that = this,
                delimiter = that.options.delimiter,
                currentValue,
                parts;

            if (!delimiter) {
                return value;
            }

            currentValue = that.currentValue;
            parts = currentValue.split(delimiter);

            if (parts.length === 1) {
                return value;
            }

            return currentValue.substr(0, currentValue.length - parts[parts.length - 1].length) + value;
        },

        dispose: function () {
            var that = this;
            that.el.off(\'.autocomplete\').removeData(\'autocomplete\');
            $(window).off(\'resize.autocomplete\', that.fixPositionCapture);
            $(that.suggestionsContainer).remove();
        }
    };

    // Create chainable jQuery plugin:
    $.fn.devbridgeAutocomplete = function (options, args) {
        var dataKey = \'autocomplete\';
        // If function invoked without argument return
        // instance of the first matched element:
        if (!arguments.length) {
            return this.first().data(dataKey);
        }

        return this.each(function () {
            var inputElement = $(this),
                instance = inputElement.data(dataKey);

            if (typeof options === \'string\') {
                if (instance && typeof instance[options] === \'function\') {
                    instance[options](args);
                }
            } else {
                // If instance already exists, destroy it:
                if (instance && instance.dispose) {
                    instance.dispose();
                }
                instance = new Autocomplete(this, options);
                inputElement.data(dataKey, instance);
            }
        });
    };

    // Don\'t overwrite if it already exists
    if (!$.fn.autocomplete) {
        $.fn.autocomplete = $.fn.devbridgeAutocomplete;
    }
}));
','2025-04-01 09:41:24');
INSERT INTO `ms_user_file_version` VALUES ('667','1','./../templates/default/units/melbis_base_head/main.htm','<head>
    <meta charset=\"{CHARSET}\">          
    <meta name=\"generator\" content=\"Melbis Shop v6.4.0\">        
    <meta name=\"author\" content=\"KasDim\">
    <meta name=\"viewport\" content=\"width=device-width, initial-scale=1, shrink-to-fit=no\">  
    <meta http-equiv=\"Last-Modified\" content=\"{LASTMODIFY}\">                    
    <title>{MS:PAGE:TITLE}</title>
    <meta name=\"robots\" content=\"index,follow\">

    <link rel=\"canonical\" href=\"https://{CONST:MELBIS_SHOP_DOMAIN}/{MS:VAR:LANG}{MS:PAGE:PATH}\">
    <link rel=\"alternate\" hreflang=\"x-default\" href=\"https://{CONST:MELBIS_SHOP_DOMAIN}/en{MS:PAGE:PATH}\" />
    {ALTER}     

    <link rel=\"icon\" href=\"{PATH}/images/demo_logo.png\"> 
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/bootstrap.css\">  
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/icons/css/all.css\">
    <link rel=\"stylesheet\" type=\"text/css\" href=\"{PATH}/melbis.css?{BUILD}\">

    <script src=\"{PATH}/jquery.js\"></script>      
    <script src=\"{PATH}/bootstrap.js\"></script>
    <script src=\"{PATH}/bootbox.js\"></script>     
    <script src=\"{PATH}/autocomplete.js\"></script>    
    <script src=\"{PATH}/melbis.js?{BUILD}\"></script>       
</head>','2025-04-01 09:43:55');
INSERT INTO `ms_user_file_version` VALUES ('668','1','./../units/melbis_basket.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASKET
 **/
function MELBIS_BASKET($mVars)
{ 
    global $gParser;  
    
    // Vars
    $func = __FUNCTION__.\'_\'.$mVars[\'post\'][\'func\'];
    
    // Call function    
    if ( function_exists($func) )
    {
        return call_user_func($func, $mVars);    
    }  
    else
    {
        return \'Function \'.$func.\' is absent!\';
    }     
} 


/** 
 * Function MELBIS_BASKET_plus
 **/
function MELBIS_BASKET_plus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Add goods
    $version = MELBIS_INC_LOGIC_order_goods_add($version, $store_id);
     
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);    
                        
    return \'\';                         
}    


/** 
 * Function MELBIS_BASKET_minus
 **/
function MELBIS_BASKET_minus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Remove goods
    $version = MELBIS_INC_LOGIC_order_goods_remove($version, $store_id);    
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);        
                               
    // Go to list
    return MELBIS_BASKET_goods($mVars);     
} 


/** 
 * Function MELBIS_BASKET_goods
 **/
function MELBIS_BASKET_goods($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);         
             
    // Get Goods
    if ( count($version[\'store\']) > 0 )
    {   
        foreach($version[\'store\'] as $hash )
        {
            $gParser->TplAssign($tpl, array(\'ID\'            => $hash[\'store_id\'],
                                            \'AMOUNT\'        => $hash[\'amount\'],
                                            \'PRICE\'         => MELBIS_INC_STD_number($hash[\'out_price\'], 0),
                                            \'NAME\'          => MELBIS_INC_LANG(\'kStore\', \'NAME\', $hash[\'store_id\'], $hash[\'store_name\'])
                                            ));         
            $gParser->TplParse($tpl, \'ITEM\', \'.goods_item\');  
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'goods\');                
    }
    else
    {
        $gParser->TplParse($tpl, \'MAIN\', \'goods_empty\');
    }
    
    return $gParser->TplFree($tpl, \'MAIN\');     
}      


/** 
 * Function MELBIS_BASKET_fields
 **/
function MELBIS_BASKET_fields($mVars)
{ 
    global $gParser, $gSession; 
                                        
    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];      
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get fields
    if ( count($version[\'client\']) > 0 )
    {   
        foreach($version[\'client\'] as $hash )
        {
            if ( $hash[\'field_folder\'] == 1 )
            {
                $gParser->TplAssign($tpl, \'NAME\', MELBIS_INC_LANG(\'kClient\', \'FIELD\', $hash[\'field_id\'], $hash[\'field_name\']));
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_group\');
                continue;                        
            }
                                              
            $command = \"SELECT *
                          FROM {DBNICK}_field
                         WHERE id = \'$hash[field_id]\' 
                        \";                              
            $field = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_field_value
                         WHERE field_id = \'$field[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $field[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.fields_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'field_id\'],
                                                \'NAME\'  => MELBIS_INC_LANG(\'kClient\', \'FIELD\', $hash[\'field_id\'], $hash[\'field_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'field_id\'], 
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_txt\']),                                            
                                                \'NAME\'      => MELBIS_INC_LANG(\'kClient\', \'FIELD\', $hash[\'field_id\'], $hash[\'field_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.fields_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'fields\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
}      


/** 
 * Function MELBIS_BASKET_options
 **/
function MELBIS_BASKET_options($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get options
    if ( count($version[\'option\']) > 0 )
    {   
        foreach($version[\'option\'] as $hash )
        {     
            $command = \"SELECT *
                          FROM {DBNICK}_order_option
                         WHERE id = \'$hash[option_id]\' 
                        \";                              
            $option = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_order_option_value
                         WHERE option_id = \'$option[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $option[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.options_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'option_id\'],
                                                \'NAME\'  => MELBIS_INC_LANG(\'kOption\', \'FIELD\', $hash[\'option_id\'], $hash[\'option_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'OPTION\', \'.options_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'option_id\'],  
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_name\']),                                            
                                                \'NAME\'      => MELBIS_INC_LANG(\'kOption\', \'FIELD\', $hash[\'option_id\'], $hash[\'option_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.options_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'OPTION\', \'.options_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'options\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
} 


/** 
 * Function MELBIS_BASKET_auto_field
 **/
function MELBIS_BASKET_auto_field($mVars)
{ 
    global $gParser;       
                
    // Vars   
    $id = $mVars[\'post\'][\'id\']*1;                     
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_field_value
                 WHERE name LIKE \'%$query%\' 
                   AND field_id = \'$id\'                
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_auto_option
 **/
function MELBIS_BASKET_auto_option($mVars)
{ 
    global $gParser;       
                
    // Vars                                      
    $id = $mVars[\'post\'][\'id\']*1;
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_order_option_value                  
                 WHERE name LIKE \'%$query%\'
                   AND option_id = \'$id\'                 
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_save
 **/
function MELBIS_BASKET_save($mVars)
{ 
    global $gParser, $gSession; 
                               
    // Vars
    $data[\'result\'] = \'OK\';
    $data[\'message\'] = \'\';    
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }  
    
    // Update fields
    $rows = count($version[\'client\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'client\'][$i][\'field_id\'];
        $value_id = $mVars[\'post\'][\'field\'.$id.\'_id\'] ?? 0;        
        $version[\'client\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'client\'][$i][\'value_txt\'] = $mVars[\'post\'][\'field\'.$id.\'_text\'];
    }
        
    // Update options
    $rows = count($version[\'option\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'option\'][$i][\'option_id\'];
        $value_id = $mVars[\'post\'][\'option\'.$id.\'_id\'] ?? 0;        
        $version[\'option\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'option\'][$i][\'value_name\'] = $mVars[\'post\'][\'option\'.$id.\'_text\'];
    }
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
    
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);                                          

    // Verify cart    
    if ( count($version[\'store\']) == 0 )
    {  
        $data[\'result\'] = \'ERROR_EMPTY\';
        $data[\'message\'] = \'No goods found!\';    
        
        return json_encode($data);    
    }   

    // Verify calculation
    if ( $version[\'result\'][\'value\'] != \'OK\' )
    {
        $data[\'result\'] = $version[\'result\'][\'value\'];
        $data[\'message\'] = $version[\'result\'][\'message\'];
        
        return json_encode($data);  
    }     
    
    // Create order    
    $result = MELBIS_INC_LOGIC_order_edit($version);
    
    // Error exists?
    if ( $result[\'value\'] != \'OK\' )
    {  
        $data[\'result\'] = $result[\'value\'];
        $data[\'message\'] = $result[\'message\'];
        
        return json_encode($data);
    }
    else
    {
        // Close order session
        $gSession->RemoveValue(\'melbis_version\');
    }       
                        
    return json_encode($data);   
}       

?>','2025-04-01 09:55:42');
INSERT INTO `ms_user_file_version` VALUES ('669','1','./../units/melbis_basket.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASKET
 **/
function MELBIS_BASKET($mVars)
{ 
    global $gParser;  
    
    // Vars
    $func = __FUNCTION__.\'_\'.$mVars[\'post\'][\'func\'];
    
    // Call function    
    if ( function_exists($func) )
    {
        return call_user_func($func, $mVars);    
    }  
    else
    {
        return \'Function \'.$func.\' is absent!\';
    }     
} 


/** 
 * Function MELBIS_BASKET_plus
 **/
function MELBIS_BASKET_plus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Add goods
    $version = MELBIS_INC_LOGIC_order_goods_add($version, $store_id);
     
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);    
                        
    return \'\';                         
}    


/** 
 * Function MELBIS_BASKET_minus
 **/
function MELBIS_BASKET_minus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Remove goods
    $version = MELBIS_INC_LOGIC_order_goods_remove($version, $store_id);    
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);        
                               
    // Go to list
    return MELBIS_BASKET_goods($mVars);     
} 


/** 
 * Function MELBIS_BASKET_goods
 **/
function MELBIS_BASKET_goods($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);         
             
    // Get Goods
    if ( count($version[\'store\']) > 0 )
    {   
        foreach($version[\'store\'] as $hash )
        {
            $gParser->TplAssign($tpl, array(\'ID\'            => $hash[\'store_id\'],
                                            \'AMOUNT\'        => $hash[\'amount\'],
                                            \'PRICE\'         => MELBIS_INC_STD_number($hash[\'out_price\'], 0),
                                            \'NAME\'          => MELBIS_INC_LANG(\'kStore\', \'NAME\', $hash[\'store_id\'], $hash[\'store_name\'])
                                            ));         
            $gParser->TplParse($tpl, \'ITEM\', \'.goods_item\');  
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'goods\');                
    }
    else
    {
        $gParser->TplParse($tpl, \'MAIN\', \'goods_empty\');
    }
    
    return $gParser->TplFree($tpl, \'MAIN\');     
}      


/** 
 * Function MELBIS_BASKET_fields
 **/
function MELBIS_BASKET_fields($mVars)
{ 
    global $gParser, $gSession; 
                                        
    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];      
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get fields
    if ( count($version[\'client\']) > 0 )
    {   
        foreach($version[\'client\'] as $hash )
        {
            if ( $hash[\'field_folder\'] == 1 )
            {
                $gParser->TplAssign($tpl, \'NAME\', MELBIS_INC_LANG(\'kClient\', \'FIELD\', $hash[\'field_id\'], $hash[\'field_name\']));
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_group\');
                continue;                        
            }
                                              
            $command = \"SELECT *
                          FROM {DBNICK}_field
                         WHERE id = \'$hash[field_id]\' 
                        \";                              
            $field = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_field_value
                         WHERE field_id = \'$field[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $field[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.fields_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'field_id\'],
                                                \'NAME\'  => MELBIS_INC_LANG(\'kClient\', \'FIELD\', $hash[\'field_id\'], $hash[\'field_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'field_id\'], 
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_txt\']),                                            
                                                \'NAME\'      => MELBIS_INC_LANG(\'kClient\', \'FIELD\', $hash[\'field_id\'], $hash[\'field_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.fields_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'fields\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
}      


/** 
 * Function MELBIS_BASKET_options
 **/
function MELBIS_BASKET_options($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get options
    if ( count($version[\'option\']) > 0 )
    {   
        foreach($version[\'option\'] as $hash )
        {     
            $command = \"SELECT *
                          FROM {DBNICK}_order_option
                         WHERE id = \'$hash[option_id]\' 
                        \";                              
            $option = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_order_option_value
                         WHERE option_id = \'$option[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $option[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => MELBIS_INC_LANG(\'kOption\', \'VALUE\', $val[\'id\'], $val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.options_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'option_id\'],
                                                \'NAME\'  => MELBIS_INC_LANG(\'kOption\', \'FIELD\', $hash[\'option_id\'], $hash[\'option_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'OPTION\', \'.options_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'option_id\'],  
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_name\']),                                            
                                                \'NAME\'      => MELBIS_INC_LANG(\'kOption\', \'FIELD\', $hash[\'option_id\'], $hash[\'option_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.options_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'OPTION\', \'.options_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'options\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
} 


/** 
 * Function MELBIS_BASKET_auto_field
 **/
function MELBIS_BASKET_auto_field($mVars)
{ 
    global $gParser;       
                
    // Vars   
    $id = $mVars[\'post\'][\'id\']*1;                     
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_field_value
                 WHERE name LIKE \'%$query%\' 
                   AND field_id = \'$id\'                
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_auto_option
 **/
function MELBIS_BASKET_auto_option($mVars)
{ 
    global $gParser;       
                
    // Vars                                      
    $id = $mVars[\'post\'][\'id\']*1;
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_order_option_value                  
                 WHERE name LIKE \'%$query%\'
                   AND option_id = \'$id\'                 
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_save
 **/
function MELBIS_BASKET_save($mVars)
{ 
    global $gParser, $gSession; 
                               
    // Vars
    $data[\'result\'] = \'OK\';
    $data[\'message\'] = \'\';    
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }  
    
    // Update fields
    $rows = count($version[\'client\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'client\'][$i][\'field_id\'];
        $value_id = $mVars[\'post\'][\'field\'.$id.\'_id\'] ?? 0;        
        $version[\'client\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'client\'][$i][\'value_txt\'] = $mVars[\'post\'][\'field\'.$id.\'_text\'];
    }
        
    // Update options
    $rows = count($version[\'option\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'option\'][$i][\'option_id\'];
        $value_id = $mVars[\'post\'][\'option\'.$id.\'_id\'] ?? 0;        
        $version[\'option\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'option\'][$i][\'value_name\'] = $mVars[\'post\'][\'option\'.$id.\'_text\'];
    }
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
    
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);                                          

    // Verify cart    
    if ( count($version[\'store\']) == 0 )
    {  
        $data[\'result\'] = \'ERROR_EMPTY\';
        $data[\'message\'] = \'No goods found!\';    
        
        return json_encode($data);    
    }   

    // Verify calculation
    if ( $version[\'result\'][\'value\'] != \'OK\' )
    {
        $data[\'result\'] = $version[\'result\'][\'value\'];
        $data[\'message\'] = $version[\'result\'][\'message\'];
        
        return json_encode($data);  
    }     
    
    // Create order    
    $result = MELBIS_INC_LOGIC_order_edit($version);
    
    // Error exists?
    if ( $result[\'value\'] != \'OK\' )
    {  
        $data[\'result\'] = $result[\'value\'];
        $data[\'message\'] = $result[\'message\'];
        
        return json_encode($data);
    }
    else
    {
        // Close order session
        $gSession->RemoveValue(\'melbis_version\');
    }       
                        
    return json_encode($data);   
}       

?>','2025-04-01 09:57:23');
INSERT INTO `ms_user_file_version` VALUES ('670','1','./../units/melbis_basket.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASKET
 **/
function MELBIS_BASKET($mVars)
{ 
    global $gParser;  
    
    // Vars
    $func = __FUNCTION__.\'_\'.$mVars[\'post\'][\'func\'];
    
    // Call function    
    if ( function_exists($func) )
    {
        return call_user_func($func, $mVars);    
    }  
    else
    {
        return \'Function \'.$func.\' is absent!\';
    }     
} 


/** 
 * Function MELBIS_BASKET_plus
 **/
function MELBIS_BASKET_plus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Add goods
    $version = MELBIS_INC_LOGIC_order_goods_add($version, $store_id);
     
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);    
                        
    return \'\';                         
}    


/** 
 * Function MELBIS_BASKET_minus
 **/
function MELBIS_BASKET_minus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Remove goods
    $version = MELBIS_INC_LOGIC_order_goods_remove($version, $store_id);    
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);        
                               
    // Go to list
    return MELBIS_BASKET_goods($mVars);     
} 


/** 
 * Function MELBIS_BASKET_goods
 **/
function MELBIS_BASKET_goods($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);         
             
    // Get Goods
    if ( count($version[\'store\']) > 0 )
    {   
        foreach($version[\'store\'] as $hash )
        {
            $gParser->TplAssign($tpl, array(\'ID\'            => $hash[\'store_id\'],
                                            \'AMOUNT\'        => $hash[\'amount\'],
                                            \'PRICE\'         => MELBIS_INC_STD_number($hash[\'out_price\'], 0),
                                            \'NAME\'          => MELBIS_INC_LANG(\'kStore\', \'NAME\', $hash[\'store_id\'], $hash[\'store_name\'])
                                            ));         
            $gParser->TplParse($tpl, \'ITEM\', \'.goods_item\');  
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'goods\');                
    }
    else
    {
        $gParser->TplParse($tpl, \'MAIN\', \'goods_empty\');
    }
    
    return $gParser->TplFree($tpl, \'MAIN\');     
}      


/** 
 * Function MELBIS_BASKET_fields
 **/
function MELBIS_BASKET_fields($mVars)
{ 
    global $gParser, $gSession; 
                                        
    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];      
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get fields
    if ( count($version[\'client\']) > 0 )
    {   
        foreach($version[\'client\'] as $hash )
        {
            if ( $hash[\'field_folder\'] == 1 )
            {
                $gParser->TplAssign($tpl, \'NAME\', MELBIS_INC_LANG(\'kClient\', \'FIELD\', $hash[\'field_id\'], $hash[\'field_name\']));
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_group\');
                continue;                        
            }
                                              
            $command = \"SELECT *
                          FROM {DBNICK}_field
                         WHERE id = \'$hash[field_id]\' 
                        \";                              
            $field = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_field_value
                         WHERE field_id = \'$field[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $field[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.fields_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'field_id\'],
                                                \'NAME\'  => MELBIS_INC_LANG(\'kClient\', \'FIELD\', $hash[\'field_id\'], $hash[\'field_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'field_id\'], 
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_txt\']),                                            
                                                \'NAME\'      => MELBIS_INC_LANG(\'kClient\', \'FIELD\', $hash[\'field_id\'], $hash[\'field_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.fields_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'fields\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
}      


/** 
 * Function MELBIS_BASKET_options
 **/
function MELBIS_BASKET_options($mVars)
{ 
    global $gParser, $gSession;  
    
    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];         
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get options
    if ( count($version[\'option\']) > 0 )
    {   
        foreach($version[\'option\'] as $hash )
        {     
            $command = \"SELECT *
                          FROM {DBNICK}_order_option
                         WHERE id = \'$hash[option_id]\' 
                        \";                              
            $option = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_order_option_value
                         WHERE option_id = \'$option[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $option[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => MELBIS_INC_LANG(\'kOption\', \'VALUE\', $val[\'id\'], $val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.options_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'option_id\'],
                                                \'NAME\'  => MELBIS_INC_LANG(\'kOption\', \'FIELD\', $hash[\'option_id\'], $hash[\'option_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'OPTION\', \'.options_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'option_id\'],  
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_name\']),                                            
                                                \'NAME\'      => MELBIS_INC_LANG(\'kOption\', \'FIELD\', $hash[\'option_id\'], $hash[\'option_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.options_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'OPTION\', \'.options_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'options\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
} 


/** 
 * Function MELBIS_BASKET_auto_field
 **/
function MELBIS_BASKET_auto_field($mVars)
{ 
    global $gParser;       
                
    // Vars   
    $id = $mVars[\'post\'][\'id\']*1;                     
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_field_value
                 WHERE name LIKE \'%$query%\' 
                   AND field_id = \'$id\'                
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_auto_option
 **/
function MELBIS_BASKET_auto_option($mVars)
{ 
    global $gParser;       
                
    // Vars                                      
    $id = $mVars[\'post\'][\'id\']*1;
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_order_option_value                  
                 WHERE name LIKE \'%$query%\'
                   AND option_id = \'$id\'                 
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_save
 **/
function MELBIS_BASKET_save($mVars)
{ 
    global $gParser, $gSession; 
                               
    // Vars
    $data[\'result\'] = \'OK\';
    $data[\'message\'] = \'\';    
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }  
    
    // Update fields
    $rows = count($version[\'client\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'client\'][$i][\'field_id\'];
        $value_id = $mVars[\'post\'][\'field\'.$id.\'_id\'] ?? 0;        
        $version[\'client\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'client\'][$i][\'value_txt\'] = $mVars[\'post\'][\'field\'.$id.\'_text\'];
    }
        
    // Update options
    $rows = count($version[\'option\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'option\'][$i][\'option_id\'];
        $value_id = $mVars[\'post\'][\'option\'.$id.\'_id\'] ?? 0;        
        $version[\'option\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'option\'][$i][\'value_name\'] = $mVars[\'post\'][\'option\'.$id.\'_text\'];
    }
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
    
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);                                          

    // Verify cart    
    if ( count($version[\'store\']) == 0 )
    {  
        $data[\'result\'] = \'ERROR_EMPTY\';
        $data[\'message\'] = \'No goods found!\';    
        
        return json_encode($data);    
    }   

    // Verify calculation
    if ( $version[\'result\'][\'value\'] != \'OK\' )
    {
        $data[\'result\'] = $version[\'result\'][\'value\'];
        $data[\'message\'] = $version[\'result\'][\'message\'];
        
        return json_encode($data);  
    }     
    
    // Create order    
    $result = MELBIS_INC_LOGIC_order_edit($version);
    
    // Error exists?
    if ( $result[\'value\'] != \'OK\' )
    {  
        $data[\'result\'] = $result[\'value\'];
        $data[\'message\'] = $result[\'message\'];
        
        return json_encode($data);
    }
    else
    {
        // Close order session
        $gSession->RemoveValue(\'melbis_version\');
    }       
                        
    return json_encode($data);   
}       

?>','2025-04-01 09:58:34');
INSERT INTO `ms_user_file_version` VALUES ('671','1','./../templates/default/units/melbis_basket/options_text_auto.htm','<input type=\"hidden\" name=\"option{ID}_id\" value=\"{VALUE_ID}\">

<script>

$(\'input[name=option{ID}_text]\').autocomplete(
{    
    lookup: function (query, done) 
    {
        $.post(\'[MS:VAR:LANG]/?mod=melbis_basket\', { func: \'auto_option\', query: query, id: {ID} }, function(data) { done(data); }, \'json\');        
    },
    onSelect: function (sugg) 
    {
        $(\'input[name=option{ID}_id\').val(sugg.data);
    }
});

</script>
','2025-04-01 09:59:00');
INSERT INTO `ms_user_file_version` VALUES ('672','1','./../units/melbis_basket.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASKET
 **/
function MELBIS_BASKET($mVars)
{ 
    global $gParser;  
    
    // Vars
    $func = __FUNCTION__.\'_\'.$mVars[\'post\'][\'func\'];
    
    // Call function    
    if ( function_exists($func) )
    {
        return call_user_func($func, $mVars);    
    }  
    else
    {
        return \'Function \'.$func.\' is absent!\';
    }     
} 


/** 
 * Function MELBIS_BASKET_plus
 **/
function MELBIS_BASKET_plus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Add goods
    $version = MELBIS_INC_LOGIC_order_goods_add($version, $store_id);
     
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);    
                        
    return \'\';                         
}    


/** 
 * Function MELBIS_BASKET_minus
 **/
function MELBIS_BASKET_minus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Remove goods
    $version = MELBIS_INC_LOGIC_order_goods_remove($version, $store_id);    
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);        
                               
    // Go to list
    return MELBIS_BASKET_goods($mVars);     
} 


/** 
 * Function MELBIS_BASKET_goods
 **/
function MELBIS_BASKET_goods($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);         
             
    // Get Goods
    if ( count($version[\'store\']) > 0 )
    {   
        foreach($version[\'store\'] as $hash )
        {
            $gParser->TplAssign($tpl, array(\'ID\'            => $hash[\'store_id\'],
                                            \'AMOUNT\'        => $hash[\'amount\'],
                                            \'PRICE\'         => MELBIS_INC_STD_number($hash[\'out_price\'], 0),
                                            \'NAME\'          => MELBIS_INC_LANG(\'kStore\', \'NAME\', $hash[\'store_id\'], $hash[\'store_name\'])
                                            ));         
            $gParser->TplParse($tpl, \'ITEM\', \'.goods_item\');  
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'goods\');                
    }
    else
    {
        $gParser->TplParse($tpl, \'MAIN\', \'goods_empty\');
    }
    
    return $gParser->TplFree($tpl, \'MAIN\');     
}      


/** 
 * Function MELBIS_BASKET_fields
 **/
function MELBIS_BASKET_fields($mVars)
{ 
    global $gParser, $gSession; 
                                        
    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];      
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get fields
    if ( count($version[\'client\']) > 0 )
    {   
        foreach($version[\'client\'] as $hash )
        {
            if ( $hash[\'field_folder\'] == 1 )
            {
                $gParser->TplAssign($tpl, \'NAME\', MELBIS_INC_LANG(\'kClient\', \'FIELD\', $hash[\'field_id\'], $hash[\'field_name\']));
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_group\');
                continue;                        
            }
                                              
            $command = \"SELECT *
                          FROM {DBNICK}_field
                         WHERE id = \'$hash[field_id]\' 
                        \";                              
            $field = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_field_value
                         WHERE field_id = \'$field[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $field[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => htmlspecialchars($val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.fields_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'field_id\'],
                                                \'NAME\'  => MELBIS_INC_LANG(\'kClient\', \'FIELD\', $hash[\'field_id\'], $hash[\'field_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'field_id\'], 
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_txt\']),                                            
                                                \'NAME\'      => MELBIS_INC_LANG(\'kClient\', \'FIELD\', $hash[\'field_id\'], $hash[\'field_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.fields_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'fields\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
}      


/** 
 * Function MELBIS_BASKET_options
 **/
function MELBIS_BASKET_options($mVars)
{ 
    global $gParser, $gSession;  
    
    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];         
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get options
    if ( count($version[\'option\']) > 0 )
    {   
        foreach($version[\'option\'] as $hash )
        {     
            $command = \"SELECT *
                          FROM {DBNICK}_order_option
                         WHERE id = \'$hash[option_id]\' 
                        \";                              
            $option = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_order_option_value
                         WHERE option_id = \'$option[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $option[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => MELBIS_INC_LANG(\'kOption\', \'VALUE\', $val[\'id\'], $val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.options_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'option_id\'],
                                                \'NAME\'  => MELBIS_INC_LANG(\'kOption\', \'FIELD\', $hash[\'option_id\'], $hash[\'option_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'OPTION\', \'.options_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'option_id\'],  
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_name\']),                                            
                                                \'NAME\'      => MELBIS_INC_LANG(\'kOption\', \'FIELD\', $hash[\'option_id\'], $hash[\'option_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.options_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'OPTION\', \'.options_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'options\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
} 


/** 
 * Function MELBIS_BASKET_auto_field
 **/
function MELBIS_BASKET_auto_field($mVars)
{ 
    global $gParser;       
                
    // Vars   
    $id = $mVars[\'post\'][\'id\']*1;                     
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_field_value
                 WHERE name LIKE \'%$query%\' 
                   AND field_id = \'$id\'                
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_auto_option
 **/
function MELBIS_BASKET_auto_option($mVars)
{ 
    global $gParser;       
                
    // Vars                                      
    $id = $mVars[\'post\'][\'id\']*1;
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_order_option_value                  
                 WHERE name LIKE \'%$query%\'
                   AND option_id = \'$id\'                 
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_save
 **/
function MELBIS_BASKET_save($mVars)
{ 
    global $gParser, $gSession; 
                               
    // Vars
    $data[\'result\'] = \'OK\';
    $data[\'message\'] = \'\';    
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }  
    
    // Update fields
    $rows = count($version[\'client\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'client\'][$i][\'field_id\'];
        $value_id = $mVars[\'post\'][\'field\'.$id.\'_id\'] ?? 0;        
        $version[\'client\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'client\'][$i][\'value_txt\'] = $mVars[\'post\'][\'field\'.$id.\'_text\'] ?? \'\';
    }
        
    // Update options
    $rows = count($version[\'option\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'option\'][$i][\'option_id\'];
        $value_id = $mVars[\'post\'][\'option\'.$id.\'_id\'] ?? 0;        
        $version[\'option\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'option\'][$i][\'value_name\'] = $mVars[\'post\'][\'option\'.$id.\'_text\'];
    }
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
    
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);                                          

    // Verify cart    
    if ( count($version[\'store\']) == 0 )
    {  
        $data[\'result\'] = \'ERROR_EMPTY\';
        $data[\'message\'] = \'No goods found!\';    
        
        return json_encode($data);    
    }   

    // Verify calculation
    if ( $version[\'result\'][\'value\'] != \'OK\' )
    {
        $data[\'result\'] = $version[\'result\'][\'value\'];
        $data[\'message\'] = $version[\'result\'][\'message\'];
        
        return json_encode($data);  
    }     
    
    // Create order    
    $result = MELBIS_INC_LOGIC_order_edit($version);
    
    // Error exists?
    if ( $result[\'value\'] != \'OK\' )
    {  
        $data[\'result\'] = $result[\'value\'];
        $data[\'message\'] = $result[\'message\'];
        
        return json_encode($data);
    }
    else
    {
        // Close order session
        $gSession->RemoveValue(\'melbis_version\');
    }       
                        
    return json_encode($data);   
}       

?>','2025-04-01 10:09:03');
INSERT INTO `ms_user_file_version` VALUES ('673','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var melbis_topic_id = [MS:PAGE:ID] </script>
        
        {MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main>              
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}    
    </body>                                       
    
<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">{TAG_BASKET}</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">{TAG_CLOSE}</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> {TAG_CHECKOUT}</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">{TAG_ORDER}</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">{TAG_CART}</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">{TAG_FIELDS}</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">{TAG_OPTIONS}</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>{TAG_ERROR}</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">{TAG_CLOSE}</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> {TAG_FINISH}</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">Order finish</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">Close</button>
      </div>
    </div>
  </div>
</div>   

{SCRIPTS} 
    
</html>
','2025-04-01 10:11:12');
INSERT INTO `ms_user_file_version` VALUES ('674','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var melbis_topic_id = [MS:PAGE:ID] </script>
        
        {MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main>              
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}    
    </body>                                       
    
<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">{TAG_BASKET}</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">{TAG_CLOSE}</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> {TAG_CHECKOUT}</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">{TAG_ORDER}</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">{TAG_CART}</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">{TAG_FIELDS}</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">{TAG_OPTIONS}</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>{TAG_ERROR}</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">{TAG_CLOSE}</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> {TAG_FINISH}</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">{TAG_ORDER}</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">Order was successfully placed</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">{TAG_CLOSE}</button>
      </div>
    </div>
  </div>
</div>   

{SCRIPTS} 
    
</html>
','2025-04-01 10:12:37');
INSERT INTO `ms_user_file_version` VALUES ('675','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var melbis_topic_id = [MS:PAGE:ID] </script>
        
        {MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main>              
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}    
    </body>                                       
    
<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">{TAG_BASKET}</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">{TAG_CLOSE}</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> {TAG_CHECKOUT}</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">{TAG_ORDER}</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">{TAG_CART}</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">{TAG_FIELDS}</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">{TAG_OPTIONS}</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>{TAG_ERROR}</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">{TAG_CLOSE}</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> {TAG_FINISH}</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">{TAG_ORDER}</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">{TAG_SUCCESS}</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">{TAG_CLOSE}</button>
      </div>
    </div>
  </div>
</div>   

{SCRIPTS} 
    
</html>
','2025-04-01 10:12:51');
INSERT INTO `ms_user_file_version` VALUES ('676','1','./../templates/default/units/melbis_base_page/main.htm','<!doctype html>
<html lang=\"[MS:VAR:LANG]\" class=\"h-100\">
    
    {MELBIS:melbis_base_head([MS:VAR:LANG])}
    
    <body class=\"d-flex flex-column h-100\">
     
        <script type=\"text/javascript\"> var melbis_topic_id = [MS:PAGE:ID] </script>
        
        {MELBIS:melbis_base_header([MS:VAR:LANG])}

        <main class=\"flex-shrink-0 mt-3\">  
            {CONTENT}   
        </main>              
        
        {MELBIS:melbis_base_footer([MS:VAR:LANG])}    
    </body>                                       
    
<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_basket\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">{TAG_BASKET}</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\"></div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">{TAG_CLOSE}</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_checkout\"><i class=\"fas fa-shopping-cart\"></i> {TAG_CHECKOUT}</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_checkout\">
  <div class=\"modal-dialog modal-dialog-centered modal-dialog-scrollable modal-xl\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h3 class=\"modal-title\">{TAG_ORDER}</h3>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <form id=\"melbis_form_order\">                
            <h4 class=\"border-bottom pb-1\">{TAG_CART}</h4>
            <div id=\"melbis_order_goods\"></div>
            <h4 class=\"border-bottom pb-1\">{TAG_FIELDS}</h4>
            <div id=\"melbis_order_fields\"></div>             
            <h4 class=\"border-bottom pb-1\">{TAG_OPTIONS}</h4>
            <div id=\"melbis_order_options\"></div>
        </form>        
      </div>
        <div class=\"alert m-2 alert-danger fade\"><strong>{TAG_ERROR}</strong> <span></span></div>            
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">{TAG_CLOSE}</button>
        <button type=\"button\" class=\"btn btn-primary\" id=\"melbis_btn_finish\"><i class=\"fas fa-paper-plane\"></i> {TAG_FINISH}</button>
      </div>
    </div>
  </div>
</div>

<div class=\"modal fade\" tabindex=\"-1\" id=\"melbis_win_finish\">
  <div class=\"modal-dialog modal-dialog-centered\">
    <div class=\"modal-content\">
      <div class=\"modal-header\">
        <h5 class=\"modal-title\">{TAG_ORDER}</h5>
        <button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\">
          <span aria-hidden=\"true\">&times;</span>
        </button>
      </div>
      <div class=\"modal-body\">
        <h4 class=\"text-center\">{TAG_SUCCESS}</h4>
      </div>
      <div class=\"modal-footer\">
        <button type=\"button\" class=\"btn btn-secondary\" data-dismiss=\"modal\">{TAG_CLOSE}</button>
      </div>
    </div>
  </div>
</div>   

{SCRIPTS} 
    
</html>
','2025-04-01 10:13:25');
INSERT INTO `ms_user_file_version` VALUES ('677','1','./../units/melbis_basket.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_BASKET
 **/
function MELBIS_BASKET($mVars)
{ 
    global $gParser;  
    
    // Vars
    $func = __FUNCTION__.\'_\'.$mVars[\'post\'][\'func\'];
    
    // Call function    
    if ( function_exists($func) )
    {
        return call_user_func($func, $mVars);    
    }  
    else
    {
        return \'Function \'.$func.\' is absent!\';
    }     
} 


/** 
 * Function MELBIS_BASKET_plus
 **/
function MELBIS_BASKET_plus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Add goods
    $version = MELBIS_INC_LOGIC_order_goods_add($version, $store_id);
     
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);    
                        
    return \'\';                         
}    


/** 
 * Function MELBIS_BASKET_minus
 **/
function MELBIS_BASKET_minus($mVars)
{ 
    global $gParser, $gSession;       

    // Vars
    $store_id = $mVars[\'post\'][\'id\']*1;
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }               

    // Remove goods
    $version = MELBIS_INC_LOGIC_order_goods_remove($version, $store_id);    
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
             
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);        
                               
    // Go to list
    return MELBIS_BASKET_goods($mVars);     
} 


/** 
 * Function MELBIS_BASKET_goods
 **/
function MELBIS_BASKET_goods($mVars)
{ 
    global $gParser, $gSession;       
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);         
             
    // Get Goods
    if ( count($version[\'store\']) > 0 )
    {   
        foreach($version[\'store\'] as $hash )
        {
            $gParser->TplAssign($tpl, array(\'ID\'            => $hash[\'store_id\'],
                                            \'AMOUNT\'        => $hash[\'amount\'],
                                            \'PRICE\'         => MELBIS_INC_STD_number($hash[\'out_price\'], 0),
                                            \'NAME\'          => MELBIS_INC_LANG(\'kStore\', \'NAME\', $hash[\'store_id\'], $hash[\'store_name\'])
                                            ));         
            $gParser->TplParse($tpl, \'ITEM\', \'.goods_item\');  
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'goods\');                
    }
    else
    {
        $gParser->TplParse($tpl, \'MAIN\', \'goods_empty\');
    }
    
    return $gParser->TplFree($tpl, \'MAIN\');     
}      


/** 
 * Function MELBIS_BASKET_fields
 **/
function MELBIS_BASKET_fields($mVars)
{ 
    global $gParser, $gSession; 
                                        
    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];      
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get fields
    if ( count($version[\'client\']) > 0 )
    {   
        foreach($version[\'client\'] as $hash )
        {
            if ( $hash[\'field_folder\'] == 1 )
            {
                $gParser->TplAssign($tpl, \'NAME\', MELBIS_INC_LANG(\'kClient\', \'FIELD\', $hash[\'field_id\'], $hash[\'field_name\']));
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_group\');
                continue;                        
            }
                                              
            $command = \"SELECT *
                          FROM {DBNICK}_field
                         WHERE id = \'$hash[field_id]\' 
                        \";                              
            $field = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_field_value
                         WHERE field_id = \'$field[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $field[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => MELBIS_INC_LANG(\'kClient\', \'VALUE\', $val[\'id\'], $val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.fields_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'field_id\'],
                                                \'NAME\'  => MELBIS_INC_LANG(\'kClient\', \'FIELD\', $hash[\'field_id\'], $hash[\'field_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'field_id\'], 
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_txt\']),                                            
                                                \'NAME\'      => MELBIS_INC_LANG(\'kClient\', \'FIELD\', $hash[\'field_id\'], $hash[\'field_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.fields_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'FIELD\', \'.fields_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'fields\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
}      


/** 
 * Function MELBIS_BASKET_options
 **/
function MELBIS_BASKET_options($mVars)
{ 
    global $gParser, $gSession;  
    
    // Vars
    $gParser->gVars[\'ms\'][\'var\'][\'lang\'] = $mVars[\'lang\'];         
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }                                 
    
    // Create 
    $tpl = $gParser->TplCreate();  
             
    // Get options
    if ( count($version[\'option\']) > 0 )
    {   
        foreach($version[\'option\'] as $hash )
        {     
            $command = \"SELECT *
                          FROM {DBNICK}_order_option
                         WHERE id = \'$hash[option_id]\' 
                        \";                              
            $option = $gParser->SqlSelectToArray(__LINE__, $command);
                                            
            $command = \"SELECT *
                          FROM {DBNICK}_order_option_value
                         WHERE option_id = \'$option[id]\' 
                      ORDER BY pos    
                        \";                              
            $value = $gParser->SqlSelect(__LINE__, $command);
            
            if ( count($value) > 0 && $option[\'fixed_set\'] == 1 )
            {          
                $gParser->TplClear($tpl, \'VALUE\');
                foreach( $value as $val )
                {
                    $gParser->TplAssign($tpl, array(\'ID\'    => $val[\'id\'],
                                                    \'NAME\'  => MELBIS_INC_LANG(\'kOption\', \'VALUE\', $val[\'id\'], $val[\'name\']),
                                                    \'SELECT\'=> ( $hash[\'value_id\'] == $val[\'id\'] ) ? \'selected\' : \'\'
                                                    )); 
                    $gParser->TplParse($tpl, \'VALUE\', \'.options_box_val\');            
                } 
                $gParser->TplAssign($tpl, array(\'ID\'    => $hash[\'option_id\'],
                                                \'NAME\'  => MELBIS_INC_LANG(\'kOption\', \'FIELD\', $hash[\'option_id\'], $hash[\'option_name\'])
                                                )); 
                $gParser->TplParse($tpl, \'OPTION\', \'.options_box\');                                       
            }
            else
            {                                                                 
                $gParser->TplAssign($tpl, array(\'ID\'        => $hash[\'option_id\'],  
                                                \'VALUE_ID\'  => $hash[\'value_id\'],
                                                \'VALUE\'     => htmlspecialchars($hash[\'value_name\']),                                            
                                                \'NAME\'      => MELBIS_INC_LANG(\'kOption\', \'FIELD\', $hash[\'option_id\'], $hash[\'option_name\']),
                                                \'AUTO\'      => \'\'
                                                ));
                if ( count($value) > 0 )
                {                                                         
                    $gParser->TplParse($tpl, \'AUTO\', \'.options_text_auto\');
                }                                                         
                $gParser->TplParse($tpl, \'OPTION\', \'.options_text\');
            }
        }                         
        $gParser->TplParse($tpl, \'MAIN\', \'options\');
        
        return $gParser->TplFree($tpl, \'MAIN\');                
    }
    else
    {
        return \'\';
    }
} 


/** 
 * Function MELBIS_BASKET_auto_field
 **/
function MELBIS_BASKET_auto_field($mVars)
{ 
    global $gParser;       
                
    // Vars   
    $id = $mVars[\'post\'][\'id\']*1;                     
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_field_value
                 WHERE name LIKE \'%$query%\' 
                   AND field_id = \'$id\'                
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_auto_option
 **/
function MELBIS_BASKET_auto_option($mVars)
{ 
    global $gParser;       
                
    // Vars                                      
    $id = $mVars[\'post\'][\'id\']*1;
    $query = addslashes($mVars[\'post\'][\'query\']); 

    // Get data      
    $command = \"SELECT name AS value, id AS data
                  FROM {DBNICK}_order_option_value                  
                 WHERE name LIKE \'%$query%\'
                   AND option_id = \'$id\'                 
                \";  
    $data[\'suggestions\'] = $gParser->SqlSelect(__LINE__, $command);
    
    return json_encode($data);                            
}    


/** 
 * Function MELBIS_BASKET_save
 **/
function MELBIS_BASKET_save($mVars)
{ 
    global $gParser, $gSession; 
                               
    // Vars
    $data[\'result\'] = \'OK\';
    $data[\'message\'] = \'\';    
    
    // Get version    
    $version = $gSession->GetValue(\'melbis_version\');
    if ( !is_array($version) )
    {
        $version = MELBIS_INC_LOGIC_order_create();   
    }  
    
    // Update fields
    $rows = count($version[\'client\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'client\'][$i][\'field_id\'];
        $value_id = $mVars[\'post\'][\'field\'.$id.\'_id\'] ?? 0;        
        $version[\'client\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'client\'][$i][\'value_txt\'] = $mVars[\'post\'][\'field\'.$id.\'_text\'] ?? \'\';
    }
        
    // Update options
    $rows = count($version[\'option\']); 
    for ( $i = 0; $i <= $rows - 1; $i++ )
    { 
        $id = $version[\'option\'][$i][\'option_id\'];
        $value_id = $mVars[\'post\'][\'option\'.$id.\'_id\'] ?? 0;        
        $version[\'option\'][$i][\'value_id\'] = ( $value_id == 0 ) ? null : (int)$value_id;
        $version[\'option\'][$i][\'value_name\'] = $mVars[\'post\'][\'option\'.$id.\'_text\'];
    }
    
    // Calculate
    $version = MELBIS_INC_LOGIC_order_calc($version);
    
    // Save version
    $gSession->SetValue(\'melbis_version\', $version);                                          

    // Verify cart    
    if ( count($version[\'store\']) == 0 )
    {  
        $data[\'result\'] = \'ERROR_EMPTY\';
        $data[\'message\'] = \'No goods found!\';    
        
        return json_encode($data);    
    }   

    // Verify calculation
    if ( $version[\'result\'][\'value\'] != \'OK\' )
    {
        $data[\'result\'] = $version[\'result\'][\'value\'];
        $data[\'message\'] = $version[\'result\'][\'message\'];
        
        return json_encode($data);  
    }     
    
    // Create order    
    $result = MELBIS_INC_LOGIC_order_edit($version);
    
    // Error exists?
    if ( $result[\'value\'] != \'OK\' )
    {  
        $data[\'result\'] = $result[\'value\'];
        $data[\'message\'] = $result[\'message\'];
        
        return json_encode($data);
    }
    else
    {
        // Close order session
        $gSession->RemoveValue(\'melbis_version\');
    }       
                        
    return json_encode($data);   
}       

?>','2025-04-01 10:21:44');
INSERT INTO `ms_user_file_version` VALUES ('678','1','./../units/melbis_store_features.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_FEATURES
 **/
function MELBIS_STORE_FEATURES($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
    
        
    // Get features
    $command = \"SELECT i.name AS info_name, i.type_key, 
                       si.id, si.value_dec, si.value_txt, si.value_id, si.info_id, 
                       iv.name AS value_name 
                  FROM {DBNICK}_store_info si
                  JOIN {DBNICK}_info i
                    ON i.id = si.info_id
             LEFT JOIN {DBNICK}_info_value iv
                    ON iv.id = si.value_id     
                 WHERE si.store_id = \'$mVars[id]\'
                   AND i.in_topic = 1   
              ORDER BY i.absindex
                \";                    
    $query = $gParser->SqlQuery(__LINE__, $command);
    $rows = $gParser->SqlNumRows($query); 
    $value = \'\';
    for ( $i = 1; $i <= $rows; $i++ )
    {           
        // Get feature values               
        $gParser->SqlDataSeek($query, $i - 1);
        $row = $gParser->SqlFetchHash($query);        
            
        switch ( $row[\'type_key\'] ) 
        {
            case \'kSet\':
                $value .= MELBIS_INC_LANG(\'kInfo\', \'VALUE\', $row[\'value_id\'], $row[\'value_name\']);
                break;
            case \'kDecimal\':
                $value = MELBIS_INC_STD_number($row[\'value_dec\']);
                break;                  
            case \'kText\':
                $value = MELBIS_INC_LANG(\'kInfo\', \'TEXT\', $row[\'id\'], $row[\'value_txt\']);
                break;                                  
        }
                             
        // Verify next
        $next = $gParser->SqlFetchHash($query);
        if ( ( $next[\'info_id\'] ?? 0 ) != $row[\'info_id\'] )
        {                                              
            $gParser->TplAssign($tpl, array(\'NAME\'  => MELBIS_INC_LANG(\'kInfo\', \'NAME\', $row[\'info_id\'], $row[\'info_name\']), 
                                            \'VALUE\' => $value
                                            )); 
            $gParser->TplParse($tpl, \'ITEM\', \'.item\');
            $value = \'\';
        }  
        else
        {
            $value .= \', \';
        }
    }    
    
    if ( $rows > 0 ) 
    {
    
        // Final: return content
        $gParser->TplParse($tpl, \'MAIN\', \'main\');

        return $gParser->TplFree($tpl, \'MAIN\');
    } 
    else
    {
        return \'\';
    }
} 



?>','2025-04-01 10:47:43');
INSERT INTO `ms_user_file_version` VALUES ('679','1','./../units/melbis_store_image.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_IMAGE
 **/
function MELBIS_STORE_IMAGE($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();   
    
    // Lang tags    
    MELBIS_INC_LANG_tags($tpl, __FUNCTION__);      
       
    // Get image    
    $command = \"SELECT *
                  FROM {DBNICK}_files_store
                 WHERE elem_id = \'$mVars[id]\' 
                   AND kind_key = \'$mVars[key]\'
              ORDER BY pos
                 LIMIT 1
                \";                    
    $hash = $gParser->SqlSelectToArray(__LINE__, $command);                 
    
    $gParser->TplAssign($tpl, \'IMAGES\', \'\');
    if ( isset($hash[\'id\']) )
    {    
        // Additional
        $command = \"SELECT *
                      FROM {DBNICK}_files_store
                     WHERE elem_id = \'$mVars[id]\' 
                       AND kind_key <> \'$mVars[key]\'
                  ORDER BY pos
                \";                    
        $imgs = $gParser->SqlSelect(__LINE__, $command);   
        foreach ($imgs as $img) 
        {
            $gParser->TplAssign($tpl, \'FILE\', MELBIS_INC_STD_path($img));
            $gParser->TplParse($tpl, \'IMAGES\', \'.img\');                              
        }                                                           
                                                           
        // Base
        $gParser->TplAssign($tpl, \'FILE\', MELBIS_INC_STD_path($hash));
        $gParser->TplParse($tpl, \'IMAGE\', \'image\');                 
    }
    else
    {
        $gParser->TplParse($tpl, \'IMAGE\', \'no_image\'); 
    }

    return $gParser->TplFree($tpl, \'IMAGE\');
} 



?>','2025-04-01 10:51:49');
INSERT INTO `ms_user_file_version` VALUES ('680','1','./../templates/default/units/melbis_store_image/no_image.htm','<svg class=\"bd-placeholder-img card-img-top\" width=\"100%\" height=\"200\" xmlns=\"http://www.w3.org/2000/svg\" preserveAspectRatio=\"xMidYMid slice\" focusable=\"false\">        
    <rect width=\"100%\" height=\"100%\" fill=\"#55595c\"></rect>
    <text x=\"35%\" y=\"50%\" fill=\"#eceeef\">{TAG_NO_IMAGE}</text>
</svg>                                                        
','2025-04-01 10:53:24');
INSERT INTO `ms_user_file_version` VALUES ('681','1','./../templates/default/units/melbis_store_image/no_image.htm','<svg class=\"bd-placeholder-img card-img-top\" width=\"100%\" height=\"200\" xmlns=\"http://www.w3.org/2000/svg\" preserveAspectRatio=\"xMidYMid slice\" focusable=\"false\">        
    <rect width=\"100%\" height=\"100%\" fill=\"#55595c\"></rect>
    <text x=\"15%\" y=\"50%\" fill=\"#eceeef\">{TAG_NO_IMAGE}</text>
</svg>                                                        
','2025-04-01 10:54:11');
INSERT INTO `ms_user_file_version` VALUES ('682','1','./../templates/default/units/melbis_store_image/no_image.htm','<svg class=\"bd-placeholder-img card-img-top\" width=\"100%\" height=\"200\" xmlns=\"http://www.w3.org/2000/svg\" preserveAspectRatio=\"xMidYMid slice\" focusable=\"false\">        
    <rect width=\"100%\" height=\"100%\" fill=\"#55595c\"></rect>
    <text x=\"15%\" y=\"50%\" fill=\"#eceeef\">{TAG_NO_IMAGE}</text>
</svg>                                                        
','2025-04-01 10:54:21');
INSERT INTO `ms_user_file_version` VALUES ('683','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay text-center\" style=\"padding-top: 10px;\">
            <h2 class=\"card-title text-info\" style=\"font-size: 3rem; text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 10px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-04-01 11:14:47');
INSERT INTO `ms_user_file_version` VALUES ('684','1','./../templates/default/units/melbis_cataloge_center/item.htm','<div class=\"col mb-4\">
    <a href=\"/{MS:VAR:LANG}{LINK}\" class=\"card h-100 bg-white text-dark\">
        <img src=\"{IMAGE}\" class=\"card-img\" alt=\"{NAME}\" style=\"max-width:300px; max-height:300px;\">
        <div class=\"card-img-overlay text-center\" style=\"padding-top: 10px;\">
            <h2 class=\"card-title text-info\" style=\"font-size: 2rem; text-shadow: -1px -1px 2px black, 1px 1px 2px black, 2px 2px 10px black;\">{NAME}</h2>                                
        </div>
    </a>
</div>    ','2025-04-01 11:15:05');
INSERT INTO `ms_user_file_version` VALUES ('685','1','./../units/melbis_store_random.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_RANDOM($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
            
    // Get random goods
    $lim = $mVars[\'limit\']*1;
    $command = \"SELECT s.id
                  FROM {DBNICK}_store s
                  JOIN {DBNICK}_topic_store ts
                    ON s.id = ts.store_id
                  JOIN {DBNICK}_topic t
                    ON t.id = ts.topic_id                    
                 WHERE s.no_visible = 0   
                   AND t.kind_key = \'kGoods\'
              ORDER BY ts.pos
                 LIMIT $lim 
                \";                    
    $goods = $gParser->SqlSelect(__LINE__, $command);
    if ( count($goods) == 0 ) $gParser->TplAssign($tpl, \'ITEM\', \'\');
    foreach ( $goods as $item )
    {
        $gParser->TplAssign($tpl, \'ID\', $item[\'id\']);
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }         
    
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-04-01 11:16:35');
INSERT INTO `ms_user_file_version` VALUES ('686','1','./../units/melbis_store_random.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_RANDOM($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
            
    // Get random goods
    $lim = $mVars[\'limit\']*1;
    $command = \"SELECT s.id
                  FROM {DBNICK}_store s
                  JOIN {DBNICK}_topic_store ts
                    ON s.id = ts.store_id
                  JOIN {DBNICK}_topic t
                    ON t.id = ts.topic_id                    
                 WHERE s.no_visible = 0   
                   AND t.kind_key = \'kGoods\'
              ORDER BY id, RAND()
                 LIMIT $lim 
                \";                    
    $goods = $gParser->SqlSelect(__LINE__, $command);
    if ( count($goods) == 0 ) $gParser->TplAssign($tpl, \'ITEM\', \'\');
    foreach ( $goods as $item )
    {
        $gParser->TplAssign($tpl, \'ID\', $item[\'id\']);
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }         
    
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-04-01 11:18:10');
INSERT INTO `ms_user_file_version` VALUES ('687','1','./../units/melbis_store_random.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_RANDOM($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
            
    // Get random goods
    $lim = $mVars[\'limit\']*1;
    $command = \"SELECT s.id
                  FROM {DBNICK}_store s
                  JOIN {DBNICK}_topic_store ts
                    ON s.id = ts.store_id
                  JOIN {DBNICK}_topic t
                    ON t.id = ts.topic_id                    
                 WHERE s.no_visible = 0   
                   AND t.kind_key = \'kGoods\'
              ORDER BY s.id, RAND()
                 LIMIT $lim 
                \";                    
    $goods = $gParser->SqlSelect(__LINE__, $command);
    if ( count($goods) == 0 ) $gParser->TplAssign($tpl, \'ITEM\', \'\');
    foreach ( $goods as $item )
    {
        $gParser->TplAssign($tpl, \'ID\', $item[\'id\']);
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }         
    
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-04-01 11:18:18');
INSERT INTO `ms_user_file_version` VALUES ('688','1','./../units/melbis_store_random.php','<?php
/***************************************************************************************************
 * @version 6.4.0
 * @copyright 2025 Melbis Company
 * @link https://melbis.com
 * @author Dmitriy Kasyanoff
 **************************************************************************************************/


/** 
 * Function MELBIS_STORE_RANDOM
 **/
function MELBIS_STORE_RANDOM($mVars)
{ 
    global $gParser;
                       
    // Create 
    $tpl = $gParser->TplCreate();
            
    // Get random goods
    $lim = $mVars[\'limit\']*1;
    $command = \"SELECT s.id
                  FROM {DBNICK}_store s
                  JOIN {DBNICK}_topic_store ts
                    ON s.id = ts.store_id
                  JOIN {DBNICK}_topic t
                    ON t.id = ts.topic_id                    
                 WHERE s.no_visible = 0   
                   AND t.kind_key = \'kGoods\'
              ORDER BY s.id
                 LIMIT $lim 
                \";                    
    $goods = $gParser->SqlSelect(__LINE__, $command);
    if ( count($goods) == 0 ) $gParser->TplAssign($tpl, \'ITEM\', \'\');
    foreach ( $goods as $item )
    {
        $gParser->TplAssign($tpl, \'ID\', $item[\'id\']);
        $gParser->TplParse($tpl, \'ITEM\', \'.item\');  
    }         
    
    
    // Final: return content
    $gParser->TplParse($tpl, \'MAIN\', \'main\');

    return $gParser->TplFree($tpl, \'MAIN\');
} 



?>','2025-04-01 11:18:39');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_user_filter`
--

DROP TABLE IF EXISTS `ms_user_filter`;

CREATE TABLE `ms_user_filter` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `place` tinyint unsigned NOT NULL DEFAULT '0',
  `name` char(255) NOT NULL DEFAULT '',
  `sql_txt` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_user_filter`
--

LOCK TABLES `ms_user_filter` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_user_group`
--

DROP TABLE IF EXISTS `ms_user_group`;

CREATE TABLE `ms_user_group` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `name` char(100) NOT NULL DEFAULT '',
  `phone` char(255) NOT NULL DEFAULT '',
  `email` char(255) NOT NULL DEFAULT '',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_user_group`
--

LOCK TABLES `ms_user_group` WRITE;
INSERT INTO `ms_user_group` VALUES ('1','','Администраторы','','','1');
INSERT INTO `ms_user_group` VALUES ('2','','Управляющие','','','2');
INSERT INTO `ms_user_group` VALUES ('3','','Менеджеры','','','3');
INSERT INTO `ms_user_group` VALUES ('4','','Логисты','','','4');
INSERT INTO `ms_user_group` VALUES ('5','','Копирайтеры','','','5');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_user_log`
--

DROP TABLE IF EXISTS `ms_user_log`;

CREATE TABLE `ms_user_log` (
  `id` int unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int unsigned DEFAULT NULL,
  `user_ip` int unsigned NOT NULL DEFAULT '0',
  `command` char(100) NOT NULL DEFAULT '',
  `for_command` char(100) NOT NULL DEFAULT '',
  `options` text NOT NULL DEFAULT (_utf8mb3''),
  `vars` text NOT NULL DEFAULT (_utf8mb3''),
  `date_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_user_log`
--

LOCK TABLES `ms_user_log` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_user_online`
--

DROP TABLE IF EXISTS `ms_user_online`;

CREATE TABLE `ms_user_online` (
  `user_id` int unsigned DEFAULT NULL,
  `last_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  UNIQUE KEY `user_id` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_user_online`
--

LOCK TABLES `ms_user_online` WRITE;
INSERT INTO `ms_user_online` VALUES ('1','2025-04-01 15:07:37');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_user_task`
--

DROP TABLE IF EXISTS `ms_user_task`;

CREATE TABLE `ms_user_task` (
  `id` int unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int unsigned DEFAULT NULL,
  `exec_id` int unsigned DEFAULT NULL,
  `name` char(255) NOT NULL DEFAULT '',
  `kind_key` char(100) NOT NULL DEFAULT '',
  `state_key` char(100) NOT NULL DEFAULT '',
  `privy` tinyint unsigned NOT NULL DEFAULT '0',
  `date_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  PRIMARY KEY (`id`),
  KEY `user_id` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_user_task`
--

LOCK TABLES `ms_user_task` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_user_task_note`
--

DROP TABLE IF EXISTS `ms_user_task_note`;

CREATE TABLE `ms_user_task_note` (
  `id` int unsigned NOT NULL AUTO_INCREMENT,
  `task_id` int unsigned DEFAULT NULL,
  `user_id` int unsigned DEFAULT NULL,
  `kind_key` char(100) NOT NULL DEFAULT '',
  `state_key` char(100) NOT NULL DEFAULT '',
  `content` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `date_time` datetime NOT NULL DEFAULT '2000-01-01 00:00:00',
  PRIMARY KEY (`id`),
  KEY `task_id` (`task_id`),
  KEY `user_id` (`user_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_user_task_note`
--

LOCK TABLES `ms_user_task_note` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_web_inside`
--

DROP TABLE IF EXISTS `ms_web_inside`;

CREATE TABLE `ms_web_inside` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `place` tinyint unsigned NOT NULL DEFAULT '0',
  `name` char(255) NOT NULL DEFAULT '',
  `url` text NOT NULL DEFAULT (_utf8mb3''),
  `auth` tinyint unsigned NOT NULL DEFAULT '0',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_web_inside`
--

LOCK TABLES `ms_web_inside` WRITE;
INSERT INTO `ms_web_inside` VALUES ('1','TEST','0','Тестовый модуль','https://shop.com/?mod=melbis_web_test','1','1');
INSERT INTO `ms_web_inside` VALUES ('2','TEST','1','Тестовый модуль','https://shop.com/?mod=melbis_web_test','1','1');
INSERT INTO `ms_web_inside` VALUES ('3','TEST','2','Тестовый модуль','https://shop.com/?mod=melbis_web_test','1','1');
INSERT INTO `ms_web_inside` VALUES ('4','TEST','3','Тестовый модуль','https://shop.com/?mod=melbis_web_test','1','1');
INSERT INTO `ms_web_inside` VALUES ('5','TEST','4','Тестовый модуль','https://shop.com/?mod=melbis_web_test','1','1');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_web_inside_right`
--

DROP TABLE IF EXISTS `ms_web_inside_right`;

CREATE TABLE `ms_web_inside_right` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `inside_id` int unsigned DEFAULT NULL,
  `user_id` int unsigned DEFAULT NULL,
  `group_id` int unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `inside_id` (`inside_id`),
  KEY `user_id` (`user_id`),
  KEY `group_id` (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_web_inside_right`
--

LOCK TABLES `ms_web_inside_right` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_web_key`
--

DROP TABLE IF EXISTS `ms_web_key`;

CREATE TABLE `ms_web_key` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `descr` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `tindex` int unsigned NOT NULL DEFAULT '0',
  `tlevel` int unsigned NOT NULL DEFAULT '0',
  `absindex` int unsigned NOT NULL DEFAULT '0',
  `folder` tinyint unsigned NOT NULL DEFAULT '0',
  `kind_key` char(100) NOT NULL DEFAULT '',
  `params` char(255) NOT NULL DEFAULT '',
  `color_set` char(32) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_web_key`
--

LOCK TABLES `ms_web_key` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_web_key_right`
--

DROP TABLE IF EXISTS `ms_web_key_right`;

CREATE TABLE `ms_web_key_right` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `web_key_id` int unsigned DEFAULT NULL,
  `user_id` int unsigned DEFAULT NULL,
  `group_id` int unsigned DEFAULT NULL,
  `for_read` tinyint unsigned NOT NULL DEFAULT '0',
  `for_write` tinyint unsigned NOT NULL DEFAULT '0',
  `for_remove` tinyint unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `web_key_id` (`web_key_id`),
  KEY `user_id` (`user_id`),
  KEY `group_id` (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_web_key_right`
--

LOCK TABLES `ms_web_key_right` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_web_key_value`
--

DROP TABLE IF EXISTS `ms_web_key_value`;

CREATE TABLE `ms_web_key_value` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `web_key_id` int unsigned DEFAULT NULL,
  `name` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `descr` mediumtext NOT NULL DEFAULT (_utf8mb3''),
  `kind_key` char(100) NOT NULL DEFAULT '',
  `params` char(255) NOT NULL DEFAULT '',
  `color_set` char(32) NOT NULL DEFAULT '',
  `pos` int unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `web_key_id` (`web_key_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_web_key_value`
--

LOCK TABLES `ms_web_key_value` WRITE;
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_web_outside`
--

DROP TABLE IF EXISTS `ms_web_outside`;

CREATE TABLE `ms_web_outside` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `skey` char(32) NOT NULL DEFAULT '',
  `name` char(255) NOT NULL DEFAULT '',
  `tindex` int unsigned NOT NULL DEFAULT '0',
  `tlevel` int unsigned NOT NULL DEFAULT '0',
  `absindex` int unsigned NOT NULL DEFAULT '0',
  `folder` tinyint unsigned NOT NULL DEFAULT '0',
  `url` text NOT NULL DEFAULT (_utf8mb3''),
  `auth` tinyint unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_web_outside`
--

LOCK TABLES `ms_web_outside` WRITE;
INSERT INTO `ms_web_outside` VALUES ('1','','Магазин','0','0','0','0','https://shop.com','0');
INSERT INTO `ms_web_outside` VALUES ('2','TEST','Тестовый модуль','0','0','1','0','https://shop.com/?mod=melbis_web_test','1');
INSERT INTO `ms_web_outside` VALUES ('3','','Поисковая система','0','0','2','0','https://google.com','0');
UNLOCK TABLES;
-- --------------------------------------------------------

--
-- Table structure for table `ms_web_outside_right`
--

DROP TABLE IF EXISTS `ms_web_outside_right`;

CREATE TABLE `ms_web_outside_right` (
  `id` int unsigned NOT NULL DEFAULT '0',
  `outside_id` int unsigned DEFAULT NULL,
  `user_id` int unsigned DEFAULT NULL,
  `group_id` int unsigned DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `outside_id` (`outside_id`),
  KEY `user_id` (`user_id`),
  KEY `group_id` (`group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8mb4 COLLATE=utf8mb4_0900_ai_ci;

--
-- Dumping data for table `ms_web_outside_right`
--

LOCK TABLES `ms_web_outside_right` WRITE;
UNLOCK TABLES;
